/*
*  builtins.h:  VSX configuration file for compiler built-in types
*
*  Geoff Clare, UniSoft Ltd., June 1994.
*
*  This user-configurable file contains definitions of types used in
*  system header files that are recognised as built-ins by the compiler.
*  The definitions are needed by the hdranal utility, which is used to
*  identify symbols made visible by the system headers when the header
*  tests are built.
*
*  If a system header uses any built-in types that are not defined here,
*  the hdranal utility will report a syntax error when the corresponding
*  header testset is built.  When this happens the user should add the
*  necessary definitions to this file and rebuild the affected header
*  tests.  The definitions provided here do not need to reflect
*  accurately the definitions made by the compiler.  All that is
*  required is that they allow the system headers to be processed by
*  hdranal without error.
*
*  Please report any additions made to this file to VSX Support, so that
*  they can be included in future VSX releases.
*/

typedef int __int8;
typedef int __int16;
typedef int __int32;
typedef int __int64;
typedef int __int128;

typedef unsigned int __uint8;
typedef unsigned int __uint16;
typedef unsigned int __uint32;
typedef unsigned int __uint64;
typedef unsigned int __uint128;


#ifdef __GNUC__

#define __attribute__(x)

#ifndef __restrict
#define __restrict
#endif

#endif
