/*
 * ctrlcodes.h - control character encodings
 *
 * This file specifies the character encodings of control characters
 * for the POSIX locale and for the VSX pseudolanguages.
 *
 * This file must be modified by the user if the POSIX locale encodings
 * are incorrect or the pseudolanguages encodings are not appropriate.
 */

/* POSIX locale control characters */

#define PSL0_ACK	0x06
#define PSL0_BEL	0x07
#define PSL0_BS 	0x08
#define PSL0_CAN	0x18
#define PSL0_CR 	0x0d
#define PSL0_DC1	0x11
#define PSL0_DC2	0x12
#define PSL0_DC3	0x13
#define PSL0_DC4	0x14
#define PSL0_DEL	0x7f
#define PSL0_DLE	0x10
#define PSL0_EM 	0x19
#define PSL0_ENQ	0x05
#define PSL0_EOT	0x04
#define PSL0_ESC	0x1b
#define PSL0_ETB	0x17
#define PSL0_ETX	0x03
#define PSL0_FF 	0x0c
#define PSL0_FS 	0x1c
#define PSL0_GS 	0x1d
#define PSL0_HT 	0x09
#define PSL0_IS4	0x1c
#define PSL0_IS3	0x1d
#define PSL0_IS2	0x1e
#define PSL0_IS1	0x1f
#define PSL0_LF 	0x0a
#define PSL0_NAK	0x15
#define PSL0_RS 	0x1e
#define PSL0_SI 	0x0f
#define PSL0_SO 	0x0e
#define PSL0_SOH	0x01
#define PSL0_STX	0x02
#define PSL0_SUB	0x1a
#define PSL0_SYN	0x16
#define PSL0_US 	0x1f
#define PSL0_VT 	0x0b

/* VSX pseudolanguage control characters */

#define PSL14_ACK	0x06
#define PSL14_BEL	0x07
#define PSL14_BS 	0x08
#define PSL14_CAN	0x18
#define PSL14_CR 	0x0d
#define PSL14_DC1	0x11
#define PSL14_DC2	0x12
#define PSL14_DC3	0x13
#define PSL14_DC4	0x14
#define PSL14_DEL	0x7f
#define PSL14_DLE	0x10
#define PSL14_EM 	0x19
#define PSL14_ENQ	0x05
#define PSL14_EOT	0x04
#define PSL14_ESC	0x1b
#define PSL14_ETB	0x17
#define PSL14_ETX	0x03
#define PSL14_FF 	0x0c
#define PSL14_FS 	0x1c
#define PSL14_GS 	0x1d
#define PSL14_HT 	0x09
#define PSL14_IS4	0x1c
#define PSL14_IS3	0x1d
#define PSL14_IS2	0x1e
#define PSL14_IS1	0x1f
#define PSL14_LF 	0x0a
#define PSL14_NAK	0x15
#define PSL14_RS 	0x1e
#define PSL14_SI 	0x0f
#define PSL14_SO 	0x0e
#define PSL14_SOH	0x01
#define PSL14_STX	0x02
#define PSL14_SUB	0x1a
#define PSL14_SYN	0x16
#define PSL14_US 	0x1f
#define PSL14_VT 	0x0b
