/*
 * ctrlebcdic.h - control character encodings for EBCDIC systems
 *
 * This file specifies the character encodings of control characters
 * for the POSIX locale and for the VSX pseudolanguages.
 *
 * This file must be modified by the user if the POSIX locale encodings
 * are incorrect or the pseudolanguages encodings are not appropriate.
 */

/* POSIX locale control characters */

#define PSL0_ACK	056
#define PSL0_BEL	057
#define PSL0_BS		026
#define PSL0_CAN	030
#define PSL0_CR		015
#define PSL0_DC1	021
#define PSL0_DC2	022
#define PSL0_DC3	023
#define PSL0_DC4	074
#define PSL0_DEL	007
#define PSL0_DLE	020
#define PSL0_EM		031
#define PSL0_ENQ	055
#define PSL0_EOT	067
#define PSL0_ESC	047
#define PSL0_ETB	046
#define PSL0_ETX	003
#define PSL0_FF		014
#define PSL0_FS		034
#define PSL0_GS		035
#define PSL0_HT		005
#define PSL0_IS4	034
#define PSL0_IS3	035
#define PSL0_IS2	036
#define PSL0_IS1	037
#define PSL0_LF		025
#define PSL0_NAK	075
#define PSL0_RS		036
#define PSL0_SI		017
#define PSL0_SO		016
#define PSL0_SOH	001
#define PSL0_STX	002
#define PSL0_SUB	077
#define PSL0_SYN	062
#define PSL0_US		037
#define PSL0_VT		013

/* VSX pseudolanguage control characters */

#define PSL14_ACK	056
#define PSL14_BEL	057
#define PSL14_BS	026
#define PSL14_CAN	030
#define PSL14_CR	015
#define PSL14_DC1	021
#define PSL14_DC2	022
#define PSL14_DC3	023
#define PSL14_DC4	074
#define PSL14_DEL	007
#define PSL14_DLE	020
#define PSL14_EM	031
#define PSL14_ENQ	055
#define PSL14_EOT	067
#define PSL14_ESC	047
#define PSL14_ETB	046
#define PSL14_ETX	003
#define PSL14_FF	014
#define PSL14_FS	034
#define PSL14_GS	035
#define PSL14_HT	005
#define PSL14_IS4	034
#define PSL14_IS3	035
#define PSL14_IS2	036
#define PSL14_IS1	037
#define PSL14_LF	025
#define PSL14_NAK	075
#define PSL14_RS	036
#define PSL14_SI	017
#define PSL14_SO	016
#define PSL14_SOH	001
#define PSL14_STX	002
#define PSL14_SUB	077
#define PSL14_SYN	062
#define PSL14_US	037
#define PSL14_VT	013
