/*
*	SCCS:	@(#)	INC/exitcodes.h	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

/***********************************************************************

NAME:		exitcodes.h - testset exit codes

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	simple defines for vsx-wide testset exit codes
AUTHOR:		H Reid, UniSoft Ltd.
DATE CREATED:	Tue Jun 24 10:39:19 BST 1986
MODIFICATIONS:
		mhr - Thu Aug 14 11:31:27 PDT 1986 - added A_* defines
		for abandon() calls.
		hr - 18/8/86 - added A_STATDIFAIL
		hr - 19/8/86 - added A_SIGFAIL
		af -  1/9/86 - added A_READFAIL, A_PIPEFAIL, A_FCNTLFAIL
				     A_CLOSEFAIL
		mg -  2/9/86 - added A_OPENFAIL, A_MKNODFAIL
		af -14/11/86 - added A_DUPFAIL
		dmm - Fri May 29 10:03:16 WET 1987 - added A_* defines
		mm - 29/5/87 - added A_FSTATFAIL
************************************************************************/

#define	VE_SUCC		(0)	/* SUCCESS	*/

#define	VE_FATAL	(1)	/* Fatal error, controlled panic	*/
#define	VE_SIGTERM	(2)	/* SIGTERM caught			*/

#define	A_EXECFAIL	20		/* exec call failed */
#define	A_UIDFAIL	21		/* {get,set}{uid,gid} call failed */
#define	A_FORKFAIL	22		/* exit code if fork fails */
#define	A_EXECRET	23		/* child's exit code is bad */
#define	A_CHILDTO	24		/* child did not exit before timeout */
#define	A_NOSIG		25		/* signal SIG{TERM,KILL} not defined */
#define	A_WRCHILD	26		/* wait returned unknown child */
#define	A_WAITFAIL	27		/* wait failed for unknown reason */
#define	A_OPENSYNC	28		/* opensync failed */
#define	A_SENDSYNC	29		/* sendsync failed */
#define	A_WAITSYNC	30		/* waitsync failed */
#define	A_MISC		31		/* miscellaneous reasons */
#define	A_STATDIFAIL	32		/* statdevinode failed */
#define	A_NOMEM		33		/* no memory - malloc returned NULL */
#define	A_SIGFAIL	34		/* signal(2) failure */
#define	A_CHDIRFAIL	35		/* chdir(2) failure */
#define	A_WRITEFAIL	36		/* write(2) failure */
#define	A_STATFAIL	37		/* stat(2) failure */
#define	A_TSETDIR	38		/* tset directory set up badly */
#define	A_KILLFAIL	39		/* kill(2) failed */
#define A_PIPEFAIL	40		/* pipe(2) failed */
#define A_CLOSEFAIL	41		/* close(2) failed */
#define A_FCNTLFAIL	42		/* fcntl(2) failed */
#define A_READFAIL	43		/* read(2) failed */
#define	A_OPENFAIL	44		/* open(2) failed */
#define	A_MKNODFAIL	45		/* mknod(2) failed */
#define	A_CREATFAIL	46		/* creat(2) failed */
#define	A_LSEEKFAIL	47		/* lseek(2) failed */
#define	A_CHMODFAIL	48		/* chmod(2) failed */
#define	A_MOUNTFAIL	49		/* mount(2) failed */
#define	A_UMOUNTFAIL	50		/* umount(2) failed */
#define	A_ULIMITFAIL	51		/* ulimit(2) failed */
#define	A_DUPFAIL	52		/* dup(2) failed */
#define	A_FSTATFAIL	53		/* fstat(2) failure */
