/*
 *      SCCS: @(#)  INC/mount.h 4.1 (01/21/97)  VSXgen release 1.4
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

/***********************************************************************

NAME:		mount.h

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION:	RPC Header file for MOUNT protocol - generated by rpcgen

		Requires prior inclusion of <rpcincs.h>

AUTHOR:		Matthew Newman, UniSoft Ltd.
DATE CREATED:
MODIFICATIONS:
		Calum Laing, 29 Sept 1992
			Changed exportlist structure to contain expinfo
		
		Geoff Clare, 4 Jan 1993
			Removed extraneous comma from last enum member.

		Geoff Clare, 14 Jan 1993
			New configurable header <rpcincs.h>

************************************************************************/

/*
 * Sun RPC is a product of Sun Microsystems, Inc. and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.  Users
 * may copy or modify Sun RPC without charge, but are not authorized
 * to license or distribute it to anyone else except as part of a product or
 * program developed by the user or with the express written consent of
 * Sun Microsystems, Inc.
 *
 * SUN RPC IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 *
 * Sun RPC is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 *
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY SUN RPC
 * OR ANY PART THEREOF.
 *
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even if
 * Sun has been advised of the possibility of such damages.
 *
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */
/*
 * Copyright (c) 1985, 1990 by Sun Microsystems, Inc.
 */

/* @(#)mount.h	4.1 97/01/21 */
/* from @(#)mount.x	1.3 91/03/11 TIRPC 1.0 */
#ifndef _xnfs_mount_h
#define _xnfs_mount_h
#define MNTPATHLEN 1024
#define MNTNAMLEN 255
#define FHSIZE 32

#ifndef _fhandle
#define _fhandle
typedef char fhandle[FHSIZE];
bool_t xdr_fhandle();
#endif

enum mnt_stat {
	MNT_OK = 0,
	MNT_EPERM = 1,
	MNT_ENOENT = 2,
	MNT_EACCESS = 13,
	MNT_EINVAL = 22
};
typedef enum mnt_stat mnt_stat;
bool_t xdr_mnt_stat();

struct fhstatus {
	mnt_stat status;
	union {
		fhandle directory;
	} fhstatus_u;
};
typedef struct fhstatus fhstatus;
bool_t xdr_fhstatus();

typedef char *dirpath;
bool_t xdr_dirpath();

typedef char *name;
bool_t xdr_name();

struct mountlist {
	name hostname;
	dirpath dirname;
	struct mountlist *nextentry;
};
typedef struct mountlist mountlist;
bool_t xdr_mountlist();

struct expinfo {
	name expitem;
	struct expinfo *expnext;
};
typedef struct expinfo expinfo;
bool_t xdr_expinfo();

/*
 * Original and wrong (!) - Cal.
 * struct exportlist {
 * 	dirpath filesys;
 * 	struct expinfo 		expinfo;
 * 	struct exportlist 	*next;
 * };
 */

struct exportlist {
	dirpath filesys;
	struct expinfo 		*expinfo;
	struct exportlist 	*next;
};
typedef struct exportlist exportlist;
bool_t xdr_Xexportlist();

#define MOUNTPROG ((unsigned int)100005)
#define MOUNTVERS ((unsigned int)1)
#define MOUNTPROC_NULL ((unsigned long)0)
extern void *mountproc_null_1();
#define MOUNTPROC_MNT ((unsigned long)1)
extern fhstatus *mountproc_mnt_1();
#define MOUNTPROC_DUMP ((unsigned long)2)
extern mountlist *mountproc_dump_1();
#define MOUNTPROC_UMNT ((unsigned long)3)
extern void *mountproc_umnt_1();
#define MOUNTPROC_UMNTALL ((unsigned long)4)
extern void *mountproc_umntall_1();
#define MOUNTPROC_EXPORT ((unsigned long)5)
extern exportlist *mountproc_export_1();
#endif /*!_xnfs_mount_h*/
