/*
 *      SCCS: @(#)  INC/nlm.h 4.1 (01/21/97)  VSXgen release 1.4
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

/***********************************************************************

NAME:		nlm.h

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION:	RPC Header file for NLM protocol - generated by rpcgen

AUTHOR:		Matthew Newman, UniSoft Ltd.
DATE CREATED:
MODIFICATIONS:
		Geoff Clare, 4 Jan 1993
			Removed extraneous commas from last enum members.

		Geoff Clare, 28 Jan 1993
			Changed NLM_VERSX to unsigned int.

************************************************************************/
/*
 * Sun RPC is a product of Sun Microsystems, Inc. and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.  Users
 * may copy or modify Sun RPC without charge, but are not authorized
 * to license or distribute it to anyone else except as part of a product or
 * program developed by the user or with the express written consent of
 * Sun Microsystems, Inc.
 *
 * SUN RPC IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 *
 * Sun RPC is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 *
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY SUN RPC
 * OR ANY PART THEREOF.
 *
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even if
 * Sun has been advised of the possibility of such damages.
 *
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */
/*
 * Copyright (c) 1986, 1990 by Sun Microsystems, Inc.
 */

/* from @(#)nlm.h	4.1 97/01/21 */
/* from @(#)nlm_prot.x	1.3 91/03/11 TIRPC 1.0 */
#ifndef _xnfs_nlm_h
#define _xnfs_nlm_h
#define LM_MAXSTRLEN	1024
#define MAXNAMELEN	LM_MAXSTRLEN+1
#define MAXNETOBJ_SZ	1024

enum nlm_stats {
	LCK_GRANTED = 0,
	LCK_DENIED = 1,
	LCK_DENIED_NOLOCKS = 2,
	LCK_BLOCKED = 3,
	LCK_DENIED_GRACE_PERIOD = 4
};
typedef enum nlm_stats nlm_stats;
bool_t xdr_nlm_stats();


struct nlm_stat {
	nlm_stats stat;
};
typedef struct nlm_stat nlm_stat;
bool_t xdr_nlm_stat();


struct nlm_res {
	netobj cookie;
	nlm_stat stat;
};
typedef struct nlm_res nlm_res;
bool_t xdr_nlm_res();


struct nlm_holder {
	bool_t exclusive;
	int uppid;
	netobj oh;
	unsigned int l_offset;
	unsigned int l_len;
};
typedef struct nlm_holder nlm_holder;
bool_t xdr_nlm_holder();


struct nlm_testrply {
	nlm_stats stat;
	union {
		struct nlm_holder holder;
	} nlm_testrply_u;
};
typedef struct nlm_testrply nlm_testrply;
bool_t xdr_nlm_testrply();


struct nlm_testres {
	netobj cookie;
	nlm_testrply stat;
};
typedef struct nlm_testres nlm_testres;
bool_t xdr_nlm_testres();

struct nlm_lock {
	char *caller_name;
	netobj fh;
	netobj oh;
	int uppid;
	unsigned int l_offset;
	unsigned int l_len;
};
typedef struct nlm_lock nlm_lock;
bool_t xdr_nlm_lock();


struct nlm_lockargs {
	netobj cookie;
	bool_t block;
	bool_t exclusive;
	struct nlm_lock alock;
	bool_t reclaim;
	int state;
};
typedef struct nlm_lockargs nlm_lockargs;
bool_t xdr_nlm_lockargs();


struct nlm_cancargs {
	netobj cookie;
	bool_t block;
	bool_t exclusive;
	struct nlm_lock alock;
};
typedef struct nlm_cancargs nlm_cancargs;
bool_t xdr_nlm_cancargs();


struct nlm_testargs {
	netobj cookie;
	bool_t exclusive;
	struct nlm_lock alock;
};
typedef struct nlm_testargs nlm_testargs;
bool_t xdr_nlm_testargs();


struct nlm_unlockargs {
	netobj cookie;
	struct nlm_lock alock;
};
typedef struct nlm_unlockargs nlm_unlockargs;
bool_t xdr_nlm_unlockargs();

/*
 * The following enums are actually bit encoded for efficient
 * boolean algebra.... DON'T change them.....
 */

enum fsh_mode {
	fsm_DN = 0,
	fsm_DR = 1,
	fsm_DW = 2,
	fsm_DRW = 3
};
typedef enum fsh_mode fsh_mode;
bool_t xdr_fsh_mode();


enum fsh_access {
	fsa_NONE = 0,
	fsa_R = 1,
	fsa_W = 2,
	fsa_RW = 3
};
typedef enum fsh_access fsh_access;
bool_t xdr_fsh_access();


struct nlm_share {
	char *caller_name;
	netobj fh;
	netobj oh;
	fsh_mode mode;
	fsh_access access;
};
typedef struct nlm_share nlm_share;
bool_t xdr_nlm_share();


struct nlm_shareargs {
	netobj cookie;
	nlm_share share;
	bool_t reclaim;
};
typedef struct nlm_shareargs nlm_shareargs;
bool_t xdr_nlm_shareargs();


struct nlm_shareres {
	netobj cookie;
	nlm_stats stat;
	int sequence;
};
typedef struct nlm_shareres nlm_shareres;
bool_t xdr_nlm_shareres();


struct nlm_notify {
	char *name;
	long state;
};
typedef struct nlm_notify nlm_notify;
bool_t xdr_nlm_notify();


#define NLM_PROG ((unsigned int)100021)
#define NLM_VERS ((unsigned int)1)
#define NLM_NULL ((unsigned long)0)
extern void *nlm_null_1();
#define NLM_TEST ((unsigned long)1)
extern nlm_testres *nlm_test_1();
#define NLM_LOCK ((unsigned long)2)
extern nlm_res *nlm_lock_1();
#define NLM_CANCEL ((unsigned long)3)
extern nlm_res *nlm_cancel_1();
#define NLM_UNLOCK ((unsigned long)4)
extern nlm_res *nlm_unlock_1();
#define NLM_GRANTED ((unsigned long)5)
extern nlm_res *nlm_granted_1();
#define NLM_TEST_MSG ((unsigned long)6)
extern void *nlm_test_msg_1();
#define NLM_LOCK_MSG ((unsigned long)7)
extern void *nlm_lock_msg_1();
#define NLM_CANCEL_MSG ((unsigned long)8)
extern void *nlm_cancel_msg_1();
#define NLM_UNLOCK_MSG ((unsigned long)9)
extern void *nlm_unlock_msg_1();
#define NLM_GRANTED_MSG ((unsigned long)10)
extern void *nlm_granted_msg_1();
#define NLM_TEST_RES ((unsigned long)11)
extern void *nlm_test_res_1();
#define NLM_LOCK_RES ((unsigned long)12)
extern void *nlm_lock_res_1();
#define NLM_CANCEL_RES ((unsigned long)13)
extern void *nlm_cancel_res_1();
#define NLM_UNLOCK_RES ((unsigned long)14)
extern void *nlm_unlock_res_1();
#define NLM_GRANTED_RES ((unsigned long)15)
extern void *nlm_granted_res_1();
#define NLM_VERSX ((unsigned int)3)
#define NLM_SHARE ((unsigned long)20)
extern nlm_shareres *nlm_share_3();
#define NLM_UNSHARE ((unsigned long)21)
extern nlm_shareres *nlm_unshare_3();
#define NLM_NM_LOCK ((unsigned long)22)
extern nlm_res *nlm_nm_lock_3();
#define NLM_FREE_ALL ((unsigned long)23)
extern void *nlm_free_all_3();

#endif /*!_xnfs_nlm_h*/
