
/*
*	SCCS:	@(#)	INC/nlsclass.h		4.1 (01/21/97)  VSXgen release 1.4
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

/***********************************************************************

NAME:		nlsclass.h

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:	NLS Character Classifications (for isupper() etc.)

AUTHOR:		Andrew Twigger, UniSoft Ltd.
DATE CREATED:	Aug 24, 1988 (XPG3 version)
MODIFICATIONS:
		Geoff Clare, 29 May 1992
			Change XDIGIT chars in lang1 and lang2 to comply
			with XBD4 rules on class combinations.

		Geoff Clare, 22 March 1995
			Replaced static tables with extern declarations
			of tables to be initialised by pslclass().

***********************************************************************/

#define	DEFASCII 	1
#define	DEFCNTRL	2
#define DEFGRAPH	4
#define	DEFPRINT	8
#define	DEFPUNCT	16
#define	DEFSPACE	32
#define	DEFALNUM	64
#define	DEFXDIGIT	128
#define	DEFDIGIT	256
#define	DEFLOWER	512
#define	DEFUPPER	1024
#define	DEFALPHA	2048

extern	int	lang0_table[256][2];
extern	int	lang1_table[256][2];
extern	int	lang3_table[256][2];

/* to support old code */
#define	asc_table	lang0_table
#define	lang2_table	lang1_table
#define	lang4_table	lang3_table
