/*
 *      SCCS: @(#)  INC/nsm.h 4.1 (01/21/97)  VSXgen release 1.4
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

/***********************************************************************

NAME:		nsm.h

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION:	RPC Header file for NSM protocol - generated by rpcgen

		Requires prior inclusion of <rpcincs.h>

AUTHOR:		Matthew Newman, UniSoft Ltd.
DATE CREATED:
MODIFICATIONS:
		Geoff Clare, 4 Jan 1993
			Removed extraneous comma from last enum member.

		Geoff Clare, 14 Jan 1993
			New configurable header <rpcincs.h>

************************************************************************/

/*
 * Sun RPC is a product of Sun Microsystems, Inc. and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.  Users
 * may copy or modify Sun RPC without charge, but are not authorized
 * to license or distribute it to anyone else except as part of a product or
 * program developed by the user or with the express written consent of
 * Sun Microsystems, Inc.
 *
 * SUN RPC IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 *
 * Sun RPC is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 *
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY SUN RPC
 * OR ANY PART THEREOF.
 *
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even if
 * Sun has been advised of the possibility of such damages.
 *
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */
/*
 * Copyright (c) 1986, 1990 by Sun Microsystems, Inc.
 */

/* from @(#)nsm.h	4.1 97/01/21 */
/* from @(#)sm_inter.x	1.3 91/03/11 TIRPC 1.0 */

#ifndef _xnfs_nsm_h
#define _xnfs_nsm_h

#define SM_MAXSTRLEN 1024

struct sm_name {
	char *mon_name;
};
typedef struct sm_name sm_name;
bool_t xdr_sm_name();

enum sm_res {
	STAT_SUCC = 0,
	STAT_FAIL = 1
};
typedef enum sm_res sm_res;
bool_t xdr_sm_res();

struct sm_stat_res {
	sm_res res_stat;
	int state;
};
typedef struct sm_stat_res sm_stat_res;
bool_t xdr_sm_stat_res();

struct sm_stat {
	int state;
};
typedef struct sm_stat sm_stat;
bool_t xdr_sm_stat();

struct my_id {
	char *my_name;
	int my_prog;
	int my_vers;
	int my_proc;
};
typedef struct my_id my_id;
bool_t xdr_my_id();

struct mon_id {
	char *mon_name;
	struct my_id my_id;
};
typedef struct mon_id mon_id;
bool_t xdr_mon_id();

struct mon {
	struct mon_id mon_id;
	char priv[16];
};
typedef struct mon mon;
bool_t xdr_mon();

struct stat_chge {
	char *mon_name;
	int state;
};
typedef struct stat_chge stat_chge;
bool_t xdr_stat_chge();

struct status {
	char *mon_name;
	int state;
	char priv[16];
};
typedef struct status status;
bool_t xdr_status();

#define SM_PROG ((unsigned int)100024)
#define SM_VERS ((unsigned int)1)
#define SM_NULL ((unsigned long)0)
extern void *sm_null_1();
#define SM_STAT ((unsigned long)1)
extern struct sm_stat_res *sm_stat_1();
#define SM_MON ((unsigned long)2)
extern struct sm_stat_res *sm_mon_1();
#define SM_UNMON ((unsigned long)3)
extern struct sm_stat *sm_unmon_1();
#define SM_UNMON_ALL ((unsigned long)4)
extern struct sm_stat *sm_unmon_all_1();
#define SM_SIMU_CRASH ((unsigned long)5)
extern void *sm_simu_crash_1();
#define SM_NOTIFY ((unsigned long)6)
extern void *sm_notify_1();

#endif /*!_xnfs_nsm_h*/
