/*
*      SCCS:   @(#)	pcts_max.h 4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

/***********************************************************************

NAME:		pcts_max.h - define PCTS_xyz_MAX constants

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
		Defines PCTS_ARG_MAX, PCTS_CHILD_MAX, PCTS_OPEN_MAX,
			PCTS_LINK_MAX, PCTS_MAX_CANON, PCTS_MAX_INPUT,
			PCTS_PATH_MAX and PCTS_NAME_MAX.

ASSUMES:

AUTHOR:		Geoff Clare, UniSoft Ltd.
DATE CREATED:	15 Mar 1989
REQUIRES PRIOR INCLUSION OF:	<limits.h>
MODIFICATIONS:	
		Geoff Clare, 29 Mar 1990
			Add PCTS_PATH_MAX and PCTS_NAME_MAX.
		Geoff Clare, 26 Apr 1990
			Add PCTS_TZNAME_MAX.

************************************************************************/

#define PCTS_ARG_MAX	(10 * _POSIX_ARG_MAX)
#define PCTS_CHILD_MAX	256
#define PCTS_LINK_MAX	256
#define PCTS_MAX_CANON	(4 * _POSIX_MAX_CANON)
#define PCTS_MAX_INPUT	(4 * _POSIX_MAX_INPUT)
#define PCTS_NAME_MAX	2048
#define PCTS_OPEN_MAX	256
#define PCTS_PATH_MAX	4096
#define PCTS_TZNAME_MAX	256
