/*
 *      SCCS: @(#)  INC/pmap.h 4.1 (01/21/97)  VSXgen release 1.4
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

/***********************************************************************

NAME:		pmap.h

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION:	RPC Header file for PMAP protocol - generated by rpcgen

		Requires prior inclusion of <rpcincs.h>

AUTHOR:		Matthew Newman, UniSoft Ltd.
DATE CREATED:
MODIFICATIONS:
		Geoff Clare, 14 Jan 1993
			New configurable header <rpcincs.h>

************************************************************************/

/*
 * Sun RPC is a product of Sun Microsystems, Inc. and is provided for
 * unrestricted use provided that this legend is included on all tape
 * media and as a part of the software program in whole or part.  Users
 * may copy or modify Sun RPC without charge, but are not authorized
 * to license or distribute it to anyone else except as part of a product or
 * program developed by the user or with the express written consent of
 * Sun Microsystems, Inc.
 *
 * SUN RPC IS PROVIDED AS IS WITH NO WARRANTIES OF ANY KIND INCLUDING THE
 * WARRANTIES OF DESIGN, MERCHANTIBILITY AND FITNESS FOR A PARTICULAR
 * PURPOSE, OR ARISING FROM A COURSE OF DEALING, USAGE OR TRADE PRACTICE.
 *
 * Sun RPC is provided with no support and without any obligation on the
 * part of Sun Microsystems, Inc. to assist in its use, correction,
 * modification or enhancement.
 *
 * SUN MICROSYSTEMS, INC. SHALL HAVE NO LIABILITY WITH RESPECT TO THE
 * INFRINGEMENT OF COPYRIGHTS, TRADE SECRETS OR ANY PATENTS BY SUN RPC
 * OR ANY PART THEREOF.
 *
 * In no event will Sun Microsystems, Inc. be liable for any lost revenue
 * or profits or other special, indirect and consequential damages, even if
 * Sun has been advised of the possibility of such damages.
 *
 * Sun Microsystems, Inc.
 * 2550 Garcia Avenue
 * Mountain View, California  94043
 */
/*
 * Copyright (c) 1985, 1990 by Sun Microsystems, Inc.
 */

/* from @(#)pmap.h	4.1 97/01/21 */
/* from @(#)pmap_prot.x	1.3 91/03/11 TIRPC 1.0 */

#ifndef _xnfs_pmap_h
#define _xnfs_pmap_h


struct mapping {
	unsigned int prog;
	unsigned int vers;
	unsigned int prot;
	unsigned int port;
};
typedef struct mapping mapping;
bool_t xdr_mapping();

struct pmaplist {
	mapping map;
	struct pmaplist *next;
};
typedef struct pmaplist pmaplist;
bool_t xdr_pmaplist();

#define PMAP_PROG ((unsigned int)100000)
#define PMAP_VERS ((unsigned int)2)
#define PMAP_NULL ((unsigned long)0)
extern void *pmap_null_2();
#define PMAP_SET ((unsigned long)1)
extern bool_t *pmap_set_2();
#define PMAP_UNSET ((unsigned long)2)
extern bool_t *pmap_unset_2();
#define PMAP_GETPORT ((unsigned long)3)
extern unsigned int *pmap_getport_2();
#define PMAP_DUMP ((unsigned long)4)
extern pmaplist *pmap_dump_2();

#endif /* ! _xnfs_pmap_h */
