/*
 * pslcodes.h - pseudolanguage character encodings
 *
 * This file specifies the character encodings of characters not in
 * the portable character set (except control characters) for each
 * VSX pseudolanguage.
 *
 * This file must be modified by the user if the default encodings
 * are not appropriate.
 */

/* VSX4L1 and VSX4L2 extra characters */

#define PSL12_A_umlaut	0x9c
#define PSL12_O_umlaut	0x9d
#define PSL12_U_umlaut	0x9e
#define PSL12_cedilla	0x9f
#define PSL12_a_umlaut	0xdc
#define PSL12_o_umlaut	0xdd
#define PSL12_u_umlaut	0xde
#define PSL12_eszet	0xdf

/* VSX4L3 and VSX4L3@dict extra characters */

#define PSL34_A_grave		0xc0	
#define PSL34_A_acute		0xc1	
#define PSL34_A_circumflex	0xc2	
#define PSL34_A_tilde		0xc3	
#define PSL34_A_umlaut		0xc4	
#define PSL34_A_ring		0xc5	
#define PSL34_C_cedilla		0xc7	
#define PSL34_E_grave		0xc8	
#define PSL34_E_acute		0xc9	
#define PSL34_E_circumflex	0xca	
#define PSL34_E_umlaut		0xcb	
#define PSL34_I_grave		0xcc	
#define PSL34_I_acute		0xcd	
#define PSL34_I_circumflex	0xce	
#define PSL34_I_umlaut		0xcf	
#define PSL34_O_grave		0xd2	
#define PSL34_O_acute		0xd3	
#define PSL34_O_circumflex	0xd4	
#define PSL34_O_tilde		0xd5	
#define PSL34_O_umlaut		0xd6	
#define PSL34_U_grave		0xd9	
#define PSL34_U_acute		0xda	
#define PSL34_U_circumflex	0xdb	
#define PSL34_U_umlaut		0xdc	
#define PSL34_Y_acute		0xdd	
#define PSL34_eszet		0xdf	
#define PSL34_a_grave		0xe0	
#define PSL34_a_acute		0xe1	
#define PSL34_a_circumflex	0xe2	
#define PSL34_a_tilde		0xe3	
#define PSL34_a_umlaut		0xe4	
#define PSL34_a_ring		0xe5	
#define PSL34_c_cedilla		0xe7	
#define PSL34_e_grave		0xe8	
#define PSL34_e_acute		0xe9	
#define PSL34_e_circumflex	0xea	
#define PSL34_e_umlaut		0xeb	
#define PSL34_i_grave		0xec	
#define PSL34_i_acute		0xed	
#define PSL34_i_circumflex	0xee	
#define PSL34_i_umlaut		0xef	
#define PSL34_o_grave		0xf2	
#define PSL34_o_acute		0xf3	
#define PSL34_o_circumflex	0xf4	
#define PSL34_o_tilde		0xf5	
#define PSL34_o_umlaut		0xf6	
#define PSL34_u_grave		0xf9	
#define PSL34_u_acute		0xfa	
#define PSL34_u_circumflex	0xfb	
#define PSL34_u_umlaut		0xfc	
#define PSL34_y_acute		0xfd	
