/*
 * pslebcdic.h - pseudolanguage character encodings for EBCDIC systems
 *
 * This file specifies the character encodings of characters not in
 * the portable character set (except control characters) for each
 * VSX pseudolanguage.
 *
 * This file must be modified by the user if the default encodings
 * are not appropriate.
 */

/* VSX4L1 and VSX4L2 extra characters */

#define PSL12_A_umlaut	0x9c
#define PSL12_O_umlaut	0x9d
#define PSL12_U_umlaut	0x9e
#define PSL12_cedilla	0x9f
#define PSL12_a_umlaut	0xdc
#define PSL12_o_umlaut	0xdd
#define PSL12_u_umlaut	0xde
#define PSL12_eszet	0xdf

/* VSX4L3 and VSX4L3@dict extra characters */

#define PSL34_A_tilde		0x41
#define PSL34_A_grave		0x42
#define PSL34_A_acute		0x43
#define PSL34_A_ring		0x44
#define PSL34_A_circumflex	0x45
#define PSL34_A_umlaut		0x46
#define PSL34_C_cedilla		0x51
#define PSL34_E_grave		0x52
#define PSL34_E_acute		0x53
#define PSL34_E_circumflex	0x55
#define PSL34_E_umlaut		0x56
#define PSL34_I_grave		0x62
#define PSL34_I_acute		0x63
#define PSL34_I_circumflex	0x65
#define PSL34_I_umlaut		0x66
#define PSL34_O_tilde		0x71
#define PSL34_O_grave		0x72
#define PSL34_O_acute		0x73
#define PSL34_O_circumflex	0x75
#define PSL34_O_umlaut		0x76
#define PSL34_Y_acute		0xb1
#define PSL34_U_grave		0xb2
#define PSL34_U_acute		0xb3
#define PSL34_U_circumflex	0xb5
#define PSL34_U_umlaut		0xb6
#define PSL34_a_tilde		0x8a
#define PSL34_a_grave		0x8b
#define PSL34_a_acute		0x8c
#define PSL34_a_ring		0x8d
#define PSL34_a_circumflex	0x8e
#define PSL34_a_umlaut		0x8f
#define PSL34_e_grave		0x9b
#define PSL34_e_acute		0x9c
#define PSL34_e_circumflex	0x9e
#define PSL34_e_umlaut		0x9f
#define PSL34_c_cedilla		0xaa
#define PSL34_i_grave		0xab
#define PSL34_i_acute		0xac
#define PSL34_i_circumflex	0xae
#define PSL34_i_umlaut		0xaf
#define PSL34_o_tilde		0xba
#define PSL34_o_grave		0xbb
#define PSL34_o_acute		0xbc
#define PSL34_o_circumflex	0xbe
#define PSL34_o_umlaut		0xbf
#define PSL34_y_acute		0xca
#define PSL34_u_grave		0xcb
#define PSL34_u_acute		0xcc
#define PSL34_u_circumflex	0xce
#define PSL34_u_umlaut		0xcf
#define PSL34_eszet		0xdf
