/* dv @(#)COMMONGABI/GABIINC/resmgr.h	1.6 99/11/12 */
/*
* (C) Copyright 1998 UniSoft Limited.
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*/

#ifndef _RESMGR_H
#define _RESMGR_H

#include <stdlib.h>
#include <sys/types.h>

/* Initial types of resources dealt with by the resource manager */
#define RES_ALL		-1
#define RES_NONE	0
#define RES_MEMORY	1
#define RES_FILE	2
#define RES_FILEDES	3
#define RES_DIR		4
#define RES_STDIOSTREAM	5

/* Function pointer types for use when adding new types of resource */
typedef void * (*res_savefunc_t)(void *);
typedef int (*res_cmpfunc_t)(void *, void *);
typedef void (*res_freefunc_t)(void *);

/* Function prototypes */
void res_register(void *data, int type);
void res_unregister(void *data, int type);
void res_unregtype(int type);
void res_freeall(void);
int res_setenable(int type, int enable);
int res_addtype(res_savefunc_t savefn, res_cmpfunc_t cmpfn,
	res_freefunc_t freefn);
void res_regnewtype(int *type, res_savefunc_t savefn, res_cmpfunc_t cmpfn,
	res_freefunc_t freefn, void *data);
void * res_saveptr(void *data);
int res_cmpptr(void *data1, void *data2);
void * res_savestr(void *data);
int res_cmpstr(void *data1, void *data2);
void * res_saveint(void *data);
int res_cmpint(void *data1, void *data2);
void res_remove(void *data);
void res_close(void *data);
int res_cmpfail(void *data1, void *data2);
void res_fclose(void *data);
void res_freenoop(void *data);
void * rmalloc(size_t size);
void * rrealloc(void *ptr, size_t size);
char * rstrdup(char *str);
int ropen(char *path, int oflag, ... /* [mode_t mode] */ );
int rmkdir(char *path, mode_t mode);

#endif /* _RESMGR_H */
