/*
*      SCCS:   @(#)	setprv.h 4.2 (04/22/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

/***********************************************************************

NAME:		setprv.h - defines for setprv() arguments

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
		see vport/userintf.c
ASSUMES:

AUTHOR:		Geoff Clare, UniSoft Ltd.
DATE CREATED:	22 Mar 1989
MODIFICATIONS:	
		Geoff Clare, 29 June 1990
			Add PRV_KILL

		Geoff Clare, 27 Aug 1991
			Add PRV_DEVICE, PRV_ASSIGN

		Matt Newman, 9 Sep 1991
			Add PRV_IPC

		Peter Skan, 10 Sep 1991
			Add PRV_NICE

		Peter Skan, 26 Sep 1991
			Add PRV_ULIMIT

		Geoff Clare, 10 Jan 1997
			Additions for XSH5.

************************************************************************/

#define PRV_SETID	1	/* change to any uid/gid */
#define PRV_MOUNT	2	/* mount and unmount file systems */
#define PRV_LINKDIR	3	/* create links to directories */
#define PRV_ACCESS	4	/* unrestricted access to files */
#define PRV_CHOWN	5	/* change owner/group/mode of ANY file */
#define PRV_SETGRPS	6	/* set supplementary group IDs */
#define PRV_NEWROOT	7	/* set root directory of process */
#define PRV_KILL	8	/* send signal to any process */
#define PRV_DEVICE	9	/* access device files */
#define PRV_ASSIGN	10	/* assign privilege to an executable file */
#define PRV_IPC		11	/* allow unrestricted ipc access */
#define PRV_NICE	12	/* change process priority */
#define PRV_ULIMIT	13	/* increase file size limit */
#define PRV_EXPORT	14	/* export and unexport file systems	*/
#define PRV_LIMITS	15	/* privileged setrlimit() */
#define PRV_MEMLOCK	16	/* memory locking */
#define PRV_SETTIME	17	/* set (real-time) clocks */
#define PRV_SETRTSCHED  18	/* set (real-time) process scheduling params */
#define PRV_GETRTSCHED  19	/* get (real-time) process scheduling params */
#define PRV_SETTHRSCHED 20	/* set threads scheduling params */
#define PRV_GETTHRSCHED 21	/* get threads scheduling params */
