
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_fw.h	1.12
*
*************************************************************************/


/******	This header defines the major data structures and associated
	routines used in re-entrancy, cancellation point and EINTR
	testing in VSTH.					******/


#define	VSTH_SWARM		16	/* Number of threads to use in RT testing */
#define	VSTH_ETTRIES_MAX	16	/* Max number of iterations in EINTR testing */
#define	VSTH_ETSIGS_MAX		4096	/* Max number of signals sent in 1 et test */
#define	VSTH_BUFLEN		256
#define	VSTH_MBTOWC_MAXBYTES	50

typedef	struct {
	int	(*sfunc)();
	int	(*tfunc)();
	int	(*efunc)();
	char	*fname;
} VSTH_RT, *VSTH_PRT;

extern	int		Vsth_rt_cnt;
extern	int		Vsth_wc_init;

/* for general use by vsth_rt() and called functions */
extern	pthread_mutex_t	Vsth_mx;
extern	char		Vsth_buf1[VSTH_BUFLEN];
extern	char		Vsth_buf2[VSTH_BUFLEN];

/* Vsth_rt_ arrays used by PTHR.os/all/General.4,6-12 */
extern	VSTH_RT		Vsth_rt_a_to_d[];
extern	VSTH_RT		Vsth_rt_e[];
extern	VSTH_RT		Vsth_rt_f[];
extern	VSTH_RT		Vsth_rt_g_to_h[];
extern	VSTH_RT		Vsth_rt_i_to_n[];
extern	VSTH_RT		Vsth_rt_o_to_p[];
extern	VSTH_RT		Vsth_rt_q_to_s[];
extern	VSTH_RT		Vsth_rt_t_to_z[];

/* Vsth_cp arrays used by PTHR.os/all/pthread_cancel.6-9 */
extern	VSTH_RT		Vsth_cp6[];
extern	VSTH_RT		Vsth_cp7[];
extern	VSTH_RT		Vsth_cp8[];
extern	VSTH_RT		Vsth_cp9[];

extern	VSTH_RT		Vsth_fs[];

void	vsth_rt( VSTH_PRT prt, int *errors, int *fails );
void	vsth_cpt( VSTH_PRT prt, int flag, int *errors, int *fails );
void	vsth_et( VSTH_PRT prt, int *errors, int *fails );
void	vsth_ec();	/* enter critical region */
void	vsth_xc();	/* exit critical region */
