/*
*	SCCS:	@(#)	INC/wait_child.h		4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/
/***********************************************************************

NAME:		wait_child.h - status values for child set by wait_child()

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:	wait_child() returns a value to indicate the status of a 
		child process which has been waited for.
		The value will be one of the following:
		CHLD_EXIT	Child process exitted.
				In this case, ex_code is the exit code of child.
		CHLD_ABRT	Child process terminated on receiving signal.
				In this case, sg_code is the signal number.
		CHLD_LIVE	The child process is alive - waitpid timed out.
		CHLD_STOP	The child process is stopped.
		CHLD_ERR	Error in waitpid().

REQUIRES PRIOR INCLUSION OF:

AUTHOR:
	Dave Cater, Unisoft Ltd.
DATE CREATED:
	Wed Mar 29 10:32:44 GMT 1989
MODIFICATIONS:

************************************************************************/


#define	CHLD_EXIT	1
#define	CHLD_ABRT	2
#define	CHLD_LIVE	3
#define	CHLD_STOP	4
#define	CHLD_ERR	5
