/*
*	SCCS:	@(#)	INC/wchar_cfg.h		4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

/***********************************************************************

NAME:		wchar_cfg.h - wide character config definitions

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
		Contains definitions for use in tests which use the
		wcharcfg() function.

ASSUMES:

AUTHOR:		David G. Sawyer, UniSoft Ltd.
DATE CREATED:	Fri Dec 06 21:20:06 GMT 1991
REQUIRES PRIOR INCLUSION OF:
MODIFICATIONS:	
		Geoff Clare, 3 Mar 1992
			Add psl_wc_skip() as temporary measure to
			skip problem character values.

		Geoff Clare, 6 May 1992
			Remove psl_wc_skip().

************************************************************************/

struct wc_prop
{
	unsigned char	*name;
	unsigned char	*is[3];
	unsigned char	*not[3];
};

struct wchar
{
	unsigned char	*locale1;
	unsigned char	*locale2;
	unsigned char	*iswcntrl[3];
	unsigned char	*notcntrl[3];
	unsigned char	*iswgraph[3];
	unsigned char	*notgraph[3];
	unsigned char	*iswlower[3];
	unsigned char	*notlower[3];
	unsigned char	*iswpunct[3];
	unsigned char	*notpunct[3];
	unsigned char	*iswspace[3];
	unsigned char	*notspace[3];
	unsigned char	*iswupper[3];
	unsigned char	*notupper[3];
	struct wc_prop	*properties;
	unsigned char	*towupper[3][2];
	unsigned char	*towlower[3][2];
	unsigned char	*width0[3];
	unsigned char	*width1[3];
	unsigned char	*width2[3];
	unsigned char	*width3[3];
	unsigned char	*dontcare[3];
	unsigned char	*primary[10][2];
	unsigned char	*secondary[10][2];
	unsigned char	*primary2_1[6][3];
	unsigned char	*secondary2_1[6][3];
	unsigned char	*equal1_2[6][3];
	unsigned char	*decpoint1;
	unsigned char	*decpoint2;
	unsigned char	*month1[12];
	unsigned char	*abmon1[12];
	unsigned char	*day1[7];
	unsigned char	*abday1[7];
	unsigned char	*am_str1;
	unsigned char	*pm_str1;
	unsigned char	*month2[12];
	unsigned char	*abmon2[12];
	unsigned char	*day2[12];
	unsigned char	*abday2[12];
	unsigned char	*am_str2;
	unsigned char	*pm_str2;
	unsigned char	*mbcurmax1;
	unsigned char	*mbcurmax2;
	unsigned char	*invalid_mb;
	wchar_t	invalid_wc;
};
