/*
*      SCCS:   @(#)common/drivers/Hlocal.c	4.2 (02/11/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/
static	char sccsid[] = "@(#)common/drivers/drvlib.a VSXgen release 1.4";

/***********************************************************************

NAME:           Hlocal.c - local routines/data for driver.hdr

PROJECT:	VSX (X/OPEN Validation Suite)

SYNOPSIS:
		int cfile_rpt();
		int C_driver;
		char *ftmaclist[];

DESCRIPTION:
	Functions and data that differ between the header test driver(s) and
	the C language test driver.

AUTHOR:		Stuart Boutell, UniSoft Ltd
DATE CREATED:	Tue Nov 13 14:58:59 GMT 1990
MODIFICATIONS:
	Stuart Boutell, 29 Nov 1990
		Added C_driver declaration

	Geoff Clare, 12 Nov 1991
		Added ftmaclist[] array.

	Geoff Clare, 10 Jan 1997
		Added ftmaclist[] entries for POSIX96, UNIX95 and UNIX98.

	Geoff Clare, 11 Feb 1997
		Moved cflags_var to Hvarnames.c.

************************************************************************/

#include <std.h>
#include <hdr.h>
#include <sysdep.h>

public	int	C_driver = 0; /* This is NOT the C language driver */

/* feature test macros for use in each test mode */

public	char	*ftmaclist[] = {

#ifdef _XOPEN_SOURCE

#  if TEST_UNIX
#    if TEST_XPG >= 500
	/* UNIX98 */
	"-D_XOPEN_SOURCE=500",
	"-D_XOPEN_SOURCE=500 -D_POSIX_SOURCE",
	"-D_XOPEN_SOURCE=500 -D_POSIX_C_SOURCE=1",
	"-D_XOPEN_SOURCE=500 -D_POSIX_C_SOURCE=1 -D_POSIX_SOURCE",
	"-D_XOPEN_SOURCE=500 -D_POSIX_C_SOURCE=2",
	"-D_XOPEN_SOURCE=500 -D_POSIX_C_SOURCE=2 -D_POSIX_SOURCE",
	"-D_XOPEN_SOURCE=500 -D_POSIX_C_SOURCE=199309",
	"-D_XOPEN_SOURCE=500 -D_POSIX_C_SOURCE=199309 -D_POSIX_SOURCE",
	"-D_XOPEN_SOURCE=500 -D_POSIX_C_SOURCE=199506",
	"-D_XOPEN_SOURCE=500 -D_POSIX_C_SOURCE=199506 -D_POSIX_SOURCE",
#    else
	/* UNIX95 */
	"-D_XOPEN_SOURCE_EXTENDED -D_XOPEN_SOURCE",
	"-D_XOPEN_SOURCE_EXTENDED -D_XOPEN_SOURCE -D_POSIX_SOURCE",
	"-D_XOPEN_SOURCE_EXTENDED -D_XOPEN_SOURCE -D_POSIX_C_SOURCE=1",
	"-D_XOPEN_SOURCE_EXTENDED -D_XOPEN_SOURCE -D_POSIX_C_SOURCE=2",
	"-D_XOPEN_SOURCE_EXTENDED -D_XOPEN_SOURCE -D_POSIX_SOURCE -D_POSIX_C_SOURCE=1",
	"-D_XOPEN_SOURCE_EXTENDED -D_XOPEN_SOURCE -D_POSIX_SOURCE -D_POSIX_C_SOURCE=2",
#    endif

#  else /* !TEST_UNIX */

#    if TEST_XPG > 3
	/* XPG4 */
	"-D_XOPEN_SOURCE",
	"-D_XOPEN_SOURCE -D_POSIX_SOURCE",
	"-D_XOPEN_SOURCE -D_POSIX_C_SOURCE=1",
	"-D_XOPEN_SOURCE -D_POSIX_C_SOURCE=2",
	"-D_XOPEN_SOURCE -D_POSIX_SOURCE -D_POSIX_C_SOURCE=1",
	"-D_XOPEN_SOURCE -D_POSIX_SOURCE -D_POSIX_C_SOURCE=2",
#    else
	/* XPG3 */
	"-D_XOPEN_SOURCE",
#    endif

#  endif /* !TEST_UNIX */

#else /* !_XOPEN_SOURCE */

#  if _POSIX_C_SOURCE >= 199506
	/* POSIX96 */
	"-D_POSIX_C_SOURCE=199506",
	"-D_POSIX_C_SOURCE=199506 -D_POSIX_SOURCE",
#  else
	/* POSIX90 and FIPS */
	"-D_POSIX_SOURCE",
#  endif

#endif /* !_XOPEN_SOURCE */

	0
};

public int
cfile_rpt()
{
	return(T_FAIL);
}
