/*
*      SCCS:   @(#)SRC/common/drivers/execute.c	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

/***********************************************************************

NAME:		execute.c - execute objectfile

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	execute()

SYNOPSIS:
	int
	execute()

DESCRIPTION:
	execute() exec's objectfile; the result of compiling
	datafile.
	execute() will return only PASS, FAIL or RFI

METHODS:
ASSUMES:
	extern char *objectfile points to valid file name

CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Paul Hackney
DATE CREATED:	Wed Jul 30 13:39:20 BST 1986

MODIFICATIONS:
		Geoff Clare, 20 Dec 1989
			Remove environment set-up (just pass down the one
			inherited from vtest).  This allows executable
			header tests to access vtest parameters.

************************************************************************/

#include	<std.h>
#include	<stdlib.h>
#include	<sys/types.h>
#include	<string.h>
#include	<dbug.h>
#include	<hdr.h>
#include	<fcntl.h>

#include	<unistd.h>

#include	<sysdep.h>

extern	void	htabandon();
extern	char	*errname();
extern	char	**environ;

extern	void	ccexec();
extern	char	*argv[];		/* argument vector for above */

public	int 
execute()
	/*NOPARAMETERS*/
{
	DBUG_ENTER( "execute" );

	/*
	 * command line is simply the name of objectfile
	 */

	DBUG_PRINTF("execute","%s",objectfile);
	argv[0] = objectfile;
	argv[1] = (char *)NULL;

	cstatus	= tet_fork(ccexec,NULLFN,(160*SPEEDFACTOR),~0);

	DBUG_RETURN( cstatus == 0 ?
		SUCCEED : FAIL );
}
