/*
*      SCCS:   @(#)/SRC/common/drivers/(globals.c)	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/
/***********************************************************************

NAME:		globals.c - teset wide global variables

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
		declare all testset wide variables
REQUIRES PRIOR INCLUSION OF:
ASSUMES:

AUTHOR:		Paul Hackney
DATE CREATED:	Wed Jul 30 12:45:53 BST 1986

MODIFICATIONS:
		Geoff Clare, 3 Nov 1989
			Delete definition of 'child' (already in genlib)

		Stuart Boutell, 25 Feb 1991
			Renamed 'index' to 'test_index' to avoid
			namespace pollution.

		Geoff Clare, 12 Nov 1991
			Added ftmacs.

************************************************************************/
#include	<std.h>
#include	<hdr.h>
#include	<sysdep.h>

public	int	ntests;				/* number of tests */
public	int	test_index;			/* Index into tcnrl struct */
public	int	debug		= FALSE;	/* true for "-D" flag */
public	int	cstatus;			/* child return status */
public	int	running		= FALSE;	/* testset is running */
public	struct tcntrl	**test;			/* test control array */

public	char	*vsx_cc;			/* C compiler path */
public	char	*vsx_cflags;			/* C compiler flags */
public	char	*ftmacs;			/* Feature test macros */
public	char	*vsx_libs;			/* C compiler libraries */
public	char	*vsx_ld;			/* Linker path */
public	char	*vsx_c_out;			/* Linker output file spec */
public	char	*vsx_c_nolink;			/* No link option */
public	char	*vsx_c_link;			/* link option */
public	char	*vsx_c_isep;			/* -I seperator */
public	char	*vsx_c_suffix;			/* .o suffix */
public	char	*vg_file = "<no file>";		/* argv[0] */
public	char	*vg_ident = "<no ident>";	/* argv[1] */
public	char	*vg_dbug = (char *) 0;		/* argv[3] */

public	char	*incl = INCLUDE;		/* Optionial include path */
public	char	*(datafiles[11]);		/* current DATAFILE name */
public	char	*(cc_ofiles[11]);		/* cc object file ( -c ) */
public	char	objectfile[LOCAL_PATH_LEN];	/* current OBJECTFILE name */
public	char	resultsfile[LOCAL_PATH_LEN];	/* current RESULTSFILE name */
public	char	data_dir[LOCAL_PATH_LEN];	/* data directory (d.xxx) */
