
/*
*      SCCS:   @(#)SRC/common/drivers/ident.c	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

/***********************************************************************

NAME:		ident - testset ident functions

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	set_ident()
	get_ident()

SYNOPSIS:
	void
	set_ident( ident )
		char	*ident;

	char *
	get_ident()

DESCRIPTION:
	these routines maintain a copy of the testset ident (from argv[1]),
	and the current test ident.
	set_ident( ident ) simply copies ident to an internal variable
	and get_ident() returns a pointer to that internal variable; a
	null string ("") is returned by default

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Paul Hackney
DATE CREATED:	Wed Jul 30 13:39:20 BST 1986

MODIFICATIONS:
		Geoff Clare, 27 Apr 1990
			Remove redundant set_tid() and get_tid().

************************************************************************/

#include	<std.h>
#include	<stdlib.h>
#include	<string.h>
#include	<hdr.h>
#include	<sysdep.h>

#define	TSET_PFX	"T."	/* testset name prefix		*/

extern	void	htabandon();

extern	char	*vg_ident;

public void
set_ident( ident )
	char *ident;
{
	char *offset;
	if ( is_string( ident ) )
	{
		vg_ident = (char *)malloc((size_t) (strlen(ident) + 1));
		if (vg_ident == (char *) NULL)
		{
			vsxerror("malloc() returned NULL (out of memory)");
			htabandon();
		}
		if((offset = strstr(ident,TSET_PFX))==NULL)
		{
			(void) strcpy( vg_ident, ident );
		}
		else
		{
			(void) strcpy( vg_ident, &offset[2]);
		}
	}
}

public char *
get_ident()
	/*NOPARAMETERS*/
{
	return vg_ident;
}

