/*
*      SCCS:   @(#)SRC/common/drivers/subr.c	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

/***********************************************************************

NAME:		subr.c - miscelleaneous subroutines

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	no_output()
	charof()

SYNOPSIS:

	int
	no_output()

	char
	charof(int)

DESCRIPTION:
	no_output() returns TRUE or FALSE depending on whether resultsfile
	is empty or not, respectively
METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Paul Hackney
DATE CREATED:	Wed Jul 30 13:39:20 BST 1986

MODIFICATIONS:
		Stuart Boutell, 5 Nov 1990
			timestamp() removed

		Geoff Clare, 23 June 1994
			Added #include <stdio.h> (for sprintf decl)

************************************************************************/

#include	<std.h>
#include	<stdio.h>
#include	<time.h>
#include	<hdr.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<sysdep.h>

extern	void	htabandon();

public	int
no_output()
	/*NOPARAMETERS*/
{
	/*
	 * check whether resultsfile has any data in it
	 */
	private	struct	stat	st;

	if ( stat( resultsfile, &st ) == SYSERROR )
	{
		sys_error( "no_output", resultsfile, "stat" );
		htabandon();
	}

	return st.st_size == 0 ? TRUE : FALSE;
}

public char	
charof(i)
int	i;
{
	char	buffer[2];
	(void)	sprintf(buffer,"%1d",i);
	return(buffer[0]);
}
