/*
*      SCCS:   @(#)common/genlib/alrm.c	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

/***********************************************************************

NAME:		alrm.c - signal catcher for timeouts (see timeout.h)

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	alrm()
SYNOPSIS:
	void alrm()

	int alrm_flag;

DESCRIPTION:
	alrm() increments alrm_flag when ever it is called.  Used by
	SET_TIMEOUT (see timeout.h) to catch SIGALRM.  Alrm_flag should
	be examined after CLEAR_ALARM to see if the alarm went off.
METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Mike Rendell, UniSoft Ltd.
DATE CREATED:	Fri Aug 15 09:49:21 PDT 1986
MODIFICATIONS:
		Geoff Clare, 14 Mar 1989
			SET_TIMEOUT uses sigaction() instead of signal()
			so SIGALRM no longer needs resetting.

************************************************************************/
#include	<std.h>
#include	<dbug.h>
#include	<sysdep.h>

public	int	alrm_flag = 0;

public void
alrm(sig)
	int	sig;
{
	DBUG_LENTER("alrm", 2);
	DBUG_PRINTF("args", "alrm(%d)", sig);

	++alrm_flag;

	DBUG_VOID_RETURN;
}
