/*
*      SCCS:   @(#)common/genlib/atouid.c	4.2 (04/15/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/


/***********************************************************************

NAME:		atouid.c - ascii to uid_t routine.

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	atouid()
SYNOPSIS:
	uid_t atouid(string)
		char *string;
DESCRIPTION:
	atouid() converts the string argument to a uid_t value.

SOURCE:		
AUTHOR:		Geoff Clare, UniSoft Ltd.
DATE CREATED:	8 Jan 1993
MODIFICATIONS:
		Geoff Clare, 15 April 1997
		Fixed unsigned arithmetic problem.

************************************************************************/

#include	<std.h>
#include	<sys/types.h>
#include	<stdio.h>
#include	<ctype.h>
#include	<dbug.h>
#include	<sysdep.h>

public uid_t
atouid(nbuf)
char *nbuf;
{
	unsigned char *p;
	uid_t num = 0;
	int sign = 1;

	DBUG_LENTER("atouid", 2);
	DBUG_PRINTF("args", "atouid(%s)", nbuf);

	p = (unsigned char *)nbuf;

	while (*p != '\0' && isspace((int)*p))
		p++;

	if (*p == '+')
		p++;
	else if (*p == '-')
	{
		sign = -1;
		p++;
	}

	while (*p >= '0' && *p <= '9')
	{
		num = num*10 + sign*(int)(*p - '0');
		p++;
	}

	if (num < 0)
		DBUG_PRINTF("return", "atouid = %ld", (long)num);
	else
		DBUG_PRINTF("return", "atouid = %lu", (unsigned long)num);
	DBUG_RETURN(num);
}
