/*
*      SCCS:   @(#)common/genlib/closesync.c	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/


/***********************************************************************

NAME:		closesync.c - close a synchronisation channel

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	closesync()
SYNOPSIS:
	int closesync(synchdesc)
		synch	*synchdesc;

DESCRIPTION:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
	Errno will be set to the appropriate error if closesync() fails.
RELATED DOCUMENTS:
SOURCE:
AUTHOR:		David McCardle, UniSoft Ltd.
DATE CREATED:	Tue Jul 15 12:54:52 BST 1986
MODIFICATIONS:

************************************************************************/

#include	<std.h>
#include	<stdlib.h>
#include	<stdio.h>	
#include	<dbug.h>
#include	<synch.h>
#include	<errno.h>
#include	<sysdep.h>

int
closesync(synchdesc)
	synch	*synchdesc;	/* synchronisation channel to be closed	*/
{
	int	r1, r2;

	DBUG_LENTER("closesync", 2);
	DBUG_PRINTF("args", "closesync([%d, %d])",
		(*synchdesc)[0], (*synchdesc)[1]);

	errno = NOERROR;

	if (synchdesc == (synch *) NULL)
	{
		DBUG_PRINTF("return", "closesync = %d", SYSERROR);
		DBUG_RETURN(SYSERROR);
	}
	
	r1 = close(synchdesc[0][0]);
	r2 = close(synchdesc[0][1]);
	
	free((void *) synchdesc);
	if (r1 || r2)
	{
		DBUG_PRINTF("return", "closesync = %d", SYSERROR);
		DBUG_RETURN(SYSERROR);
	}
	else
	{
		DBUG_PRINTF("return", "closesync = %d", SUCCEED);
		DBUG_RETURN(SUCCEED);
	}
}
