/*
*      SCCS:   @(#)common/genlib(cppair.c)	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/


/***********************************************************************

NAME:		cppair.c - create a child-parent pair

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	cppair()
SYNOPSIS:
	int cppair(childproc, parentproc, waittime, exitvals))
		void	(*childproc)();
		void	(*parentproc)();
		int	waittime;
		int	exitvals;

DESCRIPTION:
	Fork a child process and execute (*childproc)() in the
	child and (*parentproc)() (if not NULL) in the parent.
	Wait for the child, with a time-out of waittime.
	Exitvals is a bit mask of the allowed exit values besides OK.

	This routine is now obsolete and is simply an interface to
	tet_fork().  New code should use tet_fork() directly.

CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:
AUTHOR:		Geoff Clare, UniSoft Ltd.
DATE CREATED:	1 Nov 1990
MODIFICATIONS:
			

************************************************************************/

#include	<std.h>
#include	<dbug.h>
#include	<tet_api.h>
#include	<sysdep.h>

int
cppair(childproc, parentproc, waittime, exitvals)
void (*childproc) ();
void (*parentproc) ();
int	waittime;
int	exitvals;
{
	int ret;

	DBUG_LENTER("cppair", 2);
	DBUG_PRINTF("args", "cppair(0x%lx, 0x%lx, %d, %d)",
		(long) childproc, (long) parentproc, waittime, exitvals);

	ret = tet_fork(childproc, parentproc, waittime, exitvals|OK);

	/* tet_fork() exits with code 0 if child function returns,
	   so for compatibility with old cppair() change it to OK */
	if (ret == 0)
		ret = OK;

	DBUG_PRINTF("return", "cppair = %d", ret);
	DBUG_RETURN(ret);
}
