/*
*      SCCS:   @(#)common/genlib(fpcomp.c)	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/


/***********************************************************************

NAME:		fpcomp.c - floating point comparison routines, etc.

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
		mlmachar(), fcomp(), dcomp(), ldcomp().
SYNOPSIS:
		void mlmachar()
		int fcomp(float val1, float val2);
		int dcomp(double val1, double val2);
		int ldcomp(long double val1, long double val2);

DESCRIPTION:
		Mlmachar() calculates the following external constants
		which are used in the mathematical library tests:-
		    double epspos - smallest positive number which changes 1.0
		    double epsneg - smallest negative number which changes 1.0
		    double maxdble - largest double precision number
		    double mindble - smallest double precision number
		    int expbase - exponent base (normally 2)
		    int dexplen - exponent length in a double
		    int dsignif - number of significant digits in a double
		    int fsignif - number of significant digits in a float
		    int dmaxexp - largest exponent for a double
		    int dminexp - smallest exponent for a double

		fcomp(), dcomp() and ldcomp() compare two values of type
		float, double and long double respectively.  They return 1
		if the values are approximately equal, otherwise 0.

SIDE EFFECTS:
RELATED DOCUMENTS:
AUTHOR:		Geoff Clare, UniSoft Ltd.
DATE CREATED:	1 Feb 1991
MODIFICATIONS:
		Geoff Clare, 13 Mar 1991
			Add #define SET_NOSIGRESET

************************************************************************/
#include	<std.h>
#include	<dbug.h>
#include	<tet_api.h>
#include	<sysdep.h>

#define SET_HWFACTOR
#define SET_NOSIGRESET
#include	<FPCOMP.h>	/* all the code is in here! */
