/*
*      SCCS:   @(#)common/genlib/hexstr.c	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/


/***********************************************************************

NAME:		hexstr.c - change a string to hex printable format.

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	hexstr()
SYNOPSIS:
	char *hexstr(str)
		char	*str;
DESCRIPTION:
	hexstr changes each character of a string into the
	printable hex equivalent.

SOURCE:		
AUTHOR:		Mike Rendell, UniSoft Ltd.
DATE CREATED:	Thu Aug 28 19:30:00 BST 1986
MODIFICATIONS:

************************************************************************/
#include	<std.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<sys/types.h>
#include	<dbug.h>
#include	<sysdep.h>

private char hextab[17] = "0123456789abcdef";

public char *
hexstr(s)
unsigned char	*s;
{
	char	*ns, *hs;
	unsigned index;

	DBUG_LENTER("hexstr", 2);

	ns = (char *)malloc((size_t) ((2*strlen((char *)s)) + 1));
	if (ns == NULL)
		DBUG_RETURN((char *) s);
	hs = ns;
	while (*s)
	{
		index = (unsigned) *s++;
		*hs++ = hextab[index/16];
		*hs++ = hextab[index%16];
	}
	*hs = '\0';
	DBUG_RETURN(ns);
}
