/*
*      SCCS:   @(#)common/genlib/opensync.c	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/


/***********************************************************************

NAME:		opensync.c - open a synchronisation channel

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	opensync()
SYNOPSIS:
	synch *opensync()

DESCRIPTION:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
	Errno will be set to the appropriate error if opensync() fails.
RELATED DOCUMENTS:
SOURCE:
AUTHOR:		David McCardle, UniSoft Ltd.
DATE CREATED:	Tue Jul 15 12:54:52 BST 1986
MODIFICATIONS:

************************************************************************/

#include	<std.h>
#include	<stdlib.h>
#include	<stdio.h>	
#include	<sys/types.h>	
#include	<dbug.h>
#include	<synch.h>
#include	<errno.h>
#include	<sysdep.h>

synch *
opensync()
{
	int *fildes;		/* file descriptors returned by pipe()	*/

	DBUG_LENTER("opensync", 2);

	if (( fildes = (int *) malloc((size_t)sizeof(synch)) ) == (int *) NULL)
	{
		DBUG_PRINTF("return", "opensync = NULL");
		DBUG_RETURN((synch *)fildes);
	}

	errno = NOERROR;

	if (pipe(fildes) == SYSERROR)
	{
		free((void *) fildes);
		fildes = (int *) NULL;
	}

	DBUG_PRINTF("return", "opensync = [%d, %d]", *fildes, *(fildes + 1));
	DBUG_RETURN((synch *)fildes);
}
