/*
*      SCCS:   @(#)common/genlib/parsync.c	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/


/***********************************************************************

NAME:		parsync.c - close child end of synchronisation channel

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	parsync()
SYNOPSIS:
	int parsync(synchdesc, side)
		synch	*synchdesc;
		char	side;

DESCRIPTION:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
	Errno will be set to the appropriate error if parsync() fails.
RELATED DOCUMENTS:
SOURCE:
AUTHOR:		David McCardle, UniSoft Ltd.
DATE CREATED:	Tue Jul 15 12:54:52 BST 1986
MODIFICATIONS:

************************************************************************/

#include	<std.h>
#include	<stdio.h>	
#include	<dbug.h>
#include	<synch.h>
#include	<errno.h>
#include	<sysdep.h>



int
parsync(synchdesc, side)

	synch	*synchdesc;	/* synchronisation channel to be closed	*/
	char	side;		/* side of channel to be closed		*/
{
	int num;		/* value returned by close()		*/

	DBUG_LENTER("parsync", 2);
	DBUG_PRINTF("args", "parsync([%d, %d], %c)", *synchdesc, *(synchdesc + 1), side);

	errno = NOERROR;

	switch((int) side)
	{
		case 'r':
 			num = close(synchdesc[0][0]);
			break;
		case 'w':
 			num = close(synchdesc[0][1]);
			break;
		default:
			num = SYSERROR;
			errno = EINVAL;
			break;
	}
	DBUG_PRINTF("return", "parsync = %d", num);
	DBUG_RETURN(num);
}
