/*
*      SCCS:   @(#)common/genlib/sendsync.c	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/


/***********************************************************************

NAME:		sendsync.c - send data to synchronisation channel

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	sendsync()
SYNOPSIS:
	int sendsync(fdesc, buf, size, timeout)
		int		fdesc;
		char		*buf;
		unsigned	size;
		unsigned	timeout;

DESCRIPTION:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
	Errno will be set to the appropriate error and timedout will be set
	to 1 if sendsync() fails.
RELATED DOCUMENTS:
SOURCE:
AUTHOR:		David McCardle, UniSoft Ltd.
DATE CREATED:	Tue Jul 15 12:54:52 BST 1986
MODIFICATIONS:

************************************************************************/

#include	<std.h>
#include	<stdio.h>	
#include	<dbug.h>
#include	<synch.h>
#include	<errno.h>
#include	<signal.h>
#include	<timeout.h>
#include	<tet_api.h>
#include	<sysdep.h>


int
sendsync(fdesc, buf, size, timeout)

	int		fdesc;		/* file descriptor		*/
	char		*buf;		/* buffer of data to be sent	*/
	unsigned	size;		/* number of bytes to be sent	*/
	unsigned	timeout;	/* number of seconds to timeout	*/
{
	int rtval;

	DBUG_LENTER("sendsync", 2);
	DBUG_PRINTF("args", "sendsync(%d, 0x%lx, %u, %u)", fdesc,
		(long)buf, size, timeout);

	errno = NOERROR;

	SET_TIMEOUT(timeout)
	rtval = write(fdesc, buf, size);
	CLEAR_ALARM

	DBUG_PRINTF("return", "sendsync = %d", rtval);
	DBUG_RETURN(rtval);
}
