/*
*      SCCS:   @(#)common/genlib/waitsync.c	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/


/***********************************************************************

NAME:		waitsync.c - receive data from synchronisation channel

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	waitsync()
SYNOPSIS:
	int waitsync(fdesc, buf, size, timeout)
		int		fdesc;
		char		*buf;
		unsigned	size;
		unsigned	timeout;

DESCRIPTION:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
	alrm_flag will be > 0 if waitsync() times out.
RELATED DOCUMENTS:
SOURCE:
AUTHOR:		David McCardle, UniSoft Ltd.
DATE CREATED:	Tue Jul 15 12:54:52 BST 1986
MODIFICATIONS:
		Geoff Clare, 28 Nov 1990
			Add tet_setblock() call.

************************************************************************/
#include	<std.h>
#include	<errno.h>
#include	<stdio.h>	
#include	<dbug.h>
#include	<synch.h>
#include	<signal.h>
#include	<timeout.h>
#include	<tet_api.h>
#include	<sysdep.h>

int
waitsync(fdesc, buf, size, timeout)

	int		fdesc;		/* file descriptor		  */
	char		*buf;		/* buffer for data received	  */
	unsigned	size;		/* number of bytes to be received */
	unsigned	timeout;	/* number of seconds to timeout	  */
{
	int rtval;

	DBUG_LENTER("waitsync", 2);
	DBUG_PRINTF("args", "waitsync(%d, 0x%lx, %u, %u)", fdesc,
		(long)buf, size, timeout);

	tet_setblock();

	errno = NOERROR;
	SET_TIMEOUT(timeout)
	rtval = read(fdesc, buf, size);
	CLEAR_ALARM

	DBUG_PRINTF("return", "waitsync = %d", rtval);
	DBUG_RETURN(rtval);
}
