/*

##########################################################################
# (C) Copyright 1998-2001 The Open Group
#
# All rights reserved.  No part of this source code may be reproduced,
# stored in a retrieval system, or transmitted, in any form or by any
# means, electronic, mechanical, photocopying, recording or otherwise,
# except as stated in the end-user licence agreement, without the prior
# permission of the copyright owners.
#
# X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
# the UK and other countries.
#
#	PROJECT:	LSB-FHS
#	PRODUCT:	LSB.fhs/SRC/common/lsbutils/lsb_issymlink.c
#	AUTHOR:		Andrew Josey, The Open Group
#	DATE CREATED:	21 Dec 1998
##########################################################################

# This is $Revision: 1.2 $
#
# $Log: lsb_issymlink.c,v $
# Revision 1.2  2001/07/18 07:03:01  ajosey
# add header, and cvs revision stuff
#

*/
/* lsb_issymlink:
 *	Arguments: argv[1] filename
 *	Returns: 0 - True, filename is a symlink
 *		 1 - False , filename is not a symlink
 *		 2 - Unresolved, too many arguments
 */

#include <stdio.h>
#include <string.h>
#include <unistd.h>
#include <sys/stat.h>
#include <errno.h>
#include "lsb-fhs-ts.h"

main (argc, argv)
int argc;
char *argv[];
{
struct stat buf;
int retval;

if ( argc < 2 ) {
	fprintf(stderr, "%s: usage: %s filename\n", argv[0], argv[0]);
	exit(LSB_FHS_TS_UNRESOLVED);
}

errno = 0;
retval = lstat ( argv[1], &buf );
if ( retval == -1 ) {

	fprintf(stderr, "%s: lstat (%s) returned -1, errno= %d, (%s)\n",
		argv[0], argv[1], errno, strerror(errno));

	exit (LSB_FHS_TS_UNRESOLVED);
}

if (S_ISLNK(buf.st_mode))
	exit (LSB_FHS_TS_PASS);
else
	exit (LSB_FHS_TS_FAIL);

}
