/*

##########################################################################
# (C) Copyright 1998-2001 The Open Group
#
# All rights reserved.  No part of this source code may be reproduced,
# stored in a retrieval system, or transmitted, in any form or by any
# means, electronic, mechanical, photocopying, recording or otherwise,
# except as stated in the end-user licence agreement, without the prior
# permission of the copyright owners.
#
# X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
# the UK and other countries.
#
#	PROJECT:	LSB-FHS
#	PRODUCT:	LSB.fhs/SRC/common/lsbutils/lsb_realpath.c
#	AUTHOR:		Andrew Josey, The Open Group
#	DATE CREATED:	21 Dec 1998
##########################################################################

# This is $Revision: 1.3 $
#
# $Log: lsb_realpath.c,v $
# Revision 1.3  2001/09/06 10:06:52  ajosey
# workaround for compilation using c89
#
# Revision 1.2  2001/07/18 07:03:01  ajosey
# add header, and cvs revision stuff
#

*/

/* lsb_realpath: return canonicalized full pathname */

/* lsb_realpath:
 *	Arguments: argv[1] filename
 *	Returns: 0 - success, canonicalised filename is output on stdout
 *		 2 - Unresolved, an error message is output on stderr
 */

/* Ensure that _XOPEN_SOURCE is defined to
   make PATH_MAX and the realpath() function visible 
   in the header file namespace. Otherwise this module 
   can fail to compile when used with c89 */

#ifndef _XOPEN_SOURCE

#define _XOPEN_SOURCE 500

#endif

#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <limits.h>
#include <errno.h>
#include "lsb-fhs-ts.h"

main (argc, argv)
int argc;
char *argv[];
{
char namebuf[PATH_MAX];
char *canon_name;

if ( argc < 2 ) {
	fprintf(stderr, "%s: usage: %s pathname\n", argv[0], argv[0]);
	exit(LSB_FHS_TS_UNRESOLVED);
}

canon_name = realpath ( argv[1], namebuf );
if ( canon_name == NULL ) {
	fprintf(stderr, "%s returned -1, set errno to %d (%s)", errno,
		strerror(errno));
	exit(LSB_FHS_TS_UNRESOLVED);
}

fprintf(stdout, "%s\n", namebuf);
exit(LSB_FHS_TS_PASS);

}
