/*
*      SCCS:   @(#)common/tsetlib(cpsig.c)	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/


/***********************************************************************

NAME:		cpsig.c - create a child-parent pair for signal tests

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	cpsig()
SYNOPSIS:
	int cpsig(childproc, parentproc, waittime, exitvals))
		void	(*childproc)();
		void	(*parentproc)();
		int	waittime;
		int	exitvals;

DESCRIPTION:
	Fork a child process and execute (*childproc)() in the
	child and (*parentproc)() in the parent.
	Parentproc should wait for the child as necessary - cpsig()
	will kill it if it still exists after parentproc returns.
	Waittime and exitvals are not used.

	This routine is now obsolete and is simply an interface to
	tet_fork().  New code should use tet_fork() directly.

CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:
AUTHOR:		Geoff Clare, UniSoft Ltd.
DATE CREATED:	1 Nov 1990
MODIFICATIONS:
			

************************************************************************/

#include	<std.h>
#include	<dbug.h>
#include	<tet_api.h>
#include	<sysdep.h>

int
cpsig(childproc, parentproc, waittime, exitvals)
void (*childproc) ();
void (*parentproc) ();
int	waittime;
int	exitvals;
{
	int ret;

	DBUG_LENTER("cpsig", 2);
	DBUG_PRINTF("args", "cpsig(0x%lx, 0x%lx, %d, %d)",
		(long) childproc, (long) parentproc, waittime, exitvals);

	/* this relies on an undocumented extension to tet_fork(),
	   that a waittime of -1 means don't wait */
	ret = tet_fork(childproc, parentproc, -1, 0);

	DBUG_PRINTF("return", "cpsig = %d", ret);
	DBUG_RETURN(ret);
}
