/*
*      SCCS:  @(#)common/tsetlib(delay.c)	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

/***********************************************************************

NAME:		delay - cause a delay by doing many stat()s, used
			instaed of sleep in some places.

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	delay()
SYNOPSIS:
	void delay(count)
		int count;
DESCRIPTION:
	delay() is used instaed of sleep in some places (eg: when testing
	pause()), delat() causes a delay by stat()ing "/" count times.
METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Mike Rendell, UniSoft Ltd.
DATE CREATED:	Fri Aug 15 10:23:39 PDT 1986
MODIFICATIONS:
		Unknown, Unknown
			Changed to busy-wait calling time()

************************************************************************/
#include	<std.h>
#include	<stdio.h>
#include	<sys/types.h>
#include	<dbug.h>
#include	<time.h>
#include <tet_api.h>
#include	<sysdep.h>

public void
delay(sec)
	int	sec;
{
	time_t	tim;

	DBUG_LENTER("delay", 2);
	DBUG_PRINTF("args", "delay(%d)", sec);

	tim = time((time_t *) 0) + sec;
	while (time((time_t *) 0) < tim)
		;
	DBUG_VOID_RETURN;
}
