/*
*      SCCS:  @(#)common/tsetlib(devinodrpt.c)	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/



/***********************************************************************

NAME:

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	devinod_rpt()
SYNOPSIS:
	void devinod_rpt(inode1, dev1, inode2, dev2)
		ino_t	inode1;
		dev_t	dev1;
		ino_t	inode2;
		dev_t	dev2;


DESCRIPTION:
	prints out the values of inode1/dev1 and inode2/dev2 using in_rpt.
	inode1/dev1 is the expected values, inode2/dev2 is the recieved 
	actual value.
METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Mike Rendell, UniSoft Ltd.
DATE CREATED:	Tue Aug 12 16:08:08 PDT 1986
MODIFICATIONS:
		Geoff Clare, 5 June 1992
			Change to use %g and (double) in case dev_t or
			ino_t is double.

************************************************************************/
#include <std.h>
#include <sys/types.h>
#include <dbug.h>
#include <tet_api.h>
#include <sysdep.h>

public void
devinod_rpt(inode1, dev1, inode2, dev2)

	ino_t	inode1;
	dev_t	dev1;
	ino_t	inode2;
	dev_t	dev2;
{
	in_rpt("inode expected %g, device expected %g",
		(double)inode1, (double)dev1);
	in_rpt("actual inode %g, actual device %g",
		(double)inode2, (double)dev2);
}
