/*
*      SCCS:  @(#)common/tsetlib (pipelib.h)	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1995 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

/*********************************************************************

NAME:		pipelib.h

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:	a header file for use with the new versions of
		pipeclib.c and pipeplib.c

AUTHOR:		Andrew Dingwall, UniSoft Ltd.
DATE CREATED:   September 1995
MODIFICATIONS:	

**********************************************************************/

/* structure of a pipelib message header */
struct pipemhdr {
	int ph_mtype;			/* message type - see below */
	int ph_dlen;			/* no of bytes in pm_data */
};

/* definition of pipelib message data */
union pipemdata {
	int pd_rescode;			/* a result code */
	char pd_text[512];		/* a text message */
};

/* pipelib message types */
#define PM_XS_RPT	1	/* call to xs_rpt() (no data) */
#define PM_XX_RPT	2	/* call to xx_rpt() (data is pd_rescode) */
#define PM_IN_RPT	3	/* call to in_rpt() (data is pd_text) */
#define PM_END_RPT	4	/* end reporting (no data) */

/* structure of a protypical pipelib message */
struct pipemsg {
	long pm_magic;			/* magic number */
	struct pipemhdr pm_hdr;		/* message header */
	union pipemdata pm_data;	/* message data */
};

#define PM_MAGIC	0x704d5367	/* identifies a pipemsg message */

/* short names for struct pipemsg elements */
#define pm_mtype	pm_hdr.ph_mtype
#define pm_dlen		pm_hdr.ph_dlen
#define pm_rescode	pm_data.pd_rescode
#define pm_text		pm_data.pd_text

/* total length of an actual pipemsg message */
#define pipemsgsz(x)	(&(x)->pm_text[(x)->pm_dlen] - (char *) (x))

/* minimum macro */
#define MIN(a, b)	((a) < (b) ? (a) : (b))

