/*
*      SCCS:  @(#)common/tsetlib(testid.c)	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/


/***********************************************************************

NAME:		testid.c - give full testid from testname

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
		char *testid(testname)
			char *testname;
DESCRIPTION:
	Testid() returns a pointer to a static area containing
	the full test id for the given test name; eg
		testid("1a")
	returns a pointer to "os.knl/file/access.1a" if the global
	variable vg_ident contains "os.knl/file/access".

	NOTE: assumes existance of vg_ident.

AUTHOR:		Hamish Reid, UniSoft Ltd.
DATE CREATED:	Wed Jun 25 13:57:03 BST 1986
MODIFICATIONS:

************************************************************************/

#include	<std.h>
#include	<string.h>
#include	<stdio.h>
#include	<dbug.h>
#include <tet_api.h>
#include	<sysdep.h>

#define	BSIZE	256		/* size of buf, below */


extern	char	*vg_ident;

char *
testid(testname)
	char	*testname;
{
	/* return pointer to static string containing full testset/test
	number, in format tset_ident " " testname, eg os.knl/file/access 1a
	*/

	static	char	buf[BSIZE] = { NUL };

	
	DBUG_LENTER("testid", 2);
	DBUG_PRINTF("args", "testid(%s)", testname);

	(void) strcpy(buf, vg_ident);
	(void) strcat(buf, " ");
	(void) strcat(buf, testname);

	DBUG_PRINTF("return", "testid = %s", buf);
	DBUG_RETURN (buf);
}
