/*
*      SCCS:  @(#)common/tsetlib(timetoa.c)	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/


/***********************************************************************

NAME:		timetoa.c - time_t to "ascii" routine.

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	timetoa()
SYNOPSIS:
	char *timetoa(tm)
		time_t tm;
DESCRIPTION:
	timetoa() returns a pointer to a static character array which
	holds a printable representation of tm.

SOURCE:		
AUTHOR:		Mike Rendell, UniSoft Ltd.
DATE CREATED:	Mon Aug 18 13:50:14 PDT 1986
MODIFICATIONS:
		Geoff Clare, 21 Nov 1996
		Rewritten so as not to assume time_t is an integral type.

************************************************************************/

#include	<std.h>
#include	<sys/types.h>
#include	<stdio.h>
#include	<limits.h>
#include	<dbug.h>
#include	<sysdep.h>

public char *
timetoa(tm)
time_t tm;
{
	static char nbuf[2 + (sizeof(tm)*CHAR_BIT*10 + 32)/33];

	DBUG_LENTER("timetoa", 2);

	if (tm <= LONG_MAX && tm >= LONG_MIN)
		(void) sprintf(nbuf, "%ld", (long)tm);
	else
	{
#if LONG_DOUBLE_SUPPORTED
		(void) sprintf(nbuf, "%.0Lg", (long double)tm);
#else
		(void) sprintf(nbuf, "%.0g", (double)tm);
#endif
	}

	DBUG_PRINTF("return", "timetoa = %s", nbuf);
	DBUG_RETURN(nbuf);
}
