/*
*      SCCS:   @(#)common/tsetlib(utoa.c)	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/


/***********************************************************************

NAME:		utoa.c - unsigned integer to "ascii" routine.

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	utoa()
SYNOPSIS:
	char *utoa(number)
		unsigned int number;
DESCRIPTION:
	utoa() returns a pointer to a static character array which
	holds a printable representation of the number.

SOURCE:		
AUTHOR:		Mike Rendell, UniSoft Ltd.
DATE CREATED:	Mon Aug 18 13:50:14 PDT 1986
MODIFICATIONS:
		Geoff Clare, 21 Nov 1996
		Calculate required buffer size.

************************************************************************/

#include	<std.h>
#include	<stdio.h>
#include	<limits.h>	
#include	<dbug.h>
#include	<sysdep.h>

public char *
utoa(number)
unsigned int number;
{
	static char nbuf[2 + (sizeof(number)*CHAR_BIT*10 + 32)/33];
	char *p;

	DBUG_LENTER("utoa", 2);
	DBUG_PRINTF("args", "utoa(%u)", number);

	p = &nbuf[sizeof(nbuf) - 1];
	*p-- = NUL;
	if (number ==  0)
		*p-- = '0';
	else
		while (number != 0)
		{
			*p-- = "0123456789abcdef"[number % 10];
			number /= 10;
		}

	++p;

	DBUG_PRINTF("return", "utoa = %s", p);
	DBUG_RETURN(p);
}
