/*
*      SCCS:   @(#)tset/vlib(newstr.c)	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/


/***********************************************************************

NAME:		newstr.c - copy a string into new memory.

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	newstr()
SYNOPSIS:
	char *newstr(str)
		char	*str;
DESCRIPTION:
	newstr() malloc()'s engough memory to hold "str", copies
	"str" to the new string and returns the new string.  If
	malloc fails NULL is returned.

SOURCE:		
AUTHOR:		Mike Rendell, UniSoft Ltd.
DATE CREATED:	Thu Aug 28 19:30:00 BST 1986
MODIFICATIONS:

************************************************************************/

#include	<std.h>
#include	<stdlib.h>
#include	<stdio.h>	
#include	<sys/types.h>	
#include	<dbug.h>
#include	<string.h>
#include	<sysdep.h>


public char *
newstr(s)
char	*s;
{
	char	*ns;

	DBUG_LENTER("newstr", 2);
	DBUG_PRINTF("args", "newstr(0x%lx)", (long)s);

	if ((ns = (char *)malloc((size_t) (strlen(s) + 1))) != NULL)
		(void) strcpy(ns, s);

	DBUG_PRINTF("return", "newstr = 0x%lx", (long)ns);
	DBUG_RETURN(ns);
}
