/*
*      SCCS:   @(#)common/vlib(panic.c)	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

/***********************************************************************

NAME:		panic.c - print panic string and abort with core dump

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
		panic.c

SYNOPSIS:
	void	
	panic(str)
		char	*str;
DESCRIPTION:
	panic() will print
	panic: XXXXX: YYYYY
	on stderr, where XXXXX is the program name as given by
	vsx_pname, and YYYYY is the string as specified by str.
	A core dump is then produced, and the program
	terminated immediately.
	format should not be terminated by a newline.
NOTE:
	program name XXXXX is sensible only if it has been set by
	set_pname() prior to the call to get_pname();
ASSUMES:
	stderr open and writable.

AUTHOR:	Hamish REID, UniSoft Ltd.
DATE CREATED: Thu Apr  3 12:31:59 GMT 1986
MODIFICATIONS:
	changed to use stdio -	7/apr/86	H Reid

************************************************************************/

#include	<std.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include 	<dbug.h>
#include	<sysdep.h>

#define	PSTR1	"\n\007\007panic: "	/* panic string */
#define	PSTR2	" : "
#define	PSTR3	"\007\n"

extern	char	*get_pname();

void
panic(pstr)
	char	*pstr;
{
	DBUG_LENTER("panic", 2);
	DBUG_PRINTF("args", "panic(%s)", pstr);
	(void) fprintf(stderr, "%s%s%s%s%s",
		PSTR1,
		get_pname(),
		PSTR2,
		pstr,
		PSTR3 );
	(void) fflush(stderr);
	abort();
	/* for lint */
	DBUG_VOID_RETURN;
}
