/*
*      SCCS:   @(#)common/vlib(pname.c)	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/
/***********************************************************************

NAME:		pname.c - program name functions

PROJECT:	VSX (X/OPEN Validation Suite)
MODULE CONTAINS:
		set_pname();
		get_pname();
SYNOPSIS:
		void
		set_pname(name);
			char	*name;

		char *
		get_pname();
DESCRIPTION:
		These routines simply maintain the program or process
		name for vtest(1) or any testset - set_pname() is usually
		called with argv[0] as its argument, and puts this into
		the internal variable vsx_pname; get_pname simply
		returns a NUL-terminated pointer to this name or NULL,
		if the name was not set.

AUTHOR:		Hamish Reid, UniSoft Ltd.
DATE CREATED:	Fri Apr  4 14:47:51 GMT 1986
MODIFICATIONS:

************************************************************************/

#include	<std.h>
#include	<string.h>
#include	<dbug.h>
#include	<sysdep.h>

#define	VSX_N_SIZE	128	/* make this big enough for full paths	*/

private	char	vsx_pname[VSX_N_SIZE] = { NUL };


public	void
set_pname(name)
	char	*name;
{
	DBUG_LENTER("set_pname",2);
	DBUG_PRINTF("args", "set_pname(%s)", name);
	(void) strncpy(vsx_pname, name, (size_t)(VSX_N_SIZE - 1));
	DBUG_VOID_RETURN;
}

public	char *
get_pname()
{
	DBUG_LENTER("get_pname", 2);
	if (vsx_pname[0] == NUL)
	{
		DBUG_PRINTF("return", "get_pname = NULL");
		DBUG_RETURN ((char *) NULL);
	}
	else
	{
		DBUG_PRINTF("return", "get_pname = %s", vsx_pname);
		DBUG_RETURN (vsx_pname);
	}
}
