/*
*      SCCS:   @(#)common/vlib/vgetenv.c	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
*/
/***********************************************************************

NAME:		vgetenv.c - xvs type version of getenv(3)

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
		vgetenv()
SYNOPSIS:
		vgetenv(envptr, name)
			char	**envptr;
			char	*name;
DESCRIPTION:
		emulates getenv(3) except takes argument (envptr) to
		specify where the envptr is, rather than use hardwired
		environ ptr as before.
AUTHOR:		Andrew Twigger
DATE CREATED:	Tue Apr 10 16:22:07 BST 1990
MODIFICATIONS:

************************************************************************/
/*
 *	vgetenv(envptr,name)
 *	returns ptr to value associated with name, if any, else NULL
 */

#include	<std.h>
#include	<sys/types.h>
#include	<string.h>
#include	<dbug.h>
#include	<sysdep.h>

char *
vgetenv(envptr, vblname)
	char **envptr;
	char *vblname;
{
	char **cur;
	char *envname;
	char *val;
	int n;

	DBUG_LENTER("vgetenv", 2);
	DBUG_PRINTF("args", "vgetenv(0x%1x, %s)", (long)envptr, vblname);

	if (envptr == (char **) NULL)
	{
		DBUG_PRINTF("return", "vgetenv = NULL");
		DBUG_RETURN((char *) NULL);
	}

	cur = envptr;

	while (*cur != (char *) NULL)
	{
		envname = *cur;
		n = strcspn(vblname, "=");
		if (strncmp(envname, vblname, (size_t) n) || envname[n] != '=')
			cur++;
		else
		{
			val = &envname[n+1];
			DBUG_PRINTF("return", "vgetenv = %s", val);
			DBUG_RETURN(val);
		}
	}

	DBUG_PRINTF("return", "vgetenv = NULL");
	DBUG_RETURN((char *) NULL);
}
