/*
*      SCCS:   @(#)common/vlib/vputenv.c	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
*/
/***********************************************************************

NAME:		vputenv.c - VSX version of putenv(3)

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
		vputenv()
SYNOPSIS:
		int
		vputenv(envptr, source)
			char	**envptr;
			char	*source;
DESCRIPTION:
		Basically a trivially-implemented version of putenv(3)
		which allows us to specify the environment pointer instead
		of hardwiring it into **environ.
ASSUMES:
		Assumes envptr != NULL
AUTHOR:		Andrew Twigger
DATE CREATED:	Tue Apr 10 16:22:07 BST 1990
MODIFICATIONS:

************************************************************************/
#include	<std.h>
#include	<stdlib.h>
#include	<sys/types.h>
#include	<string.h>
#include	<dbug.h>
#include	<sysdep.h>

#ifndef _XOPEN_SOURCE
#undef memcpy
extern void	*memcpy();
#endif

static int firsttime = 0;

int
vputenv(envptr, vblname)
	char ***envptr;
	char *vblname;
{
	char **newenv;
	char **cur;
	char *envname;
	int n, count = 0;

	DBUG_LENTER("vputenv", 2);
	DBUG_PRINTF("args", "vputenv(0x%1x, %s)", (long)envptr, vblname);

	if (*envptr == (char **) NULL)
	{
		newenv = (char **)malloc((size_t)(2*sizeof(char *)));
		if (newenv == (char **) (NULL)) 
		{
			DBUG_PRINTF("return", "vputenv = %d", -1);
			DBUG_RETURN(-1);
		}
		newenv[0] = vblname;
		newenv[1] = (char *) NULL;
		*envptr = newenv;
		DBUG_PRINTF("return", "vputenv = %d", 0);
		DBUG_RETURN(0);
	}

	cur = *envptr;

	while (*cur != (char *) NULL)
	{
		count++;
		envname = *cur;
		n = strcspn(vblname, "=");
		if (strncmp(envname, vblname, (size_t) n) || envname[n] != '=')
			cur++;
		else
		{
			*cur = vblname;
			DBUG_PRINTF("return", "vputenv = %d", 0);
			DBUG_RETURN(0);
		}
	}
	
	if (firsttime)
		newenv = (char **) realloc((void *) *envptr, 
				(size_t) ((count+2)*sizeof(char *)));
	else
	{
		newenv = (char **) malloc((size_t) ((count+2)*sizeof(char *)));
	}

	if (newenv == (char **) (NULL)) 
	{
		DBUG_PRINTF("return", "vputenv = %d", -1);
		DBUG_RETURN(-1);
	}
	
	if (!firsttime)
	{
		(void)memcpy((void *) newenv, (void *) (*envptr),
			(size_t)(count*sizeof(char *)));
		firsttime++;
	}
	newenv[count] = vblname;
	newenv[count+1] = (char *) NULL;
	*envptr = newenv;

	DBUG_PRINTF("return", "vputenv = %d", 0);
	DBUG_RETURN(0);
}
