/*
*      SCCS:   @(#)common/vport(vargtypes.c)	4.1 (01/21/97)  VSXgen release 1.4
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/
/***********************************************************************

NAME:		vargtypes.c - routines with varying argument types

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
		vread()
		vwrite()
		vgetcwd()
SYNOPSIS:
		int vread(fd, buf, nbyte)
			int fd;
			char *buf;
			unsigned int nbyte;

		int vwrite(fd, buf, nbyte)
			int fd;
			char *buf;
			unsigned int nbyte;

		char *vgetcwd(buf, size)
			char *buf;
			int size;

DESCRIPTION:
		These are interfaces to routines which require different
		argument types in different test modes.  They are accessed
		via a #define in <sysdep.h> of the "real" function they call.
		In this source file, and in the tests for these functions,
		the definitions are disabled by predefining NO_V<FUNC>.

AUTHOR:		Geoff Clare, UniSoft Ltd.
DATE CREATED:	25 Apr 1990
MODIFICATIONS:

************************************************************************/

#define NO_VREAD
#define NO_VWRITE
#define NO_VGETCWD

#include <std.h>
#include <sys/types.h>
#include <unistd.h>
#include <sysdep.h>

int
vread(fd, buf, nbyte)
int fd;
char *buf;
unsigned int nbyte;
{
#if !defined(_XOPEN_SOURCE) || TEST_XPG > 3
	return read(fd, (void *)buf, (size_t)nbyte);
#else
	return read(fd, buf, nbyte);
#endif
}

int
vwrite(fd, buf, nbyte)
int fd;
char *buf;
unsigned int nbyte;
{
#if !defined(_XOPEN_SOURCE) || TEST_XPG > 3
	return write(fd, (void *)buf, (size_t)nbyte);
#else
	return write(fd, buf, nbyte);
#endif
}

char *
vgetcwd(buf, size)
char *buf;
int size;
{
#if !defined(_XOPEN_SOURCE) || TEST_XPG > 3
	return getcwd(buf, (size_t)size);
#else
	return getcwd(buf, size);
#endif
}
