/*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif, OSF/1 and UNIX are registered trademarks and X/Open,
* the "X Device" and The Open Group are trademarks of The Open Group.
*
* Project: LSB-OS
*
* File: SRC/common/vsrtlib/sharedmem.c
*
* Modifications:
* $Log: sharedmem.c,v $
* Revision 1.2  2001/10/02 11:59:05  ajosey
* clean up the various header comment blocks for lsb-os
*
* Revision 1.1  2001/09/28 08:21:02  cyeoh
* Move of lsb-os specific libraries to lsb-os test set
*
* Revision 1.1  2001/06/01 02:00:15  cyeoh
* Merges for lsb-os test suite
*
*
*/

#include <vsrt/vsrt.h>

/*create a shared memory segment name by prepending the used-defined path*/
/*name supplied must be at most 14 characters*/
int vsrt_get_shm_name(char *, char *, size_t);

int vsrt_get_shm_name(char *buf, char *name, size_t size_max)
{
	char	*tshm;
	
	memset(buf, 0, size_max);
	tshm = tet_getvar("VSRT_SHM_PREFIX");
	if ((tshm == 0) || (strlen(tshm) == 0)) {
		xx_rpt(FAILURE);
		in_rpt("get_shm_name: Parameter VSRT_SHM_PREFIX is not set in tetexec.cfg");
		return -1;
	}

	if (strlen(tshm) + strlen(name) + 2 > size_max) {
		xx_rpt(FAILURE);
		in_rpt("get_shm_name: VSRT_SHM_PREFIX + name is too large\n");
		return -1;
	}

	strcpy(buf, tshm);

	if (buf[strlen(buf)-1] != '/')
		strcat(buf, "/");

	strcat(buf, name);

	return 0;
}
