
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_cpa.c	1.17
*
* CHANGE HISTORY
*	12 May 1999 - Incorporate SR#104, to require ifdefs around aio.h
*************************************************************************/


#include "std.h"

/* SR #104 */
#include <unistd.h>
#ifdef _POSIX_ASYNCHRONOUS_IO
#include <aio.h>
#endif
#include <assert.h>
#include <fcntl.h>
#include <math.h>

#include <stdio.h>
#include <stdlib.h>
#include <time.h>

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"


#if	( TEST_XPG > 4 )

/****** Testset for a64l()					 ******/

#ifdef	a64l
#undef	a64l
#endif

int
a64l_csf()
{
	return(0);
}

int
a64l_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	long	val;

	errs	= 0;
	fails	= 0;

	val = a64l("a64l");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
a64l_cef()
{
	return(0);
}

#endif


/****** Testset for abort()					 ******/

#ifdef	abort
#undef	abort
#endif

int
abort_csf()
{
	return(0);
}

int
abort_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not tested for obvious reasons */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
abort_cef()
{
	return(0);
}



/****** Testset for abs()					 ******/

#ifdef	abs
#undef	abs
#endif

int
abs_csf()
{
	return(0);
}

int
abs_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = abs(-1);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
abs_cef()
{
	return(0);
}



/****** Testset for access()					 ******/

#ifdef	access
#undef	access
#endif

int
access_csf()
{
	return(0);
}

int
access_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = access("./nonesuch", F_OK);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
access_cef()
{
	return(0);
}



/****** Testset for acos()					 ******/

#ifdef	acos
#undef	acos
#endif

int
acos_csf()
{
	return(0);
}

int
acos_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	double	val;

	errs	= 0;
	fails	= 0;

	val = acos(0.5);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
acos_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for acosh()					 ******/

#ifdef	acosh
#undef	acosh
#endif

int
acosh_csf()
{
	return(0);
}

int
acosh_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	double	val;

	errs	= 0;
	fails	= 0;

	val = acosh(0.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
acosh_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for advance()					 ******/

#ifdef	advance
#undef	advance
#endif

int
advance_csf()
{
	return(0);
}

int
advance_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* legacy */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
advance_cef()
{
	return(0);
}

#endif
#endif

#if	defined(_POSIX_ASYNCHRONOUS_IO)

/****** Testset for aio_cancel()				 ******/

#ifdef	aio_cancel
#undef	aio_cancel
#endif

int
aio_cancel_csf()
{
	return(0);
}

int
aio_cancel_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = aio_cancel(STDOUT_FILENO, NULL);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
aio_cancel_cef()
{
	return(0);
}

#endif

#if	defined(_POSIX_ASYNCHRONOUS_IO)

/****** Testset for aio_error()					 ******/

#ifdef	aio_error
#undef	aio_error
#endif

int
aio_error_csf()
{
	return(0);
}

int
aio_error_ctf()
{
	int		rval;
	int		errs;
	int		fails;
	char		buf[1];
	struct aiocb	cb;

	errs	= 0;
	fails	= 0;

	memset((void *) &cb, 0, sizeof(struct aiocb));

	cb.aio_fildes	= -1;
	cb.aio_offset	= 0;
	cb.aio_buf	= (void *) &buf[0];
	cb.aio_nbytes	= 0;


	(void) aio_error(&cb);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
aio_error_cef()
{
	return(0);
}

#endif

#if	defined(_POSIX_ASYNCHRONOUS_IO) && defined(_POSIX_SYNCHRONIZED_IO)

/****** Testset for aio_fsync()					 ******/

#ifdef	aio_fsync
#undef	aio_fsync
#endif

int
aio_fsync_csf()
{
	return(0);
}

int
aio_fsync_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) aio_fsync(O_DSYNC + O_SYNC + 1, NULL);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
aio_fsync_cef()
{
	return(0);
}

#endif

#if	defined(_POSIX_ASYNCHRONOUS_IO)

/****** Testset for aio_read()					 ******/

#ifdef	aio_read
#undef	aio_read
#endif

int
aio_read_csf()
{
	return(0);
}

int
aio_read_ctf()
{
	int		rval;
	int		errs;
	int		fails;
	char		buf[1];
	struct aiocb	cb;

	errs	= 0;
	fails	= 0;

	cb.aio_fildes	= -1;
	cb.aio_offset	= 0;
	cb.aio_buf	= (void *) &buf[0];
	cb.aio_nbytes	= 0;

	(void) aio_read(&cb);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
aio_read_cef()
{
	return(0);
}

#endif

#if	defined(_POSIX_ASYNCHRONOUS_IO)

/****** Testset for aio_return()				 ******/

#ifdef	aio_return
#undef	aio_return
#endif

int
aio_return_csf()
{
	return(0);
}

int
aio_return_ctf()
{
	int		rval;
	int		errs;
	int		fails;
	char		buf[1];
	struct aiocb	cb;

	errs	= 0;
	fails	= 0;

	cb.aio_fildes	= -1;
	cb.aio_offset	= 0;
	cb.aio_buf	= (void *) &buf[0];
	cb.aio_nbytes	= 0;

	(void) aio_return(&cb);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
aio_return_cef()
{
	return(0);
}

#endif

#if	defined(_POSIX_ASYNCHRONOUS_IO)

/****** Testset for aio_suspend()				 ******/

#ifdef	aio_suspend
#undef	aio_suspend
#endif

int
aio_suspend_csf()
{
	return(0);
}

int
aio_suspend_ctf()
{
	int			rval;
	int			errs;
	int			fails;
	char			buf[1];
	struct aiocb		cb;
	const struct aiocb	*cba[1];
	struct timespec		ts;

	errs	= 0;
	fails	= 0;

	cb.aio_fildes	= -1;
	cb.aio_offset	= 0;
	cb.aio_buf	= (void *) &buf[0];
	cb.aio_nbytes	= 0;

	cba[0]		= &cb;

	ts.tv_sec	= 0;
	ts.tv_nsec	= 0;

	(void) aio_suspend(&cba[0], 1, (const struct timespec *) &ts);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
aio_suspend_cef()
{
	return(0);
}

#endif

#if	defined(_POSIX_ASYNCHRONOUS_IO)

/****** Testset for aio_write()					 ******/

#ifdef	aio_write
#undef	aio_write
#endif

int
aio_write_csf()
{
	return(0);
}

int
aio_write_ctf()
{
	int		rval;
	int		errs;
	int		fails;
	char		buf[1];
	struct aiocb	cb;

	errs	= 0;
	fails	= 0;

	cb.aio_fildes	= -1;
	cb.aio_offset	= 0;
	cb.aio_buf	= (void *) &buf[0];
	cb.aio_nbytes	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
aio_write_cef()
{
	return(0);
}

#endif


/****** Testset for alarm()					 ******/

#ifdef	alarm
#undef	alarm
#endif

int
alarm_csf()
{
	return(0);
}

int
alarm_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = alarm(0);
	if ( rval > 0 )
	{
		(void) alarm(rval);
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
alarm_cef()
{
	return(0);
}



/****** Testset for asctime()					 ******/

#ifdef	asctime
#undef	asctime
#endif

static struct tm	*asctime_ptm;

int
asctime_csf()
{

	time_t	t;

	t		= time(NULL);
	asctime_ptm	= localtime(&t);

	return(0);
}

int
asctime_ctf()
{
	int		rval;
	int		errs;
	int		fails;

	errs	= 0;
	fails	= 0;

	(void) asctime(asctime_ptm);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
asctime_cef()
{
	return(0);
}



/****** Testset for asin()					 ******/

#ifdef	asin
#undef	asin
#endif

int
asin_csf()
{
	return(0);
}

int
asin_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) asin(0.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
asin_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for asinh()					 ******/

#ifdef	asinh
#undef	asinh
#endif

int
asinh_csf()
{
	return(0);
}

int
asinh_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) asinh(0.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
asinh_cef()
{
	return(0);
}

#endif


/****** Testset for assert()					 ******/

int
assert_csf()
{
	return(0);
}

int
assert_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) assert(TRUE);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
assert_cef()
{
	return(0);
}



/****** Testset for atan()					 ******/

#ifdef	atan
#undef	atan
#endif

int
atan_csf()
{
	return(0);
}

int
atan_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) atan(0.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
atan_cef()
{
	return(0);
}



/****** Testset for atan2()					 ******/

#ifdef	atan2
#undef	atan2
#endif

int
atan2_csf()
{
	return(0);
}

int
atan2_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) atan2(0.0, 0.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
atan2_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for atanh()					 ******/

#ifdef	atanh
#undef	atanh
#endif

int
atanh_csf()
{
	return(0);
}

int
atanh_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) atanh(0.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
atanh_cef()
{
	return(0);
}

#endif


/****** Testset for atexit()					 ******/

#ifdef	atexit
#undef	atexit
#endif

static void
atexit_func()
{
	int	notused;

	/* avoid compiler complaints about null functions */
	notused = 1;
}

int
atexit_csf()
{
	return(0);
}

int
atexit_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) atexit(atexit_func);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
atexit_cef()
{
	return(0);
}



/****** Testset for atof()					 ******/

#ifdef	atof
#undef	atof
#endif

int
atof_csf()
{
	return(0);
}

int
atof_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) atof("X");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
atof_cef()
{
	return(0);
}



/****** Testset for atoi()					 ******/

#ifdef	atoi
#undef	atoi
#endif

int
atoi_csf()
{
	return(0);
}

int
atoi_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) atoi("X");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
atoi_cef()
{
	return(0);
}



/****** Testset for atol()					 ******/

#ifdef	atol
#undef	atol
#endif

int
atol_csf()
{
	return(0);
}

int
atol_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) atol("X");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
atol_cef()
{
	return(0);
}



