
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_cpb.c	1.5
*
*************************************************************************/


#include "std.h"


#if	( TEST_XPG > 4 )
#include <libgen.h>
#endif

#include <signal.h>
#include <stdio.h>
#include <stdlib.h>

#if	( TEST_XPG > 4 )
#include <strings.h>
#endif

#include <unistd.h>

#if	( TEST_XPG > 4 )
#include <wchar.h>
#endif


#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"


#if	( TEST_XPG > 4 )

/****** Testset for basename()					 ******/

#ifdef	basename
#undef	basename
#endif

int
basename_csf()
{
	return(0);
}

int
basename_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) basename("a/b");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
basename_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for bcmp()					 ******/

#ifdef	bcmp
#undef	bcmp
#endif

int
bcmp_csf()
{
	return(0);
}

int
bcmp_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	char	buf1[1];
	char	buf2[1];

	errs	= 0;
	fails	= 0;

	(void) bcmp((const void *) &buf1[0], (const void *) &buf2[0], 0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
bcmp_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for bcopy()					 ******/

#ifdef	bcopy
#undef	bcopy
#endif

int
bcopy_csf()
{
	return(0);
}

int
bcopy_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	char	buf1[1];
	char	buf2[1];

	errs	= 0;
	fails	= 0;

	(void) bcopy((const void *) &buf1[0], (void *) &buf2[0], 0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
bcopy_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for brk()					 ******/

#ifdef	brk
#undef	brk
#endif

int
brk_csf()
{
	return(0);
}

int
brk_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* legacy, not tested */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
brk_cef()
{
	return(0);
}

#endif
#endif

#if	( TEST_XPG > 4 )

/****** Testset for bsd_signal()				 ******/

#ifdef	bsd_signal
#undef	bsd_signal
#endif

int
bsd_signal_csf()
{
	return(0);
}

static void
bsd_signal_func( int sig )
{
	int	notused;

	notused = sig;
}

int
bsd_signal_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) bsd_signal( -1, bsd_signal_func );

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
bsd_signal_cef()
{
	return(0);
}

#endif


/****** Testset for bsearch()					 ******/

#ifdef	bsearch
#undef	bsearch
#endif

int
bsearch_csf()
{
	return(0);
}

static int
bsearch_func( const void *el1, const void *el2 )
{
	char	a;
	char	b;

	a = *((char *) el1);
	b = *((char *) el2);

	return( a < b ? -1 : ( a == b ? 0 : 1));
}

int
bsearch_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	char	buf[2];
	char	c;


	errs	= 0;
	fails	= 0;

	c	= 'a';
	buf[0]	= 'a';
	buf[1]	= 'b';

	(void) bsearch(	(const void *) &c,
			(const void *) &buf[0],
			2,
			sizeof(char),
			bsearch_func );

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
bsearch_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for btowc()					 ******/

#ifdef	btowc
#undef	btowc
#endif

int
btowc_csf()
{
	return(0);
}

int
btowc_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) btowc('X');

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
btowc_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for bzero()					 ******/

#ifdef	bzero
#undef	bzero
#endif

int
bzero_csf()
{
	return(0);
}

int
bzero_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	char	buf[1];

	errs	= 0;
	fails	= 0;

	(void) bzero( (void *) &buf[0], 0 );

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
bzero_cef()
{
	return(0);
}

#endif


