
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_cpc.c	1.8
*
*************************************************************************/


#include "std.h"

#include <dirent.h>
#include <fcntl.h>
#include <math.h>

#if	( TEST_XPG > 4 )
#include <nl_types.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <sys/types.h>

#if	( TEST_XPG > 4 )
#include <syslog.h>
#endif

#include <termios.h>
#include <time.h>
#include <unistd.h>

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"



/****** Testset for calloc()					 ******/

#ifdef	calloc
#undef	calloc
#endif

int
calloc_csf()
{
	return(0);
}

int
calloc_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) calloc(0, sizeof(char));

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
calloc_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for catclose()					 ******/

#ifdef	catclose
#undef	catclose
#endif

int
catclose_csf()
{
	return(0);
}

int
catclose_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) catclose((nl_catd) -1);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
catclose_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for catgets()					 ******/

#ifdef	catgets
#undef	catgets
#endif

int
catgets_csf()
{
	return(0);
}

int
catgets_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) catgets((nl_catd) -1, 01, 01, "X");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
catgets_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for catopen()					 ******/

#ifdef	catopen
#undef	catopen
#endif

int
catopen_csf()
{
	return(0);
}

int
catopen_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) catopen("nonesuch", -1);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
catopen_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for cbrt()					 ******/

#ifdef	cbrt
#undef	cbrt
#endif

int
cbrt_csf()
{
	return(0);
}

int
cbrt_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) cbrt(0.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
cbrt_cef()
{
	return(0);
}

#endif


/****** Testset for ceil()					 ******/

#ifdef	ceil
#undef	ceil
#endif

int
ceil_csf()
{
	return(0);
}

int
ceil_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) ceil(0.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ceil_cef()
{
	return(0);
}



/****** Testset for cfgetispeed()				 ******/

#ifdef	cfgetispeed
#undef	cfgetispeed
#endif

static struct termios	cfgetispeed_termios;

int
cfgetispeed_csf()
{
	(void) cfsetispeed(&cfgetispeed_termios, B9600);

	return(0);
}

int
cfgetispeed_ctf()
{
	int		rval;
	int		errs;
	int		fails;

	errs	= 0;
	fails	= 0;

	(void) cfgetispeed(&cfgetispeed_termios);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
cfgetispeed_cef()
{
	return(0);
}



/****** Testset for cfgetospeed()				 ******/

#ifdef	cfgetospeed
#undef	cfgetospeed
#endif

static struct termios	cfgetospeed_termios;

int
cfgetospeed_csf()
{
	(void) cfsetospeed(&cfgetospeed_termios, B9600);
	return(0);
}

int
cfgetospeed_ctf()
{
	int		rval;
	int		errs;
	int		fails;

	errs	= 0;
	fails	= 0;

	(void) cfgetospeed(&cfgetospeed_termios);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
cfgetospeed_cef()
{
	return(0);
}



/****** Testset for cfsetispeed()				 ******/

#ifdef	cfsetispeed
#undef	cfsetispeed
#endif

int
cfsetispeed_csf()
{
	return(0);
}

int
cfsetispeed_ctf()
{
	int		rval;
	int		errs;
	int		fails;
	struct termios	t;

	errs	= 0;
	fails	= 0;

	(void) cfsetispeed(&t, B9600);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
cfsetispeed_cef()
{
	return(0);
}



/****** Testset for cfsetospeed()				 ******/

#ifdef	cfsetospeed
#undef	cfsetospeed
#endif

int
cfsetospeed_csf()
{
	return(0);
}

int
cfsetospeed_ctf()
{
	int		rval;
	int		errs;
	int		fails;
	struct termios	t;

	errs	= 0;
	fails	= 0;

	(void) cfsetospeed(&t, B9600);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
cfsetospeed_cef()
{
	return(0);
}



/****** Testset for chdir()					 ******/

#ifdef	chdir
#undef	chdir
#endif

int
chdir_csf()
{
	return(0);
}

int
chdir_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) chdir(".");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
chdir_cef()
{
	return(0);
}



/****** Testset for chmod()					 ******/

#ifdef	chmod
#undef	chmod
#endif

int
chmod_csf()
{
	return(0);
}

int
chmod_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) chmod(".", S_IRWXU);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
chmod_cef()
{
	return(0);
}



/****** Testset for chown()					 ******/

#ifdef	chown
#undef	chown
#endif

static uid_t	chown_uid;
static gid_t	chown_gid;

int
chown_csf()
{
	chown_uid = geteuid();
	chown_gid = getgid();
	return(0);
}

int
chown_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) chown(".", chown_uid, chown_gid);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
chown_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for chroot()					 ******/

#ifdef	chroot
#undef	chroot
#endif

int
chroot_csf()
{
	return(0);
}

int
chroot_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) chroot("/");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
chroot_cef()
{
	return(0);
}

#endif
#endif


/****** Testset for clearerr()					 ******/

#ifdef	clearerr
#undef	clearerr
#endif

int
clearerr_csf()
{
	return(0);
}

int
clearerr_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) clearerr(stdout);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
clearerr_cef()
{
	return(0);
}



/****** Testset for clock()					 ******/

#ifdef	clock
#undef	clock
#endif

int
clock_csf()
{
	return(0);
}

int
clock_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) clock();

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
clock_cef()
{
	return(0);
}


#if	defined(_POSIX_TIMERS)

/****** Testset for clock_getres()				 ******/

#ifdef	clock_getres
#undef	clock_getres
#endif

int
clock_getres_csf()
{
	return(0);
}

int
clock_getres_ctf()
{
	int		rval;
	int		errs;
	int		fails;
	struct timespec	ts;

	errs	= 0;
	fails	= 0;

	(void) clock_getres(-1, &ts);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
clock_getres_cef()
{
	return(0);
}

#endif

#if	defined(_POSIX_TIMERS)

/****** Testset for clock_gettime()				 ******/

#ifdef	clock_gettime
#undef	clock_gettime
#endif

int
clock_gettime_csf()
{
	return(0);
}

int
clock_gettime_ctf()
{
	int		rval;
	int		errs;
	int		fails;
	struct timespec	ts;

	errs	= 0;
	fails	= 0;

	(void) clock_gettime(-1, &ts);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
clock_gettime_cef()
{
	return(0);
}

#endif

#if	defined(_POSIX_TIMERS)

/****** Testset for clock_settime()				 ******/

#ifdef	clock_settime
#undef	clock_settime
#endif

int
clock_settime_csf()
{
	return(0);
}

int
clock_settime_ctf()
{
	int		rval;
	int		errs;
	int		fails;
	struct timespec	ts;

	errs	= 0;
	fails	= 0;

	ts.tv_nsec	= -1;
	ts.tv_sec	= 0;

	(void) clock_settime(-1, &ts);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
clock_settime_cef()
{
	return(0);
}

#endif


/****** Testset for close()					 ******/

#ifdef	close
#undef	close
#endif

int
close_csf()
{
	return(0);
}

int
close_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) close(-1);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
close_cef()
{
	return(0);
}



/****** Testset for closedir()					 ******/

#ifdef	closedir
#undef	closedir
#endif

static DIR	*Closedir_dirp;

int
closedir_csf()
{
	Closedir_dirp = opendir(".");
	closedir(Closedir_dirp);
	return(0);
}

int
closedir_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) closedir(Closedir_dirp);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
closedir_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for closelog()					 ******/

#ifdef	closelog
#undef	closelog
#endif

int
closelog_csf()
{
	return(0);
}

int
closelog_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) closelog();

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
closelog_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for compile()					 ******/

#ifdef	compile
#undef	compile
#endif

int
compile_csf()
{
	return(0);
}

int
compile_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* legacy, not tested */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
compile_cef()
{
	return(0);
}

#endif
#endif

#if	( TEST_XPG > 4 )

/****** Testset for confstr()					 ******/

#ifdef	confstr
#undef	confstr
#endif

int
confstr_csf()
{
	return(0);
}

int
confstr_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	char	buf[2];

	errs	= 0;
	fails	= 0;

	(void) confstr(_CS_PATH, &buf[0], 1);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
confstr_cef()
{
	return(0);
}

#endif


/****** Testset for cos()					 ******/

#ifdef	cos
#undef	cos
#endif

int
cos_csf()
{
	return(0);
}

int
cos_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) cos(0.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
cos_cef()
{
	return(0);
}



/****** Testset for cosh()					 ******/

#ifdef	cosh
#undef	cosh
#endif

int
cosh_csf()
{
	return(0);
}

int
cosh_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) cosh(0.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
cosh_cef()
{
	return(0);
}



/****** Testset for creat()					 ******/

#ifdef	creat
#undef	creat
#endif

#define	VSTH_CREATE_FILENAME	"./nonesuch"

int
creat_csf()
{
	return(0);
}

int
creat_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) creat(VSTH_CREATE_FILENAME, S_IRWXU);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
creat_cef()
{
	(void) remove(VSTH_CREATE_FILENAME);
	return(0);
}


#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_CRYPT) && (_XOPEN_CRYPT != -1)

/****** Testset for crypt()					 ******/

#ifdef	crypt
#undef	crypt
#endif

int
crypt_csf()
{
	return(0);
}

int
crypt_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	char	buf[1];
	char	*salt;

	errs	= 0;
	fails	= 0;

	salt	= "ab";
	buf[0]	= '\0';
	(void) crypt(&buf[0], &salt[0]);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
crypt_cef()
{
	return(0);
}

#endif
#endif


/****** Testset for ctermid()					 ******/

#ifdef	ctermid
#undef	ctermid
#endif

int
ctermid_csf()
{
	return(0);
}

int
ctermid_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) ctermid(NULL);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ctermid_cef()
{
	return(0);
}



/****** Testset for ctime()					 ******/

#ifdef	ctime
#undef	ctime
#endif

static time_t	Ctime_t;

int
ctime_csf()
{
	Ctime_t = time(NULL);
	return(0);
}

int
ctime_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) ctime(&Ctime_t);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ctime_cef()
{
	return(0);
}


#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)

/****** Testset for ctime_r()					 ******/

#ifdef	ctime_r
#undef	ctime_r
#endif

static time_t	Ctime_r_t;

int
ctime_r_csf()
{
	Ctime_r_t = time(NULL);
	return(0);
}

int
ctime_r_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	char	buf[32];

	errs	= 0;
	fails	= 0;

	(void) ctime_r(&Ctime_r_t, &buf[0]);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ctime_r_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for cuserid()					 ******/

#ifdef	cuserid
#undef	cuserid
#endif

int
cuserid_csf()
{
	return(0);
}

int
cuserid_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) cuserid(NULL);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
cuserid_cef()
{
	return(0);
}

#endif
#endif


