
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_cpd.c	1.4
*
*************************************************************************/


#include "std.h"


#if	( TEST_XPG > 4 )
#include <dlfcn.h>
#endif

#include <fcntl.h>

#if	( TEST_XPG > 4 )
#include <libgen.h>
#include <ndbm.h>
#endif

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>
#include <time.h>
#include <unistd.h>

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"


#if	( TEST_XPG > 4 )

/****** Testset for dbm_clearerr()				 ******/

#ifdef	dbm_clearerr
#undef	dbm_clearerr
#endif

int
dbm_clearerr_csf()
{
	return(0);
}

int
dbm_clearerr_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;


	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dbm_clearerr_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dbm_close()					 ******/

#ifdef	dbm_close
#undef	dbm_close
#endif

static	DBM	*Dbm_close_pdb;
int
dbm_close_csf()
{

	Dbm_close_pdb = dbm_open("./db", O_CREAT | O_WRONLY, S_IRWXU);
	return(0);
}

int
dbm_close_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) dbm_close(Dbm_close_pdb);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dbm_close_cef()
{
	(void) remove("./db.dir");
	(void) remove("./db.pag");
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dbm_delete()				 ******/

#ifdef	dbm_delete
#undef	dbm_delete
#endif

static DBM	*Dbm_delete_pdb;

int
dbm_delete_csf()
{
	Dbm_delete_pdb = dbm_open("./db", O_CREAT | O_WRONLY, S_IRWXU);
	return(0);
}

int
dbm_delete_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	datum	datum;

	datum.dptr	= "key";
	datum.dsize	= 3;

	errs	= 0;
	fails	= 0;

	(void) dbm_delete(Dbm_delete_pdb, datum);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dbm_delete_cef()
{
	(void) dbm_close(Dbm_delete_pdb);
	(void) remove("./db.dir");
	(void) remove("./db.pag");
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dbm_error()					 ******/

#ifdef	dbm_error
#undef	dbm_error
#endif

static DBM	*Dbm_error_pdb;

int
dbm_error_csf()
{
	Dbm_error_pdb = dbm_open("./db", O_CREAT | O_WRONLY, S_IRWXU);

	return(0);
}

int
dbm_error_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) dbm_error(Dbm_error_pdb);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dbm_error_cef()
{
	(void) dbm_close(Dbm_error_pdb);
	(void) remove("./db.dir");
	(void) remove("./db.pag");
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dbm_fetch()					 ******/

#ifdef	dbm_fetch
#undef	dbm_fetch
#endif

static DBM	*Dbm_fetch_pdb;

int
dbm_fetch_csf()
{
	Dbm_fetch_pdb = dbm_open("./db", O_CREAT | O_WRONLY, S_IRWXU);
	return(0);
}

int
dbm_fetch_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	datum	datum;

	errs	= 0;
	fails	= 0;

	datum.dptr	= "key";
	datum.dsize	= 3;

	(void) dbm_fetch(Dbm_fetch_pdb, datum);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dbm_fetch_cef()
{
	(void) dbm_close(Dbm_fetch_pdb);
	(void) remove("./db.dir");
	(void) remove("./db.pag");
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dbm_firstkey()				 ******/

#ifdef	dbm_firstkey
#undef	dbm_firstkey
#endif

static DBM	*Dbm_firstkey_pdb;

int
dbm_firstkey_csf()
{
	Dbm_firstkey_pdb = dbm_open("./db", O_CREAT | O_WRONLY, S_IRWXU);
	return(0);
}

int
dbm_firstkey_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) dbm_firstkey(Dbm_firstkey_pdb);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dbm_firstkey_cef()
{
	(void) dbm_close(Dbm_firstkey_pdb);
	(void) remove("./db.dir");
	(void) remove("./db.pag");
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dbm_nextkey()				 ******/

#ifdef	dbm_nextkey
#undef	dbm_nextkey
#endif

static DBM	*Dbm_nextkey_pdb;

int
dbm_nextkey_csf()
{
	Dbm_nextkey_pdb = dbm_open("./db", O_CREAT | O_WRONLY, S_IRWXU);
	return(0);
}

int
dbm_nextkey_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) dbm_nextkey(Dbm_nextkey_pdb);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dbm_nextkey_cef()
{
	(void) dbm_close(Dbm_nextkey_pdb);
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dbm_open()					 ******/

#ifdef	dbm_open
#undef	dbm_open
#endif

static DBM	*Dbm_open_pdb;

int
dbm_open_csf()
{
	return(0);
}

int
dbm_open_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	Dbm_open_pdb = dbm_open("./db", O_CREAT | O_WRONLY, S_IRWXU);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dbm_open_cef()
{
	(void) dbm_close(Dbm_open_pdb);
	(void) remove("./db.dir");
	(void) remove("./db.pag");
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dbm_store()					 ******/

#ifdef	dbm_store
#undef	dbm_store
#endif

static DBM	*Dbm_store_pdb;

int
dbm_store_csf()
{
	Dbm_store_pdb = dbm_open("./db", O_CREAT | O_WRONLY, S_IRWXU);
	return(0);
}

int
dbm_store_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	datum	key;
	datum	content;

	errs	= 0;
	fails	= 0;

	key.dptr	= "key";
	key.dsize	= 3;
	content.dptr	= "content";
	content.dsize	= 7;

	(void) dbm_store(Dbm_store_pdb, key, content, DBM_INSERT);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dbm_store_cef()
{
	(void) dbm_close(Dbm_store_pdb);
	(void) remove("./db.dir");
	(void) remove("./db.pag");
	return(0);
}

#endif


/****** Testset for difftime()					 ******/

#ifdef	difftime
#undef	difftime
#endif

int
difftime_csf()
{
	return(0);
}

int
difftime_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) difftime((time_t) 0, (time_t) 0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
difftime_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for dirname()					 ******/

#ifdef	dirname
#undef	dirname
#endif

int
dirname_csf()
{
	return(0);
}

int
dirname_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) dirname("X");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dirname_cef()
{
	return(0);
}

#endif


/****** Testset for div()					 ******/

#ifdef	div
#undef	div
#endif

int
div_csf()
{
	return(0);
}

int
div_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) div(1, 1);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
div_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for dlclose()					 ******/

#ifdef	dlclose
#undef	dlclose
#endif

int
dlclose_csf()
{
	return(0);
}

int
dlclose_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not tested */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dlclose_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dlerror()					 ******/

#ifdef	dlerror
#undef	dlerror
#endif

int
dlerror_csf()
{
	return(0);
}

int
dlerror_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) dlerror();

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dlerror_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dlopen()					 ******/

#ifdef	dlopen
#undef	dlopen
#endif

int
dlopen_csf()
{
	return(0);
}

int
dlopen_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not tested */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dlopen_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dlsym()					 ******/

#ifdef	dlsym
#undef	dlsym
#endif

int
dlsym_csf()
{
	return(0);
}

int
dlsym_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not tested */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dlsym_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for drand48()					 ******/

#ifdef	drand48
#undef	drand48
#endif

int
drand48_csf()
{
	return(0);
}

int
drand48_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) drand48();

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
drand48_cef()
{
	return(0);
}

#endif


/****** Testset for dup()					 ******/

#ifdef	dup
#undef	dup
#endif

int
dup_csf()
{
	return(0);
}

int
dup_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) dup(-1);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dup_cef()
{
	return(0);
}



/****** Testset for dup2()					 ******/

#ifdef	dup2
#undef	dup2
#endif

int
dup2_csf()
{
	return(0);
}

int
dup2_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) dup2(-1, -1);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dup2_cef()
{
	return(0);
}



