
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_cpe.c	1.5
*
*************************************************************************/


#include "std.h"

#include <grp.h>
#include <math.h>
#include <pwd.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#if	( TEST_XPG > 4 )
#include <utmpx.h>
#endif


#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"


#if	( TEST_XPG > 4 )

/****** Testset for ecvt()					 ******/

#ifdef	ecvt
#undef	ecvt
#endif

int
ecvt_csf()
{
	return(0);
}

int
ecvt_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	int	decpt;
	int	sign;

	errs	= 0;
	fails	= 0;

	(void) ecvt(0.0, 0, &decpt, &sign);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ecvt_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_CRYPT) && (_XOPEN_CRYPT != -1)

/****** Testset for encrypt()					 ******/

#ifdef	encrypt
#undef	encrypt
#endif

static char	Encrypt_buf[64];

int
encrypt_csf()
{
	memset((void *) &Encrypt_buf[0], 0, 64);
	return(0);
}

int
encrypt_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	char	buf[64];

	errs	= 0;
	fails	= 0;

	encrypt(&Encrypt_buf[0], 1);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
encrypt_cef()
{
	return(0);
}

#endif
#endif

#if	( TEST_XPG > 4 )

/****** Testset for endgrent()					 ******/

#ifdef	endgrent
#undef	endgrent
#endif

int
endgrent_csf()
{
	return(0);
}

int
endgrent_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) endgrent();

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
endgrent_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for endpwent()					 ******/

#ifdef	endpwent
#undef	endpwent
#endif

int
endpwent_csf()
{
	return(0);
}

int
endpwent_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) endpwent();

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
endpwent_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for endutxent()					 ******/

#ifdef	endutxent
#undef	endutxent
#endif

int
endutxent_csf()
{
	return(0);
}

int
endutxent_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) endutxent();

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
endutxent_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for erand48()					 ******/

#ifdef	erand48
#undef	erand48
#endif

int
erand48_csf()
{
	return(0);
}

int
erand48_ctf()
{
	int			rval;
	int			errs;
	int			fails;
	unsigned short int	xsubi[3];

	errs	= 0;
	fails	= 0;

	(void) erand48(&xsubi[0]);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
erand48_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for erf()					 ******/

#ifdef	erf
#undef	erf
#endif

int
erf_csf()
{
	return(0);
}

int
erf_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) erf(0.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
erf_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for erfc()					 ******/

#ifdef	erfc
#undef	erfc
#endif

int
erfc_csf()
{
	return(0);
}

int
erfc_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) erfc(0.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
erfc_cef()
{
	return(0);
}

#endif


/****** Testset for execl()					 ******/

#ifdef	execl
#undef	execl
#endif

int
execl_csf()
{
	return(0);
}

int
execl_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) execl("./nonesuch", "./nonesuch", NULL);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
execl_cef()
{
	return(0);
}



/****** Testset for execle()					 ******/

#ifdef	execle
#undef	execle
#endif

int
execle_csf()
{
	return(0);
}

int
execle_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	char	*envp[1];

	errs	= 0;
	fails	= 0;
	envp[0]	= NULL;

	(void) execle("./nonesuch", "./nonesuch", NULL, envp);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
execle_cef()
{
	return(0);
}



/****** Testset for execlp()					 ******/

#ifdef	execlp
#undef	execlp
#endif

int
execlp_csf()
{
	return(0);
}

int
execlp_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) execlp("./nonesuch", "./nonesuch", NULL);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
execlp_cef()
{
	return(0);
}



/****** Testset for execv()					 ******/

#ifdef	execv
#undef	execv
#endif

int
execv_csf()
{
	return(0);
}

int
execv_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	char	*argv[2];

	errs	= 0;
	fails	= 0;
	argv[0]	= "./nonesuch";
	argv[1]	= NULL;

	(void) execv("./nonesuch", argv);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
execv_cef()
{
	return(0);
}



/****** Testset for execve()					 ******/

#ifdef	execve
#undef	execve
#endif

int
execve_csf()
{
	return(0);
}

int
execve_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	char	*argv[2];
	char	*envp[1];

	errs	= 0;
	fails	= 0;
	argv[0]	= "./nonesuch";
	argv[1]	= NULL;
	envp[0]	= NULL;

	(void) execve("./nonesuch", argv, envp);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
execve_cef()
{
	return(0);
}



/****** Testset for execvp()					 ******/

#ifdef	execvp
#undef	execvp
#endif

int
execvp_csf()
{
	return(0);
}

int
execvp_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	char	*argv[2];

	errs	= 0;
	fails	= 0;
	argv[0]	= "./nonesuch";
	argv[1]	= NULL;

	(void) execvp("./nonesuch", argv);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
execvp_cef()
{
	return(0);
}



/****** Testset for exit()					 ******/

#ifdef	exit
#undef	exit
#endif

int
exit_csf()
{
	return(0);
}

int
exit_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;


	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
exit_cef()
{
	return(0);
}



/****** Testset for exp()					 ******/

#ifdef	exp
#undef	exp
#endif

int
exp_csf()
{
	return(0);
}

int
exp_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) exp(0.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
exp_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for expm1()					 ******/

#ifdef	expm1
#undef	expm1
#endif

int
expm1_csf()
{
	return(0);
}

int
expm1_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) expm1(0.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
expm1_cef()
{
	return(0);
}

#endif


