
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	The Open Group VSTH Threads Test Suite
*	@(#)vsth_cpf.c	1.9
*
*************************************************************************/


#include "std.h"

#include <fcntl.h>

#if	( TEST_XPG > 4 )
#include <fmtmsg.h>
#include <fnmatch.h>
#include <ftw.h>
#endif

#include <math.h>
#include <stdio.h>
#include <stdlib.h>

#if	( TEST_XPG > 4 )
#include <strings.h>
#include <stropts.h>
#include <sys/ipc.h>
#endif

#include <sys/stat.h>

#if	( TEST_XPG > 4 )
#include <sys/statvfs.h>
#include <sys/timeb.h>
#endif

#include <sys/types.h>
#include <unistd.h>

#if	( TEST_XPG > 4 )
#include <wchar.h>
#endif


#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"



/****** Testset for fabs()					 ******/

#ifdef	fabs
#undef	fabs
#endif

int
fabs_csf()
{
	return(0);
}

int
fabs_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fabs(0.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fabs_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for fattach()					 ******/

#ifdef	fattach
#undef	fattach
#endif

int
fattach_csf()
{
	return(0);
}

int
fattach_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fattach(-1, "./nonesuch");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fattach_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for fchdir()					 ******/

#ifdef	fchdir
#undef	fchdir
#endif

int
fchdir_csf()
{
	return(0);
}

int
fchdir_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fchdir(-1);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fchdir_cef()
{
	return(0);
}

#endif


/****** Testset for fchmod()					 ******/

#ifdef	fchmod
#undef	fchmod
#endif

int
fchmod_csf()
{
	return(0);
}

int
fchmod_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fchmod(-1, S_IRWXU);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fchmod_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for fchown()					 ******/

#ifdef	fchown
#undef	fchown
#endif

int
fchown_csf()
{
	return(0);
}

int
fchown_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fchown(-1, -1, -1);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fchown_cef()
{
	return(0);
}

#endif


/****** Testset for fclose()					 ******/

#ifdef	fclose
#undef	fclose
#endif

static	FILE	*Fclose_fp;

int
fclose_csf()
{
	Fclose_fp = fopen("./nonesuch", "w+");

	return(0);
}

int
fclose_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fclose(Fclose_fp);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fclose_cef()
{
	(void) remove("./nonesuch");
	return(0);
}



/****** Testset for fcntl()					 ******/

#ifdef	fcntl
#undef	fcntl
#endif

int
fcntl_csf()
{
	return(0);
}

int
fcntl_ctf()
{
	int		rval;
	int		errs;
	int		fails;
	struct flock	fl;

	errs	= 0;
	fails	= 0;

	fl.l_type	= F_RDLCK;
	fl.l_whence	= 0;
	fl.l_start	= 0;
	fl.l_len	= 0;

	(void) fcntl(-1, F_SETLKW, &fl);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fcntl_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for fcvt()					 ******/

#ifdef	fcvt
#undef	fcvt
#endif

int
fcvt_csf()
{
	return(0);
}

int
fcvt_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	int	decpt;
	int	sign;

	errs	= 0;
	fails	= 0;

	(void) fcvt(0.0, 0, &decpt, &sign);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fcvt_cef()
{
	return(0);
}

#endif

#if	defined(_POSIX_SYNCHRONIZED_IO)

/****** Testset for fdatasync()					 ******/

#ifdef	fdatasync
#undef	fdatasync
#endif

int
fdatasync_csf()
{
	return(0);
}

int
fdatasync_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fdatasync(-1);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fdatasync_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for fdetach()					 ******/

#ifdef	fdetach
#undef	fdetach
#endif

int
fdetach_csf()
{
	return(0);
}

int
fdetach_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fdetach("./nonesuch");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fdetach_cef()
{
	return(0);
}

#endif


/****** Testset for fdopen()					 ******/

#ifdef	fdopen
#undef	fdopen
#endif

int
fdopen_csf()
{
	return(0);
}

int
fdopen_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fdopen(-1, "X");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fdopen_cef()
{
	return(0);
}



/****** Testset for feof()					 ******/

#ifdef	feof
#undef	feof
#endif

int
feof_csf()
{
	return(0);
}

int
feof_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) feof(stdout);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
feof_cef()
{
	return(0);
}



/****** Testset for ferror()					 ******/

#ifdef	ferror
#undef	ferror
#endif

int
ferror_csf()
{
	return(0);
}

int
ferror_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) ferror(stdout);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ferror_cef()
{
	return(0);
}



/****** Testset for fflush()					 ******/

#ifdef	fflush
#undef	fflush
#endif

int
fflush_csf()
{
	return(0);
}

int
fflush_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fflush(stdout);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fflush_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for ffs()					 ******/

#ifdef	ffs
#undef	ffs
#endif

int
ffs_csf()
{
	return(0);
}

int
ffs_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) ffs(0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ffs_cef()
{
	return(0);
}

#endif


/****** Testset for fgetc()					 ******/

#ifdef	fgetc
#undef	fgetc
#endif

static FILE	*Fgetc_fp;

int
fgetc_csf()
{
	int	rval;

	rval = 0;

	Fgetc_fp = fopen("./nonesuch", "w+");
	if ( Fgetc_fp != NULL )
	{
		rval = close(fileno(Fgetc_fp));
	}
	else
	{
		++rval;
		tet_infoline("fopen failed");
	}
	return(rval);
}

int
fgetc_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fgetc(Fgetc_fp);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fgetc_cef()
{
	(void) fclose(Fgetc_fp);
	(void) remove("./nonesuch");
	return(0);
}



/****** Testset for fgetpos()					 ******/

#ifdef	fgetpos
#undef	fgetpos
#endif

int
fgetpos_csf()
{
	return(0);
}

int
fgetpos_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	fpos_t	pos;

	errs	= 0;
	fails	= 0;

	(void) fgetpos(stdout, &pos);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fgetpos_cef()
{
	return(0);
}



/****** Testset for fgets()					 ******/

#ifdef	fgets
#undef	fgets
#endif

static FILE	*Fgets_fp;

int
fgets_csf()
{
	int	rval;

	rval = 0;

	Fgets_fp = fopen("./nonesuch", "w+");
	if ( Fgets_fp != NULL )
	{
		rval = close(fileno(Fgets_fp));
	}
	else
	{
		tet_infoline("fopen failed");
		++rval;
	}
	return(rval);
}

int
fgets_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	char	buf[2];

	errs	= 0;
	fails	= 0;

	(void) fgets(&buf[0], 1, Fgets_fp);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fgets_cef()
{
	(void) fclose(Fgets_fp);
	(void) remove("./nonesuch");
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for fgetwc()					 ******/

#ifdef	fgetwc
#undef	fgetwc
#endif

static FILE	*Fgetwc_fp;

int
fgetwc_csf()
{
	int	rval;

	rval = 0;

	Fgetwc_fp = fopen("./nonesuch", "w+");
	if ( Fgetwc_fp != NULL )
	{
		rval = close(fileno(Fgetwc_fp));
	}
	else
	{
		tet_infoline("fopen failed");
		++rval;
	}
	return(rval);
}

int
fgetwc_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fgetwc(Fgetwc_fp);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fgetwc_cef()
{
	(void) fclose(Fgetwc_fp);
	(void) remove("./nonesuch");
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for fgetws()					 ******/

#ifdef	fgetws
#undef	fgetws
#endif

static FILE	*Fgetws_fp;

int
fgetws_csf()
{
	int	rval;

	rval = 0;

	Fgetws_fp = fopen("./nonesuch", "w+");
	if ( Fgetws_fp != NULL )
	{
	}
	else
	{
		tet_infoline("fopen failed");
		++rval;
	}
	return(rval);
}

int
fgetws_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	wchar_t	wbuf[2];

	errs	= 0;
	fails	= 0;

	(void) fgetws(&wbuf[0], 1, Fgetws_fp);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fgetws_cef()
{
	(void) fclose(Fgetws_fp);
	(void) remove("./nonesuch");
	return(0);
}

#endif


/****** Testset for fileno()					 ******/

#ifdef	fileno
#undef	fileno
#endif

int
fileno_csf()
{
	return(0);
}

int
fileno_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fileno(stdout);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fileno_cef()
{
	return(0);
}


#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)

/****** Testset for flockfile()					 ******/

#ifdef	flockfile
#undef	flockfile
#endif

FILE	*Flockfile_fp;

int
flockfile_csf()
{
	int	rval;

	rval = 0;

	Flockfile_fp = tmpfile();
	if ( Flockfile_fp == NULL )
		rval = 1;

	return(rval);
}

int
flockfile_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	flockfile(Flockfile_fp);

	/* SR 113 */
	funlockfile(Flockfile_fp);
	return(0);
}

int
flockfile_cef()
{
	return(0);
}

#endif


/****** Testset for floor()					 ******/

#ifdef	floor
#undef	floor
#endif

int
floor_csf()
{
	return(0);
}

int
floor_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) floor(0.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
floor_cef()
{
	return(0);
}



/****** Testset for fmod()					 ******/

#ifdef	fmod
#undef	fmod
#endif

int
fmod_csf()
{
	return(0);
}

int
fmod_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fmod(0.0, 1.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fmod_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for fmtmsg()					 ******/

#ifdef	fmtmsg
#undef	fmtmsg
#endif

int
fmtmsg_csf()
{
	return(0);
}

int
fmtmsg_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fmtmsg(MM_SOFT, "la:bel", MM_NOSEV, "text", "action", "tag");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fmtmsg_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for fnmatch()					 ******/

#ifdef	fnmatch
#undef	fnmatch
#endif

int
fnmatch_csf()
{
	return(0);
}

int
fnmatch_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fnmatch("pattern", "string", FNM_PATHNAME);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fnmatch_cef()
{
	return(0);
}

#endif


/****** Testset for fopen()					 ******/

#ifdef	fopen
#undef	fopen
#endif

static FILE	*Fopen_fp;

int
fopen_csf()
{
	return(0);
}

int
fopen_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	Fopen_fp = fopen("./nonesuch", "w+");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fopen_cef()
{
	(void) fclose(Fopen_fp);
	(void) remove("./nonesuch");
	return(0);
}



/****** Testset for fork()					 ******/

#ifdef	fork
#undef	fork
#endif

int
fork_csf()
{
	return(0);
}

int
fork_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	if ( fork() == 0 )
	{
		exit(0);
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fork_cef()
{
	return(0);
}



/****** Testset for fpathconf()					 ******/

#ifdef	fpathconf
#undef	fpathconf
#endif

int
fpathconf_csf()
{
	return(0);
}

int
fpathconf_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fpathconf(-1, _PC_NAME_MAX);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fpathconf_cef()
{
	return(0);
}



/****** Testset for fprintf()					 ******/

#ifdef	fprintf
#undef	fprintf
#endif

int
fprintf_csf()
{
	return(0);
}

int
fprintf_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fprintf(stdout, "");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fprintf_cef()
{
	return(0);
}



/****** Testset for fputc()					 ******/

#ifdef	fputc
#undef	fputc
#endif

static FILE	*Fputc_fp;

int
fputc_csf()
{
	Fputc_fp = fopen("./nonesuch", "w+");
	return(0);
}

int
fputc_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fputc('X', Fputc_fp);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fputc_cef()
{
	(void) fclose(Fputc_fp);
	(void) remove("./nonesuch");
	return(0);
}



/****** Testset for fputs()					 ******/

#ifdef	fputs
#undef	fputs
#endif

int
fputs_csf()
{
	return(0);
}

int
fputs_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fputs("", stdout);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fputs_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for fputwc()					 ******/

#ifdef	fputwc
#undef	fputwc
#endif

static FILE	*Fputwc_fp;

int
fputwc_csf()
{
	Fputwc_fp = fopen("./nonesuch", "w+");
	return(0);
}

int
fputwc_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fputwc((wchar_t) 0, Fputwc_fp);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fputwc_cef()
{
	(void) fclose(Fputwc_fp);
	(void) remove("./nonesuch");
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for fputws()					 ******/

#ifdef	fputws
#undef	fputws
#endif

static FILE	*Fputws_fp;

int
fputws_csf()
{
	Fputws_fp = fopen("./nonesuch", "w+");
	return(0);
}

int
fputws_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	wchar_t	wbuf[1];

	errs	= 0;
	fails	= 0;

	wbuf[0] = (wchar_t) 0;
	fputws(&wbuf[0], Fputws_fp);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fputws_cef()
{
	(void) fclose(Fputws_fp);
	(void) remove("./nonesuch");
	return(0);
}

#endif


/****** Testset for fread()					 ******/

#ifdef	fread
#undef	fread
#endif

int
fread_csf()
{
	return(0);
}

int
fread_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	char	buf[1];

	errs	= 0;
	fails	= 0;

	(void) fread(&buf[0], sizeof(char), 0, stdin);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fread_cef()
{
	return(0);
}



/****** Testset for free()					 ******/

#ifdef	free
#undef	free
#endif

static char	*Free_addr;

int
free_csf()
{
	Free_addr = (char *) malloc(1 * sizeof(char));
	return(0);
}

int
free_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) free((void *) Free_addr);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
free_cef()
{
	return(0);
}



/****** Testset for freopen()					 ******/

#ifdef	freopen
#undef	freopen
#endif

static FILE	*Freopen_fp;
static FILE	*Freopen_newfp;

int
freopen_csf()
{
	Freopen_fp = fopen("./nonesuch", "w+");
	return(0);
}

int
freopen_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	FILE	*fp;

	errs	= 0;
	fails	= 0;

	Freopen_newfp = freopen("./nonesuch", "w+", Freopen_fp);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
freopen_cef()
{
	(void) fclose(Freopen_newfp);
	(void) remove("./nonesuch");
	return(0);
}



/****** Testset for frexp()					 ******/

#ifdef	frexp
#undef	frexp
#endif

int
frexp_csf()
{
	return(0);
}

int
frexp_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	int	exp;

	errs	= 0;
	fails	= 0;

	(void) frexp(0.0, &exp);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
frexp_cef()
{
	return(0);
}



/****** Testset for fscanf()					 ******/

#ifdef	fscanf
#undef	fscanf
#endif

int
fscanf_csf()
{
	return(0);
}

int
fscanf_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	fscanf(stdin, "");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fscanf_cef()
{
	return(0);
}



/****** Testset for fseek()					 ******/

#ifdef	fseek
#undef	fseek
#endif

int
fseek_csf()
{
	return(0);
}

int
fseek_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fseek(stdout, 0, SEEK_CUR);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fseek_cef()
{
	return(0);
}



/****** Testset for fsetpos()					 ******/

#ifdef	fsetpos
#undef	fsetpos
#endif

static fpos_t	Fsetpos_pos;

int
fsetpos_csf()
{
	(void) fgetpos(stdout, &Fsetpos_pos);
	return(0);
}

int
fsetpos_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fsetpos(stdout, &Fsetpos_pos);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fsetpos_cef()
{
	return(0);
}



/****** Testset for fstat()					 ******/

#ifdef	fstat
#undef	fstat
#endif

int
fstat_csf()
{
	return(0);
}

int
fstat_ctf()
{
	int		rval;
	int		errs;
	int		fails;
	struct stat	sb;

	errs	= 0;
	fails	= 0;

	(void) fstat(-1, &sb);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fstat_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for fstatvfs()					 ******/

#ifdef	fstatvfs
#undef	fstatvfs
#endif

int
fstatvfs_csf()
{
	return(0);
}

int
fstatvfs_ctf()
{
	int		rval;
	int		errs;
	int		fails;
	struct statvfs	sb;

	errs	= 0;
	fails	= 0;

	(void) fstatvfs(01, &sb);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fstatvfs_cef()
{
	return(0);
}

#endif

#if	defined(_POSIX_FSYNC)

/****** Testset for fsync()					 ******/

#ifdef	fsync
#undef	fsync
#endif

int
fsync_csf()
{
	return(0);
}

int
fsync_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fsync(-1);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fsync_cef()
{
	return(0);
}

#endif


/****** Testset for ftell()					 ******/

#ifdef	ftell
#undef	ftell
#endif

int
ftell_csf()
{
	return(0);
}

int
ftell_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) ftell(stdout);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ftell_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for ftello()					 ******/

#ifdef	ftello
#undef	ftello
#endif

int
ftello_csf()
{
	return(0);
}

int
ftello_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) ftello(stdout);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ftello_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for ftime()					 ******/

#ifdef	ftime
#undef	ftime
#endif

int
ftime_csf()
{
	return(0);
}

int
ftime_ctf()
{
	int		rval;
	int		errs;
	int		fails;
	struct timeb	tp;

	errs	= 0;
	fails	= 0;

	(void) ftime(&tp);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ftime_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for ftok()					 ******/

#ifdef	ftok
#undef	ftok
#endif

int
ftok_csf()
{
	return(0);
}

int
ftok_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) ftok("./nonesuch", 0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ftok_cef()
{
	return(0);
}

#endif


/****** Testset for ftruncate()					 ******/

#ifdef	ftruncate
#undef	ftruncate
#endif

int
ftruncate_csf()
{
	return(0);
}

int
ftruncate_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) ftruncate(-1, 0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ftruncate_cef()
{
	return(0);
}


#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)

/****** Testset for ftrylockfile()				 ******/

#ifdef	ftrylockfile
#undef	ftrylockfile
#endif

FILE	*Ftrylockfile_fp;

int
ftrylockfile_csf()
{
	int	rval;

	rval = 0;

	Ftrylockfile_fp = tmpfile();
	if ( Ftrylockfile_fp == NULL )
	{
		rval = 1;
	}

	return(rval);
}

int
ftrylockfile_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) ftrylockfile(Ftrylockfile_fp);
	/* SR 113 */
	(void) funlockfile(Ftrylockfile_fp);

	return(0);
}

int
ftrylockfile_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for ftw()					 ******/

#ifdef	ftw
#undef	ftw
#endif

static int
ftw_func( const char *s, const struct stat *psb, int flag )
{
	return(0);
}

int
ftw_csf()
{
	return(0);
}

int
ftw_ctf()
{
	int		rval;
	int		errs;
	int		fails;
	struct stat	sb;

	errs	= 0;
	fails	= 0;

	(void) ftw("./nonesuch", ftw_func, 0);
	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ftw_cef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)

/****** Testset for funlockfile()				 ******/

#ifdef	funlockfile
#undef	funlockfile
#endif

FILE	*Funlockfile_fp;

int
funlockfile_csf()
{
	return(0);
}

int
funlockfile_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	int	oldstate;

	errs	= 0;
	fails	= 0;

	rval = pthread_setcancelstate( PTHREAD_CANCEL_DISABLE, &oldstate );
	if ( rval == 0 )
	{
		Funlockfile_fp = tmpfile();
		if ( Funlockfile_fp )
		{
			flockfile(Funlockfile_fp);
			rval = pthread_setcancelstate( PTHREAD_CANCEL_ENABLE, &oldstate );
			if ( rval == 0 )
			{
				funlockfile(Funlockfile_fp);
			}
			else
			{
				++errs;
			}
		}
		else
		{
			++errs;
		}
	}
	else
	{
		++errs;
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
funlockfile_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for fwide()					 ******/

#ifdef	fwide
#undef	fwide
#endif

int
fwide_csf()
{
	return(0);
}

int
fwide_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) fwide(stdout, 0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fwide_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for fwprintf()					 ******/

#ifdef	fwprintf
#undef	fwprintf
#endif

int
fwprintf_csf()
{
	return(0);
}

int
fwprintf_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	wchar_t	wbuf[2];

	errs	= 0;
	fails	= 0;

	wbuf[0] = (wchar_t) 0;
	fwprintf(stdout, &wbuf[0]);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fwprintf_cef()
{
	return(0);
}

#endif


/****** Testset for fwrite()					 ******/

#ifdef	fwrite
#undef	fwrite
#endif

int
fwrite_csf()
{
	return(0);
}

int
fwrite_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	char	buf[1];

	errs	= 0;
	fails	= 0;

	buf[0] = '\0';
	(void) fwrite((const void *) &buf[0], sizeof(char), 0, stdout);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fwrite_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for fwscanf()					 ******/

#ifdef	fwscanf
#undef	fwscanf
#endif

int
fwscanf_csf()
{
	return(0);
}

int
fwscanf_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	wchar_t	wbuf[1];

	errs	= 0;
	fails	= 0;

	wbuf[0] = (wchar_t) 0;
	(void) fwscanf(stdin, &wbuf[0] );

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
fwscanf_cef()
{
	return(0);
}

#endif


