
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_cph.c	1.5
*
*************************************************************************/


#include "std.h"

#include <math.h>

#if	( TEST_XPG > 4 )
#include <search.h>
#endif

#include <stdio.h>
#include <unistd.h>

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"


#if	( TEST_XPG > 4 )

/****** Testset for hcreate()					 ******/

#ifdef	hcreate
#undef	hcreate
#endif

int
hcreate_csf()
{
	return(0);
}

int
hcreate_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) hcreate(0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
hcreate_cef()
{
	(void) hdestroy();
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for hdestroy()					 ******/

#ifdef	hdestroy
#undef	hdestroy
#endif

int
hdestroy_csf()
{
	(void) hcreate(0);
	return(0);
}

int
hdestroy_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) hdestroy();

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
hdestroy_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for hsearch()					 ******/

#ifdef	hsearch
#undef	hsearch
#endif

int
hsearch_csf()
{
	int	rval;

	rval = hcreate(2);

	return(rval ? 0 : 1);
}

int
hsearch_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	ENTRY	item;

	errs	= 0;
	fails	= 0;

	item.key	= "";
	item.data	= (void *) "";
	(void) hsearch(item, FIND);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
hsearch_cef()
{
	hdestroy();
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for hypot()					 ******/

#ifdef	hypot
#undef	hypot
#endif

int
hypot_csf()
{
	return(0);
}

int
hypot_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) hypot(0.0, 0.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
hypot_cef()
{
	return(0);
}

#endif


