
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_cpk.c	1.3
*
*************************************************************************/


#include "std.h"

#include <signal.h>
#include <stdio.h>
#include <sys/types.h>
#include <unistd.h>

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"



/****** Testset for kill()					 ******/

#ifdef	kill
#undef	kill
#endif

static pid_t	Kill_pid;

int
kill_csf()
{
	Kill_pid = getpid();
	return(0);
}

int
kill_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) kill(Kill_pid, 0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
kill_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for killpg()					 ******/

#ifdef	killpg
#undef	killpg
#endif

static pid_t	Killpg_pid;

int
killpg_csf()
{
	Killpg_pid = getpgid((pid_t) 0);
	return(0);
}

int
killpg_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) killpg(Killpg_pid, 0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
killpg_cef()
{
	return(0);
}

#endif


