
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_cpn.c	1.5
*
*************************************************************************/


#include "std.h"


#if	( TEST_XPG > 4 )
#include <ftw.h>
#include <langinfo.h>
#endif

#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>
#include <unistd.h>

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"


#if	defined(_POSIX_TIMERS)

/****** Testset for nanosleep()					 ******/

#ifdef	nanosleep
#undef	nanosleep
#endif

int
nanosleep_csf()
{
	return(0);
}

int
nanosleep_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	struct timespec	st;
	struct timespec rt;

	errs	= 0;
	fails	= 0;

	st.tv_sec	= 0;
	st.tv_nsec	= 0;

	(void) nanosleep( &st, &rt );

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
nanosleep_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for nextafter()					 ******/

#ifdef	nextafter
#undef	nextafter
#endif

int
nextafter_csf()
{
	return(0);
}

int
nextafter_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) nextafter(0.0, 0.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
nextafter_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for nftw()					 ******/

#ifdef	nftw
#undef	nftw
#endif

static int
nftw_func( const char *s, const struct stat *psb, int flag, struct FTW *pftw )
{
	return(1);
}

int
nftw_csf()
{
	return(0);
}

int
nftw_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) nftw("./nonesuch", nftw_func, 0, FTW_CHDIR);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
nftw_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for nice()					 ******/

#ifdef	nice
#undef	nice
#endif

int
nice_csf()
{
	return(0);
}

int
nice_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) nice(0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
nice_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for nl_langinfo()				 ******/

#ifdef	nl_langinfo
#undef	nl_langinfo
#endif

int
nl_langinfo_csf()
{
	return(0);
}

int
nl_langinfo_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) nl_langinfo(ABDAY_1);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
nl_langinfo_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for nrand48()					 ******/

#ifdef	nrand48
#undef	nrand48
#endif

int
nrand48_csf()
{
	return(0);
}

int
nrand48_ctf()
{
	int			rval;
	int			errs;
	int			fails;
	unsigned short int	xsubi[3];

	errs	= 0;
	fails	= 0;

	(void) nrand48(&xsubi[0]);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
nrand48_cef()
{
	return(0);
}

#endif


