
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_cpo.c	1.5
*
*************************************************************************/


#include "std.h"

#include <dirent.h>
#include <fcntl.h>
#include <stdio.h>
#include <sys/stat.h>
#include <sys/types.h>

#if	( TEST_XPG > 4 )
#include <syslog.h>
#endif

#include <unistd.h>

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"



/****** Testset for open()					 ******/

#ifdef	open
#undef	open
#endif

#define	VSTH_OPEN_FILENAME	"./open_file"

static int	Vsth_open_fd = -1;

int
open_csf()
{
	return(0);
}

int
open_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	Vsth_open_fd = open(VSTH_OPEN_FILENAME, O_CREAT | O_RDWR, S_IRWXU);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
open_cef()
{
	if ( Vsth_open_fd >= 0 )
		(void) close(Vsth_open_fd);
	(void) remove(VSTH_OPEN_FILENAME);

	return(0);
}



/****** Testset for opendir()					 ******/

#ifdef	opendir
#undef	opendir
#endif

int
opendir_csf()
{
	return(0);
}

int
opendir_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) opendir("./nonesuch");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
opendir_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for openlog()					 ******/

#ifdef	openlog
#undef	openlog
#endif

int
openlog_csf()
{
	return(0);
}

int
openlog_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) openlog("X", LOG_PID, LOG_USER);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
openlog_cef()
{
	closelog();
	return(0);
}

#endif


