
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_cpr.c	1.11
*
* 
*************************************************************************/


#include "std.h"

#include <dirent.h>

#if	( TEST_XPG > 4 )
#include <libgen.h>
#endif

#include <limits.h>
#include <math.h>

#if	( TEST_XPG > 4 )
#include <re_comp.h>
#include <regex.h>
#include <search.h>
#endif

#include <signal.h>
#include <stdio.h>
#include <stdlib.h>

#if	( TEST_XPG > 4 )
#include <strings.h>
#endif

#include <sys/types.h>

#if	( TEST_XPG > 4 )
#include <sys/uio.h>
#endif

#include <unistd.h>

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"



/****** Testset for raise()					 ******/

#ifdef	raise
#undef	raise
#endif

int
raise_csf()
{
	return(0);
}

int
raise_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) raise(0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
raise_cef()
{
	return(0);
}



/****** Testset for rand()					 ******/

#ifdef	rand
#undef	rand
#endif

int
rand_csf()
{
	return(0);
}

int
rand_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) rand();

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
rand_cef()
{
	return(0);
}


#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)

/****** Testset for rand_r()					 ******/

#ifdef	rand_r
#undef	rand_r
#endif

int
rand_r_csf()
{
	return(0);
}

int
rand_r_ctf()
{
	int		rval;
	int		errs;
	int		fails;
	unsigned int	seed;

	errs	= 0;
	fails	= 0;

	seed = 0;
	(void) rand_r(&seed);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
rand_r_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for random()					 ******/

#ifdef	random
#undef	random
#endif

int
random_csf()
{
	return(0);
}

int
random_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) random();

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
random_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for re_comp()					 ******/

#ifdef	re_comp
#undef	re_comp
#endif

int
re_comp_csf()
{
	return(0);
}

int
re_comp_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) re_comp("");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
re_comp_cef()
{
	return(0);
}

#endif
#endif

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for re_exec()					 ******/

#ifdef	re_exec
#undef	re_exec
#endif

int
re_exec_csf()
{
	return(0);
}

int
re_exec_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) re_exec("");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
re_exec_cef()
{
	return(0);
}

#endif
#endif


/****** Testset for read()					 ******/

#ifdef	read
#undef	read
#endif

int
read_csf()
{
	return(0);
}

int
read_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	char	buf[1];

	errs	= 0;
	fails	= 0;

	(void) read(-1, &buf[0], 0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
read_cef()
{
	return(0);
}



/****** Testset for readdir()					 ******/

#ifdef	readdir
#undef	readdir
#endif

static DIR	*Readdir_dirp;

int
readdir_csf()
{
	int	rval;

	rval = 0;

	Readdir_dirp = opendir("..");
	if ( Readdir_dirp == NULL )
	{
		++rval;
	}

	return(rval);
}

int
readdir_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) readdir(Readdir_dirp);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
readdir_cef()
{
	(void) closedir(Readdir_dirp);
	return(0);
}

/****** Testset for readdir_r()					 ******/

#ifdef	readdir_r
#undef	readdir_r
#endif

static DIR		*Readdir_r_dirp;
static struct dirent	*Readdir_r_entry;

int
readdir_r_csf()
{
	int	rval;
	long	namemax;

	rval = 0;

	namemax = pathconf(".", _PC_NAME_MAX);

	Readdir_r_dirp = opendir("..");
	if ( Readdir_r_dirp != NULL )
	{
		Readdir_r_entry = (struct dirent *) malloc(sizeof(struct dirent) + namemax + 1);
		if ( Readdir_r_entry == NULL )
		{
			++rval;
		}
	}
	else
	{
		++rval;
	}

	return(rval);
}

int
readdir_r_ctf()
{
	int		rval;
	int		errs;
	int		fails;
	struct dirent	*result;

	errs	= 0;
	fails	= 0;

	(void) readdir_r(Readdir_r_dirp, Readdir_r_entry, &result);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
readdir_r_cef()
{
	(void) closedir(Readdir_r_dirp);
	if ( Readdir_r_entry != NULL )
	{
		(void) free(Readdir_r_entry);
	}
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for readlink()					 ******/

#ifdef	readlink
#undef	readlink
#endif

int
readlink_csf()
{
	return(0);
}

int
readlink_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	char	buf[1];

	errs	= 0;
	fails	= 0;

	(void) readlink("./nonesuch", &buf[0], 0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
readlink_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for readv()					 ******/

#ifdef	readv
#undef	readv
#endif

int
readv_csf()
{
	return(0);
}

int
readv_ctf()
{
	int		rval;
	int		errs;
	int		fails;
	char		buf[1];
	struct iovec	iov;

	errs	= 0;
	fails	= 0;

	iov.iov_base	= (caddr_t) &buf[0];
	iov.iov_len	= 0;

	(void) readv(-1, &iov, 1);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
readv_cef()
{
	return(0);
}

#endif


/****** Testset for realloc()					 ******/

#ifdef	realloc
#undef	realloc
#endif

static void	*Realloc_addr;

int
realloc_csf()
{
	int	rval;

	rval = 0;

	Realloc_addr = malloc(1);
	if ( Realloc_addr == NULL )
	{
		++rval;
	}

	return(rval);
}

int
realloc_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	Realloc_addr = realloc(Realloc_addr, 1);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
realloc_cef()
{
	if (Realloc_addr != NULL )
	{
		(void) free(Realloc_addr);
	}
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for realpath()					 ******/

#ifdef	realpath
#undef	realpath
#endif

char	*Realpath_buf;

int
realpath_csf()
{
	Realpath_buf = (char *) malloc((pathconf(".", _PC_PATH_MAX) + 1) * sizeof(char));
	if ( Realpath_buf == NULL )
		return(1);
	else
		return(0);
}

int
realpath_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) realpath("./nonesuch", Realpath_buf);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
realpath_cef()
{
	if ( Realpath_buf != NULL )
		(void) free(Realpath_buf);
	return(0);
}

#endif

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for regcmp()					 ******/

#ifdef	regcmp
#undef	regcmp
#endif

int
regcmp_csf()
{
	return(0);
}

int
regcmp_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) regcmp("a", NULL);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
regcmp_cef()
{
	return(0);
}

#endif
#endif

#if	( TEST_XPG > 4 )

/****** Testset for regcomp()					 ******/

#ifdef	regcomp
#undef	regcomp
#endif

static regex_t	Regcomp_reg;

int
regcomp_csf()
{
	return(0);
}

int
regcomp_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) regcomp(&Regcomp_reg, "", REG_EXTENDED);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
regcomp_cef()
{
	(void) regfree(&Regcomp_reg);
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for regerror()					 ******/

#ifdef	regerror
#undef	regerror
#endif

static int	Regerror_err;
static regex_t	Regerror_reg;

int
regerror_csf()
{

	Regerror_err = regcomp(&Regerror_reg, "", REG_EXTENDED);
	return(0);
}

int
regerror_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	char	buf[1];

	errs	= 0;
	fails	= 0;

	(void) regerror(Regerror_err, &Regerror_reg, &buf[0], 0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
regerror_cef()
{
	(void) regfree(&Regerror_reg);
	return(0);
}

#endif

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for regex()					 ******/

#ifdef	regex
#undef	regex
#endif

static char	*Regex_p;

int
regex_csf()
{
	Regex_p = regcmp("a", NULL);
	return(0);
}

int
regex_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) regex(Regex_p, "", NULL);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
regex_cef()
{
	return(0);
}

#endif
#endif

#if	( TEST_XPG > 4 )

/****** Testset for regexec()					 ******/

#ifdef	regexec
#undef	regexec
#endif

static regex_t	Regexec_reg;

int
regexec_csf()
{
	(void) regcomp(&Regexec_reg, "", REG_EXTENDED);
	return(0);
}

int
regexec_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) regexec(&Regexec_reg, "", 0, NULL, REG_NOTBOL);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
regexec_cef()
{
	(void) regfree(&Regexec_reg);
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for regfree()					 ******/

#ifdef	regfree
#undef	regfree
#endif

static regex_t	Regfree_re;

int
regfree_csf()
{
	(void) regcomp(&Regfree_re, "", REG_EXTENDED);
	return(0);
}

int
regfree_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) regfree(&Regfree_re);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
regfree_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for remainder()					 ******/

#ifdef	remainder
#undef	remainder
#endif

int
remainder_csf()
{
	return(0);
}

int
remainder_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) remainder(0.0, 1.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
remainder_cef()
{
	return(0);
}

#endif


/****** Testset for remove()					 ******/

#ifdef	remove
#undef	remove
#endif

int
remove_csf()
{
	return(0);
}

int
remove_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) remove("./nonesuch");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
remove_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for remque()					 ******/

#ifdef	remque
#undef	remque
#endif

struct qe	{
	struct qe	*q_next;
	struct qe	*q_last;
	int		value;
};

static struct qe	Remque_e1;
static struct qe	Remque_e2;

int
remque_csf()
{
	Remque_e1.q_next	= NULL;
	Remque_e1.q_last	= NULL;

	(void) insque((void *) &Remque_e1, (void *) &Remque_e2);
	return(0);
}

int
remque_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) remque((void *) &Remque_e1);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
remque_cef()
{
	return(0);
}

#endif


/****** Testset for rename()					 ******/

#ifdef	rename
#undef	rename
#endif

int
rename_csf()
{
	return(0);
}

int
rename_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) rename("./nonesuch", "./nonesuch");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
rename_cef()
{
	return(0);
}



/****** Testset for rewind()					 ******/

#ifdef	rewind
#undef	rewind
#endif

int
rewind_csf()
{
	return(0);
}

int
rewind_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) rewind(stdout);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
rewind_cef()
{
	return(0);
}



/****** Testset for rewinddir()					 ******/

#ifdef	rewinddir
#undef	rewinddir
#endif

static DIR	*Rewinddir_dirp;

int
rewinddir_csf()
{
	int	rval;

	rval = 0;

	Rewinddir_dirp = opendir("..");
	if ( Rewinddir_dirp == (DIR *) NULL )
	{
		++rval;
	}

	return(rval);
}

int
rewinddir_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) rewinddir(Rewinddir_dirp);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
rewinddir_cef()
{
	if (Rewinddir_dirp != NULL )
	{
		(void) closedir(Rewinddir_dirp);
	}
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for rindex()					 ******/

#ifdef	rindex
#undef	rindex
#endif

int
rindex_csf()
{
	return(0);
}

int
rindex_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) rindex("", 0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
rindex_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for rint()					 ******/

#ifdef	rint
#undef	rint
#endif

int
rint_csf()
{
	return(0);
}

int
rint_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) rint(0.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
rint_cef()
{
	return(0);
}

#endif


/****** Testset for rmdir()					 ******/

#ifdef	rmdir
#undef	rmdir
#endif

int
rmdir_csf()
{
	return(0);
}

int
rmdir_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) rmdir("./nonesuch");

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
rmdir_cef()
{
	return(0);
}



