
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_cpt.c	1.8
*
*************************************************************************/


#include "std.h"

#include <ctype.h>
#include <dirent.h>
#include <limits.h>
#include <math.h>

#if	( TEST_XPG > 4 )
#include <search.h>
#endif

#include <signal.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/times.h>
#include <sys/types.h>
#include <termios.h>
#include <time.h>
#include <unistd.h>

#if	( TEST_XPG > 4 )
#include <wctype.h>
#endif


#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"



/****** Testset for tan()					 ******/

#ifdef	tan
#undef	tan
#endif

int
tan_csf()
{
	return(0);
}

int
tan_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) tan(0.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
tan_cef()
{
	return(0);
}



/****** Testset for tanh()					 ******/

#ifdef	tanh
#undef	tanh
#endif

int
tanh_csf()
{
	return(0);
}

int
tanh_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) tanh(0.0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
tanh_cef()
{
	return(0);
}



/****** Testset for tcdrain()					 ******/

#ifdef	tcdrain
#undef	tcdrain
#endif

int
tcdrain_csf()
{
	return(0);
}

int
tcdrain_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) tcdrain(STDOUT_FILENO);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
tcdrain_cef()
{
	return(0);
}



/****** Testset for tcflow()					 ******/

#ifdef	tcflow
#undef	tcflow
#endif

int
tcflow_csf()
{
	return(0);
}

int
tcflow_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) tcflow(-1, TCOON);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
tcflow_cef()
{
	return(0);
}



/****** Testset for tcflush()					 ******/

#ifdef	tcflush
#undef	tcflush
#endif

int
tcflush_csf()
{
	return(0);
}

int
tcflush_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) tcflush(-1, TCOFLUSH);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
tcflush_cef()
{
	return(0);
}



/****** Testset for tcgetattr()					 ******/

#ifdef	tcgetattr
#undef	tcgetattr
#endif

int
tcgetattr_csf()
{
	return(0);
}

int
tcgetattr_ctf()
{
	int		rval;
	int		errs;
	int		fails;
	struct termios	termios;


	errs	= 0;
	fails	= 0;

	(void) tcgetattr(-1, &termios);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
tcgetattr_cef()
{
	return(0);
}


#if	defined(_POSIX_JOB_CONTROL)

/****** Testset for tcgetpgrp()					 ******/

#ifdef	tcgetpgrp
#undef	tcgetpgrp
#endif

int
tcgetpgrp_csf()
{
	return(0);
}

int
tcgetpgrp_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) tcgetpgrp(-1);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
tcgetpgrp_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for tcgetsid()					 ******/

#ifdef	tcgetsid
#undef	tcgetsid
#endif

int
tcgetsid_csf()
{
	return(0);
}

int
tcgetsid_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) tcgetsid(-1);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
tcgetsid_cef()
{
	return(0);
}

#endif


/****** Testset for tcsendbreak()				 ******/

#ifdef	tcsendbreak
#undef	tcsendbreak
#endif

int
tcsendbreak_csf()
{
	return(0);
}

int
tcsendbreak_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) tcsendbreak(-1, 0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
tcsendbreak_cef()
{
	return(0);
}



/****** Testset for tcsetattr()					 ******/

#ifdef	tcsetattr
#undef	tcsetattr
#endif

static struct termios	Tcsetattr_termios;
static struct sigaction	Tcsetattr_osa;

int
tcsetattr_csf()
{
	int			rval;
	struct sigaction	sa;

	(void) sigfillset(&sa.sa_mask);
	sa.sa_flags	= 0;
	sa.sa_handler	= SIG_IGN;

	rval = sigaction(SIGTTOU, &sa, &Tcsetattr_osa);
	if ( rval == 0 )
	{
		rval = tcgetattr(STDIN_FILENO, &Tcsetattr_termios);
	}

	return(rval);
}

int
tcsetattr_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) tcsetattr(STDIN_FILENO, TCSANOW, &Tcsetattr_termios);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
tcsetattr_cef()
{
	struct sigaction	osa;

	(void) sigaction(SIGTTOU, &Tcsetattr_osa, &osa);

	return(0);
}


#if	defined(_POSIX_JOB_CONTROL)

/****** Testset for tcsetpgrp()					 ******/

#ifdef	tcsetpgrp
#undef	tcsetpgrp
#endif

static pid_t	Tcsetpgrp_pid;

int
tcsetpgrp_csf()
{
	Tcsetpgrp_pid = getpgid(getpid());
	return(0);
}

int
tcsetpgrp_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) tcsetpgrp(-1, Tcsetpgrp_pid);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
tcsetpgrp_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for tdelete()					 ******/

#ifdef	tdelete
#undef	tdelete
#endif

static int
tdelete_func(const void *n1, const void *n2)
{
	return(0);
}

int
tdelete_csf()
{
	return(0);
}

int
tdelete_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) tdelete( NULL, NULL, tdelete_func);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
tdelete_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for telldir()					 ******/

#ifdef	telldir
#undef	telldir
#endif

static DIR	*Telldir_dirp;

int
telldir_csf()
{
	int	rval;

	rval = 0;

	Telldir_dirp = opendir(".");
	if ( Telldir_dirp == NULL )
	{
		++rval;
	}

	return(rval);
}

int
telldir_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) telldir(Telldir_dirp);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
telldir_cef()
{
	(void) closedir(Telldir_dirp);
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for tempnam()					 ******/

#ifdef	tempnam
#undef	tempnam
#endif

int
tempnam_csf()
{
	return(0);
}

int
tempnam_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) tempnam(NULL, NULL);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
tempnam_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for tfind()					 ******/

#ifdef	tfind
#undef	tfind
#endif

static int
tfind_func( const void *n1, const void *n2)
{
	return(0);
}

int
tfind_csf()
{
	return(0);
}

int
tfind_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) tfind(NULL, NULL, tfind_func);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
tfind_cef()
{
	return(0);
}

#endif


/****** Testset for time()					 ******/

#ifdef	time
#undef	time
#endif

int
time_csf()
{
	return(0);
}

int
time_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) time(NULL);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
time_cef()
{
	return(0);
}


#if	defined(_POSIX_TIMERS)

/****** Testset for timer_create()				 ******/

#ifdef	timer_create
#undef	timer_create
#endif

static timer_t	Timer_create_timer;

int
timer_create_csf()
{
	return(0);
}

int
timer_create_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) timer_create(CLOCK_REALTIME, NULL,  &Timer_create_timer);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
timer_create_cef()
{
	timer_delete(Timer_create_timer);
	return(0);
}

#endif

#if	defined(_POSIX_TIMERS)

/****** Testset for timer_delete()				 ******/

#ifdef	timer_delete
#undef	timer_delete
#endif

static timer_t	Timer_delete_timer;

int
timer_delete_csf()
{
	int	rval;

	rval = 0;

	rval = timer_create(CLOCK_REALTIME, NULL, &Timer_delete_timer);

	return(rval);
}

int
timer_delete_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) timer_delete(Timer_delete_timer);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
timer_delete_cef()
{
	return(0);
}

#endif

#if	defined(_POSIX_TIMERS)

/****** Testset for timer_getoverrun()				 ******/

#ifdef	timer_getoverrun
#undef	timer_getoverrun
#endif

static timer_t		Timer_getoverrun_timerid;

int
timer_getoverrun_csf()
{
	int	rval;

	rval = timer_create(CLOCK_REALTIME, NULL, &Timer_getoverrun_timerid);

	return(rval);
}

int
timer_getoverrun_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) timer_getoverrun(Timer_getoverrun_timerid);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
timer_getoverrun_cef()
{
	(void) timer_delete(Timer_getoverrun_timerid);
	return(0);
}

#endif

#if	defined(_POSIX_TIMERS)

/****** Testset for timer_gettime()				 ******/

#ifdef	timer_gettime
#undef	timer_gettime
#endif

static timer_t	Timer_gettime_timerid;

int
timer_gettime_csf()
{
	int	rval;

	rval = timer_create(CLOCK_REALTIME, NULL, &Timer_gettime_timerid);

	return(rval);
}

int
timer_gettime_ctf()
{
	int			rval;
	int			errs;
	int			fails;
	struct itimerspec	val;

	errs	= 0;
	fails	= 0;

	(void) timer_gettime(Timer_gettime_timerid, &val);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
timer_gettime_cef()
{
	(void) timer_delete(Timer_gettime_timerid);
	return(0);
}

#endif

#if	defined(_POSIX_TIMERS)

/****** Testset for timer_settime()				 ******/

#ifdef	timer_settime
#undef	timer_settime
#endif

static timer_t	Timer_settime_timerid;

int
timer_settime_csf()
{
	int	rval;

	rval = timer_create(CLOCK_REALTIME, NULL, &Timer_settime_timerid);

	return(rval);
}

int
timer_settime_ctf()
{
	int			rval;
	int			errs;
	int			fails;
	struct itimerspec	ts;

	errs	= 0;
	fails	= 0;

	ts.it_value.tv_sec	= INT_MAX;
	ts.it_value.tv_nsec	= 0;
	(void) timer_settime(Timer_settime_timerid, 0, &ts, NULL);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
timer_settime_cef()
{
	(void) timer_delete(Timer_settime_timerid);
	return(0);
}

#endif


/****** Testset for times()					 ******/

#ifdef	times
#undef	times
#endif

int
times_csf()
{
	return(0);
}

int
times_ctf()
{
	int		rval;
	int		errs;
	int		fails;
	struct tms	buf;

	errs	= 0;
	fails	= 0;

	(void) times(&buf);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
times_cef()
{
	return(0);
}



/****** Testset for tmpfile()					 ******/

#ifdef	tmpfile
#undef	tmpfile
#endif

static FILE	*Tmpfile_fp;

int
tmpfile_csf()
{
	return(0);
}

int
tmpfile_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	Tmpfile_fp = tmpfile();

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
tmpfile_cef()
{
	(void) fclose(Tmpfile_fp);
	return(0);
}



/****** Testset for tmpnam()					 ******/

#ifdef	tmpnam
#undef	tmpnam
#endif

int
tmpnam_csf()
{
	return(0);
}

int
tmpnam_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) tmpnam(NULL);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
tmpnam_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for toascii()					 ******/

#ifdef	toascii
#undef	toascii
#endif

int
toascii_csf()
{
	return(0);
}

int
toascii_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) toascii('X');

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
toascii_cef()
{
	return(0);
}

#endif


/****** Testset for tolower()					 ******/

#ifdef	tolower
#undef	tolower
#endif

int
tolower_csf()
{
	return(0);
}

int
tolower_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) tolower('X');

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
tolower_cef()
{
	return(0);
}



/****** Testset for toupper()					 ******/

#ifdef	toupper
#undef	toupper
#endif

int
toupper_csf()
{
	return(0);
}

int
toupper_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) toupper('X');

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
toupper_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )

/****** Testset for towctrans()					 ******/

#ifdef	towctrans
#undef	towctrans
#endif

static wctrans_t	Towctrans_desc;

int
towctrans_csf()
{
	Towctrans_desc = wctrans("toupper");
	return(0);
}

int
towctrans_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) towctrans((wint_t) 0, Towctrans_desc);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
towctrans_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for towlower()					 ******/

#ifdef	towlower
#undef	towlower
#endif

int
towlower_csf()
{
	return(0);
}

int
towlower_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) tolower('X');

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
towlower_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for towupper()					 ******/

#ifdef	towupper
#undef	towupper
#endif

int
towupper_csf()
{
	return(0);
}

int
towupper_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) toupper('X');

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
towupper_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for truncate()					 ******/

#ifdef	truncate
#undef	truncate
#endif

int
truncate_csf()
{
	return(0);
}

int
truncate_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) truncate("./nonesuch", (off_t) 0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
truncate_cef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for tsearch()					 ******/

#ifdef	tsearch
#undef	tsearch
#endif

static int
tsearch_func( const void *n1, const void *n2)
{
	return(0);
}

int
tsearch_csf()
{
	return(0);
}

int
tsearch_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	char	c;
	char	*p;

	errs	= 0;
	fails	= 0;

	c = 'X';
	p = &c;

	(void) tsearch((void *) p, NULL, tsearch_func);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
tsearch_cef()
{
	return(0);
}

#endif


/****** Testset for ttyname()					 ******/

#ifdef	ttyname
#undef	ttyname
#endif

int
ttyname_csf()
{
	return(0);
}

int
ttyname_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) ttyname(-1);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ttyname_cef()
{
	return(0);
}



/****** Testset for ttyname_r()					 ******/

#ifdef	ttyname_r
#undef	ttyname_r
#endif

int
ttyname_r_csf()
{
	return(0);
}

int
ttyname_r_ctf()
{
	int	rval;
	int	errs;
	int	fails;
	char	buf[1];

	errs	= 0;
	fails	= 0;

	(void) ttyname_r(-1, &buf[0], 0);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ttyname_r_cef()
{
	return(0);
}


#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for ttyslot()					 ******/

#ifdef	ttyslot
#undef	ttyslot
#endif

int
ttyslot_csf()
{
	return(0);
}

int
ttyslot_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) ttyslot();

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ttyslot_cef()
{
	return(0);
}

#endif
#endif

#if	( TEST_XPG > 4 )

/****** Testset for twalk()					 ******/

#ifdef	twalk
#undef	twalk
#endif

static void	*Twalk_root = NULL;
static int	Twalk_node;

static int
twalk_func1( const void *n1, const void *n2 )
{
	return(0);
}

static void
twalk_func2( const void *node, VISIT v, int i )
{
}

int
twalk_csf()
{
	(void) tsearch((void *) &Twalk_node, &Twalk_root, twalk_func1);
	return(0);
}

int
twalk_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) twalk(Twalk_root, twalk_func2);

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
twalk_cef()
{
	return(0);
}

#endif


/****** Testset for tzset()					 ******/

#ifdef	tzset
#undef	tzset
#endif

int
tzset_csf()
{
	return(0);
}

int
tzset_ctf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	(void) tzset();

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
tzset_cef()
{
	return(0);
}



