
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_rt.c	1.8
*
*************************************************************************/


#include <stdio.h>

#include "std.h"

#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"
#include "vsth/vsth_rt.h"

/* 
   These arrays are exercised  by  tests
	PTHR.os/all/General/General.4,6-12

   In VSTH5.1.3 smaller arrays for functions
	a-d, e, f, g-h, i-n, o-p, q-s, t-z
   were introduced so that these
   could be called by their own tests rather
   than one single large test.
*/

VSTH_RT	Vsth_rt_a_to_d[] = {
	{	_exit_sf,	NULL,	_exit_ef,	"_exit"	},
#if	( TEST_XPG > 4 )
	{	_longjmp_sf,	NULL,	_longjmp_ef,	"_longjmp"	},
#endif
#if	( TEST_XPG > 4 )
	{	_setjmp_sf,	NULL,	_setjmp_ef,	"_setjmp"	},
#endif
#if	( TEST_XPG > 4 )
	{	_tolower_sf,	NULL,	_tolower_ef,	"_tolower"	},
#endif
#if	( TEST_XPG > 4 )
	{	_toupper_sf,	NULL,	_toupper_ef,	"_toupper"	},
#endif
#if	( TEST_XPG > 4 )
	{	a64l_sf,	NULL,	a64l_ef,	"a64l"	},
#endif
	{	abort_sf,	NULL,	abort_ef,	"abort"	},
	{	abs_sf,	abs_tf,	abs_ef,	"abs"	},
	{	access_sf,	access_tf,	access_ef,	"access"	},
	{	acos_sf,	acos_tf,	acos_ef,	"acos"	},
#if	( TEST_XPG > 4 )
	{	acosh_sf,	acosh_tf,	acosh_ef,	"acosh"	},
#endif
#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)
	{	advance_sf,	NULL,	advance_ef,	"advance"	},
#endif
#endif
#if	defined(_POSIX_ASYNCHRONOUS_IO)
	{	aio_cancel_sf,	NULL,	aio_cancel_ef,	"aio_cancel"	},
#endif
#if	defined(_POSIX_ASYNCHRONOUS_IO)
	{	aio_error_sf,	NULL,	aio_error_ef,	"aio_error"	},
#endif
#if	defined(_POSIX_ASYNCHRONOUS_IO) && defined(_POSIX_SYNCHRONIZED_IO)
	{	aio_fsync_sf,	NULL,	aio_fsync_ef,	"aio_fsync"	},
#endif
#if	defined(_POSIX_ASYNCHRONOUS_IO)
	{	aio_read_sf,	NULL,	aio_read_ef,	"aio_read"	},
#endif
#if	defined(_POSIX_ASYNCHRONOUS_IO)
	{	aio_return_sf,	NULL,	aio_return_ef,	"aio_return"	},
#endif
#if	defined(_POSIX_ASYNCHRONOUS_IO)
	{	aio_suspend_sf,	NULL,	aio_suspend_ef,	"aio_suspend"	},
#endif
#if	defined(_POSIX_ASYNCHRONOUS_IO)
	{	aio_write_sf,	NULL,	aio_write_ef,	"aio_write"	},
#endif
	{	alarm_sf,	NULL,	alarm_ef,	"alarm"	},
	{	asctime_sf,	NULL,	asctime_ef,	"asctime"	},
	{	asin_sf,	asin_tf,	asin_ef,	"asin"	},
#if	( TEST_XPG > 4 )
	{	asinh_sf,	asinh_tf,	asinh_ef,	"asinh"	},
#endif
	{	assert_sf,	NULL,	assert_ef,	"assert"	},
	{	atan_sf,	atan_tf,	atan_ef,	"atan"	},
	{	atan2_sf,	atan2_tf,	atan2_ef,	"atan2"	},
#if	( TEST_XPG > 4 )
	{	atanh_sf,	atanh_tf,	atanh_ef,	"atanh"	},
#endif
	{	atexit_sf,	NULL,	atexit_ef,	"atexit"	},
	{	atof_sf,	atof_tf,	atof_ef,	"atof"	},
	{	atoi_sf,	atoi_tf,	atoi_ef,	"atoi"	},
	{	atol_sf,	atol_tf,	atol_ef,	"atol"	},
#if	( TEST_XPG > 4 )
	{	basename_sf,	NULL,	basename_ef,	"basename"	},
#endif
#if	( TEST_XPG > 4 )
	{	bcmp_sf,	bcmp_tf,	bcmp_ef,	"bcmp"	},
#endif
#if	( TEST_XPG > 4 )
	{	bcopy_sf,	bcopy_tf,	bcopy_ef,	"bcopy"	},
#endif
#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)
	{	brk_sf,	NULL,	brk_ef,	"brk"	},
#endif
#endif
#if	( TEST_XPG > 4 )
	{	bsd_signal_sf,	NULL,	bsd_signal_ef,	"bsd_signal"	},
#endif
	{	bsearch_sf,	bsearch_tf,	bsearch_ef,	"bsearch"	},
#if	( TEST_XPG > 4 )
	{	btowc_sf,	NULL,	btowc_ef,	"btowc"	},
#endif
#if	( TEST_XPG > 4 )
	{	bzero_sf,	bzero_tf,	bzero_ef,	"bzero"	},
#endif
	{	calloc_sf,	NULL,	calloc_ef,	"calloc"	},
#if	( TEST_XPG > 4 )
	{	catclose_sf,	NULL,	catclose_ef,	"catclose"	},
#endif
#if	( TEST_XPG > 4 )
	{	catgets_sf,	NULL,	catgets_ef,	"catgets"	},
#endif
#if	( TEST_XPG > 4 )
	{	catopen_sf,	NULL,	catopen_ef,	"catopen"	},
#endif
#if	( TEST_XPG > 4 )
	{	cbrt_sf,	cbrt_tf,	cbrt_ef,	"cbrt"	},
#endif
	{	ceil_sf,	ceil_tf,	ceil_ef,	"ceil"	},
	{	cfgetispeed_sf,	NULL,	cfgetispeed_ef,	"cfgetispeed"	},
	{	cfgetospeed_sf,	NULL,	cfgetospeed_ef,	"cfgetospeed"	},
	{	cfsetispeed_sf,	NULL,	cfsetispeed_ef,	"cfsetispeed"	},
	{	cfsetospeed_sf,	NULL,	cfsetospeed_ef,	"cfsetospeed"	},
	{	chdir_sf,	NULL,	chdir_ef,	"chdir"	},
	{	chmod_sf,	NULL,	chmod_ef,	"chmod"	},
	{	chown_sf,	NULL,	chown_ef,	"chown"	},
#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)
	{	chroot_sf,	NULL,	chroot_ef,	"chroot"	},
#endif
#endif
	{	clearerr_sf,	NULL,	clearerr_ef,	"clearerr"	},
	{	clock_sf,	NULL,	clock_ef,	"clock"	},
#if	defined(_POSIX_TIMERS)
	{	clock_getres_sf,	NULL,	clock_getres_ef,	"clock_getres"	},
#endif
#if	defined(_POSIX_TIMERS)
	{	clock_gettime_sf,	NULL,	clock_gettime_ef,	"clock_gettime"	},
#endif
#if	defined(_POSIX_TIMERS)
	{	clock_settime_sf,	NULL,	clock_settime_ef,	"clock_settime"	},
#endif
	{	close_sf,	NULL,	close_ef,	"close"	},
	{	closedir_sf,	NULL,	closedir_ef,	"closedir"	},
#if	( TEST_XPG > 4 )
	{	closelog_sf,	NULL,	closelog_ef,	"closelog"	},
#endif
#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)
	{	compile_sf,	NULL,	compile_ef,	"compile"	},
#endif
#endif
#if	( TEST_XPG > 4 )
	{	confstr_sf,	NULL,	confstr_ef,	"confstr"	},
#endif
	{	cos_sf,	cos_tf,	cos_ef,	"cos"	},
	{	cosh_sf,	cosh_tf,	cosh_ef,	"cosh"	},
	{	creat_sf,	NULL,	creat_ef,	"creat"	},
#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_CRYPT) && (_XOPEN_CRYPT != -1)
	{	crypt_sf,	NULL,	crypt_ef,	"crypt"	},
#endif
#endif
	{	ctermid_sf,	NULL,	ctermid_ef,	"ctermid"	},
	{	ctime_sf,	NULL,	ctime_ef,	"ctime"	},
#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)
	{	ctime_r_sf,	NULL,	ctime_r_ef,	"ctime_r"	},
#endif
#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)
	{	cuserid_sf,	NULL,	cuserid_ef,	"cuserid"	},
#endif
#endif
#if	( TEST_XPG > 4 )
	{	dbm_clearerr_sf,	NULL,	dbm_clearerr_ef,	"dbm_clearerr"	},
#endif
#if	( TEST_XPG > 4 )
	{	dbm_close_sf,	NULL,	dbm_close_ef,	"dbm_close"	},
#endif
#if	( TEST_XPG > 4 )
	{	dbm_delete_sf,	NULL,	dbm_delete_ef,	"dbm_delete"	},
#endif
#if	( TEST_XPG > 4 )
	{	dbm_error_sf,	NULL,	dbm_error_ef,	"dbm_error"	},
#endif
#if	( TEST_XPG > 4 )
	{	dbm_fetch_sf,	NULL,	dbm_fetch_ef,	"dbm_fetch"	},
#endif
#if	( TEST_XPG > 4 )
	{	dbm_firstkey_sf,	NULL,	dbm_firstkey_ef,	"dbm_firstkey"	},
#endif
#if	( TEST_XPG > 4 )
	{	dbm_nextkey_sf,	NULL,	dbm_nextkey_ef,	"dbm_nextkey"	},
#endif
#if	( TEST_XPG > 4 )
	{	dbm_open_sf,	NULL,	dbm_open_ef,	"dbm_open"	},
#endif
#if	( TEST_XPG > 4 )
	{	dbm_store_sf,	NULL,	dbm_store_ef,	"dbm_store"	},
#endif
	{	difftime_sf,	NULL,	difftime_ef,	"difftime"	},
#if	( TEST_XPG > 4 )
	{	dirname_sf,	NULL,	dirname_ef,	"dirname"	},
#endif
	{	div_sf,	NULL,	div_ef,	"div"	},
#if	( TEST_XPG > 4 )
	{	dlclose_sf,	NULL,	dlclose_ef,	"dlclose"	},
#endif
#if	( TEST_XPG > 4 )
	{	dlerror_sf,	NULL,	dlerror_ef,	"dlerror"	},
#endif
#if	( TEST_XPG > 4 )
	{	dlopen_sf,	NULL,	dlopen_ef,	"dlopen"	},
#endif
#if	( TEST_XPG > 4 )
	{	dlsym_sf,	NULL,	dlsym_ef,	"dlsym"	},
#endif
#if	( TEST_XPG > 4 )
	{	drand48_sf,	NULL,	drand48_ef,	"drand48"	},
#endif
	{	dup_sf,	NULL,	dup_ef,	"dup"	},
	{	dup2_sf,	NULL,	dup2_ef,	"dup2"	},
	{	NULL,	NULL,	NULL,	NULL	}
};

/* -------PARTITION THE TEST ---------------------------------------*/

VSTH_RT	Vsth_rt_e[] = {

#if	( TEST_XPG > 4 )
	{	ecvt_sf,	NULL,	ecvt_ef,	"ecvt"	},
#endif

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_CRYPT) && (_XOPEN_CRYPT != -1)
	{	encrypt_sf,	NULL,	encrypt_ef,	"encrypt"	},
#endif
#endif
#if	( TEST_XPG > 4 )
	{	endgrent_sf,	NULL,	endgrent_ef,	"endgrent"	},
#endif
#if	( TEST_XPG > 4 )
	{	endpwent_sf,	NULL,	endpwent_ef,	"endpwent"	},
#endif
#if	( TEST_XPG > 4 )
	{	endutxent_sf,	NULL,	endutxent_ef,	"endutxent"	},
#endif
#if	( TEST_XPG > 4 )
	{	erand48_sf,	erand48_tf,	erand48_ef,	"erand48"	},
#endif
#if	( TEST_XPG > 4 )
	{	erf_sf,	erf_tf,	erf_ef,	"erf"	},
#endif
#if	( TEST_XPG > 4 )
	{	erfc_sf,	erfc_tf,	erfc_ef,	"erfc"	},
#endif
	{	execl_sf,	NULL,	execl_ef,	"execl"	},
	{	execle_sf,	NULL,	execle_ef,	"execle"	},
	{	execlp_sf,	NULL,	execlp_ef,	"execlp"	},
	{	execv_sf,	NULL,	execv_ef,	"execv"	},
	{	execve_sf,	NULL,	execve_ef,	"execve"	},
	{	execvp_sf,	NULL,	execvp_ef,	"execvp"	},
	{	exit_sf,	NULL,	exit_ef,	"exit"	},
	{	exp_sf,	exp_tf,	exp_ef,	"exp"	},
#if	( TEST_XPG > 4 )
	{	expm1_sf,	expm1_tf,	expm1_ef,	"expm1"	},
#endif
	{	NULL,	NULL,	NULL,	NULL	}
};

/* -------PARTITION THE TEST ---------------------------------------*/

VSTH_RT	Vsth_rt_f[] = {

	{	fabs_sf,	fabs_tf,	fabs_ef,	"fabs"	},
#if	( TEST_XPG > 4 )
	{	fattach_sf,	NULL,	fattach_ef,	"fattach"	},
#endif
#if	( TEST_XPG > 4 )
	{	fchdir_sf,	NULL,	fchdir_ef,	"fchdir"	},
#endif
	{	fchmod_sf,	fchmod_tf,	fchmod_ef,	"fchmod"	},
#if	( TEST_XPG > 4 )
	{	fchown_sf,	fchown_tf,	fchown_ef,	"fchown"	},
#endif
	{	fclose_sf,	fclose_tf,	fclose_ef,	"fclose"	},
	{	fcntl_sf,	fcntl_tf,	fcntl_ef,	"fcntl"	},
#if	( TEST_XPG > 4 )
	{	fcvt_sf,	NULL,	fcvt_ef,	"fcvt"	},
#endif
#if	defined(_POSIX_SYNCHRONIZED_IO)
	{	fdatasync_sf,	NULL,	fdatasync_ef,	"fdatasync"	},
#endif
#if	( TEST_XPG > 4 )
	{	fdetach_sf,	NULL,	fdetach_ef,	"fdetach"	},
#endif
	{	fdopen_sf,	fdopen_tf,	fdopen_ef,	"fdopen"	},
	{	feof_sf,	feof_tf,	feof_ef,	"feof"	},
	{	ferror_sf,	ferror_tf,	ferror_ef,	"ferror"	},
	{	fflush_sf,	fflush_tf,	fflush_ef,	"fflush"	},
#if	( TEST_XPG > 4 )
	{	ffs_sf,	NULL,	ffs_ef,	"ffs"	},
#endif
	{	fgetc_sf,	fgetc_tf,	fgetc_ef,	"fgetc"	},
	{	fgetpos_sf,	fgetpos_tf,	fgetpos_ef,	"fgetpos"	},
	{	fgets_sf,	fgets_tf,	fgets_ef,	"fgets"	},

#if	( TEST_XPG > 4 )
	{	fgetwc_sf,	fgetwc_tf,	fgetwc_ef,	"fgetwc"	},
#endif
#if	( TEST_XPG > 4 )
	{	fgetws_sf,	fgetws_tf,	fgetws_ef,	"fgetws"	},
#endif
	{	fileno_sf,	fileno_tf,	fileno_ef,	"fileno"	},
#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)
	{	flockfile_sf,	flockfile_tf,	flockfile_ef,	"flockfile"	},
#endif
	{	floor_sf,	floor_tf,	floor_ef,	"floor"	},
	{	fmod_sf,	fmod_tf,	fmod_ef,	"fmod"	},
#if	( TEST_XPG > 4 )
	{	fmtmsg_sf,	NULL,	fmtmsg_ef,	"fmtmsg"	},
#endif
#if	( TEST_XPG > 4 )
	{	fnmatch_sf,	NULL,	fnmatch_ef,	"fnmatch"	},
#endif
	{	fopen_sf,	NULL,	fopen_ef,	"fopen"	},
	{	fork_sf,	NULL,	fork_ef,	"fork"	},
	{	fpathconf_sf,	NULL,	fpathconf_ef,	"fpathconf"	},
	{	fprintf_sf,	NULL,	fprintf_ef,	"fprintf"	},
	{	fputc_sf,	NULL,	fputc_ef,	"fputc"	},
	{	fputs_sf,	NULL,	fputs_ef,	"fputs"	},
#if	( TEST_XPG > 4 )
	{	fputwc_sf,	NULL,	fputwc_ef,	"fputwc"	},
#endif
#if	( TEST_XPG > 4 )
	{	fputws_sf,	NULL,	fputws_ef,	"fputws"	},
#endif
	{	fread_sf,	NULL,	fread_ef,	"fread"	},
	{	free_sf,	NULL,	free_ef,	"free"	},
	{	freopen_sf,	NULL,	freopen_ef,	"freopen"	},
	{	frexp_sf,	frexp_tf,	frexp_ef,	"frexp"	},
	{	fscanf_sf,	NULL,	fscanf_ef,	"fscanf"	},
	{	fseek_sf,	NULL,	fseek_ef,	"fseek"	},
	{	fsetpos_sf,	NULL,	fsetpos_ef,	"fsetpos"	},
	{	fstat_sf,	NULL,	fstat_ef,	"fstat"	},
#if	( TEST_XPG > 4 )
	{	fstatvfs_sf,	NULL,	fstatvfs_ef,	"fstatvfs"	},
#endif
#if	defined(_POSIX_FSYNC)
	{	fsync_sf,	NULL,	fsync_ef,	"fsync"	},
#endif
	{	ftell_sf,	NULL,	ftell_ef,	"ftell"	},
#if	( TEST_XPG > 4 )
	{	ftello_sf,	NULL,	ftello_ef,	"ftello"	},
#endif
#if	( TEST_XPG > 4 )
	{	ftime_sf,	NULL,	ftime_ef,	"ftime"	},
#endif
#if	( TEST_XPG > 4 )
	{	ftok_sf,	NULL,	ftok_ef,	"ftok"	},
#endif
	{	ftruncate_sf,	NULL,	ftruncate_ef,	"ftruncate"	},
#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)
	{	ftrylockfile_sf,	NULL,	ftrylockfile_ef,	"ftrylockfile"	},
#endif
#if	( TEST_XPG > 4 )
	{	ftw_sf,	NULL,	ftw_ef,	"ftw"	},
#endif
#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)
	{	funlockfile_sf,	NULL,	funlockfile_ef,	"funlockfile"	},
#endif
#if	( TEST_XPG > 4 )
	{	fwide_sf,	NULL,	fwide_ef,	"fwide"	},
#endif
#if	( TEST_XPG > 4 )
	{	fwprintf_sf,	NULL,	fwprintf_ef,	"fwprintf"	},
#endif
	{	fwrite_sf,	NULL,	fwrite_ef,	"fwrite"	},
#if	( TEST_XPG > 4 )
	{	fwscanf_sf,	NULL,	fwscanf_ef,	"fwscanf"	},
#endif
	{	NULL,	NULL,	NULL,	NULL	}
};

/* -------PARTITION THE TEST ---------------------------------------*/

VSTH_RT	Vsth_rt_g_to_h[] = {

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)
	{	gamma_sf,	NULL,	gamma_ef,	"gamma"	},
#endif
#endif
#if	( TEST_XPG > 4 )
	{	gcvt_sf,	NULL,	gcvt_ef,	"gcvt"	},
#endif
	{	getc_sf,	NULL,	getc_ef,	"getc"	},
	{	getc_unlocked_sf,	NULL,	getc_unlocked_ef,	"getc_unlocked"	},
	{	getchar_sf,	NULL,	getchar_ef,	"getchar"	},
	{	getchar_unlocked_sf,	NULL,	getchar_unlocked_ef,	"getchar_unlocked"	},
#if	( TEST_XPG > 4 )
	{	getcontext_sf,	NULL,	getcontext_ef,	"getcontext"	},
#endif
	{	getcwd_sf,	NULL,	getcwd_ef,	"getcwd"	},
#if	( TEST_XPG > 4 )
	{	getdate_sf,	NULL,	getdate_ef,	"getdate"	},
#endif
#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)
	{	getdtablesize_sf,	NULL,	getdtablesize_ef,	"getdtablesize"	},
#endif
#endif
	{	getegid_sf,	NULL,	getegid_ef,	"getegid"	},
	{	getenv_sf,	NULL,	getenv_ef,	"getenv"	},
	{	geteuid_sf,	NULL,	geteuid_ef,	"geteuid"	},
	{	getgid_sf,	NULL,	getgid_ef,	"getgid"	},
#if	( TEST_XPG > 4 )
	{	getgrent_sf,	NULL,	getgrent_ef,	"getgrent"	},
#endif
	{	getgrgid_sf,	NULL,	getgrgid_ef,	"getgrgid"	},
#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)
	{	getgrgid_r_sf,	NULL,	getgrgid_r_ef,	"getgrgid_r"	},
#endif
	{	getgrnam_sf,	NULL,	getgrnam_ef,	"getgrnam"	},
#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)
	{	getgrnam_r_sf,	NULL,	getgrnam_r_ef,	"getgrnam_r"	},
#endif
	{	getgroups_sf,	NULL,	getgroups_ef,	"getgroups"	},
#if	( TEST_XPG > 4 )
	{	gethostid_sf,	NULL,	gethostid_ef,	"gethostid"	},
#endif
#if	( TEST_XPG > 4 )
	{	getitimer_sf,	NULL,	getitimer_ef,	"getitimer"	},
#endif
	{	getlogin_sf,	NULL,	getlogin_ef,	"getlogin"	},
#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)
	{	getlogin_r_sf,	NULL,	getlogin_r_ef,	"getlogin_r"	},
#endif
#if	( TEST_XPG > 4 )
	{	getmsg_sf,	NULL,	getmsg_ef,	"getmsg"	},
#endif
#if	( TEST_XPG > 4 )
	{	getopt_sf,	NULL,	getopt_ef,	"getopt"	},
#endif
#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)
	{	getpagesize_sf,	NULL,	getpagesize_ef,	"getpagesize"	},
#endif
#endif
#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)
	{	getpass_sf,	NULL,	getpass_ef,	"getpass"	},
#endif
#endif
#if	( TEST_XPG > 4 )
	{	getpgid_sf,	NULL,	getpgid_ef,	"getpgid"	},
#endif
	{	getpgrp_sf,	NULL,	getpgrp_ef,	"getpgrp"	},
	{	getpid_sf,	NULL,	getpid_ef,	"getpid"	},
#if	( TEST_XPG > 4 )
	{	getpmsg_sf,	NULL,	getpmsg_ef,	"getpmsg"	},
#endif
	{	getppid_sf,	NULL,	getppid_ef,	"getppid"	},
#if	( TEST_XPG > 4 )
	{	getpriority_sf,	NULL,	getpriority_ef,	"getpriority"	},
#endif
#if	( TEST_XPG > 4 )
	{	getpwent_sf,	NULL,	getpwent_ef,	"getpwent"	},
#endif
	{	getpwnam_sf,	NULL,	getpwnam_ef,	"getpwnam"	},
#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)
	{	getpwnam_r_sf,	NULL,	getpwnam_r_ef,	"getpwnam_r"	},
#endif
	{	getpwuid_sf,	NULL,	getpwuid_ef,	"getpwuid"	},
#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)
	{	getpwuid_r_sf,	NULL,	getpwuid_r_ef,	"getpwuid_r"	},
#endif
#if	( TEST_XPG > 4 )
	{	getrlimit_sf,	NULL,	getrlimit_ef,	"getrlimit"	},
#endif
#if	( TEST_XPG > 4 )
	{	getrusage_sf,	NULL,	getrusage_ef,	"getrusage"	},
#endif
	{	gets_sf,	NULL,	gets_ef,	"gets"	},
#if	( TEST_XPG > 4 )
	{	getsid_sf,	NULL,	getsid_ef,	"getsid"	},
#endif
#if	( TEST_XPG > 4 )
	{	getsubopt_sf,	NULL,	getsubopt_ef,	"getsubopt"	},
#endif
#if	( TEST_XPG > 4 )
	{	gettimeofday_sf,	NULL,	gettimeofday_ef,	"gettimeofday"	},
#endif
	{	getuid_sf,	NULL,	getuid_ef,	"getuid"	},
#if	( TEST_XPG > 4 )
	{	getutxent_sf,	NULL,	getutxent_ef,	"getutxent"	},
#endif
#if	( TEST_XPG > 4 )
	{	getutxid_sf,	NULL,	getutxid_ef,	"getutxid"	},
#endif
#if	( TEST_XPG > 4 )
	{	getutxline_sf,	NULL,	getutxline_ef,	"getutxline"	},
#endif
#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)
	{	getw_sf,	NULL,	getw_ef,	"getw"	},
#endif
#endif
#if	( TEST_XPG > 4 )
	{	getwc_sf,	NULL,	getwc_ef,	"getwc"	},
#endif
#if	( TEST_XPG > 4 )
	{	getwchar_sf,	NULL,	getwchar_ef,	"getwchar"	},
#endif
#if	( TEST_XPG > 4 )
	{	getwd_sf,	NULL,	getwd_ef,	"getwd"	},
#endif
#if	( TEST_XPG > 4 )
	{	glob_sf,	NULL,	glob_ef,	"glob"	},
#endif
	{	gmtime_sf,	NULL,	gmtime_ef,	"gmtime"	},
#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)
	{	gmtime_r_sf,	NULL,	gmtime_r_ef,	"gmtime_r"	},
#endif
#if	( TEST_XPG > 4 )
	{	grantpt_sf,	NULL,	grantpt_ef,	"grantpt"	},
#endif
#if	( TEST_XPG > 4 )
	{	hcreate_sf,	NULL,	hcreate_ef,	"hcreate"	},
#endif
#if	( TEST_XPG > 4 )
	{	hdestroy_sf,	NULL,	hdestroy_ef,	"hdestroy"	},
#endif
#if	( TEST_XPG > 4 )
	{	hsearch_sf,	NULL,	hsearch_ef,	"hsearch"	},
#endif
#if	( TEST_XPG > 4 )
	{	hypot_sf,	hypot_tf,	hypot_ef,	"hypot"	},
#endif
	{	NULL,	NULL,	NULL,	NULL	}
};

/* -------PARTITION THE TEST ---------------------------------------*/

VSTH_RT	Vsth_rt_i_to_n[] = {

#if	( TEST_XPG > 4 )
	{	iconv_sf,	NULL,	iconv_ef,	"iconv"	},
#endif
#if	( TEST_XPG > 4 )
	{	iconv_close_sf,	NULL,	iconv_close_ef,	"iconv_close"	},
#endif
#if	( TEST_XPG > 4 )
	{	iconv_open_sf,	NULL,	iconv_open_ef,	"iconv_open"	},
#endif
#if	( TEST_XPG > 4 )
	{	ilogb_sf,	ilogb_tf,	ilogb_ef,	"ilogb"	},
#endif
#if	( TEST_XPG > 4 )
	{	index_sf,	NULL,	index_ef,	"index"	},
#endif
#if	( TEST_XPG > 4 )
	{	initstate_sf,	NULL,	initstate_ef,	"initstate"	},
#endif
#if	( TEST_XPG > 4 )
	{	insque_sf,	NULL,	insque_ef,	"insque"	},
#endif
#if	( TEST_XPG > 4 )
	{	ioctl_sf,	NULL,	ioctl_ef,	"ioctl"	},
#endif
	{	isalnum_sf,	isalnum_tf,	isalnum_ef,	"isalnum"	},
	{	isalpha_sf,	isalpha_tf,	isalpha_ef,	"isalpha"	},
	{	isascii_sf,	isascii_tf,	isascii_ef,	"isascii"	},
#if	( TEST_XPG > 4 )
	{	isastream_sf,	NULL,	isastream_ef,	"isastream"	},
#endif
	{	isatty_sf,	isatty_tf,	isatty_ef,	"isatty"	},
	{	iscntrl_sf,	iscntrl_tf,	iscntrl_ef,	"iscntrl"	},
	{	isdigit_sf,	isdigit_tf,	isdigit_ef,	"isdigit"	},
	{	isgraph_sf,	isgraph_tf,	isgraph_ef,	"isgraph"	},
	{	islower_sf,	islower_tf,	islower_ef,	"islower"	},
#if	( TEST_XPG > 4 )
	{	isnan_sf,	isnan_tf,	isnan_ef,	"isnan"	},
#endif
	{	isprint_sf,	isprint_tf,	isprint_ef,	"isprint"	},
	{	ispunct_sf,	ispunct_tf,	ispunct_ef,	"ispunct"	},
	{	isspace_sf,	isspace_tf,	isspace_ef,	"isspace"	},
	{	isupper_sf,	isupper_tf,	isupper_ef,	"isupper"	},
#if	( TEST_XPG > 4 )
	{	iswalnum_sf,	iswalnum_tf,	iswalnum_ef,	"iswalnum"	},
#endif
#if	( TEST_XPG > 4 )
	{	iswalpha_sf,	iswalpha_tf,	iswalpha_ef,	"iswalpha"	},
#endif
#if	( TEST_XPG > 4 )
	{	iswcntrl_sf,	iswcntrl_tf,	iswcntrl_ef,	"iswcntrl"	},
#endif
#if	( TEST_XPG > 4 )
	{	iswdigit_sf,	iswdigit_tf,	iswdigit_ef,	"iswdigit"	},
#endif
#if	( TEST_XPG > 4 )
	{	iswgraph_sf,	iswgraph_tf,	iswgraph_ef,	"iswgraph"	},
#endif
#if	( TEST_XPG > 4 )
	{	iswlower_sf,	iswlower_tf,	iswlower_ef,	"iswlower"	},
#endif
#if	( TEST_XPG > 4 )
	{	iswprint_sf,	iswprint_tf,	iswprint_ef,	"iswprint"	},
#endif
#if	( TEST_XPG > 4 )
	{	iswpunct_sf,	iswpunct_tf,	iswpunct_ef,	"iswpunct"	},
#endif
#if	( TEST_XPG > 4 )
	{	iswspace_sf,	iswspace_tf,	iswspace_ef,	"iswspace"	},
#endif
#if	( TEST_XPG > 4 )
	{	iswupper_sf,	iswupper_tf,	iswupper_ef,	"iswupper"	},
#endif
#if	( TEST_XPG > 4 )
	{	iswctype_sf,	iswctype_tf,	iswctype_ef,	"iswctype"	},
#endif
#if	( TEST_XPG > 4 )
	{	iswxdigit_sf,	iswxdigit_tf,	iswxdigit_ef,	"iswxdigit"	},
#endif
#if	( TEST_XPG > 4 )
	{	j0_sf,	j0_tf,	j0_ef,	"j0"	},
#endif
#if	( TEST_XPG > 4 )
	{	j1_sf,	j1_tf,	j1_ef,	"j1"	},
#endif
#if	( TEST_XPG > 4 )
	{	jn_sf,	jn_tf,	jn_ef,	"jn"	},
#endif
#if	( TEST_XPG > 4 )
	{	jrand48_sf,	jrand48_tf,	jrand48_ef,	"jrand48"	},
#endif
	{	kill_sf,	NULL,	kill_ef,	"kill"	},
#if	( TEST_XPG > 4 )
	{	killpg_sf,	NULL,	killpg_ef,	"killpg"	},
#endif
#if	( TEST_XPG > 4 )
	{	l64a_sf,	NULL,	l64a_ef,	"l64a"	},
#endif
	{	labs_sf,	NULL,	labs_ef,	"labs"	},
#if	( TEST_XPG > 4 )
	{	lchown_sf,	NULL,	lchown_ef,	"lchown"	},
#endif
#if	( TEST_XPG > 4 )
	{	lcong48_sf,	NULL,	lcong48_ef,	"lcong48"	},
#endif
	{	ldexp_sf,	ldexp_tf,	ldexp_ef,	"ldexp"	},
	{	ldiv_sf,	ldiv_tf,	ldiv_ef,	"ldiv"	},
#if	( TEST_XPG > 4 )
	{	lfind_sf,	NULL,	lfind_ef,	"lfind"	},
#endif
#if	( TEST_XPG > 4 )
	{	lgamma_sf,	NULL,	lgamma_ef,	"lgamma"	},
#endif
	{	link_sf,	NULL,	link_ef,	"link"	},
#if	defined(_POSIX_ASYNCHRONOUS_IO)
	{	lio_listio_sf,	NULL,	lio_listio_ef,	"lio_listio"	},
#endif
#if	( TEST_XPG > 4 )
	{	localconv_sf,	NULL,	localconv_ef,	"localconv"	},
#endif
	{	localtime_sf,	NULL,	localtime_ef,	"localtime"	},
#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)
	{	localtime_r_sf,	NULL,	localtime_r_ef,	"localtime_r"	},
#endif
#if	( TEST_XPG > 4 )
	{	lockf_sf,	NULL,	lockf_ef,	"lockf"	},
#endif
	{	log_sf,	log_tf,	log_ef,	"log"	},
	{	log10_sf,	log10_tf,	log10_ef,	"log10"	},
#if	( TEST_XPG > 4 )
	{	log1p_sf,	log1p_tf,	log1p_ef,	"log1p"	},
#endif
#if	( TEST_XPG > 4 )
	{	logb_sf,	logb_tf,	logb_ef,	"logb"	},
#endif
	{	longjmp_sf,	NULL,	longjmp_ef,	"longjmp"	},
#if	( TEST_XPG > 4 )
	{	lrand48_sf,	NULL,	lrand48_ef,	"lrand48"	},
#endif
#if	( TEST_XPG > 4 )
	{	lsearch_sf,	NULL,	lsearch_ef,	"lsearch"	},
#endif
	{	lseek_sf,	NULL,	lseek_ef,	"lseek"	},
#if	( TEST_XPG > 4 )
	{	lstat_sf,	NULL,	lstat_ef,	"lstat"	},
#endif
#if	( TEST_XPG > 4 )
	{	makecontext_sf,	NULL,	makecontext_ef,	"makecontext"	},
#endif
	{	malloc_sf,	NULL,	malloc_ef,	"malloc"	},
	{	mblen_sf,	NULL,	mblen_ef,	"mblen"	},
#if	( TEST_XPG > 4 )
	{	mbrlen_sf,	NULL,	mbrlen_ef,	"mbrlen"	},
#endif
#if	( TEST_XPG > 4 )
	{	mbrtowc_sf,	NULL,	mbrtowc_ef,	"mbrtowc"	},
#endif
#if	( TEST_XPG > 4 )
	{	mbsinit_sf,	NULL,	mbsinit_ef,	"mbsinit"	},
#endif
#if	( TEST_XPG > 4 )
	{	mbsrtowcs_sf,	NULL,	mbsrtowcs_ef,	"mbsrtowcs"	},
#endif
#if	( TEST_XPG > 4 )
	{	mbstowcs_sf,	NULL,	mbstowcs_ef,	"mbstowcs"	},
#endif
	{	mbtowc_sf,	NULL,	mbtowc_ef,	"mbtowc"	},
#if	( TEST_XPG > 4 )
	{	memccpy_sf,	NULL,	memccpy_ef,	"memccpy"	},
#endif
	{	memchr_sf,	NULL,	memchr_ef,	"memchr"	},
	{	memcmp_sf,	NULL,	memcmp_ef,	"memcmp"	},
	{	memcpy_sf,	NULL,	memcpy_ef,	"memcpy"	},
	{	memmove_sf,	NULL,	memmove_ef,	"memmove"	},
	{	memset_sf,	NULL,	memset_ef,	"memset"	},
	{	mkdir_sf,	NULL,	mkdir_ef,	"mkdir"	},
	{	mkfifo_sf,	NULL,	mkfifo_ef,	"mkfifo"	},
#if	( TEST_XPG > 4 )
	{	mknod_sf,	NULL,	mknod_ef,	"mknod"	},
#endif
#if	( TEST_XPG > 4 )
	{	mkstemp_sf,	NULL,	mkstemp_ef,	"mkstemp"	},
#endif
#if	( TEST_XPG > 4 )
	{	mktemp_sf,	NULL,	mktemp_ef,	"mktemp"	},
#endif
	{	mktime_sf,	NULL,	mktime_ef,	"mktime"	},
#if	defined(_POSIX_MEMLOCK_RANGE)
	{	mlock_sf,	NULL,	mlock_ef,	"mlock"	},
#endif
#if	defined(_POSIX_MEMLOCK)
	{	mlockall_sf,	NULL,	mlockall_ef,	"mlockall"	},
#endif
#if	defined(_POSIX_MAPPED_FILES) || defined(_POSIX_SHARED_MEMORY_OBJECTS)
	{	mmap_sf,	NULL,	mmap_ef,	"mmap"	},
#endif
	{	modf_sf,	modf_tf,	modf_ef,	"modf"	},
#if	defined(_POSIX_MEMORY_PROTECTION)
	{	mprotect_sf,	NULL,	mprotect_ef,	"mprotect"	},
#endif
#if	defined(_POSIX_MESSAGE_PASSING)
	{	mq_close_sf,	NULL,	mq_close_ef,	"mq_close"	},
#endif
#if	defined(_POSIX_MESSAGE_PASSING)
	{	mq_getattr_sf,	NULL,	mq_getattr_ef,	"mq_getattr"	},
#endif
#if	defined(_POSIX_MESSAGE_PASSING) && defined(_POSIX_REALTIME_SIGNALS)
	{	mq_notify_sf,	NULL,	mq_notify_ef,	"mq_notify"	},
#endif
#if	defined(_POSIX_MESSAGE_PASSING)
	{	mq_open_sf,	NULL,	mq_open_ef,	"mq_open"	},
#endif
#if	defined(_POSIX_MESSAGE_PASSING)
	{	mq_receive_sf,	NULL,	mq_receive_ef,	"mq_receive"	},
#endif
#if	defined(_POSIX_MESSAGE_PASSING)
	{	mq_send_sf,	NULL,	mq_send_ef,	"mq_send"	},
#endif
#if	defined(_POSIX_MESSAGE_PASSING)
	{	mq_setattr_sf,	NULL,	mq_setattr_ef,	"mq_setattr"	},
#endif
#if	defined(_POSIX_MESSAGE_PASSING)
	{	mq_unlink_sf,	NULL,	mq_unlink_ef,	"mq_unlink"	},
#endif
#if	( TEST_XPG > 4 )
	{	mrand48_sf,	NULL,	mrand48_ef,	"mrand48"	},
#endif
#if	( TEST_XPG > 4 )
	{	msgctl_sf,	NULL,	msgctl_ef,	"msgctl"	},
#endif
#if	( TEST_XPG > 4 )
	{	msgget_sf,	NULL,	msgget_ef,	"msgget"	},
#endif
#if	( TEST_XPG > 4 )
	{	msgrcv_sf,	NULL,	msgrcv_ef,	"msgrcv"	},
#endif
#if	( TEST_XPG > 4 )
	{	msgsnd_sf,	NULL,	msgsnd_ef,	"msgsnd"	},
#endif
#if	defined(_POSIX_MAPPED_FILES) && defined(_POSIX_SYNCHRONIZED_IO)
	{	msync_sf,	NULL,	msync_ef,	"msync"	},
#endif
#if	defined(_POSIX_MEMLOCK_RANGE)
	{	munlock_sf,	NULL,	munlock_ef,	"munlock"	},
#endif
#if	defined(_POSIX_MEMLOCK)
	{	munlockall_sf,	NULL,	munlockall_ef,	"munlockall"	},
#endif
#if	defined(_POSIX_MAPPED_FILES) || defined(_POSIX_SHARED_MEMORY_OBJECTS)
	{	munmap_sf,	NULL,	munmap_ef,	"munmap"	},
#endif
#if	defined(_POSIX_TIMERS)
	{	nanosleep_sf,	NULL,	nanosleep_ef,	"nanosleep"	},
#endif
#if	( TEST_XPG > 4 )
	{	nextafter_sf,	nextafter_tf,	nextafter_ef,	"nextafter"	},
#endif
#if	( TEST_XPG > 4 )
	{	nftw_sf,	NULL,	nftw_ef,	"nftw"	},
#endif
#if	( TEST_XPG > 4 )
	{	nice_sf,	NULL,	nice_ef,	"nice"	},
#endif
#if	( TEST_XPG > 4 )
	{	nl_langinfo_sf,	NULL,	nl_langinfo_ef,	"nl_langinfo"	},
#endif
#if	( TEST_XPG > 4 )
	{	nrand48_sf,	nrand48_tf,	nrand48_ef,	"nrand48"	},
#endif
	{	NULL,	NULL,	NULL,	NULL	}
};

/* -------PARTITION THE TEST ---------------------------------------*/

VSTH_RT	Vsth_rt_o_to_p[] = {

	{	open_sf,	NULL,	open_ef,	"open"	},
	{	opendir_sf,	NULL,	opendir_ef,	"opendir"	},
#if	( TEST_XPG > 4 )
	{	openlog_sf,	NULL,	openlog_ef,	"openlog"	},
#endif
	{	pathconf_sf,	NULL,	pathconf_ef,	"pathconf"	},
	{	pause_sf,	NULL,	pause_ef,	"pause"	},
#if	( TEST_XPG > 4 )
	{	pclose_sf,	NULL,	pclose_ef,	"pclose"	},
#endif
	{	perror_sf,	NULL,	perror_ef,	"perror"	},
	{	pipe_sf,	NULL,	pipe_ef,	"pipe"	},
#if	( TEST_XPG > 4 )
	{	poll_sf,	NULL,	poll_ef,	"poll"	},
#endif
#if	( TEST_XPG > 4 )
	{	popen_sf,	NULL,	popen_ef,	"popen"	},
#endif
	{	pow_sf,	pow_tf,	pow_ef,	"pow"	},
#if	( TEST_XPG > 4 )
	{	pread_sf,	NULL,	pread_ef,	"pread"	},
#endif
	{	printf_sf,	NULL,	printf_ef,	"printf"	},
#if	defined(_POSIX_THREADS)
	{	pthread_atfork_sf,	NULL,	pthread_atfork_ef,	"pthread_atfork"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_attr_destroy_sf,	NULL,	pthread_attr_destroy_ef,	"pthread_attr_destroy"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_attr_getdetachstate_sf,	NULL,	pthread_attr_getdetachstate_ef,	"pthread_attr_getdetachstate"	},
#endif
#if	( TEST_XPG > 4 )
	{	pthread_attr_getguardsize_sf,	NULL,	pthread_attr_getguardsize_ef,	"pthread_attr_getguardsize"	},
#endif
#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PRIORITY_SCHEDULING)
	{	pthread_attr_getinheritsched_sf,	NULL,	pthread_attr_getinheritsched_ef,	"pthread_attr_getinheritsched"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_attr_getschedparam_sf,	NULL,	pthread_attr_getschedparam_ef,	"pthread_attr_getschedparam"	},
#endif
#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PRIORITY_SCHEDULING)
	{	pthread_attr_getschedpolicy_sf,	NULL,	pthread_attr_getschedpolicy_ef,	"pthread_attr_getschedpolicy"	},
#endif
#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PRIORITY_SCHEDULING)
	{	pthread_attr_getscope_sf,	NULL,	pthread_attr_getscope_ef,	"pthread_attr_getscope"	},
#endif
#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_ATTR_STACKADDR)
	{	pthread_attr_getstackaddr_sf,	NULL,	pthread_attr_getstackaddr_ef,	"pthread_attr_getstackaddr"	},
#endif
#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_ATTR_STACKSIZE)
	{	pthread_attr_getstacksize_sf,	NULL,	pthread_attr_getstacksize_ef,	"pthread_attr_getstacksize"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_attr_init_sf,	NULL,	pthread_attr_init_ef,	"pthread_attr_init"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_attr_setdetachstate_sf,	NULL,	pthread_attr_setdetachstate_ef,	"pthread_attr_setdetachstate"	},
#endif
#if	( TEST_XPG > 4 )
	{	pthread_attr_setguardsize_sf,	NULL,	pthread_attr_setguardsize_ef,	"pthread_attr_setguardsize"	},
#endif
#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PRIORITY_SCHEDULING)
	{	pthread_attr_setinheritsched_sf,	NULL,	pthread_attr_setinheritsched_ef,	"pthread_attr_setinheritsched"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_attr_setschedparam_sf,	NULL,	pthread_attr_setschedparam_ef,	"pthread_attr_setschedparam"	},
#endif
#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PRIORITY_SCHEDULING)
	{	pthread_attr_setschedpolicy_sf,	NULL,	pthread_attr_setschedpolicy_ef,	"pthread_attr_setschedpolicy"	},
#endif
#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PRIORITY_SCHEDULING)
	{	pthread_attr_setscope_sf,	NULL,	pthread_attr_setscope_ef,	"pthread_attr_setscope"	},
#endif
#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_ATTR_STACKADDR)
	{	pthread_attr_setstackaddr_sf,	NULL,	pthread_attr_setstackaddr_ef,	"pthread_attr_setstackaddr"	},
#endif
#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_ATTR_STACKSIZE)
	{	pthread_attr_setstacksize_sf,	NULL,	pthread_attr_setstacksize_ef,	"pthread_attr_setstacksize"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_cancel_sf,	NULL,	pthread_cancel_ef,	"pthread_cancel"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_cleanup_pop_sf,	NULL,	pthread_cleanup_pop_ef,	"pthread_cleanup_pop"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_cleanup_push_sf,	NULL,	pthread_cleanup_push_ef,	"pthread_cleanup_push"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_cond_broadcast_sf,	NULL,	pthread_cond_broadcast_ef,	"pthread_cond_broadcast"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_cond_destroy_sf,	NULL,	pthread_cond_destroy_ef,	"pthread_cond_destroy"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_cond_init_sf,	NULL,	pthread_cond_init_ef,	"pthread_cond_init"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_cond_signal_sf,	NULL,	pthread_cond_signal_ef,	"pthread_cond_signal"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_cond_timedwait_sf,	NULL,	pthread_cond_timedwait_ef,	"pthread_cond_timedwait"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_cond_wait_sf,	NULL,	pthread_cond_wait_ef,	"pthread_cond_wait"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_condattr_destroy_sf,	NULL,	pthread_condattr_destroy_ef,	"pthread_condattr_destroy"	},
#endif
#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PROCESS_SHARED)
	{	pthread_condattr_getpshared_sf,	NULL,	pthread_condattr_getpshared_ef,	"pthread_condattr_getpshared"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_condattr_init_sf,	NULL,	pthread_condattr_init_ef,	"pthread_condattr_init"	},
#endif
#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PROCESS_SHARED)
	{	pthread_condattr_setpshared_sf,	NULL,	pthread_condattr_setpshared_ef,	"pthread_condattr_setpshared"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_create_sf,	NULL,	pthread_create_ef,	"pthread_create"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_detach_sf,	NULL,	pthread_detach_ef,	"pthread_detach"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_equal_sf,	NULL,	pthread_equal_ef,	"pthread_equal"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_exit_sf,	NULL,	pthread_exit_ef,	"pthread_exit"	},
#endif
#if	( TEST_XPG > 4 )
	{	pthread_getconcurrency_sf,	NULL,	pthread_getconcurrency_ef,	"pthread_getconcurrency"	},
#endif
#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PRIORITY_SCHEDULING)
	{	pthread_getschedparam_sf,	NULL,	pthread_getschedparam_ef,	"pthread_getschedparam"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_getspecific_sf,	NULL,	pthread_getspecific_ef,	"pthread_getspecific"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_join_sf,	NULL,	pthread_join_ef,	"pthread_join"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_key_create_sf,	NULL,	pthread_key_create_ef,	"pthread_key_create"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_key_delete_sf,	NULL,	pthread_key_delete_ef,	"pthread_key_delete"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_kill_sf,	NULL,	pthread_kill_ef,	"pthread_kill"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_mutex_destroy_sf,	NULL,	pthread_mutex_destroy_ef,	"pthread_mutex_destroy"	},
#endif
#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PRIO_PROTECT)
	{	pthread_mutex_getprioceiling_sf,	NULL,	pthread_mutex_getprioceiling_ef,	"pthread_mutex_getprioceiling"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_mutex_init_sf,	NULL,	pthread_mutex_init_ef,	"pthread_mutex_init"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_mutex_lock_sf,	NULL,	pthread_mutex_lock_ef,	"pthread_mutex_lock"	},
#endif
#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PRIO_PROTECT)
	{	pthread_mutex_setprioceiling_sf,	NULL,	pthread_mutex_setprioceiling_ef,	"pthread_mutex_setprioceiling"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_mutex_trylock_sf,	NULL,	pthread_mutex_trylock_ef,	"pthread_mutex_trylock"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_mutex_unlock_sf,	NULL,	pthread_mutex_unlock_ef,	"pthread_mutex_unlock"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_mutexattr_destroy_sf,	NULL,	pthread_mutexattr_destroy_ef,	"pthread_mutexattr_destroy"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_mutexattr_getprioceiling_sf,	NULL,	pthread_mutexattr_getprioceiling_ef,	"pthread_mutexattr_getprioceiling"	},
#endif
#if	defined(_POSIX_THREADS) && (defined(_POSIX_THREAD_PRIO_INHERIT) || defined(_POSIX_THREAD_PRIO_PROTECT))
	{	pthread_mutexattr_getprotocol_sf,	NULL,	pthread_mutexattr_getprotocol_ef,	"pthread_mutexattr_getprotocol"	},
#endif
#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PROCESS_SHARED)
	{	pthread_mutexattr_getpshared_sf,	NULL,	pthread_mutexattr_getpshared_ef,	"pthread_mutexattr_getpshared"	},
#endif
#if	( TEST_XPG > 4 )
	{	pthread_mutexattr_gettype_sf,	NULL,	pthread_mutexattr_gettype_ef,	"pthread_mutexattr_gettype"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_mutexattr_init_sf,	NULL,	pthread_mutexattr_init_ef,	"pthread_mutexattr_init"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_mutexattr_setprioceiling_sf,	NULL,	pthread_mutexattr_setprioceiling_ef,	"pthread_mutexattr_setprioceiling"	},
#endif
#if	defined(_POSIX_THREADS) && (defined(_POSIX_THREAD_PRIO_INHERIT) || defined(_POSIX_THREAD_PRIO_PROTECT))
	{	pthread_mutexattr_setprotocol_sf,	NULL,	pthread_mutexattr_setprotocol_ef,	"pthread_mutexattr_setprotocol"	},
#endif
#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PROCESS_SHARED)
	{	pthread_mutexattr_setpshared_sf,	NULL,	pthread_mutexattr_setpshared_ef,	"pthread_mutexattr_setpshared"	},
#endif
#if	( TEST_XPG > 4 )
	{	pthread_mutexattr_settype_sf,	NULL,	pthread_mutexattr_settype_ef,	"pthread_mutexattr_settype"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_once_sf,	NULL,	pthread_once_ef,	"pthread_once"	},
#endif
#if	( TEST_XPG > 4 )
	{	pthread_rwlock_destroy_sf,	NULL,	pthread_rwlock_destroy_ef,	"pthread_rwlock_destroy"	},
#endif
#if	( TEST_XPG > 4 )
	{	pthread_rwlock_init_sf,	NULL,	pthread_rwlock_init_ef,	"pthread_rwlock_init"	},
#endif
#if	( TEST_XPG > 4 )
	{	pthread_rwlock_rdlock_sf,	NULL,	pthread_rwlock_rdlock_ef,	"pthread_rwlock_rdlock"	},
#endif
#if	( TEST_XPG > 4 )
	{	pthread_rwlock_tryrdlock_sf,	NULL,	pthread_rwlock_tryrdlock_ef,	"pthread_rwlock_tryrdlock"	},
#endif
#if	( TEST_XPG > 4 )
	{	pthread_rwlock_trywrlock_sf,	NULL,	pthread_rwlock_trywrlock_ef,	"pthread_rwlock_trywrlock"	},
#endif
#if	( TEST_XPG > 4 )
	{	pthread_rwlock_unlock_sf,	NULL,	pthread_rwlock_unlock_ef,	"pthread_rwlock_unlock"	},
#endif
#if	( TEST_XPG > 4 )
	{	pthread_rwlock_wrlock_sf,	NULL,	pthread_rwlock_wrlock_ef,	"pthread_rwlock_wrlock"	},
#endif
#if	( TEST_XPG > 4 )
	{	pthread_rwlockattr_destroy_sf,	NULL,	pthread_rwlockattr_destroy_ef,	"pthread_rwlockattr_destroy"	},
#endif
#if	( TEST_XPG > 4 )
	{	pthread_rwlockattr_getpshared_sf,	NULL,	pthread_rwlockattr_getpshared_ef,	"pthread_rwlockattr_getpshared"	},
#endif
#if	( TEST_XPG > 4 )
	{	pthread_rwlockattr_init_sf,	NULL,	pthread_rwlockattr_init_ef,	"pthread_rwlockattr_init"	},
#endif
#if	( TEST_XPG > 4 )
	{	pthread_rwlockattr_setpshared_sf,	NULL,	pthread_rwlockattr_setpshared_ef,	"pthread_rwlockattr_setpshared"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_self_sf,	NULL,	pthread_self_ef,	"pthread_self"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_setcancelstate_sf,	NULL,	pthread_setcancelstate_ef,	"pthread_setcancelstate"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_setcanceltype_sf,	NULL,	pthread_setcanceltype_ef,	"pthread_setcanceltype"	},
#endif
#if	( TEST_XPG > 4 )
	{	pthread_setconcurrency_sf,	NULL,	pthread_setconcurrency_ef,	"pthread_setconcurrency"	},
#endif
#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PRIORITY_SCHEDULING)
	{	pthread_setschedparam_sf,	NULL,	pthread_setschedparam_ef,	"pthread_setschedparam"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_setspecific_sf,	NULL,	pthread_setspecific_ef,	"pthread_setspecific"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_sigmask_sf,	NULL,	pthread_sigmask_ef,	"pthread_sigmask"	},
#endif
#if	defined(_POSIX_THREADS)
	{	pthread_testcancel_sf,	NULL,	pthread_testcancel_ef,	"pthread_testcancel"	},
#endif
#if	( TEST_XPG > 4 )
	{	ptsname_sf,	NULL,	ptsname_ef,	"ptsname"	},
#endif
	{	putc_sf,	NULL,	putc_ef,	"putc"	},
	{	putc_unlocked_sf,	NULL,	putc_unlocked_ef,	"putc_unlocked"	},
	{	putchar_sf,	NULL,	putchar_ef,	"putchar"	},
	{	putchar_unlocked_sf,	NULL,	putchar_unlocked_ef,	"putchar_unlocked"	},
#if	( TEST_XPG > 4 )
	{	putenv_sf,	NULL,	putenv_ef,	"putenv"	},
#endif
#if	( TEST_XPG > 4 )
	{	putmsg_sf,	NULL,	putmsg_ef,	"putmsg"	},
#endif
#if	( TEST_XPG > 4 )
	{	putpmsg_sf,	NULL,	putpmsg_ef,	"putpmsg"	},
#endif
	{	puts_sf,	NULL,	puts_ef,	"puts"	},
#if	( TEST_XPG > 4 )
	{	pututxline_sf,	NULL,	pututxline_ef,	"pututxline"	},
#endif
#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)
	{	putw_sf,	NULL,	putw_ef,	"putw"	},
#endif
#endif
#if	( TEST_XPG > 4 )
	{	putwc_sf,	NULL,	putwc_ef,	"putwc"	},
#endif
#if	( TEST_XPG > 4 )
	{	putwchar_sf,	NULL,	putwchar_ef,	"putwchar"	},
#endif
#if	( TEST_XPG > 4 )
	{	pwrite_sf,	NULL,	pwrite_ef,	"pwrite"	},
#endif
	{	NULL,	NULL,	NULL,	NULL	}
};

/* -------PARTITION THE TEST ---------------------------------------*/

VSTH_RT	Vsth_rt_q_to_s[] = {

	{	qsort_sf,	NULL,	qsort_ef,	"qsort"	},
	{	raise_sf,	NULL,	raise_ef,	"raise"	},
	{	rand_sf,	NULL,	rand_ef,	"rand"	},
#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)
	{	rand_r_sf,	NULL,	rand_r_ef,	"rand_r"	},
#endif
#if	( TEST_XPG > 4 )
	{	random_sf,	NULL,	random_ef,	"random"	},
#endif
#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)
	{	re_comp_sf,	NULL,	re_comp_ef,	"re_comp"	},
#endif
#endif
#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)
	{	re_exec_sf,	NULL,	re_exec_ef,	"re_exec"	},
#endif
#endif
	{	read_sf,	NULL,	read_ef,	"read"	},
	{	readdir_sf,	NULL,	readdir_ef,	"readdir"	},
#if	( TEST_XPG > 4 )
	{	readlink_sf,	NULL,	readlink_ef,	"readlink"	},
#endif
#if	( TEST_XPG > 4 )
	{	readv_sf,	NULL,	readv_ef,	"readv"	},
#endif
	{	realloc_sf,	NULL,	realloc_ef,	"realloc"	},
#if	( TEST_XPG > 4 )
	{	realpath_sf,	NULL,	realpath_ef,	"realpath"	},
#endif
#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)
	{	regcmp_sf,	NULL,	regcmp_ef,	"regcmp"	},
#endif
#endif
#if	( TEST_XPG > 4 )
	{	regcomp_sf,	NULL,	regcomp_ef,	"regcomp"	},
#endif
#if	( TEST_XPG > 4 )
	{	regerror_sf,	NULL,	regerror_ef,	"regerror"	},
#endif
#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)
	{	regex_sf,	NULL,	regex_ef,	"regex"	},
#endif
#endif
#if	( TEST_XPG > 4 )
	{	regexec_sf,	NULL,	regexec_ef,	"regexec"	},
#endif
#if	( TEST_XPG > 4 )
	{	regfree_sf,	NULL,	regfree_ef,	"regfree"	},
#endif
#if	( TEST_XPG > 4 )
	{	remainder_sf,	remainder_tf,	remainder_ef,	"remainder"	},
#endif
	{	remove_sf,	NULL,	remove_ef,	"remove"	},
#if	( TEST_XPG > 4 )
	{	remque_sf,	NULL,	remque_ef,	"remque"	},
#endif
	{	rename_sf,	NULL,	rename_ef,	"rename"	},
	{	rewind_sf,	NULL,	rewind_ef,	"rewind"	},
	{	rewinddir_sf,	NULL,	rewinddir_ef,	"rewinddir"	},
#if	( TEST_XPG > 4 )
	{	rindex_sf,	NULL,	rindex_ef,	"rindex"	},
#endif
#if	( TEST_XPG > 4 )
	{	rint_sf,	rint_tf,	rint_ef,	"rint"	},
#endif
	{	rmdir_sf,	NULL,	rmdir_ef,	"rmdir"	},
#if	( TEST_XPG > 4 )
	{	sbrk_sf,	NULL,	sbrk_ef,	"sbrk"	},
#endif
#if	( TEST_XPG > 4 )
	{	scalb_sf,	scalb_tf,	scalb_ef,	"scalb"	},
#endif
	{	scanf_sf,	NULL,	scanf_ef,	"scanf"	},
#if	defined(_POSIX_PRIORITY_SCHEDULING)
	{	sched_get_priority_max_sf,	NULL,	sched_get_priority_max_ef,	"sched_get_priority_max"	},
#endif
#if	defined(_POSIX_PRIORITY_SCHEDULING)
	{	sched_get_priority_min_sf,	NULL,	sched_get_priority_min_ef,	"sched_get_priority_min"	},
#endif
#if	defined(_POSIX_PRIORITY_SCHEDULING)
	{	sched_getparam_sf,	NULL,	sched_getparam_ef,	"sched_getparam"	},
#endif
#if	defined(_POSIX_PRIORITY_SCHEDULING)
	{	sched_getscheduler_sf,	NULL,	sched_getscheduler_ef,	"sched_getscheduler"	},
#endif
#if	defined(_POSIX_PRIORITY_SCHEDULING)
	{	sched_rr_get_interval_sf,	NULL,	sched_rr_get_interval_ef,	"sched_rr_get_interval"	},
#endif
#if	defined(_POSIX_PRIORITY_SCHEDULING)
	{	sched_setparam_sf,	NULL,	sched_setparam_ef,	"sched_setparam"	},
#endif
#if	defined(_POSIX_PRIORITY_SCHEDULING)
	{	sched_setscheduler_sf,	NULL,	sched_setscheduler_ef,	"sched_setscheduler"	},
#endif
#if	defined(_POSIX_THREADS) || defined(_POSIX_PRIORITY_SCHEDULING)
	{	sched_yield_sf,	NULL,	sched_yield_ef,	"sched_yield"	},
#endif
#if	( TEST_XPG > 4 )
	{	seed48_sf,	NULL,	seed48_ef,	"seed48"	},
#endif
#if	( TEST_XPG > 4 )
	{	seekdir_sf,	NULL,	seekdir_ef,	"seekdir"	},
#endif
#if	( TEST_XPG > 4 )
	{	select_sf,	NULL,	select_ef,	"select"	},
#endif
#if	defined(_POSIX_SEMAPHORES)
	{	sem_close_sf,	NULL,	sem_close_ef,	"sem_close"	},
#endif
#if	defined(_POSIX_SEMAPHORES)
	{	sem_destroy_sf,	NULL,	sem_destroy_ef,	"sem_destroy"	},
#endif
#if	defined(_POSIX_SEMAPHORES)
	{	sem_getvalue_sf,	NULL,	sem_getvalue_ef,	"sem_getvalue"	},
#endif
#if	defined(_POSIX_SEMAPHORES)
	{	sem_init_sf,	NULL,	sem_init_ef,	"sem_init"	},
#endif
#if	defined(_POSIX_SEMAPHORES)
	{	sem_open_sf,	NULL,	sem_open_ef,	"sem_open"	},
#endif
#if	defined(_POSIX_SEMAPHORES)
	{	sem_post_sf,	NULL,	sem_post_ef,	"sem_post"	},
#endif
#if	defined(_POSIX_SEMAPHORES)
	{	sem_trywait_sf,	NULL,	sem_trywait_ef,	"sem_trywait"	},
#endif
#if	defined(_POSIX_SEMAPHORES)
	{	sem_unlink_sf,	NULL,	sem_unlink_ef,	"sem_unlink"	},
#endif
#if	defined(_POSIX_SEMAPHORES)
	{	sem_wait_sf,	NULL,	sem_wait_ef,	"sem_wait"	},
#endif
#if	( TEST_XPG > 4 )
	{	semctl_sf,	NULL,	semctl_ef,	"semctl"	},
#endif
#if	( TEST_XPG > 4 )
	{	semget_sf,	NULL,	semget_ef,	"semget"	},
#endif
#if	( TEST_XPG > 4 )
	{	semop_sf,	NULL,	semop_ef,	"semop"	},
#endif
	{	setbuf_sf,	NULL,	setbuf_ef,	"setbuf"	},
#if	( TEST_XPG > 4 )
	{	setcontext_sf,	NULL,	setcontext_ef,	"setcontext"	},
#endif
	{	setgid_sf,	NULL,	setgid_ef,	"setgid"	},
#if	( TEST_XPG > 4 )
	{	setgrent_sf,	NULL,	setgrent_ef,	"setgrent"	},
#endif
#if	( TEST_XPG > 4 )
	{	setitimer_sf,	NULL,	setitimer_ef,	"setitimer"	},
#endif
	{	setjmp_sf,	NULL,	setjmp_ef,	"setjmp"	},
#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_CRYPT) && (_XOPEN_CRYPT != -1)
	{	setkey_sf,	NULL,	setkey_ef,	"setkey"	},
#endif
#endif
	{	setlocale_sf,	NULL,	setlocale_ef,	"setlocale"	},
#if	( TEST_XPG > 4 )
	{	setlogmask_sf,	NULL,	setlogmask_ef,	"setlogmask"	},
#endif
#if	defined(_POSIX_JOB_CONTROL)
	{	setpgid_sf,	NULL,	setpgid_ef,	"setpgid"	},
#endif
#if	( TEST_XPG > 4 )
	{	setpgrp_sf,	NULL,	setpgrp_ef,	"setpgrp"	},
#endif
#if	( TEST_XPG > 4 )
	{	setpriority_sf,	NULL,	setpriority_ef,	"setpriority"	},
#endif
#if	( TEST_XPG > 4 )
	{	setpwent_sf,	NULL,	setpwent_ef,	"setpwent"	},
#endif
#if	( TEST_XPG > 4 )
	{	setregid_sf,	NULL,	setregid_ef,	"setregid"	},
#endif
#if	( TEST_XPG > 4 )
	{	setrlimit_sf,	NULL,	setrlimit_ef,	"setrlimit"	},
#endif
	{	setsid_sf,	NULL,	setsid_ef,	"setsid"	},
#if	( TEST_XPG > 4 )
	{	setstate_sf,	NULL,	setstate_ef,	"setstate"	},
#endif
	{	setuid_sf,	NULL,	setuid_ef,	"setuid"	},
#if	( TEST_XPG > 4 )
	{	setutxent_sf,	NULL,	setutxent_ef,	"setutxent"	},
#endif
	{	setvbuf_sf,	NULL,	setvbuf_ef,	"setvbuf"	},
#if	defined(_POSIX_SHARED_MEMORY_OBJECTS)
	{	shm_open_sf,	NULL,	shm_open_ef,	"shm_open"	},
#endif
#if	defined(_POSIX_SHARED_MEMORY_OBJECTS)
	{	shm_unlink_sf,	NULL,	shm_unlink_ef,	"shm_unlink"	},
#endif
#if	( TEST_XPG > 4 )
	{	shmat_sf,	NULL,	shmat_ef,	"shmat"	},
#endif
#if	( TEST_XPG > 4 )
	{	shmctl_sf,	NULL,	shmctl_ef,	"shmctl"	},
#endif
#if	( TEST_XPG > 4 )
	{	shmdt_sf,	NULL,	shmdt_ef,	"shmdt"	},
#endif
#if	( TEST_XPG > 4 )
	{	shmget_sf,	NULL,	shmget_ef,	"shmget"	},
#endif
	{	sigaction_sf,	NULL,	sigaction_ef,	"sigaction"	},
	{	sigaddset_sf,	NULL,	sigaddset_ef,	"sigaddset"	},
#if	( TEST_XPG > 4 )
	{	sigaltstack_sf,	NULL,	sigaltstack_ef,	"sigaltstack"	},
#endif
	{	sigdelset_sf,	NULL,	sigdelset_ef,	"sigdelset"	},
	{	sigemptyset_sf,	NULL,	sigemptyset_ef,	"sigemptyset"	},
	{	sigfillset_sf,	NULL,	sigfillset_ef,	"sigfillset"	},
#if	( TEST_XPG > 4 )
	{	sighold_sf,	NULL,	sighold_ef,	"sighold"	},
#endif
#if	( TEST_XPG > 4 )
	{	sigignore_sf,	NULL,	sigignore_ef,	"sigignore"	},
#endif
#if	( TEST_XPG > 4 )
	{	siginterrupt_sf,	NULL,	siginterrupt_ef,	"siginterrupt"	},
#endif
	{	sigismember_sf,	NULL,	sigismember_ef,	"sigismember"	},
	{	siglongjmp_sf,	NULL,	siglongjmp_ef,	"siglongjmp"	},
	{	signal_sf,	NULL,	signal_ef,	"signal"	},
#if	( TEST_XPG > 4 )
	{	signgam_sf,	NULL,	signgam_ef,	"signgam"	},
#endif
#if	( TEST_XPG > 4 )
	{	sigpause_sf,	NULL,	sigpause_ef,	"sigpause"	},
#endif
	{	sigpending_sf,	NULL,	sigpending_ef,	"sigpending"	},
	{	sigprocmask_sf,	NULL,	sigprocmask_ef,	"sigprocmask"	},
#if	defined(_POSIX_REALTIME_SIGNALS)
	{	sigqueue_sf,	NULL,	sigqueue_ef,	"sigqueue"	},
#endif
#if	( TEST_XPG > 4 )
	{	sigrelse_sf,	NULL,	sigrelse_ef,	"sigrelse"	},
#endif
#if	( TEST_XPG > 4 )
	{	sigset_sf,	NULL,	sigset_ef,	"sigset"	},
#endif
	{	sigsetjmp_sf,	NULL,	sigsetjmp_ef,	"sigsetjmp"	},
#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)
	{	sigstack_sf,	NULL,	sigstack_ef,	"sigstack"	},
#endif
#endif
	{	sigsuspend_sf,	NULL,	sigsuspend_ef,	"sigsuspend"	},
#ifdef	_POSIX_REALTIME_SIGNALS
	{	sigtimedwait_sf,	NULL,	sigtimedwait_ef,	"sigtimedwait"	},
#endif
	{	sigwait_sf,	NULL,	sigwait_ef,	"sigwait"	},
#ifdef	_POSIX_REALTIME_SIGNALS
	{	sigwaitinfo_sf,	NULL,	sigwaitinfo_ef,	"sigwaitinfo"	},
#endif
	{	sin_sf,	sin_tf,	sin_ef,	"sin"	},
	{	sinh_sf,	sinh_tf,	sinh_ef,	"sinh"	},
	{	sleep_sf,	NULL,	sleep_ef,	"sleep"	},
#if	( TEST_XPG > 4 )
	{	snprintf_sf,	NULL,	snprintf_ef,	"snprintf"	},
#endif
	{	sprintf_sf,	NULL,	sprintf_ef,	"sprintf"	},
	{	sqrt_sf,	sqrt_tf,	sqrt_ef,	"sqrt"	},
	{	srand_sf,	NULL,	srand_ef,	"srand"	},
#if	( TEST_XPG > 4 )
	{	srand48_sf,	NULL,	srand48_ef,	"srand48"	},
#endif
#if	( TEST_XPG > 4 )
	{	srandom_sf,	NULL,	srandom_ef,	"srandom"	},
#endif
	{	sscanf_sf,	NULL,	sscanf_ef,	"sscanf"	},
	{	stat_sf,	NULL,	stat_ef,	"stat"	},
#if	( TEST_XPG > 4 )
	{	statvfs_sf,	NULL,	statvfs_ef,	"statvfs"	},
#endif
#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)
	{	step_sf,	NULL,	step_ef,	"step"	},
#endif
#endif
#if	( TEST_XPG > 4 )
	{	strcasecmp_sf,	strcasecmp_tf,	strcasecmp_ef,	"strcasecmp"	},
#endif
	{	strcat_sf,	strcat_tf,	strcat_ef,	"strcat"	},
	{	strchr_sf,	strchr_tf,	strchr_ef,	"strchr"	},
	{	strcmp_sf,	strcmp_tf,	strcmp_ef,	"strcmp"	},
	{	strcoll_sf,	strcoll_tf,	strcoll_ef,	"strcoll"	},
	{	strcpy_sf,	strcpy_tf,	strcpy_ef,	"strcpy"	},
	{	strcspn_sf,	strcspn_tf,	strcspn_ef,	"strcspn"	},
#if	( TEST_XPG > 4 )
	{	strdup_sf,	strdup_tf,	strdup_ef,	"strdup"	},
#endif
	{	strerror_sf,	NULL,	strerror_ef,	"strerror"	},
#if	( TEST_XPG > 4 )
	{	strfmon_sf,	strfmon_tf,	strfmon_ef,	"strfmon"	},
#endif
	{	strftime_sf,	strftime_tf,	strftime_ef,	"strftime"	},
	{	strlen_sf,	strlen_tf,	strlen_ef,	"strlen"	},
#if	( TEST_XPG > 4 )
	{	strncasecmp_sf,	strncasecmp_tf,	strncasecmp_ef,	"strncasecmp"	},
#endif
	{	strncat_sf,	strncat_tf,	strncat_ef,	"strncat"	},
	{	strncmp_sf,	strncmp_tf,	strncmp_ef,	"strncmp"	},
	{	strncpy_sf,	strncpy_tf,	strncpy_ef,	"strncpy"	},
	{	strpbrk_sf,	strpbrk_tf,	strpbrk_ef,	"strpbrk"	},
#if	( TEST_XPG > 4 )
	{	strptime_sf,	strptime_tf,	strptime_ef,	"strptime"	},
#endif
	{	strrchr_sf,	strrchr_tf,	strrchr_ef,	"strrchr"	},
	{	strspn_sf,	strspn_tf,	strspn_ef,	"strspn"	},
	{	strstr_sf,	strstr_tf,	strstr_ef,	"strstr"	},
	{	strtod_sf,	strtod_tf,	strtod_ef,	"strtod"	},
	{	strtok_sf,	NULL,	strtok_ef,	"strtok"	},
#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)
	{	strtok_r_sf,	NULL,	strtok_r_ef,	"strtok_r"	},
#endif
	{	strtol_sf,	strtol_tf,	strtol_ef,	"strtol"	},
	{	strtoul_sf,	strtoul_tf,	strtoul_ef,	"strtoul"	},
	{	strxfrm_sf,	strxfrm_tf,	strxfrm_ef,	"strxfrm"	},
#if	( TEST_XPG > 4 )
	{	swab_sf,	swab_tf,	swab_ef,	"swab"	},
#endif
#if	( TEST_XPG > 4 )
	{	swapcontext_sf,	NULL,	swapcontext_ef,	"swapcontext"	},
#endif
#if	( TEST_XPG > 4 )
	{	swprintf_sf,	NULL,	swprintf_ef,	"swprintf"	},
#endif
#if	( TEST_XPG > 4 )
	{	swscanf_sf,	NULL,	swscanf_ef,	"swscanf"	},
#endif
#if	( TEST_XPG > 4 )
	{	symlink_sf,	NULL,	symlink_ef,	"symlink"	},
#endif
#if	( TEST_XPG > 4 )
	{	sync_sf,	NULL,	sync_ef,	"sync"	},
#endif
	{	sysconf_sf,	NULL,	sysconf_ef,	"sysconf"	},
#if	( TEST_XPG > 4 )
	{	syslog_sf,	NULL,	syslog_ef,	"syslog"	},
#endif
	{	system_sf,	NULL,	system_ef,	"system"	},
	{	NULL,	NULL,	NULL,	NULL	}
};

/* -------PARTITION THE TEST ---------------------------------------*/

VSTH_RT	Vsth_rt_t_to_z[] = {

	{	tan_sf,	tan_tf,	tan_ef,	"tan"	},
	{	tanh_sf,	tanh_tf,	tanh_ef,	"tanh"	},
	{	tcdrain_sf,	NULL,	tcdrain_ef,	"tcdrain"	},
	{	tcflow_sf,	NULL,	tcflow_ef,	"tcflow"	},
	{	tcflush_sf,	NULL,	tcflush_ef,	"tcflush"	},
	{	tcgetattr_sf,	NULL,	tcgetattr_ef,	"tcgetattr"	},
#if	defined(_POSIX_JOB_CONTROL)
	{	tcgetpgrp_sf,	NULL,	tcgetpgrp_ef,	"tcgetpgrp"	},
#endif
#if	( TEST_XPG > 4 )
	{	tcgetsid_sf,	NULL,	tcgetsid_ef,	"tcgetsid"	},
#endif
	{	tcsendbreak_sf,	NULL,	tcsendbreak_ef,	"tcsendbreak"	},
	{	tcsetattr_sf,	NULL,	tcsetattr_ef,	"tcsetattr"	},
#if	defined(_POSIX_JOB_CONTROL)
	{	tcsetpgrp_sf,	NULL,	tcsetpgrp_ef,	"tcsetpgrp"	},
#endif
#if	( TEST_XPG > 4 )
	{	tdelete_sf,	NULL,	tdelete_ef,	"tdelete"	},
#endif
#if	( TEST_XPG > 4 )
	{	telldir_sf,	NULL,	telldir_ef,	"telldir"	},
#endif
#if	( TEST_XPG > 4 )
	{	tempnam_sf,	NULL,	tempnam_ef,	"tempnam"	},
#endif
#if	( TEST_XPG > 4 )
	{	tfind_sf,	NULL,	tfind_ef,	"tfind"	},
#endif
	{	time_sf,	NULL,	time_ef,	"time"	},
#if	defined(_POSIX_TIMERS)
	{	timer_create_sf,	NULL,	timer_create_ef,	"timer_create"	},
#endif
#if	defined(_POSIX_TIMERS)
	{	timer_delete_sf,	NULL,	timer_delete_ef,	"timer_delete"	},
#endif
#if	defined(_POSIX_TIMERS)
	{	timer_getoverrun_sf,	NULL,	timer_getoverrun_ef,	"timer_getoverrun"	},
#endif
#if	defined(_POSIX_TIMERS)
	{	timer_gettime_sf,	NULL,	timer_gettime_ef,	"timer_gettime"	},
#endif
#if	defined(_POSIX_TIMERS)
	{	timer_settime_sf,	NULL,	timer_settime_ef,	"timer_settime"	},
#endif
	{	times_sf,	NULL,	times_ef,	"times"	},
	{	tmpfile_sf,	NULL,	tmpfile_ef,	"tmpfile"	},
	{	tmpnam_sf,	NULL,	tmpnam_ef,	"tmpnam"	},
#if	( TEST_XPG > 4 )
	{	toascii_sf,	toascii_tf,	toascii_ef,	"toascii"	},
#endif
	{	tolower_sf,	tolower_tf,	tolower_ef,	"tolower"	},
	{	toupper_sf,	toupper_tf,	toupper_ef,	"toupper"	},
#if	( TEST_XPG > 4 )
	{	towctrans_sf,	towctrans_tf,	towctrans_ef,	"towctrans"	},
#endif
#if	( TEST_XPG > 4 )
	{	towlower_sf,	towlower_tf,	towlower_ef,	"towlower"	},
#endif
#if	( TEST_XPG > 4 )
	{	towupper_sf,	towupper_tf,	towupper_ef,	"towupper"	},
#endif
#if	( TEST_XPG > 4 )
	{	truncate_sf,	NULL,	truncate_ef,	"truncate"	},
#endif
#if	( TEST_XPG > 4 )
	{	tsearch_sf,	NULL,	tsearch_ef,	"tsearch"	},
#endif
	{	ttyname_sf,	NULL,	ttyname_ef,	"ttyname"	},
	{	ttyname_r_sf,	NULL,	ttyname_r_ef,	"ttyname_r"	},
#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)
	{	ttyslot_sf,	NULL,	ttyslot_ef,	"ttyslot"	},
#endif
#endif
#if	( TEST_XPG > 4 )
	{	twalk_sf,	NULL,	twalk_ef,	"twalk"	},
#endif
	{	tzset_sf,	NULL,	tzset_ef,	"tzset"	},
#if	( TEST_XPG > 4 )
	{	ualarm_sf,	NULL,	ualarm_ef,	"ualarm"	},
#endif
#if	( TEST_XPG > 4 )
	{	ulimit_sf,	NULL,	ulimit_ef,	"ulimit"	},
#endif
	{	umask_sf,	NULL,	umask_ef,	"umask"	},
	{	uname_sf,	NULL,	uname_ef,	"uname"	},
	{	ungetc_sf,	NULL,	ungetc_ef,	"ungetc"	},
#if	( TEST_XPG > 4 )
	{	ungetwc_sf,	NULL,	ungetwc_ef,	"ungetwc"	},
#endif
	{	unlink_sf,	NULL,	unlink_ef,	"unlink"	},
#if	( TEST_XPG > 4 )
	{	unlockpt_sf,	NULL,	unlockpt_ef,	"unlockpt"	},
#endif
#if	( TEST_XPG > 4 )
	{	usleep_sf,	NULL,	usleep_ef,	"usleep"	},
#endif
	{	utime_sf,	NULL,	utime_ef,	"utime"	},
#if	( TEST_XPG > 4 )
	{	utimes_sf,	NULL,	utimes_ef,	"utimes"	},
#endif
#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)
	{	valloc_sf,	NULL,	valloc_ef,	"valloc"	},
#endif
#endif
#if	( TEST_XPG > 4 )
	{	vfork_sf,	NULL,	vfork_ef,	"vfork"	},
#endif
	{	vfprintf_sf,	NULL,	vfprintf_ef,	"vfprintf"	},
#if	( TEST_XPG > 4 )
	{	vfwprintf_sf,	NULL,	vfwprintf_ef,	"vfwprintf"	},
#endif
	{	vprintf_sf,	NULL,	vprintf_ef,	"vprintf"	},
#if	( TEST_XPG > 4 )
	{	vsnprintf_sf,	NULL,	vsnprintf_ef,	"vsnprintf"	},
#endif
	{	vsprintf_sf,	NULL,	vsprintf_ef,	"vsprintf"	},
#if	( TEST_XPG > 4 )
	{	vswprintf_sf,	NULL,	vswprintf_ef,	"vswprintf"	},
#endif
#if	( TEST_XPG > 4 )
	{	vwprintf_sf,	NULL,	vwprintf_ef,	"vwprintf"	},
#endif
	{	wait_sf,	NULL,	wait_ef,	"wait"	},
#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)
	{	wait3_sf,	NULL,	wait3_ef,	"wait3"	},
#endif
#endif
#if	( TEST_XPG > 4 )
	{	waitid_sf,	NULL,	waitid_ef,	"waitid"	},
#endif
	{	waitpid_sf,	NULL,	waitpid_ef,	"waitpid"	},
#if	( TEST_XPG > 4 )
	{	wcrtomb_sf,	NULL,	wcrtomb_ef,	"wcrtomb"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcscat_sf,	NULL,	wcscat_ef,	"wcscat"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcschr_sf,	NULL,	wcschr_ef,	"wcschr"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcscmp_sf,	NULL,	wcscmp_ef,	"wcscmp"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcscoll_sf,	NULL,	wcscoll_ef,	"wcscoll"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcscpy_sf,	NULL,	wcscpy_ef,	"wcscpy"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcscspn_sf,	NULL,	wcscspn_ef,	"wcscspn"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcsftime_sf,	NULL,	wcsftime_ef,	"wcsftime"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcslen_sf,	NULL,	wcslen_ef,	"wcslen"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcsncat_sf,	NULL,	wcsncat_ef,	"wcsncat"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcsncmp_sf,	NULL,	wcsncmp_ef,	"wcsncmp"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcsncpy_sf,	NULL,	wcsncpy_ef,	"wcsncpy"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcspbrk_sf,	NULL,	wcspbrk_ef,	"wcspbrk"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcsrchr_sf,	NULL,	wcsrchr_ef,	"wcsrchr"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcsrtombs_sf,	NULL,	wcsrtombs_ef,	"wcsrtombs"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcsspn_sf,	NULL,	wcsspn_ef,	"wcsspn"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcsstr_sf,	NULL,	wcsstr_ef,	"wcsstr"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcstod_sf,	NULL,	wcstod_ef,	"wcstod"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcstok_sf,	NULL,	wcstok_ef,	"wcstok"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcstol_sf,	NULL,	wcstol_ef,	"wcstol"	},
#endif
	{	wcstombs_sf,	NULL,	wcstombs_ef,	"wcstombs"	},
#if	( TEST_XPG > 4 )
	{	wcstoul_sf,	NULL,	wcstoul_ef,	"wcstoul"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcswcs_sf,	NULL,	wcswcs_ef,	"wcswcs"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcswidth_sf,	NULL,	wcswidth_ef,	"wcswidth"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcsxfrm_sf,	NULL,	wcsxfrm_ef,	"wcsxfrm"	},
#endif
#if	( TEST_XPG > 4 )
	{	wctob_sf,	NULL,	wctob_ef,	"wctob"	},
#endif
	{	wctomb_sf,	NULL,	wctomb_ef,	"wctomb"	},
#if	( TEST_XPG > 4 )
	{	wctrans_sf,	NULL,	wctrans_ef,	"wctrans"	},
#endif
#if	( TEST_XPG > 4 )
	{	wctype_sf,	NULL,	wctype_ef,	"wctype"	},
#endif
#if	( TEST_XPG > 4 )
	{	wcwidth_sf,	NULL,	wcwidth_ef,	"wcwidth"	},
#endif
#if	( TEST_XPG > 4 )
	{	wmemchr_sf,	NULL,	wmemchr_ef,	"wmemchr"	},
#endif
#if	( TEST_XPG > 4 )
	{	wmemcmp_sf,	NULL,	wmemcmp_ef,	"wmemcmp"	},
#endif
#if	( TEST_XPG > 4 )
	{	wmemcpy_sf,	NULL,	wmemcpy_ef,	"wmemcpy"	},
#endif
#if	( TEST_XPG > 4 )
	{	wmemmove_sf,	NULL,	wmemmove_ef,	"wmemmove"	},
#endif
#if	( TEST_XPG > 4 )
	{	wmemset_sf,	NULL,	wmemset_ef,	"wmemset"	},
#endif
#if	( TEST_XPG > 4 )
	{	wordexp_sf,	NULL,	wordexp_ef,	"wordexp"	},
#endif
#if	( TEST_XPG > 4 )
	{	wprintf_sf,	NULL,	wprintf_ef,	"wprintf"	},
#endif
	{	write_sf,	NULL,	write_ef,	"write"	},
#if	( TEST_XPG > 4 )
	{	writev_sf,	NULL,	writev_ef,	"writev"	},
#endif
#if	( TEST_XPG > 4 )
	{	wscanf_sf,	NULL,	wscanf_ef,	"wscanf"	},
#endif
#if	( TEST_XPG > 4 )
	{	y0_sf,	y0_tf,	y0_ef,	"y0"	},
#endif
#if	( TEST_XPG > 4 )
	{	y1_sf,	y1_tf,	y1_ef,	"y1"	},
#endif
#if	( TEST_XPG > 4 )
	{	yn_sf,	yn_tf,	yn_ef,	"yn"	},
#endif
	{	NULL,	NULL,	NULL,	NULL	}
};


