
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_rtb.c	1.5
*
*************************************************************************/

#include "std.h"


#if	( TEST_XPG > 4 )
#include <libgen.h>
#endif

#include <signal.h>
#include <stdio.h>
#include <stdlib.h>


#if	( TEST_XPG > 4 )
#include <strings.h>
#endif

#include <unistd.h>

#if	( TEST_XPG > 4 )
#include <wchar.h>
#endif

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"

#if	( TEST_XPG > 4 )

/****** Testset for basename()					 ******/

#ifdef	basename
#undef	basename
#endif

int
basename_sf()
{
	return(0);
}

int
basename_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
basename_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for bcmp()					 ******/

#ifdef	bcmp
#undef	bcmp
#endif

#define	VSTH_BCMP_S1	"\x0\x1\x2\x3\x4\x5\x6\x7\x8"
#define	VSTH_BCMP_S2	"\x0\x1\x2\x3\x4\x5\x6\x7\x9"
#define	VSTH_BCMP_S3	"\x0\x1\x2\x3\x4\x5\x6\x9\x9"

int	Vsth_bcmp_val1;
int	Vsth_bcmp_val2;

int
bcmp_sf()
{
	return(0);
}

int
bcmp_tf()
{
	int	cnt;
	int	rval;
	int	errs;
	int	fails;
	int	val;

	errs	= 0;
	fails	= 0;

	for( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		val = bcmp(VSTH_BCMP_S1, VSTH_BCMP_S2, 8);
		if ( val )
		{
			++fails;
		}

		val = bcmp(VSTH_BCMP_S1, VSTH_BCMP_S3, 8);
		if ( val == 0 )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
bcmp_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for bcopy()					 ******/

#ifdef	bcopy
#undef	bcopy
#endif

#define	VSTH_BCOPY_S1	"\x0\x1\x2\x3\x4\x5\x6\x7"
#define	VSTH_BCOPY_S2	"\x3\x4\x5\x6\x7\x5\x6\x7"
#define	VSTH_BCOPY_S3	"\x0\x1\x2\x0\x1\x2\x3\x4"

int
bcopy_sf()
{
	return(0);
}

int
bcopy_tf()
{
	int	cnt;
	int	rval;
	int	errs;
	int	fails;
	char	*p;
	char	buf[VSTH_BUFLEN];

	errs	= 0;
	fails	= 0;

	for( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		bcopy(VSTH_BCOPY_S1, &buf[0], 8);
		bcopy(&buf[3], &buf[0], 5);

		vsth_ec();
		if (bcmp(&buf[0], VSTH_BCOPY_S2, 8))
		{
			++fails;
		}
		vsth_xc();

		bcopy(VSTH_BCOPY_S1, &buf[0], 8);
		bcopy(&buf[0], &buf[3], 5);

		vsth_ec();
		if (bcmp(&buf[0], VSTH_BCOPY_S3, 8))
		{
			++fails;
		}
		vsth_xc();

	}
	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
bcopy_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for brk()					 ******/

#ifdef	brk
#undef	brk
#endif

int
brk_sf()
{
	return(0);
}

int
brk_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
brk_ef()
{
	return(0);
}

#endif
#endif

#if	( TEST_XPG > 4 )

/****** Testset for bsd_signal()				 ******/

#ifdef	bsd_signal
#undef	bsd_signal
#endif

int
bsd_signal_sf()
{
	return(0);
}

int
bsd_signal_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
bsd_signal_ef()
{
	return(0);
}

#endif

/****** Testset for bsearch()					 ******/

#ifdef	bsearch
#undef	bsearch
#endif

#define	VSTH_BSEARCH_NELEM	16

typedef struct {
	int	a;
	int	b;
} Vsth_bsearch_el;

int			Vsth_bsearch_init = 0;
Vsth_bsearch_el		Vsth_bsearch_array[VSTH_BSEARCH_NELEM];
void			*Vsth_bsearch_val1;
void			*Vsth_bsearch_val2;

int
vsth_bsearch_cf( const void *el1, const void *el2 )
{
	int	rval;

	if (((Vsth_bsearch_el *) el1)->a == ((Vsth_bsearch_el *) el2)->a)
	{
		rval = 0;
	}
	else if (((Vsth_bsearch_el *) el1)->a < ((Vsth_bsearch_el *) el2)->a)
	{
		rval = -1;
	}
	if (((Vsth_bsearch_el *) el1)->a > ((Vsth_bsearch_el *) el2)->a)
	{
		rval = 1;
	}
	return(rval);
}

int
bsearch_sf()
{
	int	cnt;

	if ( ! Vsth_bsearch_init )
	{
		for (cnt = 0; cnt < VSTH_BSEARCH_NELEM; ++cnt)
		{
			Vsth_bsearch_array[cnt].a = cnt;
			Vsth_bsearch_array[cnt].b = -cnt;
		}
		Vsth_bsearch_init = 1;
	}
	return(0);
}

int
bsearch_tf()
{
	int			cnt;
	int			rval;
	int			errs;
	int			fails;
	Vsth_bsearch_el		*val;
	Vsth_bsearch_el		el;

	errs	= 0;
	fails	= 0;

	for( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		el.a = 5;
		val = (Vsth_bsearch_el *) bsearch( (void *) &el,
						&Vsth_bsearch_array[0],
						VSTH_BSEARCH_NELEM,
						sizeof(Vsth_bsearch_el), 
						vsth_bsearch_cf );
		if (((Vsth_bsearch_el *) val)->a != 5)
		{
			++fails;
		}

		el.a = 13;
		val = (Vsth_bsearch_el *) bsearch( (void *) &el,
						&Vsth_bsearch_array[0],
						VSTH_BSEARCH_NELEM,
						sizeof(Vsth_bsearch_el), 
						vsth_bsearch_cf );
		if (((Vsth_bsearch_el *) val)->a != 13)
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
bsearch_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for btowc()					 ******/

#ifdef	btowc
#undef	btowc
#endif

int
btowc_sf()
{
	return(0);
}

int
btowc_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
btowc_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for bzero()					 ******/

#ifdef	bzero
#undef	bzero
#endif

int
bzero_sf()
{
	return(0);
}

int
bzero_tf()
{
	int	cnt;
	int	rval;
	int	errs;
	int	fails;
	int	ix;
	char	buf1[VSTH_BUFLEN];
	char	buf2[VSTH_BUFLEN];

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		/* kinda daft, I know ... */
		memset(&buf1[0], 1, VSTH_BUFLEN);
		bzero(&buf1[0], (size_t) VSTH_BUFLEN);
		for ( ix = 0; ix < Vsth_rt_cnt; ++ix )
		{
			if ( buf1[ix] )
			{
				++fails;
			}
		}

		memset(&buf2[0], 2, VSTH_BUFLEN);
		bzero(&buf2[0], (size_t) VSTH_BUFLEN);
		for ( ix = 0; ix < Vsth_rt_cnt; ++ix )
		{
			if ( buf2[ix] )
			{
				++fails;
			}
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
bzero_ef()
{
	return(0);
}

#endif
