
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_rtd.c	1.2
*
*************************************************************************/

#include "std.h"

#if	( TEST_XPG > 4 )
#include <dlfcn.h>
#include <ndbm.h>
#endif

#include <stdlib.h>
#include <stdio.h>
#include <time.h>
#include <unistd.h>

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"

#if	( TEST_XPG > 4 )

/****** Testset for dbm_clearerr()				 ******/

#ifdef	dbm_clearerr
#undef	dbm_clearerr
#endif

int
dbm_clearerr_sf()
{
	return(0);
}

int
dbm_clearerr_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dbm_clearerr_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dbm_close()					 ******/

#ifdef	dbm_close
#undef	dbm_close
#endif

int
dbm_close_sf()
{
	return(0);
}

int
dbm_close_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dbm_close_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dbm_delete()				 ******/

#ifdef	dbm_delete
#undef	dbm_delete
#endif

int
dbm_delete_sf()
{
	return(0);
}

int
dbm_delete_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dbm_delete_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dbm_error()					 ******/

#ifdef	dbm_error
#undef	dbm_error
#endif

int
dbm_error_sf()
{
	return(0);
}

int
dbm_error_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dbm_error_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dbm_fetch()					 ******/

#ifdef	dbm_fetch
#undef	dbm_fetch
#endif

int
dbm_fetch_sf()
{
	return(0);
}

int
dbm_fetch_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dbm_fetch_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dbm_firstkey()				 ******/

#ifdef	dbm_firstkey
#undef	dbm_firstkey
#endif

int
dbm_firstkey_sf()
{
	return(0);
}

int
dbm_firstkey_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dbm_firstkey_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dbm_nextkey()				 ******/

#ifdef	dbm_nextkey
#undef	dbm_nextkey
#endif

int
dbm_nextkey_sf()
{
	return(0);
}

int
dbm_nextkey_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dbm_nextkey_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dbm_open()					 ******/

#ifdef	dbm_open
#undef	dbm_open
#endif

int
dbm_open_sf()
{
	return(0);
}

int
dbm_open_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dbm_open_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dbm_store()					 ******/

#ifdef	dbm_store
#undef	dbm_store
#endif

int
dbm_store_sf()
{
	return(0);
}

int
dbm_store_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dbm_store_ef()
{
	return(0);
}

#endif

/****** Testset for difftime()					 ******/

#ifdef	difftime
#undef	difftime
#endif

int
difftime_sf()
{
	return(0);
}

int
difftime_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
difftime_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for dirname()					 ******/

#ifdef	dirname
#undef	dirname
#endif

int
dirname_sf()
{
	return(0);
}

int
dirname_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dirname_ef()
{
	return(0);
}

#endif

/****** Testset for div()					 ******/

#ifdef	div
#undef	div
#endif

int
div_sf()
{
	return(0);
}

int
div_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
div_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for dlclose()					 ******/

#ifdef	dlclose
#undef	dlclose
#endif

int
dlclose_sf()
{
	return(0);
}

int
dlclose_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dlclose_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dlerror()					 ******/

#ifdef	dlerror
#undef	dlerror
#endif

int
dlerror_sf()
{
	return(0);
}

int
dlerror_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dlerror_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dlopen()					 ******/

#ifdef	dlopen
#undef	dlopen
#endif

int
dlopen_sf()
{
	return(0);
}

int
dlopen_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dlopen_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for dlsym()					 ******/

#ifdef	dlsym
#undef	dlsym
#endif

int
dlsym_sf()
{
	return(0);
}

int
dlsym_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dlsym_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for drand48()					 ******/

#ifdef	drand48
#undef	drand48
#endif

int
drand48_sf()
{
	return(0);
}

int
drand48_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
drand48_ef()
{
	return(0);
}

#endif

/****** Testset for dup()					 ******/

#ifdef	dup
#undef	dup
#endif

int
dup_sf()
{
	return(0);
}

int
dup_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dup_ef()
{
	return(0);
}

/****** Testset for dup2()					 ******/

#ifdef	dup2
#undef	dup2
#endif

int
dup2_sf()
{
	return(0);
}

int
dup2_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
dup2_ef()
{
	return(0);
}

