
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_rte.c	1.5
*
*************************************************************************/

#include "std.h"

#include <grp.h>
#include <math.h>
#include <pwd.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#if	( TEST_XPG > 4 )
#include <utmpx.h>
#endif

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"

#if	( TEST_XPG > 4 )

/****** Testset for ecvt()					 ******/

#ifdef	ecvt
#undef	ecvt
#endif

int
ecvt_sf()
{
	return(0);
}

int
ecvt_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ecvt_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_CRYPT) && (_XOPEN_CRYPT != -1)

/****** Testset for encrypt()					 ******/

#ifdef	encrypt
#undef	encrypt
#endif

int
encrypt_sf()
{
	return(0);
}

int
encrypt_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
encrypt_ef()
{
	return(0);
}

#endif
#endif

#if	( TEST_XPG > 4 )

/****** Testset for endgrent()					 ******/

#ifdef	endgrent
#undef	endgrent
#endif

int
endgrent_sf()
{
	return(0);
}

int
endgrent_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
endgrent_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for endpwent()					 ******/

#ifdef	endpwent
#undef	endpwent
#endif

int
endpwent_sf()
{
	return(0);
}

int
endpwent_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
endpwent_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for endutxent()					 ******/

#ifdef	endutxent
#undef	endutxent
#endif

int
endutxent_sf()
{
	return(0);
}

int
endutxent_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
endutxent_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for erand48()					 ******/

#ifdef	erand48
#undef	erand48
#endif

double			Vsth_erand48_val1;
double			Vsth_erand48_val2;

int
erand48_sf()
{
	unsigned short int	xsubi1[3];
	unsigned short int	xsubi2[3];

	xsubi1[0] = 0x10;
	xsubi1[1] = 0x11;
	xsubi1[2] = 0x12;

	xsubi2[0] = 0x01;
	xsubi2[1] = 0x11;
	xsubi2[2] = 0x21;

	Vsth_erand48_val1 = erand48(&xsubi1[0]);
	Vsth_erand48_val2 = erand48(&xsubi2[0]);

	return(0);
}

int
erand48_tf()
{
	int			cnt;
	int			rval;
	int			errs;
	int			fails;
	unsigned short int	xsubi1[3];
	unsigned short int	xsubi2[3];
	double			val1;
	double			val2;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{

		xsubi1[0] = 0x10;
		xsubi1[1] = 0x11;
		xsubi1[2] = 0x12;

		xsubi2[0] = 0x01;
		xsubi2[1] = 0x11;
		xsubi2[2] = 0x21;

		val1 = erand48(&xsubi1[0]);
		if ( val1 != Vsth_erand48_val1 )
		{
			++errs;
		}

		val2 = erand48(&xsubi2[0]);
		if ( val2 != Vsth_erand48_val2 )
		{
			++errs;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
erand48_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for erf()					 ******/

#ifdef	erf
#undef	erf
#endif

#define	VSTH_ERF_VAL1		-0.2
#define	VSTH_ERF_VAL2		0.5
int	Vsth_erf_init = 0;
double	Vsth_erf_val1;
double	Vsth_erf_val2;

int
erf_sf()
{
	if ( ! Vsth_erf_init )
	{
		Vsth_erf_val1 = erf(VSTH_ERF_VAL1);
		Vsth_erf_val2 = erf(VSTH_ERF_VAL2);
		Vsth_erf_init = 1;
	}
		
	return(0);
}

int
erf_tf()
{
	int	cnt;
	double	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = erf(VSTH_ERF_VAL1);
		if ( rval != Vsth_erf_val1 )
		{
			++errs;
		}

		rval = erf(VSTH_ERF_VAL2);
		if ( rval != Vsth_erf_val2 )
		{
			++errs;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
erf_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for erfc()					 ******/

#ifdef	erfc
#undef	erfc
#endif

#define	VSTH_ERFC_VAL1		-0.2
#define	VSTH_ERFC_VAL2		0.5
int	Vsth_erfc_init = 0;
double	Vsth_erfc_val1;
double	Vsth_erfc_val2;

int
erfc_sf()
{
	if ( ! Vsth_erfc_init )
	{
		Vsth_erfc_val1 = erfc(VSTH_ERFC_VAL1);
		Vsth_erfc_val2 = erfc(VSTH_ERFC_VAL2);
		Vsth_erfc_init = 1;
	}
		
	return(0);
}

int
erfc_tf()
{
	int	cnt;
	double	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = erfc(VSTH_ERFC_VAL1);
		if ( rval != Vsth_erfc_val1 )
		{
			++errs;
		}

		rval = erfc(VSTH_ERFC_VAL2);
		if ( rval != Vsth_erfc_val2 )
		{
			++errs;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
erfc_ef()
{
	return(0);
}

#endif

/****** Testset for execl()					 ******/

#ifdef	execl
#undef	execl
#endif

int
execl_sf()
{
	return(0);
}

int
execl_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
execl_ef()
{
	return(0);
}

/****** Testset for execle()					 ******/

#ifdef	execle
#undef	execle
#endif

int
execle_sf()
{
	return(0);
}

int
execle_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
execle_ef()
{
	return(0);
}

/****** Testset for execlp()					 ******/

#ifdef	execlp
#undef	execlp
#endif

int
execlp_sf()
{
	return(0);
}

int
execlp_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
execlp_ef()
{
	return(0);
}

/****** Testset for execv()					 ******/

#ifdef	execv
#undef	execv
#endif

int
execv_sf()
{
	return(0);
}

int
execv_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
execv_ef()
{
	return(0);
}

/****** Testset for execve()					 ******/

#ifdef	execve
#undef	execve
#endif

int
execve_sf()
{
	return(0);
}

int
execve_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
execve_ef()
{
	return(0);
}

/****** Testset for execvp()					 ******/

#ifdef	execvp
#undef	execvp
#endif

int
execvp_sf()
{
	return(0);
}

int
execvp_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
execvp_ef()
{
	return(0);
}

/****** Testset for exit()					 ******/

#ifdef	exit
#undef	exit
#endif

int
exit_sf()
{
	return(0);
}

int
exit_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
exit_ef()
{
	return(0);
}

/****** Testset for exp()					 ******/

#ifdef	exp
#undef	exp
#endif

#define	VSTH_EXP_VAL1		-0.2
#define	VSTH_EXP_VAL2		0.5
int	Vsth_exp_init = 0;
double	Vsth_exp_val1;
double	Vsth_exp_val2;

int
exp_sf()
{
	if ( ! Vsth_exp_init )
	{
		Vsth_exp_val1 = exp(VSTH_EXP_VAL1);
		Vsth_exp_val2 = exp(VSTH_EXP_VAL2);
		Vsth_exp_init = 1;
	}
		
	return(0);
}

int
exp_tf()
{
	int	cnt;
	double	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = exp(VSTH_EXP_VAL1);
		if ( rval != Vsth_exp_val1 )
		{
			++fails;
		}

		rval = exp(VSTH_EXP_VAL2);
		if ( rval != Vsth_exp_val2 )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
exp_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for expm1()					 ******/

#ifdef	expm1
#undef	expm1
#endif

#define	VSTH_EXPM1_VAL1		-0.2
#define	VSTH_EXPM1_VAL2		0.5
int	Vsth_expm1_init = 0;
double	Vsth_expm1_val1;
double	Vsth_expm1_val2;

int
expm1_sf()
{
	if ( ! Vsth_expm1_init )
	{
		Vsth_expm1_val1 = expm1(VSTH_EXPM1_VAL1);
		Vsth_expm1_val2 = expm1(VSTH_EXPM1_VAL2);
		Vsth_expm1_init = 1;
	}
		
	return(0);
}

int
expm1_tf()
{
	int	cnt;
	double	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = expm1(VSTH_EXPM1_VAL1);
		if ( rval != Vsth_expm1_val1 )
		{
			++fails;
		}

		rval = expm1(VSTH_EXPM1_VAL2);
		if ( rval != Vsth_expm1_val2 )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
expm1_ef()
{
	return(0);
}

#endif
