
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_rtg.c	1.3
*
*************************************************************************/

#include "std.h"

#if	( TEST_XPG > 4 )
#include <glob.h>
#endif

#include <grp.h>
#include <math.h>
#include <pwd.h>
#include <stdio.h>
#include <stdlib.h>

#if	( TEST_XPG > 4 )
#include <stropts.h>
#include <sys/resource.h>
#include <sys/time.h>
#endif

#include <sys/types.h>
#include <time.h>

#if	( TEST_XPG > 4 )
#include <ucontext.h>
#endif

#include <unistd.h>

#if	( TEST_XPG > 4 )
#include <utmpx.h>
#include <wchar.h>
#endif

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for gamma()					 ******/

#ifdef	gamma
#undef	gamma
#endif

int
gamma_sf()
{
	return(0);
}

int
gamma_tf()
{
	double	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
gamma_ef()
{
	return(0);
}

#endif
#endif

#if	( TEST_XPG > 4 )

/****** Testset for gcvt()					 ******/

#ifdef	gcvt
#undef	gcvt
#endif

int
gcvt_sf()
{
	return(0);
}

int
gcvt_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
gcvt_ef()
{
	return(0);
}

#endif

/****** Testset for getc()					 ******/

#ifdef	getc
#undef	getc
#endif

int
getc_sf()
{
	return(0);
}

int
getc_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getc_ef()
{
	return(0);
}

/****** Testset for getc_unlocked()				 ******/

#ifdef	getc_unlocked
#undef	getc_unlocked
#endif

int
getc_unlocked_sf()
{
	return(0);
}

int
getc_unlocked_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getc_unlocked_ef()
{
	return(0);
}

/****** Testset for getchar()					 ******/

#ifdef	getchar
#undef	getchar
#endif

int
getchar_sf()
{
	return(0);
}

int
getchar_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getchar_ef()
{
	return(0);
}

/****** Testset for getchar_unlocked()				 ******/

#ifdef	getchar_unlocked
#undef	getchar_unlocked
#endif

int
getchar_unlocked_sf()
{
	return(0);
}

int
getchar_unlocked_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getchar_unlocked_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for getcontext()				 ******/

#ifdef	getcontext
#undef	getcontext
#endif

int
getcontext_sf()
{
	return(0);
}

int
getcontext_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getcontext_ef()
{
	return(0);
}

#endif

/****** Testset for getcwd()					 ******/

#ifdef	getcwd
#undef	getcwd
#endif

int
getcwd_sf()
{
	return(0);
}

int
getcwd_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getcwd_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for getdate()					 ******/

#ifdef	getdate
#undef	getdate
#endif

int
getdate_sf()
{
	return(0);
}

int
getdate_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getdate_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for getdtablesize()				 ******/

#ifdef	getdtablesize
#undef	getdtablesize
#endif

int
getdtablesize_sf()
{
	return(0);
}

int
getdtablesize_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getdtablesize_ef()
{
	return(0);
}

#endif
#endif

/****** Testset for getegid()					 ******/

#ifdef	getegid
#undef	getegid
#endif

int
getegid_sf()
{
	return(0);
}

int
getegid_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getegid_ef()
{
	return(0);
}

/****** Testset for getenv()					 ******/

#ifdef	getenv
#undef	getenv
#endif

int
getenv_sf()
{
	return(0);
}

int
getenv_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getenv_ef()
{
	return(0);
}

/****** Testset for geteuid()					 ******/

#ifdef	geteuid
#undef	geteuid
#endif

int
geteuid_sf()
{
	return(0);
}

int
geteuid_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
geteuid_ef()
{
	return(0);
}

/****** Testset for getgid()					 ******/

#ifdef	getgid
#undef	getgid
#endif

int
getgid_sf()
{
	return(0);
}

int
getgid_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getgid_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for getgrent()					 ******/

#ifdef	getgrent
#undef	getgrent
#endif

int
getgrent_sf()
{
	return(0);
}

int
getgrent_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getgrent_ef()
{
	return(0);
}

#endif

/****** Testset for getgrgid()					 ******/

#ifdef	getgrgid
#undef	getgrgid
#endif

int
getgrgid_sf()
{
	return(0);
}

int
getgrgid_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getgrgid_ef()
{
	return(0);
}

#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)

/****** Testset for getgrgid_r()				 ******/

#ifdef	getgrgid_r
#undef	getgrgid_r
#endif

int
getgrgid_r_sf()
{
	return(0);
}

int
getgrgid_r_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getgrgid_r_ef()
{
	return(0);
}

#endif

/****** Testset for getgrnam()					 ******/

#ifdef	getgrnam
#undef	getgrnam
#endif

int
getgrnam_sf()
{
	return(0);
}

int
getgrnam_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getgrnam_ef()
{
	return(0);
}

#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)

/****** Testset for getgrnam_r()				 ******/

#ifdef	getgrnam_r
#undef	getgrnam_r
#endif

int
getgrnam_r_sf()
{
	return(0);
}

int
getgrnam_r_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getgrnam_r_ef()
{
	return(0);
}

#endif

/****** Testset for getgroups()					 ******/

#ifdef	getgroups
#undef	getgroups
#endif

int
getgroups_sf()
{
	return(0);
}

int
getgroups_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getgroups_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for gethostid()					 ******/

#ifdef	gethostid
#undef	gethostid
#endif

int
gethostid_sf()
{
	return(0);
}

int
gethostid_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
gethostid_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for getitimer()					 ******/

#ifdef	getitimer
#undef	getitimer
#endif

int
getitimer_sf()
{
	return(0);
}

int
getitimer_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getitimer_ef()
{
	return(0);
}

#endif

/****** Testset for getlogin()					 ******/

#ifdef	getlogin
#undef	getlogin
#endif

int
getlogin_sf()
{
	return(0);
}

int
getlogin_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getlogin_ef()
{
	return(0);
}

#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)

/****** Testset for getlogin_r()				 ******/

#ifdef	getlogin_r
#undef	getlogin_r
#endif

int
getlogin_r_sf()
{
	return(0);
}

int
getlogin_r_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getlogin_r_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for getmsg()					 ******/

#ifdef	getmsg
#undef	getmsg
#endif

int
getmsg_sf()
{
	return(0);
}

int
getmsg_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getmsg_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for getopt()					 ******/

#ifdef	getopt
#undef	getopt
#endif

int
getopt_sf()
{
	return(0);
}

int
getopt_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getopt_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for getpagesize()				 ******/

#ifdef	getpagesize
#undef	getpagesize
#endif

int
getpagesize_sf()
{
	return(0);
}

int
getpagesize_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getpagesize_ef()
{
	return(0);
}

#endif
#endif

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for getpass()					 ******/

#ifdef	getpass
#undef	getpass
#endif

int
getpass_sf()
{
	return(0);
}

int
getpass_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getpass_ef()
{
	return(0);
}

#endif
#endif

#if	( TEST_XPG > 4 )

/****** Testset for getpgid()					 ******/

#ifdef	getpgid
#undef	getpgid
#endif

int
getpgid_sf()
{
	return(0);
}

int
getpgid_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getpgid_ef()
{
	return(0);
}

#endif

/****** Testset for getpgrp()					 ******/

#ifdef	getpgrp
#undef	getpgrp
#endif

int
getpgrp_sf()
{
	return(0);
}

int
getpgrp_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getpgrp_ef()
{
	return(0);
}

/****** Testset for getpid()					 ******/

#ifdef	getpid
#undef	getpid
#endif

int
getpid_sf()
{
	return(0);
}

int
getpid_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getpid_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for getpmsg()					 ******/

#ifdef	getpmsg
#undef	getpmsg
#endif

int
getpmsg_sf()
{
	return(0);
}

int
getpmsg_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getpmsg_ef()
{
	return(0);
}

#endif

/****** Testset for getppid()					 ******/

#ifdef	getppid
#undef	getppid
#endif

int
getppid_sf()
{
	return(0);
}

int
getppid_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getppid_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for getpriority()				 ******/

#ifdef	getpriority
#undef	getpriority
#endif

int
getpriority_sf()
{
	return(0);
}

int
getpriority_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getpriority_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for getpwent()					 ******/

#ifdef	getpwent
#undef	getpwent
#endif

int
getpwent_sf()
{
	return(0);
}

int
getpwent_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getpwent_ef()
{
	return(0);
}

#endif

/****** Testset for getpwnam()					 ******/

#ifdef	getpwnam
#undef	getpwnam
#endif

int
getpwnam_sf()
{
	return(0);
}

int
getpwnam_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getpwnam_ef()
{
	return(0);
}

#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)

/****** Testset for getpwnam_r()				 ******/

#ifdef	getpwnam_r
#undef	getpwnam_r
#endif

int
getpwnam_r_sf()
{
	return(0);
}

int
getpwnam_r_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getpwnam_r_ef()
{
	return(0);
}

#endif

/****** Testset for getpwuid()					 ******/

#ifdef	getpwuid
#undef	getpwuid
#endif

int
getpwuid_sf()
{
	return(0);
}

int
getpwuid_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getpwuid_ef()
{
	return(0);
}

#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)

/****** Testset for getpwuid_r()				 ******/

#ifdef	getpwuid_r
#undef	getpwuid_r
#endif

int
getpwuid_r_sf()
{
	return(0);
}

int
getpwuid_r_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getpwuid_r_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for getrlimit()					 ******/

#ifdef	getrlimit
#undef	getrlimit
#endif

int
getrlimit_sf()
{
	return(0);
}

int
getrlimit_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getrlimit_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for getrusage()					 ******/

#ifdef	getrusage
#undef	getrusage
#endif

int
getrusage_sf()
{
	return(0);
}

int
getrusage_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getrusage_ef()
{
	return(0);
}

#endif

/****** Testset for gets()					 ******/

#ifdef	gets
#undef	gets
#endif

int
gets_sf()
{
	return(0);
}

int
gets_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
gets_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for getsid()					 ******/

#ifdef	getsid
#undef	getsid
#endif

int
getsid_sf()
{
	return(0);
}

int
getsid_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getsid_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for getsubopt()					 ******/

#ifdef	getsubopt
#undef	getsubopt
#endif

int
getsubopt_sf()
{
	return(0);
}

int
getsubopt_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getsubopt_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for gettimeofday()				 ******/

#ifdef	gettimeofday
#undef	gettimeofday
#endif

int
gettimeofday_sf()
{
	return(0);
}

int
gettimeofday_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
gettimeofday_ef()
{
	return(0);
}

#endif

/****** Testset for getuid()					 ******/

#ifdef	getuid
#undef	getuid
#endif

int
getuid_sf()
{
	return(0);
}

int
getuid_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getuid_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for getutxent()					 ******/

#ifdef	getutxent
#undef	getutxent
#endif

int
getutxent_sf()
{
	return(0);
}

int
getutxent_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getutxent_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for getutxid()					 ******/

#ifdef	getutxid
#undef	getutxid
#endif

int
getutxid_sf()
{
	return(0);
}

int
getutxid_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getutxid_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for getutxline()				 ******/

#ifdef	getutxline
#undef	getutxline
#endif

int
getutxline_sf()
{
	return(0);
}

int
getutxline_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getutxline_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for getw()					 ******/

#ifdef	getw
#undef	getw
#endif

int
getw_sf()
{
	return(0);
}

int
getw_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getw_ef()
{
	return(0);
}

#endif
#endif

#if	( TEST_XPG > 4 )

/****** Testset for getwc()					 ******/

#ifdef	getwc
#undef	getwc
#endif

int
getwc_sf()
{
	return(0);
}

int
getwc_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getwc_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for getwchar()					 ******/

#ifdef	getwchar
#undef	getwchar
#endif

int
getwchar_sf()
{
	return(0);
}

int
getwchar_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getwchar_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for getwd()					 ******/

#ifdef	getwd
#undef	getwd
#endif

int
getwd_sf()
{
	return(0);
}

int
getwd_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
getwd_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for glob()					 ******/

#ifdef	glob
#undef	glob
#endif

int
glob_sf()
{
	return(0);
}

int
glob_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
glob_ef()
{
	return(0);
}

#endif

/****** Testset for gmtime()					 ******/

#ifdef	gmtime
#undef	gmtime
#endif

int
gmtime_sf()
{
	return(0);
}

int
gmtime_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
gmtime_ef()
{
	return(0);
}

#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)

/****** Testset for gmtime_r()					 ******/

#ifdef	gmtime_r
#undef	gmtime_r
#endif

int
gmtime_r_sf()
{
	return(0);
}

int
gmtime_r_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
gmtime_r_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for grantpt()					 ******/

#ifdef	grantpt
#undef	grantpt
#endif

int
grantpt_sf()
{
	return(0);
}

int
grantpt_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
grantpt_ef()
{
	return(0);
}

#endif
