
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_rth.c	1.2
*
*************************************************************************/

#include "std.h"

#include <math.h>

#if	( TEST_XPG > 4 )
#include <search.h>
#endif

#include <stdio.h>
#include <unistd.h>

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"

#if	( TEST_XPG > 4 )

/****** Testset for hcreate()					 ******/

#ifdef	hcreate
#undef	hcreate
#endif

int
hcreate_sf()
{
	return(0);
}

int
hcreate_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
hcreate_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for hdestroy()					 ******/

#ifdef	hdestroy
#undef	hdestroy
#endif

int
hdestroy_sf()
{
	return(0);
}

int
hdestroy_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
hdestroy_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for hsearch()					 ******/

#ifdef	hsearch
#undef	hsearch
#endif

int
hsearch_sf()
{
	return(0);
}

int
hsearch_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
hsearch_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for hypot()					 ******/

#ifdef	hypot
#undef	hypot
#endif

#define	VSTH_HYPOT_VAL1		-0.2
#define	VSTH_HYPOT_VAL2		0.5
int	Vsth_hypot_init = 0;
double	Vsth_hypot_val1;
double	Vsth_hypot_val2;

int
hypot_sf()
{
	if ( ! Vsth_hypot_init )
	{
		Vsth_hypot_val1 = hypot(VSTH_HYPOT_VAL1, VSTH_HYPOT_VAL1);
		Vsth_hypot_val2 = hypot(VSTH_HYPOT_VAL2, VSTH_HYPOT_VAL2);
		Vsth_hypot_init = 1;
	}
		
	return(0);
}

int
hypot_tf()
{
	int	cnt;
	double	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = hypot(VSTH_HYPOT_VAL1, VSTH_HYPOT_VAL1);
		if ( rval != Vsth_hypot_val1 )
		{
			++errs;
		}

		rval = hypot(VSTH_HYPOT_VAL2, VSTH_HYPOT_VAL2);
		if ( rval != Vsth_hypot_val2 )
		{
			++errs;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
hypot_ef()
{
	return(0);
}

#endif
