
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_rti.c	1.8
*
*************************************************************************/

#include "std.h"

#include <ctype.h>

#if	( TEST_XPG > 4 )
#include <iconv.h>
#endif

#include <locale.h>
#include <math.h>

#if	( TEST_XPG > 4 )
#include <search.h>
#endif

#include <stdio.h>
#include <stdlib.h>

#if	( TEST_XPG > 4 )
#include <strings.h>
#include <stropts.h>
#endif

#include <unistd.h>

#if	( TEST_XPG > 4 )
#include <wctype.h>
#endif

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"

#if	( TEST_XPG > 4 )

/****** Testset for iconv()					 ******/

#ifdef	iconv
#undef	iconv
#endif

int
iconv_sf()
{
	return(0);
}

int
iconv_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
iconv_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for iconv_close()				 ******/

#ifdef	iconv_close
#undef	iconv_close
#endif

int
iconv_close_sf()
{
	return(0);
}

int
iconv_close_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
iconv_close_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for iconv_open()				 ******/

#ifdef	iconv_open
#undef	iconv_open
#endif

int
iconv_open_sf()
{
	return(0);
}

int
iconv_open_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
iconv_open_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for ilogb()					 ******/

#ifdef	ilogb
#undef	ilogb
#endif

#define	VSTH_ILOGB_VAL1		-2.2
#define	VSTH_ILOGB_VAL2		5.5
int	Vsth_ilogb_init = 0;
int	Vsth_ilogb_val1;
int	Vsth_ilogb_val2;

int
ilogb_sf()
{
	if ( ! Vsth_ilogb_init )
	{
		Vsth_ilogb_val1 = ilogb(VSTH_ILOGB_VAL1);
		Vsth_ilogb_val2 = ilogb(VSTH_ILOGB_VAL2);
		Vsth_ilogb_init = 1;
	}
		
	return(0);
}

int
ilogb_tf()
{
	int	cnt;
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = ilogb(VSTH_ILOGB_VAL1);
		if ( rval != Vsth_ilogb_val1 )
		{
			++fails;
		}

		rval = ilogb(VSTH_ILOGB_VAL2);
		if ( rval != Vsth_ilogb_val2 )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ilogb_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for index()					 ******/

#ifdef	index
#undef	index
#endif

int
index_sf()
{
	return(0);
}

int
index_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
index_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for initstate()					 ******/

#ifdef	initstate
#undef	initstate
#endif

int
initstate_sf()
{
	return(0);
}

int
initstate_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
initstate_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for insque()					 ******/

#ifdef	insque
#undef	insque
#endif

int
insque_sf()
{
	return(0);
}

int
insque_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
insque_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for ioctl()					 ******/

#ifdef	ioctl
#undef	ioctl
#endif

int
ioctl_sf()
{
	return(0);
}

int
ioctl_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ioctl_ef()
{
	return(0);
}

#endif

/****** Testset for isalnum()					 ******/

#ifdef	isalnum
#undef	isalnum
#endif

int
isalnum_sf()
{
	return(0);
}

int
isalnum_tf()
{
	int	cnt;
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = isalnum(0);
		if ( rval )
		{
			++fails;
		}
	
		rval = isalnum('1');
		if ( rval == 0 )
		{
			++fails;
		}
	
		rval = isalnum('A');
		if ( rval == 0 )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
isalnum_ef()
{
	return(0);
}

/****** Testset for isalpha()					 ******/

#ifdef	isalpha
#undef	isalpha
#endif

int
isalpha_sf()
{
	return(0);
}

int
isalpha_tf()
{
	int	cnt;
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = isalpha(0);
		if ( rval )
		{
			++fails;
		}
	
		rval = isalpha('X');
		if ( rval == 0 )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
isalpha_ef()
{
	return(0);
}

/****** Testset for isascii()					 ******/

#ifdef	isascii
#undef	isascii
#endif

int
isascii_sf()
{
	return(0);
}

int
isascii_tf()
{
	int	cnt;
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = isascii(0xff);
		if ( rval )
		{
			++fails;
		}
	
		rval = isascii('X');
		if ( rval == 0 )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
isascii_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for isastream()					 ******/

#ifdef	isastream
#undef	isastream
#endif

int
isastream_sf()
{
	char	*s;
	return(0);
}

int
isastream_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
isastream_ef()
{
	return(0);
}

#endif

/****** Testset for isatty()					 ******/

#ifdef	isatty
#undef	isatty
#endif

int	Vsth_isatty_init = 0;
int	Vsth_isatty_fd;

int
isatty_sf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	if ( ! Vsth_isatty_init )
	{
		Vsth_isatty_fd = fileno(stdin);
		Vsth_isatty_init = 1;
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
isatty_tf()
{
	int	cnt;
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = isatty(Vsth_isatty_fd);
		if ( rval == 0 )
		{
			++fails;
		}
	
		rval = isatty(-1);
		if ( rval )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
isatty_ef()
{
	return(0);
}

/****** Testset for iscntrl()					 ******/

#ifdef	iscntrl
#undef	iscntrl
#endif

int
iscntrl_sf()
{
	return(0);
}

int
iscntrl_tf()
{
	int	cnt;
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = iscntrl(0);
		if ( rval == 0 )
		{
			++fails;
		}
	
		rval = iscntrl('X');
		if ( rval )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
iscntrl_ef()
{
	return(0);
}

/****** Testset for isdigit()					 ******/

#ifdef	isdigit
#undef	isdigit
#endif

int
isdigit_sf()
{
	return(0);
}

int
isdigit_tf()
{
	int	cnt;
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = isdigit('9');
		if ( rval == 0 )
		{
			++fails;
		}
	
		rval = isdigit('X');
		if ( rval )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
isdigit_ef()
{
	return(0);
}

/****** Testset for isgraph()					 ******/

#ifdef	isgraph
#undef	isgraph
#endif

int
isgraph_sf()
{
	return(0);
}

int
isgraph_tf()
{
	int	cnt;
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = isgraph(0);
		if ( rval )
		{
			++fails;
		}
	
		rval = isgraph('x');
		if ( ! rval )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
isgraph_ef()
{
	return(0);
}

/****** Testset for islower()					 ******/

#ifdef	islower
#undef	islower
#endif

int
islower_sf()
{
	return(0);
}

int
islower_tf()
{
	int	cnt;
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = islower('a');
		if ( rval == 0 )
		{
			++fails;
		}
	
		rval = islower('A');
		if ( rval )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
islower_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for isnan()					 ******/

#ifdef	isnan
#undef	isnan
#endif

double	Vsth_nan;

int
isnan_sf()
{
	Vsth_nan = sqrt(-1.0);
	return(0);
}

int
isnan_tf()
{
	int	cnt;
	int	rval;
	int	val;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		val = isnan(Vsth_nan);
		if ( val != 1 )
		{
			++fails;
		}
	
		val = isnan(0);
		if ( val != 0 )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
isnan_ef()
{
	return(0);
}

#endif

/****** Testset for isprint()					 ******/

#ifdef	isprint
#undef	isprint
#endif

int
isprint_sf()
{
	return(0);
}

int
isprint_tf()
{
	int	cnt;
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = isprint(0);
		if ( rval )
		{
			++fails;
		}
	
		rval = isprint('X');
		if ( rval == 0 )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
isprint_ef()
{
	return(0);
}

/****** Testset for ispunct()					 ******/

#ifdef	ispunct
#undef	ispunct
#endif

int
ispunct_sf()
{
	return(0);
}

int
ispunct_tf()
{
	int	cnt;
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = ispunct('.');
		if ( rval == 0 )
		{
			++fails;
		}
	
		rval = ispunct(0);
		if ( rval )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ispunct_ef()
{
	return(0);
}

/****** Testset for isspace()					 ******/

#ifdef	isspace
#undef	isspace
#endif

int
isspace_sf()
{
	return(0);
}

int
isspace_tf()
{
	int	cnt;
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = isspace(' ');
		if ( rval == 0 )
		{
			++fails;
		}
	
		rval = isspace('X');
		if ( rval )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
isspace_ef()
{
	return(0);
}

/****** Testset for isupper()					 ******/

#ifdef	isupper
#undef	isupper
#endif

int
isupper_sf()
{
	return(0);
}

int
isupper_tf()
{
	int	cnt;
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = isupper('a');
		if ( rval )
		{
			++fails;
		}
	
		rval = isupper('A');
		if ( ! rval )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
isupper_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for iswalnum()					 ******/

#ifdef	iswalnum
#undef	iswalnum
#endif

int
iswalnum_sf()
{
	return(0);
}

int
iswalnum_tf()
{
	int	rval;
	int	errs;
	int	fails;
	int	cnt;
	int	expval;
	char	mbs[2];
	wchar_t	wc;

	errs	= 0;
	fails	= 0;
	mbs[1]	= '\0';

	for ( cnt = 0; cnt < 256; ++cnt )
	{
		mbs[0]	= cnt;

		rval	= mbtowc( &wc, mbs, VSTH_MBTOWC_MAXBYTES );
		if ( rval >= 0 )
		{
			rval	= iswalnum(wc);
			expval	= isalnum(cnt);
			if ((expval && (!rval)) || ((!expval) && rval))
			{
				++fails;
				tet_printf("char %d, expected %d, got %d",
						cnt, expval, rval);
			}
		}
		else
		{
			++errs;
			tet_infoline("mbtowc failed");
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
iswalnum_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for iswalpha()					 ******/

#ifdef	iswalpha
#undef	iswalpha
#endif

int
iswalpha_sf()
{
	return(0);
}

int
iswalpha_tf()
{
	int	rval;
	int	errs;
	int	cnt;
	int	fails;
	int	expval;
	char	mbs[2];
	wchar_t	wc;

	errs	= 0;
	fails	= 0;
	mbs[1]	= '\0';

	for ( cnt = 0; cnt < 256; ++cnt )
	{
		mbs[0]	= cnt;

		rval	= mbtowc( &wc, mbs, VSTH_MBTOWC_MAXBYTES );
		if ( rval >= 0 )
		{
			rval	= iswalpha(wc);
			expval	= isalpha(cnt);
			if ((expval && (!rval)) || ((!expval) && rval))
			{
				++fails;
				tet_printf("char %d, expected %d, got %d",
						cnt, expval, rval);
			}
		}
		else
		{
			++errs;
			tet_infoline("mbtowc failed");
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
iswalpha_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for iswcntrl()					 ******/

#ifdef	iswcntrl
#undef	iswcntrl
#endif

int
iswcntrl_sf()
{
	return(0);
}

int
iswcntrl_tf()
{
	int	rval;
	int	errs;
	int	fails;
	int	cnt;
	int	expval;
	char	mbs[2];
	wchar_t	wc;

	errs	= 0;
	fails	= 0;
	mbs[1]	= '\0';

	for ( cnt = 0; cnt < 256; ++cnt )
	{
		mbs[0]	= cnt;

		rval	= mbtowc( &wc, mbs, VSTH_MBTOWC_MAXBYTES );
		if ( rval >= 0 )
		{
			rval	= iswcntrl(wc);
			expval	= iscntrl(cnt);
			if ((expval && (!rval)) || ((!expval) && rval))
			{
				++fails;
				tet_printf("char %d, expected %d, got %d",
						cnt, expval, rval);
			}
		}
		else
		{
			++errs;
			tet_infoline("mbtowc failed");
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
iswcntrl_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for iswdigit()					 ******/

#ifdef	iswdigit
#undef	iswdigit
#endif

int
iswdigit_sf()
{
	return(0);
}

int
iswdigit_tf()
{
	int	rval;
	int	errs;
	int	fails;
	int	cnt;
	int	expval;
	char	mbs[2];
	wchar_t	wc;

	errs	= 0;
	fails	= 0;
	mbs[1]	= '\0';

	for ( cnt = 0; cnt < 256; ++cnt )
	{
		mbs[0]	= cnt;

		rval	= mbtowc( &wc, mbs, VSTH_MBTOWC_MAXBYTES );
		if ( rval >= 0 )
		{
			rval	= iswdigit(wc);
			expval	= isdigit(cnt);
			if ((expval && (!rval)) || ((!expval) && rval))
			{
				++fails;
				tet_printf("char %d, expected %d, got %d",
						cnt, expval, rval);
			}
		}
		else
		{
			++errs;
			tet_infoline("mbtowc failed");
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
iswdigit_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for iswgraph()					 ******/

#ifdef	iswgraph
#undef	iswgraph
#endif

int
iswgraph_sf()
{
	return(0);
}

int
iswgraph_tf()
{
	int	rval;
	int	errs;
	int	fails;
	int	cnt;
	int	expval;
	char	mbs[2];
	wchar_t	wc;

	errs	= 0;
	fails	= 0;
	mbs[1]	= '\0';

	for ( cnt = 0; cnt < 256; ++cnt )
	{
		mbs[0]	= cnt;

		rval	= mbtowc( &wc, mbs, VSTH_MBTOWC_MAXBYTES );
		if ( rval >= 0 )
		{
			rval	= iswgraph(wc);
			expval	= isgraph(cnt);
			if ((expval && (!rval)) || ((!expval) && rval))
			{
				++fails;
				tet_printf("char %d, expected %d, got %d",
						cnt, expval, rval);
			}
		}
		else
		{
			++errs;
			tet_infoline("mbtowc failed");
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
iswgraph_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for iswlower()					 ******/

#ifdef	iswlower
#undef	iswlower
#endif

int
iswlower_sf()
{
	return(0);
}

int
iswlower_tf()
{
	int	rval;
	int	errs;
	int	fails;
	int	cnt;
	int	expval;
	char	mbs[2];
	wchar_t	wc;

	errs	= 0;
	fails	= 0;
	mbs[1]	= '\0';

	for ( cnt = 0; cnt < 256; ++cnt )
	{
		mbs[0]	= cnt;

		rval	= mbtowc( &wc, mbs, VSTH_MBTOWC_MAXBYTES );
		if ( rval >= 0 )
		{
			rval	= iswlower(wc);
			expval	= islower(cnt);
			if ((expval && (!rval)) || ((!expval) && rval))
			{
				++fails;
				tet_printf("char %d, expected %d, got %d",
						cnt, expval, rval);
			}
		}
		else
		{
			++errs;
			tet_infoline("mbtowc failed");
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
iswlower_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for iswprint()					 ******/

#ifdef	iswprint
#undef	iswprint
#endif

int
iswprint_sf()
{
	return(0);
}

int
iswprint_tf()
{
	int	rval;
	int	errs;
	int	fails;
	int	cnt;
	int	expval;
	char	mbs[2];
	wchar_t	wc;

	errs	= 0;
	fails	= 0;
	mbs[1]	= '\0';

	for ( cnt = 0; cnt < 256; ++cnt )
	{
		mbs[0]	= cnt;

		rval	= mbtowc( &wc, mbs, VSTH_MBTOWC_MAXBYTES );
		if ( rval >= 0 )
		{
			rval	= iswprint(wc);
			expval	= isprint(cnt);
			if ((expval && (!rval)) || ((!expval) && rval))
			{
				++fails;
				tet_printf("char %d, expected %d, got %d",
						cnt, expval, rval);
			}
		}
		else
		{
			++errs;
			tet_infoline("mbtowc failed");
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
iswprint_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for iswpunct()					 ******/

#ifdef	iswpunct
#undef	iswpunct
#endif

int
iswpunct_sf()
{
	return(0);
}

int
iswpunct_tf()
{
	int	rval;
	int	errs;
	int	fails;
	int	cnt;
	int	expval;
	char	mbs[2];
	wchar_t	wc;

	errs	= 0;
	fails	= 0;
	mbs[1]	= '\0';

	for ( cnt = 0; cnt < 256; ++cnt )
	{
		mbs[0]	= cnt;

		rval	= mbtowc( &wc, mbs, VSTH_MBTOWC_MAXBYTES );
		if ( rval >= 0 )
		{
			rval	= iswpunct(wc);
			expval	= ispunct(cnt);
			if ((expval && (!rval)) || ((!expval) && rval))
			{
				++fails;
				tet_printf("char %d, expected %d, got %d",
						cnt, expval, rval);
			}
		}
		else
		{
			++errs;
			tet_infoline("mbtowc failed");
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
iswpunct_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for iswspace()					 ******/

#ifdef	iswspace
#undef	iswspace
#endif

int
iswspace_sf()
{
	return(0);
}

int
iswspace_tf()
{
	int	rval;
	int	errs;
	int	fails;
	int	cnt;
	int	expval;
	char	mbs[2];
	wchar_t	wc;

	errs	= 0;
	fails	= 0;
	mbs[1]	= '\0';

	for ( cnt = 0; cnt < 256; ++cnt )
	{
		mbs[0]	= cnt;

		rval	= mbtowc( &wc, mbs, VSTH_MBTOWC_MAXBYTES );
		if ( rval >= 0 )
		{
			rval	= iswspace(wc);
			expval	= isspace(cnt);
			if ((expval && (!rval)) || ((!expval) && rval))
			{
				++fails;
				tet_printf("char %d, expected %d, got %d",
						cnt, expval, rval);
			}
		}
		else
		{
			++errs;
			tet_infoline("mbtowc failed");
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
iswspace_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for iswupper()					 ******/

#ifdef	iswupper
#undef	iswupper
#endif

int
iswupper_sf()
{
	return(0);
}

int
iswupper_tf()
{
	int	rval;
	int	errs;
	int	fails;
	int	cnt;
	int	expval;
	char	mbs[2];
	wchar_t	wc;

	errs	= 0;
	fails	= 0;
	mbs[1]	= '\0';

	for ( cnt = 0; cnt < 256; ++cnt )
	{
		mbs[0]	= cnt;

		rval	= mbtowc( &wc, mbs, VSTH_MBTOWC_MAXBYTES );
		if ( rval >= 0 )
		{
			rval	= iswupper(wc);
			expval	= isupper(cnt);
			if ((expval && (!rval)) || ((!expval) && rval))
			{
				++fails;
				tet_printf("char %d, expected %d, got %d",
						cnt, expval, rval);
			}
		}
		else
		{
			++errs;
			tet_infoline("mbtowc failed");
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
iswupper_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for iswctype()					 ******/

#ifdef	iswctype
#undef	iswctype
#endif

int
iswctype_sf()
{
	return(0);
}

int
iswctype_tf()
{
	int	rval;
	int	errs;
	int	cnt;
	int	fails;
	int	expval;
	char	mbs[2];
	wchar_t	wc;

	errs	= 0;
	fails	= 0;
	mbs[1]	= '\0';

	for ( cnt = 0; cnt < 256; ++cnt )
	{
		mbs[0]	= cnt;

		rval	= mbtowc( &wc, mbs, VSTH_MBTOWC_MAXBYTES );
		if ( rval >= 0 )
		{
			rval	= iswctype(wc, wctype("alnum"));
			expval	= isalnum(cnt);
			if ((expval && (!rval)) || ((!expval) && rval))
			{
				++fails;
				tet_printf("char %d, expected %d, got %d",
						cnt, expval, rval);
			}
		}
		else
		{
			++errs;
			tet_infoline("mbtowc failed");
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
iswctype_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for iswxdigit()					 ******/

#ifdef	iswxdigit
#undef	iswxdigit
#endif

int
iswxdigit_sf()
{
	return(0);
}

int
iswxdigit_tf()
{
	int	rval;
	int	errs;
	int	fails;
	int	cnt;
	int	expval;
	char	mbs[2];
	wchar_t	wc;

	errs	= 0;
	fails	= 0;
	mbs[1]	= '\0';

	for ( cnt = 0; cnt < 256; ++cnt )
	{
		mbs[0]	= cnt;

		rval	= mbtowc( &wc, mbs, VSTH_MBTOWC_MAXBYTES );
		if ( rval >= 0 )
		{
			rval	= iswxdigit(wc);
			expval	= isxdigit(cnt);
			if ((expval && (!rval)) || ((!expval) && rval))
			{
				++fails;
				tet_printf("char %d, expected %d, got %d",
						cnt, expval, rval);
			}
		}
		else
		{
			++errs;
			tet_infoline("mbtowc failed");
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
iswxdigit_ef()
{
	return(0);
}

#endif
