
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_rtj.c	1.4
*
*************************************************************************/

#include "std.h"

#include <math.h>
#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"

#if	( TEST_XPG > 4 )

/****** Testset for j0()					 ******/

#ifdef	j0
#undef	j0
#endif

#define	VSTH_J0_VAL1		2.2
#define	VSTH_J0_VAL2		5.5
int	Vsth_j0_init = 0;
double	Vsth_j0_val1;
double	Vsth_j0_val2;

int
j0_sf()
{
	if ( ! Vsth_j0_init )
	{
		Vsth_j0_val1 = j0(VSTH_J0_VAL1);
		Vsth_j0_val2 = j0(VSTH_J0_VAL2);
		Vsth_j0_init = 1;
	}
		
	return(0);
}

int
j0_tf()
{
	int	cnt;
	double	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = j0(VSTH_J0_VAL1);
		if ( rval != Vsth_j0_val1 )
		{
			++fails;
		}

		rval = j0(VSTH_J0_VAL2);
		if ( rval != Vsth_j0_val2 )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
j0_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for j1()					 ******/

#ifdef	j1
#undef	j1
#endif

#define	VSTH_J1_VAL1		2.2
#define	VSTH_J1_VAL2		5.5
int	Vsth_j1_init = 0;
double	Vsth_j1_val1;
double	Vsth_j1_val2;

int
j1_sf()
{
	if ( ! Vsth_j1_init )
	{
		Vsth_j1_val1 = j1(VSTH_J1_VAL1);
		Vsth_j1_val2 = j1(VSTH_J1_VAL2);
		Vsth_j1_init = 1;
	}
		
	return(0);
}

int
j1_tf()
{
	int	cnt;
	double	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = j1(VSTH_J1_VAL1);
		if ( rval != Vsth_j1_val1 )
		{
			++fails;
		}

		rval = j1(VSTH_J1_VAL2);
		if ( rval != Vsth_j1_val2 )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
j1_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for jn()					 ******/

#ifdef	jn
#undef	jn
#endif

#define	VSTH_JN_VAL1		2.2
#define	VSTH_JN_VAL2		5.5
int	Vsth_jn_init = 0;
double	Vsth_jn_val1;
double	Vsth_jn_val2;

int
jn_sf()
{
	if ( ! Vsth_jn_init )
	{
		Vsth_jn_val1 = jn( 3, VSTH_JN_VAL1);
		Vsth_jn_val2 = jn( 3, VSTH_JN_VAL2);
		Vsth_jn_init = 1;
	}
		
	return(0);
}

int
jn_tf()
{
	int	cnt;
	double	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = jn( 3, VSTH_JN_VAL1);
		if ( rval != Vsth_jn_val1 )
		{
			++fails;
		}

		rval = jn( 3, VSTH_JN_VAL2);
		if ( rval != Vsth_jn_val2 )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
jn_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for jrand48()					 ******/

#ifdef	jrand48
#undef	jrand48
#endif

long			Vsth_jrand48_val1;
long			Vsth_jrand48_val2;

int
jrand48_sf()
{
	unsigned short int	xsubi1[3];
	unsigned short int	xsubi2[3];

	xsubi1[0] = 0x10;
	xsubi1[1] = 0x11;
	xsubi1[2] = 0x12;

	xsubi2[0] = 0x01;
	xsubi2[1] = 0x11;
	xsubi2[2] = 0x21;

	Vsth_jrand48_val1 = jrand48(&xsubi1[0]);
	Vsth_jrand48_val2 = jrand48(&xsubi2[0]);

	return(0);
}

int
jrand48_tf()
{
	int			cnt;
	int			rval;
	int			errs;
	int			fails;
	long			val1;
	long			val2;
	unsigned short int	xsubi1[3];
	unsigned short int	xsubi2[3];

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{

		xsubi1[0] = 0x10;
		xsubi1[1] = 0x11;
		xsubi1[2] = 0x12;

		xsubi2[0] = 0x01;
		xsubi2[1] = 0x11;
		xsubi2[2] = 0x21;

		val1 = jrand48(&xsubi1[0]);
		if ( val1 != Vsth_jrand48_val1 )
		{
			++fails;
		}

		val2 = jrand48(&xsubi2[0]);
		if ( val2 != Vsth_jrand48_val2 )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
jrand48_ef()
{
	return(0);
}

#endif
