
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_rtm.c	1.7
*
*
* CHANGE HISTORY
*	12 May 1999 - Incorporate SR#104, to require ifdefs around mqueue.h
*************************************************************************/

#include "std.h"

#include <math.h>
#include <unistd.h>

#if	defined(_POSIX_MESSAGE_PASSING)
#include <mqueue.h>
#endif
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/mman.h>

#if	( TEST_XPG > 4 )
#include <sys/msg.h>
#endif

#include <sys/stat.h>
#include <sys/types.h>
#include <time.h>

#if	( TEST_XPG > 4 )
#include <ucontext.h>
#include <wchar.h>
#endif

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"

#if	( TEST_XPG > 4 )

/****** Testset for makecontext()				 ******/

#ifdef	makecontext
#undef	makecontext
#endif

int
makecontext_sf()
{
	return(0);
}

int
makecontext_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
makecontext_ef()
{
	return(0);
}

#endif

/****** Testset for malloc()					 ******/

#ifdef	malloc
#undef	malloc
#endif

int
malloc_sf()
{
	return(0);
}

int
malloc_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
malloc_ef()
{
	return(0);
}

/****** Testset for mblen()					 ******/

#ifdef	mblen
#undef	mblen
#endif

int
mblen_sf()
{
	return(0);
}

int
mblen_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mblen_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for mbrlen()					 ******/

#ifdef	mbrlen
#undef	mbrlen
#endif

int
mbrlen_sf()
{
	return(0);
}

int
mbrlen_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mbrlen_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for mbrtowc()					 ******/

#ifdef	mbrtowc
#undef	mbrtowc
#endif

int
mbrtowc_sf()
{
	return(0);
}

int
mbrtowc_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mbrtowc_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for mbsinit()					 ******/

#ifdef	mbsinit
#undef	mbsinit
#endif

int
mbsinit_sf()
{
	return(0);
}

int
mbsinit_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mbsinit_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for mbsrtowcs()					 ******/

#ifdef	mbsrtowcs
#undef	mbsrtowcs
#endif

int
mbsrtowcs_sf()
{
	return(0);
}

int
mbsrtowcs_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mbsrtowcs_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for mbstowcs()					 ******/

#ifdef	mbstowcs
#undef	mbstowcs
#endif

int
mbstowcs_sf()
{
	return(0);
}

int
mbstowcs_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mbstowcs_ef()
{
	return(0);
}

#endif

/****** Testset for mbtowc()					 ******/

#ifdef	mbtowc
#undef	mbtowc
#endif

int
mbtowc_sf()
{
	return(0);
}

int
mbtowc_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mbtowc_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for memccpy()					 ******/

#ifdef	memccpy
#undef	memccpy
#endif

int
memccpy_sf()
{
	return(0);
}

int
memccpy_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
memccpy_ef()
{
	return(0);
}

#endif

/****** Testset for memchr()					 ******/

#ifdef	memchr
#undef	memchr
#endif

int
memchr_sf()
{
	return(0);
}

int
memchr_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
memchr_ef()
{
	return(0);
}

/****** Testset for memcmp()					 ******/

#ifdef	memcmp
#undef	memcmp
#endif

int
memcmp_sf()
{
	return(0);
}

int
memcmp_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
memcmp_ef()
{
	return(0);
}

/****** Testset for memcpy()					 ******/

#ifdef	memcpy
#undef	memcpy
#endif

int
memcpy_sf()
{
	return(0);
}

int
memcpy_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
memcpy_ef()
{
	return(0);
}

/****** Testset for memmove()					 ******/

#ifdef	memmove
#undef	memmove
#endif

int
memmove_sf()
{
	return(0);
}

int
memmove_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
memmove_ef()
{
	return(0);
}

/****** Testset for memset()					 ******/

#ifdef	memset
#undef	memset
#endif

int
memset_sf()
{
	return(0);
}

int
memset_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
memset_ef()
{
	return(0);
}

/****** Testset for mkdir()					 ******/

#ifdef	mkdir
#undef	mkdir
#endif

int
mkdir_sf()
{
	return(0);
}

int
mkdir_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mkdir_ef()
{
	return(0);
}

/****** Testset for mkfifo()					 ******/

#ifdef	mkfifo
#undef	mkfifo
#endif

int
mkfifo_sf()
{
	return(0);
}

int
mkfifo_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mkfifo_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for mknod()					 ******/

#ifdef	mknod
#undef	mknod
#endif

int
mknod_sf()
{
	return(0);
}

int
mknod_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mknod_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for mkstemp()					 ******/

#ifdef	mkstemp
#undef	mkstemp
#endif

int
mkstemp_sf()
{
	return(0);
}

int
mkstemp_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mkstemp_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for mktemp()					 ******/

#ifdef	mktemp
#undef	mktemp
#endif

int
mktemp_sf()
{
	return(0);
}

int
mktemp_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mktemp_ef()
{
	return(0);
}

#endif

/****** Testset for mktime()					 ******/

#ifdef	mktime
#undef	mktime
#endif

int
mktime_sf()
{
	return(0);
}

int
mktime_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mktime_ef()
{
	return(0);
}

#if	defined(_POSIX_MEMLOCK_RANGE)

/****** Testset for mlock()					 ******/

#ifdef	mlock
#undef	mlock
#endif

int
mlock_sf()
{
	return(0);
}

int
mlock_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mlock_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_MEMLOCK)

/****** Testset for mlockall()					 ******/

#ifdef	mlockall
#undef	mlockall
#endif

int
mlockall_sf()
{
	return(0);
}

int
mlockall_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mlockall_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_MAPPED_FILES) || defined(_POSIX_SHARED_MEMORY_OBJECTS)

/****** Testset for mmap()					 ******/

#ifdef	mmap
#undef	mmap
#endif

int
mmap_sf()
{
	return(0);
}

int
mmap_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mmap_ef()
{
	return(0);
}

#endif

/****** Testset for modf()					 ******/

#ifdef	modf
#undef	modf
#endif

#define	VSTH_MODF_VAL1		-0.2
#define	VSTH_MODF_VAL2		0.5
int	Vsth_modf_init = 0;
double	Vsth_modf_val1;
double	Vsth_modf_val1i;
double	Vsth_modf_val2;
double	Vsth_modf_val2i;

int
modf_sf()
{
	if ( ! Vsth_modf_init )
	{
		Vsth_modf_val1 = modf(VSTH_MODF_VAL1, &Vsth_modf_val1i);
		Vsth_modf_val2 = modf(VSTH_MODF_VAL2, &Vsth_modf_val2i);
		Vsth_modf_init = 1;
	}
		
	return(0);
}

int
modf_tf()
{
	int	cnt;
	int	errs;
	int	fails;
	double	val;
	double	rval;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = modf(VSTH_MODF_VAL1, &val);
		if ( rval != Vsth_modf_val1 )
		{
			++fails;
		}

		if ( val != Vsth_modf_val1i )
		{
			++fails;
		}

		rval = modf(VSTH_MODF_VAL2, &val);
		if ( rval != Vsth_modf_val2 )
		{
			++fails;
		}

		if ( val != Vsth_modf_val2i )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
modf_ef()
{
	return(0);
}

#if	defined(_POSIX_MEMORY_PROTECTION)

/****** Testset for mprotect()					 ******/

#ifdef	mprotect
#undef	mprotect
#endif

int
mprotect_sf()
{
	return(0);
}

int
mprotect_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mprotect_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_MESSAGE_PASSING)

/****** Testset for mq_close()					 ******/

#ifdef	mq_close
#undef	mq_close
#endif

int
mq_close_sf()
{
	return(0);
}

int
mq_close_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mq_close_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_MESSAGE_PASSING)

/****** Testset for mq_getattr()				 ******/

#ifdef	mq_getattr
#undef	mq_getattr
#endif

int
mq_getattr_sf()
{
	return(0);
}

int
mq_getattr_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mq_getattr_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_MESSAGE_PASSING) && defined(_POSIX_REALTIME_SIGNALS)

/****** Testset for mq_notify()					 ******/

#ifdef	mq_notify
#undef	mq_notify
#endif

int
mq_notify_sf()
{
	return(0);
}

int
mq_notify_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mq_notify_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_MESSAGE_PASSING)

/****** Testset for mq_open()					 ******/

#ifdef	mq_open
#undef	mq_open
#endif

int
mq_open_sf()
{
	return(0);
}

int
mq_open_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mq_open_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_MESSAGE_PASSING)

/****** Testset for mq_receive()				 ******/

#ifdef	mq_receive
#undef	mq_receive
#endif

int
mq_receive_sf()
{
	return(0);
}

int
mq_receive_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mq_receive_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_MESSAGE_PASSING)

/****** Testset for mq_send()					 ******/

#ifdef	mq_send
#undef	mq_send
#endif

int
mq_send_sf()
{
	return(0);
}

int
mq_send_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mq_send_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_MESSAGE_PASSING)

/****** Testset for mq_setattr()				 ******/

#ifdef	mq_setattr
#undef	mq_setattr
#endif

int
mq_setattr_sf()
{
	return(0);
}

int
mq_setattr_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mq_setattr_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_MESSAGE_PASSING)

/****** Testset for mq_unlink()					 ******/

#ifdef	mq_unlink
#undef	mq_unlink
#endif

int
mq_unlink_sf()
{
	return(0);
}

int
mq_unlink_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mq_unlink_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for mrand48()					 ******/

#ifdef	mrand48
#undef	mrand48
#endif

int
mrand48_sf()
{
	return(0);
}

int
mrand48_tf()
{
	int	cnt;
	int	rval;
	int	errs;
	int	fails;
	long	val1;
	long	val2;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
mrand48_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for msgctl()					 ******/

#ifdef	msgctl
#undef	msgctl
#endif

int
msgctl_sf()
{
	return(0);
}

int
msgctl_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
msgctl_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for msgget()					 ******/

#ifdef	msgget
#undef	msgget
#endif

int
msgget_sf()
{
	return(0);
}

int
msgget_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
msgget_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for msgrcv()					 ******/

#ifdef	msgrcv
#undef	msgrcv
#endif

int
msgrcv_sf()
{
	return(0);
}

int
msgrcv_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
msgrcv_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for msgsnd()					 ******/

#ifdef	msgsnd
#undef	msgsnd
#endif

int
msgsnd_sf()
{
	return(0);
}

int
msgsnd_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
msgsnd_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_MAPPED_FILES) && defined(_POSIX_SYNCHRONIZED_IO)

/****** Testset for msync()					 ******/

#ifdef	msync
#undef	msync
#endif

int
msync_sf()
{
	return(0);
}

int
msync_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
msync_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_MEMLOCK_RANGE)

/****** Testset for munlock()					 ******/

#ifdef	munlock
#undef	munlock
#endif

int
munlock_sf()
{
	return(0);
}

int
munlock_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
munlock_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_MEMLOCK)

/****** Testset for munlockall()				 ******/

#ifdef	munlockall
#undef	munlockall
#endif

int
munlockall_sf()
{
	return(0);
}

int
munlockall_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
munlockall_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_MAPPED_FILES) || defined(_POSIX_SHARED_MEMORY_OBJECTS)

/****** Testset for munmap()					 ******/

#ifdef	munmap
#undef	munmap
#endif

int
munmap_sf()
{
	return(0);
}

int
munmap_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
munmap_ef()
{
	return(0);
}

#endif
