
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_rtp.c	1.2
*
*************************************************************************/

#include "std.h"

#include <math.h>

#if	( TEST_XPG > 4 )
#include <poll.h>
#endif

#include <pthread.h>
#include <signal.h>
#include <stdio.h>
#include <stdlib.h>

#if	( TEST_XPG > 4 )
#include <stropts.h>
#endif

#include <sys/types.h>
#include <unistd.h>

#if	( TEST_XPG > 4 )
#include <utmpx.h>
#include <wchar.h>
#endif

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"

/****** Testset for pathconf()					 ******/

#ifdef	pathconf
#undef	pathconf
#endif

int
pathconf_sf()
{
	return(0);
}

int
pathconf_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pathconf_ef()
{
	return(0);
}

/****** Testset for pause()					 ******/

#ifdef	pause
#undef	pause
#endif

int
pause_sf()
{
	return(0);
}

int
pause_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pause_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for pclose()					 ******/

#ifdef	pclose
#undef	pclose
#endif

int
pclose_sf()
{
	return(0);
}

int
pclose_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pclose_ef()
{
	return(0);
}

#endif

/****** Testset for perror()					 ******/

#ifdef	perror
#undef	perror
#endif

int
perror_sf()
{
	return(0);
}

int
perror_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
perror_ef()
{
	return(0);
}

/****** Testset for pipe()					 ******/

#ifdef	pipe
#undef	pipe
#endif

int
pipe_sf()
{
	return(0);
}

int
pipe_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pipe_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for poll()					 ******/

#ifdef	poll
#undef	poll
#endif

int
poll_sf()
{
	return(0);
}

int
poll_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
poll_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for popen()					 ******/

#ifdef	popen
#undef	popen
#endif

int
popen_sf()
{
	return(0);
}

int
popen_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
popen_ef()
{
	return(0);
}

#endif

/****** Testset for pow()					 ******/

#ifdef	pow
#undef	pow
#endif

#define	VSTH_POW_VAL1		2.2
#define	VSTH_POW_VAL2		5.5
int	Vsth_pow_init = 0;
double	Vsth_pow_val1;
double	Vsth_pow_val2;

int
pow_sf()
{
	if ( ! Vsth_pow_init )
	{
		Vsth_pow_val1 = pow(VSTH_POW_VAL1, VSTH_POW_VAL2);
		Vsth_pow_val2 = pow(VSTH_POW_VAL2, VSTH_POW_VAL1);
		Vsth_pow_init = 1;
	}
		
	return(0);
}

int
pow_tf()
{
	int	cnt;
	double	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = pow(VSTH_POW_VAL1, VSTH_POW_VAL2);
		if ( rval != Vsth_pow_val1 )
		{
			++fails;
		}

		rval = pow(VSTH_POW_VAL2, VSTH_POW_VAL1);
		if ( rval != Vsth_pow_val2 )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pow_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for pread()					 ******/

#ifdef	pread
#undef	pread
#endif

int
pread_sf()
{
	return(0);
}

int
pread_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pread_ef()
{
	return(0);
}

#endif

/****** Testset for printf()					 ******/

#ifdef	printf
#undef	printf
#endif

int
printf_sf()
{
	return(0);
}

int
printf_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
printf_ef()
{
	return(0);
}

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_atfork()				 ******/

#ifdef	pthread_atfork
#undef	pthread_atfork
#endif

int
pthread_atfork_sf()
{
	return(0);
}

int
pthread_atfork_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_atfork_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_attr_destroy()			 ******/

#ifdef	pthread_attr_destroy
#undef	pthread_attr_destroy
#endif

int
pthread_attr_destroy_sf()
{
	return(0);
}

int
pthread_attr_destroy_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_attr_destroy_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_attr_getdetachstate()		 ******/

#ifdef	pthread_attr_getdetachstate
#undef	pthread_attr_getdetachstate
#endif

int
pthread_attr_getdetachstate_sf()
{
	return(0);
}

int
pthread_attr_getdetachstate_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_attr_getdetachstate_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for pthread_attr_getguardsize()			 ******/

#ifdef	pthread_attr_getguardsize
#undef	pthread_attr_getguardsize
#endif

int
pthread_attr_getguardsize_sf()
{
	return(0);
}

int
pthread_attr_getguardsize_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_attr_getguardsize_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PRIORITY_SCHEDULING)

/****** Testset for pthread_attr_getinheritsched()		 ******/

#ifdef	pthread_attr_getinheritsched
#undef	pthread_attr_getinheritsched
#endif

int
pthread_attr_getinheritsched_sf()
{
	return(0);
}

int
pthread_attr_getinheritsched_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_attr_getinheritsched_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_attr_getschedparam()		 ******/

#ifdef	pthread_attr_getschedparam
#undef	pthread_attr_getschedparam
#endif

int
pthread_attr_getschedparam_sf()
{
	return(0);
}

int
pthread_attr_getschedparam_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_attr_getschedparam_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PRIORITY_SCHEDULING)

/****** Testset for pthread_attr_getschedpolicy()		 ******/

#ifdef	pthread_attr_getschedpolicy
#undef	pthread_attr_getschedpolicy
#endif

int
pthread_attr_getschedpolicy_sf()
{
	return(0);
}

int
pthread_attr_getschedpolicy_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_attr_getschedpolicy_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PRIORITY_SCHEDULING)

/****** Testset for pthread_attr_getscope()			 ******/

#ifdef	pthread_attr_getscope
#undef	pthread_attr_getscope
#endif

int
pthread_attr_getscope_sf()
{
	return(0);
}

int
pthread_attr_getscope_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_attr_getscope_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_ATTR_STACKADDR)

/****** Testset for pthread_attr_getstackaddr()			 ******/

#ifdef	pthread_attr_getstackaddr
#undef	pthread_attr_getstackaddr
#endif

int
pthread_attr_getstackaddr_sf()
{
	return(0);
}

int
pthread_attr_getstackaddr_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_attr_getstackaddr_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_ATTR_STACKSIZE)

/****** Testset for pthread_attr_getstacksize()			 ******/

#ifdef	pthread_attr_getstacksize
#undef	pthread_attr_getstacksize
#endif

int
pthread_attr_getstacksize_sf()
{
	return(0);
}

int
pthread_attr_getstacksize_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_attr_getstacksize_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_attr_init()				 ******/

#ifdef	pthread_attr_init
#undef	pthread_attr_init
#endif

int
pthread_attr_init_sf()
{
	return(0);
}

int
pthread_attr_init_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_attr_init_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_attr_setdetachstate()		 ******/

#ifdef	pthread_attr_setdetachstate
#undef	pthread_attr_setdetachstate
#endif

int
pthread_attr_setdetachstate_sf()
{
	return(0);
}

int
pthread_attr_setdetachstate_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_attr_setdetachstate_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for pthread_attr_setguardsize()			 ******/

#ifdef	pthread_attr_setguardsize
#undef	pthread_attr_setguardsize
#endif

int
pthread_attr_setguardsize_sf()
{
	return(0);
}

int
pthread_attr_setguardsize_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_attr_setguardsize_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PRIORITY_SCHEDULING)

/****** Testset for pthread_attr_setinheritsched()		 ******/

#ifdef	pthread_attr_setinheritsched
#undef	pthread_attr_setinheritsched
#endif

int
pthread_attr_setinheritsched_sf()
{
	return(0);
}

int
pthread_attr_setinheritsched_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_attr_setinheritsched_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_attr_setschedparam()		 ******/

#ifdef	pthread_attr_setschedparam
#undef	pthread_attr_setschedparam
#endif

int
pthread_attr_setschedparam_sf()
{
	return(0);
}

int
pthread_attr_setschedparam_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_attr_setschedparam_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PRIORITY_SCHEDULING)

/****** Testset for pthread_attr_setschedpolicy()		 ******/

#ifdef	pthread_attr_setschedpolicy
#undef	pthread_attr_setschedpolicy
#endif

int
pthread_attr_setschedpolicy_sf()
{
	return(0);
}

int
pthread_attr_setschedpolicy_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_attr_setschedpolicy_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PRIORITY_SCHEDULING)

/****** Testset for pthread_attr_setscope()			 ******/

#ifdef	pthread_attr_setscope
#undef	pthread_attr_setscope
#endif

int
pthread_attr_setscope_sf()
{
	return(0);
}

int
pthread_attr_setscope_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_attr_setscope_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_ATTR_STACKADDR)

/****** Testset for pthread_attr_setstackaddr()			 ******/

#ifdef	pthread_attr_setstackaddr
#undef	pthread_attr_setstackaddr
#endif

int
pthread_attr_setstackaddr_sf()
{
	return(0);
}

int
pthread_attr_setstackaddr_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_attr_setstackaddr_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_ATTR_STACKSIZE)

/****** Testset for pthread_attr_setstacksize()			 ******/

#ifdef	pthread_attr_setstacksize
#undef	pthread_attr_setstacksize
#endif

int
pthread_attr_setstacksize_sf()
{
	return(0);
}

int
pthread_attr_setstacksize_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_attr_setstacksize_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_cancel()				 ******/

#ifdef	pthread_cancel
#undef	pthread_cancel
#endif

int
pthread_cancel_sf()
{
	return(0);
}

int
pthread_cancel_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_cancel_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_cleanup_pop()			 ******/

#ifdef	pthread_cleanup_pop
#undef	pthread_cleanup_pop
#endif

int
pthread_cleanup_pop_sf()
{
	return(0);
}

int
pthread_cleanup_pop_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_cleanup_pop_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_cleanup_push()			 ******/

#ifdef	pthread_cleanup_push
#undef	pthread_cleanup_push
#endif

int
pthread_cleanup_push_sf()
{
	return(0);
}

int
pthread_cleanup_push_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_cleanup_push_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_cond_broadcast()			 ******/

#ifdef	pthread_cond_broadcast
#undef	pthread_cond_broadcast
#endif

int
pthread_cond_broadcast_sf()
{
	return(0);
}

int
pthread_cond_broadcast_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_cond_broadcast_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_cond_destroy()			 ******/

#ifdef	pthread_cond_destroy
#undef	pthread_cond_destroy
#endif

int
pthread_cond_destroy_sf()
{
	return(0);
}

int
pthread_cond_destroy_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_cond_destroy_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_cond_init()				 ******/

#ifdef	pthread_cond_init
#undef	pthread_cond_init
#endif

int
pthread_cond_init_sf()
{
	return(0);
}

int
pthread_cond_init_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_cond_init_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_cond_signal()			 ******/

#ifdef	pthread_cond_signal
#undef	pthread_cond_signal
#endif

int
pthread_cond_signal_sf()
{
	return(0);
}

int
pthread_cond_signal_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_cond_signal_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_cond_timedwait()			 ******/

#ifdef	pthread_cond_timedwait
#undef	pthread_cond_timedwait
#endif

int
pthread_cond_timedwait_sf()
{
	return(0);
}

int
pthread_cond_timedwait_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_cond_timedwait_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_cond_wait()				 ******/

#ifdef	pthread_cond_wait
#undef	pthread_cond_wait
#endif

int
pthread_cond_wait_sf()
{
	return(0);
}

int
pthread_cond_wait_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_cond_wait_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_condattr_destroy()			 ******/

#ifdef	pthread_condattr_destroy
#undef	pthread_condattr_destroy
#endif

int
pthread_condattr_destroy_sf()
{
	return(0);
}

int
pthread_condattr_destroy_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_condattr_destroy_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PROCESS_SHARED)

/****** Testset for pthread_condattr_getpshared()		 ******/

#ifdef	pthread_condattr_getpshared
#undef	pthread_condattr_getpshared
#endif

int
pthread_condattr_getpshared_sf()
{
	return(0);
}

int
pthread_condattr_getpshared_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_condattr_getpshared_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_condattr_init()			 ******/

#ifdef	pthread_condattr_init
#undef	pthread_condattr_init
#endif

int
pthread_condattr_init_sf()
{
	return(0);
}

int
pthread_condattr_init_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_condattr_init_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PROCESS_SHARED)

/****** Testset for pthread_condattr_setpshared()		 ******/

#ifdef	pthread_condattr_setpshared
#undef	pthread_condattr_setpshared
#endif

int
pthread_condattr_setpshared_sf()
{
	return(0);
}

int
pthread_condattr_setpshared_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_condattr_setpshared_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_create()				 ******/

#ifdef	pthread_create
#undef	pthread_create
#endif

int
pthread_create_sf()
{
	return(0);
}

int
pthread_create_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_create_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_detach()				 ******/

#ifdef	pthread_detach
#undef	pthread_detach
#endif

int
pthread_detach_sf()
{
	return(0);
}

int
pthread_detach_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_detach_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_equal()				 ******/

#ifdef	pthread_equal
#undef	pthread_equal
#endif

int
pthread_equal_sf()
{
	return(0);
}

int
pthread_equal_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_equal_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_exit()				 ******/

#ifdef	pthread_exit
#undef	pthread_exit
#endif

int
pthread_exit_sf()
{
	return(0);
}

int
pthread_exit_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_exit_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for pthread_getconcurrency()			 ******/

#ifdef	pthread_getconcurrency
#undef	pthread_getconcurrency
#endif

int
pthread_getconcurrency_sf()
{
	return(0);
}

int
pthread_getconcurrency_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_getconcurrency_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PRIORITY_SCHEDULING)

/****** Testset for pthread_getschedparam()			 ******/

#ifdef	pthread_getschedparam
#undef	pthread_getschedparam
#endif

int
pthread_getschedparam_sf()
{
	return(0);
}

int
pthread_getschedparam_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_getschedparam_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_getspecific()			 ******/

#ifdef	pthread_getspecific
#undef	pthread_getspecific
#endif

int
pthread_getspecific_sf()
{
	return(0);
}

int
pthread_getspecific_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_getspecific_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_join()				 ******/

#ifdef	pthread_join
#undef	pthread_join
#endif

int
pthread_join_sf()
{
	return(0);
}

int
pthread_join_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_join_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_key_create()			 ******/

#ifdef	pthread_key_create
#undef	pthread_key_create
#endif

int
pthread_key_create_sf()
{
	return(0);
}

int
pthread_key_create_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_key_create_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_key_delete()			 ******/

#ifdef	pthread_key_delete
#undef	pthread_key_delete
#endif

int
pthread_key_delete_sf()
{
	return(0);
}

int
pthread_key_delete_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_key_delete_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_kill()				 ******/

#ifdef	pthread_kill
#undef	pthread_kill
#endif

int
pthread_kill_sf()
{
	return(0);
}

int
pthread_kill_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_kill_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_mutex_destroy()			 ******/

#ifdef	pthread_mutex_destroy
#undef	pthread_mutex_destroy
#endif

int
pthread_mutex_destroy_sf()
{
	return(0);
}

int
pthread_mutex_destroy_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_mutex_destroy_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PRIO_PROTECT)

/****** Testset for pthread_mutex_getprioceiling()		 ******/

#ifdef	pthread_mutex_getprioceiling
#undef	pthread_mutex_getprioceiling
#endif

int
pthread_mutex_getprioceiling_sf()
{
	return(0);
}

int
pthread_mutex_getprioceiling_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_mutex_getprioceiling_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_mutex_init()			 ******/

#ifdef	pthread_mutex_init
#undef	pthread_mutex_init
#endif

int
pthread_mutex_init_sf()
{
	return(0);
}

int
pthread_mutex_init_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_mutex_init_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_mutex_lock()			 ******/

#ifdef	pthread_mutex_lock
#undef	pthread_mutex_lock
#endif

int
pthread_mutex_lock_sf()
{
	return(0);
}

int
pthread_mutex_lock_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_mutex_lock_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PRIO_PROTECT)

/****** Testset for pthread_mutex_setprioceiling()		 ******/

#ifdef	pthread_mutex_setprioceiling
#undef	pthread_mutex_setprioceiling
#endif

int
pthread_mutex_setprioceiling_sf()
{
	return(0);
}

int
pthread_mutex_setprioceiling_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_mutex_setprioceiling_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_mutex_trylock()			 ******/

#ifdef	pthread_mutex_trylock
#undef	pthread_mutex_trylock
#endif

int
pthread_mutex_trylock_sf()
{
	return(0);
}

int
pthread_mutex_trylock_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_mutex_trylock_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_mutex_unlock()			 ******/

#ifdef	pthread_mutex_unlock
#undef	pthread_mutex_unlock
#endif

int
pthread_mutex_unlock_sf()
{
	return(0);
}

int
pthread_mutex_unlock_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_mutex_unlock_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_mutexattr_destroy()			 ******/

#ifdef	pthread_mutexattr_destroy
#undef	pthread_mutexattr_destroy
#endif

int
pthread_mutexattr_destroy_sf()
{
	return(0);
}

int
pthread_mutexattr_destroy_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_mutexattr_destroy_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_mutexattr_getprioceiling()		 ******/

#ifdef	pthread_mutexattr_getprioceiling
#undef	pthread_mutexattr_getprioceiling
#endif

int
pthread_mutexattr_getprioceiling_sf()
{
	return(0);
}

int
pthread_mutexattr_getprioceiling_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_mutexattr_getprioceiling_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS) && (defined(_POSIX_THREAD_PRIO_INHERIT) || defined(_POSIX_THREAD_PRIO_PROTECT))

/****** Testset for pthread_mutexattr_getprotocol()		 ******/

#ifdef	pthread_mutexattr_getprotocol
#undef	pthread_mutexattr_getprotocol
#endif

int
pthread_mutexattr_getprotocol_sf()
{
	return(0);
}

int
pthread_mutexattr_getprotocol_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_mutexattr_getprotocol_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PROCESS_SHARED)

/****** Testset for pthread_mutexattr_getpshared()		 ******/

#ifdef	pthread_mutexattr_getpshared
#undef	pthread_mutexattr_getpshared
#endif

int
pthread_mutexattr_getpshared_sf()
{
	return(0);
}

int
pthread_mutexattr_getpshared_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_mutexattr_getpshared_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for pthread_mutexattr_gettype()			 ******/

#ifdef	pthread_mutexattr_gettype
#undef	pthread_mutexattr_gettype
#endif

int
pthread_mutexattr_gettype_sf()
{
	return(0);
}

int
pthread_mutexattr_gettype_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_mutexattr_gettype_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_mutexattr_init()			 ******/

#ifdef	pthread_mutexattr_init
#undef	pthread_mutexattr_init
#endif

int
pthread_mutexattr_init_sf()
{
	return(0);
}

int
pthread_mutexattr_init_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_mutexattr_init_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_mutexattr_setprioceiling()		 ******/

#ifdef	pthread_mutexattr_setprioceiling
#undef	pthread_mutexattr_setprioceiling
#endif

int
pthread_mutexattr_setprioceiling_sf()
{
	return(0);
}

int
pthread_mutexattr_setprioceiling_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_mutexattr_setprioceiling_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS) && (defined(_POSIX_THREAD_PRIO_INHERIT) || defined(_POSIX_THREAD_PRIO_PROTECT))

/****** Testset for pthread_mutexattr_setprotocol()		 ******/

#ifdef	pthread_mutexattr_setprotocol
#undef	pthread_mutexattr_setprotocol
#endif

int
pthread_mutexattr_setprotocol_sf()
{
	return(0);
}

int
pthread_mutexattr_setprotocol_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_mutexattr_setprotocol_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PROCESS_SHARED)

/****** Testset for pthread_mutexattr_setpshared()		 ******/

#ifdef	pthread_mutexattr_setpshared
#undef	pthread_mutexattr_setpshared
#endif

int
pthread_mutexattr_setpshared_sf()
{
	return(0);
}

int
pthread_mutexattr_setpshared_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_mutexattr_setpshared_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for pthread_mutexattr_settype()			 ******/

#ifdef	pthread_mutexattr_settype
#undef	pthread_mutexattr_settype
#endif

int
pthread_mutexattr_settype_sf()
{
	return(0);
}

int
pthread_mutexattr_settype_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_mutexattr_settype_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_once()				 ******/

#ifdef	pthread_once
#undef	pthread_once
#endif

int
pthread_once_sf()
{
	return(0);
}

int
pthread_once_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_once_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for pthread_rwlock_destroy()			 ******/

#ifdef	pthread_rwlock_destroy
#undef	pthread_rwlock_destroy
#endif

int
pthread_rwlock_destroy_sf()
{
	return(0);
}

int
pthread_rwlock_destroy_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_rwlock_destroy_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for pthread_rwlock_init()			 ******/

#ifdef	pthread_rwlock_init
#undef	pthread_rwlock_init
#endif

int
pthread_rwlock_init_sf()
{
	return(0);
}

int
pthread_rwlock_init_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_rwlock_init_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for pthread_rwlock_rdlock()			 ******/

#ifdef	pthread_rwlock_rdlock
#undef	pthread_rwlock_rdlock
#endif

int
pthread_rwlock_rdlock_sf()
{
	return(0);
}

int
pthread_rwlock_rdlock_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_rwlock_rdlock_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for pthread_rwlock_tryrdlock()			 ******/

#ifdef	pthread_rwlock_tryrdlock
#undef	pthread_rwlock_tryrdlock
#endif

int
pthread_rwlock_tryrdlock_sf()
{
	return(0);
}

int
pthread_rwlock_tryrdlock_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_rwlock_tryrdlock_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for pthread_rwlock_trywrlock()			 ******/

#ifdef	pthread_rwlock_trywrlock
#undef	pthread_rwlock_trywrlock
#endif

int
pthread_rwlock_trywrlock_sf()
{
	return(0);
}

int
pthread_rwlock_trywrlock_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_rwlock_trywrlock_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for pthread_rwlock_unlock()			 ******/

#ifdef	pthread_rwlock_unlock
#undef	pthread_rwlock_unlock
#endif

int
pthread_rwlock_unlock_sf()
{
	return(0);
}

int
pthread_rwlock_unlock_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_rwlock_unlock_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for pthread_rwlock_wrlock()			 ******/

#ifdef	pthread_rwlock_wrlock
#undef	pthread_rwlock_wrlock
#endif

int
pthread_rwlock_wrlock_sf()
{
	return(0);
}

int
pthread_rwlock_wrlock_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_rwlock_wrlock_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for pthread_rwlockattr_destroy()		 ******/

#ifdef	pthread_rwlockattr_destroy
#undef	pthread_rwlockattr_destroy
#endif

int
pthread_rwlockattr_destroy_sf()
{
	return(0);
}

int
pthread_rwlockattr_destroy_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_rwlockattr_destroy_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for pthread_rwlockattr_getpshared()		 ******/

#ifdef	pthread_rwlockattr_getpshared
#undef	pthread_rwlockattr_getpshared
#endif

int
pthread_rwlockattr_getpshared_sf()
{
	return(0);
}

int
pthread_rwlockattr_getpshared_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_rwlockattr_getpshared_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for pthread_rwlockattr_init()			 ******/

#ifdef	pthread_rwlockattr_init
#undef	pthread_rwlockattr_init
#endif

int
pthread_rwlockattr_init_sf()
{
	return(0);
}

int
pthread_rwlockattr_init_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_rwlockattr_init_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for pthread_rwlockattr_setpshared()		 ******/

#ifdef	pthread_rwlockattr_setpshared
#undef	pthread_rwlockattr_setpshared
#endif

int
pthread_rwlockattr_setpshared_sf()
{
	return(0);
}

int
pthread_rwlockattr_setpshared_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_rwlockattr_setpshared_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_self()				 ******/

#ifdef	pthread_self
#undef	pthread_self
#endif

int
pthread_self_sf()
{
	return(0);
}

int
pthread_self_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_self_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_setcancelstate()			 ******/

#ifdef	pthread_setcancelstate
#undef	pthread_setcancelstate
#endif

int
pthread_setcancelstate_sf()
{
	return(0);
}

int
pthread_setcancelstate_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_setcancelstate_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_setcanceltype()			 ******/

#ifdef	pthread_setcanceltype
#undef	pthread_setcanceltype
#endif

int
pthread_setcanceltype_sf()
{
	return(0);
}

int
pthread_setcanceltype_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_setcanceltype_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for pthread_setconcurrency()			 ******/

#ifdef	pthread_setconcurrency
#undef	pthread_setconcurrency
#endif

int
pthread_setconcurrency_sf()
{
	return(0);
}

int
pthread_setconcurrency_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_setconcurrency_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS) && defined(_POSIX_THREAD_PRIORITY_SCHEDULING)

/****** Testset for pthread_setschedparam()			 ******/

#ifdef	pthread_setschedparam
#undef	pthread_setschedparam
#endif

int
pthread_setschedparam_sf()
{
	return(0);
}

int
pthread_setschedparam_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_setschedparam_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_setspecific()			 ******/

#ifdef	pthread_setspecific
#undef	pthread_setspecific
#endif

int
pthread_setspecific_sf()
{
	return(0);
}

int
pthread_setspecific_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_setspecific_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_sigmask()				 ******/

#ifdef	pthread_sigmask
#undef	pthread_sigmask
#endif

int
pthread_sigmask_sf()
{
	return(0);
}

int
pthread_sigmask_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_sigmask_ef()
{
	return(0);
}

#endif

#if	defined(_POSIX_THREADS)

/****** Testset for pthread_testcancel()			 ******/

#ifdef	pthread_testcancel
#undef	pthread_testcancel
#endif

int
pthread_testcancel_sf()
{
	return(0);
}

int
pthread_testcancel_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pthread_testcancel_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for ptsname()					 ******/

#ifdef	ptsname
#undef	ptsname
#endif

int
ptsname_sf()
{
	return(0);
}

int
ptsname_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ptsname_ef()
{
	return(0);
}

#endif

/****** Testset for putc()					 ******/

#ifdef	putc
#undef	putc
#endif

int
putc_sf()
{
	return(0);
}

int
putc_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
putc_ef()
{
	return(0);
}

/****** Testset for putc_unlocked()				 ******/

#ifdef	putc_unlocked
#undef	putc_unlocked
#endif

int
putc_unlocked_sf()
{
	return(0);
}

int
putc_unlocked_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
putc_unlocked_ef()
{
	return(0);
}

/****** Testset for putchar()					 ******/

#ifdef	putchar
#undef	putchar
#endif

int
putchar_sf()
{
	return(0);
}

int
putchar_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
putchar_ef()
{
	return(0);
}

/****** Testset for putchar_unlocked()				 ******/

#ifdef	putchar_unlocked
#undef	putchar_unlocked
#endif

int
putchar_unlocked_sf()
{
	return(0);
}

int
putchar_unlocked_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
putchar_unlocked_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for putenv()					 ******/

#ifdef	putenv
#undef	putenv
#endif

int
putenv_sf()
{
	return(0);
}

int
putenv_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
putenv_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for putmsg()					 ******/

#ifdef	putmsg
#undef	putmsg
#endif

int
putmsg_sf()
{
	return(0);
}

int
putmsg_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
putmsg_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for putpmsg()					 ******/

#ifdef	putpmsg
#undef	putpmsg
#endif

int
putpmsg_sf()
{
	return(0);
}

int
putpmsg_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
putpmsg_ef()
{
	return(0);
}

#endif

/****** Testset for puts()					 ******/

#ifdef	puts
#undef	puts
#endif

int
puts_sf()
{
	return(0);
}

int
puts_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
puts_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for pututxline()				 ******/

#ifdef	pututxline
#undef	pututxline
#endif

int
pututxline_sf()
{
	return(0);
}

int
pututxline_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pututxline_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for putw()					 ******/

#ifdef	putw
#undef	putw
#endif

int
putw_sf()
{
	return(0);
}

int
putw_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
putw_ef()
{
	return(0);
}

#endif
#endif

#if	( TEST_XPG > 4 )

/****** Testset for putwc()					 ******/

#ifdef	putwc
#undef	putwc
#endif

int
putwc_sf()
{
	return(0);
}

int
putwc_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
putwc_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for putwchar()					 ******/

#ifdef	putwchar
#undef	putwchar
#endif

int
putwchar_sf()
{
	return(0);
}

int
putwchar_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
putwchar_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for pwrite()					 ******/

#ifdef	pwrite
#undef	pwrite
#endif

int
pwrite_sf()
{
	return(0);
}

int
pwrite_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
pwrite_ef()
{
	return(0);
}

#endif
