
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_rtr.c	1.3
*
*************************************************************************/

#include "std.h"

#include <dirent.h>

#if	( TEST_XPG > 4 )
#include <libgen.h>
#endif

#include <math.h>

#if	( TEST_XPG > 4 )
#include <re_comp.h>
#include <regex.h>
#include <search.h>
#endif

#include <signal.h>
#include <stdio.h>
#include <stdlib.h>

#if	( TEST_XPG > 4 )
#include <strings.h>
#endif

#include <sys/types.h>

#if	( TEST_XPG > 4 )
#include <sys/uio.h>
#endif

#include <unistd.h>

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"

/****** Testset for raise()					 ******/

#ifdef	raise
#undef	raise
#endif

int
raise_sf()
{
	return(0);
}

int
raise_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
raise_ef()
{
	return(0);
}

/****** Testset for rand()					 ******/

#ifdef	rand
#undef	rand
#endif

int
rand_sf()
{
	return(0);
}

int
rand_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
rand_ef()
{
	return(0);
}

#if	defined(_POSIX_THREAD_SAFE_FUNCTIONS)

/****** Testset for rand_r()					 ******/

#ifdef	rand_r
#undef	rand_r
#endif

int
rand_r_sf()
{
	return(0);
}

int
rand_r_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
rand_r_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for random()					 ******/

#ifdef	random
#undef	random
#endif

int
random_sf()
{
	return(0);
}

int
random_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
random_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for re_comp()					 ******/

#ifdef	re_comp
#undef	re_comp
#endif

int
re_comp_sf()
{
	return(0);
}

int
re_comp_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
re_comp_ef()
{
	return(0);
}

#endif
#endif

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for re_exec()					 ******/

#ifdef	re_exec
#undef	re_exec
#endif

int
re_exec_sf()
{
	return(0);
}

int
re_exec_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
re_exec_ef()
{
	return(0);
}

#endif
#endif

/****** Testset for read()					 ******/

#ifdef	read
#undef	read
#endif

int
read_sf()
{
	return(0);
}

int
read_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
read_ef()
{
	return(0);
}

/****** Testset for readdir()					 ******/

#ifdef	readdir
#undef	readdir
#endif

int
readdir_sf()
{
	return(0);
}

int
readdir_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	/* not required to be thread safe */

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
readdir_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for readlink()					 ******/

#ifdef	readlink
#undef	readlink
#endif

int
readlink_sf()
{
	return(0);
}

int
readlink_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
readlink_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for readv()					 ******/

#ifdef	readv
#undef	readv
#endif

int
readv_sf()
{
	return(0);
}

int
readv_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
readv_ef()
{
	return(0);
}

#endif

/****** Testset for realloc()					 ******/

#ifdef	realloc
#undef	realloc
#endif

int
realloc_sf()
{
	return(0);
}

int
realloc_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
realloc_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for realpath()					 ******/

#ifdef	realpath
#undef	realpath
#endif

int
realpath_sf()
{
	return(0);
}

int
realpath_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
realpath_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for regcmp()					 ******/

#ifdef	regcmp
#undef	regcmp
#endif

int
regcmp_sf()
{
	return(0);
}

int
regcmp_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
regcmp_ef()
{
	return(0);
}

#endif
#endif

#if	( TEST_XPG > 4 )

/****** Testset for regcomp()					 ******/

#ifdef	regcomp
#undef	regcomp
#endif

int
regcomp_sf()
{
	return(0);
}

int
regcomp_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
regcomp_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for regerror()					 ******/

#ifdef	regerror
#undef	regerror
#endif

int
regerror_sf()
{
	return(0);
}

int
regerror_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
regerror_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for regex()					 ******/

#ifdef	regex
#undef	regex
#endif

int
regex_sf()
{
	return(0);
}

int
regex_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
regex_ef()
{
	return(0);
}

#endif
#endif

#if	( TEST_XPG > 4 )

/****** Testset for regexec()					 ******/

#ifdef	regexec
#undef	regexec
#endif

int
regexec_sf()
{
	return(0);
}

int
regexec_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
regexec_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for regfree()					 ******/

#ifdef	regfree
#undef	regfree
#endif

int
regfree_sf()
{
	return(0);
}

int
regfree_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
regfree_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for remainder()					 ******/

#ifdef	remainder
#undef	remainder
#endif

#define	VSTH_REMAINDER_VAL1		-0.2
#define	VSTH_REMAINDER_VAL2		0.5
int	Vsth_remainder_init = 0;
double	Vsth_remainder_val1;
double	Vsth_remainder_val2;

int
remainder_sf()
{
	if ( ! Vsth_remainder_init )
	{
		Vsth_remainder_val1 = remainder(VSTH_REMAINDER_VAL1, VSTH_REMAINDER_VAL2);
		Vsth_remainder_val2 = remainder(VSTH_REMAINDER_VAL2, VSTH_REMAINDER_VAL1);
		Vsth_remainder_init = 1;
	}
		
	return(0);
}

int
remainder_tf()
{
	int	cnt;
	double	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = remainder(VSTH_REMAINDER_VAL1, VSTH_REMAINDER_VAL2);
		if ( rval != Vsth_remainder_val1 )
		{
			++fails;
		}

		rval = remainder(VSTH_REMAINDER_VAL2, VSTH_REMAINDER_VAL1);
		if ( rval != Vsth_remainder_val2 )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
remainder_ef()
{
	return(0);
}

#endif

/****** Testset for remove()					 ******/

#ifdef	remove
#undef	remove
#endif

int
remove_sf()
{
	return(0);
}

int
remove_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
remove_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for remque()					 ******/

#ifdef	remque
#undef	remque
#endif

int
remque_sf()
{
	return(0);
}

int
remque_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
remque_ef()
{
	return(0);
}

#endif

/****** Testset for rename()					 ******/

#ifdef	rename
#undef	rename
#endif

int
rename_sf()
{
	return(0);
}

int
rename_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
rename_ef()
{
	return(0);
}

/****** Testset for rewind()					 ******/

#ifdef	rewind
#undef	rewind
#endif

int
rewind_sf()
{
	return(0);
}

int
rewind_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
rewind_ef()
{
	return(0);
}

/****** Testset for rewinddir()					 ******/

#ifdef	rewinddir
#undef	rewinddir
#endif

int
rewinddir_sf()
{
	return(0);
}

int
rewinddir_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
rewinddir_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for rindex()					 ******/

#ifdef	rindex
#undef	rindex
#endif

int
rindex_sf()
{
	return(0);
}

int
rindex_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
rindex_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for rint()					 ******/

#ifdef	rint
#undef	rint
#endif

#define	VSTH_RINT_VAL1		-2.2
#define	VSTH_RINT_VAL2		5.5

int	Vsth_rint_init = 0;
double	Vsth_rint_val1;
double	Vsth_rint_val2;

int
rint_sf()
{
	if ( ! Vsth_rint_init )
	{
		Vsth_rint_val1 = rint(VSTH_RINT_VAL1);
		Vsth_rint_val2 = rint(VSTH_RINT_VAL2);
		Vsth_rint_init = 1;
	}
		
	return(0);
}

int
rint_tf()
{
	int	cnt;
	double	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = rint(VSTH_RINT_VAL1);
		if ( rval != Vsth_rint_val1 )
		{
			++fails;
		}

		rval = rint(VSTH_RINT_VAL2);
		if ( rval != Vsth_rint_val2 )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
rint_ef()
{
	return(0);
}

#endif

/****** Testset for rmdir()					 ******/

#ifdef	rmdir
#undef	rmdir
#endif

int
rmdir_sf()
{
	return(0);
}

int
rmdir_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
rmdir_ef()
{
	return(0);
}

