
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_rtu.c	1.2
*
*************************************************************************/

#include "std.h"

#include <stdio.h>
#include <stdlib.h>
#include <sys/stat.h>

#if	( TEST_XPG > 4 )
#include <sys/time.h>
#endif

#include <sys/types.h>
#include <sys/utsname.h>

#if	( TEST_XPG > 4 )
#include <ulimit.h>
#endif

#include <unistd.h>
#include <utime.h>

#if	( TEST_XPG > 4 )
#include <wchar.h>
#endif

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"

#if	( TEST_XPG > 4 )

/****** Testset for ualarm()					 ******/

#ifdef	ualarm
#undef	ualarm
#endif

int
ualarm_sf()
{
	return(0);
}

int
ualarm_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ualarm_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for ulimit()					 ******/

#ifdef	ulimit
#undef	ulimit
#endif

int
ulimit_sf()
{
	return(0);
}

int
ulimit_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ulimit_ef()
{
	return(0);
}

#endif

/****** Testset for umask()					 ******/

#ifdef	umask
#undef	umask
#endif

int
umask_sf()
{
	return(0);
}

int
umask_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
umask_ef()
{
	return(0);
}

/****** Testset for uname()					 ******/

#ifdef	uname
#undef	uname
#endif

int
uname_sf()
{
	return(0);
}

int
uname_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
uname_ef()
{
	return(0);
}

/****** Testset for ungetc()					 ******/

#ifdef	ungetc
#undef	ungetc
#endif

int
ungetc_sf()
{
	return(0);
}

int
ungetc_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ungetc_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for ungetwc()					 ******/

#ifdef	ungetwc
#undef	ungetwc
#endif

int
ungetwc_sf()
{
	return(0);
}

int
ungetwc_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
ungetwc_ef()
{
	return(0);
}

#endif

/****** Testset for unlink()					 ******/

#ifdef	unlink
#undef	unlink
#endif

int
unlink_sf()
{
	return(0);
}

int
unlink_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
unlink_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for unlockpt()					 ******/

#ifdef	unlockpt
#undef	unlockpt
#endif

int
unlockpt_sf()
{
	return(0);
}

int
unlockpt_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
unlockpt_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for usleep()					 ******/

#ifdef	usleep
#undef	usleep
#endif

int
usleep_sf()
{
	return(0);
}

int
usleep_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
usleep_ef()
{
	return(0);
}

#endif

/****** Testset for utime()					 ******/

#ifdef	utime
#undef	utime
#endif

int
utime_sf()
{
	return(0);
}

int
utime_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
utime_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for utimes()					 ******/

#ifdef	utimes
#undef	utimes
#endif

int
utimes_sf()
{
	return(0);
}

int
utimes_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
utimes_ef()
{
	return(0);
}

#endif
