
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_rtv.c	1.2
*
*************************************************************************/

#include "std.h"

#include <stdarg.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>

#if	( TEST_XPG > 4 )
#include <wchar.h>
#endif

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for valloc()					 ******/

#ifdef	valloc
#undef	valloc
#endif

int
valloc_sf()
{
	return(0);
}

int
valloc_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
valloc_ef()
{
	return(0);
}

#endif
#endif

#if	( TEST_XPG > 4 )

/****** Testset for vfork()					 ******/

#ifdef	vfork
#undef	vfork
#endif

int
vfork_sf()
{
	return(0);
}

int
vfork_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
vfork_ef()
{
	return(0);
}

#endif

/****** Testset for vfprintf()					 ******/

#ifdef	vfprintf
#undef	vfprintf
#endif

int
vfprintf_sf()
{
	return(0);
}

int
vfprintf_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
vfprintf_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for vfwprintf()					 ******/

#ifdef	vfwprintf
#undef	vfwprintf
#endif

int
vfwprintf_sf()
{
	return(0);
}

int
vfwprintf_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
vfwprintf_ef()
{
	return(0);
}

#endif

/****** Testset for vprintf()					 ******/

#ifdef	vprintf
#undef	vprintf
#endif

int
vprintf_sf()
{
	return(0);
}

int
vprintf_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
vprintf_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for vsnprintf()					 ******/

#ifdef	vsnprintf
#undef	vsnprintf
#endif

int
vsnprintf_sf()
{
	return(0);
}

int
vsnprintf_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
vsnprintf_ef()
{
	return(0);
}

#endif

/****** Testset for vsprintf()					 ******/

#ifdef	vsprintf
#undef	vsprintf
#endif

int
vsprintf_sf()
{
	return(0);
}

int
vsprintf_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
vsprintf_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for vswprintf()					 ******/

#ifdef	vswprintf
#undef	vswprintf
#endif

int
vswprintf_sf()
{
	return(0);
}

int
vswprintf_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
vswprintf_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for vwprintf()					 ******/

#ifdef	vwprintf
#undef	vwprintf
#endif

int
vwprintf_sf()
{
	return(0);
}

int
vwprintf_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
vwprintf_ef()
{
	return(0);
}

#endif
