
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_rtw.c	1.3
*
*************************************************************************/

#include "std.h"

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <sys/wait.h>

#if	( TEST_XPG > 4 )
#include <sys/uio.h>
#endif

#include <unistd.h>

#if	( TEST_XPG > 4 )
#include <wchar.h>
#include <wctype.h>
#include <wordexp.h>
#endif

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"

/****** Testset for wait()					 ******/

#ifdef	wait
#undef	wait
#endif

int
wait_sf()
{
	return(0);
}

int
wait_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wait_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )
#if	defined(_XOPEN_LEGACY) && (_XOPEN_LEGACY != -1)

/****** Testset for wait3()					 ******/

#ifdef	wait3
#undef	wait3
#endif

int
wait3_sf()
{
	return(0);
}

int
wait3_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wait3_ef()
{
	return(0);
}

#endif
#endif

#if	( TEST_XPG > 4 )

/****** Testset for waitid()					 ******/

#ifdef	waitid
#undef	waitid
#endif

int
waitid_sf()
{
	return(0);
}

int
waitid_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
waitid_ef()
{
	return(0);
}

#endif

/****** Testset for waitpid()					 ******/

#ifdef	waitpid
#undef	waitpid
#endif

int
waitpid_sf()
{
	return(0);
}

int
waitpid_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
waitpid_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for wcrtomb()					 ******/

#ifdef	wcrtomb
#undef	wcrtomb
#endif

int
wcrtomb_sf()
{
	return(0);
}

int
wcrtomb_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcrtomb_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcscat()					 ******/

#ifdef	wcscat
#undef	wcscat
#endif

int
wcscat_sf()
{
	return(0);
}

int
wcscat_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcscat_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcschr()					 ******/

#ifdef	wcschr
#undef	wcschr
#endif

int
wcschr_sf()
{
	return(0);
}

int
wcschr_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcschr_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcscmp()					 ******/

#ifdef	wcscmp
#undef	wcscmp
#endif

int
wcscmp_sf()
{
	return(0);
}

int
wcscmp_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcscmp_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcscoll()					 ******/

#ifdef	wcscoll
#undef	wcscoll
#endif

int
wcscoll_sf()
{
	return(0);
}

int
wcscoll_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcscoll_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcscpy()					 ******/

#ifdef	wcscpy
#undef	wcscpy
#endif

int
wcscpy_sf()
{
	return(0);
}

int
wcscpy_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcscpy_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcscspn()					 ******/

#ifdef	wcscspn
#undef	wcscspn
#endif

int
wcscspn_sf()
{
	return(0);
}

int
wcscspn_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcscspn_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcsftime()					 ******/

#ifdef	wcsftime
#undef	wcsftime
#endif

int
wcsftime_sf()
{
	return(0);
}

int
wcsftime_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcsftime_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcslen()					 ******/

#ifdef	wcslen
#undef	wcslen
#endif

int
wcslen_sf()
{
	return(0);
}

int
wcslen_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcslen_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcsncat()					 ******/

#ifdef	wcsncat
#undef	wcsncat
#endif

int
wcsncat_sf()
{
	return(0);
}

int
wcsncat_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcsncat_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcsncmp()					 ******/

#ifdef	wcsncmp
#undef	wcsncmp
#endif

int
wcsncmp_sf()
{
	return(0);
}

int
wcsncmp_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcsncmp_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcsncpy()					 ******/

#ifdef	wcsncpy
#undef	wcsncpy
#endif

int
wcsncpy_sf()
{
	return(0);
}

int
wcsncpy_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcsncpy_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcspbrk()					 ******/

#ifdef	wcspbrk
#undef	wcspbrk
#endif

int
wcspbrk_sf()
{
	return(0);
}

int
wcspbrk_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcspbrk_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcsrchr()					 ******/

#ifdef	wcsrchr
#undef	wcsrchr
#endif

int
wcsrchr_sf()
{
	return(0);
}

int
wcsrchr_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcsrchr_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcsrtombs()					 ******/

#ifdef	wcsrtombs
#undef	wcsrtombs
#endif

int
wcsrtombs_sf()
{
	return(0);
}

int
wcsrtombs_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcsrtombs_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcsspn()					 ******/

#ifdef	wcsspn
#undef	wcsspn
#endif

int
wcsspn_sf()
{
	return(0);
}

int
wcsspn_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcsspn_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcsstr()					 ******/

#ifdef	wcsstr
#undef	wcsstr
#endif

int
wcsstr_sf()
{
	return(0);
}

int
wcsstr_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcsstr_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcstod()					 ******/

#ifdef	wcstod
#undef	wcstod
#endif

int
wcstod_sf()
{
	return(0);
}

int
wcstod_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcstod_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcstok()					 ******/

#ifdef	wcstok
#undef	wcstok
#endif

int
wcstok_sf()
{
	return(0);
}

int
wcstok_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcstok_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcstol()					 ******/

#ifdef	wcstol
#undef	wcstol
#endif

int
wcstol_sf()
{
	return(0);
}

int
wcstol_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcstol_ef()
{
	return(0);
}

#endif

/****** Testset for wcstombs()					 ******/

#ifdef	wcstombs
#undef	wcstombs
#endif

int
wcstombs_sf()
{
	return(0);
}

int
wcstombs_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcstombs_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for wcstoul()					 ******/

#ifdef	wcstoul
#undef	wcstoul
#endif

int
wcstoul_sf()
{
	return(0);
}

int
wcstoul_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcstoul_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcswcs()					 ******/

#ifdef	wcswcs
#undef	wcswcs
#endif

int
wcswcs_sf()
{
	return(0);
}

int
wcswcs_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcswcs_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcswidth()					 ******/

#ifdef	wcswidth
#undef	wcswidth
#endif

int
wcswidth_sf()
{
	return(0);
}

int
wcswidth_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcswidth_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcsxfrm()					 ******/

#ifdef	wcsxfrm
#undef	wcsxfrm
#endif

int
wcsxfrm_sf()
{
	return(0);
}

int
wcsxfrm_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcsxfrm_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wctob()					 ******/

#ifdef	wctob
#undef	wctob
#endif

int
wctob_sf()
{
	return(0);
}

int
wctob_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wctob_ef()
{
	return(0);
}

#endif

/****** Testset for wctomb()					 ******/

#ifdef	wctomb
#undef	wctomb
#endif

int
wctomb_sf()
{
	return(0);
}

int
wctomb_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wctomb_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for wctrans()					 ******/

#ifdef	wctrans
#undef	wctrans
#endif

int
wctrans_sf()
{
	return(0);
}

int
wctrans_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wctrans_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wctype()					 ******/

#ifdef	wctype
#undef	wctype
#endif

int
wctype_sf()
{
	return(0);
}

int
wctype_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wctype_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wcwidth()					 ******/

#ifdef	wcwidth
#undef	wcwidth
#endif

int
wcwidth_sf()
{
	return(0);
}

int
wcwidth_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wcwidth_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wmemchr()					 ******/

#ifdef	wmemchr
#undef	wmemchr
#endif

int
wmemchr_sf()
{
	return(0);
}

int
wmemchr_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wmemchr_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wmemcmp()					 ******/

#ifdef	wmemcmp
#undef	wmemcmp
#endif

int
wmemcmp_sf()
{
	return(0);
}

int
wmemcmp_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wmemcmp_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wmemcpy()					 ******/

#ifdef	wmemcpy
#undef	wmemcpy
#endif

int
wmemcpy_sf()
{
	return(0);
}

int
wmemcpy_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wmemcpy_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wmemmove()					 ******/

#ifdef	wmemmove
#undef	wmemmove
#endif

int
wmemmove_sf()
{
	return(0);
}

int
wmemmove_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wmemmove_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wmemset()					 ******/

#ifdef	wmemset
#undef	wmemset
#endif

int
wmemset_sf()
{
	return(0);
}

int
wmemset_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wmemset_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wordexp()					 ******/

#ifdef	wordexp
#undef	wordexp
#endif

int
wordexp_sf()
{
	return(0);
}

int
wordexp_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wordexp_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wprintf()					 ******/

#ifdef	wprintf
#undef	wprintf
#endif

int
wprintf_sf()
{
	return(0);
}

int
wprintf_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wprintf_ef()
{
	return(0);
}

#endif

/****** Testset for write()					 ******/

#ifdef	write
#undef	write
#endif

int
write_sf()
{
	return(0);
}

int
write_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
write_ef()
{
	return(0);
}

#if	( TEST_XPG > 4 )

/****** Testset for writev()					 ******/

#ifdef	writev
#undef	writev
#endif

int
writev_sf()
{
	return(0);
}

int
writev_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
writev_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for wscanf()					 ******/

#ifdef	wscanf
#undef	wscanf
#endif

int
wscanf_sf()
{
	return(0);
}

int
wscanf_tf()
{
	int	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
wscanf_ef()
{
	return(0);
}

#endif
