
/*************************************************************************
*
* Copyright (c) 1997 X/Open Company Ltd., A member of The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)vsth_rty.c	1.2
*
*************************************************************************/

#include "std.h"

#include <math.h>
#include <stdio.h>
#include <unistd.h>

#include "tet_api.h"
#include "vsth/vsth.h"
#include "vsth/vsth_fw.h"

#if	( TEST_XPG > 4 )

/****** Testset for y0()					 ******/

#ifdef	y0
#undef	y0
#endif

#define	VSTH_Y0_VAL1		2.2
#define	VSTH_Y0_VAL2		5.5
int	Vsth_y0_init = 0;
double	Vsth_y0_val1;
double	Vsth_y0_val2;

int
y0_sf()
{
	if ( ! Vsth_y0_init )
	{
		Vsth_y0_val1 = y0(VSTH_Y0_VAL1);
		Vsth_y0_val2 = y0(VSTH_Y0_VAL2);
		Vsth_y0_init = 1;
	}
		
	return(0);
}

int
y0_tf()
{
	int	cnt;
	double	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = y0(VSTH_Y0_VAL1);
		if ( rval != Vsth_y0_val1 )
		{
			++fails;
		}

		rval = y0(VSTH_Y0_VAL2);
		if ( rval != Vsth_y0_val2 )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if (( errs == 0 ) && ( fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
y0_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for y1()					 ******/

#ifdef	y1
#undef	y1
#endif

#define	VSTH_Y1_VAL1		2.2
#define	VSTH_Y1_VAL2		5.5
int	Vsth_y1_init = 0;
double	Vsth_y1_val1;
double	Vsth_y1_val2;

int
y1_sf()
{
	if ( ! Vsth_y1_init )
	{
		Vsth_y1_val1 = y1(VSTH_Y1_VAL1);
		Vsth_y1_val2 = y1(VSTH_Y1_VAL2);
		Vsth_y1_init = 1;
	}
		
	return(0);
}

int
y1_tf()
{
	int	cnt;
	double	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = y1(VSTH_Y1_VAL1);
		if ( rval != Vsth_y1_val1 )
		{
			++fails;
		}

		rval = y1(VSTH_Y1_VAL2);
		if ( rval != Vsth_y1_val2 )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
y1_ef()
{
	return(0);
}

#endif

#if	( TEST_XPG > 4 )

/****** Testset for yn()					 ******/

#ifdef	yn
#undef	yn
#endif

#define	VSTH_YN_VAL1		2.2
#define	VSTH_YN_VAL2		5.5
int	Vsth_yn_init = 0;
double	Vsth_yn_val1;
double	Vsth_yn_val2;

int
yn_sf()
{
	if ( ! Vsth_yn_init )
	{
		Vsth_yn_val1 = yn( 3, VSTH_YN_VAL1);
		Vsth_yn_val2 = yn( 3, VSTH_YN_VAL2);
		Vsth_yn_init = 1;
	}
		
	return(0);
}

int
yn_tf()
{
	int	cnt;
	double	rval;
	int	errs;
	int	fails;

	errs	= 0;
	fails	= 0;

	for ( cnt = 0; cnt < Vsth_rt_cnt; ++cnt )
	{
		rval = yn( 3, VSTH_YN_VAL1);
		if ( rval != Vsth_yn_val1 )
		{
			++fails;
		}

		rval = yn( 3, VSTH_YN_VAL2);
		if ( rval != Vsth_yn_val2 )
		{
			++fails;
		}
	}

	rval = 1;
	if ( fails )
	{
		rval = 2;
	}
	else if ((errs == 0) && (fails == 0 ))
	{
		rval = 0;
	}
	return(rval);
}

int
yn_ef()
{
	return(0);
}

#endif
