/*      SCCS:   @(#)common/vtools/c-tree.h	4.1 (01/21/97)  VSXgen release 1.4

   Definitions for C parsing and type checking.
   Copyright (C) 1988 Free Software Foundation, Inc.

This file is part of GNU CC.

GNU CC is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 1, or (at your option)
any later version.

GNU CC is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with GNU CC; see the file COPYING.  If not, write to
the Free Software Foundation, 675 Mass Ave, Cambridge, MA 02139, USA.  */

/***********************************************************************

NAME:		c-tree.h

PROJECT:	VSX (X/OPEN Validation Suite)
MODULE CONTAINS:
SYNOPSIS:
DESCRIPTION:
		Stripped down version of original GNU code.

AUTHOR:		Geoff Clare, UniSoft Ltd.
DATE CREATED:	26 Jan 1990
MODIFICATIONS:
		Geoff Clare, 20 June 1994
			Added warning() declaration.

************************************************************************/


/* This function must have a prototype as it is called with variable
   numbers of arguments (even though they are not used) */

#if TEST_ANSI
extern int warning(char *, ...);
#endif

/* Nonzero means reject anything that ANSI standard C forbids.  */
extern int pedantic;

/* In a RECORD_TYPE or UNION_TYPE, nonzero if any component is read-only.  */
#define C_TYPE_FIELDS_READONLY(type) TYPE_SEP_UNIT (type)

/* in c-decl.c */

extern int func_start ();
extern void fin_function ();
extern void store_parm_decls ();
extern tree get_parm_info ();

extern void pushlevel(), poplevel();

extern tree groktypename(), lookup_name();

extern tree implicitly_declare(), getdecls(), gettags ();

extern tree decl_start();
extern void fin_decl();

extern tree stru_start(), fin_struct(), xref_tag();
extern tree grokfield();

extern tree enum_start(), fin_enum();
extern tree bd_enumerator();

extern tree double_type_node, long_double_type_node, float_type_node;
extern tree char_type_node, uchar_type_node, signed_char_type_node;

extern tree short_int_type_node, ushint_type_node;
extern tree long_int_type_node, long_uint_type_node;
extern tree uint_type_node;
extern tree string_type_node, char_array_type_node, int_array_type_node;

extern int cufn_val_return;
extern int cufn_null_return;

extern int lineno;

extern tree ridpointers[];

/* Points to the FUNCTION_DECL of the function whose body we are reading. */
extern tree cufn_decl;

/* Nonzero means `$' can be in an identifier.  */

extern int dollars_in_ident;

/* Nonzero means `char' should be signed.  */

extern int flag_signed_char;

/* Nonzero means don't recognize the keyword `asm'.  */

extern int flag_no_asm;

/* Nonzero means warn about implicit declarations.  */

extern int warn_implicit;

/* Nonzero means warn about function definitions that default the return type
   or that use a null return and have a return-type other than void.  */

extern int warn_return_type;

/* Nonzero means give string constants the type `const char *'
   to get extra warnings from them.  These warnings will be too numerous
   to be useful, except in thoroughly ANSIfied programs.  */

extern int warn_write_strings;

/* Nonzero means warn for all old-style non-prototype function decls.  */

extern int warn_strict_prototypes;

/* Nonzero means do some things the same way PCC does.  */

extern int flag_traditional;
