: use /bin/sh
#
#	SCCS:	@(#)install/scripts/chmake.sh	4.1 (01/21/97)  VSXgen release 1.4
#
# This shell script modifies the default paramaters in a makefile.
# The names of the Makefiles are read in from standard input, The arguments
# are taken to be of the form "parameter=value".  All instances of parameter
# which occur at the start of a line and contain '=' are changed to look
# like "parameter	=	value"
# A copy of each makefile is taken from <makefile>.org

trap "" 1 2 3

name=$0
if test "$#" -lt "1"
then
	echo "usage: find . -name Makefile.org -print | $name param=value ..."
	exit 1
fi
sedtmp=/tmp/sedss.tmp

while test "$#" -gt 0
do
	pat=`echo $1 | sed -e 's?^\([^=]*\)=.*$?\1?'`
	if test -z "$pat"
	then
		echo "$name: bad argument $1"
		rm -f $sedtmp
		exit 1
	fi
	echo "s?^$pat[	 ]*=.*?$1?" >> $sedtmp
	shift
done

tname="/tmp/chmss.tmp"
while read mfile
do
	tgtfile=`dirname $mfile`/`basename $mfile .org`
	if sed -f $sedtmp < $mfile > $tname
	then
		cp $tname $tgtfile
	fi
done
rm -f $tname $sedtmp
exit 0
