: use /bin/sh
#########################################################################
#									#
#	SCCS:	@(#)install/scripts/incmerge.sh	4.2 (04/10/97)  VSXgen release 1.4#
#									#
#	incmerge: merge two or more Inc.list files			#
#									#
#	Usage:  incmerge.sh file1 file2 ...				#
#									#
#	Geoff Clare, UniSoft Ltd., 15 Nov 1990			  	#
#									#
#	Modified:							#
#		Geoff Clare, 21 Oct 1992			  	#
#		Handle header files with no listed contents		#
#									#
#		Geoff Clare, 12 Nov 1993			  	#
#		Add -i flag to sort, to cope with implementations that	#
#		include the newline in the sort key			#
#									#
#		Geoff Clare, 10 April 1997			  	#
#		Ignore comment lines in input files.			#
#									#
#########################################################################


awk '/^#/        { next }
     $1 ~ /\.h$/ { file = $0; print file ":"; next }
	   	 { print file ":" $0 }' "$@" | \
sort -iu | \
awk '{
	n = split($0, a, ":")
	if (n == 2 && a[2] == "")
	{
		print a[1]
		next
	}
	printf "%s", a[2]
	for (i = 3; i <= n+0; i++)
		printf ":%s", a[i]
	printf "\n"
}'
