: use /bin/sh
#########################################################################
#									#
#	SCCS:	@(#)install/scripts/posixonly.sh	4.1 (01/21/97)  VSXgen release 1.4#
#									#
#		  POSIX pre-configuration script			#
#		Remove sections not needed in POSIX modes		#
#									#
#########################################################################

RM='rm -rf'


echo "
**********************************************************
**		    VSXgen release 1.4			**
**		X/OPEN Verification Suite		**
**	         POSIX Pre-Configuration		**
**********************************************************
"

cd "$HOME" || exit 1
if test ! -d SRC/subsets
then
	echo "*** VSX must be installed in your HOME directory ($HOME)"
	exit 1
fi

# Construct list of sections required in POSIX mode in $PSECTS
# (all testsets named "*_X" will be removed from these sections),
# and list of sections NOT required in POSIX mode in $XSECTS
# (these sections will be entirely removed).

PSECTS=""
XSECTS=""
for file in SRC/subsets/*/config_info
do
	if test ! -r $file
	then
		echo "*** cannot open file: $file"
		exit 1
	fi

	CONFIG_POSIX_SECTIONS=""
	CONFIG_NONPOSIX_SECTIONS=""

	. $file

	PSECTS="$PSECTS $CONFIG_POSIX_SECTIONS"
	XSECTS="$XSECTS $CONFIG_NONPOSIX_SECTIONS"
done

case "$PSECTS$XSECTS" in
"")
	echo "*** no available subsets support the use of posixonly.sh"
	exit 1
	;;
esac

echo "
This procedure will remove all VSX tests which are not needed for
testing POSIX.1.  Afterwards VSX cannot be used in any X/Open modes
without re-installing the affected test packages.
"

while :
do
	echo "Are you sure you want to remove all non-POSIX tests? [y/n]: \c"
	if read ans
	then
		case "$ans" in
		[yY]*) break ;;
		[nN]*) exit 0 ;;
		*) echo "\nPlease answer 'y' or 'n'." ;;
		esac
	else
		exit 0
	fi
done

# create flag file for config.sh to notice
> SRC/install/posix_only

echo "
Removing directories $XSECTS under $HOME/tset"
(cd tset && $RM $XSECTS)

echo "
Removing directories $XSECTS under $HOME/MAN/tset"
(cd MAN/tset && $RM $XSECTS)

echo "
Removing X/Open specific tests from directories
$PSECTS under $HOME/tset"
(cd tset && find $PSECTS -name '*_X' -type d -exec $RM '{}' \;)

echo "
Removing X/Open specific tests from directories
$PSECTS under $HOME/MAN/tset"
(cd MAN/tset && find $PSECTS -name '*_X' -type d -exec $RM '{}' \;)

echo "
**********************************************************
**		    VSXgen release 1.4			**
**		X/OPEN Verification Suite		**
**	      End of POSIX Pre-Configuration		**
**********************************************************
"
