:
# SCCS:	@(#)SRC/subsets/base/config_sub.sh	Rel 4.4.1 (06/09/97)

# Ask for SIGNAL_SUPP if installing in a POSIX mode
# and not testing XNFS

case "$TEST_MODE:$TEST_XNFS" in
*:[yY])
	;;
POSIX*|FIPS*)
	if test -z "$SIGNAL_SUPP"
	then
		default=y
	else
		default=$SIGNAL_SUPP
	fi
	while :
	do
		getans "
Is the ANSI function signal() supported (y/n) [$default]? "
		if test -z "$ans"
		then
			ans=$default
		fi
		case "$ans" in
		y|n)
			SIGNAL_SUPP=$ans
			break
			;;
		*)
			;;
		esac
	done
	;;
*)
	SIGNAL_SUPP=y
	;;
esac

# set ASK_* variables for optional config parameters

case $TEST_XNFS in
[yY]*)
	ASK_RPCLIB=Y
	;;
*)
	ASK_MLIB=Y
	ASK_NOSPC_DEV=Y
	case $TEST_MODE in
	POSIX*|FIPS*) ;;
	*) ASK_CFPURE=Y ;;
	esac
	;;
esac

# create the install_info file (contents are mode-dependent)

INSTALL_LIBS="tsetlib"
INSTALL_USERINTF="gen_mnt gen_termios gen_newroot gen_setlimit gen_pathres"
INSTALL_USERINTF="$INSTALL_USERINTF base_setgrps base_cputime"
INSTALL_USER_TARGETS="dirgid filldisc"

case $TEST_XNFS:$TEST_MODE in
[yY]:*)
	INSTALL_LIBS="tsetlib xnfslib"
	INSTALL_UTILS=""
	INSTALL_USER_TARGETS=""
	INSTALL_USERINTF="gen_nfsmnt gen_newroot gen_setlimit gen_pathres base_setgrps"
	;;
*:POSIX*)
	INSTALL_UTILS="drivers"
	INSTALL_USER_TARGETS="filldisc"
	;;
*:FIPS*)
	INSTALL_UTILS="drivers"
	;;
*:XPG3)
	INSTALL_UTILS="drivers purefile"
	INSTALL_USER_TARGETS="filldisc"
	;;
*:XPG4)
	INSTALL_UTILS="drivers purefile wchars"
	INSTALL_USERINTF="$INSTALL_USERINTF base_ftok"
	;;
*:*) # UNIX98 and later - non XNFS
	INSTALL_UTILS="drivers purefile wchars"
	;;
esac

echo > "$VSXDIR"/subsets/base/install_info \
"INSTALL_LIBS=\"$INSTALL_LIBS\"
INSTALL_UTILS=\"$INSTALL_UTILS\"
INSTALL_USER_TARGETS=\"$INSTALL_USER_TARGETS\"
INSTALL_FIXED_TARGETS=\"\"
INSTALL_USERINTF=\"$INSTALL_USERINTF\"
"
