:
# SCCS:	@(#)SRC/subsets/dynl/config_sub.sh	Rel 5.1.4 (11/19/97)

# Ask for DYNL_DEPOBJ_SUPPORTED

if test -z "$DYNL_DEPOBJ_SUPPORTED"
then
	default="y"
else
	default=$DYNL_DEPOBJ_SUPPORTED
fi
while :
do
	getans "
Are dependencies between shared objects supported (y/n) [$default]? "
	if test -z "$ans"
	then
		ans=$default
	fi
	case "$ans" in
	y|n)
		DYNL_DEPOBJ_SUPPORTED=$ans
		break
		;;
	esac
done

# Ask for DYNL_NODEFS_SUPPORTED

if test -z "$DYNL_NODEFS_SUPPORTED"
then
	default="y"
else
	default=$DYNL_NODEFS_SUPPORTED
fi
while :
do
	getans "
Are shared objects containing unresolved references supported (y/n) [$default]? "
	if test -z "$ans"
	then
		ans=$default
	fi
	case "$ans" in
	y|n)
		DYNL_NODEFS_SUPPORTED=$ans
		break
		;;
	esac
done

# Ask for DYNL_COPTS and DYNL_LDFLAGS

if test -z "$DYNL_COPTS"
then
	if test -z "$COPTS"
	then
		default="none"
	else
		default="$COPTS"
	fi
else
	default="$DYNL_COPTS"
fi
getans "
What compiler options are used instead of the normal options when
compiling programs that employ dlopen() and its related services
[$default]? "
if test -z "$ans" 
then
	ans="$default"
fi
case "$ans" in
none)
	DYNL_COPTS=""
	;;
*)
	DYNL_COPTS="$ans"
	;;
esac

if test -z "$DYNL_LDFLAGS"
then
	if test -z "$LDFLAGS"
	then
		default="none"
	else
		default="$LDFLAGS"
	fi
else
	default="$DYNL_LDFLAGS"
fi
getans "
What link editor options are used instead of the normal options when
linking programs that employ dlopen() and its related services
[$default]? "
if test -z "$ans" 
then
	ans="$default"
fi
case "$ans" in
none)
	DYNL_LDFLAGS=""
	;;
*)
	DYNL_LDFLAGS="$ans"
	;;
esac

# Ask for DYNL_LIBDL 

if test -z "$DYNL_LIBDL"
then
	default="none"
else
	default=$DYNL_LIBDL
fi
warntxt=""
case "$CC" in
c89|*/c89) warntxt="
(Must be \"none\" for UNIX98 registration runs)" ;;
esac
while :
do
	getans "
Which library is your dynamic linking library (for dlopen() etc.)$warntxt
Enter either -l<name>, a full pathname, or \"none\": [$default]? "
	case $ans in
	"")
		break
		;;
	none)
		DYNL_LIBDL=""
		break
		;;
	-l*)
		if checklib "$ans"
		then
			DYNL_LIBDL="$ans"
			break
		else
			echo "*** Could not find library $ans"
		fi
		;;
	/*)
		if test -f "$ans"
		then
			DYNL_LIBDL="$ans"
			break
		else
			echo "*** Could not find library $ans"
		fi
		;;
	*)
		echo "*** $ans not of form: -l<name> or full pathname"
		;;
	esac
done

# Create template dynl_mkso.sh script for user to edit.
# Don't overwrite it if it already exists.

target="$VSXDIR"/dynl_mkso.sh

if test ! -f "$target"
then
	cp "$VSXDIR"/subsets/lsb-os/dynl_mkso.sh "$target"
	chmod 755 "$target"
fi
