: use /bin/sh
# $Header: /cvsroot/lsb/test_sets/lsb-os/SRC/subsets/lsb-os/config_sub-vsrt.sh,v 1.2 2001/09/19 09:05:30 ajosey Exp $
#
# Copyright (c) 1997 X/Open Company Limited, a member of the Open Group
#
# All rights reserved.  No part of this source code may be reproduced,
# stored in a retrieval system, or transmitted, in any form or by any
# means, electronic, mechanical, photocopying, recording or otherwise,
# except as stated in the end-user licence agreement, without the prior
# permission of the copyright owners.
#
# Motif, OSF/1 and UNIX are registered trademarks and X/Open,
# the "X Device" and The Open Group are trademarks of The Open Group.
#
# Project: VSRT
#
# File: SRC/subsets/vsrt/config_sub.sh
#
# Modifications
# $Log: config_sub-vsrt.sh,v $
# Revision 1.2  2001/09/19 09:05:30  ajosey
# make messages more generic in config.sh script
#
# Revision 1.1  2001/06/01 02:00:16  cyeoh
# Merges for lsb-os test suite
#
# Revision 11.2  2000/03/16 17:50:57  vsx
# ask for VSRT_LDFLAGS
#
# Revision 11.1  2000/03/09 11:30:50  vsx
# set ASK_THR_COPTS
#
# Revision 11.0  1999/03/22 19:46:27  andy
# Branch point for Release 5.0.3
#
# Revision 10.0  1999/02/08 16:44:02  andy
# Branch point for Release 5.0.3b1
#
# Revision 9.0  1998/07/15 18:57:24  andy
# Branch point for Release 5.0.2
#
# Revision 8.0  1998/06/18 22:21:30  andy
# Branch point for Release 5.0.2b2
#
# Revision 7.0  1998/05/25 01:53:16  andy
# Branch point for Release 5.0.2b1
#
# Revision 6.0  1998/01/04 02:33:26  tbr
# Branch point for Release vsrt 5.0.1A
#
# Revision 5.0  1997/11/26 21:44:09  andy
# Branch point for Release 5.0.1
#
# Revision 4.0  1997/10/22 15:42:45  dave
# Branch point for Release 5-0-0b1
#
# Revision 3.0  1997/07/27 18:15:35  andy
# Branch point for Release 5.0.0
#
# Revision 2.0  1997/06/15  19:58:52  andy
# Branch point for Release 5.0.0b1
#
# Revision 1.1  1997/04/29  00:56:28  andy
# Initial revision
#

# Ask for VSRT_LDFLAGS

if test -z "$VSRT_LDFLAGS"
then
	if test -z "$LDFLAGS"
	then
		default="none"
	else
		default="$LDFLAGS"
	fi
else
	default="$VSRT_LDFLAGS"
fi
getans "
What link editor options are used instead of the normal options when
linking programs that use threads and real time features [$default]? "
if test -z "$ans" 
then
	ans="$default"
fi
case "$ans" in
none)
	VSRT_LDFLAGS=""
	;;
*)
	VSRT_LDFLAGS="$ans"
	;;
esac

# Ask for VSRT_RT_LIB and VSRT_LIBS

# If there are default VSRT_RT_LIB, check compiler finds them
case $VSRT_RT_LIB in
"")
	;;
*)
	if checklib $VSRT_RT_LIB >/dev/null 2>&1
	then :
	else
		echo "
*** warning: compiler cannot find one or more default Realtime libraries"
	fi
	;;
esac

if test -z "$VSRT_RT_LIB"
then
	question="
There are no libraries needed to build programs using
only Realtime APIs. Is this correct (y/n) [y]? "
else
	question="
The following libraries are needed to build programs using
only Realtime APIs (e.g. -l rt):
	$VSRT_RT_LIB
Is this correct (y/n) [y]? "
fi
while :
do
	getans "$question"
	case "$ans" in
	"y"|"")
		confirm="1"
		break
		;;
	"n")
		confirm=""
		break
		;;
	*)
		;;
	esac
done

if test -z "$confirm"
then
	VSRT_LIBSTD=""
	echo "
Name the additional libraries needed, in order of searching
(should be of form: -l<name> or full pathname): "
	while :
	do
		getans "	Name of next library (type return to end): "
		case $ans in
		"")
			break
			;;
		-l*)
			# no quotes on $ans to allow for multiple libs
			# that need each other to link OK
			if checklib $ans
			then
				VSRT_LIBSTD="$VSRT_LIBSTD $ans"
			else
				echo "*** Could not find library $ans"
			fi
			;;
		/*)
			if test -f "$ans"
			then
				VSRT_LIBSTD="$VSRT_LIBSTD $ans"
			else
				echo "*** Could not find library $ans"
			fi
			;;
		*)
			echo "*** $ans not of form: -l<name> or full pathname"
			;;
		esac
	done
	VSRT_RT_LIB="$VSRT_LIBSTD"
fi

# If there are default VSRT_LIBS, check compiler finds them
case $VSRT_LIBS in
"")
	;;
*)
	if checklib $VSRT_LIBS >/dev/null 2>&1
	then :
	else
		echo "
*** warning: compiler cannot find one or more default VSRT libraries"
	fi
	;;
esac

if test -z "$VSRT_LIBS"
then
	question="
There are no libraries needed to build programs using
Base APIs (including Threads APIs) and Realtime APIs. Is this
correct (y/n) [y]? "
else
	question="
The following libraries are needed to build programs using
Base APIs (including Threads APIs) and Realtime APIs:
	$VSRT_LIBS
Is this correct (y/n) [y]? "
fi
while :
do
	getans "$question"
	case "$ans" in
	"y"|"")
		confirm="1"
		break
		;;
	"n")
		confirm=""
		break
		;;
	*)
		;;
	esac
done

if test -z "$confirm"
then
	VSRT_LIBSTD=""
	echo "
Name the additional libraries needed, in order of searching
(should be of form: -l<name> or full pathname): "
	while :
	do
		getans "	Name of next library (type return to end): "
		case $ans in
		"")
			break
			;;
		-l*)
			# no quotes on $ans to allow for multiple libs
			# that need each other to link OK
			if checklib $ans
			then
				VSRT_LIBSTD="$VSRT_LIBSTD $ans"
			else
				echo "*** Could not find library $ans"
			fi
			;;
		/*)
			if test -f "$ans"
			then
				VSRT_LIBSTD="$VSRT_LIBSTD $ans"
			else
				echo "*** Could not find library $ans"
			fi
			;;
		*)
			echo "*** $ans not of form: -l<name> or full pathname"
			;;
		esac
	done
	VSRT_LIBS="$VSRT_LIBSTD"
fi

# set ASK_* variables for optional config parameters

ASK_THR_COPTS=Y

