
#
#	@(#)config_sub.sh	1.9 - config_sub.sh for the VSTH test suite
#	Mount Bonnell Inc. Austin Texas USA
#

ASK_THR_COPTS=Y
ASK_MLIB=Y
ASK_VSTH_PTHREAD_LIB=Y
ASK_VSTH_SYSLIBS=Y
ASK_NOSPC_DEV=Y

if test -z "VSTH_PTHREAD_LIB"
then
	default="-lpthread"
else
	default="$VSTH_PTHREAD_LIB"
fi

while :
do
	getans "
Which library is your pthreads library [$default]?
(should be of the form: -l<name> or full pathname): "
	case $ans in
	"")
		break
		;;
	-l*)
		if checklib "$ans"
		then
			VSTH_PTHREAD_LIB="$ans"
			break
		else
			echo "*** Could not find library $ans"
		fi
		;;
	/*)
		if test -f "$ans"
		then
			VSTH_PTHREAD_LIB="$ans"
			break
		else
			echo "*** Could not find library $ans"
		fi
		;;
	*)
		echo "*** $ans not of the form: -l<name> -r full pathname"
		;;
	esac
done

if test -z "VSTH_SYSLIBS"
then
	default=""
else
	default="$VSTH_SYSLIBS"
fi

while :
do
	getans "
Which other libraries are needed to build VSTH [$default]?
(should be of the form: -l<name> or full pathname): "
	case $ans in
	"")
		break
		;;
	-l*)
		VSTH_SYSLIBS="$ans"
		break
		;;
	/*)
		VSTH_SYSLIBS="$ans"
		break
		;;
	*)
		echo "*** $ans not of the form: -l<name> -r full pathname"
		;;
	esac
done


