#!/bin/sh

printf "\n\n----------------------------------------------------------------------\n"
printf "Building and Executing testsets\n"

printf "Build testsets ..? [y]"
read cmd
if [ "$cmd" = "Y" -o "$cmd" = "y" -o "$cmd" = "" ] ; then
  tcc -p -b -s $HOME/scen.bld $*
fi

printf "\n\n----------------------------------------------------------------------\n"
printf "Executing testsets\n"
tcc -p -e -s $HOME/scen.exec $*
(cd results; awk -f `which vres` `ls -d 0* | tail -1`/journal)
printf "A formal report has been saved in $HOME/results/report\n"
(cd results; vrpt `ls -d 0* | tail -1`/journal >$HOME/results/report)

printf "Rerun just the failures (produces a journal of only fails) ..? [y] "
read cmd
if [ "$cmd" = "Y" -o "$cmd" = "y" -o "$cmd" = "" ] ; then
  JNL=`ls -d $HOME/results/0* | tail -1`
  JNLDIR=`basename $JNL`
  echo "running tcc -p -e -s scen.exec -r FAIL,UNRESOLVED,UNINITIATED results/$JNLDIR/journal"
  tcc -p -e -s scen.exec -r FAIL,UNRESOLVED,UNINITIATED results/$JNLDIR/journal
fi

