#!/bin/sh

# Installation of pseudo languages
#
# This is $Revision: 1.4 $
#
# $Log: psl_setup.sh,v $
# Revision 1.4  2001/10/05 02:00:04  cyeoh
# Remove extraneous \c
#
# Revision 1.3  2001/08/01 23:22:00  cyeoh
# remove debug message
#
# Revision 1.2  2001/08/01 22:54:53  cyeoh
# Add case where the version of libc is not embedded in the name
# of the library (such as in SuSE 7.1). Assumes glibc2.2
#
# Revision 1.1  2001/05/29 01:54:01  cyeoh
# Adds new scripts
#
#

if  test ! -f scripts/locks/psl_setup
then
  touch scripts/locks/psl_setup

  printf "Install pseudolanguages ..? [y] "
  read cmd
  if [ "$cmd" = "Y" -o "$cmd" = "y" -o "$cmd" = "" ] ; then
	  echo
	  echo Attempting to determine version of glibc on the system:
	  MINOR_LIBC_VERSION=`ls -1 /lib/libc-* 2> /dev/null | cut -f2 -d'-' | cut -f2 -d'.'`
          if [ -z $MINOR_LIBC_VERSION ]; then
            echo '** WARNING: Library name is not versioned. Assuming glibc 2.2 **'
            MINOR_LIBC_VERSION=2
          fi 
          MINOR_LIBC_VERSION=${MINOR_LIBC_VERSION:-2}
	  if [ $MINOR_LIBC_VERSION -eq 2 ]; then
	      echo Appears to be a glibc 2.2
	      PSLDEFS_DIR="psldefs"
	  else
	    MINOR_MINOR_LIBC_VERSION=`ls -1 /lib/libc-* | cut -f2 -d'-' | cut -f3 -d'.'`
	    if [ $MINOR_MINOR_LIBC_VERSION -gt 10 ]; then
	      echo Appears to be a beta version of glibc 2.2
	      echo Pretending its glibc 2.2
	      PSLDEFS_DIR="psldefs"
	    else
	      echo This appears to be a version of glibc older than 2.2 - beta
	      echo or otherwise. If this is not correct then we have a problem!
	      echo You may encounter problems installing the pseudo languages
	      echo and in running the tests associated with pseudo languages
	      PSLDEFS_DIR="psldefs-glibc2.1"
	    fi
	  fi
	  echo
	  printf "Enter the root password:\n"
	  su root -c "cd $TOOLDIR/$PSLDEFS_DIR && make"
  fi
fi
  
