/*
*      SCCS:  @(#)  ANSI.os/charhandle/toupper/toupper_X.c	Rel 4.4.1	    (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)ANSI.os/charhandle/toupper - T.toupper Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		T.toupper

PROJECT:	VSX (X/OPEN Validation Suite)


DESCRIPTION:
	Testset for the toupper() system call.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		J.A. Nave, UniSoft Ltd.
DATE CREATED:	Mon Oct 08 12:54:17 BST 1990

MODIFIED:	
		Geoff Clare, 30 March 1995
			Add setup function which calls pslclass().

************************************************************************/
#include	<std.h>
#include	<stdlib.h>
#include	<dbug.h>
#include	<nlstest.h>
#include	<nlsclass.h>
#include	<report.h>
#include	<ctype.h>
#include	<locale.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef toupper
#endif


#define 	NO_TESTS	1		/* number of tests in testset */
#define		WAITTIME	(5 * SPEEDFACTOR)

int	no_tests = NO_TESTS;

private int	testfail, thisfail;
private char	*currlang = "";

private void	setup();
private void	test1();
private void	ch_t1();

public	void	(*setfunc) () = setup;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	NULL, 0
};

private void
setup()
{
	DBUG_ENTER("setup");

	if (pslclass() != 0)
		xx_all(DELETION, "pslclass() failed in setup");

	DBUG_VOID_RETURN;
}

private void
test1()
{
	DBUG_ENTER("test1");

	(void) cppair(ch_t1, NULLFN, WAITTIME, 0);

	DBUG_VOID_RETURN;
}


private	void
ch_t1()
{
	int	rval;
	int	i;
	int	pathok = 0;

	DBUG_ENTER("ch_t1");

	testfail = 0;
	thisfail = 0;

	if (setlocale(LC_ALL, INFO1LANG) == NULL)
	{
		if (!testfail)
			xx_rpt(DELETION);
		in_rpt("Pseudo Language %s is not available",  INFO1LANG);
		in_rpt("Check instalation of pseudo language");
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	if (setlocale(LC_ALL, NOINFOLANG) == NULL)
	{
		if (!testfail)
			xx_rpt(DELETION);
		in_rpt("Pseudo Language %s is not available",  NOINFOLANG);
		in_rpt("Check instalation of pseudo language");
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	currlang =  NOINFOLANG;

	for (i = 0; i < 256; i++)
	{
		if (!(asc_table[i][0]&DEFLOWER))
		{
			PATH_TRACE;
			continue;
		}
		if ((rval = toupper(i)) != asc_table[i][1])
		{
			if (!testfail++)
				xx_rpt(FAILURE);
			if (!thisfail++)
				in_rpt("No current language has been set");
			in_rpt("toupper(0x%x) failed", i);
			in_rpt("Returned value 0x%x instead of 0x%x",
				rval, asc_table[i][1]);
		}
		else
			PATH_TRACE;
	}

	if (!testfail)
		PATH_XS_RPT(258);

	DBUG_VOID_RETURN;
}
