/*
*      SCCS:  @(#)  ANSI.os/genuts/abs/abs.c	Rel 4.4.1	    (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)ANSI.os/genuts/abs - T.abs Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		T.abs

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Testset for the abs() system call.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Alex Flynn, UniSoft Ltd.
DATE CREATED:	Tue Nov 11 14:26:51 WET 1986
MODIFICATIONS:
		Andrew Twigger	09 June 1987
		Removed testid()
		Modified xx_rpt(), xs_rpt()

		David Sawyer
		Thu Jul 05 17:16:30 BST 1990
		Added resilience code

************************************************************************/
#include	<std.h>
#include	<stdlib.h>
#include	<limits.h>
#include	<dbug.h>
#include	<report.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef abs
#endif


#define 	NO_TESTS	1		/* number of tests in testset */
#define		N_TSTNUMS	5

int	no_tests = NO_TESTS;

struct	tstnum	{
	int	num;
	int	absval;
};

private	struct	tstnum	tstnum[N_TSTNUMS] = { -1, 	1,
						300, 	300,
						-999,	999,
						-INT_MAX,  INT_MAX,
						0,	0
			    	     	    };

private void	test1();
public	void	(*setfunc) () = NULL;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	NULL, 0
};

private void
test1()
{
	int	nfails = 0;
	int	i;
	int	rtval;
	int	pathok = 0;

	DBUG_ENTER("test1");

	for (i = 0; i < N_TSTNUMS; i++)
	{
		if ( (rtval = abs(tstnum[i].num)) != tstnum[i].absval )
		{
			if ( nfails++ == 0 )
				xx_rpt(FAILURE);
			in_rpt("abs(%d) returned %d", tstnum[i].num, rtval);
		}
		else
			PATH_TRACE;
	}

	if ( nfails == 0 )
		PATH_XS_RPT(N_TSTNUMS);

	DBUG_VOID_RETURN;
}
