/*
*      SCCS:  @(#)  ANSI.os/genuts/atoi/atoi.c		Rel 4.4.1	    (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)ANSI.os/genuts/atoi - T.atoi Rel 4.4.1	(06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		T.atoi

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Testset for the atoi() system call.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Alex Flynn, UniSoft Ltd.
DATE CREATED:	Fri Nov  7 10:59:37 WET 1986
MODIFICATIONS:	Andrew Twigger	09 June 87
		Removed	testid()
		Modified xx_rpt(), xs_rpt()

		David Sawyer
		Fri Jul 06 09:37:41 BST 1990
		Added resillience code

************************************************************************/
#include	<std.h>
#include	<stdlib.h>
#include	<dbug.h>
#include	<report.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef atoi
#endif

#ifndef _XOPEN_SOURCE
#undef strtol
extern	long	strtol();
#endif

#define 	NO_TESTS	2		/* number of tests in testset */

int	no_tests = NO_TESTS;

private void	test1();
private void	test2();

public	void	(*setfunc) () = NULL;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	 test2, 2,
	NULL, 0
};

private void
test1()
{
	int	nfails = 0;
	int	rtstrtl;
	int	rtatoi;
	int	pathok = 0;

	DBUG_ENTER("test1");

	if ( (rtstrtl = (int) strtol("1234567890", (char **) NULL, 10))
 			!= (rtatoi = atoi("1234567890")) )
	{
		nfails++;
		xx_rpt(FAILURE);
		in_rpt("strtol(1234567890) with base 10 returned %d",
						rtstrtl);
		in_rpt("atoi(1234567890) returned %d", rtatoi);
	}
	else
		PATH_TRACE;

	if ( (rtstrtl = (int) strtol("12345A3", (char **) NULL, 10))
 			!= (rtatoi = atoi("12345A3")) )
	{
		if ( nfails++ == 0 )
			xx_rpt(FAILURE);
		in_rpt("strtol(12345A3) with base 10 returned %d",
						rtstrtl);
		in_rpt("atoi(12345A3) returned %d", rtatoi);
	}
	else
		PATH_TRACE;

	if ( nfails == 0 )
		PATH_XS_RPT(2);

	DBUG_VOID_RETURN;
}

private void
test2()
{
	int	nfails = 0;
	int	rtstrtl;
	int	rtatoi;
	int	pathok = 0;

	DBUG_ENTER("test2");

	if ( (rtstrtl = (int) strtol("\t  1234567890", (char **) NULL, 10))
 			!= (rtatoi = atoi("\t  1234567890")) )
	{
		nfails++;
		xx_rpt(FAILURE);
		in_rpt("strtol(\\t  1234567890) with base 10 returned %d",
						rtstrtl);
		in_rpt("atoi(\\t  1234567890) returned %d", rtatoi);
	}
	else
		PATH_TRACE;

	if ( nfails == 0 )
		PATH_XS_RPT(1);

	DBUG_VOID_RETURN;
}
