/*
*      SCCS:  @(#)  ANSI.os/genuts/qsort/qsort.c	Rel 4.4.1	    (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)ANSI.os/genuts/qsort - T.qsort Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		T.qsort

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Testset for the qsort() subroutine.
METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Alex Flynn, UniSoft Ltd.
DATE CREATED:	Tue Nov 25 09:36:26 WET 1986
MODIFICATIONS:	Andrew Twigger 10 June 87
		Removed testid()
		Modified xx_rpt(), xs_rpt()

		David Sawyer
		Fri Jul 06 12:26:14 BST 1990
		Added resillience code

		Geoff Clare, 15 Feb 1991
			Cast strcmp as argument to qsort so it
			matches prototype on ANSI C systems.

************************************************************************/
#include	<std.h>
#include	<stdlib.h>
#include	<sys/types.h>
#include	<setjmp.h>
#include	<dbug.h>
#include	<report.h>
#include	<string.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef qsort
#endif


#define 	NO_TESTS	1		/* number of tests in testset */
#define		WAITTIME	(5 * SPEEDFACTOR)
#define		NMR_ELTS	10
#define		ELT_SIZE	5

#if __STDC__ > 0
#define		ARG_CAST	(int (*)(const void *, const void *))
#else
#define		ARG_CAST
#endif

int	no_tests = NO_TESTS;

private void	test1();

public	void	(*setfunc) () = NULL;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	NULL, 0
};

private void
test1()
{
	int	i;
	int	correct;
	int	pathok = 0;

	static	char	table[ NMR_ELTS * ELT_SIZE + 1 ] = {
		"fdfvfdefvfqwsdcdefvfadcfrsgefsqwddfqlxcpwedresgetf"
	};


	DBUG_ENTER("test1");

	qsort((void *)table, (size_t)NMR_ELTS, (size_t)ELT_SIZE,
		ARG_CAST strcmp);

	correct = TRUE;
	for ( i = 0 ; i < NMR_ELTS - 1 ; i++ )
	{
		correct = (strncmp(&table[i * ELT_SIZE], 
			&table[(i + 1) * ELT_SIZE], (size_t)ELT_SIZE) <= 0);
		if ( ! correct )
			break;
		else
			PATH_TRACE;
	}

	if ( ! correct )
	{
		xx_rpt(FAILURE);
		in_rpt("element %.5s was before %.5s in table sorted by qsort",
			&table[i * ELT_SIZE], &table[(i + 1) * ELT_SIZE]);
	}
	else
		PATH_XS_RPT(NMR_ELTS-1);
				
	DBUG_VOID_RETURN;
}
