/*
*      SCCS:  @(#)  ANSI.os/genuts/rand/rand.c	Rel 4.4.1	    (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)ANSI.os/genuts/rand - T.rand Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		T.rand

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Testset for the rand() subroutine.
METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Alex Flynn, UniSoft Ltd.
DATE CREATED:	Mon Nov 24 11:38:47 WET 1986
MODIFICATIONS:	Andrew Twigger 10 June 87
		Removed	abandon(), testid()
		Modified xx_rpt(), xs_rpt()

		Linda Taylor, Hoskyns.	21st, August, 1988.
		Removed tests for srand() to T.srand

		David Sawyer
		Fri Jul 06 12:39:27 BST 1990
		Added resillience code

************************************************************************/
#include	<std.h>
#include	<stdlib.h>
#include	<dbug.h>
#include	<report.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef rand
#endif


#define 	NO_TESTS	1		/* number of tests in testset */
#define		WAITTIME	(5 * SPEEDFACTOR)

int	no_tests = NO_TESTS;

private void	test1();

public	void	(*setfunc) () = NULL;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	NULL, 0
};

private void
test1()
{
	int	i;
	int	rtval;
	int	pathok = 0;

	DBUG_ENTER("test1");

	for ( i = 0 ; i < 100 ; i++ )
	{
		if ( (rtval = rand()) < 0 || (rtval > RAND_MAX) )
		{
			xx_rpt(FAILURE);
			in_rpt("rand() returned %d:", rtval);
			in_rpt("not in the range 0 to RAND_MAX");
			DBUG_VOID_RETURN;
		}
		else
			PATH_TRACE;
	}

	PATH_XS_RPT(100);

	DBUG_VOID_RETURN;
}
