/*
*      SCCS:  @(#)  ANSI.os/genuts/system/sys_cmd1/sys_cmd1.c	Rel 4.4.1     (06/09/97) 
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

/***********************************************************************

NAME:		T.system

PROJECT:	VSX (X/OPEN Validation Suite)


MODULE CONTAINS:
	cmd1()

SYNOPSIS:
	cmd1()

DESCRIPTION:
	cmd1 for the system() subroutine.

AUTHOR:		Manucher Ghezel-Ayagh, UniSoft Ltd.
DATE CREATED:	Tue Dec  9 13:46:19 WET 1986
MODIFICATIONS:

************************************************************************/
#include	<std.h>
#include	<dbug.h>
#include	<sys/types.h>
#include	<errno.h>
#include	<fcntl.h>
#include	<string.h>
#include	<unistd.h>
#include	<stdlib.h>
#include	<exitcodes.h>
#include	<sys/stat.h>
#include	<vsx_system.h>
#include	<sysdep.h>

extern	char	*errname();

main()
{
	int		fd;
	int		i;
	int		pid;
	struct stat	statbuf;
	ino_t		izero = 0;
	dev_t		dzero = 0;
	char		buf[512];
	char		*next;

	next = buf;
	for (i = 0; i <= 2; i++)
	{
		errno = NOERROR;
		if (fstat(i, &statbuf) == SYSERROR)
		{
			if (errno != EBADF)
				exit(E_STAT);
			(void) memcpy((void *)next, (void *) &izero, (size_t)sizeof (ino_t));
			next += sizeof (ino_t);
			(void) memcpy((void *)next, (void *) &dzero, (size_t)sizeof (dev_t));
			next += sizeof (dev_t);
		}
		else {
			(void) memcpy((void *)next, (void *) &(statbuf.st_ino), (size_t)sizeof (ino_t));
			next += sizeof (ino_t);
			(void) memcpy((void *)next, (void *) &(statbuf.st_dev), (size_t)sizeof (dev_t));
			next += sizeof (dev_t);
		}
	}
	pid  = getpid();
	(void) memcpy((void *)next, (void *) &pid, (size_t)sizeof (int));
	next += sizeof (int);

	if ((fd = creat(t1_info, MODEANY)) == SYSERROR)
			exit(E_CREAT);

	if (write(fd, buf, (unsigned) (next - buf)) != (next - buf))
			exit(E_WRITE);
	(void) close (fd);
	
	exit(OK0);

	/* NOTREACHED */
}
