/*
*      SCCS:  @(#)  ANSI.os/genuts/system/system1.c	Rel 4.4.1     (06/09/97) 
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#ifdef	MAIN
static	char sccsid[] = "@(#)ANSI.os/genuts/system - T.system Rel 4.4.1 (06/09/97)";
/*
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
*/
#endif	/* MAIN	*/
#endif  /* lint	*/

/***********************************************************************

NAME:		system1.c

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Testset for the system() subroutine.

AUTHOR:		Manucher Ghezel-Ayagh, UniSoft Ltd.
DATE CREATED:	Tue Dec  9 10:00:43 WET 1986
MODIFICATIONS:	Andrew Twigger 1 July 87
		Added	vg_sjmp, setjmp(), tn_rpt()
		Removed	abandon(), testid()
		Modified xs_rpt(), xx_rpt()

		Dave Cater Mon May  8 13:52:37 BST 1989
		Replaced HIBYTE() with WIFEXITED(), etc.

		Geoff Clare, 30 June 1989
		Don't use above VNOJSIG when no job control

		David Sawyer
		Tue Jul 10 11:38:50 BST 1990
		Added resillience code.

		Geoff Clare, 7 Nov 1990
		Change test25() to avoid race condition.

		Geoff Clare, 14 Feb 1991
		Add test that system(NULL) returns non-zero.

		Geoff Clare, 19 Sep 1991
		Change delay() to sleep() in test20.

		Neil Moses, 2 Oct 1991
		Added new tests for VSX 4.2

		Geoff Clare, 29 Apr 1992
		Skip XCU4-sh specific cmds if sysconf(_SC_2_VERSION) == -1

		Geoff Clare, 30 Apr 1992
		Change ECHILD to EAGAIN in test58 reporting.

		Geoff Clare, 18 May 1992
		Remove EINTR test from XPG4 mode.  Add interrupted call
		to "does not return until child terminates" test.

		Geoff Clare, 16 June 1992
		Changed test 49 so as not to overwrite string literals.

		Geoff Clare, 24 Jan 1994
		Inserted closing double quote char. in test 44 system() arg.

************************************************************************/
#include	<std.h>
#include	<sys/types.h>
#include	<sys/wait.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<dbug.h>
#include	<unistd.h>
#include	<errno.h>
#include	<time.h>
#include	<report.h>
#include	<string.h>
#include	<fcntl.h>
#include	<signal.h>
#include	<exitcodes.h>
#include	<sys/stat.h>
#include	<pcts_max.h>
#include	<vsx_signal.h>
#include	<vsx_system.h>
#include	<timeout.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef system
#endif


#define	NO_TESTS	59		/* number of tests in testset */
#define	PATH2		"PATH=.:.."
#define	BSIZE		10		/* buffer size for creating files */
#define	M_ARGLEN	50		/* buffer size for command arguments */

#if TEST_XPG > 3
#define	PATH_ERR	2
#define	NOK		4
#define	DEL		8
#define	BUF_SIZ		512
#define	P_RD		0		/* read file descriptor of pipe */
#define	P_WR		1		/* write file descriptor of pipe */
#endif

extern	void	delay();
extern	int	cppair();
extern	char	*errname();
extern	char	*pr_nchars();
extern	char	*itoa();
extern	char	*ltoa();
extern	void	(*vsignal())();
extern	int	pipe_open();
extern	void	pipe_close();
extern	void	pipe_child();
extern	void	pipe_parent();
extern	void	pipe_xx_rpt();
extern	void	pipe_in_rpt();

extern	char	*vg_dbug;
extern	char	*vg_ident;
extern	char	**environ;

extern	int	no_tests;

struct devino {
	ino_t	inode;
	dev_t	device;
};

extern struct devino sav_devino[3];

private	char	*def_stdin =	"/dev/null";
private	char	*t19_file =	"./system-t.19";
private	char	*t21_file =	"./system-t.21";
private	char	*t39a_file =	"./system-t.39a";
private	char	*t39b_file =	"./system-t.39b";
private	char	*t39c_file =	"./system-t.39c";
private	char	*t41_file =	"./.system-t.41";
#if TEST_XPG > 3
private	char	*prog56 =	"../sys_t56";
private	char	*prog57 =	"../sys_t57";

private	int	fret;
private	int	t49_i;
private	int	pipdes[2];
private	FILE	*f_rd;
private	char	buf[BUF_SIZ];

private char	*signame;
private int	tsignal;
private int	tfail;
private int	t59_errno;
private pid_t	t59_rval;
private	sigset_t t51_set;
private	int 	t50_flag;
private	int 	t51_flag;
private struct sigaction sigint;
private struct sigaction sigquit;
#endif

extern	int	rd_info();
extern	int	cmp_devino();
extern	int	rep_devino();
extern	void	exit_fail();
public	void	test18();
public	void	test19();
public	void	test20();
public	void	test21();
public	void	test22();
public	void	test23();
public	void	test24();
public	void	test25();
public	void	test26();
public	void	test27();
public	void	test28();
public	void	test29();
public	void	test30();
public	void	test31();
public	void	test32();
public	void	test33();
public	void	test34();
public	void	test35();
public	void	test36();
public	void	test37();
public	void	test38();
public	void	test39();
public	void	test40();
public	void	test41();
public	void	test42();
public	void	test43();
public	void	test44();
public	void	test45();
public	void	test46();
public	void	test47();
public	void	test48();
public	void	test49();
public void	test50();
public void	test51();
public void	test52();
public void	test53();
public void	test54();
public void	test55();
public void	test56();
public void	test57();
public void	test58();
public void	test59();
private void	ch_t45();
private void	ch_t46();
private void	ch_t47();
#if TEST_XPG > 3
private void	ch_t49();
private void	pa_t49();
private void	ch_t50();
private void	ch_t50_sig();
private void	ch_t51();
private void	ch_t51_sig();
private void	ch_t52();
private void	pa1_t52();
private void	pa2_t52();
private void	ch_t53();
private void	ch_t56();
private void	ch_t57();
private void	ch_t58();
private void	t59_sig();

/* "4:" on the front of cmd indicates an XCU4-sh specific command */
private struct {
	char	*cmd;
	char	*expres;
} cmds[] = {
	"NAME=SYSTEM; echo $NAME", "SYSTEM\n",
	"NAME=SYSTEM; echo '$NAME'", "$NAME\n",
	"NAME=SYSTEM; echo \\$NAME", "$NAME\n",
	"echo \"*\"", "*\n",
	"echo `echo system`", "system\n",
	"echo system #Ignore this", "system\n",
	"for i in testword\ndo\nif [ \"$i\" = \"testword\" ]\nthen\necho $i\nfi\ndone", "testword\n",
	"NAME=SYSTEM; unset NAME; echo NONAME$NAME", "NONAME\n",
	"set one two three; echo $1 $2 $3", "one two three\n",
	"set one two three; echo $*", "one two three\n",
	"set one two three; echo $#", "3\n",
	"set one two three; shift; echo $1", "two\n",
	"set one two three; shift; echo $*", "two three\n",
	"set one two three; shift; echo $#", "2\n",
	"NAME=SYSTEM; (echo $NAME)", "SYSTEM\n",
	"set one; echo $1", "one\n",
	"4:echo $(expr 1 + 2)", "3\n",
	"echo `expr 1 + 2`", "3\n",
	"echo \"SYSTEM system\"", "SYSTEM system\n",
	"cat <<!\nSYSTEM\n!", "SYSTEM\n",
	"echo REMOVESYSTEM | grep SYSTEM | sed -e 's/REMOVE//g'", "SYSTEM\n",
	"> t49_file; ls t??_[fabc]*e; rm -f t49_file", "t49_file\n",
	"echo SYSTEM > t49_file; cat t49_file; rm -f t49_file", "SYSTEM\n",
	"echo SYSTEM 2> t49_file 1>&2; cat t49_file; rm -f t49_file", "SYSTEM\n",
	"echo SYSTEM1 > t49_file; echo SYSTEM2 >> t49_file; cat t49_file; rm -f t49_file", "SYSTEM1\nSYSTEM2\n",
	"ls xxxx 2> t49_file; if [ -s t49_file -a $? -ne 0 ]\nthen\necho PASS\nfi; rm -f t49_file", "PASS\n",
	"echo echo SYSTEM > t49_file; chmod u+x t49_file; PATH=.:$PATH; t49_file; rm -f t49_file", "SYSTEM\n",
	"trap \"echo TRAPPED\" 15; kill -15 $$", "TRAPPED\n",
	NULL, NULL
};
#endif

public void
test18()
{
	int		rval;
	int		i;
	int		failed = 0;
	int		syspid;
	struct devino	exp_devino[3];
	struct devino	obs_devino[3];
	int		pathok = 0;

	DBUG_ENTER("test18");

	exp_devino[1].inode = 0;
	exp_devino[1].device = 0;
	for (i = 0; i <= 2; i += 2)
	{
		if (i==0)
			PATH_TRACE;
		exp_devino[i].inode  = sav_devino[i].inode;
		exp_devino[i].device = sav_devino[i].device;
	}

	(void) system("1>&- ../sys_cmd1");

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		if (! failed)
			xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;

	exp_devino[2].inode = 0;
	exp_devino[2].device = 0;
	for (i = 0; i <= 1; i++)
	{
		if (i==0)
			PATH_TRACE;
		exp_devino[i].inode  = sav_devino[i].inode;
		exp_devino[i].device = sav_devino[i].device;
	}

	(void) system("../sys_cmd1 2>&-");

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		if (! failed)
			xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;
	if (! failed)
		PATH_XS_RPT(6);

	DBUG_VOID_RETURN;
}

public void
test19()
{
	int		fd;
	int		rval;
	int		syspid;
	char		cmd1[30];
	char		chfd[2];
	struct stat	statbuf;
	struct devino	exp_devino[3];
	struct devino	obs_devino[3];
	int		pathok = 0;

	DBUG_ENTER("test19");

	errno = NOERROR;
	if ((fd = creat(t19_file, MODEANY)) == SYSERROR)
	{
		xx_rpt(DELETION);
		in_rpt("creat(%s, MODEANY) failed - errno %d(%s)",
			t19_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	if (fd > 9)
	{
		xx_rpt(DELETION);
		in_rpt("can't attribute file descriptor < 9 to %s", t19_file);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;
	chfd[0] = '0' + fd;
	chfd[1] = '\0';

	errno = NOERROR;
	if (stat(t19_file, &statbuf) == SYSERROR) {
		xx_rpt(DELETION);
		in_rpt("stat(%s) failed - errno %d(%s)",
			t19_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	exp_devino[1].inode = statbuf.st_ino;
	exp_devino[1].device = statbuf.st_dev;

	(void) strcpy(cmd1, "../sys_cmd1 1>&");
	(void) strcat(cmd1, chfd);
	(void) strcat(cmd1, " 2>&1");
	(void) system(cmd1);

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;

	if ((exp_devino[1].inode != obs_devino[1].inode) ||
	    (exp_devino[1].device != obs_devino[1].device))
	{
		xx_rpt(FAILURE);
		if (exp_devino[1].inode != obs_devino[1].inode)
			in_rpt("stdout inode number, expected : %lu , observed : %lu",
			(unsigned long) exp_devino[1].inode,
			(unsigned long) obs_devino[1].inode);

		if (exp_devino[1].device != obs_devino[1].device)
			in_rpt("stdout device number, expected : %lu , observed : %lu",
			(unsigned long) exp_devino[1].device,
			(unsigned long) obs_devino[1].device);
	}
	else
	{
		PATH_TRACE;
		PATH_XS_RPT(5);
	}

	(void) close (fd);
	(void) unlink(t19_file);
	DBUG_VOID_RETURN;
}

public void
test20()
{
	int		rval;
	int		syspid;
	struct stat	statbuf;
	struct devino	exp_devino[3];
	struct devino	obs_devino[3];
	int		pathok = 0;

	DBUG_ENTER("test20");

	errno = NOERROR;
	if (stat(def_stdin, &statbuf) == SYSERROR) {
		xx_rpt(DELETION);
		in_rpt("stat(%s) failed - errno %d(%s)",
			def_stdin, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	exp_devino[0].inode = statbuf.st_ino;
	exp_devino[0].device = statbuf.st_dev;

	(void) system("../sys_cmd1 &");

	(void) sleep(WAITTIME);

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;

	if ((exp_devino[0].inode != obs_devino[0].inode) ||
	    (exp_devino[0].device != obs_devino[0].device))
	{
		xx_rpt(FAILURE);
		in_rpt("default standard input not %s as expected", def_stdin);
		if (exp_devino[0].inode != obs_devino[0].inode)
			in_rpt("stdin inode number, expected : %lu , observed : %lu",
			(unsigned long) exp_devino[0].inode,
			(unsigned long) obs_devino[0].inode);

		if (exp_devino[0].device != obs_devino[0].device)
			in_rpt("stdin device number, expected : %lu , observed : %lu",
			(unsigned long) exp_devino[0].device,
			(unsigned long) obs_devino[0].device);
	}
	else
	{
		PATH_TRACE;
		PATH_XS_RPT(3);
	}

	DBUG_VOID_RETURN;
}

public void
test21()
{
	int		fd;
	int		rval;
	int		sval;
	int		failed = 0;
	int		syspid1;
	int		syspid2;
	char		cmd1[40];
	char		chfd[2];
	struct stat	statbuf;
	struct devino	exp_devino[3];
	struct devino	obs_di1[3];
	struct devino	obs_di2[3];
	int		pathok = 0;

	DBUG_ENTER("test21");

	errno = NOERROR;
	if ((fd = creat(t21_file, MODEANY)) == SYSERROR)
	{
		xx_rpt(DELETION);
		in_rpt("creat(%s, MODEANY) failed - errno %d(%s)",
			t21_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	if (fd > 9)
	{
		xx_rpt(DELETION);
		in_rpt("can't attribute file descriptor < 9 to %s", t21_file);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;
	chfd[0] = '0' + fd;
	chfd[1] = '\0';

	errno = NOERROR;
	if (stat(t21_file, &statbuf) == SYSERROR) {
		xx_rpt(DELETION);
		in_rpt("stat(%s) failed - errno %d(%s)",
			t21_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	exp_devino[0].inode = statbuf.st_ino;
	exp_devino[0].device = statbuf.st_dev;

	(void) strcpy(cmd1, "../sys_cmd1 | ../sys_cmd2 1>&");
	(void) strcat(cmd1, chfd);
	sval = system(cmd1);

	if (rval = rd_info(t1_info, obs_di1, &syspid1))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;

	if (rval = rd_info(t2_info, obs_di2, &syspid2))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t2_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t2_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if ((exp_devino[0].inode != obs_di2[1].inode) ||
	    (exp_devino[0].device != obs_di2[1].device))
	{
		xx_rpt(FAILURE);
		if (exp_devino[0].inode != obs_di2[1].inode)
			in_rpt("cmd2 stdout inode number, expected : %lu , observed : %lu",
			(unsigned long) exp_devino[0].inode,
			(unsigned long) obs_di2[1].inode);

		if (exp_devino[0].device != obs_di2[1].device)
			in_rpt("cmd2 stdout device number, expected : %lu , observed : %lu",
			(unsigned long) exp_devino[0].device,
			(unsigned long) obs_di2[1].device);
		failed++;
	}
	else
		PATH_TRACE;
	if (syspid1 == syspid2)
	{
		if (! failed)
			xx_rpt(FAILURE);
		in_rpt("both commands have the same process ID : %ld", syspid1);
		failed++;
	}
	else
		PATH_TRACE;
	if (WIFEXITED(sval) == 0)
	{
		exit_fail(sval, failed);
		failed++;
	}
	else 
	{
		PATH_TRACE;
		if (WEXITSTATUS (sval) != OK1)
		{
			if (! failed)
				xx_rpt(FAILURE);
			in_rpt("system did not return the exit status of cmd2");
			in_rpt("expected return value: %d, observed: %d", OK1, WEXITSTATUS(sval));
			failed++;
		}
		else
			PATH_TRACE;
	}
	if (! failed)
		PATH_XS_RPT(9);

	(void) close(fd);
	(void) unlink(t21_file);

	DBUG_VOID_RETURN;
}

public void
test22()
{
	int		sval;
	int		failed = 0;
	int		pathok = 0;

	DBUG_ENTER("test22");

	sval = system("../sys_cmd3 || ../sys_cmd4");

	if (WIFEXITED(sval) == 0)
	{
		exit_fail(sval, 0);
		failed++;
	}
	else
	{
		PATH_TRACE;
		if (WEXITSTATUS (sval) != OK0)
		{
			xx_rpt(FAILURE);
			in_rpt("system did not return the exit status of cmd3");
			in_rpt("expected return value: %d, observed: %d", OK0, WEXITSTATUS(sval));
			failed++;
		}
		else
			PATH_TRACE;
	}

	sval = system("../sys_cmd4 || ../sys_cmd3");

	if (WIFEXITED(sval) == 0)
	{
		exit_fail(sval, failed);
		failed++;
	}
	else
	{
		PATH_TRACE;
		if (WEXITSTATUS (sval) != OK0)
		{
			if (! failed)
				xx_rpt(FAILURE);
			in_rpt("system did not return the exit status of cmd3");
			in_rpt("expected return value: %d, observed: %d", OK0, WEXITSTATUS(sval));
			failed++;
		}
		else
			PATH_TRACE;
	}
	if (! failed)
		PATH_XS_RPT(4);

	DBUG_VOID_RETURN;
}

public void
test23()
{
	int		sval;
	int		failed = 0;
	int		pathok = 0;

	DBUG_ENTER("test23");

	sval = system("../sys_cmd3 && ../sys_cmd4");

	if (WIFEXITED(sval) == 0)
	{
		exit_fail(sval, 0);
		failed++;
	}
	else 
	{
		PATH_TRACE;
		if (WEXITSTATUS (sval) != OK5)
		{
			xx_rpt(FAILURE);
			in_rpt("system did not return the exit status of cmd4");
			in_rpt("expected return value: %d, observed: %d", OK5, WEXITSTATUS(sval));
			failed++;
		}
		else
			PATH_TRACE;
	}

	sval = system("../sys_cmd4 && ../sys_cmd3");

	if (WIFEXITED(sval) == 0)
	{
		exit_fail(sval, failed);
		failed++;
	}
	else 
	{
		PATH_TRACE;
		if (WEXITSTATUS (sval) != OK5)
		{
			if (! failed)
				xx_rpt(FAILURE);
			in_rpt("system did not return the exit status of cmd4");
			in_rpt("expected return value: %d, observed: %d", OK5, WEXITSTATUS(sval));
			failed++;
		}
		else
			PATH_TRACE;
	}
	if (! failed)
		PATH_XS_RPT(4);

	DBUG_VOID_RETURN;
}

public void
test24()
{
	int		failed = 0;
	struct stat	statbuf;
	int		pathok = 0;

	DBUG_ENTER("test24");

	(void) system("../sys_cmd24 &");

	errno = NOERROR;
	if (stat(t24b_file, &statbuf) != SYSERROR)
	{
		xx_rpt(FAILURE);
		in_rpt("cmd24 was not executed asynchronously as expected");
		in_rpt("stat(%s) did not fail", t24b_file);
		failed++;
	}
	else
		PATH_TRACE;

	(void) delay(WAITTIME*2);

	errno = NOERROR;
	if ((stat(t24a_file, &statbuf) == SYSERROR) && (errno == ENOENT))
	{
		if (! failed)
			xx_rpt(FAILURE);
		in_rpt("cmd24 was not executed at all");
		in_rpt("stat(%s) failed - errno %d(%s)",
			t24a_file, errno, errname(errno));
		failed++;
	}
	else
		PATH_TRACE;
	if (! failed)
		PATH_XS_RPT(2);

	(void) unlink(t24a_file);
	(void) unlink(t24b_file);
	DBUG_VOID_RETURN;
}

public void
test25()
{
	int		failed = 0;
	time_t		t0;
	struct stat	statbuf;
	int		pathok = 0;

	DBUG_ENTER("test25");

	(void) system("../sys_cmd24 & ../sys_cmd25");

	/* wait until first file has been created by sys_cmd24 */

	(void) time(&t0);
	while (stat(t24a_file, &statbuf) == SYSERROR)
	{
		if (time((time_t *)0) > t0 + WAITTIME)
		{
			xx_rpt(DELETION);
			in_rpt("timed out waiting for %s to be created",
				t24a_file);
			DBUG_VOID_RETURN;
		}
	}

	/* now second sys_cmd24 file should not have been created, and
	   sys_cmd25 file should have been created */

	if (stat(t24b_file, &statbuf) != SYSERROR)
	{
		xx_rpt(FAILURE);
		in_rpt("cmd24 was not executed asynchronously with cmd25 ");
		in_rpt("stat(%s) did not fail", t24b_file);
		failed++;
	}
	else
		PATH_TRACE;

	errno = NOERROR;
	if (stat(t25_file, &statbuf) == SYSERROR)
	{
		if (! failed)
		{
			xx_rpt(FAILURE);
			in_rpt("cmd24 was not executed asynchronously with cmd25 ");
		}
		in_rpt("stat(%s) failed - errno %d(%s)",
			t25_file, errno, errname(errno));
		failed++;
	}
	else
		PATH_TRACE;

	if (! failed)
		PATH_XS_RPT(2);

	(void) delay(WAITTIME*2);
	(void) unlink(t24a_file);
	(void) unlink(t24b_file);
	(void) unlink(t25_file);
	DBUG_VOID_RETURN;
}

public void
test26()
{
	int		failed = 0;
	struct stat	statbuf;
	int		pathok = 0;

	DBUG_ENTER("test26");

	(void) system("../sys_cmd26a ; ../sys_cmd26c");

	errno = NOERROR;
	if (stat(t26b_file, &statbuf) != SYSERROR)
	{
		xx_rpt(FAILURE);
		in_rpt("cmd26c was not executed synchronously with cmd26a");
		in_rpt("stat(%s) did not fail", t26b_file);
		(void) unlink(t26b_file);
		failed++;
	}
	else
		PATH_TRACE;
	(void) unlink(t26a_file);

	/* first command returns non-zero this time */
	(void) system("../sys_cmd26b ; ../sys_cmd26c");

	errno = NOERROR;
	if (stat(t26b_file, &statbuf) != SYSERROR)
	{
		if (! failed)
			xx_rpt(FAILURE);
		in_rpt("cmd26c was not executed synchronously with cmd26b");
		in_rpt("stat(%s) did not fail", t26b_file);
		(void) unlink(t26b_file);
		failed++;
	}
	else
		PATH_TRACE;

	if (! failed)
		PATH_XS_RPT(2);

	(void) unlink(t26a_file);
	DBUG_VOID_RETURN;
}

public void
test27()
{
	int		sval;
	int		pathok = 0;

	DBUG_ENTER("test27");

	sval = system("../sys_cmd4;");

	if (WIFEXITED(sval) == 0)
	{
		exit_fail(sval, 0);
	}
	else
	{
		PATH_TRACE;
		if (WEXITSTATUS (sval) != OK5)
		{
			xx_rpt(FAILURE);
			in_rpt("./cmd4;    was tried");
			in_rpt("expected return value: %d, observed: %d", OK5, WEXITSTATUS(sval));
		}
		else
		{
			PATH_TRACE;
			PATH_XS_RPT(2);
		}
	}

	DBUG_VOID_RETURN;
}

public void
test28()
{
	int		sval;
	int		pathok = 0;

	DBUG_ENTER("test28");

	sval = system("../sys_cmd4 && ../sys_cmd3 ; ../sys_cmd28");

	if (WIFEXITED(sval) == 0)
	{
		exit_fail(sval, 0);
	}
	else 
	{
		PATH_TRACE;
		if (WEXITSTATUS (sval) != OK7)
		{
			xx_rpt(FAILURE);
			in_rpt("';' has higher precedence than '&&'");
			in_rpt("cmd4 && cmd3 ; cmd28   was tried");
			in_rpt("cmd28 was not executed");
			in_rpt("expected return value: %d, observed: %d", OK7, WEXITSTATUS(sval));
		}
		else
		{
			PATH_TRACE;
			PATH_XS_RPT(2);
		}
	}

	DBUG_VOID_RETURN;
}

public void
test29()
{
	int		sval;
	int		pathok = 0;

	DBUG_ENTER("test29");

	sval = system("#; ./system_exit 1");

	if (WIFEXITED(sval) == 0)
	{
		exit_fail(sval, 0);
	}
	else
	{
		PATH_TRACE;
		if (WEXITSTATUS (sval) != OK0)
		{
			xx_rpt(FAILURE);
			in_rpt("'#' did not cause the rest of the command line to be ignored");
			in_rpt("expected return value: %d, observed: %d", OK0, WEXITSTATUS(sval));
		}
		else
		{
			PATH_TRACE;
			PATH_XS_RPT(2);
		}
	}

	DBUG_VOID_RETURN;
}

public void
test30()
{
	int		sval;
	int		pathok = 0;

	DBUG_ENTER("test30");

	sval = system("../sys_exit `../sys_cmd30`");

	if (WIFEXITED(sval) == 0)
	{
		exit_fail(sval, 0);
	}
	else 
	{
		PATH_TRACE;
		if (WEXITSTATUS (sval) != OK5)
		{
			xx_rpt(FAILURE);
			in_rpt("command enclosed in a pair of grave accents was not replaced correctly");
			in_rpt("../sys_exit `../sys_cmd30`   was tried");
			in_rpt("expected return value: %d, observed: %d", OK5, WEXITSTATUS(sval));
		}
		else
		{
			PATH_TRACE;
			PATH_XS_RPT(2);
		}
	}

	DBUG_VOID_RETURN;
}

public void
test31()
{
	int		failed = 0;
	int		i;
	int		nargs = 5;
	char		obs_arg[5][M_ARGLEN];
	static char	*exp_arg[] = {
		"../sys_cmd31",
		"arg1",
		"2",
		"3333",
		"a4"
	};
	FILE		*fp;
	int		pathok = 0;

	DBUG_ENTER("test31");

	(void) system("../sys_cmd31 arg1 2 3333 a4");

	if ((fp = fopen(t31_file, "r")) == NULL)
	{
		xx_rpt(DELETION);
		in_rpt("fopen(%s, r) failed", t31_file);
		(void) unlink(t31_file);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	for (i =0; i < nargs; i++)
		if (fgets(obs_arg[i], M_ARGLEN, fp) == NULL)
		{
			xx_rpt(FAILURE);
			in_rpt("incorrect argument count");
			in_rpt("expected arg count: %d, observed: %d", nargs,i);
			failed++;
			break;
		}
		else
		{
			PATH_TRACE;
			/* get rid of the NL */
			obs_arg[i][(strlen(obs_arg[i]) - 1)] = '\0';
		}

	for (i = 0; i < nargs; i++)
		if (strcmp(exp_arg[i], obs_arg[i]))
		{
			if (! failed)
				xx_rpt(FAILURE);
			in_rpt("incorrect argument: %d", i);
			in_rpt("expected: %s, observed: %s", exp_arg[i],obs_arg[i]);
			failed++;
		}
		else
			PATH_TRACE;
	if (! failed)
		PATH_XS_RPT(1+nargs+nargs);
	(void) fclose(fp);
	(void) unlink(t31_file);

	DBUG_VOID_RETURN;
}
public void
test32()
{
	int		sval;
	int		pathok = 0;

	DBUG_ENTER("test32");

	sval = system("ret=1 \n ../sys_exit $ret");

	if (WIFEXITED(sval) == 0)
	{
		exit_fail(sval, 0);
	}
	else 
	{
		PATH_TRACE;
		if (WEXITSTATUS (sval) != 1)
		{
			xx_rpt(FAILURE);
			in_rpt("keyword parameter was not assigned successfully");
			in_rpt("ret=1 \\n ../sys_exit $ret   was tried");
			in_rpt("expected return value: 1, observed: %d", WEXITSTATUS(sval));
		}
		else
		{
			PATH_TRACE;
			PATH_XS_RPT(2);
		}	
	}

	DBUG_VOID_RETURN;
}

public void
test33()
{
	int		sval;
	int		failed = 0;
	int		pathok = 0;

	DBUG_ENTER("test33");

	sval = system("ret=1 \n ../sys_exit $ret");

	if (WIFEXITED(sval) == 0)
	{
		exit_fail(sval, 0);
		failed++;
	}
	else 
	{
		PATH_TRACE;
		if (WEXITSTATUS (sval) != 1)
		{
			xx_rpt(FAILURE);
			in_rpt("parameter $ret was not assigned successfully");
			in_rpt("ret=1 \\n ../sys_exit $ret   was tried");
			in_rpt("expected return value: 1, observed: %d", WEXITSTATUS(sval));
			failed++;
		}
		else
			PATH_TRACE;
	}

	sval = system("../sys_exit $ret");

	if (WIFEXITED(sval) == 0)
	{
		exit_fail(sval, failed);
		failed++;
	}
	else 
	{
		PATH_TRACE;
		if (WEXITSTATUS (sval) != 0)
		{
			if (! failed)
				xx_rpt(FAILURE);
			in_rpt("the non existant parameter $ret, was not replaced by NULL");
			in_rpt("../sys_exit $ret   was tried");
			in_rpt("expected return value: 0, observed: %d", WEXITSTATUS(sval));
			failed++;
		}
		else
			PATH_TRACE;
	}
	if (! failed)
		PATH_XS_RPT(4);

	DBUG_VOID_RETURN;
}

public void
test34()
{
	int		sval;
	int		pathok = 0;

	DBUG_ENTER("test34");

	sval = system("ret=1 \n ../sys_exit ${ret}2");

	if (WIFEXITED(sval) == 0)
	{
		exit_fail(sval, 0);
	}
	else 
	{
		PATH_TRACE;
		if (WEXITSTATUS (sval) != 12)
		{
			xx_rpt(FAILURE);
			in_rpt("${name} substitution did not function correctly");
			in_rpt("ret=1 \\n ../sys_exit ${ret}2   was tried");
			in_rpt("expected return value: 12, observed: %d", WEXITSTATUS(sval));
		}
		else
		{
			PATH_TRACE;
			PATH_XS_RPT(2);
		}
	}

	DBUG_VOID_RETURN;
}

void public
test35()
{
	int		sval;
	int		pathok = 0;

	DBUG_ENTER("test35");

	sval = system("../sys_exit 4 ; ../sys_exit $?3");

	if (WIFEXITED(sval) == 0)
	{
		exit_fail(sval, 0);
	}
	else 
	{
		PATH_TRACE;
		if (WEXITSTATUS (sval) != 43)
		{
			xx_rpt(FAILURE);
			in_rpt("$? substitution did not function correctly");
			in_rpt("../sys_exit 4 ; ../sys_exit $?3   was tried");
			in_rpt("expected return value: 43, observed: %d", WEXITSTATUS(sval));
		}
		else
		{
			PATH_TRACE;
			PATH_XS_RPT(2);
		}
	}

	DBUG_VOID_RETURN;
}

public void
test36()
{
	struct stat	statbuf;
	int		pathok = 0;

	DBUG_ENTER("test36");

	(void) system("../sys_cmd36 $$");

	errno = NOERROR;
	if (stat(t36_file, &statbuf) != SYSERROR)
	{
		xx_rpt(FAILURE);
		in_rpt("$$ was not correctly replaced by the process ID");
		(void) unlink(t36_file);
	}
	else
	{
		PATH_TRACE;
		xs_rpt();
	}

	DBUG_VOID_RETURN;
}

public void
test37()
{
	struct stat	statbuf;
	int		pathok = 0;

	DBUG_ENTER("test37");

	(void) system("../sys_cmd37 & ../sys_cmd36 $!");

	errno = NOERROR;
	if (stat(t36_file, &statbuf) != SYSERROR)
	{
		xx_rpt(FAILURE);
		in_rpt("$! was not correctly replaced by the process ID of the last background command");
		(void) unlink(t36_file);
	}
	else
	{
		PATH_TRACE;
		xs_rpt();
	}

	DBUG_VOID_RETURN;
}

public void
test38()
{
	int		failed = 0;
	int		i;
	int		nargs = 4;
	char		obs_arg[4][M_ARGLEN];
	static char	*exp_arg[] = {
		"../sys_cmd31",
		"",
		"",
		"arg3"
	};
	FILE		*fp;
	int		pathok = 0;

	DBUG_ENTER("test38");

	(void) system("../sys_cmd31 ''\t\"\" arg3 $arg4");

	if ((fp = fopen(t31_file, "r")) == NULL)
	{
		xx_rpt(DELETION);
		in_rpt("fopen(%s, r) failed", t31_file);
		(void) unlink(t31_file);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	for (i =0; i < nargs; i++)
		if (fgets(obs_arg[i], M_ARGLEN, fp) == NULL)
		{
			xx_rpt(FAILURE);
			in_rpt("../sys_cmd31 ''\\t\"\" arg3 $arg4   was tried");
			in_rpt("incorrect argument count");
			in_rpt("expected arg count: %d, observed: %d", nargs,i);
			failed++;
			break;
		}
		else
		{
			PATH_TRACE;
			/* get rid of the NL */
			obs_arg[i][(strlen(obs_arg[i]) - 1)] = '\0';
		}

	for (i = 0; i < nargs; i++)
		if (strcmp(exp_arg[i], obs_arg[i]))
		{
			if (! failed)
			{
				xx_rpt(FAILURE);
				in_rpt("../sys_cmd31 ''\\t\"\" arg3 $arg4   was tried");
			}
			in_rpt("incorrect argument: %d", i);
			in_rpt("expected: %s, observed: %s", exp_arg[i],obs_arg[i]);
			failed++;
		}
		else
			PATH_TRACE;
	if (! failed)
		PATH_XS_RPT(1+nargs+nargs);
	(void) fclose(fp);
	(void) unlink(t31_file);

	DBUG_VOID_RETURN;
}

public void
test39()
{
	int		failed1 = 0;
	int		failed2 = 0;
	int		failed3 = 0;
	int		i;
	int		fd;
	int		nargs = 4;
	char		obs_arg[4][M_ARGLEN];
	static char	*exp_arg[] = {
		"../sys_cmd31",
		"./system-t.39a",
		"./system-t.39b",
		"./system-t.39c"
	};
	FILE		*fp;
	int		pathok = 0;

	DBUG_ENTER("test39");

	errno = NOERROR;
	if ((fd = creat(t39a_file, MODEANY)) == SYSERROR)
	{
		xx_rpt(DELETION);
		in_rpt("creat(%s, MODEANY) failed - errno %d(%s)",
			t39a_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;
	(void) close(fd);

	errno = NOERROR;
	if ((fd = creat(t39b_file, MODEANY)) == SYSERROR)
	{
		xx_rpt(DELETION);
		in_rpt("creat(%s, MODEANY) failed - errno %d(%s)",
			t39b_file, errno, errname(errno));
		(void) unlink(t39a_file);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;
	(void) close(fd);

	errno = NOERROR;
	if ((fd = creat(t39c_file, MODEANY)) == SYSERROR)
	{
		xx_rpt(DELETION);
		in_rpt("creat(%s, MODEANY) failed - errno %d(%s)",
			t39c_file, errno, errname(errno));
		(void) unlink(t39a_file);
		(void) unlink(t39b_file);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	(void) system("../sys_cmd31 ./*39* ");

	if ((fp = fopen(t31_file, "r")) == NULL)
	{
		xx_rpt(DELETION);
		in_rpt("fopen(%s, r) failed", t31_file);
		(void) unlink(t31_file);
		(void) unlink(t39a_file);
		(void) unlink(t39b_file);
		(void) unlink(t39c_file);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	for (i =0; i < nargs; i++)
		if (fgets(obs_arg[i], M_ARGLEN, fp) == NULL)
		{
			xx_rpt(FAILURE);
			in_rpt("../sys_cmd31 ./*39*   was tried");
			in_rpt("incorrect argument count");
			in_rpt("expected arg count: %d, observed: %d", nargs,i);
			failed1++;
			break;
		}
		else
		{
			PATH_TRACE;
			/* get rid of the NL */
			obs_arg[i][(strlen(obs_arg[i]) - 1)] = '\0';
		}

	for (i = 0; i < nargs; i++)
		if (strcmp(exp_arg[i], obs_arg[i]))
		{
			if (! failed1)
			{
				xx_rpt(FAILURE);
				in_rpt("../sys_cmd31 ./*39*   was tried");
			}
			in_rpt("incorrect argument: %d", i);
			in_rpt("expected: %s, observed: %s", exp_arg[i],obs_arg[i]);
			failed1++;
		}
		else
			PATH_TRACE;

	(void) system("../sys_cmd31 ./syste?-t.39? ");

	if ((fp = fopen(t31_file, "r")) == NULL)
	{
		if (! failed1)
			xx_rpt(DELETION);
		in_rpt("fopen(%s, r) failed", t31_file);
		(void) unlink(t31_file);
		(void) unlink(t39a_file);
		(void) unlink(t39b_file);
		(void) unlink(t39c_file);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	for (i =0; i < nargs; i++)
		if (fgets(obs_arg[i], M_ARGLEN, fp) == NULL)
		{
			if (! (failed1 || failed2))
				xx_rpt(FAILURE);
			in_rpt("../sys_cmd31 ./syste?-t.39?  was tried");
			in_rpt("incorrect argument count");
			in_rpt("expected arg count: %d, observed: %d", nargs,i);
			failed2++;
			break;
		}
		else
		{
			PATH_TRACE;
			/* get rid of the NL */
			obs_arg[i][(strlen(obs_arg[i]) - 1)] = '\0';
		}

	for (i = 0; i < nargs; i++)
		if (strcmp(exp_arg[i], obs_arg[i]))
		{
			if (! (failed1 || failed2))
				xx_rpt(FAILURE);
			if (! failed2)
				in_rpt("../sys_cmd31 ./syste?-t.39?  was tried");
			in_rpt("incorrect argument: %d", i);
			in_rpt("expected: %s, observed: %s", exp_arg[i],obs_arg[i]);
			failed2++;
		}
		else
			PATH_TRACE;

	(void) system("../sys_cmd31 ./sy[ts][r-u]em-[!a-d].39[!def] ");

	if ((fp = fopen(t31_file, "r")) == NULL)
	{
		if (! (failed1 || failed2))
			xx_rpt(DELETION);
		in_rpt("fopen(%s, r) failed", t31_file);
		(void) unlink(t31_file);
		(void) unlink(t39a_file);
		(void) unlink(t39b_file);
		(void) unlink(t39c_file);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	for (i = 0; i < nargs; i++)
		if (fgets(obs_arg[i], M_ARGLEN, fp) == NULL)
		{
			if (! (failed1 || failed2))
				xx_rpt(FAILURE);
			in_rpt("../sys_cmd31 ./sy[ts][r-u]em-[!a-d].39[!def]  was tried");
			in_rpt("incorrect argument count");
			in_rpt("expected arg count: %d, observed: %d", nargs,i);
			failed3++;
			break;
		}
		else
		{
			PATH_TRACE;
			/* get rid of the NL */
			obs_arg[i][(strlen(obs_arg[i]) - 1)] = '\0';
		}

	for (i = 0; i < nargs; i++)
		if (strcmp(exp_arg[i], obs_arg[i]))
		{
			if (! (failed1 || failed2 || failed3))
				xx_rpt(FAILURE);
			if (! failed3)
				in_rpt("../sys_cmd31 ./sy[ts][r-u]em-[!a-d].39[!def]  was tried");
			in_rpt("incorrect argument: %d", i);
			in_rpt("expected: %s, observed: %s", exp_arg[i],obs_arg[i]);
			failed3++;
		}
		else
			PATH_TRACE;

	if (! (failed1 || failed2 || failed3))
		PATH_XS_RPT(6+6*nargs);

	(void) unlink(t31_file);
	(void) unlink(t39a_file);
	(void) unlink(t39b_file);
	(void) unlink(t39c_file);
	DBUG_VOID_RETURN;
}

public void
test40()
{
	int		failed = 0;
	int		i;
	int		nargs = 2;
	char		obs_arg[2][M_ARGLEN];
	static char	*exp_arg[] = {
		"../sys_cmd31",
		"./*?[b]x"
	};
	FILE		*fp;
	int		pathok = 0;

	DBUG_ENTER("test40");

	(void) system("../sys_cmd31 ./*?[b]x");

	if ((fp = fopen(t31_file, "r")) == NULL)
	{
		xx_rpt(DELETION);
		in_rpt("fopen(%s, r) failed", t31_file);
		(void) unlink(t31_file);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	for (i =0; i < nargs; i++)
		if (fgets(obs_arg[i], M_ARGLEN, fp) == NULL)
		{
			xx_rpt(FAILURE);
			in_rpt("../sys_cmd31 ./*?[b]x   was tried");
			in_rpt("incorrect argument count");
			in_rpt("expected arg count: %d, observed: %d", nargs,i);
			failed++;
			break;
		}
		else
		{
			PATH_TRACE;
			/* get rid of the NL */
			obs_arg[i][(strlen(obs_arg[i]) - 1)] = '\0';
		}

	for (i = 0; i < nargs; i++)
		if (strcmp(exp_arg[i], obs_arg[i]))
		{
			if (! failed)
			{
				xx_rpt(FAILURE);
				in_rpt("../sys_cmd31 ./*?[b]x   was tried");
			}
			in_rpt("incorrect argument: %d", i);
			in_rpt("expected: %s, observed: %s", exp_arg[i],obs_arg[i]);
			failed++;
		}
		else
			PATH_TRACE;

	if (! failed)
		PATH_XS_RPT(1+2*nargs);

	(void) fclose(fp);
	(void) unlink(t31_file);

	DBUG_VOID_RETURN;
}

public void
test41()
{
	int		failed = 0;
	int		i;
	int		fd;
	int		nargs = 2;
	char		obs_arg[2][M_ARGLEN];
	static char	*exp_arg1[] = {
		"../sys_cmd31",
		"./*41"
	};
	static char	*exp_arg2[] = {
		"../sys_cmd31",
		"./.system-t.41"
	};
	FILE		*fp;
	int		pathok = 0;

	DBUG_ENTER("test41");

	errno = NOERROR;
	if ((fd = creat(t41_file, MODEANY)) == SYSERROR)
	{
		xx_rpt(DELETION);
		in_rpt("creat(%s, MODEANY) failed - errno %d(%s)",
			t41_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;
	(void) close(fd);

	(void) system("../sys_cmd31 ./*41");

	if ((fp = fopen(t31_file, "r")) == NULL)
	{
		xx_rpt(DELETION);
		in_rpt("fopen(%s, r) failed", t31_file);
		(void) unlink(t31_file);
		(void) unlink(t41_file);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	for (i =0; i < nargs; i++)
		if (fgets(obs_arg[i], M_ARGLEN, fp) == NULL)
		{
			xx_rpt(FAILURE);
			in_rpt("../sys_cmd31 ./*41   was tried");
			in_rpt("incorrect argument count");
			in_rpt("expected arg count: %d, observed: %d", nargs,i);
			failed++;
			break;
		}
		else
		{
			PATH_TRACE;
			/* get rid of the NL */
			obs_arg[i][(strlen(obs_arg[i]) - 1)] = '\0';
		}

	for (i = 0; i < nargs; i++)
		if (strcmp(exp_arg1[i], obs_arg[i]))
		{
			if (! failed)
			{
				xx_rpt(FAILURE);
				in_rpt("../sys_cmd31 ./*41   was tried");
			}
			in_rpt("incorrect argument: %d", i);
			in_rpt("expected: %s, observed: %s", exp_arg1[i],obs_arg[i]);
			failed++;
		}
		else
			PATH_TRACE;

	(void) fclose(fp);

	(void) system("../sys_cmd31 ./.*41");

	if ((fp = fopen(t31_file, "r")) == NULL)
	{
		xx_rpt(DELETION);
		in_rpt("fopen(%s, r) failed", t31_file);
		(void) unlink(t31_file);
		(void) unlink(t41_file);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	for (i =0; i < nargs; i++)
		if (fgets(obs_arg[i], M_ARGLEN, fp) == NULL)
		{
			if (! failed)
				xx_rpt(FAILURE);
			in_rpt("../sys_cmd31 ./.*41   was tried");
			in_rpt("incorrect argument count");
			in_rpt("expected arg count: %d, observed: %d", nargs,i);
			failed++;
			break;
		}
		else
		{		
			PATH_TRACE;
			/* get rid of the NL */
			obs_arg[i][(strlen(obs_arg[i]) - 1)] = '\0';
		}

	for (i = 0 ; i < nargs; i++)
		if (strcmp(exp_arg2[i], obs_arg[i]))
		{
			if (! failed)
			{
				xx_rpt(FAILURE);
				in_rpt("../sys_cmd31 ./.*41   was tried");
			}
			in_rpt("incorrect argument: %d", i);
			in_rpt("expected: %s, observed: %s", exp_arg2[i],obs_arg[i]);
			failed++;
		}
		else
			PATH_TRACE;

	if (! failed)
		PATH_XS_RPT(3+4*nargs);

	(void) fclose(fp);
	(void) unlink(t31_file);
	(void) unlink(t41_file);
	DBUG_VOID_RETURN;
}

public void
test42()
{
	int		failed = 0;
	int		i;
	int		nargs = 2;
	char		obs_arg[2][M_ARGLEN];
	static char	*exp_arg[] = {
		"../sys_cmd31",
		";&()|^<> \t"
	};
	FILE		*fp;
	int		pathok = 0;

	DBUG_ENTER("test42");

	(void) system("../sys_cmd31 \\;\\&\\(\\)\\|\\^\\<\\>\\ \\\t");

	if ((fp = fopen(t31_file, "r")) == NULL)
	{
		xx_rpt(DELETION);
		in_rpt("fopen(%s, r) failed", t31_file);
		(void) unlink(t31_file);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	for (i =0; i < nargs; i++)
		if (fgets(obs_arg[i], M_ARGLEN, fp) == NULL)
		{
			xx_rpt(FAILURE);
			in_rpt("incorrect argument count");
			in_rpt("expected arg count: %d, observed: %d", nargs,i);
			failed++;
			break;
		}
		else
		{
			PATH_TRACE;
			/* get rid of the NL */
			obs_arg[i][(strlen(obs_arg[i]) - 1)] = '\0';
		}

	for (i = 0; i < nargs; i++)
		if (strcmp(exp_arg[i], obs_arg[i]))
		{
			if (! failed)
				xx_rpt(FAILURE);
			in_rpt("incorrect argument: %d", i);
			in_rpt("expected: %s, observed: %s", exp_arg[i],obs_arg[i]);
			failed++;
		}
		else
			PATH_TRACE;

	if (! failed)
		PATH_XS_RPT(1+2*nargs);

	(void) fclose(fp);
	(void) unlink(t31_file);

	DBUG_VOID_RETURN;
}

public void
test43()
{
	int		failed = 0;
	int		i;
	int		nargs = 2;
	char		obs_arg[2][M_ARGLEN];
	static char	*exp_arg[] = {
		"../sys_cmd31",
		";&()|^<> \\tabc123"
	};
	FILE		*fp;
	int		pathok = 0;

	DBUG_ENTER("test43");

	(void) system("../sys_cmd31 ';&()|^<> \\tabc123'");

	if ((fp = fopen(t31_file, "r")) == NULL)
	{
		xx_rpt(DELETION);
		in_rpt("fopen(%s, r) failed", t31_file);
		(void) unlink(t31_file);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	for (i =0; i < nargs; i++)
		if (fgets(obs_arg[i], M_ARGLEN, fp) == NULL)
		{
			xx_rpt(FAILURE);
			in_rpt("../sys_cmd31 ';&()|^<> \\tabc123' was tried");
			in_rpt("incorrect argument count");
			in_rpt("expected arg count: %d, observed: %d", nargs,i);
			failed++;
			break;
		}
		else
		{
			PATH_TRACE;
			/* get rid of the NL */
			obs_arg[i][(strlen(obs_arg[i]) - 1)] = '\0';
		}

	for (i = 0; i < nargs; i++)
		if (strcmp(exp_arg[i], obs_arg[i]))
		{
			if (! failed)
			{
				xx_rpt(FAILURE);
				in_rpt("../sys_cmd31 ';&()|^<> \\tabc123' was tried");
			}
			in_rpt("incorrect argument: %d", i);
			in_rpt("expected: %s, observed: %s", exp_arg[i],obs_arg[i]);
			failed++;
		}
		else
			PATH_TRACE;

	if (! failed)
		PATH_XS_RPT(1+2*nargs);

	(void) fclose(fp);
	(void) unlink(t31_file);

	DBUG_VOID_RETURN;
}

public void
test44()
{
	int		failed = 0;
	int		i;
	int		nargs = 2;
	char		obs_arg[2][M_ARGLEN];
	static char	*exp_arg[] = {
		"../sys_cmd31",
		"abc1def\\gh`\"$ijk"
	};
	FILE		*fp;
	int		pathok = 0;

	DBUG_ENTER("test44");

	(void) system("par=1 \n ../sys_cmd31 \"abc${par}def\\gh\\`\\\"\\$ijk\"");

	if ((fp = fopen(t31_file, "r")) == NULL)
	{
		xx_rpt(DELETION);
		in_rpt("fopen(%s, r) failed", t31_file);
		(void) unlink(t31_file);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	for (i =0; i < nargs; i++)
		if (fgets(obs_arg[i], M_ARGLEN, fp) == NULL)
		{
			xx_rpt(FAILURE);
			in_rpt("../sys_cmd31 \"abc1def\\gh`\"$ijk\"   was tried");
			in_rpt("incorrect argument count");
			in_rpt("expected arg count: %d, observed: %d", nargs,i);
			failed++;
			break;
		}
		else
		{
			PATH_TRACE;
			/* get rid of the NL */
			obs_arg[i][(strlen(obs_arg[i]) - 1)] = '\0';
		}

	for (i = 0; i < nargs; i++)
		if (strcmp(exp_arg[i], obs_arg[i]))
		{
			if (! failed)
			{
				xx_rpt(FAILURE);
				in_rpt("../sys_cmd31 \"abc1def\\gh`\"$ijk\"   was tried");
			}
			in_rpt("incorrect argument: %d", i);
			in_rpt("expected: %s, observed: %s", exp_arg[i],obs_arg[i]);
			failed++;
		}
		else
			PATH_TRACE;

	if (! failed)
		PATH_XS_RPT(1+2*nargs);

	(void) fclose(fp);
	(void) unlink(t31_file);

	DBUG_VOID_RETURN;
}

public void
test45()
{

	DBUG_ENTER("test45");

	(void) cppair(ch_t45, NULLFN, WAITTIME, 0);
	
	DBUG_VOID_RETURN;
}

private void
ch_t45()
{
	int	rval;
	int	pathok = 0;

	DBUG_ENTER("ch_t45");

	if (vputenv(&environ,"TEST_ENV=testingenv") == -1)
		DBUG_EXIT(A_MISC);
	else
		PATH_TRACE;

	rval = system("../sys_cmd45");
		
	if (WIFEXITED(rval) == 0)
	{
		exit_fail(rval, 0);
	}
	else 
	{
		PATH_TRACE;
		if (WEXITSTATUS (rval) != OK0)
		{
			xx_rpt(FAILURE);
			in_rpt("The environment was not passed correctly");
			in_rpt("expected TEST_ENV to be set to 'testingenv'");
		}
		else
		{
			PATH_TRACE;
			PATH_XS_RPT(3);
		}
	}

	DBUG_VOID_RETURN;
}

public void
test46()
{

	DBUG_ENTER("test46");

	(void) cppair(ch_t46, NULLFN, WAITTIME, 0);
	
	DBUG_VOID_RETURN;
}

private void
ch_t46()
{
	int	i;
	int	nsigs;
	struct	stat	statbuf;
	int	pathok = 0;

	DBUG_ENTER("ch_t46");

	if (sysconf(_SC_JOB_CONTROL) == -1)
		nsigs = VNOJSIG;
	else
		nsigs = VNUMSIG;

	for (i = 1 ; i < nsigs ; i++)
	{
		if (i==1)
			PATH_TRACE;
		if (i != VSIGINT && i != VSIGTERM && i != VSIGQUIT
			&& i != VSIGCHLD && i != VSIGKILL && i != VSIGSTOP
			&& i != VSIGCONT)
			(void) vsignal(sig_array[i], SIG_IGN);
	}
	(void) vsignal(SIGINT, SIG_DFL);
	(void) vsignal(SIGQUIT, SIG_DFL);
	(void) vsignal(SIGTERM, SIG_DFL);

	(void) system("../sys_cmd46");
	
	errno = NOERROR;
	if (stat(t46_file, &statbuf) != SYSERROR)
	{
		xx_rpt(FAILURE);
		in_rpt("a non background process was tried ...");
		in_rpt("all signals did not have the inherited value");
		(void) unlink(t46_file);
	}
	else
	{
		PATH_TRACE;
		PATH_XS_RPT(2);
	}

	DBUG_VOID_RETURN;
}


public void
test47()
{
	struct	stat	statbuf;
	int		pathok = 0;

	DBUG_ENTER("test47");

	(void) cppair(ch_t47, NULLFN, WAITTIME, 0);

	errno = NOERROR;
	if (stat(t47_file, &statbuf) != SYSERROR)
	{
		xx_rpt(FAILURE);
		in_rpt("a background process was tried ...");
		in_rpt("signals SIGINT and SIGQUIT were set to SIG_DFL");
		in_rpt("these two signals were not both ignored as expected");
		(void) unlink(t47_file);
	}
	else
	{
		PATH_TRACE;
		PATH_XS_RPT(1);
	}

	DBUG_VOID_RETURN;
}

private void
ch_t47()
{

	DBUG_ENTER("ch_t47");

	(void) vsignal(SIGQUIT, SIG_DFL);
	(void) vsignal(SIGTERM, SIG_DFL);

	(void) system("../sys_cmd47 &");

	DBUG_VOID_RETURN;
}

public void
test48()
{
#if TEST_XPG > 3
	int		pathok = 0;
#endif

	DBUG_ENTER("test48");

#if TEST_XPG > 3
	if (system((char *)NULL) == 0)
	{
		xx_rpt(FAILURE);
		in_rpt("system(NULL) returned 0, expected non-zero");
	}
	else
	{
		PATH_TRACE;
		PATH_XS_RPT(1);
	}
#else
	xx_rpt(NOTINUSE);
#endif

	DBUG_VOID_RETURN;
}

public void
test49()
{
#if (TEST_XPG > 3)
	int ret, err;
	int testfail = 0;
	long posix2_vers;
	int sysconf_err;
	int pathok = 0;
#endif

	DBUG_ENTER("test_49");

#if (TEST_XPG > 3)

	errno = 0;
	posix2_vers = sysconf(_SC_2_VERSION);
	sysconf_err = errno;

	for(t49_i = 0; cmds[t49_i].cmd != NULL; t49_i++)
	{
		if(t49_i == 0)
			PATH_TRACE;

		/* Check for XCU4-sh specific command */
		if (cmds[t49_i].cmd[0] == '4' &&
		    cmds[t49_i].cmd[1] == ':')
		{
			if (posix2_vers == -1 && sysconf_err == 0)
			{
				PATH_TRACE;
				PATH_TRACE;
				PATH_TRACE;
				PATH_TRACE;
				PATH_TRACE;
				PATH_TRACE;
				continue;
			}
			else if (posix2_vers == -1 && sysconf_err != 0)
			{
				if (testfail++ == 0)
					xx_rpt(DELETION);
				in_rpt("sysconf(_SC_2_VERSION) failed, errno %d(%s)",
					sysconf_err, errname(sysconf_err));
				continue;
			}
			else
				PATH_TRACE;

			/* skip over the "4:" */
			cmds[t49_i].cmd += 2;
		}
		else
			PATH_TRACE;

		if( pipe(pipdes) == SYSERROR )
		{
			err = errno;
			xx_rpt(DELETION);
			in_rpt("pipe() failed, errno %d(%s)", err, errname(err));
			DBUG_VOID_RETURN;
		}
		else
			PATH_TRACE;

		if((f_rd = fdopen(pipdes[P_RD], "r")) == (FILE *) NULL)
		{
			err = errno;
			xx_rpt(DELETION);
			in_rpt("fdopen() failed to open pipe for reading, errno %d(%s)", err, errname(err));
			DBUG_VOID_RETURN;
		}
		else
			PATH_TRACE;

		ret = cppair(ch_t49, pa_t49, WAITTIME, PATH_ERR|NOK);

		errno = 0;
		if((fret = fread((void *)buf, (size_t)1, sizeof(buf), f_rd)) < 0
		&& errno != 0)
		{
			err = errno;
			xx_rpt(DELETION);
			in_rpt("fread() failed to read data from pipe - errno %d(%s)",
				err, errname(err));
			DBUG_VOID_RETURN;
		}
		else
			PATH_TRACE;

		(void) fclose(f_rd);
		buf[fret] = '\0';

		switch(ret)
		{
			case OK:
				PATH_TRACE;
				break;
			case PATH_ERR:
				break;
			case NOK:
				testfail++;
				break;
		}

		if(strcmp(buf, cmds[t49_i].expres))
		{
			if (testfail++ == 0)
				xx_rpt(FAILURE);
			in_rpt("system(\"%s\") failed", 
				pr_nchars(cmds[t49_i].cmd,
				(int)strlen(cmds[t49_i].cmd)));
			in_rpt("expected output: \"%s\"", 
				pr_nchars(cmds[t49_i].expres,
				(int)strlen(cmds[t49_i].expres)));
			in_rpt("observed output: \"%s\"",
				pr_nchars(buf, fret));
		}
		else
			PATH_TRACE;
	}

	if(testfail == 0)
		PATH_XS_RPT(6 * t49_i + 1);

#else
	xx_rpt(NOTINUSE);
#endif

	DBUG_VOID_RETURN;
}

#if TEST_XPG > 3
private void
pa_t49()
{
	DBUG_ENTER("pa_t49");

	(void) close(pipdes[P_WR]);

	DBUG_VOID_RETURN;
}

private void
ch_t49()
{
	int	err;
	int	pathok = 0;

	DBUG_ENTER("ch_t49");

	(void) close(pipdes[P_RD]);

	if (dup2(pipdes[P_WR], 1) == -1)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("dup2(fd, 1) failed - errno %d (%s)\n",
			err, errname(err));
		DBUG_EXIT(NOK);
	}
	else
		PATH_TRACE;

	if(system(cmds[t49_i].cmd) == SYSERROR)
	{
		err = errno;
		xx_rpt(FAILURE);
		in_rpt("system(\"%s\") failed - errno %d(%s)",
			pr_nchars(cmds[t49_i].cmd,
			(int)strlen(cmds[t49_i].cmd)),
			err, errname(err));
		DBUG_EXIT(NOK);
	}
	else
		PATH_TRACE;

	if (pathok == 2)
		DBUG_EXIT(OK);

	DBUG_EXIT(PATH_ERR);
}
#endif

public void
test50()
{
	DBUG_ENTER("test50");

#if TEST_XPG > 3
	(void) cppair(ch_t50, NULLFN, WAITTIME * 2, 0);
#else
	xx_rpt(NOTINUSE);
#endif

	DBUG_VOID_RETURN;
}

#if TEST_XPG > 3

private void
ch_t50()
{
	int	pathok = 0;

	DBUG_ENTER("ch_t50");

	t50_flag = 0;
	(void) vsignal(SIGALRM, ch_t50_sig);
	(void) alarm(5);
	(void) system("../sys_cmd50");
	(void) alarm(0);

	if(t50_flag == 0)
	{
		xx_rpt(DELETION);
         	in_rpt("Failed to call signal handler ch_t50_sig()");
		DBUG_VOID_RETURN;
	}
	else if (t50_flag == -1)
	{
		DBUG_VOID_RETURN; /* reported already */
	}
	else
		PATH_TRACE;

	if(sigint.sa_handler != SIG_IGN || sigquit.sa_handler != SIG_IGN)
	{
		xx_rpt(FAILURE);
		if(sigint.sa_handler != SIG_IGN)
			in_rpt("system() did not ignore SIGINT");

		if(sigquit.sa_handler != SIG_IGN)
			in_rpt("system() did not ignore SIGQUIT");
	}
	else
		PATH_XS_RPT(1);

	DBUG_VOID_RETURN;
}

private void
ch_t50_sig()
{
	int	err;

	DBUG_ENTER("ch_t50_sig");

	if(sigaction(SIGINT, NULLSA, &sigint) != 0)
	{
		err = errno;
		xx_rpt(DELETION);
 	      	in_rpt("sigaction() failed - errno %d(%s)",err,errname(err));
		t50_flag = -1;
		DBUG_VOID_RETURN;
	}

	if(sigaction(SIGQUIT, NULLSA, &sigquit) != 0)
	{
		err = errno;
		xx_rpt(DELETION);
 	      	in_rpt("sigaction() failed - errno %d(%s)",err,errname(err));
		t50_flag = -1;
		DBUG_VOID_RETURN;
	}

	t50_flag = 1;

	DBUG_VOID_RETURN;
}
#endif

public void
test51()
{
	DBUG_ENTER("test51");

#if TEST_XPG > 3
	(void) cppair(ch_t51, NULLFN, WAITTIME * 2, 0);
#else
	xx_rpt(NOTINUSE);
#endif

	DBUG_VOID_RETURN;
}

#if TEST_XPG > 3
private void
ch_t51()
{
	int	pathok = 0;

	DBUG_ENTER("ch_t51");

	t51_flag = 0;
	(void) vsignal(SIGALRM, ch_t51_sig);
	(void) alarm(5);
	(void) system("../sys_cmd50");
	(void) alarm(0);

	if(t51_flag == 0)
	{
		xx_rpt(DELETION);
         	in_rpt("Failed to call signal handler ch_t51_sig()");
		DBUG_VOID_RETURN;
	}
	else if (t51_flag == -1)
	{
		DBUG_VOID_RETURN; /* reported already */
	}
	else
		PATH_TRACE;

	if(!sigismember(&t51_set, SIGCHLD))
	{
		xx_rpt(FAILURE);
         	in_rpt("system() did not block SIGCHLD");
	}
	else
		PATH_XS_RPT(1);

	DBUG_VOID_RETURN;
}

private void
ch_t51_sig()
{
	int	err;

	DBUG_ENTER("ch_t51_sig");

	if(sigprocmask(SIG_SETMASK, (sigset_t *)NULL, &t51_set) != 0)
	{
		err = errno;
		xx_rpt(DELETION);
 	      	in_rpt("sigprocmask() failed - errno %d(%s)",err,errname(err));
		t51_flag = -1;
	}
	else
		t51_flag = 1;

	DBUG_VOID_RETURN;
}
#endif

public void
test52()
{
#if TEST_XPG > 3
	int	pathok = 0;
#endif

	DBUG_ENTER("test52");

#if TEST_XPG > 3

	tfail = 0;

	globok = 0;
	(void) cpsig(ch_t52, pa1_t52, -1, 0);
	PATH_FUNC_TRACE;

	if(tfail)
	{
		xx_rpt(FAILURE);
 	      	in_rpt(
	"Termination status of child processes affected by call to system()");
	}
	else
		PATH_XS_RPT(1);

#else
	xx_rpt(NOTINUSE);
#endif
	DBUG_VOID_RETURN;
}

#if TEST_XPG > 3
private void
pa1_t52()
{
	int	status;
	int	pathok = 0;

	DBUG_ENTER("pa1_t52");

	globok = 0;
	(void) cpsig(ch_t52, pa2_t52, -1, 0);
	PATH_FUNC_TRACE;

	if(waitpid(tet_child, &status, WNOHANG) == -1)
		tfail++;
	else
		PATH_TRACE;

	PATH_FUNC_RPT(2);

	DBUG_VOID_RETURN;
}

private void
ch_t52()
{
	DBUG_ENTER("ch_t52");

	DBUG_VOID_RETURN;
}

private void
pa2_t52()
{
	int	status;
	int	pathok = 0;

	DBUG_ENTER("pa2_t52");

	(void) sleep(5);
	(void) system("../sys_cmd50");
	if(waitpid(tet_child, &status, WNOHANG) == -1)
		tfail++;
	else
		PATH_TRACE;

	PATH_FUNC_RPT(1);

	DBUG_VOID_RETURN;
}
#endif

public void
test53()
{
	DBUG_ENTER("test53");

#if TEST_XPG > 3
	(void) cppair(ch_t53, NULLFN, WAITTIME * 2, 0);
#else
	xx_rpt(NOTINUSE);
#endif
	DBUG_VOID_RETURN;
}

#if TEST_XPG > 3
private void
ch_t53()
{
	time_t	stime, etime;
	int	sval, err;
	int	pathok = 0;

	DBUG_ENTER("ch_t53");

	stime = time((time_t *)NULL);

	if (system("../sys_cmd50") != 0)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("system(\"../sys_cmd50\") failed - errno %d (%s)",
			err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	etime = time((time_t *)NULL);

	if((etime - stime) < (time_t)T_DELAY_1)
	{
		xx_rpt(FAILURE);
 	      	in_rpt("system() returned before child process terminated");
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;


	SET_TIMEOUT(WAITTIME/2)

	stime = time((time_t *)NULL);
	errno = 0;
	sval = system("../sys_cmd37");
	err = errno;

	CLEAR_ALARM

	etime = time((time_t *)NULL);

	if((etime - stime) < (time_t)WAITTIME)
	{
		xx_rpt(FAILURE);
 	      	in_rpt("system() when interrupted returned before child process terminated");
		if (sval == -1)
			in_rpt("errno was set to %d (%s)", err, errname(err));

		SET_TIMEOUT(WAITTIME)
		(void) wait((int *)0);
		CLEAR_ALARM
	}
	else
		PATH_XS_RPT(2);

	DBUG_VOID_RETURN;
}
#endif

public void
test54()
{
	int		sval;
	int		pathok = 0;

	DBUG_ENTER("test54");

	sval = system("./no_cmd 2>/dev/null");

	if (WIFEXITED(sval) == 0)
	{
		exit_fail(sval, 0);
	}
	else 
	{
		PATH_TRACE;
		if (WEXITSTATUS (sval) == 0)
		{
			xx_rpt(FAILURE);
			in_rpt("system returned 0 where a non zero exit status was expected");
		}
		else
		{
			PATH_TRACE;
			PATH_XS_RPT(2);
		}
	}

	DBUG_VOID_RETURN;
}

public void
test55()
{
#if TEST_XPG == 3
	int	sval, err;
	int	pathok = 0;
#endif
	
	DBUG_ENTER("test55");

#if TEST_XPG == 3

	SET_TIMEOUT(WAITTIME/2)

	errno = 0;
	sval = system("../sys_cmd37");
	err = errno;

	CLEAR_ALARM

	if (sval >= 0 || err != EINTR)
	{
		xx_rpt(FAILURE);
		in_rpt("system() did not behave correctly when interrupted");
		in_rpt("Expected: return value < 0, errno = EINTR");
		in_rpt("Observed: return value %d, errno = %d(%s)",
			sval, err, errname(err));
	}
	else
	{
		PATH_TRACE;
		PATH_XS_RPT(1);
	}

#else
	xx_rpt(NOTINUSE);
#endif

	DBUG_VOID_RETURN;
}

public void
test56()
{
	DBUG_ENTER("test56");

#if TEST_XPG > 3

	if(pipe_open() != 0)
	{
		(void) cppair(ch_t56, NULLFN, WAITTIME * 2, 0);
		pipe_parent();
	}
	pipe_close();

#else
	xx_rpt(NOTINUSE);
#endif
	DBUG_VOID_RETURN;
}

#if TEST_XPG > 3
private void
ch_t56()
{
	char	msg[512];
	char	*args[4];
	int	err;

	DBUG_ENTER("ch_t56");

	pipe_child();

	/* can't use execle: null vg_dbug stops environ being passed */
	args[0] = prog56;
	args[1] = vg_ident;
	args[2] = vg_dbug;
	args[3] = NULL;
	(void) tet_exec(prog56, args, environ);

	/* If here then tet_exec() failed */
	err = errno;
	pipe_xx_rpt(DELETION);
	(void) sprintf(msg, "tet_exec(%s, ...) failed - errno %d (%s)", prog56, err, errname(err));
	pipe_in_rpt(msg);

	DBUG_VOID_RETURN;
}
#endif

public void
test57()
{
	DBUG_ENTER("test57");

#if TEST_XPG > 3

	if(pipe_open() != 0)
	{
		(void) cppair(ch_t57, NULLFN, WAITTIME * 2, 0);
		pipe_parent();
	}
	pipe_close();

#else
	xx_rpt(NOTINUSE);
#endif
	DBUG_VOID_RETURN;
}

#if TEST_XPG > 3
private void
ch_t57()
{
	char	msg[512];
	char	*args[4];
	int	err;

	DBUG_ENTER("ch_t57");

	pipe_child();

	/* can't use execle: null vg_dbug stops environ being passed */
	args[0] = prog57;
	args[1] = vg_ident;
	args[2] = vg_dbug;
	args[3] = NULL;
	(void) tet_exec(prog57, args, environ);

	/* If here then tet_exec() failed */
	err = errno;
	pipe_xx_rpt(DELETION);
	(void) sprintf(msg, "tet_exec(%s, ...) failed - errno %d (%s)", prog57, err, errname(err));
	pipe_in_rpt(msg);

	DBUG_VOID_RETURN;
}
#endif

public void
test58()
{
	DBUG_ENTER("test58");

#if (TEST_XPG > 3)
	(void) cppair(ch_t58, NULLFN, WAITTIME * 2, 0);
#else
	xx_rpt(NOTINUSE);
#endif

	DBUG_VOID_RETURN;
}

#if TEST_XPG > 3
private void
ch_t58()
{
	int	i, ret, rval, child_max, err;
	int 	pathok = 0;

	DBUG_ENTER("ch_t58");

	/*
	 * Find max no sub processes
	 */
	errno = NOERROR;
	if((child_max = sysconf(_SC_CHILD_MAX)) == -1 && errno == 0)
	{
		xx_rpt(UNTESTED);
		in_rpt("sysconf(_SC_CHILD_MAX) returned -1 and errno 0");
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	if(child_max > PCTS_CHILD_MAX)
	{
		xx_rpt(UNTESTED);
		in_rpt("sysconf(_SC_CHILD_MAX) returned > PCTS_CHILD_MAX");
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	/*
	 * Use up all processes
	 */
	for(i = 0; i < child_max; i++)
	{
		if(i == 0)
			PATH_TRACE;

		if((ret = fork()) == 0)
			exit(0);
		else if(ret == -1)
			break;
	}
	
	errno = NOERROR;
	rval = system("../sys_cmd50");
	err = errno;

	if(rval != -1 || err != EAGAIN)
	{
		xx_rpt(FAILURE);
	    	in_rpt("Call to system() when a child process cannot be created");
		if(rval != -1)
		{
			in_rpt("Expected return value -1");
			in_rpt("Actual   return value %d", rval);
		}

		if(err != EAGAIN)
		{
			in_rpt("Expected errno %d (EAGAIN)", EAGAIN);
			in_rpt("Actual   errno %d (%s)", err, errname(err));
		}
	}
	else
		PATH_XS_RPT(3);

	DBUG_VOID_RETURN;
}
#endif

public void
test59()
{
#if TEST_XPG > 3
	int	rval, err;
	int	pathok = 0;
#endif

	DBUG_ENTER("test59");

#if TEST_XPG > 3

	t59_errno = 0;
	t59_rval = (pid_t)0;

	(void) vsignal(SIGALRM, t59_sig);
	(void) alarm(5);
	errno = NOERROR;
	rval = system("../sys_cmd50");
	err = errno;
	(void) alarm(0);

	/*
	 * Check success of signal catchers wait()
	 */
	if(t59_rval == -1)
	{
		xx_rpt(DELETION);
 	      	in_rpt("wait() failed - errno %d (%s)",
			t59_errno, errname(t59_errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	if(t59_rval == 0)
	{
		xx_rpt(DELETION);
 	      	in_rpt("wait() not called");
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	if(rval != -1 || err != ECHILD)
	{
		xx_rpt(FAILURE);
        	in_rpt(
	       "Call to system() when a termination status cannot be obtained");

		if(rval != -1)
		{
			in_rpt("Expected return value -1");
			in_rpt("Actual   return value %d", rval);
		}

		if(err != ECHILD)
		{
			in_rpt("Expected errno %d (ECHILD)", ECHILD);
			in_rpt("Actual   errno %d (%s)", err, errname(err));
		}
	}
	else
		PATH_XS_RPT(2);

#else
	xx_rpt(NOTINUSE);
#endif
	DBUG_VOID_RETURN;
}

#if TEST_XPG > 3
private void
t59_sig()
{
	int	status;

	DBUG_ENTER("t59_sig");

	t59_rval = wait(&status);
	t59_errno = errno;

	DBUG_VOID_RETURN;
}
#endif
