/*
*      SCCS:  @(#)  ANSI.os/genuts/system_X/system_X.c	Rel 4.4.1     (06/09/97) 
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)ANSI.os/genuts/system_X - T.system_X Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN	*/
#endif  /* lint	*/

/***********************************************************************

NAME:		T.system_X

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Testset for the system() subroutine.

AUTHOR:		Manucher Ghezel-Ayagh, UniSoft Ltd.
DATE CREATED:	Tue Dec  9 10:00:43 WET 1986
MODIFICATIONS:	Andrew Twigger 1 July 87
		Added	vg_sjmp, setjmp(), tn_rpt()
		Removed	abandon(), testid()
		Modified xs_rpt(), xx_rpt()
		Dave Cater Mon May  8 13:52:37 BST 1989
		Replaced HIBYTE() with WIFEXITED(), etc.
		Joseph Nave Wed May 31 14:37:12 BST 1989
		Source file split into 2

		David Sawyer
		Tue Jul 10 10:05:15 BST 1990
		Added resillience code.

		Stuart Boutell, 5 Nov 1990
			change vg_env -> environ

		Neil Moses, 2 Oct 1991
			Added 9 new tests for VSX 4.2

		Geoff Clare, 31 March 1994
			Close fd in test 12.

************************************************************************/
#include	<std.h>
#include	<sys/types.h>
#include	<sys/wait.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<dbug.h>
#include	<unistd.h>
#include	<errno.h>
#include	<report.h>
#include	<string.h>
#include	<fcntl.h>
#include	<signal.h>
#include	<exitcodes.h>
#include	<sys/stat.h>
#include	<vsx_signal.h>
#include	<vsx_system.h>
#include	<timeout.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef system
#endif


#define	NO_TESTS	59		/* number of tests in testset */
#define	PATH2		"PATH=.:.."
#define	BSIZE		10		/* buffer size for creating files */
#define	M_ARGLEN	50		/* buffer size for command arguments */

extern	void	delay();
extern	int	cppair();
extern	char	*errname();
extern	char	*itoa();
extern	char	*ltoa();
extern	void	(*vsignal())();

extern	char	**environ;

public	int	no_tests = NO_TESTS;

struct devino {
	ino_t	inode;
	dev_t	device;
};

public struct devino sav_devino[3];

private	char	*t5_file =	"./system-t.5";
private	char	*t6_file =	"./system-t.6";
private	char	*t7_file =	"./system-t.7";
private	char	*t8_file =	"./system-t.8";
private	char	*t9_file =	"./system-t.9";
private	char	*t10_file =	"./system-t.10";
private	char	*t11_file =	"./system-t.11";
private	char	*t12_file =	"./system-t.12";
private	char	*t13_file =	"./system-t.13";
private	char	*t14_file =	"./system-t.14";

private	void	prepare_tests();
private	void	clean_tests();
public	int	rd_info();
public	int	cmp_devino();
public	int	rep_devino();
public	void	exit_fail();
private	void	test1();
private	void	test2();
private	void	test3();
private	void	test4();
private	void	test5();
private	void	test6();
private	void	test7();
private	void	test8();
private	void	test9();
private	void	test10();
private	void	test11();
private	void	test12();
private	void	test13();
private	void	test14();
private	void	test15();
private	void	test16();
private	void	test17();
extern	void	test18();
extern	void	test19();
extern	void	test20();
extern	void	test21();
extern	void	test22();
extern	void	test23();
extern	void	test24();
extern	void	test25();
extern	void	test26();
extern	void	test27();
extern	void	test28();
extern	void	test29();
extern	void	test30();
extern	void	test31();
extern	void	test32();
extern	void	test33();
extern	void	test34();
extern	void	test35();
extern	void	test36();
extern	void	test37();
extern	void	test38();
extern	void	test39();
extern	void	test40();
extern	void	test41();
extern	void	test42();
extern	void	test43();
extern	void	test44();
extern	void	test45();
extern	void	test46();
extern	void	test47();
extern	void	test48();
extern 	void	test49();
extern 	void	test50();
extern 	void	test51();
extern 	void	test52();
extern 	void	test53();
extern 	void	test54();
extern 	void	test55();
extern 	void	test56();
extern 	void	test57();
extern 	void	test58();
extern 	void	test59();
private void	ch_t1();
private void	ch_t2();
private void	ch_t4();

public	void	(*setfunc) () = prepare_tests;
public	void	(*clnfunc) () = clean_tests;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	 test2, 2,
	 test3, 3,
	 test4, 4,
	 test5, 5,
	 test6, 6,
	 test7, 7,
	 test8, 8,
	 test9, 9,
	 test10, 10,
	 test11, 11,
	 test12, 12,
	 test13, 13,
	 test14, 14,
	 test15, 15,
	 test16, 16,
	 test17, 17,
	 test18, 18,
	 test19, 19,
	 test20, 20,
	 test21, 21,
	 test22, 22,
	 test23, 23,
	 test24, 24,
	 test25, 25,
	 test26, 26,
	 test27, 27,
	 test28, 28,
	 test29, 29,
	 test30, 30,
	 test31, 31,
	 test32, 32,
	 test33, 33,
	 test34, 34,
	 test35, 35,
	 test36, 36,
	 test37, 37,
	 test38, 38,
	 test39, 39,
	 test40, 40,
	 test41, 41,
	 test42, 42,
	 test43, 43,
	 test44, 44,
	 test45, 45,
	 test46, 46,
	 test47, 47,
	 test48, 48,
	 test49, 49,
	 test50, 50,
	 test51, 51,
	 test52, 52,
	 test53, 53,
	 test54, 54,
	 test55, 55,
	 test56, 56,
	 test57, 57,
	 test58, 58,
	 test59, 59,
	NULL, 0
};

private	void
prepare_tests()
{
	DBUG_ENTER("prepare_tests");

	(void) umask((mode_t)0);

	DBUG_VOID_RETURN;
}

private	void
clean_tests()
{

	DBUG_ENTER("clean_tests");
	(void) unlink(t1_info);
	(void) unlink(t2_info);
	DBUG_VOID_RETURN;
}

private void
test1()
{
	int		rval;
	int		fd;
	int		i;
	struct stat	statbuf;
	int		syspid;
	struct devino	obs_devino[3];
	int		pathok = 0;

	DBUG_ENTER("test1");

	for (fd = 0; fd <= 2; fd++) {
		errno = NOERROR;
		if (fstat(fd, &statbuf) == SYSERROR) {
			for (i=2; i<NO_TESTS; i++)
				(void) tet_delete(i, "fstat() failed during preparation");
			xx_rpt(DELETION);
			in_rpt("deletion reason: fstat() failed during preparation");
		}
		else
			PATH_TRACE;
		sav_devino[fd].inode  = statbuf.st_ino;
		sav_devino[fd].device = statbuf.st_dev;
	}


	(void) cppair(ch_t1, NULLFN, WAITTIME, 0);
	
	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(sav_devino, obs_devino))
	{
		xx_rpt(FAILURE);
		(void) rep_devino(sav_devino, obs_devino);
	}
	else
	{
		PATH_TRACE;
		PATH_XS_RPT(5);
	}

	DBUG_VOID_RETURN;
}

private void
ch_t1()
{
	DBUG_ENTER("ch_t1");

	(void) system("../sys_cmd1");

	DBUG_VOID_RETURN;
}


private void
test2()
{
	int		rval;
	int		syspid;
	struct devino	obs_devino[3];
	int		pathok = 0;

	DBUG_ENTER("test2");

	(void) cppair(ch_t2, NULLFN, WAITTIME, 0);

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(sav_devino, obs_devino))
	{
		xx_rpt(FAILURE);
		(void) rep_devino(sav_devino, obs_devino);
	}
	else
	{
		PATH_TRACE;
		PATH_XS_RPT(2);
	}

	DBUG_VOID_RETURN;
}


private void
ch_t2()
{
	DBUG_ENTER("ch_t2");

	DBUG_PRINTF("test2","entering child");
	if (vputenv(&environ,PATH2) == -1)
		DBUG_EXIT(A_MISC);
	DBUG_PRINTF("test2","entering system");
	(void) system("sys_cmd1");

	DBUG_VOID_RETURN;
}

private void
test3()
{
	int		rval;
	int		pathok = 0;

	DBUG_ENTER("test3");

	rval = system("../sys_cmd.sh");

	if (WIFEXITED(rval) == 0)
	{
		exit_fail(rval, 0);
	}
	else 
	{
		PATH_TRACE;
		if (WEXITSTATUS(rval) != OK0)
		{
			xx_rpt(FAILURE);
			in_rpt("command file (sys_cmd.sh) not properly executed");
			in_rpt("expected exit code : %d", OK0);
			in_rpt("observed exit code : %d", WEXITSTATUS(rval));
		}
		else
		{
			PATH_TRACE;
			PATH_XS_RPT(2);
		}
	}

	DBUG_VOID_RETURN;
}

private void
test4()
{
	DBUG_ENTER("test4");

	(void) cppair(ch_t4, NULLFN, WAITTIME, 077);

	DBUG_VOID_RETURN;
}


private void
ch_t4()
{
	int	rval;
	int	pathok = 0;

	DBUG_ENTER("ch_t4");

	rval = system("../sys_cmd4");

	if (WIFEXITED(rval) == 0)
	{
		exit_fail(rval, 0);
	}
	else 
	{
		PATH_TRACE;
		if (WEXITSTATUS(rval) != OK5)
		{
			xx_rpt(FAILURE);
			in_rpt("last command's exit status not returned");
			in_rpt("expected exit code : %d", OK5);
			in_rpt("observed exit code %d", WEXITSTATUS(rval));
		}
		else
		{
			PATH_TRACE;
			PATH_XS_RPT(2);
		}
	}

	DBUG_VOID_RETURN;
}

private void
test5()
{
	int		fd;
	int		rval;
	int		i;
	int		failed = 0;
	int		syspid;
	struct stat	statbuf;
	struct devino	exp_devino[3];
	struct devino	obs_devino[3];
	int		pathok = 0;

	DBUG_ENTER("test5");

	errno = NOERROR;
	if ((fd = creat(t5_file, MODEANY)) == SYSERROR)
	{
		xx_rpt(DELETION);
		in_rpt("creat(%s, MODEANY) failed - errno %d(%s)",
			t5_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;
	(void) close(fd);

	errno = NOERROR;
	if (stat(t5_file, &statbuf) == SYSERROR) {
		xx_rpt(DELETION);
		in_rpt("stat(%s) failed - errno %d(%s)",
			t5_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	exp_devino[0].inode = statbuf.st_ino;
	exp_devino[0].device = statbuf.st_dev;
	for (i = 1; i <= 2; i++)
	{
		if (i==1)
			PATH_TRACE;
		exp_devino[i].inode  = sav_devino[i].inode;
		exp_devino[i].device = sav_devino[i].device;
	}

	(void) system("../sys_cmd1 < ./system-t.5");

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;

	if (cmp_devino(exp_devino, obs_devino))
	{
		xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;

	(void) system("<./system-t.5 ../sys_cmd1");

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		if (! failed)
			xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;

	if (cmp_devino(exp_devino, obs_devino))
	{
		if (! failed)
			xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;

	if (! failed)
		PATH_XS_RPT(7);

	(void) unlink(t5_file);
	DBUG_VOID_RETURN;
}

private void
test6()
{
	int		rval;
	int		i;
	int		failed = 0;
	int		syspid;
	off_t		fsize = BSIZE;
	struct stat	statbuf;
	struct devino	exp_devino[3];
	struct devino	obs_devino[3];
	int		pathok = 0;

	DBUG_ENTER("test6");

	if (cr10file(t6_file) != SUCCEED)
	{
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	(void) system("../sys_cmd1 > ./system-t.6");

	errno = NOERROR;
	if (stat(t6_file, &statbuf) == SYSERROR) {
		xx_rpt(DELETION);
		in_rpt("stat(%s) failed - errno %d(%s)",
			t6_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	exp_devino[1].inode = statbuf.st_ino;
	exp_devino[1].device = statbuf.st_dev;
	for (i = 0; i <= 2; i += 2)
	{
		if (i==0)
			PATH_TRACE;
		exp_devino[i].inode  = sav_devino[i].inode;
		exp_devino[i].device = sav_devino[i].device;
	}
	fsize = statbuf.st_size;

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;
	if (fsize != 0)
	{
		if (! failed)
			xx_rpt(FAILURE);
		in_rpt("%s was not truncated to zero length", t6_file);
		in_rpt("observed file size : %ld", (long) fsize);
		failed++;
	}
	else
		PATH_TRACE;

	(void) unlink(t6_file);

	(void) system(">./system-t.6 ../sys_cmd1");

	errno = NOERROR;
	if (stat(t6_file, &statbuf) == SYSERROR) {
		if (errno == ENOENT)
		{
			if (! failed)
				xx_rpt(FAILURE);
			in_rpt("system did not creat %s as expected", t6_file);
		}
		else
		{
			if (! failed)
				xx_rpt(DELETION);
			in_rpt("stat(%s) failed - errno %d(%s)",
				t6_file, errno, errname(errno));
		}
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	exp_devino[1].inode = statbuf.st_ino;
	exp_devino[1].device = statbuf.st_dev;

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		if (! failed)
			xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		if (! failed)
			xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;
	if (! failed)
		PATH_XS_RPT(9);

	(void) unlink(t6_file);
	DBUG_VOID_RETURN;
}

private void
test7()
{
	int		fd;
	int		rval;
	int		i;
	int		failed = 0;
	int		syspid;
	struct stat	statbuf;
	struct devino	exp_devino[3];
	struct devino	obs_devino[3];
	int		pathok = 0;

	DBUG_ENTER("test7");

	errno = NOERROR;
	if ((fd = creat(t7_file, MODEANY)) == SYSERROR)
	{
		xx_rpt(DELETION);
		in_rpt("creat(%s, MODEANY) failed - errno %d(%s)",
			t7_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;
	(void) close(fd);

	errno = NOERROR;
	if (stat(t7_file, &statbuf) == SYSERROR) {
		xx_rpt(DELETION);
		in_rpt("stat(%s) failed - errno %d(%s)",
			t7_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	exp_devino[0].inode = statbuf.st_ino;
	exp_devino[0].device = statbuf.st_dev;
	for (i = 1; i <= 2; i++)
	{
		if (i==1)
			PATH_TRACE;
		exp_devino[i].inode  = sav_devino[i].inode;
		exp_devino[i].device = sav_devino[i].device;
	}

	(void) system("../sys_cmd1 0< ./system-t.7");

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;

	(void) system("0<./system-t.7 ../sys_cmd1");

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		if (! failed)
			xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;
	if (! failed)
		PATH_XS_RPT(7);

	(void) unlink(t7_file);
	DBUG_VOID_RETURN;
}

private void
test8()
{
	int		rval;
	int		i;
	int		failed = 0;
	int		syspid;
	off_t		fsize = BSIZE;
	struct stat	statbuf;
	struct devino	exp_devino[3];
	struct devino	obs_devino[3];
	int		pathok = 0;

	DBUG_ENTER("test8");

	if (cr10file(t8_file) != SUCCEED)
	{
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	(void) system("../sys_cmd1 1> ./system-t.8");

	errno = NOERROR;
	if (stat(t8_file, &statbuf) == SYSERROR) {
		xx_rpt(DELETION);
		in_rpt("stat(%s) failed - errno %d(%s)",
			t8_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	exp_devino[1].inode = statbuf.st_ino;
	exp_devino[1].device = statbuf.st_dev;
	for (i = 0; i <= 2; i += 2)
	{
		if (i==0)
			PATH_TRACE;
		exp_devino[i].inode  = sav_devino[i].inode;
		exp_devino[i].device = sav_devino[i].device;
	}
	fsize = statbuf.st_size;

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;
	if (fsize != 0)
	{
		if (! failed)
			xx_rpt(FAILURE);
		in_rpt("%s was not truncated to zero length", t8_file);
		in_rpt("observed file size : %ld", (long) fsize);
		failed++;
	}
	else
		PATH_TRACE;

	(void) unlink(t8_file);

	(void) system("1>./system-t.8 ../sys_cmd1");

	errno = NOERROR;
	if (stat(t8_file, &statbuf) == SYSERROR) {
		if (errno == ENOENT)
		{
			if (! failed)
				xx_rpt(FAILURE);
			in_rpt("system did not creat %s as expected", t8_file);
		}
		else
		{
			if (! failed)
				xx_rpt(DELETION);
			in_rpt("stat(%s) failed - errno %d(%s)",
				t8_file, errno, errname(errno));
		}
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	exp_devino[1].inode = statbuf.st_ino;
	exp_devino[1].device = statbuf.st_dev;

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		if (! failed)
			xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		if (! failed)
			xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;
	if (! failed)
		PATH_XS_RPT(9);

	(void) unlink(t8_file);
	DBUG_VOID_RETURN;
}

private void
test9()
{
	int		rval;
	int		i;
	int		failed = 0;
	int		syspid;
	off_t		fsize = BSIZE;
	struct stat	statbuf;
	struct devino	exp_devino[3];
	struct devino	obs_devino[3];
	int		pathok = 0;

	DBUG_ENTER("test9");

	if (cr10file(t9_file) != SUCCEED)
	{
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	(void) system("../sys_cmd1 2> ./system-t.9");

	errno = NOERROR;
	if (stat(t9_file, &statbuf) == SYSERROR) {
		xx_rpt(DELETION);
		in_rpt("stat(%s) failed - errno %d(%s)",
			t9_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	exp_devino[2].inode = statbuf.st_ino;
	exp_devino[2].device = statbuf.st_dev;
	for (i = 0; i <= 1; i++)
	{
		if (i==0)
			PATH_TRACE;
		exp_devino[i].inode  = sav_devino[i].inode;
		exp_devino[i].device = sav_devino[i].device;
	}
	fsize = statbuf.st_size;

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;
	if (fsize != 0)
	{
		if (! failed)
			xx_rpt(FAILURE);
		in_rpt("%s was not truncated to zero length", t9_file);
		in_rpt("observed file size : %ld", (long) fsize);
		failed++;
	}
	else
		PATH_TRACE;

	(void) unlink(t9_file);

	(void) system("2>./system-t.9 ../sys_cmd1");

	errno = NOERROR;
	if (stat(t9_file, &statbuf) == SYSERROR) {
		if (errno == ENOENT)
		{
			if (! failed)
				xx_rpt(FAILURE);
			in_rpt("system did not creat %s as expected", t9_file);
		}
		else
		{
			if (! failed)
				xx_rpt(DELETION);
			in_rpt("stat(%s) failed - errno %d(%s)",
				t9_file, errno, errname(errno));
		}
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	exp_devino[2].inode = statbuf.st_ino;
	exp_devino[2].device = statbuf.st_dev;

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		if (! failed)
			xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		if (! failed)
			xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;
	if (! failed)
		PATH_XS_RPT(9);

	(void) unlink(t9_file);
	DBUG_VOID_RETURN;
}

private void
test10()
{
	int		rval;
	int		i;
	int		failed = 0;
	int		syspid;
	off_t		fsize = BSIZE;
	struct stat	statbuf;
	struct devino	exp_devino[3];
	struct devino	obs_devino[3];
	int		pathok = 0;

	DBUG_ENTER("test10");

	if (cr10file(t10_file) != SUCCEED)
	{
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	(void) system("../sys_cmd1 >> ./system-t.10");

	errno = NOERROR;
	if (stat(t10_file, &statbuf) == SYSERROR) {
		xx_rpt(DELETION);
		in_rpt("stat(%s) failed - errno %d(%s)",
			t10_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	exp_devino[1].inode = statbuf.st_ino;
	exp_devino[1].device = statbuf.st_dev;
	for (i = 0; i <= 2; i += 2)
	{
		if (i==0)
			PATH_TRACE;
		exp_devino[i].inode  = sav_devino[i].inode;
		exp_devino[i].device = sav_devino[i].device;
	}
	fsize = statbuf.st_size;

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;
	if (fsize != 10)
	{
		if (! failed)
			xx_rpt(FAILURE);
		in_rpt("%s was not truncated to zero length", t10_file);
		in_rpt("observed file size : %ld", (long) fsize);
		failed++;
	}
	else
		PATH_TRACE;
	(void) unlink(t10_file);

	(void) system(">>./system-t.10 ../sys_cmd1");

	errno = NOERROR;
	if (stat(t10_file, &statbuf) == SYSERROR) {
		if (errno == ENOENT)
		{
			if (! failed)
				xx_rpt(FAILURE);
			in_rpt("system did not creat %s as expected", t10_file);
		}
		else
		{
			if (! failed)
				xx_rpt(DELETION);
			in_rpt("stat(%s) failed - errno %d(%s)",
				t10_file, errno, errname(errno));
		}
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	exp_devino[1].inode = statbuf.st_ino;
	exp_devino[1].device = statbuf.st_dev;

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		if (! failed)
			xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		if (! failed)
			xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;
	if (! failed)
		PATH_XS_RPT(9);

	(void) unlink(t10_file);
	DBUG_VOID_RETURN;
}

private void
test11()
{
	int		fd;
	int		rval;
	int		i;
	int		failed = 0;
	int		syspid;
	char		cmd1[20];
	char		chfd[2];
	struct stat	statbuf;
	struct devino	exp_devino[3];
	struct devino	obs_devino[3];
	int		pathok = 0;

	DBUG_ENTER("test11");

	errno = NOERROR;
	if ((fd = creat(t11_file, MODEANY)) == SYSERROR)
	{
		xx_rpt(DELETION);
		in_rpt("creat(%s, MODEANY) failed - errno %d(%s)",
			t11_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	if (fd > 9)
	{
		xx_rpt(DELETION);
		in_rpt("can't attribute file descriptor <= 9 to %s", t11_file);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;
	chfd[0] = '0' + fd;
	chfd[1] = '\0';

	errno = NOERROR;
	if (stat(t11_file, &statbuf) == SYSERROR) {
		xx_rpt(DELETION);
		in_rpt("stat(%s) failed - errno %d(%s)",
			t11_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	exp_devino[0].inode = statbuf.st_ino;
	exp_devino[0].device = statbuf.st_dev;
	for (i = 1; i <= 2; i++)
	{
		if (i==1)
			PATH_TRACE;
		exp_devino[i].inode  = sav_devino[i].inode;
		exp_devino[i].device = sav_devino[i].device;
	}

	(void) strcpy(cmd1, "../sys_cmd1 <&");
	(void) strcat(cmd1, chfd);
	(void) system(cmd1);

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;

	(void) strcpy(cmd1, "<&");
	(void) strcat(cmd1, chfd);
	(void) strcat(cmd1, " ../sys_cmd1");
	(void) system(cmd1);

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		if (! failed)
			xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	if (! failed)
		PATH_XS_RPT(7);

	(void) close (fd);
	(void) unlink(t11_file);
	DBUG_VOID_RETURN;
}

private void
test12()
{
	int		fd;
	int		rval;
	int		i;
	int		failed = 0;
	int		syspid;
	char		cmd1[20];
	char		chfd[2];
	struct stat	statbuf;
	struct devino	exp_devino[3];
	struct devino	obs_devino[3];
	int		pathok = 0;

	DBUG_ENTER("test12");

	errno = NOERROR;
	if ((fd = creat(t12_file, MODEANY)) == SYSERROR)
	{
		xx_rpt(DELETION);
		in_rpt("creat(%s, MODEANY) failed - errno %d(%s)",
			t12_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;
	if (fd > 9)
	{
		xx_rpt(DELETION);
		in_rpt("can't attribute file descriptor <= 9 to %s", t12_file);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;
	chfd[0] = '0' + fd;
	chfd[1] = '\0';

	(void) strcpy(cmd1, "../sys_cmd1 >&");
	(void) strcat(cmd1, chfd);
	(void) system(cmd1);

	errno = NOERROR;
	if (stat(t12_file, &statbuf) == SYSERROR)
	{
		xx_rpt(DELETION);
		in_rpt("stat(%s) failed - errno %d(%s)",
			t12_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	exp_devino[1].inode = statbuf.st_ino;
	exp_devino[1].device = statbuf.st_dev;
	for (i = 0; i <= 2; i += 2)
	{
		if (i==0)
			PATH_TRACE;
		exp_devino[i].inode  = sav_devino[i].inode;
		exp_devino[i].device = sav_devino[i].device;
	}

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;

	(void) strcpy(cmd1, ">&");
	(void) strcat(cmd1, chfd);
	(void) strcat(cmd1, " ../sys_cmd1");
	(void) system(cmd1);

	errno = NOERROR;
	if (stat(t12_file, &statbuf) == SYSERROR) {
		if (errno == ENOENT)
		{
			if (! failed)
				xx_rpt(FAILURE);
			in_rpt("system did not creat %s as expected", t12_file);
		}
		else
		{
			if (! failed)
				xx_rpt(DELETION);
			in_rpt("stat(%s) failed - errno %d(%s)",
				t12_file, errno, errname(errno));
		}
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		if (! failed)
			xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		if (! failed)
			xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;
	if (! failed)
		PATH_XS_RPT(9);

	(void) close (fd);
	(void) unlink(t12_file);
	DBUG_VOID_RETURN;
}

private void
test13()
{
	int		fd;
	int		rval;
	int		i;
	int		failed = 0;
	int		syspid;
	char		cmd1[20];
	char		chfd[2];
	struct stat	statbuf;
	struct devino	exp_devino[3];
	struct devino	obs_devino[3];
	int		pathok = 0;

	DBUG_ENTER("test13");

	errno = NOERROR;
	if ((fd = creat(t13_file, MODEANY)) == SYSERROR)
	{
		xx_rpt(DELETION);
		in_rpt("creat(%s, MODEANY) failed - errno %d(%s)",
			t13_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	if (fd > 9)
	{
		xx_rpt(DELETION);
		in_rpt("can't attribute file descriptor <= 9 to %s", t13_file);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;
	chfd[0] = '0' + fd;
	chfd[1] = '\0';

	errno = NOERROR;
	if (stat(t13_file, &statbuf) == SYSERROR) {
		xx_rpt(DELETION);
		in_rpt("stat(%s) failed - errno %d(%s)",
			t13_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	exp_devino[0].inode = statbuf.st_ino;
	exp_devino[0].device = statbuf.st_dev;
	for (i = 1; i <= 2; i++)
	{
		if (i==1)
			PATH_TRACE;
		exp_devino[i].inode  = sav_devino[i].inode;
		exp_devino[i].device = sav_devino[i].device;
	}

	(void) strcpy(cmd1, "../sys_cmd1 0<&");
	(void) strcat(cmd1, chfd);
	(void) system(cmd1);

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;

	(void) strcpy(cmd1, "1<&");
	(void) strcat(cmd1, chfd);
	(void) strcat(cmd1, " ../sys_cmd1");
	(void) system(cmd1);

	exp_devino[1].inode = statbuf.st_ino;
	exp_devino[1].device = statbuf.st_dev;
	for (i = 0; i <= 2; i += 2)
	{
		if (i==0)
			PATH_TRACE;
		exp_devino[i].inode  = sav_devino[i].inode;
		exp_devino[i].device = sav_devino[i].device;
	}

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		if (! failed)
			xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;

	exp_devino[2].inode = statbuf.st_ino;
	exp_devino[2].device = statbuf.st_dev;
	for (i = 0; i <= 1; i++)
	{
		if (i==0)
			PATH_TRACE;
		exp_devino[i].inode  = sav_devino[i].inode;
		exp_devino[i].device = sav_devino[i].device;
	}

	(void) strcpy(cmd1, "../sys_cmd1 2<&");
	(void) strcat(cmd1, chfd);
	(void) system(cmd1);

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;
	if (! failed)
		PATH_XS_RPT(12);

	(void) close (fd);
	(void) unlink(t13_file);
	DBUG_VOID_RETURN;
}

private void
test14()
{
	int		fd;
	int		rval;
	int		i;
	int		failed = 0;
	int		syspid;
	char		cmd1[20];
	char		chfd[2];
	struct stat	statbuf;
	struct devino	exp_devino[3];
	struct devino	obs_devino[3];
	int		pathok = 0;

	DBUG_ENTER("test14");

	errno = NOERROR;
	if ((fd = creat(t14_file, MODEANY)) == SYSERROR)
	{
		xx_rpt(DELETION);
		in_rpt("creat(%s, MODEANY) failed - errno %d(%s)",
			t14_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	if (fd > 9)
	{
		xx_rpt(DELETION);
		in_rpt("can't attribute file descriptor <= 9 to %s", t14_file);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;
	chfd[0] = '0' + fd;
	chfd[1] = '\0';

	errno = NOERROR;
	if (stat(t14_file, &statbuf) == SYSERROR) {
		xx_rpt(DELETION);
		in_rpt("stat(%s) failed - errno %d(%s)",
			t14_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	(void) strcpy(cmd1, "1>&");
	(void) strcat(cmd1, chfd);
	(void) strcat(cmd1, " ../sys_cmd1");

	(void) system(cmd1);

	exp_devino[1].inode = statbuf.st_ino;
	exp_devino[1].device = statbuf.st_dev;
	for (i = 0; i <= 2; i += 2)
	{
		if (i==0)
			PATH_TRACE;
		exp_devino[i].inode  = sav_devino[i].inode;
		exp_devino[i].device = sav_devino[i].device;
	}

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		if (! failed)
			xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;

	exp_devino[2].inode = statbuf.st_ino;
	exp_devino[2].device = statbuf.st_dev;
	for (i = 0; i <= 1; i++)
	{
		if (i==0)
			PATH_TRACE;
		exp_devino[i].inode  = sav_devino[i].inode;
		exp_devino[i].device = sav_devino[i].device;
	}

	(void) strcpy(cmd1, "../sys_cmd1 2>&");
	(void) strcat(cmd1, chfd);
	(void) system(cmd1);

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;
	if (! failed)
		PATH_XS_RPT(9);

	(void) close (fd);
	(void) unlink(t14_file);
	DBUG_VOID_RETURN;
}

private void
test15()
{
	int		rval;
	int		i;
	int		failed = 0;
	int		syspid;
	struct devino	exp_devino[3];
	struct devino	obs_devino[3];
	int		pathok = 0;

	DBUG_ENTER("test15");

	exp_devino[0].inode = 0;
	exp_devino[0].device = 0;
	for (i = 1; i <= 2; i++)
	{
		if (i==1)
			PATH_TRACE;
		exp_devino[i].inode  = sav_devino[i].inode;
		exp_devino[i].device = sav_devino[i].device;
	}

	(void) system("../sys_cmd1 <&-");

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;

	(void) system("<&- ../sys_cmd1");

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		if (! failed)
			xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;
	if (! failed)
		PATH_XS_RPT(5);

	DBUG_VOID_RETURN;
}

private void
test16()
{
	int		rval;
	int		i;
	int		failed = 0;
	int		syspid;
	struct devino	exp_devino[3];
	struct devino	obs_devino[3];
	int		pathok = 0;

	DBUG_ENTER("test16");

	exp_devino[1].inode = 0;
	exp_devino[1].device = 0;
	for (i = 0; i <= 2; i += 2)
	{
		if (i==0)
			PATH_TRACE;
		exp_devino[i].inode  = sav_devino[i].inode;
		exp_devino[i].device = sav_devino[i].device;
	}

	(void) system("../sys_cmd1 >&-");

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;

	(void) system(">&- ../sys_cmd1");

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		if (! failed)
			xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;
	if (! failed)
		PATH_XS_RPT(5);

	DBUG_VOID_RETURN;
}

private void
test17()
{
	int		rval;
	int		i;
	int		failed = 0;
	int		syspid;
	struct devino	exp_devino[3];
	struct devino	obs_devino[3];
	int		pathok = 0;

	DBUG_ENTER("test17");

	exp_devino[0].inode = 0;
	exp_devino[0].device = 0;
	for (i = 1; i <= 2; i++)
	{
		if (i==1)
			PATH_TRACE;
		exp_devino[i].inode  = sav_devino[i].inode;
		exp_devino[i].device = sav_devino[i].device;
	}

	(void) system("../sys_cmd1 0<&-");

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;

	exp_devino[1].inode = 0;
	exp_devino[1].device = 0;
	for (i = 0; i <= 2; i += 2)
	{
		if (i==0)
			PATH_TRACE;
		exp_devino[i].inode  = sav_devino[i].inode;
		exp_devino[i].device = sav_devino[i].device;
	}

	(void) system("1<&- ../sys_cmd1");

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		if (! failed)
			xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;

	exp_devino[2].inode = 0;
	exp_devino[2].device = 0;
	for (i = 0; i <= 1; i++)
	{
		if (i==0)
			PATH_TRACE;
		exp_devino[i].inode  = sav_devino[i].inode;
		exp_devino[i].device = sav_devino[i].device;
	}

	(void) system("../sys_cmd1 2<&-");

	if (rval = rd_info(t1_info, obs_devino, &syspid))
	{
		xx_rpt(FAILURE);
		switch (rval)
		{
		case E_OPEN :
			in_rpt("open(%s, O_RDONLY, 0) failed", t1_info);
			DBUG_VOID_RETURN;
		case E_READ :
			in_rpt("reading from %s failed", t1_info);
			DBUG_VOID_RETURN;
		}
	}
	else
		PATH_TRACE;
	if (cmp_devino(exp_devino, obs_devino))
	{
		if (! failed)
			xx_rpt(FAILURE);
		(void) rep_devino(exp_devino, obs_devino);
		failed++;
	}
	else
		PATH_TRACE;
	if (! failed)
		PATH_XS_RPT(9);

	DBUG_VOID_RETURN;
}



public int
rd_info(infile, infobuf, syspid)
	char	*infile;
	struct devino	infobuf[];
	int	*syspid;
{
	int		fd;
	int		i;

	DBUG_ENTER("rd_info");
	if ((fd = open(infile, O_RDONLY, 0)) == SYSERROR)
			DBUG_RETURN(E_OPEN);

	for (i = 0; i <= 2; i++) {
		if (read(fd, (char *) &(infobuf[i].inode), sizeof (ino_t)) !=
		    sizeof (ino_t))
			DBUG_RETURN(E_READ);
		if (read(fd, (char *) &(infobuf[i].device), sizeof (dev_t)) !=
		    sizeof (dev_t))
			DBUG_RETURN(E_READ);
	}
	if (read(fd, (char *) syspid, sizeof (int)) != sizeof (int))
			DBUG_RETURN(E_READ);
	(void) close(fd);
	(void) unlink(infile);
	
	DBUG_RETURN(SUCCEED);
}

public int
cmp_devino(exp_res, obs_res)
	struct devino	exp_res[];
	struct devino	obs_res[];
{
	int		i;
	int		failed = 0;

	DBUG_ENTER("cmp_devino");

	for (i = 0; i <= 2; i++)
	{
		if (exp_res[i].inode != obs_res[i].inode)
			failed++;
		if (exp_res[i].device != obs_res[i].device)
			failed++;
	}
	DBUG_RETURN(failed);
}

public int
rep_devino(exp_res, obs_res)
	struct devino	exp_res[];
	struct devino	obs_res[];
{
	int		i;

	DBUG_ENTER("rep_devino");
	for (i = 0; i <= 2; i++)
	{
		if (exp_res[i].inode != obs_res[i].inode)
			in_rpt("%s inode number, expected : %lu , observed : %lu",
		  	((i == 0) ? "stdin" : ((i == 1) ? "stdout" : "stderr")),
			(unsigned long) exp_res[i].inode,
			(unsigned long) obs_res[i].inode);

		if (exp_res[i].device != obs_res[i].device)
			in_rpt("%s device number, expected : %lu , observed : %lu",
		  	((i == 0) ? "stdin" : ((i == 1) ? "stdout" : "stderr")),
			(unsigned long) exp_res[i].device,
			(unsigned long) obs_res[i].device);
	}
	DBUG_VOID_RETURN;
}

public	int
cr10file(file)
	char	*file;
{
	int		fd;
	int		err;
	int		rval;
	char		buf[BSIZE];

	(void) unlink(file);
	errno = NOERROR;
	if ((fd = creat(file, MODEANY)) == SYSERROR)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("creat(%s, %#o) failed - errno %d(%s)",
			file, MODEANY, err, errname(err));
	}
	else if ((rval = write(fd, buf, sizeof(buf))) != sizeof(buf))
	{
		err = errno;
		xx_rpt(DELETION);
		if (rval == SYSERROR)
			in_rpt("write() failed - errno %d(%s)",
				err, errname(err));
		else
			in_rpt("write() did not write whole buffer: expected %d, got %d",
				sizeof(buf), rval);
		(void) close(fd);
		(void) unlink(file);
		fd = SYSERROR;
	}
	else
		(void) close(fd);

	return fd == SYSERROR ? FAIL : SUCCEED;
}

public void
exit_fail(rval, failed)
int	rval;
int	failed;
{
	/* What to do if system() returned with WIFEXITED() zero */

	if(!failed)
		xx_rpt(DELETION);
	in_rpt("system() returned information on process that did not exit normally");
	if (WIFSIGNALED(rval))
		in_rpt("instead process was terminated by signal %d", 
							WTERMSIG(rval));
	else if (WIFSTOPPED(rval))
		in_rpt("instead process was stopped by signal %d", 
							WSTOPSIG(rval));
}
