/*
*      SCCS:  @(#)  ANSI.os/streamio/fclose/fclose_t21.c	Rel 4.4.1     (06/09/97) 
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
*/

#ifndef lint
#ifdef	MAIN
static	char sccsid[] = "@(#)ANSI.os/streamio/fclose_t21 - T.fclose Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN	*/
#endif  /* lint	*/

/***********************************************************************

NAME:		T.fclose

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Testset for the fclose() subroutine call.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		John-Paul, UniSoft Ltd.
DATE CREATED:	7 October 1992
MODIFICATIONS:	

************************************************************************/
#include	<std.h>
#include	<stdio.h>
#include	<string.h>
#include	<dbug.h>
#include	<errno.h>
#include	<report.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<xnfs.h>
#include	<signal.h>
#include 	<tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef fclose
#endif


/* Data */
#define ONE_BYTE_STR    "x"
#define ONE_BYTE_CHAR   'x'
#define ONE_BYTE_LENGTH 1

#define CHMOD_MODE	S_IWUSR
#define WAITTIME	(5 * SPEEDFACTOR)

public  char    *vg_ident =     "<no ident>";
public  char    *vg_dbug =      (char *) NULL;

private uid_t	uid;
private gid_t	gid;
private char	*file;

extern	char	*errname();
extern	void	set_pname();

private	void	testN();
private	void	ch_tN();

private	int	test_deleted = 0;
private int	test_fail = 0;

public	int
tet_main(argc, argv)
int	argc;
char	**argv;
{
	set_pname(argv[0]);

	if (argc < 4 || argc > 6)
	{
		xx_rpt(DELETION);
		in_rpt("argument count wrong");
		return(OK);
	}

	if (argc >= 6)
		vg_dbug = argv[5];
	if (argc >= 5)
		vg_ident = argv[4];

	if (vg_dbug != NULL)
	{
		DBUG_PROCESS(vg_ident);
		DBUG_PUSH(vg_dbug+2);
	}

	uid = atoi(argv[2]);
	gid = atoi(argv[3]);
	file = newstr(argv[1]);

/* XXX

	if ((uid = atoi(argv[2])) != geteuid() ||
		(gid = atoi(argv[3])) != getegid())
	{
		xx_rpt(DELETION);
		if (uid != getuid())
			in_rpt("deletion reason: uid is not equal to VSX_UID1");
		else
			in_rpt("deletion reason: gid is not equal to VSX_GID1");
	}
	else
*/
		testN();

	return(OK);
	/*NOTREACHED*/
}

private void
testN()
{

	int     pathok = 0;

	DBUG_ENTER("testN");

	(void) cppair(ch_tN, NULLFN, WAITTIME, 0);

	(void) unlink(file);

	DBUG_VOID_RETURN;
}


private void
ch_tN()
{
	int		err;
	int		ret;
	FILE		*fd;
	int		pathok = 0;

	DBUG_ENTER("ch_tN");

	globok = 0;

	if ((fd = fopen(file, "w")) == NULL)
	{
		err = errno;
		xx_rpt(FAILURE);
		in_rpt("fopen(\"%s\", \"w\") failed - errno %d(%s)",
				file, err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	/* Write to file */

	errno = NOERROR;
	ret = fwrite((void *)ONE_BYTE_STR, (size_t)1, (size_t)ONE_BYTE_LENGTH, fd);
	if(ret != ONE_BYTE_LENGTH)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("fwrite() failed errno %d", err);
		test_deleted++;
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

        errno = NOERROR;
        if(chmod(file, CHMOD_MODE) == SYSERROR)
        {
                err = errno;
                xx_rpt(DELETION);
                in_rpt("Could not chmod() file \"%s\" to %d. errno = %d(%s)", file, CHMOD_MODE, err, errname(err));
                DBUG_VOID_RETURN;
        }
        else
                PATH_TRACE;

	errno = NOERROR;
	if(setgid(gid) == SYSERROR)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("Could not set group id to %d. errno = %d",gid, err);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;		

	errno = NOERROR;
	if(setuid(uid) == SYSERROR)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("Could not set user id to %d. errno = %d",uid, err);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;		

	errno = NOERROR;
	ret = fclose(fd);
	if( (ret != EOF) || (errno != EACCES) )
	{
		err = errno;
		xx_rpt(FAILURE);
                if (ret != EOF)
                        in_rpt("fclose() returned %d when testing for errno %d(EACCES), expected EOF", ret, EACCES);
                else if (err != EACCES)
                        in_rpt("fclose() set errno incorrectly: expected %d(EACCES), actual %d(%s)", EACCES, err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;		

	if(!test_fail)
		PATH_XS_RPT(5);

	DBUG_VOID_RETURN;
}
