/*
*      SCCS:  @(#)  ANSI.os/streamio/fflush/fflush_t14.c	Rel 4.4.1     (06/09/97) 
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)ANSI.os/streamio/fflush - fflush_t14 Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN	*/
#endif  /* lint	*/

/***********************************************************************

NAME:		fflush_t14 - used by T.fflush in privileged tests

PROJECT:	XNFS (X/OPEN NFS tests)

MODULE CONTAINS:
		tet_main()

SYNOPSIS:
		int main(argc, argv)
			int argc;
			char **argv;

DESCRIPTION:
	  Exec'd by T.fflush to perform privileged tests.

	  usage:
		fflush_t14 testnum dir file ident dbug

	  where testnum is the test number to be executed, and
	  file is a parameter to be passed to the test.
METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Dave Cater, UniSoft Ltd.
DATE CREATED:	21 October 1992
MODIFICATIONS:

************************************************************************/
#include <std.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <dbug.h>
#include <errno.h>
#include <sys/stat.h>
#include <report.h>
#include <tet_api.h>
#include <xnfs.h>
#include "fflush_h.h"
#include <sysdep.h>

#ifdef UNDEF_MACROS
#undef fflush
#endif


public	char	*vg_ident =	"<no ident>";
public	char	*vg_dbug =	(char *) NULL;

private        char    *t_string =     "abcdefghijklmnopqrstuvwxyz";

extern	char	**environ;
extern	char	*errname();

extern	void	valrpt();
extern	void	set_pname();

private	int	t14_chk_func();

public	int
tet_main(argc, argv)
int	argc;
char	**argv;
{
	set_pname(argv[0]);

	if (argc < 4 || argc > 6)
	{
		xx_rpt(DELETION);
		in_rpt("argument count wrong" );
		return(OK);
	}
	if (argc >= 6)
		vg_dbug = argv[5];
	if (argc >= 5)
		vg_ident = argv[4];

	if (vg_dbug != NULL)
	{
		DBUG_PROCESS(vg_ident);
		DBUG_PUSH(vg_dbug+2);
	}

	t_eacces_flush_c(argv[3], 0, t14_chk_func, SP_T14_EACCES);

 	return(OK);
}

private int
t14_chk_func(fp, ebytes)
FILE	*fp;
int	ebytes;
{
	int	rval, err;
	int	i;
	size_t	nbytes = sizeof(t_string);
	int	pathok = 0;

	DBUG_ENTER("t14_chk_func");

	for(i = 0; i < ebytes; i++ ) {
		(void) fwrite((void *)t_string, (size_t)1, nbytes, fp);
		errno = NOERROR;
		rval = fflush(fp);
		err = errno;
		if(rval != 0)
			break;
	}

	if(rval != EOF || err != EACCES)
	{
		xx_rpt(FAILURE);

		if(rval != EOF)
		{
			in_rpt("Return value was incorrect");
			in_rpt("Expected return value (%d) EOF", EOF);
			in_rpt("Actual   return value %d", rval);
		}
		else
			PATH_TRACE;
		
		if(err != EACCES)
		{
			in_rpt("Errno not set correctly");
			in_rpt("Expected errno %d (%s)",EACCES,errname(EACCES));
			in_rpt("Actual   errno %d (%s)", err, errname(err));
		}
		else
			PATH_TRACE;

		DBUG_RETURN(-1);
	}
	else
	{
		PATH_TRACE;
		PATH_TRACE;
	}

	PATH_FUNC_RPT(2);

	DBUG_RETURN(0);
}
