/*
 *      SCCS: @(#)  ANSI.os/streamio/fopen/fopen_h.h Rel 4.4.1 (06/09/97)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

/***********************************************************************

NAME:		fopen_h.h

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION:
	Definitions common to master and slave side of the fopen test set.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		John-Paul, UniSoft Ltd.
DATE CREATED:	19 October 1992
MODIFICATIONS:
		Geoff Clare, 19 Oct 1993
			Delete T38_DIR and T39_DIR

************************************************************************/

#if TEST_XNFS

#define NOK             02
#define PATH_OK         04

/*
**	test4
*/

/* sync points */
#define SP_T4_RTIME_START	MK_SPNO(0)

/*
**	test5
*/

/* sync points */
#define SP_T5_RTIME_START	MK_SPNO(0)

/*
**	test7
*/

/* sync points */
#define SP_T7_RTIME_START	MK_SPNO(0)

/*
**	test8
*/

/* sync points */
#define SP_T8_RTIME_START	MK_SPNO(0)

/*
**	test10
*/

/* sync points */
#define SP_T10_RTIME_START	MK_SPNO(0)

/*
**	test11
*/

/* sync points */
#define SP_T11_RTIME_START	MK_SPNO(0)

/*
**	test13
*/

/* sync points */
#define SP_T13_1_RTIME_START	MK_SPNO(0)
#define SP_T13_2_RTIME_START	MK_SPNO(1)

/*
**	test14
*/

/* sync points */
#define SP_T14_1_RTIME_START	MK_SPNO(0)
#define SP_T14_2_RTIME_START	MK_SPNO(1)

/*
**	test19
*/

/* files and directories */
#define T19_2_DIR		"./fopen-d.19.2"
#define T19_2_FILE		"./fopen-d.19.2/fopen-t.19.2"

/* sync points */
#define SP_T19_MKDIR2_START	MK_SPNO(0)
#define SP_T19_MKDIR2_END	MK_SPNO(1)
#define SP_T19_RMDIR2_START	MK_SPNO(2)
#define SP_T19_RMDIR2_END	MK_SPNO(3)


/*
**	test20
*/

/* files and directories */
#define T20_2_DIR		"./fopen-d.20.2"
#define T20_2_FILE		"./fopen-d.20.2/fopen-t.20.2"

/* sync points */
#define SP_T20_MKDIR2_START	MK_SPNO(0)
#define SP_T20_MKDIR2_END	MK_SPNO(1)
#define SP_T20_RMDIR2_START	MK_SPNO(2)
#define SP_T20_RMDIR2_END	MK_SPNO(3)


/*
**	test 38
*/

/* files and directories */
#define T38_MNT			"./fopen-m.38"
#define T38_FILE		"./fopen-m.38/fopen-f.38"


/*
**	test 39
*/

/* files and directories */
#define T39_FILE		"./fopen-f.39";

#endif /* TEST_XNFS */

