/*
 *      SCCS:  ANSI.os/streamio/fopen/fopen_su.c Rel 4.4.1	(06/09/97)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

#ifndef lint
#define MAIN
static	char sccsid[] = "@(#)ANSI.os/streamio/fopen/fopen_su Rel 4.4.1 (06/09/97)";
#ifdef	MAIN
char	*copyright[] = {
		"(C) Copyright 1992 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		fopen_su.c

PROJECT:	XNFS (X/OPEN NFS tests)

MODULE CONTAINS:
		tet_main()

SYNOPSIS:
		int tet_main(argc, argv)
			int argc;
			char **argv;

DESCRIPTION:
	Common subprogram for XNFS uid mapping tests.
	Exec'd by T.fopen.

	usage:
		progname file vg_ident vg_dbug

AUTHOR:		John-Paul, UniSoft Ltd.

DATE CREATED:	22 October 1992

MODIFICATIONS:

************************************************************************/

#include <std.h>
#include <dbug.h>
#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <report.h>
#include <errno.h>
#include <tet_api.h>
#include "fopen_h.h"
#include <sysdep.h>

#ifdef UNDEF_MACROS
#undef fopen
#endif


#define MODEANY		((mode_t)(S_IRWXU|S_IRWXG|S_IRWXO))

public	char	*vg_ident =	"<no ident>";
public	char	*vg_dbug =	(char *) NULL;

extern	void	set_pname();
extern	char	*errname();

private int	subtest19_20();

public	int
tet_main(argc, argv)
int argc;
char **argv;
{
	int rc;

	set_pname(argv[0]);

	if (argc < 1 || argc > 4)
	{
		xx_rpt(DELETION);
		in_rpt("argument count wrong" );
		return(OK);
	}
	if (argc >= 4)
		vg_dbug = argv[3];
	if (argc >= 3)
		vg_ident = argv[2];

	if (vg_dbug != NULL)
	{
		DBUG_PROCESS(vg_ident);
		DBUG_PUSH(vg_dbug + 2);
	}

	rc = subtest19_20(argv[1]);

	(void) unlink(argv[1]);

	return(rc);
}

private int
subtest19_20(file)
char *file;
{
	int err, rc;
	FILE *fd;
	int pathok = 0;

	DBUG_ENTER("subtest19_20");

	fd = fopen(file, "w");
	err = errno;

	if (fd != NULL || err != EACCES)
	{
		xx_rpt(FAILURE);

		if (fd != NULL)
			in_rpt("fopen(%s, \"w\") did not return NULL", 
						file);

		if (err != EACCES)
			in_rpt("fopen(%s, \"w\") did not return expected errno",
						file);
			in_rpt("expected errno EACCES, found %d(%s)",
				err, errname(err));

		DBUG_RETURN(NOK);
	}
	else
		PATH_TRACE;

	rc = OK;
	if (pathok == 1)
		rc |= PATH_OK;

	DBUG_RETURN(rc);
}
