/*
 *      SCCS:  @(#)  ANSI.os/streamio/fopen/fopen_t39.c Rel 4.4.1 (06/09/97)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

#ifndef lint
static	char sccsid[] = "@(#)ANSI.os/streamio/fopen/fopen_t39.c Rel 4.4.1 (06/09/97)";
#endif	/* lint */

/***********************************************************************

NAME:		fopen_t39.c

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION: 	setup routine for test39() subprogram

AUTHOR:		Andrew Dingwall, UniSoft Ltd.
DATE CREATED:	7 September 1992

MODIFICATIONS:
		Geoff Clare, 20 Oct 1993
			Delete subdirectory from T39_FILE.

************************************************************************/

#include <std.h>
#include <dbug.h>
#include <sys/types.h>
#include "fopen_h.h"
#include <sysdep.h>

#ifdef UNDEF_MACROS
#undef fopen
#endif


private char	*t39_file = 	T39_FILE;

extern 	void	subtest3839();

public void
setup3839(mygid)
gid_t mygid;
{
	gid_t altgid;

	DBUG_ENTER("setup3839 for test 39");

#if TEST_FIPS || TEST_XPG > 3
	altgid = (gid_t) -1;
#else
	altgid = mygid;
#endif

	subtest3839(".", t39_file, mygid, altgid, 0, 0);

	DBUG_VOID_RETURN;
}
