/*
 *      SCCS:  @(#) ANSI.os/streamio/freopen/freop_t42.c Rel 4.4.1 (06/09/97)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

#ifndef lint
static	char sccsid[] = "@(#)ANSI.os/streamio/freopen/freop_t42.c Rel 4.4.1 (06/09/97)";
#endif	/* lint */

/***********************************************************************

NAME:		freop_t42.c

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION: 	setup routine for test42() subprogram

AUTHOR:		John-Paul, UniSoft Ltd.
DATE CREATED:	19 October 1992

MODIFICATIONS:
		Geoff Clare, 20 Oct 1993
			Delete subdirectory from T42_FILE.
			Use tet_fork() now that subtest does a setuid().

************************************************************************/

#include <std.h>
#include <dbug.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>
#include <report.h>
#include <tet_api.h>
#include <setprv.h>
#include <xnfs.h>
#include "freopen_h.h"
#include <sysdep.h>

#ifdef UNDEF_MACROS
#undef freopen
#endif


#define WAITTIME	(5 * SPEEDFACTOR)

private char	*t42_mnt = 	T42_MNT;
private char	*t42_file = 	T42_FILE;
private gid_t	mygid;
private void	chfunc();

extern 	void	subtest4243();


public void
setup4243(gid)
gid_t gid;
{
	int pathok = 0;
	char *fsys;

	DBUG_ENTER("setup4243 for test 42");

	mygid = gid;

	if ((fsys = tet_getvar("VSX_MOUNT_DEV")) == NULL || *fsys == '\0')
	{
		xx_rpt(DELETION);
		in_rpt("deletion reason: VSX_MOUNT_DEV not set");
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	if (xnfs_mount(fsys, t42_mnt, XNFS_MOUNT_GRPID | XNFS_MOUNT_INTR) < 0)
	{
		xx_rpt(DELETION);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	PATH_FUNC_RPT(2);
	(void) tet_fork(chfunc, NULLFN, 2*WAITTIME, 0);

	(void) xnfs_unmount(fsys, t42_mnt);

	DBUG_VOID_RETURN;
}

private void
chfunc()
{
	int pathok = 0;

	DBUG_ENTER("chfunc");

	PATH_FUNC_TRACE;
	subtest4243(t42_mnt, t42_file, mygid, (gid_t) -1, pathok, 1);

	DBUG_VOID_RETURN;
}
