/*
 *      SCCS: @(#)  ANSI.os/streamio/freopen/freopen_h.h Rel 4.4.1 (06/09/97)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

/***********************************************************************

NAME:		freopen_h.h

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION:
	Definitions common to master and slave side of the freopen test set.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		John-Paul, UniSoft Ltd.
DATE CREATED:	19 October 1992
MODIFICATIONS:
		Geoff Clare, 20 Oct 1993
			Delete T42_DIR and T43_DIR.
			Delete T42A_FILE and T43A_FILE.

************************************************************************/

#if TEST_XNFS

#define	XNFS_STRING		"x"
#define	XNFS_STRING_LENGTH	1

#define PATH_OK		04
#define NOK		02


/*
**	test5
*/

/* sync points */
#define SP_T5_RTIME_START	MK_SPNO(0)

/*
**	test6
*/

/* sync points */
#define SP_T6_RTIME_START	MK_SPNO(0)

/*
**	test8
*/

/* sync points */
#define SP_T8_RTIME_START	MK_SPNO(0)

/*
**	test9
*/

/* sync points */
#define SP_T9_RTIME_START	MK_SPNO(0)

/*
**      test13
*/

/* sync points */
#define SP_T13_RTIME_START      MK_SPNO(0)

/*
**      test14
*/

/* sync points */
#define SP_T14_RTIME_START      MK_SPNO(0)

/*
**      test16
*/

/* sync points */
#define SP_T16_1_RTIME_START    MK_SPNO(0)
#define SP_T16_2_RTIME_START    MK_SPNO(1)

/*
**      test17
*/

/* sync points */
#define SP_T17_1_RTIME_START    MK_SPNO(0)
#define SP_T17_2_RTIME_START    MK_SPNO(1)


/*
**	test21
*/

/* files and directories */
#define T21_2_DIR		"./freop-d.21.2"
#define T21_2_FILE		"./freop-t.21.2"
#define T21A_2_FILE		"./freop-d.21.2/freop-t.21.2"

/* sync points */
#define SP_T21_MKDIR2_START	MK_SPNO(0)
#define SP_T21_MKDIR2_END	MK_SPNO(1)
#define SP_T21_RMDIR2_START	MK_SPNO(2)
#define SP_T21_RMDIR2_END	MK_SPNO(3)


/*
**	test22
*/

/* files and directories */
#define T22_2_DIR		"./freop-d.22.2"
#define T22_2_FILE		"./freop-t.22.2"
#define T22A_2_FILE		"./freop-d.22.2/freop-t.22.2"

/* sync points */
#define SP_T22_MKDIR2_START	MK_SPNO(0)
#define SP_T22_MKDIR2_END	MK_SPNO(1)
#define SP_T22_RMDIR2_START	MK_SPNO(2)
#define SP_T22_RMDIR2_END	MK_SPNO(3)


/*
**	test36
*/

/* sync points */
#define SP_T36_RTIME_START	MK_SPNO(0)


/*
**	test 42
*/

/* files and directories */
#define T42_MNT			"./freop-m.42"
#define T42_FILE		"./freop-m.42/freop-f.42"


/*
**	test 43
*/

/* files and directories */
#define T43_FILE		"./freop-f.43";

/*
**	test 49
*/

#define	T49_FILE		"./freop-f.49"

#define SP_T49_WRITE_START      MK_SPNO(0)
#define SP_T49_WRITE_END        MK_SPNO(1)

#endif /* TEST_XNFS */

