/*
*      SCCS:  @(#)  ANSI.os/streamio/ftell/ftell_t4.c	Rel 4.4.1     (06/09/97) 
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)ANSI.os/streamio/ftell - ftell_t4 Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN	*/
#endif  /* lint	*/

/***********************************************************************

NAME:		ftell_t4.c - used in ftell() testset to test ftell()
		of a stream returned by popen.

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	main()
SYNOPSIS:
DESCRIPTION:
	Called in deviance section of the ftell() testset.  This program
	sits and waits for a file to be removed and then exits.  There
	is also a timeout.
	Usage:
		ftell_t4

RELATED DOCUMENTS:
	ftell.c

AUTHOR:		Mike Rendell, UniSoft Ltd.
DATE CREATED:	Fri Nov 28 20:04:22 WET 1986
MODIFICATIONS:
		Stuart Boutell, 30 Nov 1990
			Removed all tet references & reporting

************************************************************************/
#include	<std.h>
#include	<stdlib.h>
#include	<errno.h>
#include	<sys/types.h>
#include	<signal.h>
#include	<exitcodes.h>
#include	<unistd.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef ftell
#endif


#define	WAITTIME	(5 * SPEEDFACTOR)

extern	void		(*vsignal())();

private	void		leave();

private	char	*t4_file =	"./ftell-t.4";

int
main()
{
	int	rval;

	(void) vsignal(SIGALRM, leave);
	(void) alarm((unsigned) WAITTIME);
	do {
		errno = 0;
		rval = access(t4_file, F_OK);
	} while (rval != SYSERROR && errno != ENOENT);
	exit(SUCCEED);
	/* for lint */
	return 0;
}


private	void
leave()
{
	exit(A_MISC);
}
