/*
 *      SCCS: @(#)  ANSI.os/streamio/getc/getc_h.h Rel 4.4.1 (06/09/97)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

/***********************************************************************

NAME:		getc_h.h

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION:	Definitions common to master and slave side of the fgetc,
		gettchar and getc test sets.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		John-Paul, UniSoft Ltd.
DATE CREATED:	9 October 1992
MODIFICATIONS:
		Geoff Clare, 29 Oct 1993
			Added T4_*

************************************************************************/

#if TEST_XNFS

/* Data */
#define ONE_BYTE_STR	"x"
#define ONE_BYTE_CHAR	'x'
#define	ONE_BYTE_LENGTH	1

#define NUM_INITGET	5

/* files and directories */
#define T4_FILE			"./getc-t.4"
#define T12_FILE		"./getc-t.12"
#define T13_FILE		"./getc-t.13"

/* Test 4 sync points */
#define SP_T4_CREAT_END		MK_SPNO(0)
#define SP_T4_UNLINK_START	MK_SPNO(1)

/* Test 12 sync points */
#define SP_T12_EACCES 		MK_SPNO(0)

/* Test 13 sync points */
#define SP_T13_ESTALE		MK_SPNO(0)

#endif /* TEST_XNFS */
