/*
*      SCCS:  @(#)  ANSI.os/streamio/printf/local.h	Rel 4.4.1	    (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

/***********************************************************************

NAME:		local.h

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Local include file for the printf testset.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Geoff Clare, UniSoft Ltd.
DATE CREATED:	25 May 1989
MODIFICATIONS:
		Geoff Clare, April 1997
		Added tests for snprintf() in UNIX98 mode.

************************************************************************/

#define		WAITTIME	(5 * SPEEDFACTOR)
#define		I_PR		0	/* interface is printf */
#define		I_FP		1	/* interface is fprintf */
#define		I_SP		2	/* interface is sprintf */
#if TEST_XPG >= 500
#  define	I_SNP		3	/* interface is snprintf */
#endif
#define		P_RD		0	/* read file descriptor of pipe */
#define		P_WR		1	/* write file descriptor of pipe */
#define		E_FAIL		101	/* `test failed' exit code */
#define		E_PUTC		102	/* fputc call failed */
#define		E_PUTS		103	/* fputs call failed */
#define		E_GETS		104	/* fgets call failed */
#define		E_FDOPEN	105	/* fdopen call failed */
#define		E_FCLOSE	106	/* fclose call failed */
#define		E_LOCFAIL	107	/* setlocale call failed */
#define		BUFFERSIZE	512	/* size of array buf[] */
#define		EXPSIZE		512	/* size of regexp buffer */

/* use " _ " to separate PRINTIT arguments */
#define _ ,

#if TEST_XPG >= 500
#  define PRINTIT(args)  \
	switch ( interface ) \
	{ \
	case I_PR: \
		tretval = printf(args); \
		break; \
	case I_FP: \
		tretval = fprintf(f_wr, args); \
		break; \
	case I_SP: \
		tretval = sprintf(buf, args); \
		if ( fputs(buf, f_wr) == EOF ) \
			DBUG_EXIT(E_PUTS); \
		break; \
	case I_SNP: \
		tretval = snprintf(buf, sizeof buf, args); \
		if ( fputs(buf, f_wr) == EOF ) \
			DBUG_EXIT(E_PUTS); \
		break; \
	};
#else
#  define PRINTIT(args)  \
	switch ( interface ) \
	{ \
	case I_PR: \
		tretval = printf(args); \
		break; \
	case I_FP: \
		tretval = fprintf(f_wr, args); \
		break; \
	case I_SP: \
		tretval = sprintf(buf, args); \
		if ( fputs(buf, f_wr) == EOF ) \
			DBUG_EXIT(E_PUTS); \
		break; \
	};
#endif

#define	GETBUF	if (fgets(buf, sizeof(buf), f_rd) == NULL) \
		{ \
			if (testfail++ == 0) \
				xx_rpt(DELETION); \
			in_rpt("deletion reason: fgets() failed to read data from pipe"); \
			DBUG_VOID_RETURN; \
		}

