/*
 *      SCCS: @(#)  ANSI.os/streamio/remove/remove_h.h Rel 4.4.1 (06/09/97)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

/***********************************************************************

NAME:		remove_h.h

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION:
	Definitions common to master and slave side of the remove test set.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		John-Paul, UniSoft Ltd.
DATE CREATED:	16 November 1992
MODIFICATIONS:

************************************************************************/

#if TEST_XNFS

#define NOK             02
#define PATH_OK         04

/*
**	test4
*/

/* sync points */
#define SP_T4_RTIME_START	MK_SPNO(0)

/*
**	test5
*/

/* sync points */
#define SP_T5_RTIME_START	MK_SPNO(0)

/*
**	test7
*/

/* sync points */
#define SP_T7_RTIME_START	MK_SPNO(0)

/*
**	test8
*/

/* sync points */
#define SP_T8_DO_ACCESS1	MK_SPNO(0)
#define SP_T8_DO_ACCESS2	MK_SPNO(1)
/* XXX
#define SP_T8_RTIME_START	MK_SPNO(2)
*/

/*
**	test9
*/

/* files and directories */
#define T9_2_DIR		"./remove-d.9.2"
#define T9_2_FILE		"./remove-d.9.2/remove-t.9.2"

/* sync points */
#define SP_T9_MKDIR2_START	MK_SPNO(0)
#define SP_T9_MKDIR2_END	MK_SPNO(1)
#define SP_T9_RMDIR2_START	MK_SPNO(2)
#define SP_T9_RMDIR2_END	MK_SPNO(3)


/*
**	test10
*/

/* files and directories */
#define T10_2_DIR		"./remove-d.10.2"
#define T10_2_FILE		"./remove-d.10.2/remove-t.10.2"

/* sync points */
#define SP_T10_MKDIR2_START	MK_SPNO(0)
#define SP_T10_MKDIR2_END	MK_SPNO(1)
#define SP_T10_RMDIR2_START	MK_SPNO(2)
#define SP_T10_RMDIR2_END	MK_SPNO(3)


/*
**	test 38
*/

/* files and directories */
#define T38_MNT			"./remove-m.38"
#define T38_DIR			"./remove-m.38/remove-d.38"
#define T38_FILE		"./remove-m.38/remove-d.38/remove-f.38"


/*
**	test 39
*/

/* files and directories */
#define T39_DIR			"./remove-d.39";
#define T39_FILE		"./remove-d.39/remove-f.39";

#else /* TEST_XNFS */

#define SP_T8_DO_ACCESS1	0	/* dummy value to pass to do_access() */
#define SP_T8_DO_ACCESS2	0

#endif /* TEST_XNFS */

