/*
*      SCCS:  @(#)  ANSI.os/string/memchr_X/memchr_X.c	Rel 4.4.1	    (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)ANSI.os/string/memchr_X - T.memchr_X Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		T.memchr_X

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Testset for the memchr() system call.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		David McCardle, UniSoft Ltd.
DATE CREATED:	Thu Oct 23 10:10:21 PDT 1986
MODIFICATIONS:	Andrew Twigger 09 June 87
		Removed testid()
		Modified xx_rpt(), xs_rpt()

		David Sawyer 03 July 1990
		Added resillience code

		Stuart Boutell, 3 May 1991
			Improved testing, by using strings containing
		a '\0' character

************************************************************************/
#include	<std.h>
#include	<dbug.h>
#include	<report.h>
#include	<string.h>
#include	<sys/types.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef memchr
#endif


#define NO_TESTS	2		/* number of tests in testset */

int	no_tests = NO_TESTS;

private char	s[20];

private void	preparetests();
private void	test1();
private void	test2();

public	void	(*setfunc) () = preparetests;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	 test2, 2,
	NULL, 0
};

extern	char	*pr_nchars();

private void
preparetests()
{
	int	i;
	char	alpha;

	DBUG_ENTER("preparetests");
	for (i = 0, alpha = 'a'; i < 19; i++)
		if (i == 3 || i == 8 || i == 16)
			s[i] = alpha;
		else
		if (i==1)
			s[i] = '\0';
		else
			s[i] = '1';
	s[19] = '\0';

#ifdef	TESTBED
	s[2]=alpha;
#endif
	DBUG_PRINTF("preparetests", "s :%s:", pr_nchars(s,20));
	DBUG_VOID_RETURN;
}


private void
test1()
{
	int	num = 15;
	char	alpha = 'a', *rval;
	int 	pathok = 0;

	DBUG_ENTER("test1");
	DBUG_PRINTF("test1", "s :%s:", pr_nchars(s,20));

	if ((rval = (char *)memchr((void *)s, alpha, (size_t)num)) != &s[3])
	{
		xx_rpt(FAILURE);
		in_rpt("memchr did not return expected value");
		in_rpt("pointer & value of first  argument : %p\t%s",
			(void *)s, pr_nchars((char *)s,20));
		in_rpt("value   of second argument : %c", alpha);
		in_rpt("value   of third  argument : %d", num);
		in_rpt("expected return value      : %p", (void *)&s[3]);
		in_rpt("actual   return value      : %p", (void *)rval);
	}
	else
	{
		PATH_TRACE;
		PATH_XS_RPT(1);
	}
	DBUG_VOID_RETURN;
}


private void
test2()
{
	int	num = 3;
	char	alpha = 'a', *rval;
	int	pathok = 0;

	DBUG_ENTER("test2");
	DBUG_PRINTF("test2", "s :%s:", pr_nchars(s,20));

	if ((rval = (char *)memchr((void *)s, alpha, (size_t)num)) != NULL)
	{
		xx_rpt(FAILURE);
		in_rpt("memchr did not return expected value");
		in_rpt("pointer & value of first  argument : %p\t%s",
					(void *) s, pr_nchars((char*)s, 20));
		in_rpt("value   of second argument : %c", alpha);
		in_rpt("value   of third  argument : %d", num);
		if (rval != NULL)
		{
			in_rpt("expected return value      : %p (NULL)",
				(void *)NULL);
			in_rpt("actual   return value      : %p", rval);
		}
	}
	else
	{
		PATH_TRACE;
		PATH_XS_RPT(1);
	}
	DBUG_VOID_RETURN;
}
