/*
*      SCCS:  @(#)  ANSI.os/string/memcpy_X/memcpy_X.c	Rel 4.4.1	    (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)ANSI.os/string/memcpy_X - T.memcpy_X Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		T.memcpy_X

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Testset for the memcpy() system call.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		David McCardle, UniSoft Ltd.
DATE CREATED:	Thu Oct 23 12:31:35 PDT 1986
MODIFICATIONS:	Andrew Twigger 09 June 87
		Removed	testid()
		Modified xx_rpt(), xs_rpt()

		David Sawyer 03 July 1990
		Added resillience code

		Geoff Clare, 30 Jan 1991
			Cast pointers to long for printing.

		Stuart Boutell, 3 May 1991
			Improved testing using \0 in memory.

************************************************************************/
#include	<std.h>
#include	<dbug.h>
#include	<report.h>
#include	<string.h>
#include	<sys/types.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef memcpy
#endif


#define NO_TESTS	1		/* number of tests in testset */
#define SPACE		' '		/* space character */

int	no_tests = NO_TESTS;

private void	test1();

public	void	(*setfunc) () = NULL;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	NULL, 0
};

extern	char	*pr_nchars();

private void
test1()
{
	int	i, num = 15;
	char	s1[20], s2[20], t[20], alpha, *rval;
	int	failed1 = 0, failed2 = 0;
	int	pathok = 0;

	DBUG_ENTER("test1");

	for (i = 0, alpha = 'a'; i < 17; ++i, (i == 12) ? (alpha -= 2) : alpha++)
	{
		if (i==0)
			PATH_TRACE;
		if (i!=10)
			s2[i] = t[i] = alpha;
		else
			s2[i] = t[i] = '\0';

		s1[i] = SPACE;
	}
	for (i = 17; i < 19; i++)
	{
		if (i==17)
			PATH_TRACE;
		s2[i] = '\0';
		s1[i] = SPACE;
	}

	s1[19] = '\0';
	if ((rval = (char *)memcpy((void *)s1, (void *)s2, (size_t)num)) != s1)
	{
		++failed1;
	}
	else
		PATH_TRACE;
	for (i = 0; i < 15; i++)
		if (s1[i] != t[i])
		{
			++failed2;
			break;
		}
		else
			PATH_TRACE;
	for (i = 15; i < 19; i++)
		if (s1[i] != SPACE)
		{
			++failed2;
			break;
		}
		else
			PATH_TRACE;
	if (s1[19] != '\0')
		++failed2;
	else
		PATH_TRACE;
	DBUG_PRINTF("test1", "s1 :%s:\ts2 :%s:", pr_nchars(s1,20),
						 pr_nchars(s2,20));
	DBUG_PRINTF("test1", "failed1 :%d:\tfailed2 :%d:", failed1, failed2);

#ifdef TESTBED
	failed2++;
	failed1++;
#endif

	if (failed1 || failed2)
	{
		xx_rpt(FAILURE);

		if (failed1)
		{
			in_rpt("memcpy did not return expected value");
			in_rpt("pointer & value of first  argument : %p\t|%s|",
				(void *)s1, pr_nchars(s1,20));
			in_rpt("pointer & value of second argument : %p\t|%s|",
				(void *)s2, pr_nchars(s2,20));
			in_rpt("value of third argument            : %d", num);
			if (rval != s1)
			{
				in_rpt("expected return value      : %p",
					(void *)s1);
				in_rpt("actual   return value      : %p",
					(void *)rval);
			}
		}
		if (failed2)
		{
			in_rpt("memcpy did did not copy data correctly");
			in_rpt("expected result from memcpy() : |%s    \\000|",
							pr_nchars(t, 15));
			in_rpt("actual   result from memcpy() : |%s|",
							pr_nchars(s1,20));
		}

	}
	else
		PATH_XS_RPT(23);

	DBUG_VOID_RETURN;
}
