/*
*      SCCS:  @(#)  ANSI.os/string/memset_X/memset_X.c	Rel 4.4.1	    (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)ANSI.os/string/memset_X - T.memset_X Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		T.memset_X

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Testset for the memset() system call.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		David McCardle, UniSoft Ltd.
DATE CREATED:	Thu Oct 23 14:14:22 PDT 1986
MODIFICATIONS:	Andrew Twigger 09 June 87
		Removed	testid()
		Modified xx_rpt(), xs_rpt()

		David Sawyer 03 July 1990
		Added resillience code

		Geoff Clare, 17 June 1991
			Print pointers using %p instead of %ld

************************************************************************/
#include	<std.h>
#include	<dbug.h>
#include	<report.h>
#include	<string.h>
#include	<sys/types.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef memset
#endif


#define NO_TESTS	1		/* number of tests in testset */
#define SPACE		' '		/* space character */

int	no_tests = NO_TESTS;

private void	test1();

public	void	(*setfunc) () = NULL;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	NULL, 0
};

private void
test1()
{
	int	i, num = 15;
	char	s[20], t[20], one = '1', *rval;
	int	failed1 = 0, failed2 = 0;
	int	pathok = 0;

	DBUG_ENTER("test1");

	for (i = 0; i < 19; ++i)
	{
		if (i==0)
			PATH_TRACE;
		s[i] = t[i] = SPACE;
	}
	s[i] = t[i] = '\0';

	if ((rval = (char *)memset((void *)s, one, (size_t)num)) != s)
	{
		++failed1;
	}
	else
		PATH_TRACE;
	for (i = 0; i < 15; i++)
		if (s[i] != one)
		{
			++failed2;
			break;
		}
		else
			PATH_TRACE;
	for (i = 15; i < 19; i++)
		if (s[i] != SPACE)
		{
			++failed2;
			break;
		}
		else
			PATH_TRACE;
	if (s[19] != '\0')
		++failed2;
	else
		PATH_TRACE;
	DBUG_PRINTF("test1", "s :%s:", s);
	DBUG_PRINTF("test1", "failed1 :%d:\tfailed2 :%d:", failed1, failed2);

	if (failed1 || failed2)
	{
		xx_rpt(FAILURE);

		if (failed1)
		{
			in_rpt("memset did not return expected value");
			in_rpt("pointer & value of first  argument : %p\t|%s|",
				(void *)s, t);
			in_rpt("value of second argument           : %c", one);
			in_rpt("value of third  argument           : %d", num);
			if (rval != s)
			{
				in_rpt("expected return value      : %p",
					(void *)s);
				in_rpt("actual   return value      : %p",
					(void *)rval);
			}
		}
		if (failed2)
		{
			in_rpt("memset did did not copy data correctly");
			in_rpt("expected result from memset() : |111111111111111    |");
			in_rpt("actual   result from memset() : |%s|", s);
		}

	}
	else
		PATH_XS_RPT(22);

	DBUG_VOID_RETURN;
}
