/*
*      SCCS:  @(#)  ANSI.os/string/strcspn/strcspn.c	Rel 4.4.1	    (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)ANSI.os/string/strcspn - T.strcspn Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		T.strcspn

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Testset for the strcspn() system call.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		David McCardle, UniSoft Ltd.
DATE CREATED:	Wed Oct 22 09:39:29 PDT 1986
MODIFICATIONS:	Andrew Twigger 10 June 87
		Removed	testid()
		Modified xx_rpt(), xs_rpt()

		David Sawyer
		Wed Jul 04 09:43:45 BST 1990
		Added resillience code

		Geoff Clare, 4 Nov 1991
		Reverse checkval() "expected" and "actual" arguments

		Neil Moses, 10 Dec 1991
		Changed %ld to 0x%lx, and cast pointer arg to long

		Geoff Clare, 23 June 1992
		Changed so as not to write to string literal.

		Geoff Clare, 22 Aug 1995
			Removed ASCII dependencies.

************************************************************************/
#include	<std.h>
#include	<dbug.h>
#include	<report.h>
#include	<string.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef strcspn
#endif


#define NO_TESTS	1		/* number of tests in testset */

extern	char	*psl_to_asc();

int	no_tests = NO_TESTS;

private	int	testfail;

private void	test1();
private void	checkval();

public	void	(*setfunc) () = NULL;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	NULL, 0
};


private void
test1()
{
	int	rval;
	static char	s[20] = "abcdabcdabcdabcdefg";
	static char	set[3][20] = { "lmnopqrexyz", "lmdopqrexyz", "" };
	unsigned char	*us = (unsigned char *)s;
	unsigned char	*uset1 = (unsigned char *)set[1];
	int	pathok = 0;

	DBUG_ENTER("test1");

	testfail = 0;

	rval = strcspn(s, set[0]);
	globok = 0;
	checkval(s, set[0], 16, rval);
	PATH_FUNC_TRACE;

	rval = strcspn(s, set[1]);
	globok = 0;
	checkval(s, set[1], 3, rval);
	PATH_FUNC_TRACE;

	rval = strcspn(s, set[2]);
	globok = 0;
	checkval(s, set[2], 19, rval);
	PATH_FUNC_TRACE;

	us[3] ^= 0200;

	rval = strcspn(s, set[1]);
	globok = 0;
	checkval(s, set[1], 7, rval);
	PATH_FUNC_TRACE;

	uset1[2] ^= 0200;

	rval = strcspn(s, set[1]);
	globok = 0;
	checkval(s, set[1], 3, rval);
	PATH_FUNC_TRACE;

	if (!testfail);
		PATH_XS_RPT(5);

	DBUG_VOID_RETURN;
}

private void
checkval(str1, str2, expval, retval)
char *str1, *str2;
int  expval, retval;
{
	int	pathok = 0;

	DBUG_ENTER("checkval");

	globok = 0;

	if (retval != expval)
	{
		if (!testfail++)
			xx_rpt(FAILURE);
		in_rpt("strcspn did not return expected value");
		in_rpt("pointer & value of first  argument : 0x%lx\t%s",
			(long) str1, psl_to_asc(str1, 0));
		in_rpt("value   of second argument : %s", psl_to_asc(str2, 0));
	        in_rpt("expected return value      : %d", expval);
	        in_rpt("actual   return value      : %d", retval);
	}
	else
	{
		PATH_TRACE;
		globok = 1;
	}

	DBUG_VOID_RETURN;
}

