/*
*      SCCS:  @(#)  ANSI.os/string/strlen/strlen.c	Rel 4.4.1	    (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)ANSI.os/string/strlen - T.strlen Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		T.strlen

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Testset for the strlen() system call.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		David McCardle, UniSoft Ltd.
DATE CREATED:	Tue Oct 21 17:20:16 PDT 1986
MODIFICATIONS:	Andrew Twigger 10 June 87
		Removed	testid()
		Modified xx_rpt(), xs_rpt()

		David Sawyer
		Wed Jul 04 12:48:10 BST 1990
		Added resillience code

************************************************************************/
#include	<std.h>
#include	<dbug.h>
#include	<report.h>
#include	<string.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef strlen
#endif


#define NO_TESTS	1		/* number of tests in testset */

extern	char	*psl_to_asc();

int	no_tests = NO_TESTS;

private char	s1[] = "12345678901234567";
private int	testfail;

private void	test1();
private void	checkval();

public	void	(*setfunc) () = NULL;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	NULL, 0
};

private void
test1()
{
	int	rval;
	int	pathok = 0;

	DBUG_ENTER("test1");

	testfail = 0;
	rval = strlen(s1);
	globok = 0;
	checkval("strlen", s1, rval, 17);
	PATH_FUNC_TRACE;

	s1[0] = 0200;
	s1[3] |= 0200;
	s1[10] = '\0';

	rval = strlen(s1);
	globok = 0;
	checkval("strlen", s1, rval, 10);
	PATH_FUNC_TRACE;

	if (!testfail)
		PATH_XS_RPT(2);

	DBUG_VOID_RETURN;
}

private void
checkval(name, str1, retval, expval)
char *name, *str1;
int retval, expval;
{
	int 	pathok = 0;

	DBUG_ENTER("checkval");

	globok = 0;

	if (retval != expval)
	{
		if (!testfail++)
			xx_rpt(FAILURE);

		in_rpt("%s did not return expected value", name);
		in_rpt("value of argument : %s", psl_to_asc(str1, 0));
		in_rpt("expected return value      : %d", expval);
		in_rpt("actual   return value      : %d", retval);
	}
	else
	{
		PATH_TRACE;
		globok = 1;
	}

	DBUG_VOID_RETURN;
}
