/*
*      SCCS:  @(#)  ANSI.os/time/asctime/asctime.c	Rel 4.4.1	    (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)ANSI.os/time/asctime - T.asctime Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		T.asctime

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Testset for the asctime() system call.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Alex Flynn, UniSoft Ltd.
DATE CREATED:	Mon Nov 10 16:03:05 WET 1986

MODIFIED:	Linda Taylor, Hoskyns, 	August 1988
			Split out from ctime testset.

		Peter Lee, Unisoft Ltd., Thu Jul 05 17:07:12 BST 1990
		Added resilience code.

		Geoff Clare, 16 June 1993
			Rename clock variable to clockval.

************************************************************************/
#include	<std.h>
#include	<string.h>
#include	<dbug.h>
#include	<report.h>
#include	<sys/types.h>
#include	<ctype.h>
#include	<time.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef asctime
#endif


#define 	NO_TESTS	1		/* number of tests in testset */
#define		WAITTIME	(5 * SPEEDFACTOR)

extern	char		*psl_to_asc();

int	no_tests = NO_TESTS;

/* 	expected format of string returned by ctime():	*/
private	char	ctime_fmt[] = "ccc ccc dd dd:dd:dd dddd\n";

private int	testfail;

private void	test1();

public	void	(*setfunc) () = NULL;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	NULL, 0
};

private void
test1()
{
	char	*ascstr;
	int	asclen;
	int	i;
	time_t	clockval = 530454574L;  
	int	pathok = 0;

	DBUG_ENTER("test1");

	ascstr = asctime( localtime(&clockval) );
#ifdef TESTBED
	ascstr = "Sun Sep xx 01:03:52 1973\n";
#endif
	if ((asclen = strlen(ascstr)) != 25 )
	{
		xx_rpt(FAILURE);
		in_rpt("string returned by asctime() was %d chars long instead of 25", asclen);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	for (i = 0; ctime_fmt[i] != '\0'; i++)
	{
		switch(ctime_fmt[i])
		{
		case 'c':
			if ( ! isalpha(ascstr[i]) )
				testfail++;
			else
				PATH_TRACE;
			break;

		case 'd':
			if ( ! isdigit(ascstr[i]) )
				testfail++;
			else
				PATH_TRACE;
			break;

		default:
			if ( ascstr[i] != ctime_fmt[i] )
				testfail++;
			else
				PATH_TRACE;
			break;
		}
	}

	if (testfail)
	{
		xx_rpt(FAILURE);
		in_rpt("string returned by asctime(localtime(530454574L)) was %s", psl_to_asc(ascstr, 0));
		in_rpt("should be of form Sun Sep 16 01:03:52 1973\\n");
	}
	else
		PATH_XS_RPT(1 + i);
	
	DBUG_VOID_RETURN;
}
