#!/bin/sh
# dev-tc.sh : test case for Linux Annex /dev   directory

##########################################################################
# (C) Copyright 1998-2001 The Open Group
#
# All rights reserved.  No part of this source code may be reproduced,
# stored in a retrieval system, or transmitted, in any form or by any
# means, electronic, mechanical, photocopying, recording or otherwise,
# except as stated in the end-user licence agreement, without the prior
# permission of the copyright owners.
#
# X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
# the UK and other countries.
#
#	PROJECT:	LSB-FHS
#	PRODUCT:	LSB.fhs/linux/dev/dev-tc.sh
#	AUTHOR:		Andrew Josey, The Open Group
#	DATE CREATED:	21 Dec 1998
##########################################################################


# This is 1.3
#
# dev-tc.sh,v
# Revision 1.3  2000/04/23 14:13:30  cyeoh
# Update tests for 6.1.3-(19/20/21) to accept links to fd/X since
# /dev/fd is a symlink to /proc/self/fd (tested in 6.1.3-18)
#
# Revision 1.2  2000/04/09 06:31:53  cyeoh
# Add CVS header information
#
#

tet_startup="startup"			# startup function
tet_cleanup="cleanup"			# cleanup function
iclist="ic1 ic2 ic3 ic4 ic5 ic6 ic7 ic8 ic9 ic10 ic11 ic12 ic13 ic14 ic15 ic16 ic17 ic18 ic19 ic20 ic21 ic22 ic23 ic24 ic25 ic26 ic27 ic28 ic29"
ic1="tp1"
ic2="tp2"
ic3="tp3"
ic4="tp4"
ic5="tp5"
ic6="tp6"
ic7="tp7"
ic8="tp8"
ic9="tp9"
ic10="tp10"
ic11="tp11"
ic12="tp12"
ic13="tp13"
ic14="tp14"
ic15="tp15"
ic16="tp16"
ic17="tp17"
ic18="tp18"
ic19="tp19"
ic20="tp20"
ic21="tp21"
ic22="tp22"
ic23="tp23"
ic24="tp24"
ic25="tp25"
ic26="tp26"
ic27="tp27"
ic28="tp28"
ic29="tp29"


tp1()
{
	tpstart "Reference 6.1.3-1(A)"
	tet_infoline "The /dev/mem  device exists with"
	tet_infoline "major number 1 and minor number 1"
	lsb_test_device_by_name /dev/mem c 1 1 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult				# set result code
}

tp2()
{
	tpstart "Reference 6.1.3-2(A)"
	tet_infoline "The /dev/kmem  device exists with"
	tet_infoline "major number 1 and minor number 2"
	lsb_test_device_by_name /dev/kmem c 1 2 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult			# set result code
}
tp3()
{
	tpstart "Reference 6.1.3-3(A)"
	tet_infoline "The /dev/null  device exists with"
	tet_infoline "major number 1 and minor number 3"
	lsb_test_device_by_name /dev/null c 1 3 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult			# set result code
}
tp4()
{
	tpstart "Reference 6.1.3-4(A)"
	tet_infoline "The /dev/port  device exists with"
	tet_infoline "major number 1 and minor number 4"
	lsb_test_device_by_name /dev/port c 1 4 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult			# set result code
}
tp5()
{
	tpstart "Reference 6.1.3-5(A)"
	tet_infoline "The /dev/zero  device exists with"
	tet_infoline "major number 1 and minor number 5"
	lsb_test_device_by_name /dev/zero c 1 5 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult			# set result code
}
tp6()
{
	tpstart "Reference 6.1.3-6(A)"
	tet_infoline "The /dev/full  device exists with"
	tet_infoline "major number 1 and minor number 7"
	lsb_test_device_by_name /dev/full c 1 7 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult			# set result code
}
tp7()
{
	tpstart "Reference 6.1.3-7(A)"
	tet_infoline "The /dev/full  device exists with"
	tet_infoline "major number 1 and minor number 7"
	lsb_test_device_by_name /dev/full c 1 7 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult			# set result code
}
tp8()
{
	tpstart "Reference 6.1.3-8(A)"
	tet_infoline "The /dev/random  device exists with"
	tet_infoline "major number 1 and minor number 8"
	lsb_test_device_by_name /dev/random c 1 8 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult			# set result code
}
tp9()
{
	tpstart "Reference 6.1.3-9(A)"
	tet_infoline "The /dev/urandom  device exists with"
	tet_infoline "major number 1 and minor number 9"
	lsb_test_device_by_name /dev/urandom c 1 9 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult			# set result code
}
tp10()
{
	tpstart "Reference 6.1.3-10(A)"
	tet_infoline "The /dev/ram0  device exists with"
	tet_infoline "major number 1 and minor number 0"
	lsb_test_device_by_name /dev/ram0 b 1 0 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	tet_infoline "The /dev/ram1  device exists with"
	tet_infoline "major number 1 and minor number 1"
	lsb_test_device_by_name /dev/ram1 b 1 1 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	tet_infoline "The /dev/ram2  device exists with"
	tet_infoline "major number 1 and minor number 2"
	lsb_test_device_by_name /dev/ram2 b 1 2 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	tet_infoline "The /dev/ram3  device exists with"
	tet_infoline "major number 1 and minor number 3"
	lsb_test_device_by_name /dev/ram3 b 1 3 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	tet_infoline "The /dev/ram4  device exists with"
	tet_infoline "major number 1 and minor number 4"
	lsb_test_device_by_name /dev/ram4 b 1 4 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	tet_infoline "The /dev/ram5  device exists with"
	tet_infoline "major number 1 and minor number 5"
	lsb_test_device_by_name /dev/ram5 b 1 5 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	tet_infoline "The /dev/ram6  device exists with"
	tet_infoline "major number 1 and minor number 6"
	lsb_test_device_by_name /dev/ram6 b 1 6 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	
	tet_infoline "The /dev/ram7  device exists with"
	tet_infoline "major number 1 and minor number 7"
	lsb_test_device_by_name /dev/ram7 b 1 7 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult			# set result code
}

tp11()
{
	tpstart "Reference 6.1.3-11(A)"
	tet_infoline "The /dev/tty  device exists with"
	tet_infoline "major number 5 and minor number 0"
	lsb_test_device_by_name /dev/tty c 5 0 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult			# set result code
}
tp12()
{
	tpstart "Reference 6.1.3-12(A)"
	tet_infoline "The /dev/console  device exists with"
	tet_infoline "major number 5 and minor number 1"
	tet_infoline "(kernel releases 2.1.71 and later)"
	release=`uname -r`
	releasemajor=`echo $release |cut -f1 -d"."`
	releaseminor=`echo $release|cut -f2 -d"."`
	releasedot=`echo $release|cut -f3 -d"."`
	if ! test "$releasemajor" = "2"
	then
		tet_infoline "Kernel version != 2.x"
		tpresult UNSUPPORTED
		return
	fi
	if test "$releaseminor" = "0"
	then
		tet_infoline "Kernel version = 2.0.x"
		tpresult UNSUPPORTED
		return
	fi
	
	lsb_test_device_by_name /dev/console c 5 1 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult			# set result code
}
tp13()
{
	tpstart "Reference 6.1.3-13(A)"
	tet_infoline "The /dev/ptmx  device exists with"
	tet_infoline "major number 5 and minor number 2"
	lsb_test_device_by_name /dev/ptmx c 5 2 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult			# set result code
}
tp14()
{
	tpstart "Reference 6.1.3-14(A)"
	tet_infoline "The /dev/pts  directory exists"
	lsb_test_dir /dev/pts 
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult			# set result code
}
tp15()
{
	tpstart "Reference 6.1.3-15(A)"
	tet_infoline "The /dev/tty0  device exists with"
	tet_infoline "major number 4 and minor number 0"
	lsb_test_device_by_name /dev/tty0 c 4 0 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult			# set result code
}
tp16()
{
	tpstart "Reference 6.1.3-16(A)"
	tet_infoline "The /dev/vcs  device exists with"
	tet_infoline "major number 7 and minor number 0"
	lsb_test_device_by_name /dev/vcs c 7 0 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult			# set result code
}

tp17()
{
	tpstart "Reference 6.1.3-17(A)"
	tet_infoline "The /dev/vcsa  device exists with"
	tet_infoline "major number 7 and minor number 128"
	lsb_test_device_by_name /dev/vcsa c 7 128 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult			# set result code
}

tp18()
{
	tpstart "Reference 6.1.3-18(A)"
	tet_infoline "The symbolic link /dev/fd exists and"
	tet_infoline "points to /proc/self/fd"
	ls -l /dev/fd > out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_stdout /proc/self/fd	# should be stdout
	check_nostderr			# should be no stderr
	tpresult
}

tp19()
{
	tpstart "Reference 6.1.3-19(A)"
	tet_infoline "The symbolic link /dev/stdin exists and"
	tet_infoline "points to /proc/self/fd/0"
	ls -l /dev/stdin > out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_stdout fd/0	        # should be stdout
	check_nostderr			# should be no stderr
	tpresult
}


tp20()
{
	tpstart "Reference 6.1.3-20(A)"
	tet_infoline "The symbolic link /dev/stdout exists and"
	tet_infoline "points to /proc/self/fd/1"
	ls -l /dev/stdout > out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_stdout fd/1	        # should be stdout
	check_nostderr			# should be no stderr
	tpresult
}

tp21()
{
	tpstart "Reference 6.1.3-21(A)"
	tet_infoline "The symbolic link /dev/stderr exists and"
	tet_infoline "points to /proc/self/fd/2"
	ls -l /dev/stderr > out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_stdout fd/2	        # should be stdout
	check_nostderr			# should be no stderr
	tpresult
}

tp22()
{
	tpstart "Reference 6.1.3-22(A)"
	tet_infoline "The /dev/tty1  device exists with"
	tet_infoline "major number 4 and minor number 1"
	lsb_test_device_by_name /dev/tty1 c 4 1 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult			# set result code
}

tp23()
{
	tpstart "Reference 6.1.3-23(A)"
	tet_infoline "The devices /dev/vcs1 ... /dev/vsc12 exist with"
	tet_infoline "major number 7 and minor number 1 .. 12 respectively"
	lsb_test_device_by_name /dev/vcs1 c 7 1 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	lsb_test_device_by_name /dev/vcs2 c 7 2 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	lsb_test_device_by_name /dev/vcs3 c 7 3 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	lsb_test_device_by_name /dev/vcs4 c 7 4 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr


	lsb_test_device_by_name /dev/vcs5 c 7 5 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	lsb_test_device_by_name /dev/vcs6 c 7 6 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	lsb_test_device_by_name /dev/vcs7 c 7 7 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	lsb_test_device_by_name /dev/vcs8 c 7 8 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	lsb_test_device_by_name /dev/vcs9 c 7 9 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	lsb_test_device_by_name /dev/vcs10 c 7 10 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	lsb_test_device_by_name /dev/vcs11 c 7 11 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	lsb_test_device_by_name /dev/vcs12 c 7 12 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult
}

tp24()
{
	tpstart "Reference 6.1.3-24(A)"
	tet_infoline "The devices /dev/vcsa1 ... /dev/vsc12 exist with"
	tet_infoline "major number 7 and minor number 129 .. 140 respectively"

	lsb_test_device_by_name /dev/vcsa1 c 7 129 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	lsb_test_device_by_name /dev/vcsa2 c 7 130 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	lsb_test_device_by_name /dev/vcsa3 c 7 131 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	lsb_test_device_by_name /dev/vcsa4 c 7 132 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	lsb_test_device_by_name /dev/vcsa5 c 7 133 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	lsb_test_device_by_name /dev/vcsa6 c 7 134 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	lsb_test_device_by_name /dev/vcsa7 c 7 135 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	lsb_test_device_by_name /dev/vcsa8 c 7 136 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	lsb_test_device_by_name /dev/vcsa9 c 7 137 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	lsb_test_device_by_name /dev/vcsa10 c 7 138 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	lsb_test_device_by_name /dev/vcsa11 c 7 139 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	lsb_test_device_by_name /dev/vcsa12 c 7 140 >out.stdout 2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr

	tpresult
}

tp25()
{
	tpstart "Reference 6.1.3-25(A)"
	tet_infoline "There shall be no entries in the /dev/ directory"
	tet_infoline "with the major device number 0"
	tet_infoline "Rationale: major device number 0 is for devices with no filesystem entry"

	# create a list of the major devices numbers in /dev
	rm -f dev.out fail.out >out.stdout 2>out.stderr
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	ls -l /dev |egrep "^b|^c" |cut -c34-42|cut -f1 -d"," >dev.out
	cat dev.out |while read dev_number
	do
		if test "$dev_number" =  "0"
		then
	        	echo "$dev_number" >> fail.out
		fi
	done
	if test -r fail.out
	then
        	FAIL=Y
	fi
	tpresult
}

tp26()
{
	tpstart "Reference 6.1.3-26(A)"
	tet_infoline "There shall be no entries in the /dev/ directory"
	tet_infoline "with the major device number 42"
	tet_infoline "Rationale: major device number 42 is explicitly called out not to"
	tet_infoline "appear in any distribution"
	# create a list of the major devices numbers in /dev
	rm -f dev.out fail.out >out.stdout 2>out.stderr
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	ls -l /dev |egrep "^b|^c" |cut -c34-42|cut -f1 -d"," >dev.out
	cat dev.out |while read dev_number
	do
		if test "$dev_number" =  "42"
		then
	        	echo "$dev_number" >> fail.out
		fi
	done
	if test -r fail.out
	then
        	FAIL=Y
	fi
	tpresult
}

tp27()
{
	tpstart "Reference 6.1.3-27(A)"
	tet_infoline "There shall be no entries in the /dev/ directory"
	tet_infoline "with the major device number 255"
	tet_infoline "Rationale: major device number 255 is explicitly called out not to"
	tet_infoline "appear in any distribution"
	# create a list of the major devices numbers in /dev
	rm -f dev.out fail.out >out.stdout 2>out.stderr
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	ls -l /dev |egrep "^b|^c" |cut -c34-42|cut -f1 -d"," >dev.out
	cat dev.out |while read dev_number
	do
		if test "$dev_number" =  "255"
		then
	        	echo "$dev_number" >> fail.out
		fi
	done
	if test -r fail.out
	then
        	FAIL=Y
	fi
	tpresult
}

tp28()
{
	tpstart "Reference 6.1.3-28(D)"
	tet_infoline "No device nodes should exist with officially registered names"
	tet_infoline "for nonstandard purposes"
	cat devlist |while read dev_line
	do
		set ${dev_line}
		dev_name=$1
		dev_type=$2
		dev_major=$3
		dev_minor=$4
		lsb_test_device_by_name $dev_name $dev_type $dev_major $dev_minor >out.stdout 2>out.stderr
		case $? in
		0)  tet_infoline "$dev_name supported"
			;;
		1)  FAIL=Y
			;;
		3)	:
			;;
		esac
	done
	tpresult 
}


tp29()
{
	tpstart "Reference 6.1.3-29(D)"
	tet_infoline "No device nodes with official numbers (0-59, 64-119, 128-239)"
	tet_infoline "should exist for nonstandard purposes"
	tpresult UNTESTED
}


startup() # startup function
{
     rm -f out.stdout out.stderr out.experr dev.out fail.out >/dev/null 2>&1
}


cleanup() # clean-up function
{
     rm -f out.stdout out.stderr out.experr dev.out fail.out >/dev/null 2>&1
}

# source common shell functions

. $TET_EXECUTE/LIB/shfuncs.sh
. $TET_EXECUTE/LIB/lsbfuncs.sh

# execute shell test case manager - must be last line
. $TET_ROOT/lib/xpg3sh/tcm.sh
