#!/bin/sh
# root-tc.sh : test case for Linux Annex / Root  directory

# This is 1.2
#
# root-tc.sh,v
# Revision 1.2  2000/04/09 07:15:14  cyeoh
# Added CVS header information
#
#

tet_startup="startup"			# startup function
tet_cleanup="cleanup"			# cleanup function
iclist="ic1"
ic1="tp1"


tp1()
{
	tpstart "Reference 6.1.1-1(C)"
	tet_infoline "If the implementation supports the  kernel located in the / directory then" 
	tet_infoline "The kernel file will be named vmlinux or vmlinuz"
	if test -z $LSB_KERNEL_IN_ROOT_DIR
	then
		tpresult UNSUPPORTED
		return
	fi
	if ! test -e /vmlinux -a -e /vmlinuz
	then
		FAIL=Y
	fi	
	tpresult				# set result code
}

startup() # startup function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}


cleanup() # clean-up function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}

# source common shell functions

. $TET_EXECUTE/LIB/shfuncs.sh
. $TET_EXECUTE/LIB/lsbfuncs.sh

# execute shell test case manager - must be last line
. $TET_ROOT/lib/xpg3sh/tcm.sh
