#!/bin/sh
# usr-include-tc.sh : test case for Linux Annex /usr/include directory

# This is 1.3
#
# usr-include-tc.sh,v
# Revision 1.3  2000/04/20 11:01:13  cyeoh
# 6.1.5-1 and 6.1.5-2 have been set to NOTINUSE to better conform with FHS2.1
#
# Revision 1.2  2000/04/09 07:15:16  cyeoh
# Added CVS header information
#
#

tet_startup="startup"			# startup function
tet_cleanup="cleanup"			# cleanup function
iclist="ic1 ic2"
ic1="tp1"
ic2="tp2"


tp1()
{
	tpstart "Reference 6.1.7-1(C)"
	tet_infoline "If the implementation provides a  C or C++ compiler then"
	tet_infoline "The symbolic link /usr/include/asm exists and points to "
	tet_infoline "/usr/src/linux/include/asm-<arch>  where arch is the architecture, i.e. i386, m68k, sparc  "
	tet_infoline "As of FHS 2.1 and later this assertion is now conditional on"
 	tet_infoline "glibc not being present. It is no longer tested."
	tpresult NOTINUSE
}

tp2()
{
	tpstart "Reference 6.1.7-2(C)"
	tet_infoline "If the implementation provides a  C or C++ compiler then"
	tet_infoline "The symbolic link /usr/include/linux exists and points to "
	tet_infoline "/usr/src/linux/include/linux"
	tet_infoline "As of FHS 2.1 and later this assertion is now conditional on"
 	tet_infoline "glibc not being present. It is no longer tested."
	tpresult NOTINUSE
}

startup() # startup function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}


cleanup() # clean-up function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}

# source common shell functions

. $TET_EXECUTE/LIB/shfuncs.sh
. $TET_EXECUTE/LIB/lsbfuncs.sh

# execute shell test case manager - must be last line
. $TET_ROOT/lib/xpg3sh/tcm.sh
