#!/bin/sh
# usr-src-tc.sh : test case for Linux Annex /usr/src directory

# This is 1.3
#
# usr-src-tc.sh,v
# Revision 1.3  2000/04/20 11:24:16  cyeoh
# 6.1.6-1, 6.1.6-2, 6.1.6-3 have been set to NOTINUSE to better conform with
# FHS2.1
#
# Revision 1.2  2000/04/09 07:15:17  cyeoh
# Added CVS header information
#
#

tet_startup="startup"			# startup function
tet_cleanup="cleanup"			# cleanup function
iclist="ic1 ic2 ic3"
ic1="tp1"
ic2="tp2"
ic3="tp3"


tp1()
{
	tpstart "Reference 6.1.8-1(A)"
	tet_infoline "The /usr/src/linux directory exists"
	tet_infoline "As of FHS 2.1 and later this assertion is now conditional on"
 	tet_infoline "glibc not being present. It is no longer tested."
	tpresult NOTINUSE
}

tp2()
{
	tpstart "Reference 6.1.8-2(C)"
	tet_infoline "If the implementation provides a  C or C++ compiler then"
	tet_infoline "The directory /usr/src/linux/include exists"
	tet_infoline "The /usr/src/linux directory exists"
	tet_infoline "As of FHS 2.1 and later this assertion is now conditional on"
 	tet_infoline "glibc not being present. It is no longer tested."
	tpresult NOTINUSE
}
tp3()
{
	tpstart "Reference 6.1.8-3(C)"
	tet_infoline "If the implementation provides a  C or C++ compiler then"
  	tet_infoline "The directory /usr/src/linux/include/asm-<arch> exists"
	tet_infoline "where arch is i386 or m68k or sparc or..."
	tet_infoline "As of FHS 2.1 and later this assertion is now conditional on"
 	tet_infoline "glibc not being present. It is no longer tested."
	tpresult NOTINUSE
}

startup() # startup function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}


cleanup() # clean-up function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}

# source common shell functions

. $TET_EXECUTE/LIB/shfuncs.sh
. $TET_EXECUTE/LIB/lsbfuncs.sh

# execute shell test case manager - must be last line
. $TET_ROOT/lib/xpg3sh/tcm.sh
