#!/bin/sh
# boot-tc.sh : test case for /boot directory

# This is 1.3
#
# boot-tc.sh,v
# Revision 1.3  2000/04/09 07:15:20  cyeoh
# Added CVS header information
#
#

tet_startup="startup"		# startup function
tet_cleanup="cleanup"		# cleanup function
iclist="ic1 ic2"		# list invocable components
ic1="tp1"
ic2="tp2"


tp1()
{
	tpstart "Reference 3.5-1(A)" 
	tet_infoline "The /boot directory exists and is searchable"
	lsb_test_dir_searchable /boot >out.stdout  2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult			# set result code
}

tp2() 
{
	tpstart "Reference 3.5-2(A)"
	tet_infoline "The operating system kernel resides in either / or /boot"

	if test -z $LSB_KERNEL_NAME
	then
		tet_infoline "Expected LSB_KERNEL_NAME parameter to be defined in tetexec.cfg"
		tpresult UNRESOLVED
		return
	fi

	tname=`basename $LSB_KERNEL_NAME`
	tet_infoline "Testing existence of ${LSB_KERNEL_NAME}"

	if test ! -e /$tname -a ! -e /boot/$tname
	then
		tet_infoline "Unable to locate kernel file $LSB_KERNEL_NAME in / or /boot"
		FAIL=Y
	fi
	tpresult				# set result code
}


startup() # start-up function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}

cleanup() # clean-up function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}

# source common shell functions

. $TET_EXECUTE/LIB/shfuncs.sh
. $TET_EXECUTE/LIB/lsbfuncs.sh

# execute shell test case manager - must be last line
. $TET_ROOT/lib/xpg3sh/tcm.sh
