#!/bin/sh
# etc-opt-tc.sh : test case for /etc/opt directory

##########################################################################
# (C) Copyright 1998-2001 The Open Group
#
# All rights reserved.  No part of this source code may be reproduced,
# stored in a retrieval system, or transmitted, in any form or by any
# means, electronic, mechanical, photocopying, recording or otherwise,
# except as stated in the end-user licence agreement, without the prior
# permission of the copyright owners.
#
# X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
# the UK and other countries.
#
#	PROJECT:	LSB-FHS
#	PRODUCT:	LSB.fhs/root/etc-opt/etc-opt-tc.sh
#	AUTHOR:		Andrew Josey, The Open Group
#	DATE CREATED:	21 Dec 1998
##########################################################################

# This is $Revision: 1.3 $
#
# $Log: etc-opt-tc.sh,v $
# Revision 1.3  2001/08/14 14:28:16  ajosey
# update the assertion numbers for FHS2.2
#
# Revision 1.2  2001/07/19 11:37:20  ajosey
# add header and cvs info, review for FHS2.2
#
#
# -- old cvs log below --
# This is 1.2
#
# etc-opt-tc.sh,v
# Revision 1.2  2000/04/09 07:15:25  cyeoh
# Added CVS header information
#
#

tet_startup=""			# no startup function
tet_cleanup=""			# no cleanup function
iclist="ic1"
ic1="tp1"


tp1()
{
	tpstart "Reference 3.7.2-1(A)" 
	tet_infoline "The /etc/opt directory exists and is searchable"

	lsb_test_dir_searchable /etc/opt >out.stdout  2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult			# set result code
}

# source common shell functions

. $TET_EXECUTE/LIB/shfuncs.sh
. $TET_EXECUTE/LIB/lsbfuncs.sh

# execute shell test case manager - must be last line
. $TET_ROOT/lib/xpg3sh/tcm.sh
