#!/bin/sh
# sbin-tc.sh : test case for /usr/sbin directory

##########################################################################
# (C) Copyright 1998-2001 The Open Group
#
# All rights reserved.  No part of this source code may be reproduced,
# stored in a retrieval system, or transmitted, in any form or by any
# means, electronic, mechanical, photocopying, recording or otherwise,
# except as stated in the end-user licence agreement, without the prior
# permission of the copyright owners.
#
# X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
# the UK and other countries.
#
#	PROJECT:	LSB-FHS
#	PRODUCT:	LSB.fhs/usr/sbin/sbin-tc.sh
#	AUTHOR:		Andrew Josey, The Open Group
#	DATE CREATED:	21 Dec 1998
##########################################################################

# This is $Revision: 1.4 $
#
# $Log: sbin-tc.sh,v $
# Revision 1.4  2001/08/14 14:40:00  ajosey
# update the assertion numbers for FHS2.2
#
# Revision 1.3  2001/07/26 08:22:07  ajosey
# remove tp2 as not in FHS2.2
#
# Revision 1.2  2001/07/20 12:20:55  ajosey
# add new test tp2 for FHS2.2
#
#
# -- old cvs log below --
# This is 1.3
#
# sbin-tc.sh,v
# Revision 1.3  2000/04/14 10:38:44  ajosey
# renumber the assertions for FHS2.1
#
# Revision 1.2  2000/04/09 07:15:38  cyeoh
# Added CVS header information
#
#

tet_startup="startup"			# startup function
tet_cleanup="cleanup"			# cleanup function
iclist="ic1"
ic1="tp1"


tp1()
{
	tpstart "Reference 4.10-1(A)"
	tet_infoline "The /usr/sbin directory exists and is searchable"
	lsb_test_dir_searchable /usr/sbin >out.stdout  2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult				# set result code
}


startup() # startup function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}


cleanup() # clean-up function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}

# source common shell functions

. $TET_EXECUTE/LIB/shfuncs.sh
. $TET_EXECUTE/LIB/lsbfuncs.sh

# execute shell test case manager - must be last line
. $TET_ROOT/lib/xpg3sh/tcm.sh
