#!/bin/sh
# share-dict-tc.sh : test case for /usr/share/dict directory

##########################################################################
# (C) Copyright 1998-2001 The Open Group
#
# All rights reserved.  No part of this source code may be reproduced,
# stored in a retrieval system, or transmitted, in any form or by any
# means, electronic, mechanical, photocopying, recording or otherwise,
# except as stated in the end-user licence agreement, without the prior
# permission of the copyright owners.
#
# X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
# the UK and other countries.
#
#	PROJECT:	LSB-FHS
#	PRODUCT:	LSB.fhs/usr/share-dict/share-dict-tc.sh
#	AUTHOR:		Andrew Josey, The Open Group
#	DATE CREATED:	21 Dec 1998
##########################################################################

# This is $Revision: 1.4 $
#
# $Log: share-dict-tc.sh,v $
# Revision 1.4  2001/08/15 07:03:58  ajosey
# update the assertion numbers for FHS2.2
#
# Revision 1.3  2001/07/20 11:02:18  ajosey
# update UNSUPPORTED to FIP result codes
#
# Revision 1.2  2001/07/19 10:47:45  ajosey
# align testcase for FHS2.2
#
#
# --- old revision history below ---
# This is 1.3
#
# share-dict-tc.sh,v
# Revision 1.3  2000/04/14 10:49:48  ajosey
# renumber the assertions for FHS2.1
#
# Revision 1.2  2000/04/09 07:15:40  cyeoh
# Added CVS header information
#
#

tet_startup="startup"			# startup function
tet_cleanup="cleanup"			# cleanup function
iclist="ic1"
ic1="tp1"


tp1()
{
	tpstart "Reference 4.11.4-1(C)"
	tet_infoline "If the implementation supports the subsystem"
	tet_infoline "The /usr/share/dict directory exists and is searchable"
	lsb_test_dir_searchable /usr/share/dict >out.stdout  2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	if [ $FAIL = Y ]
	then
		FAIL=N
		tet_infoline "This test result needs to be manually resolved, returning FIP result"
		tpresult FIP
		return
	fi
	tpresult				# set result code
}

startup() # startup function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}


cleanup() # clean-up function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}

# source common shell functions

. $TET_EXECUTE/LIB/shfuncs.sh
. $TET_EXECUTE/LIB/lsbfuncs.sh

# execute shell test case manager - must be last line
. $TET_ROOT/lib/xpg3sh/tcm.sh
