#!/bin/sh
# share-misc-tc.sh : test case for /usr/share/misc directory


##########################################################################
# (C) Copyright 1998-2001 The Open Group
#
# All rights reserved.  No part of this source code may be reproduced,
# stored in a retrieval system, or transmitted, in any form or by any
# means, electronic, mechanical, photocopying, recording or otherwise,
# except as stated in the end-user licence agreement, without the prior
# permission of the copyright owners.
#
# X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
# the UK and other countries.
#
#	PROJECT:	LSB-FHS
#	PRODUCT:	LSB.fhs/usr/share-misc/share-misc-tc.sh
#	AUTHOR:		Andrew Josey, The Open Group
#	DATE CREATED:	21 Dec 1998
##########################################################################

# This is $Revision: 1.3 $
#
# $Log: share-misc-tc.sh,v $
# Revision 1.3  2001/08/15 07:05:07  ajosey
# update the assertion numbers for FHS2.2
#
# Revision 1.2  2001/07/20 12:27:37  ajosey
# update header
#
#
# -- old cvs log below --

# This is 1.3
#
# share-misc-tc.sh,v
# Revision 1.3  2000/04/14 10:51:23  ajosey
# renumber the assertions for FHS2.1
#
# Revision 1.2  2000/04/09 07:15:42  cyeoh
# Added CVS header information
#
#

tet_startup="startup"			# startup function
tet_cleanup="cleanup"			# cleanup function
iclist="ic1 ic2 ic3 ic4 ic5"
ic1="tp1"
ic2="tp2"
ic3="tp3"
ic4="tp4"
ic5="tp5"


tp1()
{
	tpstart "Reference 4.11.6-1(A)"
	tet_infoline "The /usr/share/misc directory exists and is searchable"
	lsb_test_dir_searchable /usr/share/misc >out.stdout  2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult				# set result code
}

tp2()
{
	tpstart "Reference 4.11.6-2(C)"
	tet_infoline "If the implementation supports the file ascii"
	tet_infoline "it will exist in the /usr/share/misc directory"
	if test -z $LSB_FILE_ASCII
	then
		tpresult UNSUPPORTED
		return
	fi
	lsb_test_file /usr/share/misc/ascii >out.stdout  2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult				# set result code
}

tp3()
{
	tpstart "Reference 4.11.6-3(C)"
	tet_infoline "If the implementation supports the file magic"
	tet_infoline "it will exist in the /usr/share/misc directory"
	if test -z $LSB_FILE_MAGIC
	then
		tpresult UNSUPPORTED
		return
	fi
	lsb_test_file /usr/share/misc/magic >out.stdout  2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult				# set result code
}

tp4()
{
	tpstart "Reference 4.11.6-4(C)"
	tet_infoline "If the implementation supports the file termcap"
	tet_infoline "it will exist in the /usr/share/misc directory"
	if test -z $LSB_FILE_TERMCAP
	then
		tpresult UNSUPPORTED
		return
	fi
	lsb_test_file /usr/share/misc/termcap >out.stdout  2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult				# set result code
}

tp5()
{
	tpstart "Reference 4.11.6-5(C)"
	tet_infoline "If the implementation supports the file termcap.db"
	tet_infoline "it will exist in the /usr/share/misc directory"
	if test -z $LSB_FILE_TERMCAPDB
	then
		tpresult UNSUPPORTED
		return
	fi
	lsb_test_file /usr/share/misc/termcap.db >out.stdout  2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult				# set result code
}

startup() # startup function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}


cleanup() # clean-up function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}

# source common shell functions

. $TET_EXECUTE/LIB/shfuncs.sh
. $TET_EXECUTE/LIB/lsbfuncs.sh

# execute shell test case manager - must be last line
. $TET_ROOT/lib/xpg3sh/tcm.sh
