#!/bin/sh
# account-tc.sh : test case for /var/account directory

# This is 1.2
#
# account-tc.sh,v
# Revision 1.2  2000/04/09 07:15:45  cyeoh
# Added CVS header information
#
#

tet_startup="startup"			# startup function
tet_cleanup="cleanup"			# cleanup function
iclist="ic1"
ic1="tp1"


tp1()
{
	tpstart "Reference 5.3-1(C)"
	tet_infoline "If the implementation supports process acccounting then"
	tet_infoline "The /var/account directory exists and is searchable"
	if test -z $LSB_PROCESS_ACCOUNTING
	then
		tpresult UNSUPPORTED
		return
	fi
	lsb_test_dir_searchable /var/account >out.stdout  2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult				# set result code
}

startup() # startup function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}


cleanup() # clean-up function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}

# source common shell functions

. $TET_EXECUTE/LIB/shfuncs.sh
. $TET_EXECUTE/LIB/lsbfuncs.sh

# execute shell test case manager - must be last line
. $TET_ROOT/lib/xpg3sh/tcm.sh
