#!/bin/sh
# cache-man-tc.sh : test case for /var/cache/man directory

##########################################################################
# (C) Copyright 1998-2001 The Open Group
#
# All rights reserved.  No part of this source code may be reproduced,
# stored in a retrieval system, or transmitted, in any form or by any
# means, electronic, mechanical, photocopying, recording or otherwise,
# except as stated in the end-user licence agreement, without the prior
# permission of the copyright owners.
#
# X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
# the UK and other countries.
#
#	PROJECT:	LSB-FHS
#	PRODUCT:	LSB.fhs/var/cache-man/cache-man-tc.sh
#	AUTHOR:		Andrew Josey, The Open Group
#	DATE CREATED:	21 Dec 1998
##########################################################################

# This is $Revision: 1.4 $
#
# $Log: cache-man-tc.sh,v $
# Revision 1.4  2001/08/15 07:16:16  ajosey
# update the assertion numbers for FHS2.2
#
# Revision 1.3  2001/07/27 08:24:17  ajosey
# missing FAIL=N for FIP cases
#
# Revision 1.2  2001/07/20 12:33:05  ajosey
# updated for FHS2.2
#
#
# -- old cvs log below --
# This is 1.2
#
# cache-man-tc.sh,v
# Revision 1.2  2000/04/09 07:15:48  cyeoh
# Added CVS header information
#
#

tet_startup="startup"			# startup function
tet_cleanup="cleanup"			# cleanup function
iclist="ic1"
ic1="tp1"


tp1()
{
	tpstart "Reference 5.5.4-1(C)"
	tet_infoline "If man pages are supported"
	tet_infoline "The /var/cache/man directory exists and is searchable"
	lsb_test_dir_searchable /var/cache/man >out.stdout  2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	if [ $FAIL = Y ]
	then
		FAIL=N
		tet_infoline "This test result needs to be manually resolved, returning FIP result"
		tpresult FIP
		return
	fi
	tpresult				# set result code
}

startup() # startup function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}


cleanup() # clean-up function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}

# source common shell functions

. $TET_EXECUTE/LIB/shfuncs.sh
. $TET_EXECUTE/LIB/lsbfuncs.sh

# execute shell test case manager - must be last line
. $TET_ROOT/lib/xpg3sh/tcm.sh
