#!/bin/sh
# lib-tc.sh : test case for /var/lib directory

# This is 1.1
#
# lib-tc.sh,v
# Revision 1.1  2000/04/16 08:36:01  cyeoh
# Added 5.5-1 Check /var/lib directory exists and is searchable
#
#

tet_startup="startup"			# startup function
tet_cleanup="cleanup"			# cleanup function
iclist="ic1"
ic1="tp1"


tp1()
{
	tpstart "Reference 5.8-1(A)"
	tet_infoline "The /var/lib directory exists and is searchable"
	lsb_test_dir_searchable /var/lib >out.stdout  2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult				# set result code
}

startup() # startup function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}


cleanup() # clean-up function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}

# source common shell functions

. $TET_EXECUTE/LIB/shfuncs.sh
. $TET_EXECUTE/LIB/lsbfuncs.sh

# execute shell test case manager - must be last line
. $TET_ROOT/lib/xpg3sh/tcm.sh
