#!/bin/sh
# run-tc.sh : test case for /var/run directory

# This is 1.3
#
# run-tc.sh,v
# Revision 1.3  2000/04/17 01:32:52  cyeoh
# Renumbered to 5.10-X for FHS2.1 changes
#
# Revision 1.2  2000/04/09 07:15:54  cyeoh
# Added CVS header information
#
#

tet_startup="startup"			# startup function
tet_cleanup="cleanup"			# cleanup function
iclist="ic1 ic2"
ic1="tp1"
ic2="tp2"


tp1()
{
	tpstart "Reference 5.13-1(A)"
	tet_infoline "The /var/run directory exists and is searchable"
	lsb_test_dir_searchable /var/run >out.stdout  2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult				# set result code
}

tp2()
{
	tpstart "Reference 5.13-2(A)"
	tet_infoline "The /var/run/utmp file exists"
	lsb_test_file /var/run/utmp >out.stdout  2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult				# set result code
}

startup() # startup function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}


cleanup() # clean-up function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}

# source common shell functions

. $TET_EXECUTE/LIB/shfuncs.sh
. $TET_EXECUTE/LIB/lsbfuncs.sh

# execute shell test case manager - must be last line
. $TET_ROOT/lib/xpg3sh/tcm.sh
