#!/bin/sh
# spool-tc.sh : test case for /var/spool directory

# This is 1.4
#
# spool-tc.sh,v
# Revision 1.4  2000/04/17 02:33:45  cyeoh
# Fixes syntax typo in tp1
#
# Revision 1.3  2000/04/17 01:34:05  cyeoh
# Renumbered to 5.11-1 for FHS2.1 changes
#
# Revision 1.2  2000/04/09 07:15:55  cyeoh
# Added CVS header information
#
#

tet_startup="startup"			# startup function
tet_cleanup="cleanup"			# cleanup function
iclist="ic1"
ic1="tp1"


tp1()
{
	tpstart "Reference 5.14-1(A)"
	tet_infoline "The /var/spool directory exists and is searchable"
	lsb_test_dir_searchable /var/spool >out.stdout  2>out.stderr
	check_exit_value $? 0		# should be zero
	check_nostdout			# should be no stdout
	check_nostderr			# should be no stderr
	tpresult				# set result code
}

startup() # startup function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}


cleanup() # clean-up function
{
     rm -f out.stdout out.stderr out.experr >/dev/null 2>&1
}

# source common shell functions

. $TET_EXECUTE/LIB/shfuncs.sh
. $TET_EXECUTE/LIB/lsbfuncs.sh

# execute shell test case manager - must be last line
. $TET_ROOT/lib/xpg3sh/tcm.sh
