/*
*      SCCS:  @(#)  XOPEN.os/files/dev_null/dev_null.c	Rel 4.4.1	    (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)XOPEN.os/files/dev_null - T.dev_null Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		XOPEN.os/files/dev_null/dev_null.c
PRODUCT:	T.dev_null
PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Implements the /dev/null test set as defined in the
	/dev/null functional and design specification documents.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Joseph Nave, UniSoft Ltd.;
DATE CREATED:	Tue Oct 09 16:16:10 BST 1990
MODIFICATIONS:	
		Geoff Clare, 21 Feb 1991
			General tidy up.

************************************************************************/

#include	<std.h>
#include	<stdio.h>
#include	<errno.h>
#include	<sys/types.h>
#include	<fcntl.h>
#include	<dbug.h>
#include	<sys/stat.h>
#include	<report.h>
#include	<limits.h>
#include	<unistd.h>
#include	<stdlib.h>
#include	<ctype.h>
#include 	<sys/wait.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef dev_null
#endif


#define NO_TESTS	1		/* number of tests in testset */

#define READ		0
#define WRITE		1

extern	void	valrpt();

public	int	no_tests = NO_TESTS;

private void	test1();

private char	*t1_path =	"/dev/null";

private char	alphabet[] = "abcdefghijklmnopqrstuvwxyz";

private int	testfail;
public	void	(*setfunc) () = NULL;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	NULL, 0
};

private void
test1()
{
	int	err;
	int	rval;
	int	fildes[2];
	char	in_buf[sizeof(alphabet)];
	int	pathok = 0;

	DBUG_ENTER("test1");

	errno = NOERROR;
	if ((fildes[WRITE] = open(t1_path, O_WRONLY)) == SYSERROR)
	{
		xx_rpt(FAILURE);
		in_rpt("could not open file %s for writing", t1_path);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	errno = NOERROR;
	if ((fildes[READ] = open(t1_path, O_RDONLY)) == SYSERROR)
	{
		xx_rpt(FAILURE);
		in_rpt("could not open file %s for reading", t1_path);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	errno = 0;
	rval = write(fildes[WRITE], alphabet, (unsigned) sizeof(alphabet));

	if (rval != (int) sizeof(alphabet))
	{
		err = errno;
		if (testfail++ == 0)
			xx_rpt(FAILURE);
	 	in_rpt("write(%d, buf, %d) failed when writing to \"/dev/null\"",
			fildes[WRITE], (int) sizeof(alphabet));
		valrpt((int) sizeof(alphabet), rval, 0, err);
	}
	else
		PATH_TRACE;

	errno = 0;
	rval = read(fildes[READ], in_buf, (unsigned) sizeof(alphabet));

	if (rval != 0)
	{
		err = errno;
		if (testfail++ == 0)
			xx_rpt(FAILURE);
	 	in_rpt("read(%d, buf, %d) failed when reading from \"/dev/null\"",
			fildes[READ], (int) sizeof(alphabet));
		valrpt(0, rval, 0, err);
	}
	else
		PATH_TRACE;

	(void) close(fildes[WRITE]);
	(void) close(fildes[READ]);

	if (testfail == 0)
		PATH_XS_RPT(4);

	DBUG_VOID_RETURN;
}

