##########################################################################
# (C) Copyright 1992 X/Open Company Limited
#
# All rights reserved.  No part of this source code may be reproduced,
# stored in a retrieval system, or transmitted, in any form or by any
# means, electronic, mechanical, photocopying, recording or otherwise,
# except as stated in the end-user licence agreement, without the prior
# permission of the copyright owners.
#
# X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
# the UK and other countries.
#
#	SCCS:	@(#)XOPEN.os/genuts/ftw/server.mk	Rel 4.4.1 (06/09/97)
#
#	PROJECT:	XNFS (X/OPEN NFS tests)
#	PRODUCT:	Server side of XOPEN.os/genuts/ftw
#	AUTHOR:		Neil Moses, UniSoft Ltd.
#	DATE CREATED:	16 October 1992
#	TARGETS:	T.ftw
#
##########################################################################


include ../../../../common.mk
include ../../../../defines.mk

# What is installed:

INSTOWN =	vsx0
INSTOWN1 =	vsx1
INSTOWN2 =	root
INSTGRP =	vsxg0
INSTGRP1 =	vsxg1
INSTMODE =	755
INSTMODE1 =	6755
INSTMODE2 =	4755
INSTDIR =	$(TET_EXECUTE)/tset/XOPEN.os/genuts/ftw

# product-wide libraries for ld(1):

LIBS =		$(XNFSLIB) $(GENLIB) $(VSXLIB)/vlib.a $(LIBVPORT) $(APILIB)

DBUG =	
SDBFLAG =	

# INCS, as seen from obj directory
INCS =		-I$(TETINC) -I$(VSXINC)
CFLOCAL =
CFLAGS =	$(CFLOCAL) $(INCS) $(DEFINES) $(DBUG) $(COPTS) $(SDBFLAG)

CFILES =	ftw_s.c
OFILES =	ftw_s.o

LINTFLAGS =	$(CFLOCAL) $(INCS) $(DEFINES)  -n
LINTLIBS =	$(LXNFS) -lvsx -lvlib -lgen -lvport

# Targets: ---------------------------------------------------------

all_xnfs:	T.ftw

T.ftw:		$(OFILES) $(TCM) $(VSXLIB)/startup_s.o $(LIBS)
		$(CC) -o $@ $(OFILES) $(TCM) $(VSXLIB)/startup_s.o $(LIBS) $(SYSLIBS) $(LDFLAGS)
		@echo "	$@ made"

INSTALL_xnfs:	$(INSTDIR)/T.ftw

$(INSTDIR)/T.ftw:	T.ftw
		$(CHMOG) $(INSTMODE) $(INSTOWN) $(INSTGRP) -m $? $@
		@echo " $? installed in $@"

$(LIBS):
	-@echo "Warning: cannot continue making: $@ needs to be installed"
		@false

LINT_xnfs:	LINT0

LINT0:
		$(LINT) $(LINTFLAGS) $(CFILES) $(LINTDRV) $(LTCM) $(LINTLIBS)

FORCE_xnfs:	CLOBBER_xnfs all_xnfs

CLEAN_xnfs:
		$(RM) $(OFILES)

CLOBBER_xnfs:	CLEAN_xnfs
		$(RM) T.ftw $(INSTDIR)/T.ftw

$(OFILES):	$(VSXINC)/std.h
