/* dv @(#)COMMONGABI/common/gabilib/cr_sym_loop.c	1.1 93/04/20 */
/*
*	SCCS:  @(#) common/gabilib/cr_sym_loop.c	Ver. 1.8	Rel. 1.3	(92/08/01)
*
*
* (C) Copyright 1990,1991 UniSoft Group Ltd.
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#) common/gabilib/cr_sym_loop.c	Ver. 1.8	Rel. 1.3	(92/08/01)";
static	char	*copyright[] = {
		"(C) Copyright 1990,1991 UniSoft Group Ltd.",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		cr_sym_loop.c - create two symbolic links 
		that point to each other

PROJECT:	GABI

MODULE CONTAINS:
	cr_sym_loop()
SYNOPSIS:
	int cr_sym_loop(path1,path2)
		char *path1;
		char *path2;

DESCRIPTION:
	cr_sym_loop() attempts to symbolically link path1 to path2 and 
	vice-versa. Henceforth, any reference to either, should result in
	an `ELOOP' error.

CONDITIONAL COMPILE PARAMS:

SIDE EFFECTS:
	None.
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Keith Holder
DATE CREATED:	
MODIFICATIONS:	

************************************************************************/

#include <std.h>
#include <dbug.h>
#include <unistd.h>
#include <report.h>
#include <errno.h>
#include <tet_api.h>
#include <sysdep.h>

extern	char	*errname();
extern	int	errno;

/*
 * creates  two symbolic links that 
 * reference each other.
 * Used in ELOOP deviance tests.
 */


public int
cr_sym_loop(path1,path2)
char *path1,*path2;
{
	int err;
	int pathok = 0;

	DBUG_LENTER("cr_sym_loop",2);
	DBUG_PRINTF("args","cr_sym_loop(%s,%s)",path1,path2);

	if ( symlink(path1,path2) == SYSERROR)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("symlink(%s,%s) failed, errno %d (%s)",
			path1,path2,err,errname(err));
		DBUG_PRINTF("return","cr_sym_loop = %d",SYSERROR);
		DBUG_RETURN(SYSERROR);
	}
	else
		PATH_TRACE;

	if ( symlink(path2,path1) == SYSERROR)
	{
		err = errno;
		(void)unlink(path2);
		if (err == ELOOP)
			xx_rpt(UNTESTED);
		else
			xx_rpt(DELETION);
		in_rpt("symlink(%s,%s) failed, errno %d (%s)",
			path2,path1,err,errname(err));
		DBUG_PRINTF("return","cr_sym_loop = %d",SYSERROR);
		DBUG_RETURN(SYSERROR);
	}
	else
		PATH_TRACE;
	
	DBUG_PRINTF("return","cr_sym_loop = %d",0);
	PATH_FUNC_RPT(2);
	DBUG_RETURN(0);
	/* NOTREACHED */
}
