/*
*      SCCS:  @(#)  XOPEN.os/genuts/pclose/pclose_t1.c	Rel 4.4.1     (06/09/97) 
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)XOPEN.os/genuts/pclose - pclose_t1.c Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN	*/
#endif  /* lint	*/

/***********************************************************************

NAME:		pclose_t1.c - used in pclose() testset to test pclose()
		of a stream returned by pclose.

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	main()
SYNOPSIS:
DESCRIPTION:
	Called in comply section of the pclose() testset.  This program
	sits and waits for a file to be removed and then exits.  There
	is also a timeout.
	Usage:
		pclose_t1

RELATED DOCUMENTS:
	XOPEN.os/pclose/pclose.c

AUTHOR:		Mike Rendell, UniSoft Ltd.
DATE CREATED:	Fri Nov 28 20:04:22 WET 1986
MODIFICATIONS:	J.A.Nave	23/05/90
		Added resilience testing

		Stuart Boutell, 1 Dec 1990
		Removed all TET api references.

		Geoff Clare, 24 Oct 1996
		Still some TET api references

************************************************************************/
#include	<std.h>
#include	<errno.h>
#include	<sys/types.h>
#include	<signal.h>
#include	<stdlib.h>
#include	<unistd.h>
#include	<exitcodes.h>
#include	<pclose.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef pclose
#endif


private	void		leave();

int
main(argc,argv)
int	argc;
char	**argv;
{
	int	rval;

	(void) signal(SIGALRM, leave);
	(void) alarm(WAITTIME);
	do {
		errno = 0;
		rval = access(t1_file, F_OK);
	} while (rval != SYSERROR && errno != ENOENT);

	exit(SUCCEED);
	/* NOTREACHED */
}


private	void
leave()
{
	exit(A_MISC);
}
