/*
*      SCCS:  @(#)  XOPEN.os/genuts/popen/popen_t1.c	Rel 4.4.1     (06/09/97) 
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)XOPEN.os/genuts/popen - popen_t1.c Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN	*/
#endif  /* lint	*/

/***********************************************************************

NAME:		popen_test1.c - used in popen() testset to test reading
		from a stream returned by popen().

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	main()
SYNOPSIS:
DESCRIPTION:
	Called in deviance section of the popen() testset.  This program
	reads from stdin and reports on what is found.
	Usage:
		popen_test1

RELATED DOCUMENTS:
	XOPEN.os/popen/popen.c

AUTHOR:		Mike Rendell, UniSoft Ltd.
DATE CREATED:	Fri Nov 28 20:04:22 WET 1986
MODIFICATIONS:	J.A.Nave	23/05/90
		Added resilience testing

		Stuart Boutell, 1 Dec 1990
			Removed all references to the TET api

************************************************************************/
#include	<std.h>
#include	<sys/types.h>
#include	<errno.h>
#include	<string.h>
#include	<popen.h>
#include	<signal.h>
#include	<unistd.h>
#include	<timeout.h>
#include	<stdlib.h>
#include	<dbug.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef popen
#endif


extern	char		*errname();

int
main(argc, argv)
int	argc;
char	**argv;
{
	char	buf[32];
	int	nbytes;
	int	len;
	int	err;
	int	fail = 0;
	int	pathok = 0;

	DBUG_ENTER("popen_t1");

	SET_TIMEOUT(WAITTIME)
	nbytes = read(STDIN_FILENO, buf, sizeof(buf) - 1);
	CLEAR_ALARM
	if (nbytes == SYSERROR)
	{
		fail = 1;
		err = errno;
		if (alrm_flag > 0)
			(void)printf("timed out reading fom stdin in popen()'d command\n");
		else
			(void)printf("read from stdin failed in popen()'d command - errno %d(%s)\n",
				err, errname(err));
	}
	else
		PATH_TRACE;

	buf[nbytes] = NUL;
	len = strlen(t_string);
	if (nbytes != len || strcmp(buf, t_string))
	{
		fail = 1;
		if (nbytes != len)
		{
			(void)printf("did not read correct number of bytes from stdin in popen()'d command\n");
			(void)printf("expected %d, got %d\n", len, nbytes);
		}
		else
		{
			(void)printf("did not read correct string from stdin in popen()'d command\n");
			(void)printf("expected >%s<, got >%s<\n", t_string, buf);
		}
	}
	else
		PATH_TRACE;

	if (!fail)
		if (pathok != 2)
		{
			fail = 2;
			(void)printf("path check failure in popen_t1\n");
		}

	DBUG_EXIT(fail);
	/* NOTREACHED */
}
