/*
*      SCCS:  @(#)  XOPEN.os/genuts/popen/popen_t2.c	Rel 4.4.1     (06/09/97) 
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)XOPEN.os/genuts/popen - popen_t2.c Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN	*/
#endif  /* lint	*/

/***********************************************************************

NAME:		popen_t2.c - used in popen() testset to test popen()
		of a stream returned by popen.

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	main()
SYNOPSIS:
DESCRIPTION:
	Called in comply section of the popen() testset.  This program
	write a string to stdout.
	Usage:
		popen_t2

RELATED DOCUMENTS:
	XOPEN.os/popen/popen.c

AUTHOR:		Mike Rendell, UniSoft Ltd.
DATE CREATED:	Fri Nov 28 20:04:22 WET 1986
MODIFICATIONS:	J.A.Nave	23/05/90
		Added resilience testing

		Stuart Boutell, 1 Dec 1990
			Removed all references to the TET api

************************************************************************/
#include	<std.h>
#include	<sys/types.h>
#include	<string.h>
#include	<stdlib.h>
#include	<unistd.h>
#include	<signal.h>
#include	<exitcodes.h>
#include	<popen.h>
#include	<dbug.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef popen
#endif


extern	void		(*vsignal())();

private	void		leave();

int
main(argc,argv)
int	argc;
char	**argv;
{
	int	pathok = 0;

	DBUG_ENTER("popen_t2");

	PATH_TRACE;	/*	to prove that we have been here	*/

	(void) vsignal(SIGALRM, leave);
	(void) alarm(WAITTIME);
	(void)write(STDOUT_FILENO, t_string, (unsigned) strlen(t_string));
	DBUG_EXIT(SUCCEED);
	/* NOTREACHED */
}


private	void
leave()
{
	int	pathok = 0;

	DBUG_ENTER("leave");

	PATH_TRACE;	/*	to prove that we have been here	*/

	DBUG_EXIT(A_MISC);
}
