/*
*      SCCS:  @(#)  XOPEN.os/genuts/popen/popen_t4.c	Rel 4.4.1     (06/09/97) 
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)XOPEN.os/genuts/popen - popen_t4.c Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN	*/
#endif  /* lint	*/

/***********************************************************************

NAME:		popen_t4.c - used in popen()

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	main()
SYNOPSIS:
DESCRIPTION:	Tests that child process can execute independently of
		its parent.

RELATED DOCUMENTS:
	XOPEN.os/popen/popen.c

AUTHOR:		Neil Moses
DATE CREATED:	Tue Oct 01 12:11:00 BST 1991
MODIFICATIONS:	

************************************************************************/
#include	<std.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<dbug.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef popen
#endif


extern	unsigned int sleep();
private	char	*t4_output = "../popen_t.4";

int
main()
{
	FILE	*fp;
	int	fail = 0;
	int	pathok = 0;

	DBUG_ENTER("popen_t4");

	(void) sleep(5);

	if((fp = fopen(t4_output, "a")) == (FILE *)NULL)
	{
		(void) printf("Cannot open %s to append", t4_output);
		fail++;
	}
	else
		PATH_TRACE;

	(void) fputs("child\n", fp);
	(void) fflush(fp);
	(void) fclose(fp);

	(void) printf("message to parent\n");

	DBUG_EXIT(fail);
}
