/* dv (#)SOLTESTS/tset/LSB.os/genuts/syslog_L/syslog_L.c	1.5 99/04/26 */
/*
* (C) Copyright 1998 UniSoft Limited.
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*/
#ifndef	lint
#define	MAIN
#ifdef	MAIN
static	char sccsid[] = "(#)SOLTESTS/tset/LSB.os/genuts/syslog_L/syslog_L.c	1.5 99/04/26";
char	*copyright[] = {
		"(C) Copyright 1998 UniSoft Limited",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		T.syslog_L

PROJECT:	Solaris ABI Test Suite

DESCRIPTION:
	Testset for the syslog() function.

AUTHOR:		Matthew Hails, UniSoft Ltd.
DATE CREATED:	November 1998

************************************************************************/

#include <std.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <errno.h>
#include <stdarg.h>
#include <ctype.h>
#include <fcntl.h>
#include <float.h>
#include <langinfo.h>
#include <limits.h>
#include <locale.h>
#include <sys/stat.h>
#include <sys/types.h>
#include <syslog.h>
#include <time.h>
#include <unistd.h>
#include <signal.h>
#include <wchar.h>
#include <wait_child.h>
#include <dbug.h>
#include <report.h>
#include <tet_api.h>
#include <nlstest.h>

#ifdef UNDEF_MACROS
#undef syslog
#endif

#define NO_TESTS 119
#define RADIXCHAR 39

#define WAITTIME		(5 * SPEEDFACTOR)
#define LOCNAME			"VSX4L2"
#define WAITLOGDSECS		30
#define MAXSTRINGSIZE		1024
#define TIMESTAMPFMT		"%b %e %H:%M"
#define TIMESTAMPBUFLEN		13

#define CALL_SYSLOG		1
#define	CALL_SPRINTF		2
#define CMP_PLAINSTRING		1
#define CMP_USE_SPRINTF	2

#define TOPT_NOOPENLOG		0x01
#define TOPT_ERRNOVAL(err)	(((err) & 0xff) << 8)
#define TOPT_GETERRNO(topt)	(((topt) >> 8) & 0xff)

/* External prototypes */
char *errname(int);

/* Local prototypes */
static pid_t getsyslogdpid(void);
static int setup_syslogd(char *debuglogfile);
static int cleanup_syslogd(void);
static void prepare(void);
static void clean(void);
static int setupsyslog(char *cmd, char *arg);
static void comntest(unsigned testopts, char *cmparg,
	int (*chkfn)(char *, void *), void *chkarg, char *ident,
	void (*runfn)(int, char **), char *message, char *uselog);
static void gettimestamp(char *tbuf, int buflen);
static int checklong(char *msg, void *chkarg);
static int checkint(char *msg, void *chkarg);
static int checkshort(char *msg, void *chkarg);
static int checktimestamp(char *msg, void *chkarg);

/* External data declarations */
extern int ex_code;
extern int sg_code;
extern char **_environ;

/* Global static data */
static char setupprog[] = "../setupsyslog";
static char testmsg[] = "This is only a test";
static char logfile[] = "./debug-messages";
static char *logfiles[5] = { "./debug-messages.0",
			     "./debug-messages.1",
			     "./debug-messages.2",
			     "./debug-messages.3",
			     "./debug-messages.4" };

static void test1(void);
static void sub_test1(int type, char **msgptr);
static void test2(void);
static void sub_test2(int type, char **msgptr);
static void test3(void);
static void sub_test3(int type, char **msgptr);
static void test4(void);
static void sub_test4(int type, char **msgptr);
static void test5(void);
static void sub_test5(int type, char **msgptr);
static void test6(void);
static void sub_test6(int type, char **msgptr);
static void test7(void);
static void sub_test7(int type, char **msgptr);
static void test8(void);
static void sub_test8(int type, char **msgptr);
static void test9(void);
static void sub_test9(int type, char **msgptr);
static void test10(void);
static void sub_test10(int type, char **msgptr);
static void test11(void);
static void sub_test11(int type, char **msgptr);
static void test12(void);
static void sub_test12(int type, char **msgptr);
static void test13(void);
static void sub_test13(int type, char **msgptr);
static void test14(void);
static void sub_test14(int type, char **msgptr);
static void test15(void);
static void sub_test15(int type, char **msgptr);
static void test16(void);
static void sub_test16(int type, char **msgptr);
static void test17(void);
static void sub_test17(int type, char **msgptr);
static void test18(void);
static void sub_test18(int type, char **msgptr);
static void test19(void);
static void sub_test19(int type, char **msgptr);
static void test20(void);
static void sub_test20(int type, char **msgptr);
static void test21(void);
static void sub_test21(int type, char **msgptr);
static void test22(void);
static void sub_test22(int type, char **msgptr);
static void test23(void);
static void sub_test23(int type, char **msgptr);
static void test24(void);
static void sub_test24(int type, char **msgptr);
static void test25(void);
static void sub_test25(int type, char **msgptr);
static void test26(void);
static void sub_test26(int type, char **msgptr);
static void test27(void);
static void sub_test27(int type, char **msgptr);
static void test28(void);
static void sub_test28(int type, char **msgptr);
static void test29(void);
static void sub_test29(int type, char **msgptr);
static void test30(void);
static void sub_test30(int type, char **msgptr);
static void test31(void);
static void sub_test31(int type, char **msgptr);
static void test32(void);
static void sub_test32(int type, char **msgptr);
static void test33(void);
static void sub_test33(int type, char **msgptr);
static void test34(void);
static void sub_test34(int type, char **msgptr);
static void test35(void);
static void sub_test35(int type, char **msgptr);
static void test36(void);
static void sub_test36(int type, char **msgptr);
static void test37(void);
static void sub_test37(int type, char **msgptr);
static void test38(void);
static void sub_test38(int type, char **msgptr);
static void test39(void);
static void sub_test39a(int type, char **msgptr);
static void sub_test39b(int type, char **msgptr);
static void test40(void);
static void sub_test40a(int type, char **msgptr);
static void sub_test40b(int type, char **msgptr);
static void test41(void);
static void sub_test41a(int type, char **msgptr);
static void sub_test41b(int type, char **msgptr);
static void test42(void);
static void sub_test42a(int type, char **msgptr);
static void sub_test42b(int type, char **msgptr);
static void test43(void);
static void sub_test43(int type, char **msgptr);
static void test44(void);
static void sub_test44(int type, char **msgptr);
static void test45(void);
static void sub_test45(int type, char **msgptr);
static void test46(void);
static void sub_test46(int type, char **msgptr);
static void test47(void);
static void sub_test47(int type, char **msgptr);
static void test48(void);
static void sub_test48(int type, char **msgptr);
static void test49(void);
static void sub_test49(int type, char **msgptr);
static void test50(void);
static void sub_test50(int type, char **msgptr);
static void test51(void);
static void sub_test51(int type, char **msgptr);
static void test52(void);
static void sub_test52(int type, char **msgptr);
static void test53(void);
static void sub_test53(int type, char **msgptr);
static void test54(void);
static void sub_test54(int type, char **msgptr);
static void test55(void);
static void sub_test55(int type, char **msgptr);
static void test56(void);
static void sub_test56(int type, char **msgptr);
static void test57(void);
static void sub_test57(int type, char **msgptr);
static void test58(void);
static void sub_test58(int type, char **msgptr);
static void test59(void);
static void sub_test59(int type, char **msgptr);
static void test60(void);
static void sub_test60(int type, char **msgptr);
static void test61(void);
static void sub_test61(int type, char **msgptr);
static void test62(void);
static void sub_test62(int type, char **msgptr);
static void test63(void);
static void t63(void);
static void sub_test63(int type, char **msgptr);
static void test64(void);
static void t64(void);
static void sub_test64(int type, char **msgptr);
static void test65(void);
static void sub_test65(int type, char **msgptr);
static void test66(void);
static void sub_test66(int type, char **msgptr);
static void test67(void);
static void sub_test67(int type, char **msgptr);
static void test68(void);
static void sub_test68(int type, char **msgptr);
static void test69(void);
static void sub_test69(int type, char **msgptr);
static void test70(void);
static void sub_test70(int type, char **msgptr);
static void test71(void);
static void sub_test71(int type, char **msgptr);
static void test72(void);
static void sub_test72(int type, char **msgptr);
static void test73(void);
static void sub_test73(int type, char **msgptr);
static void test74(void);
static void sub_test74(int type, char **msgptr);
static void test75(void);
static void sub_test75(int type, char **msgptr);
static void test76(void);
static void sub_test76(int type, char **msgptr);
static void test77(void);
static void sub_test77(int type, char **msgptr);
static void test78(void);
static void sub_test78(int type, char **msgptr);
static void test79(void);
static void sub_test79(int type, char **msgptr);
static void test80(void);
static void sub_test80(int type, char **msgptr);
static void test81(void);
static void sub_test81(int type, char **msgptr);
static void test82(void);
static void sub_test82(int type, char **msgptr);
static void test83(void);
static void sub_test83(int type, char **msgptr);
static void test84(void);
static void sub_test84(int type, char **msgptr);
static void test85(void);
static void sub_test85(int type, char **msgptr);
static void test86(void);
static void sub_test86(int type, char **msgptr);
static void test87(void);
static void sub_test87(int type, char **msgptr);
static void test88(void);
static void sub_test88(int type, char **msgptr);
static void test89(void);
static void sub_test89(int type, char **msgptr);
static void test90(void);
static void sub_test90(int type, char **msgptr);
static void test91(void);
static void sub_test91(int type, char **msgptr);
static void test92(void);
static void sub_test92(int type, char **msgptr);
static void test93(void);
static void sub_test93(int type, char **msgptr);
static void test94(void);
static void sub_test94(int type, char **msgptr);
static void test95(void);
static void sub_test95(int type, char **msgptr);
static void test96(void);
static void sub_test96a(int type, char **msgptr);
static void sub_test96b(int type, char **msgptr);
static void test97(void);
static void sub_test97a(int type, char **msgptr);
static void sub_test97b(int type, char **msgptr);
static void test98(void);
static void sub_test98a(int type, char **msgptr);
static void sub_test98b(int type, char **msgptr);
static void test99(void);
static void sub_test99a(int type, char **msgptr);
static void sub_test99b(int type, char **msgptr);
static void test100(void);
static void sub_test100(int type, char **msgptr);
static void test101(void);
static void sub_test101(int type, char **msgptr);
static void test102(void);
static void sub_test102(int type, char **msgptr);
static void test103(void);
static void sub_test103(int type, char **msgptr);
static void test104(void);
static void sub_test104(int type, char **msgptr);
static void test105(void);
static void sub_test105(int type, char **msgptr);
static void test106(void);
static void sub_test106(int type, char **msgptr);
static void test107(void);
static void sub_test107(int type, char **msgptr);
static void test108(void);
static void sub_test108(int type, char **msgptr);
static void test109(void);
static void sub_test109(int type, char **msgptr);
static void test110(void);
static void sub_test110(int type, char **msgptr);
static void test111(void);
static void sub_test111(int type, char **msgptr);
static void test112(void);
static void sub_test112(int type, char **msgptr);
static void test113(void);
static void sub_test113(int type, char **msgptr);
static void test114(void);
static void sub_test114(int type, char **msgptr);
static void test115(void);
static void sub_test115(int type, char **msgptr);
static void test116(void);
static void sub_test116(int type, char **msgptr);
static void test117(void);
static void sub_test117(int type, char **msgptr);
static void test118(void);
static void sub_test118(int type, char **msgptr);
static void test119(void);
static void sub_test119(int type, char **msgptr);

/*
 * Test case startup function.
 */
static void
prepare(void)
{
	int fd;
	int i;

	DBUG_ENTER("prepare");

	for (i = 0; i <= 4; i++)
	{
		/* Create log file */
		unlink(logfiles[i]);

		fd = open(logfiles[i], O_WRONLY|O_CREAT|O_EXCL,
			S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH);
		if (fd == -1)
		{
			in_rpt("Error creating %s", logfiles[i]);
			xx_all(DELETION, "Can't create log file to use with syslogd");
			DBUG_VOID_RETURN;
		}
	}

	/* Start up syslogd and tweak config file */
	if (setupsyslog("startup", logfile) != 0)
	{
		xx_all(DELETION, "Error starting/configuring syslogd");
		DBUG_VOID_RETURN;
	}

	DBUG_VOID_RETURN;
}

/*
 * Test case cleanup function.
 */
static void
clean(void)
{
	int i;

	DBUG_ENTER("clean");

	closelog();
	/* Tidy up syslog conf file etc. */
	setupsyslog("cleanup", NULL);

	/* Remove temporary log file */
	for (i = 0; i <= 4; i++)
		unlink(logfiles[i]);

	DBUG_VOID_RETURN;
}

static int
setupsyslog(char *cmd, char *arg)
{
	static char *args[4];

	DBUG_ENTER("setupsyslog");

	tet_child = fork();
	switch (tet_child)
	{
	case -1:
		in_rpt("fork failure in startup");
		DBUG_RETURN(-1);
	case 0:
		tet_setcontext();
		args[0] = setupprog;
		args[1] = cmd;
		args[2] = arg;
		args[3] = NULL;
		tet_exec(args[0], args, _environ);
		in_rpt("Failed to exec %s", setupprog);
		DBUG_EXIT(1);
	}

	switch (wait_child(WAITTIME))
	{
	case CHLD_EXIT:
		if (ex_code == 0)
		{
			/* Give syslogd time to sort itself out */
			sleep(WAITLOGDSECS * 2);
		}
		else
		{
			in_rpt("%s exited with status %d", setupprog, ex_code);
		}
		DBUG_RETURN(ex_code);
	case CHLD_ABRT:
		in_rpt("%s terminated by signal %d", setupprog, sg_code);
		DBUG_RETURN(-1);
	case CHLD_LIVE:
		in_rpt("%s timed out", setupprog);
		break;
	case CHLD_STOP:
		in_rpt("%s stopped", setupprog);
		break;
	default:
		in_rpt("Error in waitpid()");
		break;
	}

	kill(tet_child, SIGKILL);
	DBUG_RETURN(-1);
}

/*
 * Common code for testing syslog().
 *
 * cmpform can be CMP_PLAINSTRING or CMP_USE_SPRINTF.
 * cmparg is the string to compare (CMP_PLAINSTRING) or the vsprintf format
 * to use (CMP_USE_SPRINTF).
 *
 * chkfn is a pointer to a function to call to perform additional checks.
 * If NULL it is not used.
 * chkarg is passed to chkfn.
 */
static void
comntest(unsigned testopts, char *cmparg,
	int (*chkfn)(char *, void *), void *chkarg, char *ident,
	void (*runfn)(int, char **), char *expmsg, char *uselog)
{
	int pathok = 0;
	int err;
	int count;
	FILE *fp;
	struct stat statbefore;
	struct stat statafter;
	char gotmsg[MAXSTRINGSIZE];
	char *msgptr;
	int foundit;
	va_list ap;

	DBUG_ENTER("comntest");

	/* Reset logging attributes and priority */
	if (!(testopts & TOPT_NOOPENLOG)) {
		closelog();
		openlog(ident, LOG_ODELAY, LOG_USER);
	}

	setlogmask(LOG_MASK(LOG_DEBUG|LOG_WARNING));

	/* Open log file for reading */
	fp = fopen(uselog, "r");
	if (fp == NULL)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("Error opening log file (%s) for reading (%s)",
			uselog, errname(err));
		DBUG_VOID_RETURN;
	}
	else
	{
		PATH_TRACE;
	}

	/* Seek to the end of the log file */
	if (fseek(fp, 0L, SEEK_END) == 0)
	{
		PATH_TRACE;
	}
	else
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("fseek() failed, errno = %s", errname(err));
		(void) fclose(fp);
		DBUG_VOID_RETURN;
	}

	/* Retrieve modification time using stat() */
	if (stat(uselog, &statbefore) == 0)
	{
		PATH_TRACE;
	}
	else
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("stat() failed, errno = %s", errname(err));
		(void) fclose(fp);
		DBUG_VOID_RETURN;
	}

	sleep(1);

	/* Call syslog() to log the message */
	errno = TOPT_GETERRNO(testopts);
	runfn(CALL_SYSLOG, &msgptr);

	/* Loop - waiting for syslogd to log message */
	for (count = 1; count < WAITLOGDSECS; count++)
	{
		if (stat(uselog, &statafter) != 0)
		{
			err = errno;
			xx_rpt(DELETION);
			in_rpt("stat() failed, errno = %s (%d)",
				errname(err), err);
			(void) fclose(fp);
			DBUG_VOID_RETURN;
		}

		if (statafter.st_mtime > statbefore.st_mtime)
			break;

		sleep(1);
	}

	if (statafter.st_mtime > statbefore.st_mtime)
	{
		PATH_TRACE;
	}
	else
	{
		xx_rpt(FAILURE);
		in_rpt("syslog() failed to send message to logging facility");
		in_rpt("  Message = \"%s\"", expmsg);
		(void) fclose(fp);
		DBUG_VOID_RETURN;
	}

	/* Read latest addition to log file and verify syslog() message was
	 * logged with correct format.
	 */
	foundit = 0;

	while (fgets(gotmsg, sizeof(gotmsg), fp) != NULL)
	{
		if (strstr(gotmsg, expmsg) != NULL)
		{
			foundit = 1;
			break;
		}
	}

	if (ferror(fp))
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("fgets() failed, errno = %s", errname(err));
		(void) fclose(fp);
		DBUG_VOID_RETURN;
	}
	else
	{
		PATH_TRACE;
	}

	if (foundit)
	{
		PATH_TRACE;
	}
	else
	{
		xx_rpt(FAILURE);
		in_rpt("syslog() failed to format argument correctly");
		in_rpt("  Received: \"%s\"", gotmsg);
		in_rpt("  Expected: \"%s\"", expmsg);
		(void) fclose(fp);
		DBUG_VOID_RETURN;
	}

	/* If the caller provided a function to perform extra checks, call
	 * it here.
	 */
	if (chkfn == NULL)
	{
		PATH_TRACE;
	}
	else if ((*chkfn)(gotmsg, chkarg) == 0)
	{
		PATH_TRACE;
	}
	else
	{
		(void) fclose(fp);
		DBUG_VOID_RETURN;
	}

	PATH_XS_RPT(7);
	(void) fclose(fp);
	DBUG_VOID_RETURN;
}

static void
gettimestamp(char *tbuf, int buflen)
{
        time_t tod;

	tod = time(NULL);
	strftime(tbuf, buflen, TIMESTAMPFMT, localtime(&tod));
}

static int
checklong(char *msg, void *chkarg)
{
	long expval;
	long gotval;

	expval = (long)strlen(testmsg);
	gotval = *(long *)chkarg;

	if (gotval == expval)
		return 0;

	xx_rpt(FAILURE);
	in_rpt("Correct length not written to long argument (%ld expecting %ld)",
		gotval, expval);
	return -1;
}

static int
checkint(char *msg, void *chkarg)
{
	int expval;
	int gotval;

	expval = (int)strlen(testmsg);
	gotval = *(int *)chkarg;

	if (gotval == expval)
		return 0;

	xx_rpt(FAILURE);
	in_rpt("Correct length not written to int argument (%d expecting %d)",
		gotval, expval);
	return -1;
}

static int
checkshort(char *msg, void *chkarg)
{
	int expval;
	int gotval;

	expval = (int)strlen(testmsg);
	gotval = *(short *)chkarg;

	if (gotval == expval)
		return 0;

	xx_rpt(FAILURE);
	in_rpt("Correct length not written to short argument (%d expecting %d)",
		gotval, expval);
	return -1;
}

/*
 * Check timestamp.
 * Timestamp must match time before or after syslog call, excluding seconds.
 * chkarg is time before call.
 */
static int
checktimestamp(char *msg, void *chkarg)
{
	char buf[TIMESTAMPBUFLEN];

	if (strstr(msg, chkarg) != NULL)
		return 0;

	gettimestamp(buf, sizeof(buf));

	if (strstr(msg, buf) != NULL)
		return 0;

	xx_rpt(FAILURE);
	in_rpt("Failed to find correct timestamp in logged message");
	in_rpt("  Message line: \"%s\"", msg);
	in_rpt("  Expected: \"%s\" or \"%s\"", chkarg, buf);
	return -1;
}


/********************* Beginning of test cases *********************/

static void
test1(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test1");

	msgptr = expmsg;
	sub_test1(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, checktimestamp, "test-syslog-1",
		"test-syslog-1", sub_test1, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test1(int type, char **result)
{

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, testmsg);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, testmsg);
	}

	return;
}
	
static void
test2(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test2");

	msgptr = expmsg;
	sub_test2(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-2", sub_test2, msgptr, logfiles[3]);

	DBUG_VOID_RETURN;
}

static void
sub_test2(int type, char **result)
{

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, testmsg);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_WARNING, testmsg);
	}

	return;
}

static void
test3(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test3");

	msgptr = expmsg;
	sub_test3(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-3", sub_test3, msgptr, logfiles[1]);

	DBUG_VOID_RETURN;
}

static void
sub_test3(int type, char **result)
{

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, testmsg);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_LOCAL1|LOG_DEBUG, testmsg);
	}

	return;
}
	
static void
test4(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test4");

	msgptr = expmsg;
	sub_test4(CALL_SPRINTF, &msgptr);
	
	closelog();
	openlog("test-syslog-4", LOG_ODELAY, LOG_LOCAL2);

	comntest(TOPT_NOOPENLOG, testmsg, NULL, NULL,
		"test-syslog-4", sub_test4, msgptr, logfiles[2]);

	DBUG_VOID_RETURN;
}

static void
sub_test4(int type, char **result)
{

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, testmsg);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, testmsg);
	}

	return;
}
	
static void
test5(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test5");

	msgptr = expmsg;
	sub_test5(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-5", sub_test5, msgptr, logfiles[4]);

	DBUG_VOID_RETURN;
}

static void
sub_test5(int type, char **result)
{

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, testmsg);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_INFO, testmsg);
	}

	return;
}
	
static void
test6(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test6");

	msgptr = expmsg;
	sub_test6(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-6", sub_test6, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test6(int type, char **result)
{

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "24");
	}

	if (type == CALL_SYSLOG)
	{
		errno = 24;
		syslog(LOG_INFO, "%m");
	}

	return;
}

static void
test7(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test7");

	msgptr = expmsg;
	sub_test7(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-7", sub_test7, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test7(int type, char **result)
{

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, testmsg);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_INFO, testmsg);
	}

	return;
}

static void
test8(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test8");

	msgptr = expmsg;
	sub_test8(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-8", sub_test8, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test8(int type, char **result)
{
	int     i = 12345;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%3d%d", i, i);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%3d%d", i, i);
	}

	return;
}

static void
test9(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test9");

	msgptr = expmsg;
	sub_test9(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-9", sub_test9, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test9(int type, char **result)
{
	int     i = 12345;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%d%d", i, -i);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%d%d", i, -i);
	}

	return;
}

static void
test10(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test10");

	msgptr = expmsg;
	sub_test10(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-10", sub_test10, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test10(int type, char **result)
{
	int     i = 12345;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%i%i", i, -i);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%i%i", i, -i);
	}

	return;
}

static void
test11(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test11");

	msgptr = expmsg;
	sub_test11(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-11", sub_test11, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test11(int type, char **result)
{
	unsigned int     i = 12345;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%o", i);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%o", i);
	}

	return;
}
	
static void
test12(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test12");

	msgptr = expmsg;
	sub_test12(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-12", sub_test12, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test12(int type, char **result)
{
	unsigned int     i = 12345;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%u", i);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%u", i);
	}

	return;
}
	
static void
test13(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test13");

	msgptr = expmsg;
	sub_test13(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-13", sub_test13, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test13(int type, char **result)
{
	unsigned int     i = 11259;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%x", i);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%x", i);
	}

	return;
}
	
static void
test14(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test14");

	msgptr = expmsg;
	sub_test14(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-14", sub_test14, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test14(int type, char **result)
{
	unsigned int     i = 11259;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%X", i);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%X", i);
	}

	return;
}
	
static void
test15(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test15");

	msgptr = expmsg;
	sub_test15(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-15", sub_test15, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test15(int type, char **result)
{
	double  f = 12.3;
        double  d = 321.7654321;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%f %f", -f, d);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%f %f", -f, d);
	}

	return;
}

static void
test16(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test16");

	msgptr = expmsg;
	sub_test16(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-16", sub_test16, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test16(int type, char **result)
{
	double  f = -0.0123;
        double  d = 321.7654321;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%e %e", f, d);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%e %e", f, d);
	}

	return;
}

static void
test17(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test17");

	msgptr = expmsg;
	sub_test17(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-17", sub_test17, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test17(int type, char **result)
{
        double  d = 1e25;

	d *= d;
	d *= d;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%e", d);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%e", d);
	}

	return;
}

static void
test18(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test18");

	msgptr = expmsg;
	sub_test18(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-18", sub_test18, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test18(int type, char **result)
{
	double  f = -0.0123;
        double  d = 321.7654321;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%E %E", f, d);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%E %E", f, d);
	}

	return;
}
	
static void
test19(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test19");

	msgptr = expmsg;
	sub_test19(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-19", sub_test19, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test19(int type, char **result)
{
	double  d1 = 0.0001555;
        double  d2 = 12345.1234546;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%g %g", d1, d2);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%g %g", d1, d2);
	}

	return;
}
	
static void
test20(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test20");

	msgptr = expmsg;
	sub_test20(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-20", sub_test20, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test20(int type, char **result)
{
	double  d1 = 0.00001555;
        double  d2 = 12345678.1234546;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%g %g", d1, d2);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%g %g", d1, d2);
	}

	return;
}
	
static void
test21(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test21");

	msgptr = expmsg;
	sub_test21(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-21", sub_test21, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test21(int type, char **result)
{
	double  d1 = 0.00001555;
        double  d2 = 12345678.1234546;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%G %G", d1, d2);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%G %G", d1, d2);
	}

	return;
}
	
static void
test22(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test22");

	msgptr = expmsg;
	sub_test22(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-22", sub_test22, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test22(int type, char **result)
{
	double  d = 9.0500001;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%g %G", d, d);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%g %G", d, d);
	}

	return;
}
	
static void
test23(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test23");

	msgptr = expmsg;
	sub_test23(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-23", sub_test23, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test23(int type, char **result)
{
	double  d = 5.0000001;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%g %G", d, d);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%g %G", d, d);
	}

	return;
}
	
static void
test24(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test24");

	msgptr = expmsg;
	sub_test24(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-24", sub_test24, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test24(int type, char **result)
{
	char	c = 'a';

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%c", c);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%c", c);
	}

	return;
}
	
static void
test25(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test25");

	msgptr = expmsg;
	sub_test25(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-25", sub_test25, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test25(int type, char **result)
{
	char	*string = "hello world";

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%s", string);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%s", string);
	}

	return;
}
	
static void
test26(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test26");

	msgptr = expmsg;
	sub_test26(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-26", sub_test26, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test26(int type, char **result)
{
	wchar_t wc = 'a';

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%C", wc);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%C", wc);
	}

	return;
}
	
static void
test27(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test27");

	msgptr = expmsg;
	sub_test27(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-27", sub_test27, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test27(int type, char **result)
{
	static wchar_t nwcstr[] = {'a', 'b', 'c', (wchar_t)0};

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%S", nwcstr);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%S", nwcstr);
	}

	return;
}
	
static void
test28(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test28");

	msgptr = expmsg;
	sub_test28(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-28", sub_test28, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test28(int type, char **result)
{
	int	i;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%p", (void *)&i);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%p", (void *)&i);
	}

	return;
}
	
static void
test29(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test29");

	msgptr = expmsg;
	sub_test29(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-29", sub_test29, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test29(int type, char **result)
{
	char *s1 = "hello";
	char *s2 = "world";
	int	n1 = 0;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%s%n %s %d", s1, &n1, s2, n1);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%s%n %s %d", s1, &n1, s2, n1);
	}

	return;
}

static void
test30(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test30");

	msgptr = expmsg;
	sub_test30(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-30", sub_test30, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test30(int type, char **result)
{

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%%");
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%%");
	}

	return;
}
	
static void
test31(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test31");

	msgptr = expmsg;
	sub_test31(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-31", sub_test31, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test31(int type, char **result)
{
	long    d = 1234567890;
        long    i = 99999;
        unsigned long   o = 0127;
        unsigned long   u = 7654321;
        unsigned long   x = 0xfedca9;
        long    n1 = 0;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%ld %li %lo%ln %lu %lx %lX", d, i, 0, &n1, u, x, x);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%ld %li %lo%ln %lu %lx %lX", d, i, 0, &n1, u, x, x);
	}

	return;
}
	
static void
test32(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test32");

	msgptr = expmsg;
	sub_test32(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-32", sub_test32, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test32(int type, char **result)
{
	int    d = 12345;
        int    i = 9999;
        unsigned int   o = 0127;
        unsigned int   u = 7654;
        unsigned int   x = 0xca9;
        short    n1 = 0;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%hd %hi %ho%hn %hu %hx %hX", d, i, 0, &n1, u, x, x);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%hd %hi %ho%hn %hu %hx %hX", d, i, 0, &n1, u, x, x);
	}

	return;
}

static void
test33(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test33");

	msgptr = expmsg;
	sub_test33(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-33", sub_test33, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test33(int type, char **result)
{
	double  g1 = -0.01;
        double  g2 = 0.01;
        double  g3 = 1e-5;
        double  g4 = 1.4;
        double  g5 = -1.4;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%.d %.hi %.lo %.f %.e %.g %.g %.g %.g %.g %.s %.d %.hi %.lo", i , h , l , d , d , g1 , g2 , g3 , g4 , g5 , s , 0 , 0 , 0L);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%.d %.hi %.lo %.f %.e %.g %.g %.g %.g %.g %.s %.d %.hi %.lo", i , h , l , d , d , g1 , g2 , g3 , g4 , g5 , s , 0 , 0 , 0L);
	}

	return;
}
	
static void
test34(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test34");

	msgptr = expmsg;
	sub_test34(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-34", sub_test34, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test34(int type, char **result)
{
	double  g1 = -0.01;
        double  g2 = 0.01;
        double  g3 = 1e-5;
        double  g4 = 1.54321;
        double  g5 = -1.54321;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%.10d %.5hi %.15lo %.3f %.4e %.4g %.4g %.4g %.4g %.4g %.7s", i , h , l , d , d , g1 , g2 , g3 , g4 , g5 , s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%.10d %.5hi %.15lo %.3f %.4e %.4g %.4g %.4g %.4g %.4g %.7s", i , h , l , d , d , g1 , g2 , g3 , g4 , g5 , s , 0 , 0 , 0L);
	}

	return;
}

static void
test35(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test35");

	msgptr = expmsg;
	sub_test35(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-35", sub_test35, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test35(int type, char **result)
{
	double  g = 5.0000001;
        double  d = 321.7654321;
        char    c = 'a';
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;
        unsigned long   l = 1234567890;
        unsigned int    x = 0xba9;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%8d %5hi %14lo %5x %14f %14e %3g %4c %14s" , i , h , l , x , d , d , g , c , s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%8d %5hi %14lo %5x %14f %14e %3g %4c %14s" , i , h , l , x , d , d , g , c , s);
	}

	return;
}
	
static void
test36(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test36");

	msgptr = expmsg;
	sub_test36(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-36", sub_test36, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test36(int type, char **result)
{
	double  g = 5.0000001;
        double  d = 321.7654321;
        int     i = -12345;
        int     h = -1234;
        unsigned long   l = 1234567890;
        unsigned int    x = 0xba9;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%08d %06hi %014lo %05x %014f %016e %03g" , i , h , l , x , d , d , g);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%08d %06hi %014lo %05x %014f %016e %03g" , i , h , l , x , d , d , g);
	}

	return;
}
	
static void
test37(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test37");

	msgptr = expmsg;
	sub_test37(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-37", sub_test37, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test37(int type, char **result)
{
	double  g = 5.0000001;
        double  d = 321.7654321;
        int     i = 12345;
        int     h = 1234;
        unsigned long   l = 1234567890;
	char	*s = "test string";


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%8.d %5.hi %14.lo %14.f %14.e %3.g %14.s" , i , h , l , d , d , g , s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%8.d %5.hi %14.lo %14.f %14.e %3.g %14.s" , i , h , l , d , d , g , s);
	}

	return;
}
	
static void
test38(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test38");

	msgptr = expmsg;
	sub_test38(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-38", sub_test38, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test38(int type, char **result)
{
	double  g = 5.0000001;
        double  d = 321.7654321;
        int     i = 12345;
        int     h = 1234;
        unsigned long   l = 1234567890;
	char	*s = "test string";


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%8.5d %5.2hi %14.5lo %14.3f %16.8e %3.4g %14.15s" , i , h , l , d , d , g , s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%8.5d %5.2hi %14.5lo %14.3f %16.8e %3.4g %14.15s" , i , h , l , d , d , g , s);
	}

	return;
}
	
static void
test39(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test39");

	msgptr = expmsg;
	sub_test39a(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-39a", sub_test39a, msgptr, logfiles[0]);

	sub_test39b(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-39b", sub_test39b, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test39a(int type, char **result)
{
	double  g = 5.0000001;
        double  d = 321.7654321;
        int     i = 12345;
        int     h = 1234;
        unsigned long   l = 1234567890;
	char	*s = "test string";
	char	c = 'a';


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result,"%*d %*hi %*lo %*f %*e %*g %*c %*s" , 8 , i , 5 , h , 14 , l , 14 , d , 14 , d , 3 , g , 4 , c , 14 , s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%*d %*hi %*lo %*f %*e %*g %*c %*s" , 8 , i , 5 , h , 14 , l , 14 , d , 14 , d , 3 , g , 4 , c , 14 , s);
	}

	return;
}
	
static void
sub_test39b(int type, char **result)
{
	double  g = 5.0000001;
        double  d = 321.7654321;
        int     i = 12345;
        int     h = 1234;
        unsigned long   l = 1234567890;
	char	*s = "test string";
	char	c = 'a';


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result,"%*d %*hi %*lo %*f %*e %*g %*c %*s" , -8 , i , -5 , h , -14 , l , -14 , d , -14 , d , -3 , g , -4 , c , -14 , s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%*d %*hi %*lo %*f %*e %*g %*c %*s" , -8 , i , -5 , h , -14 , l , -14 , d , -14 , d , -3 , g , -4 , c , -14 , s);
	}

	return;
}
	
static void
test40(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test40");

	msgptr = expmsg;
	sub_test40a(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-40a", sub_test40a, msgptr, logfiles[0]);

	sub_test40b(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-40b", sub_test40b, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test40a(int type, char **result)
{
	double  g1 = -0.01;
        double  g2 = 0.01;
        double  g3 = 1e-5;
        double  g4 = 1.54321;
        double  g5 = -1.54321;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result,"%.*d %.*hi %.*lo %.*f %.*e %.*g %.*g %.*g %.*g %.*g %.*s" , 10 , i , 5 , h , 15 , l , 3 , d , 4 , d , 2 , g1 , 2 , g2 , 4 , g3 , 4 , g4 , 4 , g5 , 7 , s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%.*d %.*hi %.*lo %.*f %.*e %.*g %.*g %.*g %.*g %.*g %.*s" , 10 , i , 5 , h , 15 , l , 3 , d , 4 , d , 2 , g1 , 2 , g2 , 4 , g3 , 4 , g4 , 4 , g5 , 7 , s);
	}

	return;
}
	
static void
sub_test40b(int type, char **result)
{
	double  g1 = -0.01;
        double  g2 = 0.01;
        double  g3 = 1e-5;
        double  g4 = 1.54321;
        double  g5 = -1.54321;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result,"%.*d %.*hi %.*lo %.*f %.*e %.*g %.*g %.*g %.*g %.*g %.*s" , -10 , i , -5 , h , -15 , l , -3 , d , -4 , d , -2 , g1 , -2 , g2 , -4 , g3 , -4 , g4 , -4 , g5 , -7 , s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%.*d %.*hi %.*lo %.*f %.*e %.*g %.*g %.*g %.*g %.*g %.*s" , -10 , i , -5 , h , -15 , l , -3 , d , -4 , d , -2 , g1 , -2 , g2 , -4 , g3 , -4 , g4 , -4 , g5 , -7 , s);
	}

	return;
}
	
static void
test41(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test41");

	msgptr = expmsg;
	sub_test41a(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-41a", sub_test41a, msgptr, logfiles[0]);

	sub_test41b(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-41b", sub_test41b, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test41a(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result,"%*.d %*.hi %*.lo %*.f %*.e %*.g %*.s" , 8 , i , 5 , h , 14 , l , 14 , d , 14 , d , 3 , g , 14 , s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%*.d %*.hi %*.lo %*.f %*.e %*.g %*.s" , 8 , i , 5 , h , 14 , l , 14 , d , 14 , d , 3 , g , 14 , s);
	}

	return;
}
	
static void
sub_test41b(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result,"%*.d %*.hi %*.lo %*.f %*.e %*.g %*.s" , -8 , i , -5 , h , -14 , l , -14 , d , -14 , d , -3 , g , -14 , s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%*.d %*.hi %*.lo %*.f %*.e %*.g %*.s" , -8 , i , -5 , h , -14 , l , -14 , d , -14 , d , -3 , g , -14 , s);
	}

	return;
}
	
static void
test42(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test42");

	msgptr = expmsg;
	sub_test42a(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-42a", sub_test42a, msgptr, logfiles[0]);

	sub_test42b(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-42b", sub_test42b, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test42a(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result,"%*.*d %*.*hi %*.*lo %*.*f %*.*e %*.*g %*.*s" , 8 , 5 , i , 5 , 2 , h , 14 , 5 , l , 14 , 3 , d , 16 , 8 , d , 3 , 4 , g , 14 , 15 , s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%*.*d %*.*hi %*.*lo %*.*f %*.*e %*.*g %*.*s" , 8 , 5 , i , 5 , 2 , h , 14 , 5 , l , 14 , 3 , d , 16 , 8 , d , 3 , 4 , g , 14 , 15 , s);
	}

	return;
}
	
static void
sub_test42b(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result,"%*.*d %*.*hi %*.*lo %*.*f %*.*e %*.*g %*.*s" , -8 , -5 , i , -5 , -2 , h , -14 , -5 , l , -14 , -3 , d , -16 , -8 , d , -3 , -4 , g , -14 , -15 , s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%*.*d %*.*hi %*.*lo %*.*f %*.*e %*.*g %*.*s" , -8 , -5 , i , -5 , -2 , h , -14 , -5 , l , -14 , -3 , d , -16 , -8 , d , -3 , -4 , g , -14 , -15 , s);
	}

	return;
}
	
static void
test43(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test43");

	msgptr = expmsg;
	sub_test43(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-43", sub_test43, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test43(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
	char	c = 'a';
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%#f %#e %#o %#lo %#x %#lX %#g %#d %#c %#s %#hi" , d , d , u , l , u , l , g , i, c, s, h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%#f %#e %#o %#lo %#x %#lX %#g %#d %#c %#s %#hi" , d , d , u , l , u , l , g , i, c, s, h);
	}

	return;
}

static void
test44(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test44");

	msgptr = expmsg;
	sub_test44(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-44", sub_test44, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test44(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
	char	c = 'a';
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "% u % lo % c % s % d % d % f % e % g % hi % hi" , u , l , c , s , -i , i , d , d , g , h , -h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "% u % lo % c % s % d % d % f % e % g % hi % hi" , u , l , c , s , -i , i , d , d , g , h , -h);
	}

	return;
}

static void
test45(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test45");

	msgptr = expmsg;
	sub_test45(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-45", sub_test45, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test45(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
	char	c = 'a';
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%+u %+lo %+c %+s %+d %+d %+f %+e %+g %+hi %+hi" , u , l , c , s , -i , i , d , d , g , h , -h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%+u %+lo %+c %+s %+d %+d %+f %+e %+g %+hi %+hi" , u , l , c , s , -i , i , d , d , g , h , -h);
	}

	return;
}

static void
test46(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test46");

	msgptr = expmsg;
	sub_test46(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-46", sub_test46, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test46(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
	char	c = 'a';
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%-8u %-14lo %-4c %-14s %-8d %-8d %-14f %-14e %-3g %-6hi %-6hi" , u , l , c , s , -i , i , d , d , g , h , -h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%-8u %-14lo %-4c %-14s %-8d %-8d %-14f %-14e %-3g %-6hi %-6hi" , u , l , c , s , -i , i , d , d , g , h , -h);
	}

	return;
}

static void
test47(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test47");

	msgptr = expmsg;
	sub_test47(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-47", sub_test47, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test47(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
	char	c = 'a';
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%+-8u %+-14lo %+-4c %+-14s %+-8d %+-8d %+-14f %+-14e %+-3g %+-6hi %+-6hi" , u , l , c , s , -i , i , d , d , g , h , -h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%+-8u %+-14lo %+-4c %+-14s %+-8d %+-8d %+-14f %+-14e %+-3g %+-6hi %+-6hi" , u , l , c , s , -i , i , d , d , g , h , -h);
	}

	return;
}

static void
test48(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test48");

	msgptr = expmsg;
	sub_test48(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-48", sub_test48, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test48(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
	char	c = 'a';
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "% -8u % -14lo % -4c % -14s % -8d % -8d % -14f % -14e % -3g % -6hi % -6hi" , u , l , c , s , -i , i , d , d , g , h , -h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "% -8u % -14lo % -4c % -14s % -8d % -8d % -14f % -14e % -3g % -6hi % -6hi" , u , l , c , s , -i , i , d , d , g , h , -h);
	}

	return;
}

static void
test49(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test49");

	msgptr = expmsg;
	sub_test49(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-49", sub_test49, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test49(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
	char	c = 'a';
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%+ u %+ lo %+ c %+ s %+ d %+ d %+ f %+ e %+ g %+ hi %+ hi" , u , l , c , s , -i , i , d , d , g , h , -h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%+ u %+ lo %+ c %+ s %+ d %+ d %+ f %+ e %+ g %+ hi %+ hi" , u , l , c , s , -i , i , d , d , g , h , -h);
	}

	return;
}

static void
test50(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test50");

	msgptr = expmsg;
	sub_test50(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-50", sub_test50, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test50(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
	char	c = 'a';
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%- +u %- +lo %- +c %- +s %- +d %- +d %- +f %- +e %- +g %- +hi %- +hi" , u , l , c , s , -i , i , d , d , g , h , -h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%- +u %- +lo %- +c %- +s %- +d %- +d %- +f %- +e %- +g %- +hi %- +hi" , u , l , c , s , -i , i , d , d , g , h , -h);
	}

	return;
}

static void
test51(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test51");

	msgptr = expmsg;
	sub_test51(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-51", sub_test51, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test51(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%+8.*d %+6.*hi %+14.*lo %+14.*f %+16.*e %+3.*g %+14.*s" , 5 , i , 2 , h , 5 , l , 3 , d , 8 , d , 4 , g , 15 , s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG,  "%+8.*d %+6.*hi %+14.*lo %+14.*f %+16.*e %+3.*g %+14.*s" , 5 , i , 2 , h , 5 , l , 3 , d , 8 , d , 4 , g , 15 , s);
	}

	return;
}

static void
test52(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test52");

	msgptr = expmsg;
	sub_test52(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-52", sub_test52, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test52(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%-8.5d %-5.2hi %-14.5lo %-14.3f %-16.8e %-3.4g %-14.15s" , i , h , l , d , d , g , s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG,  "%-8.5d %-5.2hi %-14.5lo %-14.3f %-16.8e %-3.4g %-14.15s" , i , h , l , d , d , g , s);
	}

	return;
}


static void
test53(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test53");

	msgptr = expmsg;
	sub_test53(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-53", sub_test53, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test53(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%+-8.d %+-6.hi %+-14.lo %+-14.f %+-14.e %+-3.g %+-14.s" , i , h , l , d , d , g , s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%+-8.d %+-6.hi %+-14.lo %+-14.f %+-14.e %+-3.g %+-14.s" , i , h , l , d , d , g , s);
	}

	return;
}

static void
test54(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test54");

	msgptr = expmsg;
	sub_test54(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-54", sub_test54, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test54(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%#.lo %#.f %#.e %#.g %#.d %#.hi %#.s", l,  d, d, d, i, h, s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%#.lo %#.f %#.e %#.g %#.d %#.hi %#.s", l,  d, d, d, i, h, s);
	}

	return;
}

static void
test55(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test55");

	msgptr = expmsg;
	sub_test55(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-55", sub_test55, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test55(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%#*.lo %#*.f %#*.e %#*.g %#*.d %#*.hi %#*.s", 14 , l , 14 , d , 14 , d , 3 , g, 8, i, 5, h, 14, s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%#*.lo %#*.f %#*.e %#*.g %#*.d %#*.hi %#*.s", 14 , l , 14 , d , 14 , d , 3 , g, 8, i, 5, h, 14, s);
	}

	return;
}

static void
test56(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test56");

	msgptr = expmsg;
	sub_test56(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-56", sub_test56, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test56(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%#.15lo %#.3f %#.4e %#.4g %#.10d %#.5hi %#.7s", l , d , d , g, i, h, s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG,  "%#.15lo %#.3f %#.4e %#.4g %#.10d %#.5hi %#.7s", l , d , d , g, i, h, s);
	}

	return;
}

static void
test57(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test57");

	msgptr = expmsg;
	sub_test57(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-57", sub_test57, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test57(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
	char	c = 'a';
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%# +*lo %# +*f %# +*e %# +*g %# +*d %# +*hi %# +*c %# +*s", 13, l , 13, d , 16, d , 10, g, 8, i, 6, h, 2, c, 12, s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%# +*lo %# +*f %# +*e %# +*g %# +*d %# +*hi %# +*c %# +*s", 13, l , 13, d , 16, d , 10, g, 8, i, 6, h, 2, c, 12, s);
	}

	return;
}

static void
test58(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test58");

	msgptr = expmsg;
	sub_test58(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-58", sub_test58, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test58(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%#+-.*lo %#+-.*f %#+-.*e %#+-.*g %#+-.*d %#+-.*hi %#+-.*s", 15, l , 3, d , 4, d , 4, g, 10, i, 6, h, 7, s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%#+-.*lo %#+-.*f %#+-.*e %#+-.*g %#+-.*d %#+-.*hi %#+-.*s", 15, l , 3, d , 4, d , 4, g, 10, i, 6, h, 7, s);
	}

	return;
}

static void
test59(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test59");

	msgptr = expmsg;
	sub_test59(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-59", sub_test59, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test59(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%# *.*lo %# *.*f %# *.*e %# *.*g %# *.*d %# *.*hi %# *.*s", 14, 5, l , 7, 3, d , 16, 8, d , 4, 2, g, 8, 5, i, 5, 2, h, 14, 15, s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%# *.*lo %# *.*f %# *.*e %# *.*g %# *.*d %# *.*hi %# *.*s", 14, 5, l , 7, 3, d , 16, 8, d , 4, 2, g, 8, 5, i, 5, 2, h, 14, 15, s);
	}

	return;
}

static void
test60(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test60");

	msgptr = expmsg;
	sub_test60(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-60", sub_test60, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test60(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
	char    c = 'a';
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%#- +14lo %#- +14f %#- +16e %#- +3g %#- +8d %#- +6hi %#- +4c %#- +14s" , l , d , d , g , i , h , c , s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%#- +14lo %#- +14f %#- +16e %#- +3g %#- +8d %#- +6hi %#- +4c %#- +14s" , l , d , d , g , i , h , c , s);
	}

	return;
}

static void
test61(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test61");

	msgptr = expmsg;
	sub_test61(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-61", sub_test61, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test61(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%#-*.5lo %#-*.3f %#-*.8e %#-*.4g $#-*.5d %#-*.2hi %#-*.10s" , 14 , l , 14 , d , 16 , d , 3 , g , 8 , i , 5 , h , 12 , s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%#-*.5lo %#-*.3f %#-*.8e %#-*.4g $#-*.5d %#-*.2hi %#-*.10s" , 14 , l , 14 , d , 16 , d , 3 , g , 8 , i , 5 , h , 12 , s);
	}

	return;
}

static void
test62(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test62");

	msgptr = expmsg;
	sub_test62(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-62", sub_test62, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test62(int type, char **result)
{
	long double     d1 = -12.3;
        long double     d2 = -0.0123;
        long double     d3 =  0.0001555;
        long double     d4 = 321.765432;
        long double     d5 = 12345.1234546;
        long double     d6 = 12345678.1234546;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%Lf %Le %Lg %LE %LG %Lf %Le %Lg %LE %LG" , d1 , d2 , d3 , d2 , d3 , d4 , d4 , d5 , d4 , d6);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%Lf %Le %Lg %LE %LG %Lf %Le %Lg %LE %LG" , d1 , d2 , d3 , d2 , d3 , d4 , d4 , d5 , d4 , d6);
	}

	return;
}

public void
test63()
{
        DBUG_ENTER("test63");

        (void) cppair(t63, NULLFN, WAITTIME, 0);

        DBUG_VOID_RETURN;
}

static void
t63(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("t63");

	if (setlocale(LC_NUMERIC, RAD1LANG) == (char *)NULL)
        {
		xx_rpt(DELETION);
                in_rpt("Pseudo language %s not available", RAD1LANG);
                in_rpt("Check installation of pseudo language");
                DBUG_VOID_RETURN;
        }

	msgptr = expmsg;
	sub_test63(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-63", sub_test63, msgptr, logfiles[0]);

	if (setlocale(LC_ALL, RAD2LANG) == (char *)NULL)
        {
		xx_rpt(DELETION);
                in_rpt("Pseudo language %s not available", RAD2LANG);
                in_rpt("Check installation of pseudo language");
                DBUG_VOID_RETURN;
        }

	sub_test63(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-63", sub_test63, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test63(int type, char **result)
{
	double d = 12.35;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%e" , d);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%e" , d);
	}

	return;
}

public void
test64()
{
        DBUG_ENTER("test64");

        (void) cppair(t64, NULLFN, WAITTIME, 0);

        DBUG_VOID_RETURN;
}

static void
t64(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("t64");

	if (setlocale(LC_ALL, NORADIXLANG) == (char *)NULL)
        {
		xx_rpt(DELETION);
                in_rpt("Pseudo language %s not available", NORADIXLANG);
                in_rpt("Check installation of pseudo language");
                DBUG_VOID_RETURN;
        }

	msgptr = expmsg;
	sub_test64(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-64", sub_test64, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test64(int type, char **result)
{
	double d = 12.35;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%e" , d);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%e" , d);
	}

	return;
}

static void
test65(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test65");

	msgptr = expmsg;
	sub_test65(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-65", sub_test65, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test65(int type, char **result)
{
	int     i = 12345;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%2$3d%1$d", i, i);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%2$3d%1$d", i, i);
	}

	return;
}

static void
test66(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test66");

	msgptr = expmsg;
	sub_test66(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-66", sub_test66, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test66(int type, char **result)
{
	int     i = 12345;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%2$d%1$d", i, -i);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%2$d%1$d", i, -i);
	}

	return;
}

static void
test67(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test67");

	msgptr = expmsg;
	sub_test67(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-67", sub_test67, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test67(int type, char **result)
{
	int     i = 12345;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%2$i%1$i", i, -i);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%2$i%1$i", i, -i);
	}

	return;
}

static void
test68(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test68");

	msgptr = expmsg;
	sub_test68(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-68", sub_test68, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test68(int type, char **result)
{
	unsigned int     i = 12345;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%1$o", i);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$o", i);
	}

	return;
}
	
static void
test69(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test69");

	msgptr = expmsg;
	sub_test69(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-69", sub_test69, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test69(int type, char **result)
{
	unsigned int     i = 12345;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%1$u", i);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$u", i);
	}

	return;
}
	
static void
test70(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test70");

	msgptr = expmsg;
	sub_test70(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-70", sub_test70, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test70(int type, char **result)
{
	unsigned int     i = 11259;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%1$x", i);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$x", i);
	}

	return;
}
	
static void
test71(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test71");

	msgptr = expmsg;
	sub_test71(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-71", sub_test71, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test71(int type, char **result)
{
	unsigned int     i = 11259;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%1$X", i);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$X", i);
	}

	return;
}
	
static void
test72(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test72");

	msgptr = expmsg;
	sub_test72(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-72", sub_test72, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test72(int type, char **result)
{
	double  f = 12.3;
        double  d = 321.7654321;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%2$f %1$f",  d, -f);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%2$f %1$f",  d, -f);
	}

	return;
}

static void
test73(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test73");

	msgptr = expmsg;
	sub_test73(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-73", sub_test73, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test73(int type, char **result)
{
	double  f = -0.0123;
        double  d = 321.7654321;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%2$e %1$e", d, f);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%2$e %1$e", d, f);
	}

	return;
}

static void
test74(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test74");

	msgptr = expmsg;
	sub_test74(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-74", sub_test74, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test74(int type, char **result)
{
        double  d = 1e25;

	d *= d;
	d *= d;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%1$e", d);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$e", d);
	}

	return;
}

static void
test75(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test75");

	msgptr = expmsg;
	sub_test75(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-75", sub_test75, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test75(int type, char **result)
{
	double  f = -0.0123;
        double  d = 321.7654321;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%2$E %1$E", d, f);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%2$E %1$E", d, f);
	}

	return;
}
	
static void
test76(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test76");

	msgptr = expmsg;
	sub_test76(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-76", sub_test76, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test76(int type, char **result)
{
	double  d1 = 0.0001555;
        double  d2 = 12345.1234546;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%2$g %1$g", d2, d1);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%2$g %1$g", d2, d1);
	}

	return;
}
	
static void
test77(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test77");

	msgptr = expmsg;
	sub_test77(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-77", sub_test77, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test77(int type, char **result)
{
	double  d1 = 0.00001555;
        double  d2 = 12345678.1234546;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%2$g %1$g", d2, d1);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%2$g %1$g", d2, d1);
	}

	return;
}
	
static void
test78(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test78");

	msgptr = expmsg;
	sub_test78(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-78", sub_test78, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test78(int type, char **result)
{
	double  d1 = 0.00001555;
        double  d2 = 12345678.1234546;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%2$G %1$G", d2, d1);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%2$G %1$G", d2, d1);
	}

	return;
}
	
static void
test79(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test79");

	msgptr = expmsg;
	sub_test79(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-79", sub_test79, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test79(int type, char **result)
{
	double  d = 9.0500001;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%2$g %1$G", d, d);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%2$g %1$G", d, d);
	}

	return;
}
	
static void
test80(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test80");

	msgptr = expmsg;
	sub_test80(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-80", sub_test80, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test80(int type, char **result)
{
	double  d = 5.0000001;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%2$g %1$G", d, d);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%2$g %1$G", d, d);
	}

	return;
}
	
static void
test81(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test81");

	msgptr = expmsg;
	sub_test81(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-81", sub_test81, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test81(int type, char **result)
{
	char	c = 'a';

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%1$c", c);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$c", c);
	}

	return;
}
	
static void
test82(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test82");

	msgptr = expmsg;
	sub_test82(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-82", sub_test82, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test82(int type, char **result)
{
	char	*string = "hello world";

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%1$s", string);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$s", string);
	}

	return;
}
	
static void
test83(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test83");

	msgptr = expmsg;
	sub_test83(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-83", sub_test83, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test83(int type, char **result)
{
	wchar_t wc = 'a';

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%1$C", wc);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$C", wc);
	}

	return;
}
	
static void
test84(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test84");

	msgptr = expmsg;
	sub_test84(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-84", sub_test84, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test84(int type, char **result)
{
	static wchar_t nwcstr[] = {'a', 'b', 'c', (wchar_t)0};

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%1$S", nwcstr);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$S", nwcstr);
	}

	return;
}
	
static void
test85(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test85");

	msgptr = expmsg;
	sub_test85(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-85", sub_test85, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test85(int type, char **result)
{
	int	i;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%1$p", (void *)&i);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$p", (void *)&i);
	}

	return;
}
	
static void
test86(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test86");

	msgptr = expmsg;
	sub_test86(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-86", sub_test86, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test86(int type, char **result)
{
	char *s1 = "hello";
	char *s2 = "world";
	int	n1 = 0;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%1$s%3$n %2$s %d", s1, s2, &n1, n1);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$s%3$n %2$s %d", s1, s2, &n1, n1);
	}

	return;
}

static void
test87(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test87");

	msgptr = expmsg;
	sub_test87(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-87", sub_test87, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test87(int type, char **result)
{

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%1$s%%", "abc");
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$s%%", "abc");
	}

	return;
}
	
static void
test88(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test88");

	msgptr = expmsg;
	sub_test88(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-88", sub_test88, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test88(int type, char **result)
{
	long    d = 1234567890;
        long    i = 99999;
        unsigned long   o = 0127;
        unsigned long   u = 7654321;
        unsigned long   x = 0xfedca9;
        long    n1 = 0;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%7$ld %1$li %2$lo%3$ln %4$lu %5$lx %6$lX", i, 0, &n1, u, x, x, d);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%7$ld %1$li %2$lo%3$ln %4$lu %5$lx %6$lX", i, 0, &n1, u, x, x, d);
	}

	return;
}
	
static void
test89(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test89");

	msgptr = expmsg;
	sub_test89(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-89", sub_test89, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test89(int type, char **result)
{
	int    d = 12345;
        int    i = 9999;
        unsigned int   o = 0127;
        unsigned int   u = 7654;
        unsigned int   x = 0xca9;
        short    n1 = 0;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%7$hd %1$hi %2$ho%3$hn %4$hu %5$hx %6$hX", i, 0, &n1, u, x, x, d);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%7$hd %1$hi %2$ho%3$hn %4$hu %5$hx %6$hX", i, 0, &n1, u, x, x, d);
	}

	return;
}

static void
test90(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test90");

	msgptr = expmsg;
	sub_test90(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-90", sub_test90, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test90(int type, char **result)
{
	double  g1 = -0.01;
        double  g2 = 0.01;
        double  g3 = 1e-5;
        double  g4 = 1.4;
        double  g5 = -1.4;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%7$.d %8$.hi %1$.lo %2$.f %3$.e %4$.g %5$.g %6$.g %9$.g %10$.g %11$.s %12$.d %13$.hi %14$.lo", l , d , d , g1 , g2 , g3 , i , h , g4 , g5 , s , 0 , 0 , 0L);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%7$.d %8$.hi %1$.lo %2$.f %3$.e %4$.g %5$.g %6$.g %9$.g %10$.g %11$.s %12$.d %13$.hi %14$.lo", l , d , d , g1 , g2 , g3 , i , h , g4 , g5 , s , 0 , 0 , 0L);
	}

	return;
}
	
static void
test91(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test91");

	msgptr = expmsg;
	sub_test91(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-91", sub_test91, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test91(int type, char **result)
{
	double  g1 = -0.01;
        double  g2 = 0.01;
        double  g3 = 1e-5;
        double  g4 = 1.54321;
        double  g5 = -1.54321;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%5$.10d %6$.5hi %1$.15lo %2$.3f %3$.4e %4$.4g %7$.4g %8$.4g %9$.4g %10$.4g %11$.7s" , l , d , d , g1 , i , h , g2 , g3 , g4 , g5 , s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%5$.10d %6$.5hi %1$.15lo %2$.3f %3$.4e %4$.4g %7$.4g %8$.4g %9$.4g %10$.4g %11$.7s" , l , d , d , g1 , i , h , g2 , g3 , g4 , g5 , s);
	}

	return;
}

static void
test92(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test92");

	msgptr = expmsg;
	sub_test92(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-92", sub_test92, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test92(int type, char **result)
{
	double  g = 5.0000001;
        double  d = 321.7654321;
        char    c = 'a';
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;
        unsigned long   l = 1234567890;
        unsigned int    x = 0xba9;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%8$8d %9$5hi %1$14lo %2$5x %3$14f %4$14e %5$3g %6$4c %7$14s" , l , x , d , d , g , c , s , i , h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%8$8d %9$5hi %1$14lo %2$5x %3$14f %4$14e %5$3g %6$4c %7$14s" , l , x , d , d , g , c , s , i , h);
	}

	return;
}
	
static void
test93(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test93");

	msgptr = expmsg;
	sub_test93(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-93", sub_test93, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test93(int type, char **result)
{
	double  g = 5.0000001;
        double  d = 321.7654321;
        int     i = -12345;
        int     h = -1234;
        unsigned long   l = 1234567890;
        unsigned int    x = 0xba9;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%6$08d %7$06hi %1$014lo %2$05x %3$014f %04$16e %5$03g" , l , x , d , d , g , i , h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%6$08d %7$06hi %1$014lo %2$05x %3$014f %04$16e %5$03g" , l , x , d , d , g , i , h);
	}

	return;
}
	
static void
test94(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test94");

	msgptr = expmsg;
	sub_test94(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-94", sub_test94, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test94(int type, char **result)
{
	double  g = 5.0000001;
        double  d = 321.7654321;
        int     i = 12345;
        int     h = 1234;
        unsigned long   l = 1234567890;
	char	*s = "test string";


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%6$8.d %7$5.hi %1$14.lo %2$14.f %3$14.e %4$3.g %5$14.s" , l , d , d , g , s , i , h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%6$8.d %7$5.hi %1$14.lo %2$14.f %3$14.e %4$3.g %5$14.s" , l , d , d , g , s , i , h);
	}

	return;
}
	
static void
test95(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test95");

	msgptr = expmsg;
	sub_test95(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-95", sub_test95, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test95(int type, char **result)
{
	double  g = 5.0000001;
        double  d = 321.7654321;
        int     i = 12345;
        int     h = 1234;
        unsigned long   l = 1234567890;
	char	*s = "test string";


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%6$8.5d %7$5.2hi %1$14.5lo %2$14.3f %3$16.8e %4$3.4g %5$14.15s" , l , d , d , g , s , i , h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%6$8.5d %7$5.2hi %1$14.5lo %2$14.3f %3$16.8e %4$3.4g %5$14.15s" , l , d , d , g , s , i , h);
	}

	return;
}
	
static void
test96(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test96");

	msgptr = expmsg;
	sub_test96a(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-96a", sub_test96a, msgptr, logfiles[0]);

	sub_test96b(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-96b", sub_test96b, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test96a(int type, char **result)
{
	double  g = 5.0000001;
        double  d = 321.7654321;
        int     i = 12345;
        int     h = 1234;
        unsigned long   l = 1234567890;
	char	*s = "test string";
	char	c = 'a';


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result,"%1$*5$d %2$*6$hi %3$*7$lo %4$*8$f %9$*13$e %10$*14$g %11$*15$c %12$*16$s" , i , h , l , d , 8 , 5 , 14 , 14 , d , g , c , s , 14 , 3 , 4 , 14);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$*5$d %2$*6$hi %3$*7$lo %4$*8$f %9$*13$e %10$*14$g %11$*15$c %12$*16$s" , i , h , l , d , 8 , 5 , 14 , 14 , d , g , c , s , 14 , 3 , 4 , 14);
	}

	return;
}
	
static void
sub_test96b(int type, char **result)
{
	double  g = 5.0000001;
        double  d = 321.7654321;
        int     i = 12345;
        int     h = 1234;
        unsigned long   l = 1234567890;
	char	*s = "test string";
	char	c = 'a';


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result,"%1$*5$d %2$*6$hi %3$*7$lo %4$*8$f %9$*13$e %10$*14$g %11$*15$c %12$*16$s" , i , h , l , d , -8 , -5 , -14 , -14 , d , g , c , s , -14 , -3 , -4 , -14);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$*5$d %2$*6$hi %3$*7$lo %4$*8$f %9$*13$e %10$*14$g %11$*15$c %12$*16$s" , i , h , l , d , -8 , -5 , -14 , -14 , d , g , c , s , -14 , -3 , -4 , -14);
	}

	return;
}
	
static void
test97(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test97");

	msgptr = expmsg;
	sub_test97a(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-97a", sub_test97a, msgptr, logfiles[0]);

	sub_test97b(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-97b", sub_test97b, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test97a(int type, char **result)
{
	double  g1 = -0.01;
        double  g2 = 0.01;
        double  g3 = 1e-5;
        double  g4 = 1.54321;
        double  g5 = -1.54321;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result,"%1$.5$*d %2$.6$*hi %3$.7$*lo %4$.8$*f %9$.13$*e %10$.14$*g %11$.15$*g %12$.16$*g %17$.20$*g %18$.21$*g %19$.22$*s" , i , h , l , d , 10 , 5 , 15 , 3 , d , g1 , g2 , g3 , 4 , 2 , 2 , 4 , g4 , g5 , s, 4 , 4 , 7);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$.5$*d %2$.6$*hi %3$.7$*lo %4$.8$*f %9$.13$*e %10$.14$*g %11$.15$*g %12$.16$*g %17$.20$*g %18$.21$*g %19$.22$*s" , i , h , l , d , 10 , 5 , 15 , 3 , d , g1 , g2 , g3 , 4 , 2 , 2 , 4 , g4 , g5 , s, 4 , 4 , 7);
	}

	return;
}
	
static void
sub_test97b(int type, char **result)
{
	double  g1 = -0.01;
        double  g2 = 0.01;
        double  g3 = 1e-5;
        double  g4 = 1.54321;
        double  g5 = -1.54321;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%1$.5$*d %2$.6$*hi %3$.7$*lo %4$.8$*f %9$.13$*e %10$.14$*g %11$.15$*g %12$.16$*g %17$.20$*g %18$.21$*g %19$.22$*s" , i , h , l , d , -10 , -5 , -15 , -3 , d , g1 , g2 , g3 , -4 , -2 , -2 , -4 , g4 , g5 , s, -4 , -4 , -7);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$.5$*d %2$.6$*hi %3$.7$*lo %4$.8$*f %9$.13$*e %10$.14$*g %11$.15$*g %12$.16$*g %17$.20$*g %18$.21$*g %19$.22$*s" , i , h , l , d , -10 , -5 , -15 , -3 , d , g1 , g2 , g3 , -4 , -2 , -2 , -4 , g4 , g5 , s, -4 , -4 , -7);
	}

	return;
}
	
static void
test98(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test98");

	msgptr = expmsg;
	sub_test98a(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-98a", sub_test98a, msgptr, logfiles[0]);

	sub_test98b(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-98b", sub_test98b, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test98a(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result,"%1$*5$.d %2$*6$.hi %3$*7$.lo %4$*8$.f %9$*12$.e %10$*13$.g %11$*14$.s" , i , h , l , d , 8 , 5 , 14 , 14 , d , g , s , 14 , 3 , 14);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$*5$.d %2$*6$.hi %3$*7$.lo %4$*8$.f %9$*12$.e %10$*13$.g %11$*14$.s" , i , h , l , d , 8 , 5 , 14 , 14 , d , g , s , 14 , 3 , 14);
	}

	return;
}
	
static void
sub_test98b(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result,"%1$*5$.d %2$*6$.hi %3$*7$.lo %4$*8$.f %9$*12$.e %10$*13$.g %11$*14$.s" , i , h , l , d , -8 , -5 , -14 , -14 , d , g , s , -14 , -3 , -14);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$*5$.d %2$*6$.hi %3$*7$.lo %4$*8$.f %9$*12$.e %10$*13$.g %11$*14$.s" , i , h , l , d , -8 , -5 , -14 , -14 , d , g , s , -14 , -3 , -14);
	}

	return;
}
	
static void
test99(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test99");

	msgptr = expmsg;
	sub_test99a(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-99a", sub_test99a, msgptr, logfiles[0]);

	sub_test99b(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-99b", sub_test99b, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test99a(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result,"%1$*4$.*7$d %2$*5$.*8$hi %3$*6$.*9$lo %10$*13$.*16$f %11$*14$.*17$e %12$*15$.*18$g %19$*20$.*21$s" , i , h , l , 8 , 5 , 14 , 5 , 2 , 5 , d , d , g , 14 , 16 , 3 , 3 , 8 , 4 , s , 14 , 15);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$*4$.*7$d %2$*5$.*8$hi %3$*6$.*9$lo %10$*13$.*16$f %11$*14$.*17$e %12$*15$.*18$g %19$*20$.*21$s" , i , h , l , 8 , 5 , 14 , 5 , 2 , 5 , d , d , g , 14 , 16 , 3 , 3 , 8 , 4 , s , 14 , 15);
	}

	return;
}
	
static void
sub_test99b(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result,"%1$*4$.*7$d %2$*5$.*8$hi %3$*6$.*9$lo %10$*13$.*16$f %11$*14$.*17$e %12$*15$.*18$g %19$*20$.*21$s" , i , h , l , -8 , -5 , -14 , -5 , -2 , -5 , d , d , g , -14 , -16 , -3 , -3 , -8 , -4 , s , -14 , -15);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$*4$.*7$d %2$*5$.*8$hi %3$*6$.*9$lo %10$*13$.*16$f %11$*14$.*17$e %12$*15$.*18$g %19$*20$.*21$s" , i , h , l , -8 , -5 , -14 , -5 , -2 , -5 , d , d , g , -14 , -16 , -3 , -3 , -8 , -4 , s , -14 , -15);
	}

	return;
}
	
static void
test100(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test100");

	msgptr = expmsg;
	sub_test100(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-100", sub_test100, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test100(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
	char	c = 'a';
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%7$#f %1$#e %2$#o %3$#lo %4$#x %5$#lX %6$#g %8$#d %9$#c %10$#s %12$#hi" , d , u , l , u , l , g , d , i, c, s, h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%7$#f %1$#e %2$#o %3$#lo %4$#x %5$#lX %6$#g %8$#d %9$#c %10$#s %12$#hi" , d , u , l , u , l , g , d , i, c, s, h);
	}

	return;
}

static void
test101(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test101");

	msgptr = expmsg;
	sub_test101(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-101", sub_test101, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test101(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
	char	c = 'a';
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%9$ u %1$ lo %2$ c %3$ s %4$ d %5$ d %6$ f %7$ e %8$ g %10$ hi %11$ hi" , l , c , s , -i , i , d , d , g , u , h , -h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%9$ u %1$ lo %2$ c %3$ s %4$ d %5$ d %6$ f %7$ e %8$ g %10$ hi %11$ hi" , l , c , s , -i , i , d , d , g , u , h , -h);
	}

	return;
}

static void
test102(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test102");

	msgptr = expmsg;
	sub_test102(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-102", sub_test102, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test102(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
	char	c = 'a';
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%9$+u %1$+lo %2$+c %3$+s %4$+d %5$+d %6$+f %7$+e %8$+g %10$+hi %11$+hi" , l , c , s , -i , i , d , d , g , u , h , -h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%9$+u %1$+lo %2$+c %3$+s %4$+d %5$+d %6$+f %7$+e %8$+g %10$+hi %11$+hi" , l , c , s , -i , i , d , d , g , u , h , -h);
	}

	return;
}

static void
test103(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test103");

	msgptr = expmsg;
	sub_test103(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-103", sub_test103, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test103(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
	char	c = 'a';
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%9$-8u %1$-14lo %2$-4c %3$-14s %4$-8d %5$-8d %6$-14f %7$-14e %8$-3g %10$-6hi %11$-6hi" , l , c , s , -i , i , d , d , g , u , h , -h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%9$-8u %1$-14lo %2$-4c %3$-14s %4$-8d %5$-8d %6$-14f %7$-14e %8$-3g %10$-6hi %11$-6hi" , l , c , s , -i , i , d , d , g , u , h , -h);
	}

	return;
}

static void
test104(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test104");

	msgptr = expmsg;
	sub_test104(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-104", sub_test104, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test104(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
	char	c = 'a';
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%9$+-8u %1$+-14lo %2$+-4c %3$+-14s %4$+-8d %5$+-8d %6$+-14f %7$+-14e %8$+-3g %10$+-6hi %11$+-6hi" , l , c , s , -i , i , d , d , g , u , h , -h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%9$+-8u %1$+-14lo %2$+-4c %3$+-14s %4$+-8d %5$+-8d %6$+-14f %7$+-14e %8$+-3g %10$+-6hi %11$+-6hi" , l , c , s , -i , i , d , d , g , u , h , -h);
	}

	return;
}

static void
test105(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test105");

	msgptr = expmsg;
	sub_test105(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-105", sub_test105, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test105(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
	char	c = 'a';
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%9$ -8u %1$ -14lo %2$ -4c %3$ -14s %4$ -8d %5$ -8d %6$ -14f %7$ -14e %8$ -3g %10$ -6hi %11$ -6hi" , l , c , s , -i , i , d , d , g , u , h , -h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%9$ -8u %1$ -14lo %2$ -4c %3$ -14s %4$ -8d %5$ -8d %6$ -14f %7$ -14e %8$ -3g %10$ -6hi %11$ -6hi" , l , c , s , -i , i , d , d , g , u , h , -h);
	}

	return;
}

static void
test106(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test106");

	msgptr = expmsg;
	sub_test106(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-106", sub_test106, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test106(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
	char	c = 'a';
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%9$+ u %1$+ lo %2$+ c %3$+ s %4$+ d %5$+ d %6$+ f %7$+ e %8$+ g %10$+ hi %11$+ hi" , l , c , s , -i , i , d , d , g , u , h , -h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%9$+ u %1$+ lo %2$+ c %3$+ s %4$+ d %5$+ d %6$+ f %7$+ e %8$+ g %10$+ hi %11$+ hi" , l , c , s , -i , i , d , d , g , u , h , -h);
	}

	return;
}

static void
test107(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test107");

	msgptr = expmsg;
	sub_test107(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-107", sub_test107, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test107(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
	char	c = 'a';
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "9$%- +u %1$- +lo %2$- +c %3$- +s %4$- +d %5$- +d %6$- +f %7$- +e %8$- +g %10$- +hi %11$- +hi" , l , c , s , -i , i , d , d , g , u , h , -h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "9$%- +u %1$- +lo %2$- +c %3$- +s %4$- +d %5$- +d %6$- +f %7$- +e %8$- +g %10$- +hi %11$- +hi" , l , c , s , -i , i , d , d , g , u , h , -h);
	}

	return;
}

static void
test108(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test108");

	msgptr = expmsg;
	sub_test108(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-108", sub_test108, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test108(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%1$+8.*5$d %2$+6.*6$hi %3$+14.*7$lo %4$+14.*8$f %9$+16.*12$e %10$+3.*13$g %11$+14.*14$s" , i , h , l , d , 5 , 2 , 5 , 3 , d , g , s , 8 , 4 , 15);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG,  "%1$+8.*5$d %2$+6.*6$hi %3$+14.*7$lo %4$+14.*8$f %9$+16.*12$e %10$+3.*13$g %11$+14.*14$s" , i , h , l , d , 5 , 2 , 5 , 3 , d , g , s , 8 , 4 , 15);
	}

	return;
}

static void
test109(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test109");

	msgptr = expmsg;
	sub_test109(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-109", sub_test109, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test109(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%6$-8.5d %7$-5.2hi %1$-14.5lo %2$-14.3f %3$-16.8e %4$-3.4g %5$-14.15s" , l , d , d , g , s , i , h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG,  "%6$-8.5d %7$-5.2hi %1$-14.5lo %2$-14.3f %3$-16.8e %4$-3.4g %5$-14.15s" , l , d , d , g , s , i , h);
	}

	return;
}


static void
test110(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test110");

	msgptr = expmsg;
	sub_test110(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-110", sub_test110, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test110(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%6$+-8.d %7$+-6.hi %1$+-14.lo %2$+-14.f %3$+-14.e %4$+-3.g %5$+-14.s" , l , d , d , g , s , i , h);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%6$+-8.d %7$+-6.hi %1$+-14.lo %2$+-14.f %3$+-14.e %4$+-3.g %5$+-14.s" , l , d , d , g , s , i , h);
	}

	return;
}

static void
test111(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test111");

	msgptr = expmsg;
	sub_test111(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-111", sub_test111, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test111(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%7$#.lo %1$#.f %2$#.e %3$#.g %4$#.d %#5$.hi %6$#.s", d, d, d, i, h, s, l);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%7$#.lo %1$#.f %2$#.e %3$#.g %4$#.d %#5$.hi %6$#.s", d, d, d, i, h, s, l);
	}

	return;
}

static void
test112(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test112");

	msgptr = expmsg;
	sub_test112(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-112", sub_test112, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test112(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%1$#*5$.lo %2$#*6$.f %3$#*7$.e %4$#*8$.g %9$#*12$.d %10$#*13$.hi %11$#14$*.s", l , d , d , g, 14 , 14 , 14 , 3 , i, h,  s, 8 , 5 , 14);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$#*5$.lo %2$#*6$.f %3$#*7$.e %4$#*8$.g %9$#*12$.d %10$#*13$.hi %11$#14$*.s", l , d , d , g, 14 , 14 , 14 , 3 , i, h,  s, 8 , 5 , 14);
	}

	return;
}

static void
test113(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test113");

	msgptr = expmsg;
	sub_test113(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-113", sub_test113, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test113(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%4$#.15lo %1$#.3f %2$#.4e %3$#.4g %#5$.10d %6$#.5hi %7$#.7s", d , d , g, l, i, h, s);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%4$#.15lo %1$#.3f %2$#.4e %3$#.4g %#5$.10d %6$#.5hi %7$#.7s", d , d , g, l, i, h, s);
	}

	return;
}

static void
test114(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test114");

	msgptr = expmsg;
	sub_test114(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-114", sub_test114, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test114(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        unsigned int   u = 12345;
        double  d = 321.7654321;
	char	c = 'a';
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%1$# +*5$lo %2$# +*6$f %3$# +*7$e %4$# +*8$g %9$# +*13$d %10$# +*14$hi %11$# +*15$c %12$# +*16$s", l , d , d , g, 13, 12, 16, 10, i, h, c, s, 8, 6, 2, 12);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$# +*5$lo %2$# +*6$f %3$# +*7$e %4$# +*8$g %9$# +*13$d %10$# +*14$hi %11$# +*15$c %12$# +*16$s", l , d , d , g, 13, 12, 16, 10, i, h, c, s, 8, 6, 2, 12);
	}

	return;
}

static void
test115(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test115");

	msgptr = expmsg;
	sub_test115(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-115", sub_test115, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test115(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%1$#+-.*5$lo %2$#+-.*6$f %3$#+-.*7$e %4$#+-.*8$g %9$#+-.*12$d %10$#+-.*13$hi %11$#+-.*14$s", l , d , d , g, 15, 3, 4, 4, i, h, s, 10, 6, 7);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$#+-.*5$lo %2$#+-.*6$f %3$#+-.*7$e %4$#+-.*8$g %9$#+-.*12$d %10$#+-.*13$hi %11$#+-.*14$s", l , d , d , g, 15, 3, 4, 4, i, h, s, 10, 6, 7);
	}

	return;
}

static void
test116(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test116");

	msgptr = expmsg;
	sub_test116(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-116", sub_test116, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test116(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%$1# *$3.*$5lo %$2# *$4.*$6f %$7# *$9.*$11e %$8# *$10.*$12g %$13# *$15.*$17d %$14# *$16.*$18hi %$19# *$20.*$21s", l , d , 14, 7, 5, 3, d, g, 16, 4, 8, 2, i, h, 8, 5, 5, 2, s, 14, 15);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%$1# *$3.*$5lo %$2# *$4.*$6f %$7# *$9.*$11e %$8# *$10.*$12g %$13# *$15.*$17d %$14# *$16.*$18hi %$19# *$20.*$21s", l , d , 14, 7, 5, 3, d, g, 16, 4, 8, 2, i, h, 8, 5, 5, 2, s, 14, 15);
	}

	return;
}

static void
test117(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test117");

	msgptr = expmsg;
	sub_test117(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-117", sub_test117, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test117(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
	char    c = 'a';
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%4$#- +14lo %1$#- +14f %2$#- +16e %3$#- +3g %8$#- +8d %5$#- +6hi %6$#- +4c %7$#- +14s" , d , d , g , l , h , c , s, i);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%4$#- +14lo %1$#- +14f %2$#- +16e %3$#- +3g %8$#- +8d %5$#- +6hi %6$#- +4c %7$#- +14s" , d , d , g , l , h , c , s, i);
	}

	return;
}

static void
test118(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test118");

	msgptr = expmsg;
	sub_test118(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-118", sub_test118, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test118(int type, char **result)
{
	double  g = 5.0000001;
        unsigned long   l = 1234567890;
        double  d = 321.7654321;
        char    *s = "test-string";
        int     i = 12345;
        int     h = 1234;


	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%1$#-*5$.5lo %2$#-*6$.3f %3$#-*7$.8e %4$#-*8$.4g $9$#-*12$.5d %10$#-*13$.2hi %11$#-*14$.10s" , l , d , d , g , 14, 14, 16, 3, i , h , s, 8, 5, 12);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%1$#-*5$.5lo %2$#-*6$.3f %3$#-*7$.8e %4$#-*8$.4g $9$#-*12$.5d %10$#-*13$.2hi %11$#-*14$.10s" , l , d , d , g , 14, 14, 16, 3, i , h , s, 8, 5, 12);
	}

	return;
}

static void
test119(void)
{
	int pathok = 0;
	char expmsg[MAXSTRINGSIZE];
	char *msgptr;

	DBUG_ENTER("test119");

	msgptr = expmsg;
	sub_test119(CALL_SPRINTF, &msgptr);
	
	comntest(0U, testmsg, NULL, NULL,
		"test-syslog-119", sub_test119, msgptr, logfiles[0]);

	DBUG_VOID_RETURN;
}

static void
sub_test119(int type, char **result)
{
	long double     d1 = -12.3;
        long double     d2 = -0.0123;
        long double     d3 =  0.0001555;
        long double     d4 = 321.765432;
        long double     d5 = 12345.1234546;
        long double     d6 = 12345678.1234546;

	if (type == CALL_SPRINTF)
	{
		(void) sprintf(*result, "%5$Lf %1$Le %2$Lg %3$LE %4$LG %10$Lf %6$Le %7$Lg %8$LE %9$LG" , d2 , d3 , d2 , d3 , d1, d4 , d5 , d4 , d6, d4);
	}

	if (type == CALL_SYSLOG)
	{
		syslog(LOG_DEBUG, "%5$Lf %1$Le %2$Lg %3$LE %4$LG %10$Lf %6$Le %7$Lg %8$LE %9$LG" , d2 , d3 , d2 , d3 , d1, d4 , d5 , d4 , d6, d4);
	}

	return;
}

/************************ End of test cases ************************/

int no_tests = NO_TESTS;

void (*setfunc)() = prepare;
void (*clnfunc)() = clean;

struct tet_testlist tet_testlist[] =
{
	{ test1, 1 },
	{ test2, 1 },
	{ test3, 1 },
	{ test4, 1 },
	{ test5, 1 },
	{ test6, 1 },
	{ test7, 1 },
	{ test8, 1 },
	{ test9, 1 },
	{ test10, 1 },
	{ test11, 1 },
	{ test12, 1 },
	{ test13, 1 },
	{ test14, 1 },
	{ test15, 1 },
	{ test16, 1 },
	{ test17, 1 },
	{ test18, 1 },
	{ test19, 1 },
	{ test20, 1 },
	{ test21, 1 },
	{ test22, 1 },
	{ test23, 1 },
	{ test24, 1 },
	{ test25, 1 },
	{ test26, 1 },
	{ test27, 1 },
	{ test28, 1 },
	{ test29, 1 },
	{ test30, 1 },
	{ test31, 1 },
	{ test32, 1 },
	{ test33, 1 },
	{ test34, 1 },
	{ test35, 1 },
	{ test36, 1 },
	{ test37, 1 },
	{ test38, 1 },
	{ test39, 1 },
	{ test40, 1 },
	{ test41, 1 },
	{ test42, 1 },
	{ test43, 1 },
	{ test44, 1 },
	{ test45, 1 },
	{ test46, 1 },
	{ test47, 1 },
	{ test48, 1 },
	{ test49, 1 },
	{ test50, 1 },
	{ test51, 1 },
	{ test52, 1 },
	{ test53, 1 },
	{ test54, 1 },
	{ test55, 1 },
	{ test56, 1 },
	{ test57, 1 },
	{ test58, 1 },
	{ test59, 1 },
	{ test60, 1 },
	{ test61, 1 },
	{ test62, 1 },
	{ test63, 1 },
	{ test64, 1 },
	{ test65, 1 },
	{ test66, 1 },
	{ test67, 1 },
	{ test68, 1 },
	{ test69, 1 },
	{ test70, 1 },
	{ test71, 1 },
	{ test72, 1 },
	{ test73, 1 },
	{ test74, 1 },
	{ test75, 1 },
	{ test76, 1 },
	{ test77, 1 },
	{ test78, 1 },
	{ test79, 1 },
	{ test80, 1 },
	{ test81, 1 },
	{ test82, 1 },
	{ test83, 1 },
	{ test84, 1 },
	{ test85, 1 },
	{ test86, 1 },
	{ test87, 1 },
	{ test88, 1 },
	{ test89, 1 },
	{ test90, 1 },
	{ test91, 1 },
	{ test92, 1 },
	{ test93, 1 },
	{ test94, 1 },
	{ test95, 1 },
	{ test96, 1 },
	{ test97, 1 },
	{ test98, 1 },
	{ test99, 1 },
	{ test100, 1 },
	{ test101, 1 },
	{ test102, 1 },
	{ test103, 1 },
	{ test104, 1 },
	{ test105, 1 },
	{ test106, 1 },
	{ test107, 1 },
	{ test108, 1 },
	{ test109, 1 },
	{ test110, 1 },
	{ test111, 1 },
	{ test112, 1 },
	{ test113, 1 },
	{ test114, 1 },
	{ test115, 1 },
	{ test116, 1 },
	{ test117, 1 },
	{ test118, 1 },
	{ test119, 1 },
	{ NULL, 0 }
};
