/*
 *	SCCS: %W% (%E%)
 *
 *	UniSoft Ltd., London, England
 *
 * Copyright (c) 2001 UniSoft Ltd.
 * All rights reserved.
 *
 * No part of this source code or documentation may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * Many of the test purposes in this file are derived from corresponding
 * test purposes in POSIX.os/ioprim/read/read.c in the VSX test suite,
 * which is Copyright (c) 1992 X/Open Company Limited.
 */

#define MAIN
#ifndef lint
   static char sccsid[] = "%W% (%E%) LSB-os test suite";
#  ifdef MAIN
     char *copyright[] = {
	"(C) Copyright 2001 UniSoft Ltd.,"
	"All Rights Reserved."
     };
#  endif /* MAIN */
#endif   /* lint */

/************************************************************************

NAME:		LSB.os/ioprim/readv_L/readv_L.c
PRODUCT:	LSB-os test suite
AUTHOR:		Andrew Dingwall, UniSoft Ltd.
DATE CREATED:	January 2001

DESCRIPTION:
	XXX

MODIFICATIONS:

************************************************************************/

#define NO_VREAD

#include	<std.h>
#include	<stdio.h>
#include	<errno.h>
#include	<dbug.h>
#include	<sys/types.h>
#include	<signal.h>
#include	<report.h>
#include	<exitcodes.h>
#include	<unistd.h>
#include	<sys/uio.h>
#include	<sys/stat.h>
#include	<fcntl.h>
#include	<string.h>
#include	<timeout.h>
#include	<limits.h>
#include	<stdlib.h>
#include	<chktimes.h>
#include 	<termios.h>
#include 	<time.h>
#include	<sys/resource.h>
#include	<ctype.h>
#include	<tet_api.h>
#include	<xnfs.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef readv
#endif

#ifndef _XOPEN_SOURCE
#undef memset
extern	void	*memset();
#endif


#define NO_TESTS	24		/* number of tests in testset */
#define	OFF_SET		10
#define WAITTIME	(5 * SPEEDFACTOR)
#define MODEANY		(mode_t)(S_IRWXU|S_IRWXG|S_IRWXO)
#define	READ		0		/* fd for reading from a pipe */
#define	WRITE		1		/* fd for writting to a pipe */
#define NAP		3
#define NOK		02
#define EXP_SIZE	(sizeof(exp_data)-1)
#define PATH_NOK	8
#define MAX_VEC		4
#define MEGABYTE	(1024 * 1024)
#define MEG2BYTE(n)	((n) * MEGABYTE)
#define BYTE2MEG(n)	((int) ((n) / MEGABYTE))

extern	char	*errname();
extern	char	*execpath();
extern	void	valrpt();
extern	void	do_feio();
extern	char	*psl_to_asc();
extern	char	*itoa();
extern	char	*vg_ident;
extern	char	*vg_dbug;
extern	char	**environ;

int	no_tests = NO_TESTS;

private char	exp_data[] =	"1234567890abcdefghijklmnopqrstuvwxyz";
private	int	caught_sig = 0;
private int	notinuse = 0;
private int	alt_errno = NOERROR;
private int	testfail;
private char	*sigstat;
private char	*in_buf, *out_buf;
private int	pipe_buf;
private int	fildes[2];
private int	setupok;

private	char	*prog_su =	"readv_L_su";
private char	*t_file =	"./readv-t";
private char	*t1_file =	"./readv-t.1";
private char	*t1_fifo =	"./readv-t.1-p";
private char	*t5_file =	"./readv-t.5";
private char	*t8_file =	"./readv-t.8";
private char	*t10_file =	"./readv-t.10";
private char	*t11_file =	"./readv-t.11";
private char	*t12_file =	"./readv-t.12";
#define		t13_file	t_file
private char	*t13_fifo =	"./readv-p.13";
private char	*t14_file =	"./readv-t.14";
#define		t15_file	t_file
private char	*t16_file =	"./readv-t.16";
private char	*t17_file =	"./readv-t.17";
private char	*t18_file =	"./readv-t.18";
private char	*t21_dir =	"readv-d.21";
private char	*t21_file =	"readv-d.21/readv-t.21";

private void	prepare_tests();
private void	cln_tests();
private void	test1();
private void	test2();
private void	test3();
private void	test4();
private void	test5();
private void	test6();
private void	test7();
private void	ch_t7();
private void	test8();
private void	ch_t8();
private void	pa_t8();
private void	test9();
private void	test10();
private void	test10();
private void	test11();
private void	ch_t11();
private void	pa_t11();
private void	test12();
private void	t12_read();
private void	test13();
private void	test14();
private	void	test15();
private void	test16();
private void	test17();
private void	test18();
private void	ch_t18();
private void	pa_t18();
private void	test19();
private void	t19rpt();
private int	t19_20io();
private void	test20();
private void	t20rpt();
private void	test21();
private void	ch_t21();
private void	test22();
private void	test23();
private void	test24();
private void	ch_t24();

private	ssize_t	tbreadv();
private	ssize_t	tbrdv_to();
private char *	b2pr();

public	void	(*setfunc) () = prepare_tests;

public	void	(*clnfunc) () = cln_tests;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	 test2, 2,
	 test3, 3,
	 test4, 4,
	 test5, 5,
	 test6, 6,
	 test7, 7,
	 test8, 8,
	 test9, 9,
	 test10, 10,
	 test11, 11,
	 test12, 12,
	 test13, 13,
	 test14, 14,
	 test15, 15,
	 test16, 16,
	 test17, 17,
	 test18, 18,
	 test19, 19,
	 test20, 20,
	 test21, 21,
	 test22, 22,
	 test23, 23,
	 test24, 24,
	NULL, 0
};

private void
prepare_tests()
{
	int	fd;
	int 	i;
	int	pathok = 0;

	DBUG_ENTER("prepare_tests");

	if ((fd = crfile(t_file, MODEANY, (int) getuid(), (int) getgid())) == SYSERROR)
	{
		for (i = 1; i <= no_tests; i++)
			(void) tet_delete(i, "creat() failed in preparations");
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	if (write(fd, exp_data, (unsigned) EXP_SIZE) != EXP_SIZE)
	{
		for (i = 1; i <= no_tests; i++)
			(void) tet_delete(i, "write failed in preparations");
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	(void) close(fd);

	if (sysconf(_SC_JOB_CONTROL) == -1)
		notinuse = 1;

	/* obtain the value of PIPE_BUF from pathconf() */
	if((pipe_buf = pathconf(".", _PC_PIPE_BUF)) == SYSERROR)
	{
		for (i = 1; i <= no_tests; i++)
			(void) tet_delete(i,
				"pathconf(\".\", _PC_PIPE_BUF) failed in prep");
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	out_buf = (char *) malloc((size_t) (2*pipe_buf + 1));
	in_buf = (char *) malloc((size_t) (2*pipe_buf + 1));

	if (out_buf == NULL || in_buf == NULL)
	{
		for (i = 1; i <= NO_TESTS; i++)
			(void) tet_delete(i, "malloc() failed in prep");
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	/* NB this will contain nulls, so don't use strcmp() etc. on it */
	/* Start at 1 so as much as possible can be printed with psl_to_asc() */
	for (i = 0; i < 2 * pipe_buf; i++)
		out_buf[i] = 1 + i % (CHAR_MAX - CHAR_MIN + 1);

	PATH_SETUP_RPT(4);

	DBUG_VOID_RETURN;
}

private void
cln_tests()
{
	(void) unlink (t_file);
}

private int
getfifo(path, fds, waittime)
char *path;
int fds[2];
unsigned waittime;
{
	/* create and open a FIFO.  N.B. it is left in NONBLOCK mode */

	int err;
	int pathok = 0;

	DBUG_ENTER("getfifo");

	(void) remove(path);
	if (mkfifo(path, MODEANY) == SYSERROR)
	{
		err = errno;
		if (testfail++ == 0)
			xx_rpt(DELETION);
		in_rpt("deletion reason: mkfifo(%s, %#o) failed - errno %d (%s)",
			path, (int)MODEANY, err, errname(err));
		DBUG_RETURN(-1);
	}
	else
		PATH_TRACE;

	SET_TIMEOUT(waittime)
	fds[READ] = open(path, O_RDONLY|O_NONBLOCK);
	err = errno;
	CLEAR_ALARM

	if (fds[READ] < 0)
	{
		if (testfail++ == 0)
			xx_rpt(DELETION);
		in_rpt("deletion reason: open(O_RDONLY|O_NONBLOCK) failed on FIFO %s - errno %d (%s)",
			path, err, errname(err));
		DBUG_RETURN(-1);
	}
	else
		PATH_TRACE;

	SET_TIMEOUT(waittime)
	fds[WRITE] = open(path, O_WRONLY|O_NONBLOCK);
	err = errno;
	CLEAR_ALARM

	if (fds[WRITE] < 0)
	{
		if (testfail++ == 0)
			xx_rpt(DELETION);
		in_rpt("deletion reason: open(O_WRONLY|O_NONBLOCK) failed on FIFO %s - errno %d (%s)",
			path, err, errname(err));
		(void) close(fds[READ]);
		DBUG_RETURN(-1);
	}
	else
		PATH_TRACE;

	PATH_FUNC_RPT(3);
	DBUG_RETURN(0);
}


private void
sig_catch(sig)
{
	caught_sig = sig;
}

private ssize_t
tbrdv_to(fd, iov, iovcnt, timeout, expret, experrno, expdata)
int fd;
unsigned timeout;
int expret, experrno;
char *expdata;
{
	ssize_t	rval;
	int	pathok = setupok;

	DBUG_LENTER("tbrdv_to", 2);

	SET_TIMEOUT(timeout)

	globok = 0;
	rval = tbreadv(fd, iov, iovcnt, expret, experrno, expdata);
	PATH_FUNC_TRACE;

	CLEAR_ALARM

	if (experrno != EINTR && alt_errno != EINTR && alrm_flag > 0)
	{
		if (!testfail)
			xx_rpt(FAILURE);
	 	in_rpt("readv(%d, iov, %d) timed out", fd, iovcnt);
	}
	else
		PATH_TRACE;

	PATH_FUNC_RPT(2);
	DBUG_RETURN(rval);
}

private char *
b2pr(s, len)
char *s;
int len;
{
	static char *buf;
	static size_t buflen;
	size_t needlen;
	char *p;

	DBUG_LENTER("b2pr", 2);

	needlen = 1;
	for (p = s; p < s + len; p++)
		if (isprint((unsigned char) *s))
			needlen++;
		else
			needlen += 4;

	if (buflen < needlen) {
		if (buf == (char *) 0)
			buf = (char *) malloc(needlen);
		else
			buf = (char *) realloc((void *) buf, needlen);
		if (buf == (void *) 0) {
			in_rpt("out of memory in b2pr() - can't print expected and/or observed values");
			DBUG_RETURN("");
		}
		buflen = needlen;
	}

	for (p = buf; len > 0; len--, s++) {
		if (isprint((unsigned char) *s))
			*p++ = *s;
		else {
			(void) sprintf(p, "\\%03o", (unsigned char) *s);
			p += 4;
		}
	}
	*p = '\0';

	DBUG_RETURN(buf);
}

private ssize_t
tbreadv(tbfildes, tbiov, tbiovcnt, expret, experrno, expdata)
int tbfildes;
struct iovec *tbiov;
int tbiovcnt;
int expret, experrno;
char *expdata;
{
	ssize_t rval;
	int err;
	int failed = 0;
	int pathok = setupok;
	char *p;
	int n, len;
	struct iovec *iovp;

	DBUG_LENTER("tbread", 2);

	globok = 0;
	errno = 0;
	rval = readv(tbfildes, tbiov, tbiovcnt);

#ifdef TESTBED
	rval = -1;
	if (errno)
		errno++;
#endif
	err = errno;

	if (expret == SYSERROR)
	{
		if (rval == expret && err == experrno)
		{
			PATH_FUNC_RPT(0);
			DBUG_RETURN(rval);
		}
		else
			failed++;
	}
	else
	{
		/* expected failures are permitted */
		if (rval == SYSERROR && err == alt_errno)
		{
			PATH_FUNC_RPT(0);
			DBUG_RETURN(rval);
		}
		if (expret != rval)
			failed++;
		else
			PATH_TRACE;
	}


	if (failed)
	{
		if (!testfail++)
			xx_rpt(FAILURE);
		for (n = 0; n < tbiovcnt; n++) {
			in_rpt("iov[%d].iov_base = %#lx, iov[%d].iov_len = %d",
				n, (long) (tbiov + n)->iov_base,
				n, (tbiov + n)->iov_len);
		}
	 	in_rpt("readv(%d, iov, %d) did not behave as expected",
			tbfildes, tbiovcnt);
		valrpt(expret, rval, experrno, err);
		DBUG_RETURN(rval);
	}
	else
		PATH_TRACE;

#ifdef TESTBED2
	for (iovp = tbiov; iovp < tbiov + tbiovcnt; iovp++)
		if (iovp->iov_base && iovp->iov_len > 0)
			++*((char *) iovp->iov_base);
#endif

	if (expdata != NULL) {
		p = expdata;
		len = expret;
		for (iovp = tbiov; iovp < tbiov + tbiovcnt; iovp++) {
			if (len <= 0) {
				PATH_TRACE;
				continue;
			}
			if ((n = iovp->iov_len) > len)
				n = len;
			if (memcmp(iovp->iov_base, p, n)) {
				if (!testfail++)
					xx_rpt(FAILURE);
				in_rpt("readv(%d, iov, %d) returned incorrect data in iov[%d].iov_base",
					tbfildes, tbiovcnt,
					(int) (iovp - tbiov));
				in_rpt("expected \"%s\"", b2pr(p, n));
				in_rpt("observed \"%s\"",
					b2pr(iovp->iov_base, n));
			}
			else
				PATH_TRACE;
			p += n;
			len -= n;
		}
	}
	else {
		for (n = 0; n < tbiovcnt; n++)
			PATH_TRACE;
	}

	PATH_FUNC_RPT(2 + tbiovcnt);
	DBUG_RETURN(rval);
}


private void
test1()
{
	int i, sum, err;
	struct iovec iovector[MAX_VEC];
	int pathok = setupok;

	DBUG_ENTER("test1");

        /* initialize the iovectors to use the input buffer */
	sum = pipe_buf/MAX_VEC;
	for (i=0; i<MAX_VEC; i++) {
		iovector[i].iov_len = sum;
		iovector[i].iov_base = &in_buf[sum*i];
	}
	iovector[MAX_VEC-1].iov_len += pipe_buf-(sum*MAX_VEC);

/* for a regular file */

	fildes[WRITE] = open(t1_file, O_WRONLY|O_TRUNC|O_CREAT, MODEANY);
	if (fildes[WRITE] == SYSERROR) {
		err = errno;
		xx_rpt(DELETION);
		in_rpt("open(%s, O_WRONLY|...) failed: errno %d (%s)",
			t1_file, err, errname(err));
		DBUG_VOID_RETURN;
	} else
		PATH_TRACE;

	fildes[READ] = open(t1_file, O_RDONLY);
	if (fildes[READ] == SYSERROR) {
		err = errno;
		xx_rpt(DELETION);
		in_rpt("open(%s, O_RDONLY) failed: errno %d (%s)",
			t1_file, err, errname(err));
		(void) close(fildes[WRITE]);
		DBUG_VOID_RETURN;
	} else
		PATH_TRACE;

	testfail = 0;

	for (i=0, sum=0; i<MAX_VEC; i++) {
		sum += iovector[i].iov_len;
		if (write(fildes[WRITE], out_buf, sum) != sum) {
			xx_rpt(DELETION);
			in_rpt("write() failed on regular file");
			DBUG_VOID_RETURN;
		} else
			PATH_TRACE;

		globok = 0;
		if (tbreadv(fildes[READ], iovector, i+1, sum, NOERROR, out_buf) < 0)
			break;
		else
			PATH_TRACE;
	}

	(void) close(fildes[WRITE]);
	(void) close(fildes[READ]);
	(void) unlink(t1_file);

/* for a FIFO */
	globok = 0;
	if (getfifo(t1_fifo, fildes, WAITTIME) != 0) {
		DBUG_VOID_RETURN;
	} else
		PATH_FUNC_TRACE;

	for (i=0, sum=0; i<MAX_VEC; i++) {
		sum += iovector[i].iov_len;
		if (write(fildes[WRITE], out_buf, sum) != sum) {
			xx_rpt(DELETION);
			in_rpt("write() failed on FIFO");
			DBUG_VOID_RETURN;
		} else
			PATH_TRACE;

		globok = 0;
		if (tbreadv(fildes[READ], iovector, i+1, sum, NOERROR, out_buf) < 0)
			break;
		else
			PATH_TRACE;
	}

	(void) close(fildes[WRITE]);
	(void) close(fildes[READ]);
	(void) unlink(t1_fifo);

/* for a pipe */
	if (pipe(fildes) == SYSERROR) {
		err = errno;
		xx_rpt(DELETION);
		in_rpt("pipe() failed: errno: %d (%s)", err, errname(err));
		DBUG_VOID_RETURN;
	} else
		PATH_TRACE;

	for (i=0, sum=0; i<MAX_VEC; i++) {
		sum += iovector[i].iov_len;
		if (write(fildes[WRITE], out_buf, sum) != sum) {
			xx_rpt(DELETION);
			in_rpt("write() failed on pipe");
			DBUG_VOID_RETURN;
		} else
			PATH_TRACE;

		if (tbreadv(fildes[READ], iovector, i+1, sum, NOERROR, out_buf) < 0)
			break;
		else
			PATH_TRACE;
	}

	(void) close(fildes[WRITE]);
	(void) close(fildes[READ]);

	if (!testfail)
		PATH_XS_RPT(4 + (6 * MAX_VEC));

	DBUG_VOID_RETURN;
}

private void
test2()
{
	int		fd;
	int		rval;
	int		err;
	char		*mess;
	int		pathok = setupok;
	struct iovec iovector;

	DBUG_ENTER("test2");
	if ((fd = open(t_file, O_RDONLY, 0)) == SYSERROR)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("could not open file %s: errno = %d (%s)",
			t_file, err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	testfail = 0;

	globok = 0;
	fsavtimes(fd);
	PATH_FUNC_TRACE;

	iovector.iov_base = in_buf;
	iovector.iov_len = 0;
	globok = 0;
	(void) tbreadv(fd, &iovector, 1, 0, NOERROR, (char *)NULL);
	PATH_FUNC_TRACE;

	globok = 0;
	if ((mess = fchktimes(fd,0)) != (char *)NULL)
	{
		if (!testfail++)
			xx_rpt(FAILURE);
		in_rpt("%s", mess);
	}
	else
		PATH_FUNC_TRACE;

	errno = NOERROR;
	if ((rval = lseek(fd, (off_t)0, SEEK_CUR)) == SYSERROR)
	{
		err = errno;
		if (!testfail++)
			xx_rpt(DELETION);
		in_rpt("deletion reason: lseek() failed");
		valrpt(0,rval,NOERROR,err);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	if (rval != 0)
	{
		if (!testfail++)
			xx_rpt(FAILURE);
		in_rpt("readv() with number of bytes to be read = 0 has changed the file pointer");
		in_rpt("file points to byte %d instead of byte 0",rval);
	}
	else
		PATH_TRACE;

	errno = NOERROR;
	if ((rval = lseek(fd, (off_t)OFF_SET, SEEK_CUR)) == SYSERROR)
	{
		err = errno;
		if (!testfail++)
			xx_rpt(DELETION);
		in_rpt("deletion reason: lseek() failed");
		valrpt(OFF_SET,rval,NOERROR,err);
	}
	else
		PATH_TRACE;

	globok = 0;
	fsavtimes(fd);
	PATH_FUNC_TRACE;


	iovector.iov_base = in_buf;
	iovector.iov_len = 0;
	globok = 0;
	(void) tbreadv(fd, &iovector, 1, 0, NOERROR, (char *)NULL);
	PATH_FUNC_TRACE;

	globok = 0;
	if ((mess = fchktimes(fd,0)) != (char *)NULL)
	{
		if (!testfail++)
			xx_rpt(FAILURE);
		in_rpt("%s", mess);
	}
	else
		PATH_FUNC_TRACE;

	errno = NOERROR;
	if ((rval = lseek(fd, (off_t)0, SEEK_CUR)) == SYSERROR)
	{
		err = errno;
		if (!testfail++)
			xx_rpt(DELETION);
		in_rpt("deletion reason: lseek() failed");
		valrpt(0,rval,NOERROR,err);
	}
	else
		PATH_TRACE;

	if (rval != OFF_SET)
	{
		if (!testfail++)
			xx_rpt(FAILURE);
		in_rpt("readv() with number of bytes to be read = 0 has changed the file pointer");
		in_rpt("file points to byte %d instead of byte %d",
			rval,OFF_SET);
	}
	else
		PATH_TRACE;

	if (!testfail)
		PATH_XS_RPT(12);

	(void) close(fd);

	DBUG_VOID_RETURN;
}

private void
test3()
{
	int	fd;
	int	offset;
	int	rval;
	int		err;
	int	pathok = setupok;
	struct iovec iovector;

	DBUG_ENTER("test3");
	if ((fd = open(t_file, O_RDONLY, 0)) == SYSERROR)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("could not open file %s: errno = %d (%s)",
			t_file, err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	testfail = 0;

	for (offset=1 ; offset<EXP_SIZE ; offset+=2)
	{
		errno = NOERROR;
		if ((rval = lseek(fd, (off_t)offset, SEEK_SET)) == SYSERROR)
		{
			err = errno;
			xx_rpt(FAILURE);
			in_rpt("lseek() failed");
			valrpt(offset,rval,NOERROR,err);
			DBUG_VOID_RETURN;
		}
		else
			PATH_TRACE;

		iovector.iov_base = in_buf;
		iovector.iov_len = 1;
		globok = 0;
		(void) tbrdv_to(fd, &iovector, 1, WAITTIME, 1, NOERROR, 
			&exp_data[offset]);
		PATH_FUNC_TRACE;

	}

	if (!testfail)
		PATH_XS_RPT(1 + offset - 1);

	(void) close(fd);

	DBUG_VOID_RETURN;
}

private void
test4()
{
	int	err, fd;
	int	pathok = setupok;
	struct iovec iovector;
	off_t	offs;

	DBUG_ENTER("test4");
	if ((fd = open(t_file, O_RDONLY, 0)) == SYSERROR)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("could not open file %s: errno = %d (%s)",
			t_file, err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	testfail = 0;

	if ((offs = lseek(fd, 0, SEEK_CUR)) == SYSERROR) {
		err = errno;
		if (!testfail++)
			xx_rpt(DELETION);
		in_rpt("lseek(%d, 0, SEEK_CUR) failed, errno = %d (%s)",
			fd, err, errname(err));
	}
	else if (offs != 0) {
		if (!testfail++)
			xx_rpt(DELETION);
		in_rpt("open() did not set current file pointer to start of file");
	}
	else
		PATH_TRACE;

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE / 2;
	globok = 0;
	(void) tbreadv(fd, &iovector, 1, (EXP_SIZE/2), NOERROR, exp_data);
	PATH_FUNC_TRACE;

	if ((offs = lseek(fd, 0, SEEK_CUR)) == SYSERROR) {
		err = errno;
		if (!testfail++)
			xx_rpt(DELETION);
		in_rpt("lseek(%d, 0, SEEK_CUR) failed, errno = %d (%s)",
			fd, err, errname(err));
	}
	else if (offs != EXP_SIZE / 2) {
		if (!testfail++)
			xx_rpt(FAILURE);
		in_rpt("after a read of %d bytes, expected a current file pointer of %d, observed %d",
			EXP_SIZE / 2, EXP_SIZE / 2, offs);
	}
	else
		PATH_TRACE;

	iovector.iov_base = &in_buf[EXP_SIZE / 2];
	iovector.iov_len = EXP_SIZE / 2;
	globok = 0;
	(void) tbreadv(fd, &iovector, 1, (EXP_SIZE/2), NOERROR,
		&exp_data[EXP_SIZE/2]);
	PATH_FUNC_TRACE;

	if ((offs = lseek(fd, 0, SEEK_CUR)) == SYSERROR) {
		err = errno;
		if (!testfail++)
			xx_rpt(DELETION);
		in_rpt("lseek(%d, 0, SEEK_CUR) failed, errno = %d (%s)",
			fd, err, errname(err));
	}
	else if (offs != EXP_SIZE) {
		if (!testfail++)
			xx_rpt(FAILURE);
		in_rpt("after two reads of %d bytes each, expected a current file pointer of %d, observed %d",
			EXP_SIZE / 2, EXP_SIZE, offs);
	}
	else
		PATH_TRACE;

	if (!testfail)
		PATH_XS_RPT(6);

	(void) close(fd);

	DBUG_VOID_RETURN;
}

private void
test5()
{
	int	rval;
	int		err;
	int	pathok = setupok;
	struct iovec iovector;

	DBUG_ENTER("test5");

	testfail = 0;

	if (getfifo(t5_file, fildes, WAITTIME) != 0)
	{
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	errno = NOERROR;
	rval = write(fildes[WRITE] , exp_data, EXP_SIZE);

	if (rval != EXP_SIZE)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("deletion reason: write() failed on %s", t5_file);
		valrpt(EXP_SIZE,rval,NOERROR,err);
		(void) close(fildes[READ]);
		(void) close(fildes[WRITE]);
		(void) unlink(t5_file);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE / 2;
	globok = 0;
	(void) tbreadv(fildes[READ], &iovector, 1, (EXP_SIZE/2), NOERROR,
		exp_data);
	PATH_FUNC_TRACE;

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE / 2;
	globok = 0;
	(void) tbreadv(fildes[READ], &iovector, 1, (EXP_SIZE/2), NOERROR,
		&exp_data[EXP_SIZE/2]);
	PATH_FUNC_TRACE;

	if (!testfail)
		PATH_XS_RPT(4);

	(void) close(fildes[READ]);
	(void) close(fildes[WRITE]);
	(void) unlink(t5_file);

	DBUG_VOID_RETURN;
}

private void
test6()
{
	int	err, fd;
	int	pathok = setupok;
	struct iovec iovector;

	DBUG_ENTER("test6");

	testfail = 0;

	errno = NOERROR;
	if ((fd = open(t_file, O_RDONLY)) < 0)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("could not open file %s: errno = %d (%s)",
			t_file, err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE * 2;
	globok = 0;
	(void) tbrdv_to(fd, &iovector, 1, WAITTIME, EXP_SIZE, NOERROR,
		exp_data);
	PATH_FUNC_TRACE;

	(void) close(fd);

	if (!testfail)
		PATH_XS_RPT(2);

	DBUG_VOID_RETURN;
}

private void
test7()
{
	DBUG_ENTER("test7");

	(void) cppair(ch_t7, NULLFN, 3*WAITTIME, 0);

	DBUG_VOID_RETURN;
}

private void
ch_t7()
{
	int	ret, err;
	int	tty_fildes, loop_fildes;
	struct termios tty_termios, loop_termios;
	int	pathok = setupok;
	struct iovec iovector;

	DBUG_ENTER("ch_t7");

	testfail = 0;

	switch (termios_prep(&tty_fildes, &tty_termios,
			&loop_fildes, &loop_termios))
	{
	case 0:
		PATH_TRACE;
		break;
	case 1:
		xx_rpt(UNSUPPORTED);
		in_rpt("VSX_TERMIOS_TTY/LOOP is set to \"unsup\"");
		DBUG_VOID_RETURN;
	default:
		xx_rpt(DELETION);
		if (alrm_flag > 0)
			in_rpt("open/initialise VSX_TERMIOS_TTY and VSX_TERMIOS_LOOP timed out");
		else
			in_rpt("could not open/initialise VSX_TERMIOS_TTY/VSX_TERMIOS_LOOP");
		DBUG_VOID_RETURN;
	}

	SET_TIMEOUT(WAITTIME)

	ret = write(loop_fildes, exp_data, (unsigned) (EXP_SIZE/2));
	err = errno;

	CLEAR_ALARM

	if (ret != (EXP_SIZE/2))
	{
		xx_rpt(DELETION);
		in_rpt("deletion reason: write() to VSX_TERMIOS_LOOP failed - errno: %d (%s)", 
			err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	(void) sleep(NAP);

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	alt_errno = EINTR;
	globok = 0;
	(void) tbrdv_to(tty_fildes, &iovector, 1, WAITTIME/2, (EXP_SIZE/2), 
		NOERROR, exp_data);
	PATH_FUNC_TRACE;

	if (!testfail)
		PATH_XS_RPT(3);

	(void) close(tty_fildes);
	(void) close(loop_fildes);

	DBUG_VOID_RETURN;
}

private void
test8()
{
	int	err;
	int	pathok = setupok;
	int	retval;

	DBUG_ENTER("test8");

	testfail = 0;

	errno = NOERROR;
	if (pipe(fildes) == SYSERROR)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("deletion reason: could not create pipe, errno: %d (%s)",			 err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;


	retval = cppair(ch_t8, pa_t8, WAITTIME, NOK | PATH_NOK); 
	if (retval == PATH_NOK)
		retval = OK;
	else
		PATH_TRACE;
	if (retval == NOK)
		testfail++;
	else
		PATH_TRACE;

	(void) close(fildes[READ]);
	(void) close(fildes[WRITE]);

	if (getfifo(t8_file, fildes, WAITTIME) != 0)
	{
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;


	retval = cppair(ch_t8, pa_t8, WAITTIME, NOK | PATH_NOK); 
	if (retval == PATH_NOK)
		retval = OK;
	else
		PATH_FUNC_TRACE; 
	if (retval == NOK)
		testfail++;
	else
		PATH_TRACE;

	(void) close(fildes[READ]);
	(void) close(fildes[WRITE]);
	(void) unlink(t8_file);

	if (!testfail)
		PATH_XS_RPT(6);

	DBUG_VOID_RETURN;
}

private void
ch_t8()
{
	struct	sigaction	sig;
	int	pathok = setupok;
	struct iovec iovector;

	DBUG_ENTER("ch_t8");

	sig.sa_handler = sig_catch;
	sig.sa_flags = 0;
	(void) sigemptyset(&sig.sa_mask);
	if (sigaction(SIGUSR1 , &sig , NULLSA) == SYSERROR)
		DBUG_EXIT(A_SIGFAIL);
	else
		PATH_TRACE;
	
	(void) sleep(WAITTIME/2);
	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	(void) tbrdv_to(fildes[READ], &iovector, 1, (2*WAITTIME), 
		(EXP_SIZE/2), NOERROR, exp_data);
	PATH_FUNC_TRACE;
	
	if (testfail > 0)
	{
		DBUG_EXIT(NOK);
	}
	else
		PATH_TRACE;

	if (pathok != 3)
		DBUG_EXIT(PATH_NOK);

	DBUG_VOID_RETURN;
}

private void
pa_t8()
{
	int		err;
	int	pathok = setupok;

	DBUG_ENTER("pa_t8");

	globok = 0;
	errno = NOERROR;
	if (write(fildes[WRITE], exp_data, (unsigned) (EXP_SIZE/2)) != 
		(EXP_SIZE/2))
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("deletion reason: write() failed - errno: %d (%s)", 
			err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	(void) sleep(WAITTIME);

	(void) kill (tet_child, SIGUSR1);

	PATH_FUNC_RPT(1); 

	DBUG_VOID_RETURN;
}


private void
test9()
{
	int		fd;
	int		err;
	int	pathok = setupok;
	struct iovec iovector;

	DBUG_ENTER("test9");

	errno = NOERROR;
	if ((fd = open(t_file, O_RDONLY, 0)) == SYSERROR)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("could not open file %s: errno = %d (%s)",
			t_file, err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	testfail = 0;

	errno = NOERROR;
	if ((int) lseek(fd, (off_t) 0, SEEK_END) == SYSERROR)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("deletion reason: lseek() failed - errno: %d (%s)", 
			err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	(void) tbreadv(fd, &iovector, 1, 0, NOERROR, (char *) NULL);
	PATH_FUNC_TRACE;

	errno = NOERROR;
	if ((int) lseek(fd, (off_t) EXP_SIZE, SEEK_END) == SYSERROR)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("deletion reason: lseek() failed - errno: %d (%s)", 
			err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	(void) tbreadv(fd, &iovector, 1, 0, NOERROR, (char *) NULL);
	PATH_FUNC_TRACE;

	if (!testfail)
		PATH_XS_RPT(5);

	(void) close(fd);

	DBUG_VOID_RETURN;
}


private void
test10()
{
	int flags;
	int	pathok = setupok;
	struct iovec iovector;

	DBUG_ENTER("test10");

	testfail = 0;

/* for a FIFO */
	if (getfifo(t10_file, fildes, WAITTIME) != 0)
	{
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	(void) close(fildes[WRITE]);

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	(void) tbrdv_to(fildes[READ], &iovector, 1, WAITTIME, 0, NOERROR, 
		(char *)NULL);
	PATH_FUNC_TRACE;

	flags = fcntl(fildes[READ], F_GETFL);
	(void) fcntl(fildes[READ], F_SETFL, flags & ~O_NONBLOCK);

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	(void) tbrdv_to(fildes[READ], &iovector, 1, WAITTIME, 0, NOERROR, 
		(char *) NULL);
	PATH_FUNC_TRACE;

	(void) close(fildes[READ]);

	(void) unlink (t10_file);

/*for a pipe */
	if (pipe(fildes) == SYSERROR)
	{
		xx_rpt(DELETION);
		in_rpt("deletion reason: could not create pipe");
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	(void) close(fildes[WRITE]);

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	(void) tbrdv_to(fildes[READ], &iovector, 1, WAITTIME, 0, NOERROR, 
		(char *)NULL);
	PATH_FUNC_TRACE;

	flags = fcntl(fildes[READ], F_GETFL);
	(void) fcntl(fildes[READ], F_SETFL, flags | O_NONBLOCK);

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	(void) tbrdv_to(fildes[READ], &iovector, 1, WAITTIME, 0, NOERROR, 
		(char *)NULL);
	PATH_FUNC_TRACE;

	(void) close(fildes[READ]);

	if (!testfail)
		PATH_XS_RPT(6);

	DBUG_VOID_RETURN;
}


private void
test11()
{
	int	flags;
	int	err;
	int	pathok = setupok;

	DBUG_ENTER("test11");

	testfail = 0;

	errno = NOERROR;
	if (pipe(fildes) == SYSERROR)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("deletion reason: could not create pipe, errno: %d (%s)",			 err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	globok = 0;
	(void) cppair(ch_t11, pa_t11, WAITTIME, 0);
	PATH_FUNC_TRACE;

	if (getfifo(t11_file, fildes, WAITTIME) != 0)
	{
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	flags = fcntl(fildes[READ] , F_GETFL);
	(void) fcntl(fildes[READ] , F_SETFL , flags & ~O_NONBLOCK);

	globok = 0;
	(void) cppair(ch_t11, pa_t11, WAITTIME, 0);
	PATH_FUNC_TRACE;

	if (!testfail)
		PATH_XS_RPT(4);

	(void) unlink(t11_file);

	DBUG_VOID_RETURN;
}

private void
ch_t11()
{
	int	pathok = setupok;
	DBUG_ENTER("ch_t11");

	(void) close(fildes[READ]);

	(void) sleep(WAITTIME/2);

	(void) write(fildes[WRITE] , exp_data , EXP_SIZE);
	PATH_TRACE;

	(void) sleep(WAITTIME/2);

	(void) close(fildes[WRITE]);

	DBUG_VOID_RETURN;
}

private void
pa_t11()
{
	time_t t0, t1;
	int	pathok = setupok;
	struct iovec iovector;

	DBUG_ENTER("pa_t11");

	(void) close(fildes[WRITE]);

	/* read blocking until data written */
	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	if (tbrdv_to(fildes[READ], &iovector, 1, WAITTIME, EXP_SIZE, 
		NOERROR, exp_data) != EXP_SIZE)
	{
		DBUG_VOID_RETURN;
	}
	else
		PATH_FUNC_TRACE;

	/* read blocking until writing processes close fds */
	(void) time(&t0);
	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	(void) tbrdv_to(fildes[READ], &iovector, 1, WAITTIME, 0, NOERROR,
		(char *) NULL);
	PATH_FUNC_TRACE;

	(void) time(&t1);
	if (t1 < t0 + WAITTIME/4)
	{
		if (testfail++ == 0)
			xx_rpt(FAILURE);
		in_rpt("readv() did not block");
	}
	else
		PATH_TRACE;

	(void) close(fildes[READ]);

	PATH_FUNC_RPT(3);

	DBUG_VOID_RETURN;
}


private void
test12()
{
	FILE	*fp;
	int	err, fd;
	int	pathok = setupok;

	DBUG_ENTER("test12");
	
	testfail = 0;

	/* First test using lseek() to set up */

	if ((fd = creat(t12_file , MODEANY)) < 0)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("creat(%s, %#o) failed - errno = %d (%s)",
			t12_file, (int) MODEANY, err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	(void) write(fd , exp_data , (unsigned) EXP_SIZE);
	(void) lseek(fd, (off_t)EXP_SIZE, SEEK_CUR);
	(void) write(fd , exp_data , (unsigned) EXP_SIZE);
	(void) close(fd);

	globok = 0;
	t12_read();
	PATH_FUNC_TRACE;

	(void) unlink(t12_file);

	/* Repeat using fseek() */

	if ((fp = fopen(t12_file, "w")) == NULL)
	{
		xx_rpt(DELETION);
		in_rpt("fopen(%s, \"w\") failed - errno %d (%s)",
			t12_file, errno, errname(errno));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	(void) fwrite((void *) exp_data, (size_t) 1, (size_t) EXP_SIZE, fp);
	(void) fseek(fp, (long)EXP_SIZE, SEEK_CUR);
	(void) fwrite((void *) exp_data, (size_t) 1, (size_t) EXP_SIZE, fp);
	(void) fclose(fp);

	globok = 0;
	t12_read();
	PATH_FUNC_TRACE;

	(void) unlink(t12_file);

	if (!testfail)
		PATH_XS_RPT(4);

	DBUG_VOID_RETURN;
}

private void
t12_read()
{
	int err, fd;
	int pathok = 0;
	struct iovec iovector;

	DBUG_ENTER("t12_read");

	errno = NOERROR;
	if ((fd = open(t12_file, O_RDONLY)) == SYSERROR)
	{
		err = errno;
		testfail++;
		xx_rpt(DELETION);
		in_rpt("could not open file %s: errno = %d (%s)",
			t12_file, err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	(void) tbreadv(fd, &iovector, 1, EXP_SIZE, NOERROR, exp_data);
	PATH_FUNC_TRACE;

	(void) memset((void *)out_buf, '\0', (size_t)EXP_SIZE);
	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	(void) tbreadv(fd, &iovector, 1, (EXP_SIZE), NOERROR, out_buf);
	PATH_FUNC_TRACE;

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	(void) tbreadv(fd, &iovector, 1, (EXP_SIZE), NOERROR, exp_data);
	PATH_FUNC_TRACE;

	(void) close(fd);

	PATH_FUNC_RPT(4);
	DBUG_VOID_RETURN;
}


private void
test13()
{
	int		fd;
	char		*mess = (char *)NULL;
	int		err;
	int	pathok = setupok;
	struct iovec iovector;

	DBUG_ENTER("test13");

/* for a regular file */
	testfail = 0;

	errno = NOERROR;
	if ((fd = open(t13_file, O_RDONLY)) == SYSERROR)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("could not open file %s: errno = %d (%s)",
			t13_file, err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	globok = 0;
	savtimes(t13_file);
	PATH_FUNC_TRACE;

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	(void) tbreadv(fd, &iovector, 1, EXP_SIZE, NOERROR, exp_data);
	PATH_FUNC_TRACE;

	globok = 0;
	if ((mess = chktimes(t13_file , NEWATIME)) != NULL)
	{
		testfail++;
		xx_rpt(FAILURE);
		in_rpt(mess);
	}
	else
		PATH_FUNC_TRACE;

	(void) close(fd);


/* for a FIFO */
	if (getfifo(t13_fifo, fildes, WAITTIME) != 0)
	{
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	(void) write(fildes[WRITE], exp_data, (unsigned) EXP_SIZE);

	globok = 0;
	savtimes(t13_fifo);
	PATH_FUNC_TRACE;

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	(void) tbreadv(fildes[READ], &iovector, 1, EXP_SIZE, NOERROR, exp_data);
	PATH_FUNC_TRACE;

	globok = 0;
	if ((mess = chktimes(t13_fifo , NEWATIME)) != NULL)
	{
		if(!testfail++)
			xx_rpt(FAILURE);
		in_rpt(mess);
	}
	else
		PATH_FUNC_TRACE;

	(void) close(fildes[WRITE]);
	(void) close(fildes[READ]);
	(void) unlink(t13_fifo);

/* for a pipe */

	if (pipe(fildes) == SYSERROR)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("deletion reason: pipe() failed - errno: %d (%s)", 
			err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	(void) write(fildes[WRITE], exp_data, (unsigned) EXP_SIZE);

	globok = 0;
	fsavtimes(fildes[READ]);
	PATH_FUNC_TRACE;

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	(void) tbreadv(fildes[READ], &iovector, 1, EXP_SIZE, NOERROR, exp_data);
	PATH_FUNC_TRACE;

	globok = 0;
	if ((mess = fchktimes(fildes[READ] , NEWATIME)) != NULL)
	{
		if(!testfail++)
			xx_rpt(FAILURE);
		in_rpt(mess);
	}
	else
		PATH_FUNC_TRACE;

	(void) close(fildes[WRITE]);
	(void) close(fildes[READ]);

	if (!testfail)
		PATH_XS_RPT(12);

	DBUG_VOID_RETURN;
}


private void
test14()
{
	int	flags, err;
	int	pathok = setupok;
	struct iovec iovector;

	DBUG_ENTER("test14");

	testfail = 0;

	errno = NOERROR;
	if (pipe(fildes) == SYSERROR)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("deletion reason: could not create pipe, errno: %d (%s)",			 err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	errno = NOERROR;
	if (write(fildes[WRITE], exp_data, 1) != 1)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("deletion reason: write() failed - errno: %d (%s)", 
			err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	(void) tbrdv_to(fildes[READ], &iovector, 1, WAITTIME, 1, NOERROR,
		exp_data);
	PATH_FUNC_TRACE;

	(void) close(fildes[WRITE]);
	(void) close(fildes[READ]);


	if (getfifo(t14_file, fildes, WAITTIME) != 0)
	{
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	flags = fcntl(fildes[READ], F_GETFL);
	(void) fcntl(fildes[READ], F_SETFL, flags & ~O_NONBLOCK);

	errno = NOERROR;
	if (write(fildes[WRITE], exp_data, 1) != 1)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("deletion reason: write() failed - errno: %d (%s)", 
			err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	(void) tbrdv_to(fildes[READ], &iovector, 1, WAITTIME, 1, NOERROR,
		exp_data);
	PATH_FUNC_TRACE;

	(void) close(fildes[WRITE]);
	(void) close(fildes[READ]);
	(void) unlink(t14_file);

	if (testfail == 0)
		PATH_XS_RPT(6);
	
	DBUG_VOID_RETURN;
}


private void
test15()
{
	int		fd;
	int		rval;
	int		err;
	char		*mess;
	int	pathok = 0;
	struct iovec iovector;

	DBUG_ENTER("test15");

	testfail = 0;

	if ((fd = open(t15_file, O_RDONLY, 0)) == SYSERROR)
	{
		err = errno;
		if (!testfail++)
			xx_rpt(DELETION);
		in_rpt("could not open file %s: errno = %d (%s)",
			t15_file, err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	errno = NOERROR;
	if ((rval = lseek(fd, (off_t)0, SEEK_END)) == SYSERROR)
	{
		err = errno;
		if (!testfail++)
			xx_rpt(DELETION);
		in_rpt("deletion reason: lseek() failed");
		valrpt(0,rval,NOERROR,err);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;


	globok = 0;
	fsavtimes(fd);
	PATH_FUNC_TRACE;

	iovector.iov_base = in_buf;
	iovector.iov_len = 1;
	globok = 0;
	(void) tbreadv(fd, &iovector, 1, 0, NOERROR, (char *) NULL);
	PATH_FUNC_TRACE;

	globok = 0;
	if ((mess = fchktimes(fd,NEWATIME)) != (char *)NULL)
	{
		if (!testfail++)
			xx_rpt(FAILURE);
		in_rpt("%s", mess);
	}
	else
	{
		PATH_FUNC_TRACE;
		PATH_XS_RPT(5);
	}

	(void) close(fd);

	DBUG_VOID_RETURN;
}


private void
test16()
{
	int		flags;
	int		err;
	int	pathok = setupok;
	struct iovec iovector;

	DBUG_ENTER("test16");

	testfail = 0;

/* for a FIFO */
	if (getfifo(t16_file, fildes, WAITTIME) != 0)
	{
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	(void) tbrdv_to(fildes[READ], &iovector, 1, WAITTIME, SYSERROR, 
		EAGAIN, (char *) NULL);
	PATH_FUNC_TRACE;

	(void) close(fildes[WRITE]);
	(void) close(fildes[READ]);
	(void) unlink(t16_file);

/* for a pipe */

	if (pipe(fildes) == SYSERROR)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("deletion reason: pipe() failed - errno: %d (%s)", 
			err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	flags = fcntl(fildes[READ], F_GETFL);
	(void) fcntl(fildes[READ], F_SETFL, flags | O_NONBLOCK);

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	(void) tbrdv_to(fildes[READ], &iovector, 1, WAITTIME, SYSERROR, 
		EAGAIN, (char *) NULL);
	PATH_FUNC_TRACE;

	(void) close(fildes[WRITE]);
	(void) close(fildes[READ]);

	if (!testfail)
		PATH_XS_RPT(4);

	DBUG_VOID_RETURN;
}


private void
test17()
{
	int		err, fd;
	char		car;
	int	pathok = setupok;
	struct iovec iovector;

	DBUG_ENTER("test17");

	testfail = 0;

	iovector.iov_base = &car;
	iovector.iov_len = 1;
	globok = 0;
	(void) tbreadv(-1, &iovector, 1, SYSERROR, EBADF, (char *) NULL);
	PATH_FUNC_TRACE;

	errno = NOERROR;
	if ((fd = creat(t17_file, MODEANY)) == SYSERROR)
	{
		err = errno;
		if (!testfail++)
			xx_rpt(DELETION);
		in_rpt("could not create file %s: errno = %d (%s)",
			t17_file, err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;


	iovector.iov_base = &car;
	iovector.iov_len = 1;
	globok = 0;
	(void) tbreadv(fd, &iovector, 1, SYSERROR, EBADF, (char *) NULL);
	PATH_FUNC_TRACE;

	(void) close(fd);

	iovector.iov_base = &car;
	iovector.iov_len = 1;
	globok = 0;
	(void) tbreadv(fd, &iovector, 1, SYSERROR, EBADF, (char *) NULL);
	PATH_FUNC_TRACE;

	if (!testfail)
		PATH_XS_RPT(4);

	(void) unlink(t17_file);

	DBUG_VOID_RETURN;
}

private void
test18()
{
	int	err;

	DBUG_ENTER("test18");

	errno = NOERROR;
	if (mkfifo(t18_file, S_IRWXU) == SYSERROR)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("deletion reason: could not create FIFO %s - errno: %d (%s)", t18_file, err, errname(err));
		DBUG_VOID_RETURN;
	}

	(void) cppair(ch_t18, pa_t18, 2*WAITTIME, 0);

	(void) unlink(t18_file);
	
	DBUG_VOID_RETURN;
}

private void
ch_t18()
{
	int		err, fd;
	struct	sigaction	sig;
	int	pathok = setupok;
	struct iovec iovector;

	DBUG_ENTER("ch_t18");

	sig.sa_handler = sig_catch;
	sig.sa_flags = 0;
	(void) sigemptyset(&sig.sa_mask);
	if (sigaction(SIGUSR1 , &sig , NULLSA) == SYSERROR)
		DBUG_EXIT(A_SIGFAIL);

	SET_TIMEOUT(WAITTIME)
	fd = open(t18_file, O_RDONLY);
	err = errno;
	CLEAR_ALARM
	if ((fd == SYSERROR) || (alrm_flag)) {
		if (fd == SYSERROR) {
			in_rpt("open(%s, O_RDONLY) failed, errno = %d (%s)",
				t18_file, err, errname(err));
		}
		if (alrm_flag) {
			in_rpt("open(%s, O_RDONLY) timed out", t18_file);
		}
		if (!testfail++)
			xx_rpt(DELETION);
		DBUG_EXIT(A_OPENFAIL);
	}
	else
		PATH_TRACE;

	testfail = 0;

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	(void) tbrdv_to(fd, &iovector, 1, WAITTIME, SYSERROR, EINTR,
		(char *) NULL);
	PATH_FUNC_TRACE;

	if (!testfail)
		PATH_XS_RPT(2);

	DBUG_VOID_RETURN;
}

private void
pa_t18()
{
	int	err, fd;

	DBUG_ENTER("pa_t18");

	SET_TIMEOUT(WAITTIME)
	fd = open(t18_file, O_WRONLY);
	err = errno;
	CLEAR_ALARM
	if ((fd == SYSERROR) || (alrm_flag))
	{
		if (fd == SYSERROR) {
			in_rpt("open(%s, O_WRONLY) failed: errno = %d (%s)",
				t18_file, err, errname(err));
		}
		if (alrm_flag) {
			in_rpt("open(%s, O_WRONLY) timed out", t18_file);
		}
		if (!testfail++)
			xx_rpt(DELETION);
		(void) kill(tet_child, SIGKILL);
		(void) close (fd);
		(void) unlink(t18_file);
		DBUG_VOID_RETURN;
	}

	(void) sleep(WAITTIME/2);

	(void) kill (tet_child, SIGUSR1);

	(void) sleep(WAITTIME/2);

	(void) close (fd);
	globok = 1;

	DBUG_VOID_RETURN;
}

private	void
test19()
{
	DBUG_ENTER("test19");

	sigstat = "ignored";
	do_feio("ri", -1, t19_20io, t19rpt);

	sigstat = "blocked";
	do_feio("rb", -1, t19_20io, t19rpt);

	DBUG_VOID_RETURN;
}

private void
t19rpt(ret, err)
int ret, err;
{
	int	pathok = setupok;

	DBUG_ENTER("t19rpt");

	PATH_FUNC_TRACE;

	if (ret != SYSERROR || err != EIO)
	{
		xx_rpt(FAILURE);
		in_rpt("readv() from background with SIGTTIN %s did not give correct results",
			sigstat);
		valrpt(SYSERROR, ret, EIO, err);
	}
	else
		PATH_XS_RPT(1);

	DBUG_VOID_RETURN;
}

private	void
test20()
{
	DBUG_ENTER("test20");

	do_feio("ro", -1, t19_20io, t20rpt);

	DBUG_VOID_RETURN;
}

private void
t20rpt(ret, err)
int ret, err;
{
	int	pathok = setupok;

	DBUG_ENTER("t20rpt");

	PATH_FUNC_TRACE;

	if (ret != SYSERROR || err != EIO)
	{
		xx_rpt(FAILURE);
		in_rpt("readv() from orphaned background process did not give correct results");
		valrpt(SYSERROR, ret, EIO, err);
	}
	else
		PATH_XS_RPT(1);

	DBUG_VOID_RETURN;
}

private int
t19_20io(fp)
FILE *fp;
{
	struct iovec iovector;

	globok = 1;

	iovector.iov_base = in_buf;
	iovector.iov_len = 1;
	return(readv(fileno(fp), &iovector, 1));
}


private void
test21()
{
	DBUG_ENTER("test21");

	(void) cppair(ch_t21, NULLFN, 4 * WAITTIME, 0);

	(void) rmdir(t21_dir);

	DBUG_VOID_RETURN;
}

private void
ch_t21()
{
	char	*rofs;
	int	err;
	char	*args[7];

	DBUG_ENTER("ch_t21");

	if ((rofs = tet_getvar("VSX_ROFS")) == NULL || *rofs == '\0')
	{
		xx_rpt(DELETION);
		in_rpt("deletion reason: parameter VSX_ROFS is not defined");
		DBUG_VOID_RETURN;
	}

	args[0] = prog_su;
	args[1] = itoa(tet_thistest);
	args[2] = t21_dir;
	args[3] = t21_file;
	args[4] = vg_ident;
	args[5] = vg_dbug;
	args[6] = NULL;
	(void) tet_exec(execpath(prog_su), args, environ);

	err = errno;
	xx_rpt(DELETION);
	in_rpt("deletion reason: tet_exec(%s, ...) failed - errno %d (%s)",
		execpath(prog_su), err, errname(err));

	DBUG_VOID_RETURN;
}

private void
test22()
{
	int pathok = setupok;
	int err, fd;
	struct iovec iovector;

	DBUG_ENTER("test22");

	/*
	** When iovcnt is less than or equal to 0, then a call to readv()
	** returns -1 with errno set to EINVAL
	*/

	testfail = 0;

	if ((fd = open(t_file, O_RDONLY, 0)) == SYSERROR)
	{
		err = errno;
		if (!testfail++)
			xx_rpt(DELETION);
		in_rpt("could not open file %s: errno = %d (%s)",
			t_file, err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	(void) tbreadv(fd, &iovector, 0, SYSERROR, EINVAL, (char *) NULL);
	PATH_FUNC_TRACE;

	iovector.iov_base = in_buf;
	iovector.iov_len = EXP_SIZE;
	globok = 0;
	(void) tbreadv(fd, &iovector, -1, SYSERROR, EINVAL, (char *) NULL);
	PATH_FUNC_TRACE;

	(void) close(fd);

	if (!testfail)
		PATH_XS_RPT(3);

	DBUG_VOID_RETURN;
}

private void
test23()
{
	int pathok = setupok;
	struct iovec iovector[IOV_MAX + 1];
	int Niovector = sizeof iovector / sizeof iovector[0];
	int fd, err, len, n;

	DBUG_ENTER("test23");

	/*
	** When iovcnt is greater than IOV_MAX, then a call to readv()
	** returns -1 with errno set to EINVAL
	*/

	testfail = 0;

	if ((fd = open(t_file, O_RDONLY, 0)) == SYSERROR)
	{
		err = errno;
		if (!testfail++)
			xx_rpt(DELETION);
		in_rpt("could not open file %s: errno = %s (%s)",
			t_file, err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	if ((len = (EXP_SIZE / Niovector)) <= 0)
		len = 1;
	for (n = 0; n < Niovector; n++) {
		iovector[n].iov_base = in_buf + ((n * 4) % pipe_buf);
		iovector[n].iov_len = len;
	}
	globok = 0;
	(void) tbreadv(fd, &iovector, Niovector, SYSERROR, EINVAL,
		(char *) NULL);
	PATH_FUNC_TRACE;

	(void) close(fd);

	if (!testfail)
		PATH_XS_RPT(2);

	DBUG_VOID_RETURN;
}

private void
test24()
{
	/*
	** When the sum of the iov_len members overfolws a ssize_t,
	** then a call to readv() returns -1 with errno set to EINVAL
	*/

	DBUG_ENTER("test24");

	if (tet_fork(ch_t24, TET_NULLFP, WAITTIME, 0) < 0)
		in_rpt("(Note: a SIGSEGV in the child process may mean that readv() did not detect the error condition)");

	DBUG_VOID_RETURN;
}

private void
ch_t24()
{
	int pathok = setupok;
	struct iovec iovector[IOV_MAX];
	int Niovector = sizeof iovector / sizeof iovector[0];
	int fd, err, n;
	struct rlimit rlimit;
	void *buf;
	size_t buflen, onebuf;

	DBUG_ENTER("ch_t24");

	/*
	** if there are IOV_MAX iovectors and each iov_len is onebuf bytes,
	** then the sum of all the iov_len values will "overflow a ssize_t"
	** (this won't work if IOV_MAX < 2)
	*/
	onebuf = (size_t) (SSIZE_MAX / IOV_MAX) + IOV_MAX;
	onebuf = ((onebuf + 15) >> 4) << 4;

	/*
	** estimate how much memory the system is likely to let us have -
	** allow 2Mb for current usage
	*/
	if (getrlimit(RLIMIT_DATA, &rlimit) < 0) {
		err = errno;
		in_rpt("getrlimit(RLIMIT_DATA) failed, errno = %d (%s)",
			err, errname(err));
		buflen = MEG2BYTE(64);
		in_rpt("will assume a limit of approx %d Mb",
			BYTE2MEG(buflen));
	}
	else {
		DBUG_PRINTF("ch_t24",
			"process's max data size is %ld bytes (approx %d Mb)",
			(long) rlimit.rlim_cur,
			BYTE2MEG(rlimit.rlim_cur));
		buflen = (size_t) rlimit.rlim_cur;
	}
	if ((buflen - pipe_buf) > MEG2BYTE(2))
		buflen -= MEG2BYTE(2);

	/*
	** try and allocate a buffer that is big enough -
	** if this is not possible, then allocate the largest buffer that
	** the system will allow
	*/
	if (buflen > onebuf)
		buflen = onebuf;
	while (buflen > pipe_buf) {
		DBUG_PRINTF("ch_t24",
			"about to call malloc(%ld) (approx %d Mb)",
			(long) buflen, BYTE2MEG(buflen));
		errno = 0;
		if ((buf = malloc(buflen)) != (void *) 0) {
			DBUG_PRINTF("test30", "\tcall succeded!");
			break;
		}
		err = errno;
		DBUG_PRINTF("ch_t24", "\tcall failed, errno = %d (%s)",
			err, errname(err));
		if (buflen > MEG2BYTE(32))
			buflen /= 2;
		else if (buflen > MEG2BYTE(1))
			buflen -= MEG2BYTE(1);
		else
			buflen -= pipe_buf;
	}

	if (buflen < onebuf || buf == (void *) 0) {
		DBUG_PRINTF("ch_t24",
		"Could not allocate a large read buffer (wanted %d bytes)",
			onebuf);
		if (buf == (void *) 0) {
			DBUG_PRINTF("ch_t24",
				"Will attempt to test using in_buf of %d bytes",
				pipe_buf);
			buf = in_buf;
		}
		else
			DBUG_PRINTF("ch_t24",
			"Will attempt to test using a buffer of %ld bytes",
				(long) buflen);
		DBUG_PRINTF("ch_t24",
			"This may result in a SIGSEGV being raised");
	}

	if ((fd = open(t_file, O_RDONLY, 0)) == SYSERROR)
	{
		err = errno;
		if (!testfail++)
			xx_rpt(DELETION);
		in_rpt("could not open file %s: errno = %s (%s)",
			t_file, err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	for (n = 0; n < Niovector; n++) {
		iovector[n].iov_base = buf;
		iovector[n].iov_len = onebuf;
	}
	globok = 0;
	(void) tbreadv(fd, &iovector, Niovector, SYSERROR, EINVAL,
		(char *) NULL);
	PATH_FUNC_TRACE;

	(void) close(fd);

	if (!testfail)
		PATH_XS_RPT(2);

	DBUG_VOID_RETURN;
}

