/* dv @(#)V9TS/tset/GABI.os/ipc/ftok/ftok.c	1.3 93/05/17 */
/*
*	SCCS:  @(#)  GABI.os/ipc/ftok/ftok.c Rel 4.2.4     (10/22/92)
*
*
* (C) Copyright 1990,1991 UniSoft Group Ltd.
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)  GABI.os/ipc/ftok/ftok.c Rel 4.2.4     (10/22/92)";
static	char	*copyright[] = {
		"(C) Copyright 1990,1991 UniSoft Group Ltd.",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		T.ftok

PROJECT:	GABI Validation suite

DESCRIPTION:
	Tests for the ftok() system call.

AUTHOR:		Neil Moses
DATE CREATED:	26 April 1993
MODIFICATIONS:
		Neil Moses, UniSoft Ltd
		7 May 1993
		Added SVR4.0/4.2 switch

************************************************************************/
#include	<std.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<dbug.h>

#include	<sys/types.h>
#include	<unistd.h>
#include	<time.h>
#include	<errno.h>
#include	<sys/ipc.h>
#include	<sys/msg.h>
#include	<sys/shm.h>
#include	<sys/stat.h>

#include	<report.h>
#include	<tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef ftok
#endif

/* #define NO_TESTS	6		/* number of tests in testset */
#define NO_TESTS	4

#define	MODEANY		((mode_t)(S_IRWXU|S_IRWXG|S_IRWXO))
#define	MODENOACC	((mode_t)(S_IRUSR|S_IWUSR|S_IRGRP|S_IWGRP|S_IROTH|S_IWOTH))
#define	WAITTIME	(5 * SPEEDFACTOR)
#define SEGSIZE         512
#define MODERWANY       ((mode_t) (RW_U|RW_G|RW_O))

#define	ID1	11
#define	ID3	33

/*
 * message access permissions
 */
#define	RW_U		(S_IRUSR|S_IWUSR)	
#define	RW_G		(S_IRGRP|S_IWGRP)
#define	RW_O		(S_IROTH|S_IWOTH)
#define	MSG_READWRITE	(RW_U|RW_G|RW_O)
#define	MSG_READONLY	(S_IRUSR|S_IRGRP|S_IROTH)

public	int	no_tests = NO_TESTS;

extern	char	*errname();
extern	int	crfile();
extern	int	crdir();
extern	void	valrpt();

private	char	*msgpath	= "./ftok.f";
private	char	*msgpath1	= "./ftok.f1";
#if 0
private	char	*t5_notexist	= "./ftok.f5";
private	char	*t6_noacc_dir	= "./ftok.d6";
private	char	*t6_noacc_file	= "./ftok.d6/ftok.f6";
#endif
private int	setupok = -1;
private int	test_failed = 0;

union semun {
                int val;
                struct semid_ds *buf;
                unsigned short *array;
};

private	void	setup();
private	void	cleanup();
private	void	test1();
private	void	ch_t1();
private	void	test2();
private	void	test3();
private	void	test4();
#if 0
private	void	test5();
private	void	test6();
#endif

public 	void	(*setfunc)() = setup;
public	void	(*clnfunc)() = cleanup;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	 test2, 2,
	 test3, 3,
	 test4, 4,
#if 0
	 test5, 5,
	 test6, 6,
#endif
	NULL, 0
};

private void
setup()
{
#if 0
	char	*abi_vers;
#endif
	static 	char	errmsg[512];

	int	i;
	int	err;
	int	pathok = 0;

	DBUG_ENTER("setup");

#if 0
	if((abi_vers = tet_getvar("ABI_VERSION")) == (char *) NULL 
		|| abi_vers[0] == '\0')
	{
		xx_all(DELETION, "Unable to determine which ABI version we are testing");
		DBUG_VOID_RETURN;
	}

	if(atoi(abi_vers) < 3)
		xx_all(NOTINUSE,NULL);
#endif

	if (crfile(msgpath, MODEANY, (int) geteuid(), (int) getegid()) 
		== SYSERROR) {

		err = errno;
		(void) sprintf(errmsg, "crfile(\"%s\") failed - errno %d (%s)",
			msgpath, err, errname(err));
		for (i = 1; i <= NO_TESTS; i++)
			(void) tet_delete(i, errmsg);
		DBUG_VOID_RETURN;
	} else
		PATH_TRACE;

	PATH_SETUP_RPT(1);

	DBUG_VOID_RETURN;
}

private	void
cleanup()
{
	DBUG_ENTER("cleanup");

	(void) unlink(msgpath);
	(void) unlink(msgpath1);

	DBUG_VOID_RETURN;
}

private	void
test1()
{
	DBUG_ENTER("test1");

	(void)cppair(ch_t1, NULLFN, WAITTIME, 0);

        DBUG_VOID_RETURN;
}

private	void
ch_t1()
{
	union   semun semun;
	int	shmid, sid;
	int	err;
	int 	msgqid;
	key_t	key;
	struct 	shmid_ds shmid_ds1;
	struct	msqid_ds buf;
	int	pathok = setupok;

	DBUG_ENTER("ch_t1");

	errno = NOERROR;
	test_failed = 0;
	
	if ((key = ftok(msgpath, ID1)) == (key_t) SYSERROR) {
		err = errno;
		if(!test_failed++)
			xx_rpt(DELETION);
		in_rpt("ftok(\"%s\", %d) failed - errno %d (%s)", 
			msgpath, ID1, err, errname(err));
		DBUG_VOID_RETURN;
	} 
	else
		PATH_TRACE;

	if ((msgqid = msgget(key, (IPC_CREAT|MSG_READWRITE))) == SYSERROR) {
		if(!test_failed++)
			xx_rpt(FAILURE);
		in_rpt("ftok(\"%s\", %d) failed to return a key usable by msgget()", msgpath, ID1);
	} 
	else
		PATH_TRACE;

	(void) msgctl(msgqid, IPC_RMID, (struct msqid_ds *)0);

	if((sid = semget(key, 1, (mode_t)IPC_CREAT)) == SYSERROR)
	{
		if(!test_failed++)
			xx_rpt(FAILURE);
		in_rpt("ftok(\"%s\", %d) failed to return a key usable by semget()", msgpath, ID1);
	} 
	else
		PATH_TRACE;

	(void) semctl(sid, 0, IPC_RMID, semun);

	if((shmid = shmget(key, SEGSIZE, MODERWANY|IPC_CREAT)) == SYSERROR)
	{
		if(!test_failed++)
			xx_rpt(FAILURE);
		in_rpt("ftok(\"%s\", %d) failed to return a key usable by shmget()", msgpath, ID1);
	} 
	else
		PATH_TRACE;

	(void) shmctl(shmid, IPC_RMID, &shmid_ds1);

	if(!test_failed)
		PATH_XS_RPT(4);

	DBUG_VOID_RETURN;
}

private	void
test2()
{
	key_t	key1, key2;
	int	err;
	int	pathok = setupok;

	DBUG_ENTER("test2");

	errno = NOERROR;

	if(link(msgpath, msgpath1) == SYSERROR)
	{
		xx_rpt(DELETION);
		in_rpt("link(\"%s\", \"%s\") failed - errno %d (%s)", 
			msgpath, msgpath1);
		DBUG_VOID_RETURN;
	} 
	else
		PATH_TRACE;

	if ((key1 = ftok(msgpath, ID1)) == (key_t) SYSERROR) {
		err = errno;
		xx_rpt(DELETION);
		in_rpt("ftok(\"%s\", %d) failed - errno %d (%s)", 
			msgpath, ID1, err, errname(err));
		(void) unlink(msgpath1);
		DBUG_VOID_RETURN;
	} 
	else
		PATH_TRACE;

	if ((key2 = ftok(msgpath1, ID1)) == (key_t) SYSERROR) {
		err = errno;
		xx_rpt(DELETION);
		in_rpt("ftok(\"%s\", %d) failed - errno %d (%s)", 
			msgpath, ID1, err, errname(err));
		(void) unlink(msgpath1);
		DBUG_VOID_RETURN;
	} 
	else
		PATH_TRACE;

	if(key1 != key2)
	{
		xx_rpt(FAILURE);
		in_rpt("ftok() failed to return the same key for calls :");
		in_rpt("ftok(\"%s\", %d) returned key %d", msgpath, ID1, key1);
		in_rpt("ftok(\"%s\", %d) returned key %d", msgpath1, ID1, key2);
		in_rpt("where %s is a link to %s", msgpath1, msgpath);
	}
	else
	{
		PATH_TRACE;
		PATH_XS_RPT(4);
	}

	(void) unlink(msgpath1);

	DBUG_VOID_RETURN;
}

private	void
test3()
{
	key_t	key1, key2;
	int	err;
	int	pathok = setupok;

	DBUG_ENTER("test3");

	errno = NOERROR;
	
	if ((key1 = ftok(msgpath, ID1)) == (key_t) SYSERROR) {
		err = errno;
		xx_rpt(DELETION);
		in_rpt("ftok(\"%s\", %d) failed - errno %d (%s)", 
			msgpath, ID1, err, errname(err));
		DBUG_VOID_RETURN;
	} else
		PATH_TRACE;

	if ((key2 = ftok(msgpath, ID3)) == (key_t) SYSERROR) {
		err = errno;
		xx_rpt(DELETION);
		in_rpt("ftok(\"%s\", %d) failed - errno %d (%s)", 
			msgpath, ID3, err, errname(err));
		DBUG_VOID_RETURN;
	} else
		PATH_TRACE;

	if(key1 == key2)
	{
		xx_rpt(FAILURE);
		in_rpt("ftok() failed to return a different keys for calls :");
		in_rpt("ftok(\"%s\", %d) returned key %d", msgpath, ID1, key1);
		in_rpt("ftok(\"%s\", %d) returned key %d", msgpath1, ID1, key2);
		in_rpt("where the IDs are different");
	}
	else
	{
		PATH_TRACE;
		PATH_XS_RPT(3);
	}

	DBUG_VOID_RETURN;
}

private	void
test4()
{
	key_t	key1, key2;
	int	err;
	int	pathok = setupok;

	DBUG_ENTER("test4");

	errno = NOERROR;

	if (crfile(msgpath1, MODEANY, (int) geteuid(), (int) getegid()) 
		== SYSERROR) 
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("crfile(\"%s\") failed - errno %d (%s)",
			msgpath1, err, errname(err));
		DBUG_VOID_RETURN;
	} else
		PATH_TRACE;

	if ((key1 = ftok(msgpath, ID1)) == (key_t) SYSERROR) {
		err = errno;
		xx_rpt(DELETION);
		in_rpt("ftok(\"%s\", %d) failed - errno %d (%s)", 
			msgpath, ID1, err, errname(err));
		DBUG_VOID_RETURN;
	} 
	else
		PATH_TRACE;

	if ((key2 = ftok(msgpath1, ID1)) == (key_t) SYSERROR) {
		err = errno;
		xx_rpt(DELETION);
		in_rpt("ftok(\"%s\", %d) failed - errno %d (%s)", 
			msgpath1, ID1, err, errname(err));
		DBUG_VOID_RETURN;
	} 
	else
		PATH_TRACE;

	if(key1 == key2)
	{
		xx_rpt(FAILURE);
		in_rpt("ftok() failed to return different keys for calls :");
		in_rpt("ftok(\"%s\", %d) returned key %d", msgpath, ID1, key1);
		in_rpt("ftok(\"%s\", %d) returned key %d", msgpath1, ID1, key2);
		in_rpt("where %s is different path to %s", msgpath, msgpath1);
	}
	else
	{
		PATH_TRACE;
		PATH_XS_RPT(4);
	}

	DBUG_VOID_RETURN;
}

#if 0
private	void
test5()
{
	key_t	key;
	int	err;
	int	pathok = setupok;

	DBUG_ENTER("test5");
	
	(void) unlink(t5_notexist);

	if((key = ftok(t5_notexist, ID1)) != (key_t) -1) {
		xx_rpt(FAILURE);
		in_rpt("ftok(\"%s\",%d) did not return -1", t5_notexist, ID1);
		in_rpt("where %s does not exist", t5_notexist);
	} 
	else
		PATH_TRACE;

	PATH_XS_RPT(1);

	DBUG_VOID_RETURN;
}

private	void
test6()
{
	key_t	key;
	int	err;
	int	pathok = setupok;

	DBUG_ENTER("test6");
	
	if(crdir(t6_noacc_dir, MODEANY, (int) geteuid(), (int) getegid()) 
		== SYSERROR) 
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("crdir(\"%s\") failed - errno %d (%s)",
			t6_noacc_dir, err, errname(err));
		DBUG_VOID_RETURN;
	} 
	else
		PATH_TRACE;

	if(crfile(t6_noacc_file, MODEANY, (int) geteuid(), (int) getegid()) 
		== SYSERROR) 
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("crfile(\"%s\") failed - errno %d (%s)",
			t6_noacc_file, err, errname(err));
		(void) rmdir(t6_noacc_dir);
		DBUG_VOID_RETURN;
	} else
		PATH_TRACE;

	if(chmod(t6_noacc_dir, MODENOACC) == SYSERROR) 
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("chmod(\"%s\", %#o) failed - errno %d (%s)",
			t6_noacc_file, MODENOACC, err, errname(err));
		(void) rmdir(t6_noacc_dir);
		DBUG_VOID_RETURN;
	} else
		PATH_TRACE;

	if((key = ftok(t6_noacc_file, ID1)) != (key_t) -1) {
		xx_rpt(FAILURE);
		in_rpt("ftok(\"%s\",%d) did not return -1", t6_noacc_file, ID1);
		in_rpt("where %s does not exist", t6_noacc_file);
	} 
	else
	{
		PATH_TRACE;
		PATH_XS_RPT(4);
	}

	(void) chmod(t6_noacc_dir, MODEANY);
	(void) unlink(t6_noacc_file);
	(void) rmdir(t6_noacc_dir);

	DBUG_VOID_RETURN;
}
#endif

