/* dv @(#)V9TS/tset/GABI.os/jump/getcontext/getcontext.c	1.2 93/12/09 */
/*
*	SCCS:  @(#) GABI.os/jump/getcontext/getcontext.c	Ver. 1.8	Rel. 1.3	(92/08/01)
*
*
* (C) Copyright 1990,1991 UniSoft Group Ltd.
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#) GABI.os/jump/getcontext/getcontext.c	Ver. 1.8	Rel. 1.3	(92/08/01)";
static	char	*copyright[] = {
		"(C) Copyright 1990,1991 UniSoft Group Ltd.",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		T.getcontext

PROJECT:	gABI Validation suite

DESCRIPTION:
	Testset for the getcontext() system call.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Keith Holder
DATE CREATED:	Thu Aug  9 12:24:50 BST 1990
MODIFICATIONS:	

************************************************************************/
#include	<std.h>
#include	<stdlib.h>
#include	<dbug.h>
#include	<report.h>
#include	<errno.h>
#include	<ucontext.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef getcontext
#endif

#define 	NO_TESTS	2		/* number of tests in testset */
#define		WAITTIME	(5 * SPEEDFACTOR)


extern	int	cppair();
extern	int	valrpt();

int	no_tests = NO_TESTS;

private	ucontext_t context;
private	int	first_time = 0;
public int	jumpok;
private void	test1();
private void	test2();
private void	func1();
private void	func2();
private void	ch_t2();

public	void	(*setfunc) () = NULL;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	 test2, 2,
	NULL, 0
};


#ifdef	TESTBED
#define	getcontext(ucp)	(1)
#endif

private void
test1()
{
	int	rval;
	int	pathok=0;

	DBUG_ENTER("test1");

	if ((rval = getcontext(&context)) != 0)
	{
		xx_rpt(FAILURE);
		in_rpt("getcontext returned %d instead of 0", rval);
	} else {
		PATH_TRACE;
		PATH_XS_RPT(1);
	}

	DBUG_VOID_RETURN;
}


private	void
test2()
{
	DBUG_ENTER("test2");

	(void) cppair(ch_t2, NULLFN, WAITTIME, 0);

	DBUG_VOID_RETURN;
}

private void
ch_t2()
{

	int	err, rval;

	DBUG_ENTER("ch_t2");

	jumpok = 0;

	rval=getcontext(&context);
	err = errno;
	if ((first_time == 0) && (rval == SYSERROR)) {
		xx_rpt(FAILURE);
		in_rpt("deletion reason: getcontext() returned error");
		valrpt(NOERROR,rval,NOERROR,err);
		DBUG_VOID_RETURN;
	}  else
		JUMP_TRACE;	/* setcontext and getcontext both return here */

	if ( first_time == 0) { /* first return from getcontext() */
		first_time++;
		func1();
	} else {	    /* second return, via setcontext() */
		JUMP_XS_RPT(4);
	}

	DBUG_VOID_RETURN;
}


private	void
func1()
{

	DBUG_ENTER("func1");

	JUMP_TRACE;
	func2();

	DBUG_VOID_RETURN;
}


private	void
func2()
{

	DBUG_ENTER("func2");

	JUMP_TRACE;
	(void)setcontext(&context);

	xx_rpt(DELETION);
	in_rpt("setcontext() returned unexpectedly!");

	DBUG_VOID_RETURN;
}
