/* dv @(#)V9TS/tset/SCD.os/jump/makecontext/makecontext.c/makecontext.c	1.4 96/11/28 */
/*
*	SCCS:  @(#) GABI.os/jump/makecontext/makecontext.c	Ver. 1.8	Rel. 1.3	(92/08/01)
*
*
* (C) Copyright 1990,1991 UniSoft Group Ltd.
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#) GABI.os/jump/makecontext/makecontext.c	Ver. 1.8	Rel. 1.3	(92/08/01)";
static	char	*copyright[] = {
		"(C) Copyright 1990,1991 UniSoft Group Ltd.",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		T.makecontext

PROJECT:	gABI Validation suite

DESCRIPTION:
	Testset for the makecontext() system call.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Neil Moses
DATE CREATED:	22nd April 1993
MODIFICATIONS:
		Neil Moses, UniSoft Ltd
		7 May 1993
		Added SRV4.0/4.2 switch

************************************************************************/
#include	<std.h>
#include	<stdlib.h>
#include	<dbug.h>
#include	<report.h>
#include	<errno.h>
#include	<ucontext.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef makecontext
#endif

/* #define 	NO_TESTS	4		/* number of tests in testset */
#define 	NO_TESTS	3

#define		WAITTIME	(5 * SPEEDFACTOR)

#define		T2_ARG1		"t2_arg1"
#define		T2_ARG2		"t2_arg2"
#define		T2_ARG3		"t2_arg3"
#if 0
#define		T3_ARG1		"t3_arg1"
#define		T3_ARG2		"t3_arg2"
#define		T3_ARG3		"t3_arg3"
#endif

extern	int	cppair();
extern	char	*errname();

int	no_tests = NO_TESTS;

private int	globpathok = 0;
private	int	first_time = 0;
private	int	rval = 0;
private int	testfail = 0;
private int	callfunc = 0;
private	ucontext_t oucp, ucp;

#if 0
private int	jumpok;
#endif
private void	setup();
private void	test1();
private void	ch_t1();
private void	t1_func();
private void	test2();
private void	ch_t2();
private void	t2_func();
#if 0
private void	test3();
private void	ch_t3();
private void	t3_func();
#endif
private void	test4();
private void	ch_t4();
private void	t4_func();

public	void	(*setfunc) () = setup;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	 test2, 2,
#if 0
	 test3, 3,
	 test4, 4,
#else
	test4, 3,
#endif
	NULL, 0
};


private void
setup()
{
#if 0
	char	*abi_vers;
#endif

	DBUG_ENTER("setup");

#if 0
	if((abi_vers = tet_getvar("ABI_VERSION")) == (char *) NULL 
		|| abi_vers[0] == '\0')
	{
		xx_all(DELETION, "Unable to determine which ABI version we are testing");
		DBUG_VOID_RETURN;
	}

#ifndef ABI_MIPS
	if(atoi(abi_vers) < 3)
		xx_all(NOTINUSE,NULL);
#endif /*ABI_MIPS*/
#endif /* 0 */

	DBUG_VOID_RETURN;
}

private void
test1()
{
	DBUG_ENTER("test1");

	cppair(ch_t1, NULLFN, WAITTIME, 0);

	DBUG_VOID_RETURN;
}

private void
ch_t1()
{
	int	pathok=0;
	int	err;

	DBUG_ENTER("ch_t1");

	globpathok = 0;
	testfail = 0;
	first_time = 0;

	rval = getcontext(&ucp);
	err = errno;

	if(first_time == 1)
	{
		pathok = globpathok;

		/*
		 * It is assumed that if the user context is not
		 * modified, then the function given to makecontext
		 * will not have been called.
		 */
		if(!callfunc)
		{
			if(!testfail++)
				xx_rpt(FAILURE);
			in_rpt("makecontext() did not modify the user context");
		}
		else
			PATH_XS_RPT(3);

		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	if(rval != 0)
	{
		if(!testfail++)
			xx_rpt(DELETION);
		in_rpt("getcontext returned %d instead of 0", rval);
		if (rval == -1)
			in_rpt("with errno = %d (%s)", err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	first_time++;
	globpathok += pathok;

	/* Point to context to resume after calling setcontext() */
	ucp.uc_link = &oucp;

	/* Save context area */
	oucp = ucp;

	makecontext(&ucp, t1_func, 0);

	/* Check that context has been modified */

	if ((rval = setcontext(&ucp)) != 0)
	{
		if(!testfail++)
			xx_rpt(DELETION);
		in_rpt("setcontext returned %d instead of 0", rval);
		DBUG_VOID_RETURN;
	}

	/* Shouldn't reach here */
	xx_rpt(DELETION);
	in_rpt("setcontext() failed to set new context");
	DBUG_VOID_RETURN;
}

private	void
t1_func()
{
	int	pathok = 0;

	DBUG_ENTER("t1_func");

	globpathok++;

	PATH_TRACE;	/* Leave a footprint */

	callfunc = 1;

	DBUG_VOID_RETURN;
}

private	void
test2()
{
	DBUG_ENTER("test2");

	(void) cppair(ch_t2, NULLFN, WAITTIME, 0);

	DBUG_VOID_RETURN;
}

private void
ch_t2()
{
	int	pathok=0;
	int	err;

	DBUG_ENTER("ch_t2");

	globpathok = 0;
	testfail = 0;

	if ((rval = getcontext(&ucp)) != 0)
	{
		err = errno;
		if(!testfail++)
			xx_rpt(DELETION);
		in_rpt("getcontext returned %d instead of 0", rval);
		if (rval == -1)
			in_rpt("with errno = %d (%s)", err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	globpathok += pathok;

	/* Point to context to resume after calling setcontext() */
	ucp.uc_link = &oucp;

	/* Save context area */
	oucp = ucp;

	makecontext(&ucp, t2_func, 3, T2_ARG1, T2_ARG2, T2_ARG3);

	if ((rval = setcontext(&ucp)) != 0)
	{
		if(!testfail++)
			xx_rpt(DELETION);
		in_rpt("setcontext returned %d instead of 0", rval);
		DBUG_VOID_RETURN;
	}

	/* Shouldn't reach here */
	xx_rpt(DELETION);
	in_rpt("setcontext() failed to set new context");
	DBUG_VOID_RETURN;
}

private	void
t2_func(arg1, arg2, arg3)
char	*arg1;
char	*arg2;
char	*arg3;
{
	int	pathok = 0;

	DBUG_ENTER("t2_func");

	pathok = globpathok;

	if(strcmp(arg1, T2_ARG1) 
	|| strcmp(arg2, T2_ARG2) 
	|| strcmp(arg3, T2_ARG3))
	{
		xx_rpt(FAILURE);
	
		if(strcmp(arg1, T2_ARG1))
		{
			in_rpt("First arg not correctly passed to function");
			in_rpt("Expected argument <%s>", T2_ARG1);
			in_rpt("Actual   argument <%s>", arg1);
		}
		
		if(strcmp(arg2, T2_ARG2))
		{
			in_rpt("Second arg not correctly passed to function");
			in_rpt("Expected argument <%s>", T2_ARG2);
			in_rpt("Actual   argument <%s>", arg2);
		}
		
		if(strcmp(arg3, T2_ARG3))
		{
			in_rpt("Third arg not correctly passed to function");
			in_rpt("Expected argument <%s>", T2_ARG3);
			in_rpt("Actual   argument <%s>", arg3);
		}
	}
	else
		PATH_TRACE;
		
	if(!testfail)
		PATH_XS_RPT(2);

	DBUG_EXIT(OK);
}

#if 0
private	void
test3()
{
	DBUG_ENTER("test3");

	(void) cppair(ch_t3, NULLFN, WAITTIME, 0);

	DBUG_VOID_RETURN;
}

private void
ch_t3()
{
	ucontext_t sucp;
	int	pathok=0;
	int	err;

	DBUG_ENTER("ch_t3");

	globpathok = 0;
	testfail = 0;

	if ((rval = getcontext(&ucp)) != 0)
	{
		err = errno;
		if(!testfail++)
			xx_rpt(DELETION);
		in_rpt("getcontext returned %d instead of 0", rval);
		if (rval == -1)
			in_rpt("with errno = %d (%s)", err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	globpathok += pathok;

	/* Point to context to resume after calling swapcontext() */
	ucp.uc_link = &oucp;

	/* Save context area */
	oucp = ucp;

	makecontext(&ucp, t3_func, 3, T3_ARG1, T3_ARG2, T3_ARG3);

	if ((rval = swapcontext(&sucp, &ucp)) != 0)
	{
		if(!testfail++)
			xx_rpt(DELETION);
		in_rpt("swapcontext returned %d instead of 0", rval);
		DBUG_VOID_RETURN;
	}

	/* Shouldn't reach here */
	xx_rpt(DELETION);
	in_rpt("swapcontext() failed to set new context");
	DBUG_VOID_RETURN;
}

private	void
t3_func(arg1, arg2, arg3)
char	*arg1;
char	*arg2;
char	*arg3;
{
	int	pathok = 0;

	DBUG_ENTER("t3_func");

	pathok = globpathok;

	if(strcmp(arg1, T3_ARG1) 
	|| strcmp(arg2, T3_ARG2) 
	|| strcmp(arg3, T3_ARG3))
	{
		xx_rpt(FAILURE);
	
		if(strcmp(arg1, T3_ARG1))
		{
			in_rpt("First arg not correctly passed to function");
			in_rpt("Expected argument <%s>", T3_ARG1);
			in_rpt("Actual   argument <%s>", arg1);
		}
		
		if(strcmp(arg2, T3_ARG2))
		{
			in_rpt("Second arg not correctly passed to function");
			in_rpt("Expected argument <%s>", T3_ARG2);
			in_rpt("Actual   argument <%s>", arg2);
		}
		
		if(strcmp(arg3, T3_ARG3))
		{
			in_rpt("Third arg not correctly passed to function");
			in_rpt("Expected argument <%s>", T3_ARG3);
			in_rpt("Actual   argument <%s>", arg3);
		}
	}
	else
		PATH_TRACE;
		
	if(!testfail)
		PATH_XS_RPT(2);

	DBUG_EXIT(OK);
}

#endif

private void
test4()
{
	DBUG_ENTER("test4");

	cppair(ch_t4, NULLFN, WAITTIME, 0);

	DBUG_VOID_RETURN;
}

private void
ch_t4()
{
	int	pathok=0;
	int	err;

	DBUG_ENTER("ch_t4");

	globpathok = 0;
	testfail = 0;
	first_time = 0;

	rval = getcontext(&ucp);
	err = errno;

	if(first_time == 1)
	{
		pathok = globpathok;

		if(!testfail)
			PATH_XS_RPT(4);

		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	if(rval != 0)
	{
		if(!testfail++)
			xx_rpt(DELETION);
		in_rpt("getcontext returned %d instead of 0", rval);
		if (rval == -1)
			in_rpt("with errno = %d (%s)", err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	/* Point to context to resume after calling setcontext() */
	ucp.uc_link = &oucp;

	/* Save context area */
	oucp = ucp;

	makecontext(&ucp, t4_func, 0);

	if(first_time == 1)
	{
		xx_rpt(FAILURE);
		in_rpt("failed to resume execution at the saved user context");
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	globpathok += pathok;
	first_time++;

	if ((rval = setcontext(&ucp)) != 0)
	{
		if(!testfail++)
			xx_rpt(DELETION);
		in_rpt("setcontext returned %d instead of 0", rval);
		DBUG_VOID_RETURN;
	}

	/* Shouldn't reach here */
	xx_rpt(FAILURE);
	in_rpt("failed to resume execution at the saved user context");
	DBUG_VOID_RETURN;
}

private	void
t4_func()
{
	int	pathok = 0;

	DBUG_ENTER("t4_func");

	PATH_TRACE;	/* Leave a footprint */

	globpathok++;

	DBUG_VOID_RETURN;
}

