/* dv @(#)V9TS/tset/GABI.os/jump/setcontext/setcontext.c	1.2 93/12/09 */
/*
*	SCCS:  @(#) GABI.os/jump/setcontext/setcontext.c	Ver. 1.7	Rel. 1.3	(92/08/01)
*
*
* (C) Copyright 1990,1991 UniSoft Group Ltd.
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#) GABI.os/jump/setcontext/setcontext.c	Ver. 1.7	Rel. 1.3	(92/08/01)";
static	char	*copyright[] = {
		"(C) Copyright 1990,1991 UniSoft Group Ltd.",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		T.setcontext

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Testset for the setcontext() system call.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Keith Holder
DATE CREATED:	Thu Aug  9 12:24:50 BST 1990
MODIFICATIONS:	

************************************************************************/
#include	<std.h>
#include	<stdlib.h>
#include	<dbug.h>
#include	<report.h>
#include	<errno.h>
#include	<ucontext.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef setcontext
#endif

#define 	NO_TESTS	1		/* number of tests in testset */
#define		WAITTIME	(5 * SPEEDFACTOR)


int	no_tests = NO_TESTS;

extern	int	cppair();
extern	void	valrpt();

private	ucontext_t context;
private void	test1();
private void	func1();
private void	func2();
private void	ch_t1();
private	int 	first_time = 0;
public int	jumpok;

public	void	(*setfunc) () = NULL;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	NULL, 0
};




private void
test1()
{
	DBUG_ENTER("test1");

	(void) cppair(ch_t1, NULLFN, WAITTIME, 0);

	DBUG_VOID_RETURN;
}

private void
ch_t1()
{

	int	err, rval;

	DBUG_ENTER("ch_t1");

	jumpok = 0;
	first_time = 0;

	rval=getcontext(&context);
	err = errno;
	if ((first_time == 0) && (rval == SYSERROR)) {
		xx_rpt(DELETION);
		in_rpt("deletion reason: getcontext() returned error");
		valrpt(NOERROR,rval,NOERROR,err);
		DBUG_VOID_RETURN;
	}  else
		JUMP_TRACE;     /* setcontext and getcontext both return here */

	if ( first_time == 0) { /* first return from getcontext() */
		first_time++;
		func1();
	} else {            /* second return, via setcontext() */

		JUMP_XS_RPT(4);
	}
	
	DBUG_VOID_RETURN;
}


private	void
func1()
{

	DBUG_ENTER("func1");

	JUMP_TRACE;
	func2();

	DBUG_VOID_RETURN;
}

#ifdef	TESTBED
#define	setcontext(ucp)		getcontext(ucp)
#endif

private	void
func2()
{

	DBUG_ENTER("func2");

	JUMP_TRACE;
	(void)setcontext(&context);

	xx_rpt(FAILURE);
	in_rpt("setcontext  returned unexpectedly");
	DBUG_VOID_RETURN;
}
