/*
*      SCCS:   @(#)DYNL.os/libdl/dlopen/test6.c	Rel 5.1.1 (04/07/97)
*
* (C) Copyright 1997 UniSoft Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* UNIX is a registered trademark and X/Open, the `X Device' and The Open
* Group are trademarks of The Open Group.    
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#) DYNL.os/libdl/dlopen - test6 Rel 5.1.1 (04/07/97)";
static	char	*copyright[] = {
		"(C) Copyright 1997 UniSoft Ltd.",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		test6 - used by T.dlopen.

PROJECT:	VSX5

DESCRIPTION:
	  Exec'd by T.dlopen in test6().

		test6 vg_ident vg_dbug

AUTHOR:		Tony Fisher, UniSoft Ltd.
DATE CREATED:	3 March 1997
MODIFICATIONS:

************************************************************************/
#include <std.h>
#include <stdlib.h>
#include <stdio.h>
#include <dlfcn.h>
#include <dbug.h>
#include <report.h>
#include "defines.h"
#include <tet_api.h>
#include <sysdep.h>

#ifdef UNDEF_MACROS
#undef dlopen
#endif

public  char    *vg_ident =     "<no ident>";
public  char    *vg_dbug =      (char *) NULL;
public	int *cp();

private char 	*dynlibtest6 = "../dynlibtest.6.1.so";

private	void	subtest6();

public	int
tet_main(argc, argv)
int	argc;
char	*argv[];
{

	set_pname(argv[0]);

	if (argc < 1 || argc > 3)
	{
		xx_rpt(DELETION);
		in_rpt("argument count wrong");
		exit(EXIT_NOK);
	}

	if (argc >= 3)
		vg_dbug = argv[2];
	if (argc >= 2)
		vg_ident = argv[1];

	if (vg_dbug != NULL)
	{
		DBUG_PROCESS(vg_ident);
		DBUG_PUSH(vg_dbug+2);
	}

	subtest6();

	exit(EXIT_OK);
	/*NOTREACHED*/
}

private void
subtest6()
{
	void	*handle;
	int 	testfail = 0;
	int 	pathok = 0;
	int	*val;

	DBUG_ENTER("subtest6");
	
	/*
	 * dlopen() the shared object with a DT_NEEDED entry,
	 * and check that it succeeds.
	 */
	if((handle = dlopen(dynlibtest6, RTLD_NOW)) == NULL)
	{
		testfail++;
		xx_rpt(FAILURE);
		in_rpt("dlopen() failed to locate shared object.");
		in_rpt("%s", dlerror());
	}
	else
		PATH_TRACE;

	/*
	 * check symbol is available
	 */

	if((val = dlsym(handle, "test6")) == NULL)
	{
		testfail++;
		xx_rpt(FAILURE);
		in_rpt("dlsym() failed to locate object.");
		in_rpt("%s", dlerror());
	}
	else
		PATH_TRACE;


	(void) dlclose(handle);
	
	if(!testfail)
		PATH_XS_RPT(2);

	DBUG_VOID_RETURN;
}
