/*
*      SCCS:   @(#)DYNL.os/libdl/dlopen/test7.c	Rel 5.1.1 (04/07/97)
*
* (C) Copyright 1997 UniSoft Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* UNIX is a registered trademark and X/Open, the `X Device' and The Open
* Group are trademarks of The Open Group.    
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#) DYNL.os/libdl/dlopen - test7 Rel 5.1.1 (04/07/97)";
static	char	*copyright[] = {
		"(C) Copyright 1997 UniSoft Ltd.",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		test7 - used by T.dlopen.

PROJECT:	VSX5

DESCRIPTION:
	  Exec'd by T.dlopen in test7().

		test7 vg_ident vg_dbug

AUTHOR:		Tony Fisher, UniSoft Ltd.
DATE CREATED:	3 March 1997
MODIFICATIONS:

************************************************************************/
#include <std.h>
#include <stdlib.h>
#include <stdio.h>
#include <dlfcn.h>
#include <dbug.h>
#include <report.h>
#include "defines.h"
#include <tet_api.h>
#include <sysdep.h>

#ifdef UNDEF_MACROS
#undef dlopen
#endif

public  char    *vg_ident =     "<no ident>";
public  char    *vg_dbug =      (char *) NULL;

private char 	*dynlibtest71 = "../dynlibtest.7.1.so";
private char 	*dynlibtest73 = "../dynlibtest.7.3.so";

private	void	subtest7();

public	int
tet_main(argc, argv)
int	argc;
char	*argv[];
{

	set_pname(argv[0]);

	if (argc < 1 || argc > 3)
	{
		xx_rpt(DELETION);
		in_rpt("argument count wrong");
		exit(EXIT_NOK);
	}

	if (argc >= 3)
		vg_dbug = argv[2];
	if (argc >= 2)
		vg_ident = argv[1];

	if (vg_dbug != NULL)
	{
		DBUG_PROCESS(vg_ident);
		DBUG_PUSH(vg_dbug+2);
	}

	subtest7();

	exit(EXIT_OK);
	/*NOTREACHED*/
}

private void
subtest7()
{
	void	*handle1, *handle2;
	int 	testfail = 0;
	int 	pathok = 0;
	int	*val1, *val2;
	int	ret_test_val = 0;
	
	DBUG_ENTER("subtest7");
	/*
	 * dlopen() the dependancy shared object
	 * and check that it succeeds.
	 */
	if((handle1 = dlopen(dynlibtest73, RTLD_NOW|RTLD_GLOBAL)) == NULL)
	{
		testfail++;
		xx_rpt(FAILURE);
		in_rpt("dlopen(%s, RTLD_NOW) failed.", dynlibtest73) ;
		in_rpt("%s", dlerror());
	}
	else
		PATH_TRACE;

	/*
	 * get the test symbol via handle 1 and increment
	 */
	if((val1 = (int*)dlsym(handle1, TEST7_SYM)) == NULL)
	{
		testfail++;
		xx_rpt(DELETION);
		in_rpt("dlsym(handle1, \"%s\") failed to get symbol", TEST7_SYM);
		DBUG_VOID_RETURN;
	}
	else
	{
		/* got the object pointer, now modify */
		*val1 = *val1 + 1;
		PATH_TRACE;
	}

	/* now load an object dependant on the loaded object */
	if((handle2 = dlopen(dynlibtest71, RTLD_NOW)) == NULL)
	{
		testfail++;
		xx_rpt(FAILURE);
		in_rpt("dlopen(%s, RTLD_NOW) failed.", dynlibtest71);
		in_rpt("%s", dlerror());
	}
	else
		PATH_TRACE;

	/* get the symbol via handle 2 */
	if((val2 = dlsym(handle2, TEST7_SYM)) == NULL)
	{
		testfail++;
		xx_rpt(DELETION);
		in_rpt("dlsym(handle2, \"%s\") failed to get symbol", TEST7_SYM);
		DBUG_VOID_RETURN;
	}
	else
	{
		PATH_TRACE;
	}

	/* verify correct value for TEST7_SYM */
	if(*val2 != *val1)
	{
		testfail++;
		xx_rpt(FAILURE);
		in_rpt("Test value returned from function indicates");
		in_rpt("dlopen did not ignore dependancy entry.");
		in_rpt("Returned test value is %d, expected %d.", *val2,
		       *val1);
	}
	else
		PATH_TRACE;
	

	if(!testfail)
		PATH_XS_RPT(5);

	DBUG_VOID_RETURN;
}
