/*
*      SCCS:   @(#)DYNL.os/libdl/dlopen/test9.c	Rel 5.1.1 (04/07/97)
*
* (C) Copyright 1997 UniSoft Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* UNIX is a registered trademark and X/Open, the `X Device' and The Open
* Group are trademarks of The Open Group.    
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#) DYNL.os/libdl/dlopen - test9 Rel 5.1.1 (04/07/97)";
static	char	*copyright[] = {
		"(C) Copyright 1997 UniSoft Ltd.",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		test9 - used by T.dlopen.

PROJECT:	VSX5

DESCRIPTION:
	  Exec'd by T.dlopen in test9() and test10().

		test9/10 <test no> vg_ident vg_dbug

AUTHOR:		Tony Fisher, UniSoft Ltd.
DATE CREATED:	3 March 1997
MODIFICATIONS:

************************************************************************/
#include <std.h>
#include <stdlib.h>
#include <stdio.h>
#include <string.h>
#include <sys/types.h>
#include <sys/stat.h>	
#include <fcntl.h>
#include <dlfcn.h>
#include <dbug.h>
#include <report.h>
#include <errno.h>
#include "defines.h"
#include <tet_api.h>
#include <sysdep.h>

#ifdef UNDEF_MACROS
#undef dlopen
#endif

public  char    *vg_ident =     "<no ident>";
public  char    *vg_dbug =      (char *) NULL;

private	void	subtest9();

private	char	*libtest9 = "../dynlibtest.9.so";
private char	*libtest10 = "../dynlibtest.10.so";
private	int	testnum;

public	int
tet_main(argc, argv)
int	argc;
char	*argv[];
{
	set_pname(argv[0]);

	if (argc < 1 || argc > 4)
	{
		xx_rpt(DELETION);
		in_rpt("argument count wrong");
		exit(EXIT_NOK);
	}

	if (argc >= 4)
		vg_dbug = argv[3];
	if (argc >= 3)
		vg_ident = argv[2];

	if (vg_dbug != NULL)
	{
		DBUG_PROCESS(vg_ident);
		DBUG_PUSH(vg_dbug+2);
	}

	testnum = atoi(argv[1]);

	subtest9();

	exit(EXIT_NOK);
	/*NOTREACHED*/
}

private void
subtest9()
{
	void *handle;
	int *integer;
	int pathok = 0;
	int bind_flag;
	
	DBUG_ENTER("subtest9");

	if(testnum == 9)
		bind_flag = RTLD_LAZY;
	if(testnum == 10)
		bind_flag = RTLD_NOW;

	/* open the dynamic object */
	handle = dlopen(libtest9, bind_flag);
	
	/* check results, dlopen should succeed */
	if(handle == NULL)
	{
		xx_rpt(FAILURE);
		if(testnum == 9)
			in_rpt("dlopen(\"%s\", RTLD_LAZY) failed:", libtest9);
		else
			in_rpt("dlopen(\"%s\", RTLD_NOW) failed:", libtest9);
		in_rpt("%s", dlerror());
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	/* check can get symbol */
	if((integer = (int*)dlsym(handle, TEST9_SYM)) == NULL)
	{
		xx_rpt(FAILURE);
		in_rpt("dlsym(handle, \"%s\") failed:", TEST9_SYM);
		in_rpt("%s", dlerror());
		dlclose(handle);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;


	/* check its value is corrct */
	if(*integer != TEST9_VAL)
	{
		xx_rpt(FAILURE);
		in_rpt("value of test variable was not as expected. Got %d when expecting %d", *integer, TEST9_VAL);
		dlclose(handle);
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	dlclose(handle);

#if DYNL_NODEFS_SUPPORTED
	
	/* check that for RTLD_NOW (test10) opening */
	/* dynlibtest.10.so, which has unresolved refs fails */
	/* depends on allowing undefined's in dynamic object */

	if(testnum == 10)
	{
		/* open the dynamic object */
		handle = dlopen(libtest10, bind_flag);
		
		/* check results, dlopen should fail */
		if(handle != NULL)
		{
			xx_rpt(FAILURE);
			in_rpt("dlopen(\"%s\", RTLD_NOW) succeeded when expecteed to fail.", libtest10);
			DBUG_VOID_RETURN;
		}
		else
			PATH_TRACE;

		PATH_XS_RPT(4);
	
		DBUG_EXIT(EXIT_OK);
	}
	else
	{
		PATH_XS_RPT(3);

		DBUG_EXIT(EXIT_OK);
	}

#else	

	PATH_XS_RPT(3);
	
	DBUG_EXIT(EXIT_OK);

#endif
	
}
