/*
*      SCCS:  @(#)  XOPEN.os/procenv/nice_test4/nice_test4.c	Rel 4.4.1     (06/09/97) 
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)XOPEN.os/procenv/nice_test4 - nice_test4 Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN	*/
#endif  /* lint	*/

/***********************************************************************

NAME:		nice_test4 - used by T.nice in test4()

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
		tet_main()

SYNOPSIS:
		int main(argc, argv)
			int argc;
			char **argv;

DESCRIPTION:
	  Exec'd by T.nice to test the inheritence of nice value accross exec(). 

	  usage:
		nice_test4 niceval vg_ident 

	  where niceval is the nice value of the parent process.
METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Manucher Ghezel_Ayagh, UniSoft Ltd.
DATE CREATED:	Mon Sep 15 14:43:18 BST 1986
MODIFICATIONS:	D McCardle Tue Jun 23 09:18:07 WET 1987
			Removed testid().
			Modified xx_rpt(), xs_rpt().

			J.A.Nave	11/05/90
			Added resilience testing

		Stuart Boutell, 6 Nov 1990
			Eliminated vg_file
		
		Geoff Clare, 10 March 1993
			Added #include <unistd.h>

************************************************************************/
#include	<std.h>
#include	<dbug.h>
#include	<stdlib.h>
#include	<sys/types.h>
#include	<unistd.h>
#include	<exitcodes.h>
#include	<report.h>
#include	<errno.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef nice
#endif


public	char	*vg_ident =	"<no ident>";

extern	char	*errname();
extern	void	set_pname();

public	int
tet_main(argc, argv)

	int	argc;
	char	**argv;
{
	int	rval1, rval2, err;
	int	pathok = 0;

	pathok = atoi(argv[2]);

	set_pname(argc < 1 || argv[0] == (char *) NULL ?
		"nice_test4" : (argv[0]));
	if (argc == 4)
	{
		if (argv[3] != (char *) NULL)
			vg_ident = argv[3];
		argc--;
	}
	if (argc != 3)
	{
		vsxerror("argument count wrong");
		exit(A_MISC);
	}
	else
		PATH_TRACE;

	errno = NOERROR;
	if ((rval1 = nice(0)) != (rval2 = atoi(argv[1])))
	{
		err = errno;
		xx_rpt(FAILURE);
		in_rpt("nice returns %d in main process and %d in exec'ed process",
				rval1, rval2);
		in_rpt("errno value = %d (%s)", err, errname(err));
	}
	else
	{
		PATH_TRACE;
		PATH_XS_RPT(3);
	}

	exit(OK);

	/*NOTREACHED*/
	return 0;
}
