/*
* Copyright (c) 1997 X/Open Company Ltd., trading as The Open Group
*
* All rights reserved. No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif, OSF/1 and UNIX are registered trademarks and X/Open,
* the "X Device" and The Open Group are trademarks of The Open Group.
*
*
* Project: LSB-OS
*
* File: tset/LSB.os/procenv/nice_X/nice_X.c
*
* Modifications:
* $Log: nice_X.c,v $
* Revision 1.2  2001/10/02 13:25:13  ajosey
* clean up header block comments
*
* Revision 1.1  2001/05/27 06:59:18  cyeoh
* Adds files for lsb-os test suite
*
*
*/

#include	<vsrt/vsrt.h>
#include	<sched.h>

#define 	NO_TESTS	1	/* number of tests in testset */

#ifdef UNDEF_MACROS
#undef nice
#endif

#define		WAITTIME	(5 * SPEEDFACTOR)

extern	char	*errname();
extern	char	*execpath();
extern	int	cppair();

int	no_tests = NO_TESTS;

private void	test1();
private void	ch_t1();

extern	char	**environ;

public	void	(*setfunc) () = NULL;
public	void	(*clnfunc) () = NULL;

public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	NULL, 0
};

/*
A call to nice() shall have no effect on  the  priority
of  processes  or  threads  with  policy  SCHED_FIFO or SCHED_RR.
*/

private void test1()
{
	DBUG_ENTER("test1");

	(void) cppair(ch_t1, NULLFN, 4 * WAITTIME, 0);

	DBUG_VOID_RETURN 
} 

private void ch_t1()
{
	int	err;
	char	*args[5];

	DBUG_ENTER("ch_t1");

	args[0] = "nice_X1";
	args[1] = NULL;
	(void) tet_exec(execpath("nice_X1"), args, environ);

	err = errno;
	in_rpt("tet_exec(%s, ...) failed - errno %d (%s)", "nice_X1", err, errname(err));
	xx_rpt(FAILURE);

	DBUG_VOID_RETURN 

}
