/*
*      SCCS:  @(#)  XOPEN.os/procenv/putenv/putenv.c	Rel 4.4.1	    (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)XOPEN.os/procenv/putenv - T.putenv Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		T.putenv

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Testset for the putenv() system call.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Alex Flynn, UniSoft Ltd.
DATE CREATED:	Fri Oct 31 13:59:24 GMT 1986
MODIFICATIONS:	J.A.Nave	11/05/90
		Added resilience testing

************************************************************************/
#include	<std.h>
#include	<dbug.h>
#include	<exitcodes.h>
#include	<stdlib.h>
#include	<report.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef putenv
#endif


#define 	NO_TESTS	2	/* number of tests in testset */
#define		EXTERR		"external error"
#define		WAITTIME	(5 * SPEEDFACTOR)
#define		NMR_ENV_VARS	4	/* number of environment variables for
								tet_exec */
#define		NMR_ARG_VARS	5

extern	int	cppair();

extern	char	*vg_ident;
extern	char	*vg_dbug;

int	no_tests = NO_TESTS;

private	char	*env[NMR_ENV_VARS];
private	char	*args[NMR_ARG_VARS];

private void	test1();
private	void	test2();
private void	ch_t1();
private	void	ch_t2();

public	void	(*setfunc) () = NULL;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	 test2, 2,
	NULL, 0
};

private void
test1()
{
	DBUG_ENTER("test1");

	/* set up environment for tet_exec call */

	env[0] = "ENV0=VALUE0";
	env[1] = "ENV1=VALUE1";
	env[2] = "ENV2=VALUE2";
	env[3] = (char *) NULL;
	args[0] = "putenv1";
	args[1] = "1";
	args[2] = vg_ident;
	args[3] = vg_dbug;
	args[4] = (char *) NULL;

	(void) cppair(ch_t1, NULLFN, WAITTIME, 0);

	DBUG_VOID_RETURN;
}

private void
ch_t1()
{
	int	pathok = 0;

	DBUG_ENTER("ch_t1");

	PATH_TRACE;	/*	to prove that we have been called	*/

	(void) tet_exec("../putenv1", args, env);

	exit(A_EXECFAIL);

	DBUG_VOID_RETURN;
}

private void
test2()
{
	DBUG_ENTER("test2");

	/* set up environment for tet_exec call */

	env[0] = "ENV0=VALUE0";
	env[1] = "ENV1=VALUE1";
	env[2] = "ENV2=VALUE2";
	env[3] = (char *) NULL;
	args[0] = "putenv1";
	args[1] = "2";
	args[2] = vg_ident;
	args[3] = vg_dbug;
	args[4] = (char *) NULL;

	(void) cppair(ch_t2, NULLFN, WAITTIME, 0);

	DBUG_VOID_RETURN;
}

private void
ch_t2()
{
	int	pathok = 0;

	DBUG_ENTER("ch_t2");
	
	PATH_TRACE;	/*	to prove that we have been called	*/

	(void) tet_exec("../putenv1", args, env);

	exit(A_EXECFAIL);

	DBUG_VOID_RETURN;
}
