/* dv @(#)V9TS/tset/GABI.os/procprim/exec_A/exec_tg2_A.c	1.2 95/12/11 */
/*
*	SCCS:  @(#) GABI.os/procprim/exec_A/exec_tg2_A.c	Ver. 1.7	Rel. 1.3	(92/08/01)
*
*
* (C) Copyright 1990,1991 UniSoft Group Ltd.
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#) GABI.os/procprim/exec_A/exec_tg2_A.c	Ver. 1.7	Rel. 1.3	(92/08/01)";
static	char	*copyright[] = {
		"(C) Copyright 1990,1991 UniSoft Group Ltd.",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		exec_tg2_A.c

PROJECT:	gABI	

MODULE CONTAINS:
SYNOPSIS:
DESCRIPTION:
	Used by T.exec_A in test1 of exec() with gABI extensions.
METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Miha Wang, UniSoft Corp.
DATE CREATED:	10/23/90	
MODIFICATIONS:
		John-Paul, 7 April 1993
			Added in pipe reporting code.

************************************************************************/
#include	<std.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<errno.h>
#include	<unistd.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<report.h>
#include	<dbug.h>
#include	<exec.h>
#include	<tet_api.h>
#include	<sysdep.h>

extern  char	*errname();
extern  int	strcmp();

extern	void	pipe_in_rpt();
extern	void	pipe_end_rpt();

private char    *p_argv[MAXARG];
private char	*exec_tgen;
private char	*exec_tsh;

private char	rptbuf[256];

main(argc, argv)
int	argc;
char	*argv[];
{
	int	i;
	int	pathok = 0;

	DBUG_ENTER("exec_tg2");

	exec_tgen = EXEC_TGEN2;
	exec_tsh = EXEC_TSH2;

	if(argc < 2) {
		vsxerror("internal error - argc is %d - should be at least %d", argc, 2);
		pipe_end_rpt();
		DBUG_EXIT(NOK);
	}
	else 
		PATH_TRACE;

	p_argv[0] = exec_tsh;
 	p_argv[1] = P_ARG1;
        p_argv[2] = P_ARG2;
        p_argv[3] = P_ARG3;
        p_argv[4] = P_ARG4;
        p_argv[5] = P_ARG5;
        p_argv[6] = P_ARG6;
        p_argv[7] = P_ARG7;
        p_argv[8] = P_ARG8;
        p_argv[9] = P_ARG9;
        p_argv[10] = P_ARG10;
        p_argv[11] = P_ARG11;
        p_argv[12] = P_ARG12;
        p_argv[13] = P_ARG13;
        p_argv[14] = P_ARG14;
        p_argv[15] = P_ARG15;
        p_argv[16] = (char *)NULL;

	/*
	** Pathname specified in exec_tsh_A should be passed as arg0 
	*/
	if (argv[0] == NULL)
		argv[0] = "NULL";

	if (strcmp(argv[0], exec_tgen) != 0) 
	{
		pipe_in_rpt("arg0 is passed incorrectly by exec");	
		(void)sprintf(rptbuf,"expected value %s, observed value %s\n", exec_tgen, argv[0]);	
		pipe_in_rpt(rptbuf);
	}
	else
		PATH_TRACE;

	
	/*
	** The arguments from exec() call should be passed
	** as subsequent arguments, e.g.:
	** arg0 in exec(path, arg0, ..., argn) should be passe as argv[1] 
	**  	...
	** argn in exec(path, arg0, ..., argn) should be passe as argv[n+1]
	*/

	for (i = 1; i < MAXARG-1; i++)
	{

		if (argv[i] == NULL)
			continue;

		if (p_argv[i-1] == NULL)
			continue;

		if (strcmp(argv[i], p_argv[i-1]) != 0) 
		{
			(void)sprintf(rptbuf,"arg number %d is passed incorrectly by exec", i);	
			pipe_in_rpt(rptbuf);
			(void)sprintf(rptbuf,"expected value %s, observed value %s", p_argv[i-2], argv[i]);	
			pipe_in_rpt(rptbuf);
			pipe_end_rpt();
			DBUG_EXIT(NOK);
		}
		else
			PATH_TRACE;
	}

	if (pathok != (2+(MAXARG-3)))
	{
		pipe_end_rpt();
		DBUG_EXIT(PATH_NOK);
	}

	pipe_end_rpt();
	DBUG_EXIT(OK);
	
	/* NOT REACHED */
	return(0);

}
