/* dv @(#)V9TS/tset/GABI.os/procprim/exec_A/exec_tg_A.c	1.2 95/12/11 */
/*
*	SCCS:  @(#) GABI.os/procprim/exec_A/exec_tg_A.c	Ver. 1.6	Rel. 1.3	(92/08/01)
*
*
* (C) Copyright 1990,1991 UniSoft Group Ltd.
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#) GABI.os/procprim/exec_A/exec_tg_A.c	Ver. 1.6	Rel. 1.3	(92/08/01)";
static	char	*copyright[] = {
		"(C) Copyright 1990,1991 UniSoft Group Ltd.",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		exec_tg_A.c

PROJECT:	gABI	

MODULE CONTAINS:
SYNOPSIS:
DESCRIPTION:
	Used by T.exec_A in test2 of exec() with gABI extensions.
METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Miha Wang, UniSoft Corp.
DATE CREATED:	10/23/90	
MODIFICATIONS:

************************************************************************/
#include	<std.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<errno.h>
#include	<unistd.h>
#include	<signal.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<sys/resource.h>
#include	<sys/times.h>
#include	<report.h>
#if 0
#include	<gabi_sig.h>
#endif
#include	<dbug.h>
#include	<exec.h>
#include	<sysdep.h>


/* there are 7 resource limits defined in the XPG */
#define XPG_RLIM_NLIMITS	7

extern	int	strcmp();
extern	int	getrlimit();

extern	int	errno;
extern  char	*errname();

private char	*exec_tgen;
private struct	rlimit	rlim_name[RLIM_NLIMITS];

private void	verify_rlim();	

extern	void	pipe_in_rpt();
extern	void	pipe_end_rpt();

private	char 	rptbuf[256];

main(argc, argv)
int	argc;
char	*argv[];
{
	int	i, rindex;
	int	pathok = 0;

	DBUG_ENTER("exec_tg");

	exec_tgen = EXEC_TGEN;

	if (argc != (XPG_RLIM_NLIMITS * 2) + 2) {
		vsxerror("internal error - argc is %d - should be %d",
			argc, (XPG_RLIM_NLIMITS * 2) + 2);
		pipe_end_rpt();
		DBUG_EXIT(NOK);
	}
	else 
		PATH_TRACE;

	/*
	** Pathname specified in exec_tsh_A should be passed as arg0 
	*/
	if (argv[0] == NULL)
		argv[0] = "NULL";

	if (strcmp(argv[0], exec_tgen) != 0) 
	{
		pipe_in_rpt("arg0 is passed incorrectly by exec");	
		(void)sprintf(rptbuf,"expected value %s, observed value %s\n", exec_tgen, argv[0]);	
		pipe_in_rpt(rptbuf);	
	}
	else
		PATH_TRACE;

	/*
	** The arguments from exec() call should be passed
	** as subsequent arguments, e.g.:
	** arg0 in exec(path, arg0, ..., argn) should be passe as argv[2] 
	**  	...
	** argn in exec(path, arg0, ..., argn) should be passe as argv[n+2]
	*/
	if (argv[15] == NULL)
		argv[15] = "NULL";

	if (strcmp(argv[15], P_ARG15) != 0)
	{
		pipe_in_rpt("arg15 is passed incorrectly by exec");	
		(void)sprintf(rptbuf,"expected value %s, observed value %s\n", P_ARG15, argv[15]);	
		pipe_in_rpt(rptbuf);	
		pipe_end_rpt();
		DBUG_EXIT(NOK);
	}
	else
		PATH_TRACE;

	/*
	** argv3 - argv16 are the resource values passed
	** from parent
	*/ 

#if 0
	for (i = 1, rindex = 0; rindex < RLIM_NLIMITS; i++, rindex++)
	{
		if (argv[i] == NULL)
			argv[i] = "NULL";
		rlim_name[rindex].rlim_cur = atoi(argv[i++]);
		if (argv[i] == NULL)
			argv[i] = "NULL";
		rlim_name[rindex].rlim_max = atoi(argv[i]);
	}
#else
	rlim_name[RLIMIT_CPU].rlim_cur = atoi(argv[1]);
	rlim_name[RLIMIT_CPU].rlim_max = atoi(argv[2]);
	rlim_name[RLIMIT_FSIZE].rlim_cur = atoi(argv[3]);
	rlim_name[RLIMIT_FSIZE].rlim_max = atoi(argv[4]);
	rlim_name[RLIMIT_DATA].rlim_cur = atoi(argv[5]);
	rlim_name[RLIMIT_DATA].rlim_max = atoi(argv[6]);
	rlim_name[RLIMIT_STACK].rlim_cur = atoi(argv[7]);
	rlim_name[RLIMIT_STACK].rlim_max = atoi(argv[8]);
	rlim_name[RLIMIT_CORE].rlim_cur = atoi(argv[9]);
	rlim_name[RLIMIT_CORE].rlim_max = atoi(argv[10]);
	rlim_name[RLIMIT_NOFILE].rlim_cur = atoi(argv[11]);
	rlim_name[RLIMIT_NOFILE].rlim_max = atoi(argv[12]);
	rlim_name[RLIMIT_AS].rlim_cur = atoi(argv[13]);
	rlim_name[RLIMIT_AS].rlim_max = atoi(argv[14]);
#endif

	/*
	** verify that the resource limits  are inherited from parent 
	*/
	globok = 0;
	verify_rlim();	
	PATH_FUNC_TRACE;

	if (pathok != 4)
	{
		pipe_end_rpt();
		DBUG_EXIT(PATH_NOK);
	}

	pipe_end_rpt();
	DBUG_EXIT(OK);
	
	/* NOT REACHED */
	return (0);
}

private void
verify_rlim()	
{
	int	i, err;
	char	*rlimstr;	
	struct	rlimit	pa_rlim, ch_rlim; 
	int	pathok = 0;

	DBUG_ENTER("verify_rlim");

	for ( i  = 0; i < RLIM_NLIMITS; i++)   
	{
		switch(i)
		{
		case RLIMIT_CPU:
			
			rlimstr = "RLIMIT_CPU";
			pa_rlim.rlim_cur = rlim_name[RLIMIT_CPU].rlim_cur; 
			pa_rlim.rlim_max = rlim_name[RLIMIT_CPU].rlim_max; 
#ifdef	TESTBED1
			pa_rlim.rlim_cur++; 
			pa_rlim.rlim_max++; 
#endif
			err = errno;
			if (getrlimit(RLIMIT_CPU, &ch_rlim) == SYSERROR)
			{
				err = errno;
				pipe_xx_rpt(DELETION);
				(void)sprintf(rptbuf,"getrlimit(%s) failed - errno %d (%s)", rlimstr, err, errname(err));
				pipe_in_rpt(rptbuf);	
				break;
			}	
			else
				PATH_TRACE;

			if ((pa_rlim.rlim_cur != ch_rlim.rlim_cur) ||
				(pa_rlim.rlim_max != ch_rlim.rlim_max))
			{
				(void)sprintf(rptbuf,"%s is not inherited correctly", rlimstr);
				pipe_in_rpt(rptbuf);	
				(void)sprintf(rptbuf,"expected hard value %ld; observed value %ld", pa_rlim.rlim_max, ch_rlim.rlim_max);
				pipe_in_rpt(rptbuf);	
				(void)sprintf(rptbuf,"expected soft value %ld; observed value %ld", pa_rlim.rlim_cur, ch_rlim.rlim_cur);
				pipe_in_rpt(rptbuf);	
			
			}
			else
				PATH_TRACE;

			break;

		case RLIMIT_FSIZE:

			rlimstr = "RLIMIT_FSIZE";
			pa_rlim.rlim_cur = rlim_name[RLIMIT_FSIZE].rlim_cur; 
			pa_rlim.rlim_max = rlim_name[RLIMIT_FSIZE].rlim_max; 
			
#ifdef	TESTBED1
			pa_rlim.rlim_cur++; 
			pa_rlim.rlim_max++; 
#endif
			err = errno;
			if (getrlimit(RLIMIT_FSIZE, &ch_rlim) == SYSERROR)
			{
				err = errno;
				pipe_xx_rpt(DELETION);
				(void)sprintf(rptbuf,"getrlimit(%s) failed - errno %d (%s)", rlimstr, err, errname(err));
				pipe_in_rpt(rptbuf);	
				break;
			}	
			else
				PATH_TRACE;

			if ((pa_rlim.rlim_cur != ch_rlim.rlim_cur) ||
				(pa_rlim.rlim_max != ch_rlim.rlim_max))
			{
				(void)sprintf(rptbuf,"%s is not inherited correctly", rlimstr);
				pipe_in_rpt(rptbuf);	
				(void)sprintf(rptbuf,"expected hard value %ld; observed value %ld", pa_rlim.rlim_max, ch_rlim.rlim_max);
				pipe_in_rpt(rptbuf);	
				(void)sprintf(rptbuf,"expected soft value %ld; observed value %ld", pa_rlim.rlim_cur, ch_rlim.rlim_cur);
				pipe_in_rpt(rptbuf);	
			
			}
			else
				PATH_TRACE;
			
			break;

		case RLIMIT_DATA:

			rlimstr = "RLIMIT_DATA";
			pa_rlim.rlim_cur = rlim_name[RLIMIT_DATA].rlim_cur; 
			pa_rlim.rlim_max = rlim_name[RLIMIT_DATA].rlim_max; 
			
#ifdef	TESTBED1
			pa_rlim.rlim_cur++; 
			pa_rlim.rlim_max++; 
#endif
			err = errno;
			if (getrlimit(RLIMIT_DATA, &ch_rlim) == SYSERROR)
			{
				err = errno;
				pipe_xx_rpt(DELETION);
				(void)sprintf(rptbuf,"getrlimit(%s) failed - errno %d (%s)", rlimstr, err, errname(err));
				pipe_in_rpt(rptbuf);	
				break;
			}	
			else
				PATH_TRACE;

			if ((pa_rlim.rlim_cur != ch_rlim.rlim_cur) ||
				(pa_rlim.rlim_max != ch_rlim.rlim_max))
			{
				(void)sprintf(rptbuf,"%s is not inherited correctly", rlimstr);
				pipe_in_rpt(rptbuf);	
				(void)sprintf(rptbuf,"expected hard value %ld; observed value %ld", pa_rlim.rlim_max, ch_rlim.rlim_max);
				pipe_in_rpt(rptbuf);	
				(void)sprintf(rptbuf,"expected soft value %ld; observed value %ld", pa_rlim.rlim_cur, ch_rlim.rlim_cur);
				pipe_in_rpt(rptbuf);	
			
			}
			else
				PATH_TRACE;
			
			break;

		case RLIMIT_STACK:

			rlimstr = "RLIMIT_STACK";
			pa_rlim.rlim_cur = rlim_name[RLIMIT_STACK].rlim_cur; 
			pa_rlim.rlim_max = rlim_name[RLIMIT_STACK].rlim_max; 
			
#ifdef	TESTBED1
			pa_rlim.rlim_cur++; 
			pa_rlim.rlim_max++; 
#endif
			err = errno;
			if (getrlimit(RLIMIT_STACK, &ch_rlim) == SYSERROR)
			{
				err = errno;
				pipe_xx_rpt(DELETION);
				(void)sprintf(rptbuf,"getrlimit(%s) failed - errno %d (%s)", rlimstr, err, errname(err));
				pipe_in_rpt(rptbuf);	
				break;
			}	
			else
				PATH_TRACE;

			if ((pa_rlim.rlim_cur != ch_rlim.rlim_cur) ||
				(pa_rlim.rlim_max != ch_rlim.rlim_max))
			{
				(void)sprintf(rptbuf,"%s is not inherited correctly", rlimstr);
				pipe_in_rpt(rptbuf);	
				(void)sprintf(rptbuf,"expected hard value %ld; observed value %ld", pa_rlim.rlim_max, ch_rlim.rlim_max);
				pipe_in_rpt(rptbuf);	
				(void)sprintf(rptbuf,"expected soft value %ld; observed value %ld", pa_rlim.rlim_cur, ch_rlim.rlim_cur);
				pipe_in_rpt(rptbuf);	
			
			}
			else
				PATH_TRACE;
			
			break;

		case RLIMIT_CORE:

			rlimstr = "RLIMIT_CORE";
			pa_rlim.rlim_cur = rlim_name[RLIMIT_CORE].rlim_cur; 
			pa_rlim.rlim_max = rlim_name[RLIMIT_CORE].rlim_max; 
			
#ifdef	TESTBED1
			pa_rlim.rlim_cur++; 
			pa_rlim.rlim_max++; 
#endif
			err = errno;
			if (getrlimit(RLIMIT_CORE, &ch_rlim) == SYSERROR)
			{
				err = errno;
				pipe_xx_rpt(DELETION);
				(void)sprintf(rptbuf,"getrlimit(%s) failed - errno %d (%s)", rlimstr, err, errname(err));
				pipe_in_rpt(rptbuf);	
				break;
			}	
			else
				PATH_TRACE;

			if ((pa_rlim.rlim_cur != ch_rlim.rlim_cur) ||
				(pa_rlim.rlim_max != ch_rlim.rlim_max))
			{
				(void)sprintf(rptbuf,"%s is not inherited correctly", rlimstr);
				pipe_in_rpt(rptbuf);	
				(void)sprintf(rptbuf,"expected hard value %ld; observed value %ld", pa_rlim.rlim_max, ch_rlim.rlim_max);
				pipe_in_rpt(rptbuf);	
				(void)sprintf(rptbuf,"expected soft value %ld; observed value %ld", pa_rlim.rlim_cur, ch_rlim.rlim_cur);
				pipe_in_rpt(rptbuf);	
			
			}
			else
				PATH_TRACE;
			
			break;

		case RLIMIT_NOFILE:

			rlimstr = "RLIMIT_NOFILE";
			pa_rlim.rlim_cur = rlim_name[RLIMIT_NOFILE].rlim_cur; 
			pa_rlim.rlim_max = rlim_name[RLIMIT_NOFILE].rlim_max; 
			
#ifdef	TESTBED1
			pa_rlim.rlim_cur++; 
			pa_rlim.rlim_max++; 
#endif
			err = errno;
			if (getrlimit(RLIMIT_NOFILE, &ch_rlim) == SYSERROR)
			{
				err = errno;
				pipe_xx_rpt(DELETION);
				(void)sprintf(rptbuf,"getrlimit(%s) failed - errno %d (%s)", rlimstr, err, errname(err));
				pipe_in_rpt(rptbuf);	
				break;
			}	
			else
				PATH_TRACE;

			if ((pa_rlim.rlim_cur != ch_rlim.rlim_cur) ||
				(pa_rlim.rlim_max != ch_rlim.rlim_max))
			{
				(void)sprintf(rptbuf,"%s is not inherited correctly", rlimstr);
				pipe_in_rpt(rptbuf);	
				(void)sprintf(rptbuf,"expected hard value %ld; observed value %ld", pa_rlim.rlim_max, ch_rlim.rlim_max);
				pipe_in_rpt(rptbuf);	
				(void)sprintf(rptbuf,"expected soft value %ld; observed value %ld", pa_rlim.rlim_cur, ch_rlim.rlim_cur);
				pipe_in_rpt(rptbuf);	
			
			}
			else
				PATH_TRACE;
			
			break;

#if 0
		case RLIMIT_VMEM:

			rlimstr = "RLIMIT_VMEM";
			pa_rlim.rlim_cur = rlim_name[RLIMIT_VMEM].rlim_cur; 
			pa_rlim.rlim_max = rlim_name[RLIMIT_VMEM].rlim_max; 
			
#ifdef	TESTBED1
			pa_rlim.rlim_cur++; 
			pa_rlim.rlim_max++; 
#endif
			err = errno;
			if (getrlimit(RLIMIT_VMEM, &ch_rlim) == SYSERROR)
			{
				err = errno;
				pipe_xx_rpt(DELETION);
				(void)sprintf(rptbuf,"getrlimit(%s) failed - errno %d (%s)", rlimstr, err, errname(err));
				pipe_in_rpt(rptbuf);	
				break;
			}	
			else
				PATH_TRACE;

			if ((pa_rlim.rlim_cur != ch_rlim.rlim_cur) ||
				(pa_rlim.rlim_max != ch_rlim.rlim_max))
			{
				(void)sprintf(rptbuf,"%s is not inherited correctly", rlimstr);
				pipe_in_rpt(rptbuf);	
				(void)sprintf(rptbuf,"expected hard value %ld; observed value %ld", pa_rlim.rlim_max, ch_rlim.rlim_max);
				pipe_in_rpt(rptbuf);	
				(void)sprintf(rptbuf,"expected soft value %ld; observed value %ld", pa_rlim.rlim_cur, ch_rlim.rlim_cur);
				pipe_in_rpt(rptbuf);	
			
			}
			else
				PATH_TRACE;
			
			break;
#else
		case RLIMIT_AS:

			rlimstr = "RLIMIT_AS";
			pa_rlim.rlim_cur = rlim_name[RLIMIT_AS].rlim_cur; 
			pa_rlim.rlim_max = rlim_name[RLIMIT_AS].rlim_max; 
			
#ifdef	TESTBED1
			pa_rlim.rlim_cur++; 
			pa_rlim.rlim_max++; 
#endif
			err = errno;
			if (getrlimit(RLIMIT_AS, &ch_rlim) == SYSERROR)
			{
				err = errno;
				pipe_xx_rpt(DELETION);
				(void)sprintf(rptbuf,"getrlimit(%s) failed - errno %d (%s)", rlimstr, err, errname(err));
				pipe_in_rpt(rptbuf);	
				break;
			}	
			else
				PATH_TRACE;

			if ((pa_rlim.rlim_cur != ch_rlim.rlim_cur) ||
				(pa_rlim.rlim_max != ch_rlim.rlim_max))
			{
				(void)sprintf(rptbuf,"%s is not inherited correctly", rlimstr);
				pipe_in_rpt(rptbuf);	
				(void)sprintf(rptbuf,"expected hard value %ld; observed value %ld", pa_rlim.rlim_max, ch_rlim.rlim_max);
				pipe_in_rpt(rptbuf);	
				(void)sprintf(rptbuf,"expected soft value %ld; observed value %ld", pa_rlim.rlim_cur, ch_rlim.rlim_cur);
				pipe_in_rpt(rptbuf);	
			
			}
			else
				PATH_TRACE;
			
			break;
#endif
		}
	}

	PATH_FUNC_RPT(2 * XPG_RLIM_NLIMITS);

	DBUG_VOID_RETURN;
}

