/*
 * Program used by @name testset as exec'ed program.
 */
#include <sys/types.h>
#include <signal.h>
#include <unistd.h>

static sig_atomic_t gotsig = 0;

static void
handler(int code)
{
	if (code == SIGUSR2)
		gotsig = code;
}

int
main(void)
{
	struct sigaction act;

	/* Set signal handler for SIGUSR2 */
	act.sa_handler = handler;
	act.sa_flags = 0;
	sigemptyset(&act.sa_mask);
	sigaction(SIGUSR2, &act, NULL);

	/* Send SIGUSR2 to parent to indicate we're in child process */
	kill(getppid(), SIGUSR2);

	/* Wait until parent sends us a SIGUSR2 to indicate we can complete */
	while (gotsig != SIGUSR2)
		pause();

	return 0;
}

