/*
 * (C) Copyright 2001 The Free Standards Group Inc
 *
 * 2001, Andrew Pham (sh version) 
 * 2001, Christopher Yeoh (Adapted from sh version to use C api)
 *
 *
 */

#ifndef lint
#define MAIN
#ifdef	MAIN
char	*copyright[] = {
		"(C) Copyright 2001 The Free Standards Group Inc"
};
#endif	/* MAIN */
#endif	/* lint */

/* 
 * Name: T.initgroups
 * Standard: LSB
 *
 *
 *  Assumptions:
 * 	getgroups(), malloc(), strerror() and sizeof() are availbe to use. 
 *  
 *  Strategy Statement:
 * 	Write a small c function to test initgroups(). 
 *  
 *  Expected Results:
 *     	As specified in the spec. 
 */

#include <grp.h>
#include <sys/types.h>
#include <stdlib.h>
#include <errno.h>
#include <errno.h>
#include <string.h>

#include <tet_api.h>


int no_tests = 1;

void test1();



/* TCM Data structures */
void	(*setfunc) () = NULL;
void	(*clnfunc) () = NULL;
struct tet_testlist tet_testlist[] = {
  test1, 1,
  NULL, 0
};

void test1()
{
  if(initgroups("vsx1", 666) != 0)
  {
    tet_infoline("initgroups() returned error");
    tet_printf("  error: %s", strerror(errno));
    tet_result(TET_FAIL);
    return;
  }
  else
  {
    int count, i;
    gid_t *arr1;
	
    count = getgroups(0, arr1);
    if(count < 0)
    {
      tet_infoline("getgroups() returned values less than 0");
      tet_printf("  error: %s", strerror(errno));
      tet_result(TET_UNRESOLVED);
      return;
    }

    arr1 = (gid_t *)malloc(count*sizeof(gid_t));
    count = getgroups(count, arr1);
    if ( count < 0 ) 
    {
      tet_infoline("getgroups() returned values less than 0");
      tet_printf("  error: %s", strerror(errno));
      tet_result(TET_UNRESOLVED);
      return;
    }
    else
    {
      for (i = 0; i < count; i++)
      {
	if( 666 == arr1[i] )
	{
	  tet_result(TET_PASS);
	  return;
	}
      }
				  
      tet_infoline("initgroups failed");
      tet_result(TET_FAIL);
    }
  }	 
}
