/*
 * (C) Copyright 2001 The Free Standards Group Inc
 *
 * 2001, Andrew Pham (sh version) 
 * 2001, Christopher Yeoh (Adapted from sh version to use C api)
 *
 *
 */

#ifndef lint
#define MAIN
#ifdef	MAIN
char	*copyright[] = {
		"(C) Copyright 2001 The Free Standards Group Inc"
};
#endif	/* MAIN */
#endif	/* lint */

/* 
 * Name: T.seteuid
 * Standard: LSB
 *
 *
 *  Assumptions:
 * 	getpwnam(), getuid()  are available to use
 *  
 *  Strategy Statement:
 * 	Write a small c function to test seteuid(). 
 *  
 *  Expected Results:
 *     	As specified in the spec. 
 */

#include <unistd.h>
#include <sys/types.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>

#include <grp.h>
#include <pwd.h>

#include <tet_api.h>


int no_tests = 1;

void test1();



/* TCM Data structures */
void	(*setfunc) () = NULL;
void	(*clnfunc) () = NULL;
struct tet_testlist tet_testlist[] = {
  test1, 1,
  NULL, 0
};

void test1()
{
  struct passwd* user_info; 
  int xx;
  gid_t EUIDzz, new_euid;
  int failed = 1;
  int saved_errno;

  EUIDzz = geteuid();
  new_euid = 503;
  user_info = getpwnam("vsx1");
  if (user_info) 
	new_euid = user_info->pw_uid;

  xx = seteuid(new_euid);
  saved_errno = errno;
  if ( xx == 0)
  {
    if (new_euid == geteuid()) failed = 0;
    else tet_infoline("euid could not be set.");
  }
  else
  {
    tet_infoline("seteuid returned error");
    tet_printf("  error: %s", strerror(saved_errno));
  }

  if (failed) 
    tet_result(TET_FAIL);
  else 
    tet_result(TET_PASS);
}
