/*   (C) Copyright 2001 The Free Standards Group Inc 
 *   ./tset/LSB-usersgroups/usersgroups/commands/uberpass.c 
 *   uberpass.c: C program that returns user and group values using the 
 *   pwd, grp, and shadow APIs 
 *
 *   uberpass.c 
 * 
 *   This is $Revision: 1.4 $
 *
 *   $Log: uberpass.c,v $
 *   Revision 1.4  2001/07/25 19:54:20  cyeoh
 *   Fix comments to use C commenting style
 *
 *
 *   Revision 1.0 2001/07/23   Arnold Hayden, Andy Pham 
 *
 */

#include <stdlib.h>
#include <shadow.h>
#include <grp.h>
#include <pwd.h>
#include <sys/types.h>
#include <unistd.h>


struct passwd* user_info; 
struct group* group_info;
struct spwd* shadow_info;
char **members;

main(int argc, char *argv[]){

switch (argv[1][1]){
	
 
	case 'U':
		user_info = getpwnam(argv[3]);

		if (!user_info) {
		    return (1);
		}

		switch (argv[2][1]){

			case 'c':
				printf("%s\n", user_info->pw_gecos);
				return (0);

			case 'd':
				printf("%s\n", user_info->pw_dir);
				return (0);

			case 'g':
				printf("%d\n", user_info->pw_gid);
				return (0);

			case 's':
				printf("%s\n", user_info->pw_shell);
				return (0);
			
			case 'u':
				printf("%d\n", user_info->pw_uid);
				return (0);
			case 'n':
			       group_info = getgrgid(user_info->pw_gid);
             		       printf("%s\n", group_info->gr_name);
				return (0);
			case 'x':
				printf("%s\n", user_info->pw_name);
				return (0);
			default:
				return (1);

		}
	case 'X':
	
		group_info = getgrgid(atoi(argv[2]));

		if (!group_info){
			return (1);
		}

                printf("%s\n", group_info->gr_name);
		return (0);

	case 'Z':
	
		user_info = getpwuid(atoi(argv[2]));

		if (!user_info){
			return (1);
		}

		printf("%s\n", user_info->pw_name);
		return (0);
				

	
	case 'G':
		group_info = getgrnam(argv[3]);
		
		if (!group_info){
			return (1);
		}
		
		switch(argv[2][1]){

			case 'g':
				printf("%d\n", group_info->gr_gid);
				return (0);
								
			case 'n':
				printf("%s\n", group_info->gr_name);
				return (0);
				
			case 'm':
				members=group_info->gr_mem;
				while (*members){
					printf("%s ", *(members));
					members++;
				}
				
				printf("\n");
				return (0);
				
			default:
				return (1);
				
		}

	
	case 'S':
		
		shadow_info = getspnam(argv[3]);

		if (!shadow_info) {
			return (1);
		}

		switch(argv[2][1]) {

			case 'e':
				printf("%d\n", shadow_info->sp_expire);
				return (0);

			case 'f':
				printf("%d\n", shadow_info->sp_inact);
				return (0);

			case 'p':
				printf("%s\n", shadow_info->sp_pwdp);
				return (0);
			case 'x':
				printf("%d\n", shadow_info->sp_max);
				return (0);
			case 'n':
				printf("%d\n", shadow_info->sp_min);
				return (0);
			case 'w':
				printf("%d\n", shadow_info->sp_warn);
				return (0);
			case 'i':
				printf("%d\n", shadow_info->sp_inact);
				return (0);
			default:
				return (1);
		}

				
	default:
		return (1);
	
}
}
