/*
*      SCCS:  @(#)  POSIX.os/Csupport/tzset/tzset.c	Rel 4.4.1	    (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)POSIX.os/Csupport/tzset - T.tzset Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		T.tzset

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Testset for the tzset() system call.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Geoff Clare, UniSoft Ltd.
DATE CREATED:	20 Dec 1988
		(Split out from ctime() testset)

MODIFIED:
		Geoff Clare, 13 Sep 1989
			Don't check tzname[1] when TZ has no dst zone name
		
		Geoff Clare, 9 Nov 1989
			More thorough testing of allowed zone names
		
		Geoff Clare, 23 Nov 1989
			Moved timezone and daylight tests to tzset_X

		Dave Cater, 18 Dec 1989
			Only check alphabetic characters in allowed zone names
		
		Geoff Clare, 23 Jan 1990
			Use [0, UCHAR_MAX] instead of [CHAR_MIN, CHAR_MAX]
			to avoid passing invalid values to isalpha()
		
		Geoff Clare, 2 May 1990
			Use TZNAME_MAX in long timezone name test.
			Return to testing all allowed characters in zone names

		Anthony Lee, 26 July 1990
			Added resilience code.
		
		Geoff Clare, 14 Jan 1992
			Use new tztest() routine for tzname[] testing.

************************************************************************/
#include	<std.h>
#include	<stdlib.h>
#include	<sys/types.h>
#include	<unistd.h>
#include	<time.h>
#include	<dbug.h>
#include	<report.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef tzset
#undef tzname
#endif


#define 	NO_TESTS	1		/* number of tests in testset */
#define		WAITTIME	(5 * SPEEDFACTOR)

extern	int	cppair();
extern	void	tztest();

int	no_tests = NO_TESTS;

private void	test1();
private void	ch_t1();

public	void	(*setfunc) () = NULL;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	NULL, 0
};


private	void
test1()
{
	DBUG_ENTER("test1");

	(void) cppair(ch_t1, NULLFN, WAITTIME, 0);

	DBUG_VOID_RETURN;
}

private char *
t1_func(isdst)
int isdst;
{
	tzset();

	return tzname[isdst];
}

private void
ch_t1()
{
	DBUG_ENTER("ch_t1");

	tztest("tzset()", t1_func);

	DBUG_VOID_RETURN;
}
