/*
*       SCCS:   @(#)	POSIX.os/dataform/cpio/cpiotest.h	Rel 4.4.1     (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

/***********************************************************************

NAME:		cpiotest.h - definitions for the cpio format.

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
REQUIRES PRIOR INCLUSION OF:	sys/types.h
ASSUMES:

AUTHOR:		Dave Cater, UniSoft Ltd.
DATE CREATED:	Thu May 25 10:39:23 BST 1989
MODIFICATIONS:
		Geoff Clare, 17 Nov 1989
			Don't use S_IFMT

		Geoff Clare, 18 Feb 1991
			Changes to remove assumption that cpio_head
			members are contiguous.

		Dave Cater, 24 Nov 1992
			XNFS enhancements

************************************************************************/

#define	CR_CPIO_UTIL	"/BIN/cpio_cr.sh"	
#define	XT_CPIO_UTIL	"/BIN/cpio_xt.sh"	
#define	XT_ID_CPIO_UTIL	"/BIN/cpio_i_xt.sh"	
#define	WAITTIME	(5 * SPEEDFACTOR)
#define MODEANY		(mode_t)(S_IRWXU|S_IRWXG|S_IRWXO)
#define	FORMAT_CREATE	"format creating utility"
#define	FORMAT_READ	"format reading utility"
#define	NORESTORE	0
#define	RESTORE		1
#define	CPIO_OK		0
#define	CPIO_NOK	1
#define PATH_NOK	3
#define	NOK		2
#define	KILLWAIT	(2 * SPEEDFACTOR)
#define	UMASK		(mode_t)(S_IWGRP|S_IWOTH|S_IROTH)
#define	SU_UID		0
#define	SU_MODE		06755

/* Actions on mountable file system when testing XNFS */
#define	MOUNT_GIDTRUE		0
#define	UNMOUNT_GIDTRUE		1

/* cpio file types required */
#define	C_ISDIR		0040000
#define	C_ISFIFO	0010000
#define	C_ISREG		0100000

/* cpio file modes required */
#define	C_ISUID		04000
#define	C_ISGID		02000
#define	C_ISVTX		01000
#define	C_IRUSR		00400
#define	C_IWUSR		00200
#define	C_IXUSR		00100
#define	C_IRGRP		00040
#define	C_IWGRP		00020
#define	C_IXGRP		00010
#define	C_IROTH		00004
#define	C_IWOTH		00002
#define	C_IXOTH		00001

#define	C_IRWXU		C_IRUSR|C_IWUSR|C_IXUSR
#define	C_IRWXG		C_IRGRP|C_IWGRP|C_IXGRP
#define	C_IRWXO		C_IROTH|C_IWOTH|C_IXOTH
#define C_MODEANY	(mode_t)(C_IRWXU|C_IRWXG|C_IRWXO)
#define C_MODEMASK	C_MODEANY

/* Define the equivalent for bits of the stat structure */
#define S_MODEMASK	(mode_t)(S_IRWXU|S_IRWXG|S_IRWXO)

/* Where the file type bits will be in mode */
#define	C_IFMT		0170000

/* Some miscellaneous data items */
#define	TRAILER		"TRAILER!!!"
#define	REGDATA		"Data to write to regular file"
#define	LNKDATA		"Data to write to linked files"
#define	CBLKSIZ		512

#define	CMAGIC		"070707"

#define	CMAGLEN		6
#define	CDEVLEN		6
#define	CINOLEN		6
#define	CMODELEN	6
#define	CUGIDLEN	6
#define	CNLINKLEN	6
#define	CRDEVLEN	6
#define	CMTIMELEN	11
#define	CNAMSIZLEN	6
#define	CFILSIZLEN	11
#define CHEADSIZE	(CMAGLEN   + CDEVLEN    + CINOLEN   + CMODELEN + \
			 CUGIDLEN  + CUGIDLEN   + CNLINKLEN + CRDEVLEN + \
			 CMTIMELEN + CNAMSIZLEN + CFILSIZLEN)

struct	cpio_head {
	char	*c_magic;
	char	*c_dev;
	char	*c_ino;
	char	*c_mode;
	char	*c_uid;
	char	*c_gid;
	char	*c_nlink;
	char	*c_rdev;
	char	*c_mtime;
	char	*c_namesize;
	char	*c_filesize;
};

