/*
*       SCCS:   @(#)	POSIX.os/dataform/tar/tartest.h	Rel 4.4.1     (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

/***********************************************************************

NAME:		tartest.h - definitions for extended tar format

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
REQUIRES PRIOR INCLUSION OF:	sys/types.h
				tar.h
ASSUMES:

AUTHOR:		Dave Cater, UniSoft Ltd.
DATE CREATED:	Thu May 25 10:35:48 BST 1989
MODIFICATIONS:
		Geoff Clare, 18 Feb 1991
			Changes to remove assumption that tar_head
			members are contiguous.

************************************************************************/

#define	CR_TAR_UTIL	"/BIN/tar_cr.sh"	
#define	XT_TAR_UTIL	"/BIN/tar_xt.sh"	
#define	XT_ID_TAR_UTIL	"/BIN/tar_i_xt.sh"	
#define	WAITTIME	(5 * SPEEDFACTOR)
#define MODEANY		(mode_t)(S_IRWXU|S_IRWXG|S_IRWXO)
#define	FORMAT_CREATE	"format creating utility"
#define	FORMAT_READ	"format reading utility"
#define	NORESTORE	0
#define	RESTORE		1
#define	TAR_OK		0
#define	TAR_NOK		1
#define	NOK		2
#define	KILLWAIT	(2 * SPEEDFACTOR)
#define	UMASK		(mode_t)(S_IWGRP|S_IWOTH|S_IROTH)
#define	SU_UID		0
#define	SU_MODE		06755

/* Actions on mountable file system when testing XNFS */
#define MOUNT_GIDTRUE		0
#define UNMOUNT_GIDTRUE		1

/* tar internal file modes - defined in tar.h */
#define	T_IRWXU		TUREAD|TUWRITE|TUEXEC
#define	T_IRWXG		TGREAD|TGWRITE|TGEXEC
#define	T_IRWXO		TOREAD|TOWRITE|TOEXEC
#define	T_MODEANY	(mode_t)(T_IRWXU|T_IRWXG|T_IRWXO)

/* Define the equivalent for bits of the stat structure */
#define S_MODEMASK	(mode_t)(S_IRWXU|S_IRWXG|S_IRWXO)

/* Some miscellaneous data items */
#define	REGDATA		"Data to write to regular file"
#define	LNKDATA		"Data to write to linked files"
#define TBLKSIZ		512
#define	SLASH		"/"

/* Some tar_head field lengths are already defined by IEEE in tar.h */
#define	TNAMLEN		100
#define	TMODELEN	8
#define	TUGIDLEN	8
#define	TSIZLEN		12
#define	TMTIMELEN	12
#define	TSUMLEN		8
#define	TTYPELEN	1
#define	TLNKLEN		100
#define	TUGNAMLEN	32
#define	TDEVLEN		8
#define	TPREFLEN	155
#define	TUNSPECLEN	12

struct 	tar_head {
	char	*tar_name;
	char	*tar_mode;
	char	*tar_uid;
	char	*tar_gid;
	char	*tar_size;
	char	*tar_mtime;
	char	*tar_chksum;
	char	*tar_typeflag;
	char	*tar_linkname;
	char	*tar_magic;
	char	*tar_version;
	char	*tar_uname;
	char	*tar_gname;
	char	*tar_devmajor;
	char	*tar_devminor;
	char	*tar_prefix;
	char	*tar_unspec;
};

struct tar_trail {
	char	tar_zeros[2*TBLKSIZ];
};
