/*
*      SCCS:  @(#)  POSIX.os/devclass/c_cc/c_cc.c Rel 4.4.1	    (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)POSIX.os/devclass/c_cc - T.c_cc Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		T.c_cc

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Testset for the termios struct control chars

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Geoff Clare, UniSoft Ltd.
DATE CREATED:	1 Mar 1989
MODIFICATIONS:
		Geoff Clare, 6 June 1990
			UNSUPPORTED results.

		Anthony Lee, 06 August 1990
			Added resilience code.

************************************************************************/

#include <std.h>
#include <sys/types.h>
#include <dbug.h>
#include <report.h>
#include <stdlib.h>
#include <unistd.h>
#include <errno.h>
#include <termios.h>
#include <tet_api.h>
#include <sysdep.h>

#ifdef UNDEF_MACROS
#undef c_cc
#endif


#define NO_TESTS	1
#define WAITTIME	(5 * SPEEDFACTOR)

extern	char	*errname();

int	no_tests = NO_TESTS;

private void	test1();

public	void	(*setfunc) () = NULL;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	NULL, 0
};

private	int	tty_fildes;
private	struct termios tty_termios, *tty_termios_p = &tty_termios;
private int	testfail;

private void
test1()
{
	/* tcgetattr() returns values of START and STOP */

	int err;
	int	pathok = 0;

	DBUG_ENTER("test1");

	switch (tty_prep(&tty_fildes, tty_termios_p))
	{
	case 0:
		PATH_TRACE; 
		break;
	case 1:
		xx_rpt(UNSUPPORTED);
		in_rpt("VSX_TERMIOS_TTY is set to \"unsup\"");
		DBUG_VOID_RETURN;
	default:
		xx_rpt(DELETION);
		in_rpt("open/initialise of VSX_TERMIOS_TTY failed");
		DBUG_VOID_RETURN;
	}

	tty_termios_p->c_cc[VSTART] = 0;
	tty_termios_p->c_cc[VSTOP] = 0;

	if (tcgetattr(tty_fildes, tty_termios_p) == SYSERROR)
	{
		err = errno;
		xx_rpt(DELETION);
		in_rpt("tcgetattr() failed on VSX_TERMIOS_TTY - errno %d (%s)",
			err, errname(err));
		DBUG_VOID_RETURN;
	}
	else
		PATH_TRACE;

	if (tty_termios_p->c_cc[VSTART] == 0)
	{
		if (testfail++ == 0)
			xx_rpt(FAILURE);
		in_rpt("tcgetattr() did not return a value for START");
	}
	else
		PATH_TRACE;

	if (tty_termios_p->c_cc[VSTOP] == 0)
	{
		if (testfail++ == 0)
			xx_rpt(FAILURE);
		in_rpt("tcgetattr() did not return a value for STOP");
	}
	else
		PATH_TRACE;

	if (testfail == 0)
		PATH_XS_RPT(4); 

	DBUG_VOID_RETURN;
}
