/*
 *      SCCS: @(#)  POSIX.os/files/access/access_h.h Rel 4.4.1 (06/09/97)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

/***********************************************************************

NAME:		access_h.h

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION:
	Definitions common to master and slave side of the access test set.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		David Sawyer, UniSoft Ltd.
DATE CREATED:	19 October 1992
MODIFICATIONS:
		Geoff Clare, 2 Feb 1993
			Added SP_T0_GET_NGROUPS

************************************************************************/

#if TEST_XNFS

/*
**	setup
*/

/* sync points */
#define SP_T0_GET_NGROUPS	MK_SPNO(1)

/*
**	test4 - test25
*/

/* sync points */
#define SP_T4_25_DOROOT_START	MK_SPNO(0)
#define SP_T4_25_DOROOT_END	MK_SPNO(1)


/*
**	test26 - test35
*/

/* sync points */
#define SP_T26_35_DOROOT_START	MK_SPNO(0)
#define SP_T26_35_DOROOT_END	MK_SPNO(1)


/*
**	test45 - test74
*/

/* sync points */
#define SP_T45_74_DOROOT_START	MK_SPNO(0)
#define SP_T45_74_DOROOT_END	MK_SPNO(1)


/*
**	test36
*/

/* files and directories */
#define T36_2_DIR		"access-d.36.2"
#define T36_2_FILE		"access-d.36.2/access-t.36.2"

/* sync points */
#define SP_T36_MKDIR2_START	MK_SPNO(0)
#define SP_T36_MKDIR2_END	MK_SPNO(1)
#define SP_T36_RMDIR2_START	MK_SPNO(2)
#define SP_T36_RMDIR2_END	MK_SPNO(3)


#endif /* TEST_XNFS */
