/*
*      SCCS:  @(#)  POSIX.os/files/access_X/access_X.c Rel 4.4.1	    (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)POSIX.os/files/access_X - T.access_X Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		T.access_X

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Testset for the access() system call, X/Open extensions.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Geoff Clare, UniSoft Ltd.
DATE CREATED:	6 Apr 1989
MODIFICATIONS:
		Geoff Clare, 20 June 1990
			Give WARNING only in ETXTBSY test if call succeeds

		David Sawyer
		Thu Jul 26 10:22:51 BST 1990
		Added resilience code.

		Geoff Clare, 21 July 1992
			Change pchild from int to pid_t.

************************************************************************/
#include	<std.h>
#include	<stdlib.h>
#include	<sys/types.h>
#include	<unistd.h>
#include	<dbug.h>
#include	<errno.h>
#include	<report.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef access
#endif



#define NO_TESTS	1		/* number of tests in testset */
#define WAITTIME	(5 * SPEEDFACTOR)

extern	void	valrpt();

public	int	no_tests = NO_TESTS;

private char	*t1_file =	"access_X-t.1";

private void	test1();

public	void	(*setfunc) () = NULL;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	NULL, 0
};


private void
test1()
{
	/* write access on executing pure text program */

	pid_t pchild;
	int rval;
	int err;
	int	pathok = 0;

	DBUG_ENTER("test1");

	globok = 0;
	if (pure_run(t1_file, WAITTIME, &pchild) != SUCCEED)
	{
		DBUG_VOID_RETURN;
	}
	else	
		PATH_FUNC_TRACE;

	errno = NOERROR;
	rval = access(t1_file, W_OK);
	err = errno;

#ifdef TESTBED
	err++;
#endif

	if (rval != SYSERROR || err != ETXTBSY)
	{
		if (rval != SYSERROR)
			xx_rpt(WARNING);
		else
			xx_rpt(FAILURE);
		in_rpt("access(\"%s\", W_OK) did not give correct results",
			t1_file);
		valrpt(SYSERROR, rval, ETXTBSY, err);
	}
	else
	{
		PATH_TRACE;
		PATH_XS_RPT(2);
	}

	(void) killchild(pchild, WAITTIME);
	(void) unlink(t1_file);

	DBUG_VOID_RETURN;
}
