/*
 *      SCCS: @(#)  POSIX.os/files/chmod/chmod_h.h Rel 4.4.1 (06/09/97)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

/***********************************************************************

NAME:		chmod_h.h

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION:
	Definitions common to master and slave side of the chmod test set.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		David Sawyer, UniSoft Ltd.
DATE CREATED:	22 October 1992
MODIFICATIONS:

************************************************************************/

#if TEST_XNFS

/*
**	test3
*/

/* sync points */
#define SP_T3_DOROOT_START	MK_SPNO(0)
#define SP_T3_DOROOT_END	MK_SPNO(1)

/*
**	test4
*/

/* sync points */
#define SP_T4_DOROOT_START	MK_SPNO(0)
#define SP_T4_DOROOT_END	MK_SPNO(1)


/*
**	test6
*/

/* sync points */
#define SP_T6_DOROOT_START	MK_SPNO(0)
#define SP_T6_DOROOT_END	MK_SPNO(1)

/*
**	test9
*/

/* sync points */
#define SP_T9_DO_ACCESS		MK_SPNO(0)

/*
**	test10
*/

/* files and directories */
#define T10_2_DIR		"chmod-d.10.2"
#define T10_2_FILE		"chmod-d.10.2/chmod-t.10.2"

/* sync points */
#define SP_T10_MKDIR2_START	MK_SPNO(0)
#define SP_T10_MKDIR2_END	MK_SPNO(1)
#define SP_T10_RMDIR2_START	MK_SPNO(2)
#define SP_T10_RMDIR2_END	MK_SPNO(3)


/*
**	test17
*/

/* files and directories */
#define T17_2_FILE		"chmod-t.17.2"

/* sync points */
#define SP_T17_CREATE_START	MK_SPNO(0)
#define SP_T17_CREATE_END	MK_SPNO(1)
#define SP_T17_UNLINK_START	MK_SPNO(2)
#define SP_T17_UNLINK_END	MK_SPNO(3)

#else /* TEST_XNFS */

#define SP_T9_DO_ACCESS		0 /* dummy value to pass to do_access() */

#endif /* TEST_XNFS */
