/*
 *      SCCS: @(#)  POSIX.os/files/chown/chown_h.h Rel 4.4.1 (06/09/97)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

/***********************************************************************

NAME:		chown_h.h

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION:
	Definitions common to master and slave side of the chown test set.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		David Sawyer, UniSoft Ltd.
DATE CREATED:	26 October 1992
MODIFICATIONS:
		Geoff Clare, 27 Oct 1993
			Removed SP_T*_PCR_TRANSFER

************************************************************************/

#if TEST_XNFS

/*
**	test3
*/

/* sync points */
#define SP_T3_DOROOT_START	MK_SPNO(0)
#define SP_T3_DOROOT_END	MK_SPNO(1)


/*
**	test8
*/

/* sync points */
#define SP_T8_DO_ACCESS		MK_SPNO(0)


/*
**	test9
*/

/* files and directories */
#define T9_2_DIR		"chown-d.9.2"
#define T9_2_FILE		"chown-d.9.2/chown-t.9.2"

/* sync points */
#define SP_T9_MKDIR2_START	MK_SPNO(0)
#define SP_T9_MKDIR2_END	MK_SPNO(1)
#define SP_T9_RMDIR2_START	MK_SPNO(2)
#define SP_T9_RMDIR2_END	MK_SPNO(3)


/*
**	test17
*/

/* files and directories */
#define T17_2_FILE		"chown-t.17.2"

/* sync points */
#define SP_T17_CREATE_START	MK_SPNO(0)
#define SP_T17_CREATE_END	MK_SPNO(1)
#define SP_T17_UNLINK_START	MK_SPNO(2)
#define SP_T17_UNLINK_END	MK_SPNO(3)


/*
**	test 20
*/

/* files and directories */
#define T20_FILE		"chown-t.20"


/*
**	test 21
*/

/* files and directories */
#define T21_FILE		"chown-t.21"


#else /* TEST_XNFS */

#define SP_T8_DO_ACCESS		0 /* dummy value to pass to do_access() */

#endif /* TEST_XNFS */
