/*
 *      SCCS: @(#)  POSIX.os/files/creat/creat_h.h Rel 4.4.1 (06/09/97)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

/***********************************************************************

NAME:		creat_h.h

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION:
	Definitions common to master and slave side of the creat test set.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		David Sawyer, UniSoft Ltd.
DATE CREATED:	06 October 1992
MODIFICATIONS:
		Geoff Clare, 20 Oct 1993
			Delete T33_DIR and T34_DIR

************************************************************************/

#if TEST_XNFS

/*
**	test13
*/

/* sync points */
#define SP_T13_RTIME_START       MK_SPNO(0)


/*
**	test15
*/

/* sync points */
#define SP_T15_DO_ACCESS	MK_SPNO(0)



/*
**	test16
*/

/* sync points */
#define SP_T16_DO_ACCESS	MK_SPNO(0)


/*
**	test17
*/

/* files and directories */
#define T17_2_DIR		"./creat-d.17.2"
#define T17_2_FILE		"./creat-d.17.2/creat-t.17.2"

/* sync points */
#define SP_T17_MKDIR2_START	MK_SPNO(0)
#define SP_T17_MKDIR2_END	MK_SPNO(1)
#define SP_T17_RMDIR2_START	MK_SPNO(2)
#define SP_T17_RMDIR2_END	MK_SPNO(3)


/*
**	test18
*/

/* files and directories */
#define T18_2_FILE		"./creat-t.18.2"

/* sync points */
#define SP_T18_MKFILE2_START	MK_SPNO(0)
#define SP_T18_MKFILE2_END	MK_SPNO(1)
#define SP_T18_RMFILE2_START	MK_SPNO(2)
#define SP_T18_RMFILE2_END	MK_SPNO(3)


/*
**	test19
*/

/* files and directories */
#define T19_2_DIR		"./creat-d.19.2"
#define T19_2_FILE		"./creat-d.19.2/creat-t.19.2"

/* sync points */
#define SP_T19_MKDIR2_START	MK_SPNO(0)
#define SP_T19_MKDIR2_END	MK_SPNO(1)
#define SP_T19_RMDIR2_START	MK_SPNO(2)
#define SP_T19_RMDIR2_END	MK_SPNO(3)


/*
**      test 33
*/

/* files and directories */
#define T33_MNT			"./creat-m.33"
#define T33_FILE		"./creat-m.33/creat-f.33"



/*
**	test 34
*/

/* files and directories */
#define T34_FILE		"./creat-f.34";

#else /* TEST_XNFS */

#define SP_T15_DO_ACCESS	0 /* dummy value to pass to do_access() */
#define SP_T16_DO_ACCESS	0 /* dummy value to pass to do_access() */

#endif /* TEST_XNFS */
