/*
 *      SCCS: @(#)  POSIX.os/files/link/link_h.h Rel 4.4.1 (06/09/97)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

/***********************************************************************

NAME:		link_h.h

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION:
	Definitions common to master and slave side of the link test set.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		David Sawyer, UniSoft Ltd.
DATE CREATED:	28 October 1992
MODIFICATIONS:

************************************************************************/

#if TEST_XNFS

/*
**	test1
*/

/* sync points */
#define SP_T1_DOROOT_START	MK_SPNO(SP_PATHRES - 1)
#define SP_T1_DOROOT_END	MK_SPNO(SP_PATHRES + 1)


/*
**	test2
*/

/* sync points */
#define SP_T2_DOROOT_START	MK_SPNO(SP_PATHRES - 1)
#define SP_T2_DOROOT_END	MK_SPNO(SP_PATHRES + 1)


/*
**	test7
*/

/* sync points */
#define SP_T7_DOROOT_START	MK_SPNO(0)
#define SP_T7_DOROOT_END	MK_SPNO(1)


/*
**	test10
*/

/* sync points */
#define SP_T10_DO_ACCESS	MK_SPNO(0)


/*
**	test11
*/

/* sync points */
#define SP_T11_DO_ACCESS	MK_SPNO(0)


/*
**	test12
*/

/* files and directories */
#define T12_DIR2		"link-d.12.2"
#define T12_FILE2A		"link-d.12.2/link-t.12.2a"
#define T12_FILE2B		"link-t.12.2b"
#define T12_FILE2C		"link-d.12.2/link-t.12.2c"
#define T12_FILE2D		"link-t.12.2d"

/* sync points */
#define SP_T12_MKDIR2_START	MK_SPNO(0)
#define SP_T12_MKDIR2_END	MK_SPNO(1)
#define SP_T12_RMDIR2_START	MK_SPNO(2)
#define SP_T12_RMDIR2_END	MK_SPNO(3)


/*
**	test13
*/

/* files and directories */
#define T13_DIR2		"link-d.13.2"
#define T13_FILE2A		"link-t.13.2"
#define T13_FILE2B		"link-d.13.2/link-t.13.2"

/* sync points */
#define SP_T13_MKDIR2_START	MK_SPNO(0)
#define SP_T13_MKDIR2_END	MK_SPNO(1)
#define SP_T13_RMDIR2_START	MK_SPNO(2)
#define SP_T13_RMDIR2_END	MK_SPNO(3)


/*
**	test15
*/

/* files and directories */
#define T15A_FILE		"link-t.15a"
#define T15B_FILE		"link-t.15b"

/* sync points */
#define SP_T15_CRFILE_END	MK_SPNO(0)
#define SP_T15_PLM_TRANSFER	MK_SPNO(1)


/*
**	test26
*/

/* files and directories */
#define T26_FILE		"link-t.26"


/*
**	test27
*/

/* files and directories */
#define T27_FILE		"link-t.27"


/*
**	test28
*/

/* files and directories */
#define T28_FILE		"link-t.28"


/*
**	test29
*/

/* files and directories */
#define T29_FILE		"link-t.29"


/*
**	test30
*/

/* sync points */
#define SP_T30_DOROOT_START	MK_SPNO(0)
#define SP_T30_DOROOT_END	MK_SPNO(1)

/* files and directories */
#define T30_DIR			"link-d.30"
#define T30_FILE		"link-t.30"


/*
**	test31
*/

/* files and directories */
#define T31_DIR			"link-d.31"
#define T31_FILE		"link-t.31"

#else /* TEST_XNFS */

#define SP_T10_DO_ACCESS	0 /* dummy value to pass to do_access() */
#define SP_T11_DO_ACCESS	0 /* dummy value to pass to do_access() */

#endif /* TEST_XNFS */
