/*
 *      SCCS: @(#)  POSIX.os/files/mkdir/mkdir_h.h Rel 4.4.1 (06/09/97)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

/***********************************************************************

NAME:		mkdir_h.h

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION:
	Definitions common to master and slave side of the mkdir test set.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		David Sawyer, UniSoft Ltd.
DATE CREATED:	2 November 1992
MODIFICATIONS:
		Geoff Clare, 20 Oct 1993
			Delete T22_DIR and T23_DIR

************************************************************************/

#if	   TEST_XNFS

/*
**	test7
*/

/* sync points */
#define SP_T7_RTIME_START	MK_SPNO(0)


/*
**	test7
*/

/* sync points */
#define SP_T8_DO_ACCESS		MK_SPNO(0)


/*
**	test9
*/

/* files and directories */
#define T9_2_DIR		"./mkdir-d.9.2"
#define T9_2_FILE		"./mkdir-d.9.2/mkdir-d.9.2"

/* sync points */
#define SP_T9_MKDIR2_START	MK_SPNO(0)
#define SP_T9_MKDIR2_END	MK_SPNO(1)
#define SP_T9_RMDIR2_START	MK_SPNO(2)
#define SP_T9_RMDIR2_END	MK_SPNO(3)


/*
**	test10
*/

/* files and directories */
#define T10_2_DIR		"./mkdir-d.10.2"
#define T10_2_FILE		"./mkdir-d.10.2/mkdir-d.10.2"

/* sync points */
#define SP_T10_MKDIR2_START	MK_SPNO(0)
#define SP_T10_MKDIR2_END	MK_SPNO(1)
#define SP_T10_RMDIR2_START	MK_SPNO(2)
#define SP_T10_RMDIR2_END	MK_SPNO(3)


/*
**      test 22
*/

/* sync points */
#define SP_T12_PLM_TRANSFER	MK_SPNO(0)


/*
**      test 22
*/

/* files and directories */
#define T22_MNT			"./mkdir-m.22"
#define T22_FILE		"./mkdir-m.22/mkdir-d.22"


/*
**	test 23
*/

/* files and directories */
#define T23_FILE		"./mkdir-d.23";

#else /* TEST_XNFS */

#define SP_T8_DO_ACCESS		0 /* dummy value to pass to do_access() */

#endif	/* TEST_XNFS */
