/*
 *      SCCS: @(#)  POSIX.os/files/open/open_h.h Rel 4.4.1 (06/09/97)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

/***********************************************************************

NAME:		open_h.h

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION:
	Definitions common to master and slave side of the open test set.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Andrew Dingwall, UniSoft Ltd.
DATE CREATED:	27 August 1992
MODIFICATIONS:
		Geoff Clare, 6 Jan 1993
			Added SP_T20_DO_ACCESS

		Geoff Clare, 19 Oct 1993
			Delete T50_DIR and T51_DIR

************************************************************************/

#if TEST_XNFS

/*
**	test18
*/

/* sync points */
#define SP_T18_RTIME_START	MK_SPNO(0)

/*
**	test20
*/

/* sync points */
#define	SP_T20_DO_ACCESS	MK_SPNO(0)

/*
**	test25
*/

/* files and directories */
#define T25_2_DIR		"./open-d.25.2"
#define T25_2_FILE		"./open-d.25.2/open-t.25.2"

/* sync points */
#define SP_T25_MKDIR2_START	MK_SPNO(0)
#define SP_T25_MKDIR2_END	MK_SPNO(1)
#define SP_T25_RMDIR2_START	MK_SPNO(2)
#define SP_T25_RMDIR2_END	MK_SPNO(3)


/*
**	test30
*/

/* files and directories */
#define T30_2_DIR		"./open-d.30.2"
#define T30_2_FILE		"./open-d.30.2/open-t.30.2"

/* sync points */
#define SP_T30_MKDIR2_START	MK_SPNO(0)
#define SP_T30_MKDIR2_END	MK_SPNO(1)
#define SP_T30_RMDIR2_START	MK_SPNO(2)
#define SP_T30_RMDIR2_END	MK_SPNO(3)


/*
**	test31
*/

/* files and directories */
#define T31_2_FILE		"./open-t.31.2"

/* sync points */
#define SP_T31_CREAT2_START	MK_SPNO(0)
#define SP_T31_CREAT2_END	MK_SPNO(1)
#define SP_T31_UNLINK2_START	MK_SPNO(2)
#define SP_T31_UNLINK2_END	MK_SPNO(3)


/*
**	test 50
*/

/* files and directories */
#define T50_MNT			"./open-m.50"
#define T50_FILE		"./open-m.50/open-f.50"


/*
**	test 51
*/

/* files and directories */
#define T51_FILE		"./open-f.51";

#else /* TEST_XNFS */

#define	SP_T20_DO_ACCESS	0 /* dummy value to pass to do_access() */

#endif /* TEST_XNFS */

