/*
 *      SCCS:  @(#)  POSIX.os/files/open/open_t51.c Rel 4.4.1 (06/09/97)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

#ifndef lint
static	char sccsid[] = "@(#)POSIX.os/files/open/open_t51.c Rel 4.4.1 (06/09/97)";
#endif	/* lint */

/***********************************************************************

NAME:		open_t51.c

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION: 	setup routine for test51() subprogram

AUTHOR:		Andrew Dingwall, UniSoft Ltd.
DATE CREATED:	7 September 1992

MODIFICATIONS:
		Geoff Clare, 19 Oct 1993
			Delete subdirectory from T51_FILE.

************************************************************************/

#include <std.h>
#include <dbug.h>
#include <sys/types.h>
#include "open_h.h"
#include <sysdep.h>

#ifdef UNDEF_MACROS
#undef open
#endif


private char	*t51_file = 	T51_FILE;

extern 	void	subtest5051();

public void
setup5051(mygid)
gid_t mygid;
{
	gid_t altgid;

	DBUG_ENTER("setup5051 for test 51");

#if TEST_FIPS || TEST_XPG > 3
	altgid = (gid_t) -1;
#else
	altgid = mygid;
#endif

	subtest5051(".", t51_file, mygid, altgid, 0, 0);

	DBUG_VOID_RETURN;
}

