/*
 *      SCCS: @(#)  POSIX.os/files/rename/rename_h.h Rel 4.4.1 (06/09/97)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

/***********************************************************************

NAME:		rename_h.h

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION:
	Definitions common to master and slave side of the rename test set.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		David Sawyer, UniSoft Ltd.
DATE CREATED:	10 November 1992
MODIFICATIONS:

************************************************************************/

#if TEST_XNFS


/*
**	test15
*/

/* sync points */
#define SP_T15_DO_ACCESS	MK_SPNO(0)


/*
**	test16
*/

/* sync points */
#define SP_T16_DO_ACCESS	MK_SPNO(0)


/*
**	test18
*/

/* files and directories */
#define T18_DIR2		"rename-d.18.2"
#define T18_FILE2A		"rename-d.18.2/rename-t.18a"
#define T18_FILE2B		"rename-t.18b"
#define T18_FILE2C		"rename-t.18c"
#define T18_FILE2D		"rename-d.18.2/rename-t.18d"

/* sync points */
#define SP_T18_MKDIR2_START	MK_SPNO(0)
#define SP_T18_MKDIR2_END	MK_SPNO(1)
#define SP_T18_RMDIR2_START	MK_SPNO(2)
#define SP_T18_RMDIR2_END	MK_SPNO(3)


/*
**	test19
*/

/* files and directories */
#define T19_DIR2		"rename-d.19.2"
#define T19_FILE2A		"rename-d.19.2/rename-t.19a"
#define T19_FILE2B		"rename-t.19b"
#define T19_FILE2C		"rename-t.19c"
#define T19_FILE2D		"rename-d.19.2/rename-t.19d"

/* sync points */
#define SP_T19_MKDIR2_START	MK_SPNO(0)
#define SP_T19_MKDIR2_END	MK_SPNO(1)
#define SP_T19_RMDIR2_START	MK_SPNO(2)
#define SP_T19_RMDIR2_END	MK_SPNO(3)


/*
**	test20
*/

/* files and directories */
#define T20_DIR2A		"rename-d.20a"
#define T20_DIR2B		"rename-d.20b"
#define T20_DIR2C		"rename-d.20c"
#define T20_DIR2D		"rename-d.20d"

/* sync points */
#define SP_T20_MKDIR2_END	MK_SPNO(0)
#define SP_T20_RMDIR2_START	MK_SPNO(1)


/*
**	test35
*/

/* files and directories */
#define T35_DIR			"rename-d.35"

/* sync points */
#define SP_T35_CRDIR_END	MK_SPNO(0)
#define SP_T35_PLM_TRANSFER	MK_SPNO(1)
#define SP_T35_LOOP_END		MK_SPNO(2)


/*
**	test36
*/

/* files and directories */
#define T36_FILE		"rename-t.36"


/*
**	test37
*/

/* files and directories */
#define T37_FILE		"rename-t.37"


/*
**	test38
*/

/* files and directories */
#define T38_FILE		"rename-t.38"


/*
**	test39
*/

/* files and directories */
#define T39_FILE		"rename-t.39"

#else /* TEST_XNFS */

#define SP_T15_DO_ACCESS	0 /* dummy value to pass to do_access() */
#define SP_T16_DO_ACCESS	0

#endif /* TEST_XNFS */
