/*
*      SCCS:  @(#)  POSIX.os/files/rename_X/rename_X.c Rel 4.4.1	    (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)POSIX.os/files/rename_X - T.rename_X Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN */
#endif	/* lint */

/***********************************************************************

NAME:		T.rename_X

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Testset for the rename() system call, X/Open extensions.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Geoff Clare, UniSoft Ltd.
DATE CREATED:	6 Apr 1989
MODIFICATIONS:

		David Sawyer
		Thu Aug 02 12:33:10 BST 1990
		Added resilience code.

		Geoff Clare, 21 July 1992
			Change pchild from int to pid_t.

                John-Paul, 29 July 1992
                        Mode parameter in call to crfile() changed from 
			'int' to 'mode_t' type.

		Geoff Clare, 10 March 1993
			Added #include <stdio.h>

************************************************************************/
#include	<std.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<sys/types.h>
#include	<unistd.h>
#include	<sys/stat.h>
#include	<dbug.h>
#include	<errno.h>
#include	<report.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef rename
#endif



#define NO_TESTS	1		/* number of tests in testset */
#define WAITTIME	(5 * SPEEDFACTOR)
#define MODEANY		(mode_t)(S_IRWXU|S_IRWXG|S_IRWXO)


public	int	no_tests = NO_TESTS;
public int	testfail;

private char	*t1a_file =	"rename_X-t.1a";
private char	*t1b_file =	"rename_X-t.1b";

private void	test1();

public	void	(*setfunc) () = NULL;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	NULL, 0
};


private void
test1()
{
	/* rename to executing pure text program */

	pid_t 	pchild;
	int	pathok = 0;

	DBUG_ENTER("test1");

	testfail = 0;

	globok = 0;
	if (pure_run(t1b_file, WAITTIME, &pchild) != SUCCEED)
	{
		DBUG_VOID_RETURN;
	}
	else
		PATH_FUNC_TRACE;

	if (crfile(t1a_file, MODEANY,
			(int)geteuid(), (int)getegid()) == SYSERROR)
	{
		xx_rpt(DELETION);
		in_rpt("could not create file \"%s\"", t1a_file);
		DBUG_VOID_RETURN;
	}
	else
	{
		globok = 0;
		(void) tbrename(t1a_file, t1b_file, SYSERROR, ETXTBSY);
		PATH_FUNC_TRACE;
	}

	if (testfail == 0)
		PATH_XS_RPT(2);

	(void) killchild(pchild, WAITTIME);
	(void) unlink(t1a_file);
	(void) unlink(t1b_file);

	DBUG_VOID_RETURN;
}
