/*
 *      SCCS: @(#)  POSIX.os/files/rmdir/rmdir_h.h Rel 4.4.1 (06/09/97)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

/***********************************************************************

NAME:		rmdir_h.h

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION:
	Definitions common to master and slave side of the rmdir test set.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		David Sawyer, UniSoft Ltd.
DATE CREATED:	13 November 1992
MODIFICATIONS:

************************************************************************/

#if	   TEST_XNFS



/*
**	test8
*/

/* sync points */
#define SP_T8_DO_ACCESS		MK_SPNO(0)


/*
**	test10
*/

/* files and directories */
#define T10_DIR2		"./rmdir-d.10.2"
#define T10_FILE2		"./rmdir-d.10.2/rmdir-d.10.2"

/* sync points */
#define SP_T10_MKDIR2_START	MK_SPNO(0)
#define SP_T10_MKDIR2_END	MK_SPNO(1)
#define SP_T10_RMDIR2_START	MK_SPNO(2)
#define SP_T10_RMDIR2_END	MK_SPNO(3)


/*
**	test11
*/

/* files and directories */
#define T11_DIR2		"./rmdir-d.11.2"
#define T11_FILE2		"./rmdir-d.11.2/rmdir-d.11.2"

/* sync points */
#define SP_T11_MKDIR2_START	MK_SPNO(0)
#define SP_T11_MKDIR2_END	MK_SPNO(1)
#define SP_T11_RMDIR2_START	MK_SPNO(2)
#define SP_T11_RMDIR2_END	MK_SPNO(3)


#else /* TEST_XNFS */

#define SP_T8_DO_ACCESS		0 /* dummy value to pass to do_access() */

#endif	/* TEST_XNFS */
