/*
 *      SCCS: @(#)  POSIX.os/files/stat/stat_h.h Rel 4.4.1 (06/09/97)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

/***********************************************************************

NAME:		stat_h.h

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION:
	Definitions common to master and slave side of the stat test set.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		David Sawyer, UniSoft Ltd.
DATE CREATED:	16 November 1992
MODIFICATIONS:
		Geoff Clare, 2 Nov 1993
			Added T6_*

************************************************************************/

/* files and directories */
#define T6_FILE			"./stat-t.6"
#define T7_DIR2			"./stat-d.7.2"
#define T7_FILE2		"./stat-d.7.2/stat-f.7.2"

#if	   TEST_XNFS

/* test 3 sync points */
#define SP_T3_RTIME1_START	MK_SPNO(0)
#define SP_T3_RTIME2_START	MK_SPNO(1)

/* Test 6 sync points */
#define SP_T6_CREAT_END		MK_SPNO(0)
#define SP_T6_UNLINK_START	MK_SPNO(1)

/* test 7 sync points */
#define SP_T7_MKDIR2_START	MK_SPNO(0)
#define SP_T7_MKDIR2_END	MK_SPNO(1)
#define SP_T7_RMDIR2_START	MK_SPNO(2)
#define SP_T7_RMDIR2_END	MK_SPNO(3)

#endif	/* TEST_XNFS */
