/*
 *      SCCS: @(#)  POSIX.os/files/utime/utime_h.h Rel 4.4.1 (06/09/97)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

/***********************************************************************

NAME:		utime_h.h

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION:
	Definitions common to master and slave side of the utime test set.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Neil Moses, UniSoft Ltd.
DATE CREATED:	16 November 1992
MODIFICATIONS:

************************************************************************/

#if TEST_XNFS

/*
**	test3
*/

/* sync points */
#define SP_T3_RTIME		MK_SPNO(0)


/*
**	test4
*/

/* sync points */
#define SP_T4_RTIME		MK_SPNO(0)


/*
**	test6
*/

/* sync points */
#define SP_T6_RTIME		MK_SPNO(0)


/*
**	test9
*/

/* sync points */
#define SP_T9_DO_ACCESS		MK_SPNO(0)


/*
**	test10
*/

/* sync points */
#define SP_T10_MKDIR2_END	MK_SPNO(0)
#define SP_T10_RMDIR2_START	MK_SPNO(1)

/* test files */
#define T10_DIR2		"./utime-d.10.2"
#define T10_FILE2		"./utime-d.10.2/utime-t.10.2"

/*
**	test21
*/

/* sync points */
#define SP_T21_CR_FILE	MK_SPNO(0)

/* test file */
#define T21_FILE		"./utime-t.21"

/*
**	test27
*/

/* sync points */
#define SP_T27_CR_FILE	MK_SPNO(0)

/* test file */
#define T27_FILE		"./utime-t.27"

/*
**	test28
*/

/* sync points */
#define SP_T28_RTIME	MK_SPNO(0)

/*
**	test29
*/

/* sync points */
#define SP_T29_CR_FILE	MK_SPNO(0)
#define SP_T29_RTIME	MK_SPNO(1)

/* test file */
#define T29_FILE		"./utime-t.29"

#else /* TEST_XNFS */

#define SP_T9_DO_ACCESS		0 /* dummy value to pass to do_access() */

#endif /* TEST_XNFS */
