/*
*      SCCS:  @(#)  POSIX.os/ioprim/fcntl/fcntl_t03.c	Rel 4.4.1     (06/09/97) 
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)POSIX.os/ioprim/fcntl - fcntl_t03 Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN	*/
#endif  /* lint	*/

/***********************************************************************

NAME:		fcntl_t03 - used by T.fcntl in comply()

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
		tet_main()

SYNOPSIS:
		int main(argc, argv)
			int argc;
			char **argv;

DESCRIPTION:
	  Exec'd by T.fcntl to test fcntl() by checking that a file
	  is actually closed after exec(2), when FD_CLOEXEC is set.

	  Usage:
		


METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Joseph Nave, UniSoft Ltd.
DATE CREATED:	Fri Feb  3 16:11:41 GMT 1989
MODIFICATIONS:	

		Stuart Boutell, 5 Nov 1990
			Eliminated vg_env.

		Stuart Boutell, 6 Nov 1990
			Eliminated vg_file
		
		Geoff Clare, 4 Nov 1992
			Return from main instead of calling exit() so
			DTET will log off servers.

************************************************************************/
#include	<std.h>
#include	<errno.h>
#include	<dbug.h>
#include	<signal.h>
#include	<report.h>
#include	<exitcodes.h>
#include	<sys/types.h>
#include	<sys/stat.h>
#include	<unistd.h>
#include	<stdlib.h>
#include	<fcntl.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef fcntl
#endif


#define	WAITTIME	(5 * SPEEDFACTOR)

extern	void	valrpt();
extern	char	*errname();
extern	void	set_pname();
extern	char	*atocp();

public	char	*vg_ident =	"<no ident>";
public	char	*vg_dbug =	(char *) NULL;

private void	subtest3();

public	int
tet_main(argc, argv)		/* Assertion 10 */

	int	argc;
	char	**argv;
{

	set_pname(argv[0]);

	switch(argc)
	{
	case 4:
		vg_dbug = argv[3];
		/* fall through */
	case 3:
		vg_ident = argv[2];
		break;
	default:
		vsxerror("argument count wrong");
		return A_MISC;
	}

	if (vg_dbug != (char *) NULL)
	{
		DBUG_PROCESS(vg_ident);
		DBUG_PUSH(vg_dbug+2);
	}

	subtest3(atoi(argv[1]));

	return OK;
}


private void
subtest3( fd)
int	fd;
{
	struct stat	statb;
	int		rval;
	int		err;
	int		pathok = 0;

	DBUG_ENTER("subtest3");

	DBUG_PRINTF("subtest3", "fd = %d", fd);

	if ((rval = fstat(fd, &statb)) != SYSERROR || errno != EBADF)
	{
		err = errno;
		xx_rpt(FAILURE);
		in_rpt("fstat() on closed file descriptor did not return expected values");
		valrpt(SYSERROR, rval, EBADF, err);
	}
	else
	{
		PATH_TRACE;
		xs_rpt();
	}

	DBUG_VOID_RETURN;
}
