/*
 *      SCCS: @(#)  POSIX.os/ioprim/read/read_h.h Rel 4.4.1 (06/09/97)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

/***********************************************************************

NAME:		read_h.h

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION:
	Definitions common to master and slave side of the read test set.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Neil Moses, UniSoft Ltd.
DATE CREATED:	5 October 1992
MODIFICATIONS:
		Geoff Clare, 28 Oct 1993
			Added T13_* and T15_*

************************************************************************/

#if TEST_XNFS

/* test files */
#define T13_FILE 	"./read-t.13"
#define T15_FILE 	"./read-t.15"
#define T22_FILE 	"./read-t.22"
#define T23_FILE 	"./read-t.23"

/* Test 13 sync points */
#define SP_T13_CREAT_END	MK_SPNO(0)
#define SP_T13_UNLINK_START	MK_SPNO(1)

/* Test 15 sync points */
#define SP_T15_CREAT_END	MK_SPNO(0)
#define SP_T15_UNLINK_START	MK_SPNO(1)

/* Test 22 sync points */
#define SP_T22_ESTALE		MK_SPNO(0)

/* Test 23 sync points */
#define SP_T23_EACCES 		MK_SPNO(0)

#endif /* TEST_XNFS */
