/*
*      SCCS:  @(#)  POSIX.os/pocenv/geteuid/geteuid.c	Rel 4.4.1     (06/09/97) 
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)POSIX.os/pocenv/geteuid - T.geteuid Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN	*/
#endif  /* lint	*/

/***********************************************************************

NAME:		T.geteuid

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Testset for the geteuid() system call.

AUTHOR:		Joseph Nave, UniSoft Ltd.
DATE CREATED:	Thr Jan 12 16:35 GMT 1989
MODIFICATIONS:	
		Stuart Boutell, 2 Nov 1990
			Changed execl for tet_exec.

		Stuart Boutell, 5 Nov 1990
			Changed vg_env to environ.

		Geoff Clare, 10 March 1993
			Added #include <unistd.h>

************************************************************************/
#include	<std.h>
#include	<stdlib.h>
#include	<dbug.h>
#include	<report.h>
#include	<sys/types.h>
#include	<unistd.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef geteuid
#endif


#define	NO_TESTS	1		/* number of tests in testset */
#define	WAITTIME	(5 * SPEEDFACTOR)

int	no_tests = NO_TESTS;

private	void	test1();
private	void	ch_t1();

public	void	(*setfunc) () = NULL;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1, 1,
	NULL, 0
};

extern	char	*vg_dbug;
extern	char	*vg_ident;
private	char	*geteuid_t1	=	"../geteuid_t1";

private void
test1()
{

	DBUG_ENTER("test1");

	(void) cppair(ch_t1, NULLFN, WAITTIME, 0);

	DBUG_VOID_RETURN;
}

private void
ch_t1()		/* Assertion 03 */
{
	extern	char	**environ;
	char	*args[4];
	DBUG_ENTER("ch_t1");

	args[0] = geteuid_t1;
	args[1] = vg_ident;
	args[2] = vg_dbug;
	args[3] = (char *)NULL;
	(void) tet_exec(geteuid_t1, args, environ);

	DBUG_VOID_RETURN;
}

