/*
*      SCCS:  @(#)  POSIX.os/procenv/getpgrp/getpgrp.c	Rel 4.4.1     (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)POSIX.os/procenv/getpgrp - T.getpgrp Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN	*/
#endif  /* lint	*/

/***********************************************************************

NAME:		POSIX.os/procenv/getpgrp.c

DESCRIPTION:
		Implements the getpgrp test set as defined in the
		getpgrp functional and design specification documents.

AUTHOR:		Joseph Nave, UniSoft Ltd.;
DATE CREATED:	Fri Jan 13 16:00:42 GMT 1989
MODIFICATIONS:	J.A.Nave	11/07/90
		Added resilience testing

************************************************************************/

#include	<std.h>
#include	<stdio.h>
#include	<dbug.h>
#include	<report.h>
#include	<sys/types.h>
#include	<unistd.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef getpgrp
#endif


#define	NO_TESTS		1

extern	char	*vg_dbug;	/* DBUG string from driver */
extern	char	*vg_ident;	/* testset id from driver */

public	int	no_tests = NO_TESTS;

private	void	test1();

public	void	(*setfunc) () = NULL;
public	void	(*clnfunc) () = NULL;
public	struct tet_testlist tet_testlist[] = {
	 test1 , 1,
	NULL, 0
};

private	pid_t	tb_getpgrp();
 
private void
test1()
{
	pid_t	spg, gpg;
	int	pathok = 0;

	DBUG_ENTER("test1");

	spg = setsid();

	if ((gpg = tb_getpgrp()) != spg)
	{
		xx_rpt(FAILURE);
		in_rpt("getpgrp() did not return the process group ID of");
		in_rpt("   the calling process");
	}
	else
	{
		PATH_TRACE;
		PATH_XS_RPT(1);
	}

	DBUG_PRINTF("test1", "setsid() = %d, getpgrp() = %d", spg, gpg);

	DBUG_VOID_RETURN;
}

private	pid_t
tb_getpgrp()
{
	int	retval;

	retval = getpgrp();
#ifdef	TESTBED
	errno++;
	return -1;
#else
	return retval;
#endif
}
