/*
*      SCCS:  @(#)  POSIX.os/procenv/getuid_t01/getuid_t01.c	Rel 4.4.1     (06/09/97) 
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)POSIX.os/procenv/getuid_t01 - getuid_t01 Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN	*/
#endif  /* lint	*/

/***********************************************************************

NAME:		getuid_t01

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
	Testset for the getuid() system call.

AUTHOR:		Joseph Nave, UniSoft Ltd.
DATE CREATED:	Thr Jan 12 16:35 GMT 1989
MODIFICATIONS:	J.A.Nave	12/07/90
		Added resilience testing

		David Sawyer
		Wed Aug 08 16:11:00 BST 1990
		Removed resilience code from main() and altered argument
		checking for main().

		Stuart Boutell, 5 Nov 1990
			Eliminated vg_env and envp.

		Stuart Boutell, 6 Nov 1990
			Eliminated vg_file

		Geoff Clare, 23 Mar 1992
			Removed globok definition.

                Geoff Clare, 8 June 1992
			Changed return type of tb_getuid() to uid_t.

************************************************************************/


#include	<std.h>
#include	<errno.h>
#include	<stdio.h>
#include	<dbug.h>
#include	<report.h>
#include	<sys/types.h>
#include	<sys/times.h>
#include	<sys/stat.h>
#include	<fcntl.h>
#include	<limits.h>
#include	<pwd.h>
#include	<exitcodes.h>
#include	<unistd.h>
#include	<stdlib.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef getuid
#endif


extern	char	*errname();
extern	void	set_pname();

extern	int	vguid1;
extern	int	vguid2;

public	char	*vg_ident =	"<no ident>";
public	char	*vg_dbug =	(char *) NULL;

private	uid_t	tb_getuid();
private	void	subtest1();

public	int
tet_main(argc, argv)		/* Assertion 03 */

	int	argc;
	char	**argv;
{
	int	pathok = 0;
 
	set_pname(argc < 1 || argv[1] == (char *) NULL ?
		"getuid_t01" : (argv[1]));

	switch(argc)
	{
	case 6:
		vg_dbug = argv[5];
		/* fall through */
	case 5:
		if (argv[4] != (char *) NULL)
			pathok = atoi(argv[4]);
		vg_ident = argv[3];
		break;
	default:
		in_rpt("argument count wrong");
		exit(A_MISC);
	}

	if (vg_dbug != (char *) NULL)
	{
		DBUG_PROCESS(vg_ident);
		DBUG_PUSH(vg_dbug+2);
	}

	vguid1 = atoi(argv[1]);
	vguid2 = atoi(argv[2]);

	subtest1(pathok);

	exit(OK);

}


private void
subtest1(pathok)
int	pathok;
{
	uid_t	uid;

	DBUG_ENTER("subtest1");

	if ( (uid = geteuid()) != (uid_t)vguid2)
	{
		xx_rpt(FAILURE);
		in_rpt("Effective UID returned (%ld) not equal to VSX_UID2 (%d)",
			(long)uid, vguid2);
	}
	else if ( (uid = tb_getuid()) != (uid_t)vguid1)
	{
		xx_rpt(FAILURE);
		in_rpt("Real UID returned (%ld) not equal to VSX_UID1 (%d)",
			(long)uid, vguid1);
	}
	else
	{
		PATH_TRACE;
		PATH_XS_RPT(2);
	}

	DBUG_VOID_RETURN;
}

private	uid_t
tb_getuid()
{
	uid_t	retval;

	retval = getuid();
#ifdef	TESTBED
	errno++;
	return 9999;
#else
	return retval;
#endif
}

