/*
*      SCCS:  @(#)  POSIX.os/procenv/setpgid/setpgid_t6.c	Rel 4.4.1     (06/09/97) 
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)POSIX.os/procenv/setpgid - setpgid_t6.c Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN	*/
#endif  /* lint	*/

/***********************************************************************

NAME:		setpgid_t6.c - used in setpgid() test 6

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
	tet_main()
SYNOPSIS:
DESCRIPTION:
	Called in deviance section of the setpgid() testset.
	Usage:
		setpgid_t6 ident 
METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Joseph Nave, UniSoft Ltd.
DATE CREATED:	Mon Feb  6 16:52:40 GMT 1989
MODIFICATIONS:
		Stuart Boutell, 6 Nov 1990
			Eliminated vg_file


************************************************************************/
#include	<std.h>
#include	<sys/types.h>
#include	<dbug.h>
#include	<errno.h>
#include	<signal.h>
#include	<report.h>
#include	<exitcodes.h>
#include	<stdlib.h>
#include	<unistd.h>
#include <tet_api.h>
#include	<sysdep.h>

#ifdef UNDEF_MACROS
#undef setpgid
#endif


#define	WAITTIME	(5 * SPEEDFACTOR)

extern	void		set_pname();

public	char		*vg_ident = "<no ident>";
public	char		*vg_dbug = (char *) NULL;

tet_main(argc, argv)		/* Assertion 06 */
	int	argc;
	char	**argv;
{
	set_pname(argc < 1 || argv[1] == (char *) NULL ?
		"setpgid_t6" : (argv[1]));
	if (argc == 3)
	{
		if (argv[2] != (char *) NULL && strncmp("-D", argv[2], 2) == 0)
		{
			vg_dbug = argv[2];
			DBUG_PUSH(&vg_dbug[2]);
		}
			argc--;
	}
	if (argc > 1 && argv[1] != (char *) NULL && argv[1][0] != NUL)
		vg_ident = argv[1];
	if (argc != 2)
	{
		in_rpt("argument count wrong: expected 2, got %d, exiting",
			argc);
		er_rpt("argument count wrong, exiting");
		exit(A_MISC);
	}

	(void) sleep(2*WAITTIME);

	exit(OK);

	/* NOTREACHED */
}
