/*
*       SCCS:   @(#)	POSIX.os/procprim/exec/exec.h	Rel 4.4.1     (06/09/97)
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

/***********************************************************************

NAME:		exec.h - some simple defines for exec() tesetset.

PROJECT:	VSX (X/OPEN Validation Suite)

DESCRIPTION:
REQUIRES PRIOR INCLUSION OF:
ASSUMES:

AUTHOR:		Dave Cater, UniSoft Ltd.
DATE CREATED:	Wed Apr 26 13:41:52 BST 1989
MODIFICATIONS:
		Geoff Clare, 24 Apr 1990
			Undefine sigmask to avoid symbol clash

************************************************************************/

#define	SU_NARG		4
#define	SETID_NARG	5
#define	UID_NARG	6
#define	P1_NARG		5
#define	P1_ARG2		"test arg 1"
#define	P1_ARG3		"test-arg-1"
#define	P1_ARG4		"arg3=longstringwith=andwithoutanyblanks"
#define	P1_TSET		"TSET=POSIX.os/procprim/exec"
#define	P1_FILE		"FILE=./exec_phs1"
#define	P1_TENV1	"TESTENV_1=a long string with blanks in it"
#define	P1_LOWER	"LOWER_ENV=abcde"
#define	P1_UPPER	"UPPER_ENV=ABCDE"
#define	P1_PORT		"PORT_ENV=ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789._-"
#define	LOWER_ENV	"LOWER_ENV"
#define	UPPER_ENV	"UPPER_ENV"
#define	PORT_ENV	"PORT_ENV"
#define	LOWER_STR	"abcde"
#define	UPPER_STR	"ABCDE"
#define	PORT_STR	"ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789._-"
#define	EXEC_PATH	"PATH=..:../..:.:/bin:/usr/bin"
#define	FD_OFF		(off_t)20
#define	FD_MODE		O_RDWR
#define	FD_LCKTYPE	F_WRLCK
#define	FD_LCKSTART	(off_t)40
#define	FD_LCKLEN	15
#define	SU_WAITTIME	100*WAITTIME

#define	I_EXECL		0		/* which are we pretending to be? */
#define	I_EXECLE	1
#define	I_EXECLP	2
#define	I_EXECV		3
#define	I_EXECVE	4
#define	I_EXECVP	5

/* structures for passing results to the parent */

#define	MAXGRP		10

#define	RPTED		8

#undef sigmask

struct	tres {
	uid_t		uid;
	gid_t		gid;
	pid_t		pid;
	pid_t		ppid;
	pid_t		pgrp;
	gid_t		grps[MAXGRP];
	int		ngrps;
	struct	tms	timb;
	unsigned	tm_to_alarm;
	mode_t		umsk;
	long		ulmt;
	sigset_t	sigmask;
	int		sigpend;
	char		rootdir[_POSIX_PATH_MAX];
	char		cwdir[_POSIX_PATH_MAX];
	int		pathok;
};
