/*
 *      SCCS: @(#)  POSIX.os/procprim/exec/exec_h.h Rel 4.4.1 (06/09/97)
 *
 *	UniSoft Ltd., London, England
 *
 * (C) Copyright 1992 X/Open Company Limited
 *
 * All rights reserved.  No part of this source code may be reproduced,
 * stored in a retrieval system, or transmitted, in any form or by any
 * means, electronic, mechanical, photocopying, recording or otherwise,
 * except as stated in the end-user licence agreement, without the prior
 * permission of the copyright owners.
 *
 * X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
 * the UK and other countries.
 */

/***********************************************************************

NAME:		exec_h.h

PROJECT:	XNFS (X/OPEN NFS tests)

DESCRIPTION:
	Definitions common to master and slave side of the exec test set.

METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Neil Moses, UniSoft Ltd.
DATE CREATED:	30 September 1992
MODIFICATIONS:
		Dave Cater, 3 December 1992
			Define XNFS_PATHOK

		Geoff Clare, 10 Feb 1993
			Revised use of XNFS DEFAULT/ROOT/SPEC file systems.

		Geoff Clare, 21 April 1993
			Added tet_sync() at end of prepare_tests().

************************************************************************/

#define DIR35			"./exec-d.35"
#define FILE35			"./exec-d.35/exec_tp4"
#define FILE36			"./exec-t.36"

#if TEST_XNFS

#define	XNFS_NOK		0
#define	XNFS_OK			1
#define	XNFS_PATHOK		2
#define	XNFS_EXEC		4
#define	XNFS_CHDIR_FAIL		8
#define	XNFS_EXEC_FAIL		16

#define PROG_LIST { "exec_tfail", "exec_tgen", "exec_tok",\
	"exec_tp0", "exec_tp1", "exec_tp2", "exec_tp3", "exec_tp4",\
	"exec_tp5", "exec_tp6", "exec_tp7", "exec_tp8", "exec_tp9",\
	"exec_tstop", "exec_uids", NULL }

#define	T50_DATA		"abcde"
#define FILE50			"exec_t.close"

#define	SP_SETUP_END 		MK_SPNO(0)

#define SP_T32_DO_ACCESS 	MK_SPNO(0)

#define SP_T35_MKDIR_END 	MK_SPNO(0)
#define SP_T35_SETID_START 	MK_SPNO(1)
#define SP_T35_SETID_END 	MK_SPNO(2)
#define SP_T35_UNLINK_START 	MK_SPNO(3)

#define SP_T36_SETID_START 	MK_SPNO(0)
#define SP_T36_SETID_END 	MK_SPNO(1)

#define SP_T49_SETID_END 	MK_SPNO(0)

#define SP_T50_CHECK_DATA_START MK_SPNO(0)
#define SP_T50_CHECK_DATA_END 	MK_SPNO(1)

#else /* TEST_XNFS */

#define SP_T32_DO_ACCESS 	0 /* dummy value to pass to do_access() */

#endif /* TEST_XNFS */
