/*
*      SCCS:  @(#)  POSIX.os/procprim/waitpid/wait_exec.c	Rel 4.4.1     (06/09/97) 
*
*	UniSoft Ltd., London, England
*
* (C) Copyright 1991 X/Open Company Limited
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* X/Open and the 'X' symbol are trademarks of X/Open Company Limited in
* the UK and other countries.
*/

#ifndef lint
#define MAIN
#ifdef	MAIN
static	char sccsid[] = "@(#)POSIX.os/procprim/waitpid - wait_exec Rel 4.4.1 (06/09/97)";
char	*copyright[] = {
		"(C) Copyright 1991 X/Open Company Limited",
		"All Rights Reserved."
};
#endif	/* MAIN	*/
#endif  /* lint	*/

/***********************************************************************

NAME:		wait_exec - used by T.wait(pid) in several tests

PROJECT:	VSX (X/OPEN Validation Suite)

MODULE CONTAINS:
		main()

SYNOPSIS:
		int main(argc, argv)
			int argc;
			char **argv;

DESCRIPTION:
	  Exec'd by T.wait(pid) to test return values from main().
	  usage:
		wait_exec main_ret

	  where main_ret is the required return value.
METHODS:
ASSUMES:
CONDITIONAL COMPILE PARAMS:
SIDE EFFECTS:
RELATED DOCUMENTS:
SOURCE:

AUTHOR:		Dave Cater, Unisoft Ltd.
DATE CREATED:	Wed Apr 12 14:29:02 BST 1989
MODIFICATIONS:
		Stuart Boutell, 6 Nov 1990
			Eliminated vg_file

		Stuart Boutell, 7 Nov 1990
			main changed to tet_main
************************************************************************/
#include	<std.h>
#include	<sys/types.h>
#include	<unistd.h>
#include	<stdlib.h>
#include	<stdio.h>
#include	<exitcodes.h>
#include <tet_api.h>
#include	<sysdep.h>

extern	void	set_pname();

int
tet_main(argc, argv)
	int	argc;
	char	**argv;
{
	set_pname(argc < 1 || argv[0] == (char *) NULL ?
		"wait_exec" : (argv[0]));
	if (argc != 2)
	{
		vsxerror("argument count wrong");

		/* EXIT VALUE MUST NOT BE A REQUIRED VALUE OF ARGV[1] */
		exit(A_TSETDIR);
	}

	/* Return the required value from main() */
	return(atoi(argv[1]));
}
