
/*************************************************************************
*
* Copyright (c) 1997 by The Open Group
*
* All rights reserved.  No part of this source code may be reproduced,
* stored in a retrieval system, or transmitted, in any form or by any
* means, electronic, mechanical, photocopying, recording or otherwise,
* except as stated in the end-user licence agreement, without the prior
* permission of the copyright owners.
*
* Motif (R) and UNIX (R) are registered trademarks and 'IT DialTone' (TM),
* 'The Open Group' (TM) and the 'X Device' (TM) are trademarks of
* The Open Group.
*
*
*	testset for tset/PTHR.os/all/pthread_attr_setdetachstate_exectests
*
*	Written by Mount Bonnell Inc. Austin, Texas, USA
*	@(#)pthread_attr_setdetachstate_exectests.c	1.1
*
*	History:
*	Created separate executable to avoid calls to non-asynch safe functions.
*
*
*************************************************************************/

#if	( TEST_XPG <= 4 )
#include	<sys/types.h>	/* needed for pthread types in POSIX96 mode */
#endif
#include	<ctype.h>
#include	<errno.h>
#include	<errno.h>
#include	<pthread.h>
#include	<signal.h>
#include	<stdio.h>
#include	<stdlib.h>
#include	<string.h>
#include	<sys/types.h>
#include	<time.h>
#include	<unistd.h>

#include	"tet_api.h"
#include	"vsth/vsth.h"
#include	"vsth/vsth_fw.h"

#ifdef  UNDEF_MACROS
#undef  pthread_attr_setdetachstate
#endif

void	*t3_t1( void *arg );
void	t3_c1();

int	tet_nosigreset = 0;

int
tet_main( int argc, char **argv)
{

	t3_c1();

	exit(1);
}

void
t3_c1()
{
	int		rval;
	int		nerrs;
	int		nfails;
	void		*tval;
	pthread_t	tid;
	pthread_attr_t	attr;

	nerrs	= 0;
	nfails	= 0;

	rval = pthread_attr_init( &attr );
	if ( rval == 0 )
	{
		rval = pthread_attr_setdetachstate( &attr, PTHREAD_CREATE_DETACHED );
		if ( rval == 0 )
		{
			rval = vsth_pthread_create( &tid, &attr, t3_t1, NULL );
			if ( rval == 0 )
			{
				rval = vsth_pthread_join( tid, &tval );
				if ( rval != EINVAL )
				{
					vsth_surprise("vsth_pthread_join", EINVAL, rval, &nfails);
				}
			}
			else
			{
				vsth_surprise("vsth_pthread_create", 0, rval, &nerrs);
			}
		}
		else
		{
			vsth_surprise("pthread_attr_setdetachstate", 0, rval, &nerrs);
		}
		(void) pthread_attr_destroy( &attr );
	}
	else
	{
		vsth_surprise("pthread_attr_init", 0, rval, &nerrs);
	}

	rval = 1;

	if ( nfails )
	{
		rval = 2;
	}
	else if (( nerrs == 0 ) && ( nfails == 0 ))
	{
		rval = 0;
	}

	exit(rval);
}

void *
t3_t1( void *arg )
{
	pthread_exit(NULL);

	/* NOTREACHED */
	return(NULL);
}
